/* DeleteJob.c generated by valac 0.56.17, the Vala compiler
 * generated from DeleteJob.vala, do not modify */

/* Copyright 2022 elementary LLC (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "pantheon-files-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer marlin_file_operations_delete_job_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void marlin_file_operations_delete_job_finalize (FilesFileOperationsCommonJob * obj);
static GType marlin_file_operations_delete_job_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static void
_g_object_unref0_ (gpointer var)
{
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 59 "DeleteJob.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 67 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_can_delete_without_confirm (GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 29 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	if (g_file_has_uri_scheme (file, "burn")) {
#line 30 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = TRUE;
#line 82 "DeleteJob.c"
	} else {
#line 31 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = g_file_has_uri_scheme (file, "x-nautilus-desktop");
#line 86 "DeleteJob.c"
	}
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	if (_tmp1_) {
#line 30 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = TRUE;
#line 92 "DeleteJob.c"
	} else {
#line 32 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = g_file_has_uri_scheme (file, "trash");
#line 96 "DeleteJob.c"
	}
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	result = _tmp0_;
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 102 "DeleteJob.c"
}

FilesFileOperationsDeleteJob*
marlin_file_operations_delete_job_construct (GType object_type,
                                             GtkWindow* parent_window,
                                             GList* files,
                                             gboolean try_trash)
{
	FilesFileOperationsDeleteJob* self = NULL;
	GList* _tmp0_;
#line 36 "../libcore/FileOperations/DeleteJob.vala"
	self = (FilesFileOperationsDeleteJob*) marlin_file_operations_common_job_construct (object_type, parent_window);
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	_tmp0_ = g_list_copy_deep (files, (GCopyFunc) g_object_ref, NULL);
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	(self->files == NULL) ? NULL : (self->files = (_g_list_free__g_object_unref0_ (self->files), NULL));
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	self->files = _tmp0_;
#line 38 "../libcore/FileOperations/DeleteJob.vala"
	self->try_trash = try_trash;
#line 39 "../libcore/FileOperations/DeleteJob.vala"
	self->user_cancel = FALSE;
#line 35 "../libcore/FileOperations/DeleteJob.vala"
	return self;
#line 127 "DeleteJob.c"
}

FilesFileOperationsDeleteJob*
marlin_file_operations_delete_job_new (GtkWindow* parent_window,
                                       GList* files,
                                       gboolean try_trash)
{
#line 35 "../libcore/FileOperations/DeleteJob.vala"
	return marlin_file_operations_delete_job_construct (MARLIN_FILE_OPERATIONS_TYPE_DELETE_JOB, parent_window, files, try_trash);
#line 137 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_confirm_delete_from_trash (FilesFileOperationsDeleteJob* self,
                                                             GList* to_delete_files)
{
	gchar* prompt = NULL;
	guint file_count = 0U;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 42 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../libcore/FileOperations/DeleteJob.vala"
	file_count = g_list_length (to_delete_files);
#line 47 "../libcore/FileOperations/DeleteJob.vala"
	if (file_count == ((guint) 1)) {
#line 156 "DeleteJob.c"
		gchar* basename = NULL;
		gconstpointer _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = to_delete_files->data;
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = files_file_utils_custom_basename_from_file ((GFile*) _tmp0_);
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		basename = _tmp1_;
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_tmp2_ = basename;
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_tmp3_ = g_strdup_printf (_ ("Are you sure you want to permanently delete \"%s\" from the trash?"), _tmp2_);
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp3_;
#line 47 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (basename);
#line 178 "DeleteJob.c"
	} else {
		gchar* _tmp4_;
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		_tmp4_ = g_strdup_printf (ngettext ("Are you sure you want to permanently delete the %'d selected item from" \
" the trash?", "Are you sure you want to permanently delete the %'d selected items fro" \
"m the trash?", (gulong) file_count), file_count);
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp4_;
#line 187 "DeleteJob.c"
	}
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = prompt;
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp7_ = g_strdup (_ ("If you delete an item, it will be permanently lost."));
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	result = marlin_file_operations_common_job_run_warning ((FilesFileOperationsCommonJob*) self, _tmp6_, _tmp7_, NULL, FALSE, CANCEL, DELETE, NULL) == 1;
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (prompt);
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 201 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_confirm_delete_directly (FilesFileOperationsDeleteJob* self,
                                                           GList* to_delete_files)
{
	gchar* prompt = NULL;
	guint file_count = 0U;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 65 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../libcore/FileOperations/DeleteJob.vala"
	file_count = g_list_length (to_delete_files);
#line 70 "../libcore/FileOperations/DeleteJob.vala"
	if (file_count == ((guint) 1)) {
#line 220 "DeleteJob.c"
		gchar* basename = NULL;
		gconstpointer _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = to_delete_files->data;
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = files_file_utils_custom_basename_from_file ((GFile*) _tmp0_);
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		basename = _tmp1_;
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_tmp2_ = basename;
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_tmp3_ = g_strdup_printf (_ ("Permanently delete “%s”?"), _tmp2_);
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp3_;
#line 70 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (basename);
#line 242 "DeleteJob.c"
	} else {
		gchar* _tmp4_;
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		_tmp4_ = g_strdup_printf (ngettext ("Are you sure you want to permanently delete the %'d selected item?", "Are you sure you want to permanently delete the %'d selected items?", (gulong) file_count), file_count);
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp4_;
#line 251 "DeleteJob.c"
	}
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = prompt;
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp7_ = g_strdup (_ ("Deleted items are not sent to Trash and are not recoverable."));
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	result = marlin_file_operations_common_job_run_warning ((FilesFileOperationsCommonJob*) self, _tmp6_, _tmp7_, NULL, FALSE, CANCEL, DELETE, NULL) == 1;
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (prompt);
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 265 "DeleteJob.c"
}

void
marlin_file_operations_delete_job_report_delete_progress (FilesFileOperationsDeleteJob* self,
                                                          SourceInfo* source_info,
                                                          TransferInfo* transfer_info)
{
	gint64 now = 0LL;
	gboolean _tmp0_ = FALSE;
	gint files_left = 0;
	gchar* files_left_s = NULL;
	gchar* _tmp1_;
	PFProgressInfo* _tmp2_;
	gchar* _tmp3_;
	gdouble elapsed = 0.0;
	GTimer* _tmp4_;
#line 88 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (self != NULL);
#line 88 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (source_info != NULL);
#line 88 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (transfer_info != NULL);
#line 89 "../libcore/FileOperations/DeleteJob.vala"
	now = g_get_monotonic_time () * 1000;
#line 90 "../libcore/FileOperations/DeleteJob.vala"
	if (transfer_info->last_report_time != ((guint64) 0)) {
#line 91 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = llabs (((gint64) transfer_info->last_report_time) - now) < ((gint64) (100 * MARLIN_FILE_OPERATIONS_COMMON_JOB_NSEC_PER_MSEC));
#line 294 "DeleteJob.c"
	} else {
#line 90 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = FALSE;
#line 298 "DeleteJob.c"
	}
#line 90 "../libcore/FileOperations/DeleteJob.vala"
	if (_tmp0_) {
#line 92 "../libcore/FileOperations/DeleteJob.vala"
		return;
#line 304 "DeleteJob.c"
	}
#line 95 "../libcore/FileOperations/DeleteJob.vala"
	transfer_info->last_report_time = (guint64) now;
#line 97 "../libcore/FileOperations/DeleteJob.vala"
	files_left = source_info->num_files - transfer_info->num_files;
#line 100 "../libcore/FileOperations/DeleteJob.vala"
	if (files_left < 0) {
#line 101 "../libcore/FileOperations/DeleteJob.vala"
		files_left = 1;
#line 314 "DeleteJob.c"
	}
#line 104 "../libcore/FileOperations/DeleteJob.vala"
	_tmp1_ = g_strdup_printf (ngettext ("%'d file left to delete", "%'d files left to delete", (gulong) files_left), files_left);
#line 104 "../libcore/FileOperations/DeleteJob.vala"
	files_left_s = _tmp1_;
#line 110 "../libcore/FileOperations/DeleteJob.vala"
	_tmp2_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 110 "../libcore/FileOperations/DeleteJob.vala"
	_tmp3_ = g_strdup (_ ("Deleting files"));
#line 110 "../libcore/FileOperations/DeleteJob.vala"
	pf_progress_info_take_status (_tmp2_, _tmp3_);
#line 112 "../libcore/FileOperations/DeleteJob.vala"
	_tmp4_ = ((FilesFileOperationsCommonJob*) self)->time;
#line 112 "../libcore/FileOperations/DeleteJob.vala"
	elapsed = g_timer_elapsed (_tmp4_, NULL);
#line 113 "../libcore/FileOperations/DeleteJob.vala"
	if (elapsed < ((gdouble) MARLIN_FILE_OPERATIONS_COMMON_JOB_SECONDS_NEEDED_FOR_RELIABLE_TRANSFER_RATE)) {
#line 332 "DeleteJob.c"
		PFProgressInfo* _tmp5_;
		gchar* _tmp6_;
#line 114 "../libcore/FileOperations/DeleteJob.vala"
		_tmp5_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 114 "../libcore/FileOperations/DeleteJob.vala"
		_tmp6_ = files_left_s;
#line 114 "../libcore/FileOperations/DeleteJob.vala"
		files_left_s = NULL;
#line 114 "../libcore/FileOperations/DeleteJob.vala"
		pf_progress_info_take_details (_tmp5_, _tmp6_);
#line 343 "DeleteJob.c"
	} else {
		gdouble transfer_rate = 0.0;
		gint remaining_time = 0;
		gint formated_time_unit = 0;
		gchar* formated_time = NULL;
		gint _tmp7_ = 0;
		gchar* _tmp8_;
		gchar* time_left_s = NULL;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* details = NULL;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		PFProgressInfo* _tmp14_;
		gchar* _tmp15_;
#line 116 "../libcore/FileOperations/DeleteJob.vala"
		transfer_rate = transfer_info->num_files / elapsed;
#line 117 "../libcore/FileOperations/DeleteJob.vala"
		remaining_time = (gint) floor (files_left / transfer_rate);
#line 119 "../libcore/FileOperations/DeleteJob.vala"
		_tmp8_ = files_file_utils_format_time (remaining_time, &_tmp7_);
#line 119 "../libcore/FileOperations/DeleteJob.vala"
		formated_time_unit = _tmp7_;
#line 119 "../libcore/FileOperations/DeleteJob.vala"
		formated_time = _tmp8_;
#line 123 "../libcore/FileOperations/DeleteJob.vala"
		_tmp9_ = formated_time;
#line 123 "../libcore/FileOperations/DeleteJob.vala"
		_tmp10_ = g_strdup_printf (ngettext ("%s left", "%s left", (gulong) formated_time_unit), _tmp9_);
#line 123 "../libcore/FileOperations/DeleteJob.vala"
		time_left_s = _tmp10_;
#line 125 "../libcore/FileOperations/DeleteJob.vala"
		_tmp11_ = files_left_s;
#line 125 "../libcore/FileOperations/DeleteJob.vala"
		_tmp12_ = time_left_s;
#line 125 "../libcore/FileOperations/DeleteJob.vala"
		_tmp13_ = g_strconcat (_tmp11_, "\xE2\x80\x94", _tmp12_, NULL);
#line 125 "../libcore/FileOperations/DeleteJob.vala"
		details = _tmp13_;
#line 126 "../libcore/FileOperations/DeleteJob.vala"
		_tmp14_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 126 "../libcore/FileOperations/DeleteJob.vala"
		_tmp15_ = details;
#line 126 "../libcore/FileOperations/DeleteJob.vala"
		details = NULL;
#line 126 "../libcore/FileOperations/DeleteJob.vala"
		pf_progress_info_take_details (_tmp14_, _tmp15_);
#line 113 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (details);
#line 113 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (time_left_s);
#line 113 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (formated_time);
#line 398 "DeleteJob.c"
	}
#line 129 "../libcore/FileOperations/DeleteJob.vala"
	if (source_info->num_files != 0) {
#line 402 "DeleteJob.c"
		PFProgressInfo* _tmp16_;
#line 130 "../libcore/FileOperations/DeleteJob.vala"
		_tmp16_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 130 "../libcore/FileOperations/DeleteJob.vala"
		pf_progress_info_update_progress (_tmp16_, (gdouble) transfer_info->num_files, (gdouble) source_info->num_files);
#line 408 "DeleteJob.c"
	}
#line 88 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (files_left_s);
#line 412 "DeleteJob.c"
}

void
marlin_file_operations_delete_job_report_delete_count_progress (FilesFileOperationsDeleteJob* self,
                                                                SourceInfo* source_info)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PFProgressInfo* _tmp4_;
	gchar* _tmp5_;
	PFProgressInfo* _tmp6_;
#line 134 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (self != NULL);
#line 134 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (source_info != NULL);
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	_tmp0_ = g_format_size_full ((guint64) source_info->num_bytes, G_FORMAT_SIZE_DEFAULT);
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	_tmp1_ = _tmp0_;
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	_tmp2_ = g_strdup_printf (ngettext ("Preparing to delete %'d file (%s)", "Preparing to delete %'d files (%s)", (gulong) source_info->num_files), source_info->num_files, _tmp1_);
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	_tmp3_ = _tmp2_;
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (_tmp1_);
#line 139 "../libcore/FileOperations/DeleteJob.vala"
	s = _tmp3_;
#line 144 "../libcore/FileOperations/DeleteJob.vala"
	_tmp4_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 144 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = g_strdup (s);
#line 144 "../libcore/FileOperations/DeleteJob.vala"
	pf_progress_info_take_details (_tmp4_, _tmp5_);
#line 145 "../libcore/FileOperations/DeleteJob.vala"
	_tmp6_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 145 "../libcore/FileOperations/DeleteJob.vala"
	pf_progress_info_pulse_progress (_tmp6_);
#line 134 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (s);
#line 455 "DeleteJob.c"
}

void
marlin_file_operations_delete_job_report_trash_progress (FilesFileOperationsDeleteJob* self,
                                                         gint files_trashed,
                                                         gint total_files)
{
	gint files_left = 0;
	PFProgressInfo* _tmp0_;
	gchar* _tmp1_;
	gchar* s = NULL;
	gchar* _tmp2_;
	PFProgressInfo* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 148 "../libcore/FileOperations/DeleteJob.vala"
	g_return_if_fail (self != NULL);
#line 149 "../libcore/FileOperations/DeleteJob.vala"
	files_left = total_files - files_trashed;
#line 151 "../libcore/FileOperations/DeleteJob.vala"
	_tmp0_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 151 "../libcore/FileOperations/DeleteJob.vala"
	_tmp1_ = g_strdup (_ ("Moving files to trash"));
#line 151 "../libcore/FileOperations/DeleteJob.vala"
	pf_progress_info_take_status (_tmp0_, _tmp1_);
#line 153 "../libcore/FileOperations/DeleteJob.vala"
	_tmp2_ = g_strdup_printf (ngettext ("%'d file left to trash", "%'d files left to trash", (gulong) files_left), files_left);
#line 153 "../libcore/FileOperations/DeleteJob.vala"
	s = _tmp2_;
#line 158 "../libcore/FileOperations/DeleteJob.vala"
	_tmp3_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 158 "../libcore/FileOperations/DeleteJob.vala"
	_tmp4_ = s;
#line 158 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 158 "../libcore/FileOperations/DeleteJob.vala"
	pf_progress_info_take_details (_tmp3_, _tmp5_);
#line 160 "../libcore/FileOperations/DeleteJob.vala"
	if (total_files != 0) {
#line 495 "DeleteJob.c"
		PFProgressInfo* _tmp6_;
#line 161 "../libcore/FileOperations/DeleteJob.vala"
		_tmp6_ = ((FilesFileOperationsCommonJob*) self)->progress;
#line 161 "../libcore/FileOperations/DeleteJob.vala"
		pf_progress_info_update_progress (_tmp6_, (gdouble) files_trashed, (gdouble) total_files);
#line 501 "DeleteJob.c"
	}
#line 148 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (s);
#line 505 "DeleteJob.c"
}

static void
marlin_file_operations_delete_job_class_init (FilesFileOperationsDeleteJobClass * klass,
                                              gpointer klass_data)
{
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	marlin_file_operations_delete_job_parent_class = g_type_class_peek_parent (klass);
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	((FilesFileOperationsCommonJobClass *) klass)->finalize = marlin_file_operations_delete_job_finalize;
#line 516 "DeleteJob.c"
}

static void
marlin_file_operations_delete_job_instance_init (FilesFileOperationsDeleteJob * self,
                                                 gpointer klass)
{
}

static void
marlin_file_operations_delete_job_finalize (FilesFileOperationsCommonJob * obj)
{
	FilesFileOperationsDeleteJob * self;
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARLIN_FILE_OPERATIONS_TYPE_DELETE_JOB, FilesFileOperationsDeleteJob);
#line 26 "../libcore/FileOperations/DeleteJob.vala"
	files_file_changes_consume_changes (TRUE);
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	(self->files == NULL) ? NULL : (self->files = (_g_list_free__g_object_unref0_ (self->files), NULL));
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	MARLIN_FILE_OPERATIONS_COMMON_JOB_CLASS (marlin_file_operations_delete_job_parent_class)->finalize (obj);
#line 537 "DeleteJob.c"
}

 G_GNUC_NO_INLINE static GType
marlin_file_operations_delete_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesFileOperationsDeleteJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marlin_file_operations_delete_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesFileOperationsDeleteJob), 0, (GInstanceInitFunc) marlin_file_operations_delete_job_instance_init, NULL };
	GType marlin_file_operations_delete_job_type_id;
	marlin_file_operations_delete_job_type_id = g_type_register_static (MARLIN_FILE_OPERATIONS_TYPE_COMMON_JOB, "FilesFileOperationsDeleteJob", &g_define_type_info, 0);
	return marlin_file_operations_delete_job_type_id;
}

GType
marlin_file_operations_delete_job_get_type (void)
{
	static volatile gsize marlin_file_operations_delete_job_type_id__once = 0;
	if (g_once_init_enter (&marlin_file_operations_delete_job_type_id__once)) {
		GType marlin_file_operations_delete_job_type_id;
		marlin_file_operations_delete_job_type_id = marlin_file_operations_delete_job_get_type_once ();
		g_once_init_leave (&marlin_file_operations_delete_job_type_id__once, marlin_file_operations_delete_job_type_id);
	}
	return marlin_file_operations_delete_job_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

