/* PixbufUtils.c generated by valac 0.56.17, the Vala compiler
 * generated from PixbufUtils.vala, do not modify */

/* Copyright (c) 2018 elementary LLC (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include "pantheon-files-core.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

VALA_EXTERN guint8 pf_pixbuf_utils_lighten_component (guint8 cur_value);

guint8
pf_pixbuf_utils_lighten_component (guint8 cur_value)
{
	guint new_value = 0U;
	guint8 result;
#line 21 "../libcore/PixbufUtils.vala"
	new_value = (guint) cur_value;
#line 22 "../libcore/PixbufUtils.vala"
	new_value += 24 + (new_value >> 3);
#line 23 "../libcore/PixbufUtils.vala"
	if (new_value > ((guint) G_MAXUINT8)) {
#line 24 "../libcore/PixbufUtils.vala"
		new_value = (guint) G_MAXUINT8;
#line 53 "PixbufUtils.c"
	}
#line 27 "../libcore/PixbufUtils.vala"
	result = (guint8) new_value;
#line 27 "../libcore/PixbufUtils.vala"
	return result;
#line 59 "PixbufUtils.c"
}

GdkPixbuf*
pf_pixbuf_utils_lighten (GdkPixbuf* src)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint _tmp11_;
	gint _tmp12_;
	gint width = 0;
	gint _tmp13_;
	gint _tmp14_;
	gint height = 0;
	gint _tmp15_;
	gint _tmp16_;
	gint channels = 0;
	gint _tmp17_;
	gint _tmp18_;
	gboolean has_alpha = FALSE;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GdkPixbuf* dest = NULL;
	GdkColorspace _tmp21_;
	GdkColorspace _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GdkPixbuf* _tmp27_;
	gint dst_row_stride = 0;
	GdkPixbuf* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint src_row_stride = 0;
	gint _tmp31_;
	gint _tmp32_;
	guint8* target_pix = NULL;
	GdkPixbuf* _tmp33_;
	void* _tmp34_;
	void* _tmp35_;
	gint target_pix_length1;
	gint _target_pix_size_;
	guint8* original_pix = NULL;
	void* _tmp36_;
	void* _tmp37_;
	gint original_pix_length1;
	gint _original_pix_size_;
	GdkPixbuf* result;
#line 30 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 31 "../libcore/PixbufUtils.vala"
	_tmp2_ = gdk_pixbuf_get_has_alpha (src);
#line 31 "../libcore/PixbufUtils.vala"
	_tmp3_ = _tmp2_;
#line 31 "../libcore/PixbufUtils.vala"
	if (!_tmp3_) {
#line 118 "PixbufUtils.c"
		gint _tmp4_;
		gint _tmp5_;
#line 31 "../libcore/PixbufUtils.vala"
		_tmp4_ = gdk_pixbuf_get_n_channels (src);
#line 31 "../libcore/PixbufUtils.vala"
		_tmp5_ = _tmp4_;
#line 31 "../libcore/PixbufUtils.vala"
		_tmp1_ = _tmp5_ == 3;
#line 127 "PixbufUtils.c"
	} else {
#line 31 "../libcore/PixbufUtils.vala"
		_tmp1_ = FALSE;
#line 131 "PixbufUtils.c"
	}
#line 31 "../libcore/PixbufUtils.vala"
	if (_tmp1_) {
#line 31 "../libcore/PixbufUtils.vala"
		_tmp0_ = TRUE;
#line 137 "PixbufUtils.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 31 "../libcore/PixbufUtils.vala"
		_tmp7_ = gdk_pixbuf_get_has_alpha (src);
#line 31 "../libcore/PixbufUtils.vala"
		_tmp8_ = _tmp7_;
#line 31 "../libcore/PixbufUtils.vala"
		if (_tmp8_) {
#line 148 "PixbufUtils.c"
			gint _tmp9_;
			gint _tmp10_;
#line 31 "../libcore/PixbufUtils.vala"
			_tmp9_ = gdk_pixbuf_get_n_channels (src);
#line 31 "../libcore/PixbufUtils.vala"
			_tmp10_ = _tmp9_;
#line 31 "../libcore/PixbufUtils.vala"
			_tmp6_ = _tmp10_ == 4;
#line 157 "PixbufUtils.c"
		} else {
#line 31 "../libcore/PixbufUtils.vala"
			_tmp6_ = FALSE;
#line 161 "PixbufUtils.c"
		}
#line 31 "../libcore/PixbufUtils.vala"
		_tmp0_ = _tmp6_;
#line 165 "PixbufUtils.c"
	}
#line 31 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (_tmp0_, src);
#line 33 "../libcore/PixbufUtils.vala"
	_tmp11_ = gdk_pixbuf_get_bits_per_sample (src);
#line 33 "../libcore/PixbufUtils.vala"
	_tmp12_ = _tmp11_;
#line 33 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (_tmp12_ == 8, src);
#line 35 "../libcore/PixbufUtils.vala"
	_tmp13_ = gdk_pixbuf_get_width (src);
#line 35 "../libcore/PixbufUtils.vala"
	_tmp14_ = _tmp13_;
#line 35 "../libcore/PixbufUtils.vala"
	width = _tmp14_;
#line 36 "../libcore/PixbufUtils.vala"
	_tmp15_ = gdk_pixbuf_get_height (src);
#line 36 "../libcore/PixbufUtils.vala"
	_tmp16_ = _tmp15_;
#line 36 "../libcore/PixbufUtils.vala"
	height = _tmp16_;
#line 37 "../libcore/PixbufUtils.vala"
	_tmp17_ = gdk_pixbuf_get_n_channels (src);
#line 37 "../libcore/PixbufUtils.vala"
	_tmp18_ = _tmp17_;
#line 37 "../libcore/PixbufUtils.vala"
	channels = _tmp18_;
#line 38 "../libcore/PixbufUtils.vala"
	_tmp19_ = gdk_pixbuf_get_has_alpha (src);
#line 38 "../libcore/PixbufUtils.vala"
	_tmp20_ = _tmp19_;
#line 38 "../libcore/PixbufUtils.vala"
	has_alpha = _tmp20_;
#line 39 "../libcore/PixbufUtils.vala"
	_tmp21_ = gdk_pixbuf_get_colorspace (src);
#line 39 "../libcore/PixbufUtils.vala"
	_tmp22_ = _tmp21_;
#line 39 "../libcore/PixbufUtils.vala"
	_tmp23_ = gdk_pixbuf_get_has_alpha (src);
#line 39 "../libcore/PixbufUtils.vala"
	_tmp24_ = _tmp23_;
#line 39 "../libcore/PixbufUtils.vala"
	_tmp25_ = gdk_pixbuf_get_bits_per_sample (src);
#line 39 "../libcore/PixbufUtils.vala"
	_tmp26_ = _tmp25_;
#line 39 "../libcore/PixbufUtils.vala"
	_tmp27_ = gdk_pixbuf_new (_tmp22_, _tmp24_, _tmp26_, width, height);
#line 39 "../libcore/PixbufUtils.vala"
	dest = _tmp27_;
#line 40 "../libcore/PixbufUtils.vala"
	_tmp28_ = dest;
#line 40 "../libcore/PixbufUtils.vala"
	_tmp29_ = gdk_pixbuf_get_rowstride (_tmp28_);
#line 40 "../libcore/PixbufUtils.vala"
	_tmp30_ = _tmp29_;
#line 40 "../libcore/PixbufUtils.vala"
	dst_row_stride = _tmp30_;
#line 41 "../libcore/PixbufUtils.vala"
	_tmp31_ = gdk_pixbuf_get_rowstride (src);
#line 41 "../libcore/PixbufUtils.vala"
	_tmp32_ = _tmp31_;
#line 41 "../libcore/PixbufUtils.vala"
	src_row_stride = _tmp32_;
#line 42 "../libcore/PixbufUtils.vala"
	_tmp33_ = dest;
#line 42 "../libcore/PixbufUtils.vala"
	_tmp34_ = gdk_pixbuf_get_pixels (_tmp33_);
#line 42 "../libcore/PixbufUtils.vala"
	_tmp35_ = _tmp34_;
#line 42 "../libcore/PixbufUtils.vala"
	target_pix = (guint8*) _tmp35_;
#line 42 "../libcore/PixbufUtils.vala"
	target_pix_length1 = -1;
#line 42 "../libcore/PixbufUtils.vala"
	_target_pix_size_ = target_pix_length1;
#line 43 "../libcore/PixbufUtils.vala"
	_tmp36_ = gdk_pixbuf_get_pixels (src);
#line 43 "../libcore/PixbufUtils.vala"
	_tmp37_ = _tmp36_;
#line 43 "../libcore/PixbufUtils.vala"
	original_pix = (guint8*) _tmp37_;
#line 43 "../libcore/PixbufUtils.vala"
	original_pix_length1 = -1;
#line 43 "../libcore/PixbufUtils.vala"
	_original_pix_size_ = original_pix_length1;
#line 251 "PixbufUtils.c"
	{
		gint i = 0;
#line 44 "../libcore/PixbufUtils.vala"
		i = 0;
#line 256 "PixbufUtils.c"
		{
			gboolean _tmp38_ = FALSE;
#line 44 "../libcore/PixbufUtils.vala"
			_tmp38_ = TRUE;
#line 44 "../libcore/PixbufUtils.vala"
			while (TRUE) {
#line 263 "PixbufUtils.c"
				gint src_row = 0;
				gint dst_row = 0;
#line 44 "../libcore/PixbufUtils.vala"
				if (!_tmp38_) {
#line 268 "PixbufUtils.c"
					gint _tmp39_;
#line 44 "../libcore/PixbufUtils.vala"
					_tmp39_ = i;
#line 44 "../libcore/PixbufUtils.vala"
					i = _tmp39_ + 1;
#line 274 "PixbufUtils.c"
				}
#line 44 "../libcore/PixbufUtils.vala"
				_tmp38_ = FALSE;
#line 44 "../libcore/PixbufUtils.vala"
				if (!(i < height)) {
#line 44 "../libcore/PixbufUtils.vala"
					break;
#line 282 "PixbufUtils.c"
				}
#line 45 "../libcore/PixbufUtils.vala"
				src_row = i * src_row_stride;
#line 46 "../libcore/PixbufUtils.vala"
				dst_row = i * dst_row_stride;
#line 288 "PixbufUtils.c"
				{
					gint j = 0;
#line 47 "../libcore/PixbufUtils.vala"
					j = 0;
#line 293 "PixbufUtils.c"
					{
						gboolean _tmp40_ = FALSE;
#line 47 "../libcore/PixbufUtils.vala"
						_tmp40_ = TRUE;
#line 47 "../libcore/PixbufUtils.vala"
						while (TRUE) {
#line 300 "PixbufUtils.c"
							gint width_offset = 0;
							guint8* _tmp42_;
							gint _tmp42__length1;
							guint8* _tmp43_;
							gint _tmp43__length1;
							guint8 _tmp44_;
							guint8* _tmp45_;
							gint _tmp45__length1;
							guint8* _tmp46_;
							gint _tmp46__length1;
							guint8 _tmp47_;
							guint8* _tmp48_;
							gint _tmp48__length1;
							guint8* _tmp49_;
							gint _tmp49__length1;
							guint8 _tmp50_;
#line 47 "../libcore/PixbufUtils.vala"
							if (!_tmp40_) {
#line 319 "PixbufUtils.c"
								gint _tmp41_;
#line 47 "../libcore/PixbufUtils.vala"
								_tmp41_ = j;
#line 47 "../libcore/PixbufUtils.vala"
								j = _tmp41_ + 1;
#line 325 "PixbufUtils.c"
							}
#line 47 "../libcore/PixbufUtils.vala"
							_tmp40_ = FALSE;
#line 47 "../libcore/PixbufUtils.vala"
							if (!(j < width)) {
#line 47 "../libcore/PixbufUtils.vala"
								break;
#line 333 "PixbufUtils.c"
							}
#line 48 "../libcore/PixbufUtils.vala"
							width_offset = j * channels;
#line 49 "../libcore/PixbufUtils.vala"
							_tmp42_ = target_pix;
#line 49 "../libcore/PixbufUtils.vala"
							_tmp42__length1 = target_pix_length1;
#line 49 "../libcore/PixbufUtils.vala"
							_tmp43_ = original_pix;
#line 49 "../libcore/PixbufUtils.vala"
							_tmp43__length1 = original_pix_length1;
#line 49 "../libcore/PixbufUtils.vala"
							_tmp44_ = _tmp43_[src_row + width_offset];
#line 49 "../libcore/PixbufUtils.vala"
							_tmp42_[dst_row + width_offset] = pf_pixbuf_utils_lighten_component (_tmp44_);
#line 50 "../libcore/PixbufUtils.vala"
							_tmp45_ = target_pix;
#line 50 "../libcore/PixbufUtils.vala"
							_tmp45__length1 = target_pix_length1;
#line 50 "../libcore/PixbufUtils.vala"
							_tmp46_ = original_pix;
#line 50 "../libcore/PixbufUtils.vala"
							_tmp46__length1 = original_pix_length1;
#line 50 "../libcore/PixbufUtils.vala"
							_tmp47_ = _tmp46_[(src_row + width_offset) + 1];
#line 50 "../libcore/PixbufUtils.vala"
							_tmp45_[(dst_row + width_offset) + 1] = pf_pixbuf_utils_lighten_component (_tmp47_);
#line 51 "../libcore/PixbufUtils.vala"
							_tmp48_ = target_pix;
#line 51 "../libcore/PixbufUtils.vala"
							_tmp48__length1 = target_pix_length1;
#line 51 "../libcore/PixbufUtils.vala"
							_tmp49_ = original_pix;
#line 51 "../libcore/PixbufUtils.vala"
							_tmp49__length1 = original_pix_length1;
#line 51 "../libcore/PixbufUtils.vala"
							_tmp50_ = _tmp49_[(src_row + width_offset) + 2];
#line 51 "../libcore/PixbufUtils.vala"
							_tmp48_[(dst_row + width_offset) + 2] = pf_pixbuf_utils_lighten_component (_tmp50_);
#line 52 "../libcore/PixbufUtils.vala"
							if (has_alpha) {
#line 375 "PixbufUtils.c"
								guint8* _tmp51_;
								gint _tmp51__length1;
								guint8* _tmp52_;
								gint _tmp52__length1;
								guint8 _tmp53_;
#line 53 "../libcore/PixbufUtils.vala"
								_tmp51_ = target_pix;
#line 53 "../libcore/PixbufUtils.vala"
								_tmp51__length1 = target_pix_length1;
#line 53 "../libcore/PixbufUtils.vala"
								_tmp52_ = original_pix;
#line 53 "../libcore/PixbufUtils.vala"
								_tmp52__length1 = original_pix_length1;
#line 53 "../libcore/PixbufUtils.vala"
								_tmp53_ = _tmp52_[(src_row + width_offset) + 3];
#line 53 "../libcore/PixbufUtils.vala"
								_tmp51_[(dst_row + width_offset) + 3] = _tmp53_;
#line 393 "PixbufUtils.c"
							}
						}
					}
				}
			}
		}
	}
#line 58 "../libcore/PixbufUtils.vala"
	result = dest;
#line 58 "../libcore/PixbufUtils.vala"
	return result;
#line 405 "PixbufUtils.c"
}

GdkPixbuf*
pf_pixbuf_utils_darken (GdkPixbuf* src,
                        guint8 saturation,
                        guint8 darken)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint _tmp11_;
	gint _tmp12_;
	gint width = 0;
	gint _tmp13_;
	gint _tmp14_;
	gint height = 0;
	gint _tmp15_;
	gint _tmp16_;
	gboolean has_alpha = FALSE;
	gboolean _tmp17_;
	gboolean _tmp18_;
	gint channels = 0;
	gint _tmp19_;
	gint _tmp20_;
	GdkPixbuf* dest = NULL;
	GdkColorspace _tmp21_;
	GdkColorspace _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GdkPixbuf* _tmp25_;
	gint dst_row_stride = 0;
	GdkPixbuf* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint src_row_stride = 0;
	gint _tmp29_;
	gint _tmp30_;
	guint8* target_pix = NULL;
	GdkPixbuf* _tmp31_;
	void* _tmp32_;
	void* _tmp33_;
	gint target_pix_length1;
	gint _target_pix_size_;
	guint8* original_pix = NULL;
	void* _tmp34_;
	void* _tmp35_;
	gint original_pix_length1;
	gint _original_pix_size_;
	GdkPixbuf* result;
#line 61 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 62 "../libcore/PixbufUtils.vala"
	_tmp2_ = gdk_pixbuf_get_has_alpha (src);
#line 62 "../libcore/PixbufUtils.vala"
	_tmp3_ = _tmp2_;
#line 62 "../libcore/PixbufUtils.vala"
	if (!_tmp3_) {
#line 464 "PixbufUtils.c"
		gint _tmp4_;
		gint _tmp5_;
#line 62 "../libcore/PixbufUtils.vala"
		_tmp4_ = gdk_pixbuf_get_n_channels (src);
#line 62 "../libcore/PixbufUtils.vala"
		_tmp5_ = _tmp4_;
#line 62 "../libcore/PixbufUtils.vala"
		_tmp1_ = _tmp5_ == 3;
#line 473 "PixbufUtils.c"
	} else {
#line 62 "../libcore/PixbufUtils.vala"
		_tmp1_ = FALSE;
#line 477 "PixbufUtils.c"
	}
#line 62 "../libcore/PixbufUtils.vala"
	if (_tmp1_) {
#line 62 "../libcore/PixbufUtils.vala"
		_tmp0_ = TRUE;
#line 483 "PixbufUtils.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 62 "../libcore/PixbufUtils.vala"
		_tmp7_ = gdk_pixbuf_get_has_alpha (src);
#line 62 "../libcore/PixbufUtils.vala"
		_tmp8_ = _tmp7_;
#line 62 "../libcore/PixbufUtils.vala"
		if (_tmp8_) {
#line 494 "PixbufUtils.c"
			gint _tmp9_;
			gint _tmp10_;
#line 62 "../libcore/PixbufUtils.vala"
			_tmp9_ = gdk_pixbuf_get_n_channels (src);
#line 62 "../libcore/PixbufUtils.vala"
			_tmp10_ = _tmp9_;
#line 62 "../libcore/PixbufUtils.vala"
			_tmp6_ = _tmp10_ == 4;
#line 503 "PixbufUtils.c"
		} else {
#line 62 "../libcore/PixbufUtils.vala"
			_tmp6_ = FALSE;
#line 507 "PixbufUtils.c"
		}
#line 62 "../libcore/PixbufUtils.vala"
		_tmp0_ = _tmp6_;
#line 511 "PixbufUtils.c"
	}
#line 62 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (_tmp0_, src);
#line 64 "../libcore/PixbufUtils.vala"
	_tmp11_ = gdk_pixbuf_get_bits_per_sample (src);
#line 64 "../libcore/PixbufUtils.vala"
	_tmp12_ = _tmp11_;
#line 64 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (_tmp12_ == 8, src);
#line 66 "../libcore/PixbufUtils.vala"
	_tmp13_ = gdk_pixbuf_get_width (src);
#line 66 "../libcore/PixbufUtils.vala"
	_tmp14_ = _tmp13_;
#line 66 "../libcore/PixbufUtils.vala"
	width = _tmp14_;
#line 67 "../libcore/PixbufUtils.vala"
	_tmp15_ = gdk_pixbuf_get_height (src);
#line 67 "../libcore/PixbufUtils.vala"
	_tmp16_ = _tmp15_;
#line 67 "../libcore/PixbufUtils.vala"
	height = _tmp16_;
#line 68 "../libcore/PixbufUtils.vala"
	_tmp17_ = gdk_pixbuf_get_has_alpha (src);
#line 68 "../libcore/PixbufUtils.vala"
	_tmp18_ = _tmp17_;
#line 68 "../libcore/PixbufUtils.vala"
	has_alpha = _tmp18_;
#line 69 "../libcore/PixbufUtils.vala"
	_tmp19_ = gdk_pixbuf_get_n_channels (src);
#line 69 "../libcore/PixbufUtils.vala"
	_tmp20_ = _tmp19_;
#line 69 "../libcore/PixbufUtils.vala"
	channels = _tmp20_;
#line 70 "../libcore/PixbufUtils.vala"
	_tmp21_ = gdk_pixbuf_get_colorspace (src);
#line 70 "../libcore/PixbufUtils.vala"
	_tmp22_ = _tmp21_;
#line 70 "../libcore/PixbufUtils.vala"
	_tmp23_ = gdk_pixbuf_get_bits_per_sample (src);
#line 70 "../libcore/PixbufUtils.vala"
	_tmp24_ = _tmp23_;
#line 70 "../libcore/PixbufUtils.vala"
	_tmp25_ = gdk_pixbuf_new (_tmp22_, has_alpha, _tmp24_, width, height);
#line 70 "../libcore/PixbufUtils.vala"
	dest = _tmp25_;
#line 71 "../libcore/PixbufUtils.vala"
	_tmp26_ = dest;
#line 71 "../libcore/PixbufUtils.vala"
	_tmp27_ = gdk_pixbuf_get_rowstride (_tmp26_);
#line 71 "../libcore/PixbufUtils.vala"
	_tmp28_ = _tmp27_;
#line 71 "../libcore/PixbufUtils.vala"
	dst_row_stride = _tmp28_;
#line 72 "../libcore/PixbufUtils.vala"
	_tmp29_ = gdk_pixbuf_get_rowstride (src);
#line 72 "../libcore/PixbufUtils.vala"
	_tmp30_ = _tmp29_;
#line 72 "../libcore/PixbufUtils.vala"
	src_row_stride = _tmp30_;
#line 73 "../libcore/PixbufUtils.vala"
	_tmp31_ = dest;
#line 73 "../libcore/PixbufUtils.vala"
	_tmp32_ = gdk_pixbuf_get_pixels (_tmp31_);
#line 73 "../libcore/PixbufUtils.vala"
	_tmp33_ = _tmp32_;
#line 73 "../libcore/PixbufUtils.vala"
	target_pix = (guint8*) _tmp33_;
#line 73 "../libcore/PixbufUtils.vala"
	target_pix_length1 = -1;
#line 73 "../libcore/PixbufUtils.vala"
	_target_pix_size_ = target_pix_length1;
#line 74 "../libcore/PixbufUtils.vala"
	_tmp34_ = gdk_pixbuf_get_pixels (src);
#line 74 "../libcore/PixbufUtils.vala"
	_tmp35_ = _tmp34_;
#line 74 "../libcore/PixbufUtils.vala"
	original_pix = (guint8*) _tmp35_;
#line 74 "../libcore/PixbufUtils.vala"
	original_pix_length1 = -1;
#line 74 "../libcore/PixbufUtils.vala"
	_original_pix_size_ = original_pix_length1;
#line 593 "PixbufUtils.c"
	{
		gint i = 0;
#line 75 "../libcore/PixbufUtils.vala"
		i = 0;
#line 598 "PixbufUtils.c"
		{
			gboolean _tmp36_ = FALSE;
#line 75 "../libcore/PixbufUtils.vala"
			_tmp36_ = TRUE;
#line 75 "../libcore/PixbufUtils.vala"
			while (TRUE) {
#line 605 "PixbufUtils.c"
				gint src_row = 0;
				gint dst_row = 0;
#line 75 "../libcore/PixbufUtils.vala"
				if (!_tmp36_) {
#line 610 "PixbufUtils.c"
					gint _tmp37_;
#line 75 "../libcore/PixbufUtils.vala"
					_tmp37_ = i;
#line 75 "../libcore/PixbufUtils.vala"
					i = _tmp37_ + 1;
#line 616 "PixbufUtils.c"
				}
#line 75 "../libcore/PixbufUtils.vala"
				_tmp36_ = FALSE;
#line 75 "../libcore/PixbufUtils.vala"
				if (!(i < height)) {
#line 75 "../libcore/PixbufUtils.vala"
					break;
#line 624 "PixbufUtils.c"
				}
#line 76 "../libcore/PixbufUtils.vala"
				src_row = i * src_row_stride;
#line 77 "../libcore/PixbufUtils.vala"
				dst_row = i * dst_row_stride;
#line 630 "PixbufUtils.c"
				{
					gint j = 0;
#line 78 "../libcore/PixbufUtils.vala"
					j = 0;
#line 635 "PixbufUtils.c"
					{
						gboolean _tmp38_ = FALSE;
#line 78 "../libcore/PixbufUtils.vala"
						_tmp38_ = TRUE;
#line 78 "../libcore/PixbufUtils.vala"
						while (TRUE) {
#line 642 "PixbufUtils.c"
							gint width_offset = 0;
							guint8 r = 0U;
							guint8* _tmp40_;
							gint _tmp40__length1;
							guint8 _tmp41_;
							guint8 g = 0U;
							guint8* _tmp42_;
							gint _tmp42__length1;
							guint8 _tmp43_;
							guint8 b = 0U;
							guint8* _tmp44_;
							gint _tmp44__length1;
							guint8 _tmp45_;
							guint8 intensity = 0U;
							guint8 negalpha = 0U;
							guint8 alpha = 0U;
							guint8* _tmp46_;
							gint _tmp46__length1;
							guint8* _tmp47_;
							gint _tmp47__length1;
							guint8* _tmp48_;
							gint _tmp48__length1;
#line 78 "../libcore/PixbufUtils.vala"
							if (!_tmp38_) {
#line 667 "PixbufUtils.c"
								gint _tmp39_;
#line 78 "../libcore/PixbufUtils.vala"
								_tmp39_ = j;
#line 78 "../libcore/PixbufUtils.vala"
								j = _tmp39_ + 1;
#line 673 "PixbufUtils.c"
							}
#line 78 "../libcore/PixbufUtils.vala"
							_tmp38_ = FALSE;
#line 78 "../libcore/PixbufUtils.vala"
							if (!(j < width)) {
#line 78 "../libcore/PixbufUtils.vala"
								break;
#line 681 "PixbufUtils.c"
							}
#line 79 "../libcore/PixbufUtils.vala"
							width_offset = j * channels;
#line 80 "../libcore/PixbufUtils.vala"
							_tmp40_ = original_pix;
#line 80 "../libcore/PixbufUtils.vala"
							_tmp40__length1 = original_pix_length1;
#line 80 "../libcore/PixbufUtils.vala"
							_tmp41_ = _tmp40_[src_row + width_offset];
#line 80 "../libcore/PixbufUtils.vala"
							r = _tmp41_;
#line 81 "../libcore/PixbufUtils.vala"
							_tmp42_ = original_pix;
#line 81 "../libcore/PixbufUtils.vala"
							_tmp42__length1 = original_pix_length1;
#line 81 "../libcore/PixbufUtils.vala"
							_tmp43_ = _tmp42_[(src_row + width_offset) + 1];
#line 81 "../libcore/PixbufUtils.vala"
							g = _tmp43_;
#line 82 "../libcore/PixbufUtils.vala"
							_tmp44_ = original_pix;
#line 82 "../libcore/PixbufUtils.vala"
							_tmp44__length1 = original_pix_length1;
#line 82 "../libcore/PixbufUtils.vala"
							_tmp45_ = _tmp44_[(src_row + width_offset) + 2];
#line 82 "../libcore/PixbufUtils.vala"
							b = _tmp45_;
#line 83 "../libcore/PixbufUtils.vala"
							intensity = (guint8) ((((r * 77) + (g * 150)) + (b * 28)) >> 8);
#line 84 "../libcore/PixbufUtils.vala"
							negalpha = (guint8) (((G_MAXUINT8 - saturation) * darken) >> 8);
#line 85 "../libcore/PixbufUtils.vala"
							alpha = (guint8) ((saturation * darken) >> 8);
#line 86 "../libcore/PixbufUtils.vala"
							_tmp46_ = target_pix;
#line 86 "../libcore/PixbufUtils.vala"
							_tmp46__length1 = target_pix_length1;
#line 86 "../libcore/PixbufUtils.vala"
							_tmp46_[dst_row + width_offset] = (guint8) (((negalpha * intensity) + (alpha * r)) >> 8);
#line 87 "../libcore/PixbufUtils.vala"
							_tmp47_ = target_pix;
#line 87 "../libcore/PixbufUtils.vala"
							_tmp47__length1 = target_pix_length1;
#line 87 "../libcore/PixbufUtils.vala"
							_tmp47_[(dst_row + width_offset) + 1] = (guint8) (((negalpha * intensity) + (alpha * g)) >> 8);
#line 88 "../libcore/PixbufUtils.vala"
							_tmp48_ = target_pix;
#line 88 "../libcore/PixbufUtils.vala"
							_tmp48__length1 = target_pix_length1;
#line 88 "../libcore/PixbufUtils.vala"
							_tmp48_[(dst_row + width_offset) + 2] = (guint8) (((negalpha * intensity) + (alpha * b)) >> 8);
#line 89 "../libcore/PixbufUtils.vala"
							if (has_alpha) {
#line 735 "PixbufUtils.c"
								guint8* _tmp49_;
								gint _tmp49__length1;
								guint8* _tmp50_;
								gint _tmp50__length1;
								guint8 _tmp51_;
#line 90 "../libcore/PixbufUtils.vala"
								_tmp49_ = target_pix;
#line 90 "../libcore/PixbufUtils.vala"
								_tmp49__length1 = target_pix_length1;
#line 90 "../libcore/PixbufUtils.vala"
								_tmp50_ = original_pix;
#line 90 "../libcore/PixbufUtils.vala"
								_tmp50__length1 = original_pix_length1;
#line 90 "../libcore/PixbufUtils.vala"
								_tmp51_ = _tmp50_[(src_row + width_offset) + 3];
#line 90 "../libcore/PixbufUtils.vala"
								_tmp49_[(dst_row + width_offset) + 3] = _tmp51_;
#line 753 "PixbufUtils.c"
							}
						}
					}
				}
			}
		}
	}
#line 95 "../libcore/PixbufUtils.vala"
	result = dest;
#line 95 "../libcore/PixbufUtils.vala"
	return result;
#line 765 "PixbufUtils.c"
}

GdkPixbuf*
pf_pixbuf_utils_lucent (GdkPixbuf* src,
                        guint percent)
{
	gint width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gboolean has_alpha = FALSE;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GdkPixbuf* dest = NULL;
	GdkColorspace _tmp6_;
	GdkColorspace _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GdkPixbuf* _tmp10_;
	gint dst_row_stride = 0;
	GdkPixbuf* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint src_row_stride = 0;
	gint _tmp14_;
	gint _tmp15_;
	guint8* target_pix = NULL;
	GdkPixbuf* _tmp16_;
	void* _tmp17_;
	void* _tmp18_;
	gint target_pix_length1;
	gint _target_pix_size_;
	guint8* original_pix = NULL;
	void* _tmp19_;
	void* _tmp20_;
	gint original_pix_length1;
	gint _original_pix_size_;
	GdkPixbuf* result;
#line 98 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 99 "../libcore/PixbufUtils.vala"
	g_return_val_if_fail (percent <= ((guint) 100), src);
#line 101 "../libcore/PixbufUtils.vala"
	_tmp0_ = gdk_pixbuf_get_width (src);
#line 101 "../libcore/PixbufUtils.vala"
	_tmp1_ = _tmp0_;
#line 101 "../libcore/PixbufUtils.vala"
	width = _tmp1_;
#line 102 "../libcore/PixbufUtils.vala"
	_tmp2_ = gdk_pixbuf_get_height (src);
#line 102 "../libcore/PixbufUtils.vala"
	_tmp3_ = _tmp2_;
#line 102 "../libcore/PixbufUtils.vala"
	height = _tmp3_;
#line 103 "../libcore/PixbufUtils.vala"
	_tmp4_ = gdk_pixbuf_get_has_alpha (src);
#line 103 "../libcore/PixbufUtils.vala"
	_tmp5_ = _tmp4_;
#line 103 "../libcore/PixbufUtils.vala"
	has_alpha = _tmp5_;
#line 104 "../libcore/PixbufUtils.vala"
	_tmp6_ = gdk_pixbuf_get_colorspace (src);
#line 104 "../libcore/PixbufUtils.vala"
	_tmp7_ = _tmp6_;
#line 104 "../libcore/PixbufUtils.vala"
	_tmp8_ = gdk_pixbuf_get_bits_per_sample (src);
#line 104 "../libcore/PixbufUtils.vala"
	_tmp9_ = _tmp8_;
#line 104 "../libcore/PixbufUtils.vala"
	_tmp10_ = gdk_pixbuf_new (_tmp7_, TRUE, _tmp9_, width, height);
#line 104 "../libcore/PixbufUtils.vala"
	dest = _tmp10_;
#line 105 "../libcore/PixbufUtils.vala"
	_tmp11_ = dest;
#line 105 "../libcore/PixbufUtils.vala"
	_tmp12_ = gdk_pixbuf_get_rowstride (_tmp11_);
#line 105 "../libcore/PixbufUtils.vala"
	_tmp13_ = _tmp12_;
#line 105 "../libcore/PixbufUtils.vala"
	dst_row_stride = _tmp13_;
#line 106 "../libcore/PixbufUtils.vala"
	_tmp14_ = gdk_pixbuf_get_rowstride (src);
#line 106 "../libcore/PixbufUtils.vala"
	_tmp15_ = _tmp14_;
#line 106 "../libcore/PixbufUtils.vala"
	src_row_stride = _tmp15_;
#line 107 "../libcore/PixbufUtils.vala"
	_tmp16_ = dest;
#line 107 "../libcore/PixbufUtils.vala"
	_tmp17_ = gdk_pixbuf_get_pixels (_tmp16_);
#line 107 "../libcore/PixbufUtils.vala"
	_tmp18_ = _tmp17_;
#line 107 "../libcore/PixbufUtils.vala"
	target_pix = (guint8*) _tmp18_;
#line 107 "../libcore/PixbufUtils.vala"
	target_pix_length1 = -1;
#line 107 "../libcore/PixbufUtils.vala"
	_target_pix_size_ = target_pix_length1;
#line 108 "../libcore/PixbufUtils.vala"
	_tmp19_ = gdk_pixbuf_get_pixels (src);
#line 108 "../libcore/PixbufUtils.vala"
	_tmp20_ = _tmp19_;
#line 108 "../libcore/PixbufUtils.vala"
	original_pix = (guint8*) _tmp20_;
#line 108 "../libcore/PixbufUtils.vala"
	original_pix_length1 = -1;
#line 108 "../libcore/PixbufUtils.vala"
	_original_pix_size_ = original_pix_length1;
#line 109 "../libcore/PixbufUtils.vala"
	if (has_alpha) {
#line 878 "PixbufUtils.c"
		gdouble ratio = 0.0;
#line 110 "../libcore/PixbufUtils.vala"
		ratio = ((gdouble) percent) / 100;
#line 882 "PixbufUtils.c"
		{
			gint i = 0;
#line 111 "../libcore/PixbufUtils.vala"
			i = 0;
#line 887 "PixbufUtils.c"
			{
				gboolean _tmp21_ = FALSE;
#line 111 "../libcore/PixbufUtils.vala"
				_tmp21_ = TRUE;
#line 111 "../libcore/PixbufUtils.vala"
				while (TRUE) {
#line 894 "PixbufUtils.c"
					gint src_row = 0;
					gint dst_row = 0;
#line 111 "../libcore/PixbufUtils.vala"
					if (!_tmp21_) {
#line 899 "PixbufUtils.c"
						gint _tmp22_;
#line 111 "../libcore/PixbufUtils.vala"
						_tmp22_ = i;
#line 111 "../libcore/PixbufUtils.vala"
						i = _tmp22_ + 1;
#line 905 "PixbufUtils.c"
					}
#line 111 "../libcore/PixbufUtils.vala"
					_tmp21_ = FALSE;
#line 111 "../libcore/PixbufUtils.vala"
					if (!(i < height)) {
#line 111 "../libcore/PixbufUtils.vala"
						break;
#line 913 "PixbufUtils.c"
					}
#line 112 "../libcore/PixbufUtils.vala"
					src_row = i * src_row_stride;
#line 113 "../libcore/PixbufUtils.vala"
					dst_row = i * dst_row_stride;
#line 919 "PixbufUtils.c"
					{
						gint j = 0;
#line 114 "../libcore/PixbufUtils.vala"
						j = 0;
#line 924 "PixbufUtils.c"
						{
							gboolean _tmp23_ = FALSE;
#line 114 "../libcore/PixbufUtils.vala"
							_tmp23_ = TRUE;
#line 114 "../libcore/PixbufUtils.vala"
							while (TRUE) {
#line 931 "PixbufUtils.c"
								gint dr = 0;
								gint sr = 0;
								guint8* _tmp25_;
								gint _tmp25__length1;
								gint _tmp26_;
								guint8* _tmp27_;
								gint _tmp27__length1;
								gint _tmp28_;
								guint8 _tmp29_;
								guint8* _tmp30_;
								gint _tmp30__length1;
								gint _tmp31_;
								guint8* _tmp32_;
								gint _tmp32__length1;
								gint _tmp33_;
								guint8 _tmp34_;
								guint8* _tmp35_;
								gint _tmp35__length1;
								gint _tmp36_;
								guint8* _tmp37_;
								gint _tmp37__length1;
								gint _tmp38_;
								guint8 _tmp39_;
								guint8* _tmp40_;
								gint _tmp40__length1;
								guint8* _tmp41_;
								gint _tmp41__length1;
								guint8 _tmp42_;
#line 114 "../libcore/PixbufUtils.vala"
								if (!_tmp23_) {
#line 962 "PixbufUtils.c"
									gint _tmp24_;
#line 114 "../libcore/PixbufUtils.vala"
									_tmp24_ = j;
#line 114 "../libcore/PixbufUtils.vala"
									j = _tmp24_ + 1;
#line 968 "PixbufUtils.c"
								}
#line 114 "../libcore/PixbufUtils.vala"
								_tmp23_ = FALSE;
#line 114 "../libcore/PixbufUtils.vala"
								if (!(j < width)) {
#line 114 "../libcore/PixbufUtils.vala"
									break;
#line 976 "PixbufUtils.c"
								}
#line 115 "../libcore/PixbufUtils.vala"
								dr = dst_row + (j * 4);
#line 116 "../libcore/PixbufUtils.vala"
								sr = src_row + (j * 4);
#line 117 "../libcore/PixbufUtils.vala"
								_tmp25_ = target_pix;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp25__length1 = target_pix_length1;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp26_ = dr;
#line 117 "../libcore/PixbufUtils.vala"
								dr = _tmp26_ + 1;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp27_ = original_pix;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp27__length1 = original_pix_length1;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp28_ = sr;
#line 117 "../libcore/PixbufUtils.vala"
								sr = _tmp28_ + 1;
#line 117 "../libcore/PixbufUtils.vala"
								_tmp29_ = _tmp27_[_tmp28_];
#line 117 "../libcore/PixbufUtils.vala"
								_tmp25_[_tmp26_] = _tmp29_;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp30_ = target_pix;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp30__length1 = target_pix_length1;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp31_ = dr;
#line 118 "../libcore/PixbufUtils.vala"
								dr = _tmp31_ + 1;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp32_ = original_pix;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp32__length1 = original_pix_length1;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp33_ = sr;
#line 118 "../libcore/PixbufUtils.vala"
								sr = _tmp33_ + 1;
#line 118 "../libcore/PixbufUtils.vala"
								_tmp34_ = _tmp32_[_tmp33_];
#line 118 "../libcore/PixbufUtils.vala"
								_tmp30_[_tmp31_] = _tmp34_;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp35_ = target_pix;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp35__length1 = target_pix_length1;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp36_ = dr;
#line 119 "../libcore/PixbufUtils.vala"
								dr = _tmp36_ + 1;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp37_ = original_pix;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp37__length1 = original_pix_length1;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp38_ = sr;
#line 119 "../libcore/PixbufUtils.vala"
								sr = _tmp38_ + 1;
#line 119 "../libcore/PixbufUtils.vala"
								_tmp39_ = _tmp37_[_tmp38_];
#line 119 "../libcore/PixbufUtils.vala"
								_tmp35_[_tmp36_] = _tmp39_;
#line 120 "../libcore/PixbufUtils.vala"
								_tmp40_ = target_pix;
#line 120 "../libcore/PixbufUtils.vala"
								_tmp40__length1 = target_pix_length1;
#line 120 "../libcore/PixbufUtils.vala"
								_tmp41_ = original_pix;
#line 120 "../libcore/PixbufUtils.vala"
								_tmp41__length1 = original_pix_length1;
#line 120 "../libcore/PixbufUtils.vala"
								_tmp42_ = _tmp41_[sr];
#line 120 "../libcore/PixbufUtils.vala"
								_tmp40_[dr] = (guint8) (_tmp42_ * ratio);
#line 1054 "PixbufUtils.c"
							}
						}
					}
				}
			}
		}
	} else {
#line 124 "../libcore/PixbufUtils.vala"
		percent = (255U * percent) / 100U;
#line 1064 "PixbufUtils.c"
		{
			gint i = 0;
#line 125 "../libcore/PixbufUtils.vala"
			i = 0;
#line 1069 "PixbufUtils.c"
			{
				gboolean _tmp43_ = FALSE;
#line 125 "../libcore/PixbufUtils.vala"
				_tmp43_ = TRUE;
#line 125 "../libcore/PixbufUtils.vala"
				while (TRUE) {
#line 1076 "PixbufUtils.c"
					gint src_row = 0;
					gint dst_row = 0;
#line 125 "../libcore/PixbufUtils.vala"
					if (!_tmp43_) {
#line 1081 "PixbufUtils.c"
						gint _tmp44_;
#line 125 "../libcore/PixbufUtils.vala"
						_tmp44_ = i;
#line 125 "../libcore/PixbufUtils.vala"
						i = _tmp44_ + 1;
#line 1087 "PixbufUtils.c"
					}
#line 125 "../libcore/PixbufUtils.vala"
					_tmp43_ = FALSE;
#line 125 "../libcore/PixbufUtils.vala"
					if (!(i < height)) {
#line 125 "../libcore/PixbufUtils.vala"
						break;
#line 1095 "PixbufUtils.c"
					}
#line 126 "../libcore/PixbufUtils.vala"
					src_row = i * src_row_stride;
#line 127 "../libcore/PixbufUtils.vala"
					dst_row = i * dst_row_stride;
#line 1101 "PixbufUtils.c"
					{
						gint j = 0;
#line 128 "../libcore/PixbufUtils.vala"
						j = 0;
#line 1106 "PixbufUtils.c"
						{
							gboolean _tmp45_ = FALSE;
#line 128 "../libcore/PixbufUtils.vala"
							_tmp45_ = TRUE;
#line 128 "../libcore/PixbufUtils.vala"
							while (TRUE) {
#line 1113 "PixbufUtils.c"
								gint dr = 0;
								gint sr = 0;
								guint8* _tmp47_;
								gint _tmp47__length1;
								gint _tmp48_;
								guint8* _tmp49_;
								gint _tmp49__length1;
								gint _tmp50_;
								guint8 _tmp51_;
								guint8* _tmp52_;
								gint _tmp52__length1;
								gint _tmp53_;
								guint8* _tmp54_;
								gint _tmp54__length1;
								gint _tmp55_;
								guint8 _tmp56_;
								guint8* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
								guint8* _tmp59_;
								gint _tmp59__length1;
								gint _tmp60_;
								guint8 _tmp61_;
								guint8* _tmp62_;
								gint _tmp62__length1;
#line 128 "../libcore/PixbufUtils.vala"
								if (!_tmp45_) {
#line 1141 "PixbufUtils.c"
									gint _tmp46_;
#line 128 "../libcore/PixbufUtils.vala"
									_tmp46_ = j;
#line 128 "../libcore/PixbufUtils.vala"
									j = _tmp46_ + 1;
#line 1147 "PixbufUtils.c"
								}
#line 128 "../libcore/PixbufUtils.vala"
								_tmp45_ = FALSE;
#line 128 "../libcore/PixbufUtils.vala"
								if (!(j < width)) {
#line 128 "../libcore/PixbufUtils.vala"
									break;
#line 1155 "PixbufUtils.c"
								}
#line 129 "../libcore/PixbufUtils.vala"
								dr = dst_row + (j * 4);
#line 130 "../libcore/PixbufUtils.vala"
								sr = src_row + (j * 3);
#line 131 "../libcore/PixbufUtils.vala"
								_tmp47_ = target_pix;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp47__length1 = target_pix_length1;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp48_ = dr;
#line 131 "../libcore/PixbufUtils.vala"
								dr = _tmp48_ + 1;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp49_ = original_pix;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp49__length1 = original_pix_length1;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp50_ = sr;
#line 131 "../libcore/PixbufUtils.vala"
								sr = _tmp50_ + 1;
#line 131 "../libcore/PixbufUtils.vala"
								_tmp51_ = _tmp49_[_tmp50_];
#line 131 "../libcore/PixbufUtils.vala"
								_tmp47_[_tmp48_] = _tmp51_;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp52_ = target_pix;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp52__length1 = target_pix_length1;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp53_ = dr;
#line 132 "../libcore/PixbufUtils.vala"
								dr = _tmp53_ + 1;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp54_ = original_pix;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp54__length1 = original_pix_length1;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp55_ = sr;
#line 132 "../libcore/PixbufUtils.vala"
								sr = _tmp55_ + 1;
#line 132 "../libcore/PixbufUtils.vala"
								_tmp56_ = _tmp54_[_tmp55_];
#line 132 "../libcore/PixbufUtils.vala"
								_tmp52_[_tmp53_] = _tmp56_;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp57_ = target_pix;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp57__length1 = target_pix_length1;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp58_ = dr;
#line 133 "../libcore/PixbufUtils.vala"
								dr = _tmp58_ + 1;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp59_ = original_pix;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp59__length1 = original_pix_length1;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp60_ = sr;
#line 133 "../libcore/PixbufUtils.vala"
								sr = _tmp60_ + 1;
#line 133 "../libcore/PixbufUtils.vala"
								_tmp61_ = _tmp59_[_tmp60_];
#line 133 "../libcore/PixbufUtils.vala"
								_tmp57_[_tmp58_] = _tmp61_;
#line 134 "../libcore/PixbufUtils.vala"
								_tmp62_ = target_pix;
#line 134 "../libcore/PixbufUtils.vala"
								_tmp62__length1 = target_pix_length1;
#line 134 "../libcore/PixbufUtils.vala"
								_tmp62_[dr] = (guint8) percent;
#line 1227 "PixbufUtils.c"
							}
						}
					}
				}
			}
		}
	}
#line 139 "../libcore/PixbufUtils.vala"
	result = dest;
#line 139 "../libcore/PixbufUtils.vala"
	return result;
#line 1239 "PixbufUtils.c"
}

