/* AbstractDirectoryView.c generated by valac 0.56.17, the Vala compiler
 * generated from AbstractDirectoryView.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Jeremy Wootten <jeremy@elementaryos.org>
*/
/* Implementations of AbstractDirectoryView are
     * IconView
     * ListView
     * ColumnView
*/
/*** Private methods */
/** Signal Handlers */
/** Menu actions */
/** HELPER AND CONVENIENCE FUNCTIONS */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gio/gio.h>
#include "pantheon-files-core.h"
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include "marlin-file-operations.h"
#include <libportal/portal.h>
#include <libportal-gtk3/portal-gtk3.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "config.h"
#include <pango/pango.h>

#define FILES_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES 32
#define FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FILES_TYPE_ABSTRACT_DIRECTORY_VIEW (files_abstract_directory_view_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView))
#define FILES_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryViewClass))
#define FILES_IS_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FILES_IS_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryViewClass))

typedef struct _FilesAbstractDirectoryView FilesAbstractDirectoryView;
typedef struct _FilesAbstractDirectoryViewClass FilesAbstractDirectoryViewClass;
typedef struct _FilesAbstractDirectoryViewPrivate FilesAbstractDirectoryViewPrivate;

#define FILES_TYPE_TEXT_RENDERER (files_text_renderer_get_type ())
#define FILES_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_TEXT_RENDERER, FilesTextRenderer))
#define FILES_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_TEXT_RENDERER, FilesTextRendererClass))
#define FILES_IS_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_TEXT_RENDERER))
#define FILES_IS_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_TEXT_RENDERER))
#define FILES_TEXT_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_TEXT_RENDERER, FilesTextRendererClass))

typedef struct _FilesTextRenderer FilesTextRenderer;
typedef struct _FilesTextRendererClass FilesTextRendererClass;

#define FILES_TYPE_ICON_RENDERER (files_icon_renderer_get_type ())
#define FILES_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ICON_RENDERER, FilesIconRenderer))
#define FILES_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ICON_RENDERER, FilesIconRendererClass))
#define FILES_IS_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ICON_RENDERER))
#define FILES_IS_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ICON_RENDERER))
#define FILES_ICON_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ICON_RENDERER, FilesIconRendererClass))

typedef struct _FilesIconRenderer FilesIconRenderer;
typedef struct _FilesIconRendererClass FilesIconRendererClass;

#define FILES_VIEW_TYPE_SLOT (files_view_slot_get_type ())
#define FILES_VIEW_SLOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_SLOT, FilesViewSlot))
#define FILES_VIEW_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_SLOT, FilesViewSlotClass))
#define FILES_VIEW_IS_SLOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_SLOT))
#define FILES_VIEW_IS_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_SLOT))
#define FILES_VIEW_SLOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_SLOT, FilesViewSlotClass))

typedef struct _FilesViewSlot FilesViewSlot;
typedef struct _FilesViewSlotClass FilesViewSlotClass;

#define FILES_TYPE_CLIPBOARD_MANAGER (files_clipboard_manager_get_type ())
#define FILES_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManager))
#define FILES_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManagerClass))
#define FILES_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_CLIPBOARD_MANAGER))
#define FILES_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_CLIPBOARD_MANAGER))
#define FILES_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManagerClass))

typedef struct _FilesClipboardManager FilesClipboardManager;
typedef struct _FilesClipboardManagerClass FilesClipboardManagerClass;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_WINDOW_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES];
typedef enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID
} FilesAbstractDirectoryViewClickZone;

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_CLICK_ZONE (files_abstract_directory_view_click_zone_get_type ())
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
typedef void (*GSimpleActionChangeStateCallback) (GSimpleAction* action, GVariant* value, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

#define FILES_TYPE_APPLICATION (files_application_get_type ())
#define FILES_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_APPLICATION, FilesApplication))
#define FILES_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_APPLICATION, FilesApplicationClass))
#define FILES_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_APPLICATION))
#define FILES_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_APPLICATION))
#define FILES_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_APPLICATION, FilesApplicationClass))

typedef struct _FilesApplication FilesApplication;
typedef struct _FilesApplicationClass FilesApplicationClass;
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
typedef struct _Block19Data Block19Data;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;

#define FILES_VIEW_TYPE_WINDOW (files_view_window_get_type ())
#define FILES_VIEW_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_WINDOW, FilesViewWindow))
#define FILES_VIEW_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_WINDOW, FilesViewWindowClass))
#define FILES_VIEW_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_WINDOW))
#define FILES_VIEW_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_WINDOW))
#define FILES_VIEW_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_WINDOW, FilesViewWindowClass))

typedef struct _FilesViewWindow FilesViewWindow;
typedef struct _FilesViewWindowClass FilesViewWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;

#define FILES_TYPE_RENAMER_DIALOG (files_renamer_dialog_get_type ())
#define FILES_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog))
#define FILES_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))
#define FILES_IS_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_RENAMER_DIALOG))
#define FILES_IS_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_RENAMER_DIALOG))
#define FILES_RENAMER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))

typedef struct _FilesRenamerDialog FilesRenamerDialog;
typedef struct _FilesRenamerDialogClass FilesRenamerDialogClass;
#define __vala_XdpParent_free0(var) ((var == NULL) ? NULL : (var = (_vala_XdpParent_free (var), NULL)))

#define FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG (files_view_abstract_properties_dialog_get_type ())
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialog))
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialogClass))
#define FILES_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define FILES_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialogClass))

typedef struct _FilesViewAbstractPropertiesDialog FilesViewAbstractPropertiesDialog;
typedef struct _FilesViewAbstractPropertiesDialogClass FilesViewAbstractPropertiesDialogClass;

#define FILES_VIEW_TYPE_PROPERTIES_WINDOW (files_view_properties_window_get_type ())
#define FILES_VIEW_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindow))
#define FILES_VIEW_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindowClass))
#define FILES_VIEW_IS_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW))
#define FILES_VIEW_IS_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_PROPERTIES_WINDOW))
#define FILES_VIEW_PROPERTIES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindowClass))

typedef struct _FilesViewPropertiesWindow FilesViewPropertiesWindow;
typedef struct _FilesViewPropertiesWindowClass FilesViewPropertiesWindowClass;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM (files_abstract_directory_view_sort_sub_menu_item_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItem))
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItemClass))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItemClass))

typedef struct _FilesAbstractDirectoryViewSortSubMenuItem FilesAbstractDirectoryViewSortSubMenuItem;
typedef struct _FilesAbstractDirectoryViewSortSubMenuItemClass FilesAbstractDirectoryViewSortSubMenuItemClass;

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM (files_abstract_directory_view_new_sub_menu_item_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItem))
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItemClass))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItemClass))

typedef struct _FilesAbstractDirectoryViewNewSubMenuItem FilesAbstractDirectoryViewNewSubMenuItem;
typedef struct _FilesAbstractDirectoryViewNewSubMenuItemClass FilesAbstractDirectoryViewNewSubMenuItemClass;
typedef struct _Block31Data Block31Data;
typedef struct _Block32Data Block32Data;

#define FILES_TYPE_ABSTRACT_TREE_VIEW (files_abstract_tree_view_get_type ())
#define FILES_ABSTRACT_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ABSTRACT_TREE_VIEW, FilesAbstractTreeView))
#define FILES_ABSTRACT_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ABSTRACT_TREE_VIEW, FilesAbstractTreeViewClass))
#define FILES_IS_ABSTRACT_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ABSTRACT_TREE_VIEW))
#define FILES_IS_ABSTRACT_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ABSTRACT_TREE_VIEW))
#define FILES_ABSTRACT_TREE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ABSTRACT_TREE_VIEW, FilesAbstractTreeViewClass))

typedef struct _FilesAbstractTreeView FilesAbstractTreeView;
typedef struct _FilesAbstractTreeViewClass FilesAbstractTreeViewClass;

#define FILES_TYPE_COLUMN_VIEW (files_column_view_get_type ())
#define FILES_COLUMN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_COLUMN_VIEW, FilesColumnView))
#define FILES_COLUMN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_COLUMN_VIEW, FilesColumnViewClass))
#define FILES_IS_COLUMN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_COLUMN_VIEW))
#define FILES_IS_COLUMN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_COLUMN_VIEW))
#define FILES_COLUMN_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_COLUMN_VIEW, FilesColumnViewClass))

typedef struct _FilesColumnView FilesColumnView;
typedef struct _FilesColumnViewClass FilesColumnViewClass;

#define FILES_VIEW_TYPE_VIEW_CONTAINER (files_view_view_container_get_type ())
#define FILES_VIEW_VIEW_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_VIEW_CONTAINER, FilesViewViewContainer))
#define FILES_VIEW_VIEW_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_VIEW_CONTAINER, FilesViewViewContainerClass))
#define FILES_VIEW_IS_VIEW_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_VIEW_CONTAINER))
#define FILES_VIEW_IS_VIEW_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_VIEW_CONTAINER))
#define FILES_VIEW_VIEW_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_VIEW_CONTAINER, FilesViewViewContainerClass))

typedef struct _FilesViewViewContainer FilesViewViewContainer;
typedef struct _FilesViewViewContainerClass FilesViewViewContainerClass;
typedef struct _FilesViewViewContainerPrivate FilesViewViewContainerPrivate;

#define FILES_VIEW_TYPE_MILLER (files_view_miller_get_type ())
#define FILES_VIEW_MILLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_MILLER, FilesViewMiller))
#define FILES_VIEW_MILLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_MILLER, FilesViewMillerClass))
#define FILES_VIEW_IS_MILLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_MILLER))
#define FILES_VIEW_IS_MILLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_MILLER))
#define FILES_VIEW_MILLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_MILLER, FilesViewMillerClass))

typedef struct _FilesViewMiller FilesViewMiller;
typedef struct _FilesViewMillerClass FilesViewMillerClass;

#define FILES_TYPE_ABSTRACT_EDITABLE_LABEL (files_abstract_editable_label_get_type ())
#define FILES_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabel))
#define FILES_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabelClass))
#define FILES_IS_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL))
#define FILES_IS_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ABSTRACT_EDITABLE_LABEL))
#define FILES_ABSTRACT_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabelClass))

typedef struct _FilesAbstractEditableLabel FilesAbstractEditableLabel;
typedef struct _FilesAbstractEditableLabelClass FilesAbstractEditableLabelClass;
typedef struct _FilesAbstractDirectoryViewSetFileDisplayNameData FilesAbstractDirectoryViewSetFileDisplayNameData;
typedef struct _Block33Data Block33Data;
typedef struct _Block34Data Block34Data;
typedef struct _Block35Data Block35Data;
typedef struct _Block36Data Block36Data;
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
#define __vala_GdkEventKey_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventKey_free (var), NULL)))
typedef struct _FilesIconRendererPrivate FilesIconRendererPrivate;
typedef struct _FilesAbstractDirectoryViewSortSubMenuItemPrivate FilesAbstractDirectoryViewSortSubMenuItemPrivate;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_sort_sub_menu_item_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES];
typedef struct _FilesAbstractDirectoryViewNewSubMenuItemPrivate FilesAbstractDirectoryViewNewSubMenuItemPrivate;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_new_sub_menu_item_properties[FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES];
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL,
	FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL,
	FILES_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS
};
static guint files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FilesAbstractDirectoryView {
	GtkScrolledWindow parent_instance;
	FilesAbstractDirectoryViewPrivate * priv;
	FilesZoomLevel minimum_zoom;
	FilesZoomLevel maximum_zoom;
	GList* source_drag_file_list;
	GdkAtom current_target_type;
	gboolean dnd_disabled;
	FilesTextRenderer* name_renderer;
	gchar* original_name;
	gchar* proposed_name;
	gboolean right_margin_unselects_all;
	gboolean on_directory;
	gboolean one_or_less;
	gboolean should_activate;
	gboolean should_deselect;
	gboolean should_thumbnail;
	gboolean should_select;
	GtkTreePath* click_path;
	guint click_zone;
	guint previous_click_zone;
	GList* selected_files;
	gboolean is_writable;
	gboolean is_loading;
	gboolean helpers_shown;
	FilesListModel* model;
	FilesIconRenderer* icon_renderer;
	FilesViewSlot* slot;
	GtkRecentManager* recent;
	GtkEventControllerKey* key_controller;
	GtkGestureMultiPress* button_controller;
	GtkEventControllerScroll* scroll_controller;
	GtkEventControllerMotion* motion_controller;
};

struct _FilesAbstractDirectoryViewClass {
	GtkScrolledWindowClass parent_class;
	void (*on_row_deleted) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*on_view_key_press_event) (FilesAbstractDirectoryView* self, guint original_keyval, guint keycode, GdkModifierType state);
	void (*on_scroll_event) (FilesAbstractDirectoryView* self, gdouble dx, gdouble dy);
	gboolean (*on_view_draw) (FilesAbstractDirectoryView* self, cairo_t* cr);
	gboolean (*handle_primary_button_click) (FilesAbstractDirectoryView* self, guint n_press, GdkModifierType mods, GtkTreePath* path);
	void (*on_view_button_press_event) (FilesAbstractDirectoryView* self, gint n_press, gdouble x, gdouble y);
	void (*on_view_button_release_event) (FilesAbstractDirectoryView* self, gint n_press, gdouble x, gdouble y);
	void (*change_zoom_level) (FilesAbstractDirectoryView* self);
	gboolean (*expand_collapse) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*handle_default_button_click) (FilesAbstractDirectoryView* self);
	gboolean (*get_next_visible_iter) (FilesAbstractDirectoryView* self, GtkTreeIter* iter, gboolean recurse);
	void (*cancel) (FilesAbstractDirectoryView* self);
	void (*highlight_path) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*up) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*down) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GSettings* (*get_view_settings) (FilesAbstractDirectoryView* self);
	void (*set_up_zoom_level) (FilesAbstractDirectoryView* self);
	gboolean (*view_has_focus) (FilesAbstractDirectoryView* self);
	void (*scroll_to_cell) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean scroll_to_top);
	GList* (*get_selected_paths) (FilesAbstractDirectoryView* self);
	GtkTreePath* (*get_path_at_pos) (FilesAbstractDirectoryView* self, gint x, gint win);
	GtkTreePath* (*get_path_at_cursor) (FilesAbstractDirectoryView* self);
	void (*tree_select_all) (FilesAbstractDirectoryView* self);
	void (*tree_unselect_all) (FilesAbstractDirectoryView* self);
	void (*tree_unselect_others) (FilesAbstractDirectoryView* self);
	void (*select_path) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean cursor_follows);
	void (*unselect_path) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*path_is_selected) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*get_visible_range) (FilesAbstractDirectoryView* self, GtkTreePath** start_path, GtkTreePath** end_path);
	void (*set_cursor) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean start_editing, gboolean select, gboolean scroll_to_top);
	gboolean (*move_cursor) (FilesAbstractDirectoryView* self, guint keyval, gboolean only_shift_pressed, gboolean control_pressed);
	gboolean (*will_handle_button_press) (FilesAbstractDirectoryView* self, gboolean no_mods, gboolean only_control_pressed, gboolean only_shift_pressed);
	gboolean (*handle_multi_select) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkWidget* (*create_view) (FilesAbstractDirectoryView* self);
	guint (*get_event_position_info) (FilesAbstractDirectoryView* self, gdouble x, gdouble y, GtkTreePath** path, gboolean rubberband);
	void (*scroll_to_path) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean scroll_to_top);
	void (*set_cursor_on_cell) (FilesAbstractDirectoryView* self, GtkTreePath* path, GtkCellRenderer* renderer, gboolean start_editing, gboolean scroll_to_top);
	void (*freeze_tree) (FilesAbstractDirectoryView* self);
	void (*thaw_tree) (FilesAbstractDirectoryView* self);
	void (*freeze_child_notify) (FilesAbstractDirectoryView* self);
	void (*thaw_child_notify) (FilesAbstractDirectoryView* self);
	void (*connect_tree_signals) (FilesAbstractDirectoryView* self);
	void (*disconnect_tree_signals) (FilesAbstractDirectoryView* self);
};

struct _FilesAbstractDirectoryViewPrivate {
	GSimpleActionGroup* common_actions;
	GSimpleActionGroup* selection_actions;
	GSimpleActionGroup* background_actions;
	FilesZoomLevel _zoom_level;
	gdouble drag_x;
	gdouble drag_y;
	guint drag_scroll_timer_id;
	guint drag_enter_timer_id;
	gboolean destination_data_ready;
	gboolean drop_occurred;
	FilesFile* drop_target_file;
	GList* destination_drop_file_list;
	GdkDragAction current_suggested_action;
	GdkDragAction current_actions;
	gboolean _drop_highlight;
	gboolean button_press_disabled;
	void* drag_data;
	gint thumbnail_request;
	guint thumbnail_source_id;
	guint freeze_source_id;
	FilesThumbnailer* thumbnailer;
	guint add_remove_file_timeout_id;
	gboolean signal_free_space_change;
	gdouble total_delta_y;
	GtkTreePath* deleted_path;
	gboolean _singleclick_select;
	GdkCursor* editable_cursor;
	GdkCursor* activatable_cursor;
	GdkCursor* selectable_cursor;
	GList* open_with_apps;
	gboolean selected_files_invalid;
	GAppInfo* default_app;
	GtkTreePath* hover_path;
	gboolean _renaming;
	gboolean _is_frozen;
	gboolean _in_recent;
	gboolean _tree_frozen;
	gboolean in_trash;
	gboolean in_network_root;
	gboolean all_selected;
	GtkWidget* view;
	FilesClipboardManager* clipboard;
	guint set_cursor_timeout_id;
	gulong select_source_handler;
	guint draw_timeout_id;
};

struct _Block17Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	gboolean select;
};

struct _Block18Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GeeLinkedList* files_to_select_list;
	GFile* focus_after_select;
};

struct _Block19Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GdkScreen* screen;
	FilesOpenFlag flag;
};

struct _Block20Data {
	int _ref_count_;
	Block19Data * _data19_;
	FilesFile* file;
};

struct _Block21Data {
	int _ref_count_;
	Block19Data * _data19_;
	GList* files_to_open;
};

struct _Block22Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	gboolean only_folders;
};

struct _Block23Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GList* locations;
};

struct _Block24Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file;
};

struct _Block25Data {
	int _ref_count_;
	Block24Data * _data24_;
	gulong model_resorted;
};

struct _Block26Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file_to_rename;
};

struct _Block27Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GFile* target;
};

struct _Block28Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GFile* target;
};

struct _Block29Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file;
};

struct _Block30Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file;
};

struct _Block31Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GdkDevice* pointer;
};

struct _Block32Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GList* action_files;
};

struct _FilesViewViewContainer {
	GtkBox parent_instance;
	FilesViewViewContainerPrivate * priv;
	GtkWidget* content_item;
	FilesAbstractSlot* view;
	FilesViewMode view_mode;
};

struct _FilesViewViewContainerClass {
	GtkBoxClass parent_class;
};

struct _FilesAbstractDirectoryViewSetFileDisplayNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FilesAbstractDirectoryView* self;
	GFile* old_location;
	gchar* new_name;
	GCancellable* cancellable;
	GFile* result;
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* e;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

struct _Block33Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* new_file;
};

struct _Block34Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	guint button;
};

struct _Block35Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GtkTreePath* path;
	guint count;
	gboolean ok_next_time;
	GtkTreePath* start_path;
};

struct _Block36Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesDirectory* dir;
};

struct _FilesIconRenderer {
	GtkCellRenderer parent_instance;
	FilesIconRendererPrivate * priv;
	GdkRectangle hover_helper_rect;
	GdkRectangle hover_rect;
};

struct _FilesIconRendererClass {
	GtkCellRendererClass parent_class;
};

struct _FilesAbstractDirectoryViewSortSubMenuItem {
	GtkMenuItem parent_instance;
	FilesAbstractDirectoryViewSortSubMenuItemPrivate * priv;
};

struct _FilesAbstractDirectoryViewSortSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _FilesAbstractDirectoryViewNewSubMenuItem {
	GtkMenuItem parent_instance;
	FilesAbstractDirectoryViewNewSubMenuItemPrivate * priv;
};

struct _FilesAbstractDirectoryViewNewSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

static gint FilesAbstractDirectoryView_private_offset;
static gpointer files_abstract_directory_view_parent_class = NULL;
static GList* files_abstract_directory_view_templates;
static GList* files_abstract_directory_view_templates = NULL;
VALA_EXTERN FilesDndHandler* files_abstract_directory_view_dnd_handler;
FilesDndHandler* files_abstract_directory_view_dnd_handler = NULL;
static gpointer files_abstract_directory_view_sort_sub_menu_item_parent_class = NULL;
static gpointer files_abstract_directory_view_new_sub_menu_item_parent_class = NULL;

VALA_EXTERN GType files_abstract_directory_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryView, g_object_unref)
VALA_EXTERN GType files_text_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesTextRenderer, g_object_unref)
VALA_EXTERN GType files_icon_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesIconRenderer, g_object_unref)
VALA_EXTERN GType files_view_slot_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewSlot, g_object_unref)
VALA_EXTERN GType files_clipboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesClipboardManager, g_object_unref)
VALA_EXTERN void files_abstract_directory_view_on_row_deleted (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                                guint original_keyval,
                                                                guint keycode,
                                                                GdkModifierType state);
VALA_EXTERN void files_abstract_directory_view_on_scroll_event (FilesAbstractDirectoryView* self,
                                                    gdouble dx,
                                                    gdouble dy);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_draw (FilesAbstractDirectoryView* self,
                                                     cairo_t* cr);
VALA_EXTERN gboolean files_abstract_directory_view_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                    guint n_press,
                                                                    GdkModifierType mods,
                                                                    GtkTreePath* path);
VALA_EXTERN void files_abstract_directory_view_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y);
VALA_EXTERN void files_abstract_directory_view_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y);
VALA_EXTERN void files_abstract_directory_view_change_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_expand_collapse (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_handle_default_button_click (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                              GtkTreeIter* iter,
                                                              gboolean recurse);
VALA_EXTERN void files_abstract_directory_view_cancel (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_highlight_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_up (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_down (FilesAbstractDirectoryView* self,
                                                 GtkTreePath* path);
VALA_EXTERN GSettings* files_abstract_directory_view_get_view_settings (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_up_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_view_has_focus (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_paths (FilesAbstractDirectoryView* self);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                            gint x,
                                                            gint win);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_get_path_at_cursor (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_select_all (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_unselect_all (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_unselect_others (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_select_path (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean cursor_follows);
VALA_EXTERN void files_abstract_directory_view_unselect_path (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_path_is_selected (FilesAbstractDirectoryView* self,
                                                         GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_get_visible_range (FilesAbstractDirectoryView* self,
                                                          GtkTreePath** start_path,
                                                          GtkTreePath** end_path);
VALA_EXTERN void files_abstract_directory_view_set_cursor (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path,
                                               gboolean start_editing,
                                               gboolean select,
                                               gboolean scroll_to_top);
VALA_EXTERN gboolean files_abstract_directory_view_move_cursor (FilesAbstractDirectoryView* self,
                                                    guint keyval,
                                                    gboolean only_shift_pressed,
                                                    gboolean control_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                                 gboolean no_mods,
                                                                 gboolean only_control_pressed,
                                                                 gboolean only_shift_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_handle_multi_select (FilesAbstractDirectoryView* self,
                                                            GtkTreePath* path);
VALA_EXTERN GtkWidget* files_abstract_directory_view_create_view (FilesAbstractDirectoryView* self);
VALA_EXTERN guint files_abstract_directory_view_get_event_position_info (FilesAbstractDirectoryView* self,
                                                             gdouble x,
                                                             gdouble y,
                                                             GtkTreePath** path,
                                                             gboolean rubberband);
VALA_EXTERN void files_abstract_directory_view_scroll_to_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top);
VALA_EXTERN void files_abstract_directory_view_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path,
                                                       GtkCellRenderer* renderer,
                                                       gboolean start_editing,
                                                       gboolean scroll_to_top);
VALA_EXTERN void files_abstract_directory_view_freeze_tree (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_thaw_tree (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_freeze_child_notify (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_thaw_child_notify (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_connect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_disconnect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN GType files_abstract_directory_view_click_zone_get_type (void) G_GNUC_CONST ;
static void files_abstract_directory_view_on_selection_action_open_executable (FilesAbstractDirectoryView* self,
                                                                        GSimpleAction* action,
                                                                        GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                          GVariant* parameter,
                                                                                                          gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_app (FilesAbstractDirectoryView* self,
                                                                      GSimpleAction* action,
                                                                      GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                        GVariant* parameter,
                                                                                                        gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_default (FilesAbstractDirectoryView* self,
                                                                          GSimpleAction* action,
                                                                          GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                            GVariant* parameter,
                                                                                                            gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_other_app (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                              GVariant* parameter,
                                                                                                              gpointer self);
static void files_abstract_directory_view_on_selection_action_rename (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_view_in_location (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* param);
static void _files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_selection_action_forget (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_cut (FilesAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void files_abstract_directory_view_on_selection_action_trash (FilesAbstractDirectoryView* self,
                                                              GSimpleAction* action,
                                                              GVariant* param);
static void _files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                GVariant* parameter,
                                                                                                gpointer self);
static void files_abstract_directory_view_on_selection_action_delete (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_restore (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
VALA_EXTERN void files_abstract_directory_view_invert_selection (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_invert_selection_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void files_abstract_directory_view_on_background_action_new (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void files_abstract_directory_view_on_background_action_create_from (FilesAbstractDirectoryView* self,
                                                                     GSimpleAction* action,
                                                                     GVariant* param);
static void _files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self);
static void files_abstract_directory_view_on_background_action_sort_by_changed (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* val);
static void _files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_background_action_reverse_changed (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* val);
static void _files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_background_action_folders_first_changed (FilesAbstractDirectoryView* self,
                                                                               GSimpleAction* action,
                                                                               GVariant* val);
static void _files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                                 GVariant* parameter,
                                                                                                                 gpointer self);
static void files_abstract_directory_view_change_state_show_hidden (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action);
static void _files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                   GVariant* value,
                                                                                                   gpointer self);
static void files_abstract_directory_view_on_common_action_copy (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param);
static void _files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_common_action_paste_into (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
static void files_abstract_directory_view_on_common_action_paste (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param);
static void _files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self);
static void files_abstract_directory_view_on_common_action_open_in (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void files_abstract_directory_view_on_common_action_bookmark (FilesAbstractDirectoryView* self,
                                                              GSimpleAction* action,
                                                              GVariant* param);
static void _files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                GVariant* parameter,
                                                                                                gpointer self);
static void files_abstract_directory_view_on_common_action_properties (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
static void files_abstract_directory_view_on_common_action_copy_link (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_toggle_select_all (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void files_abstract_directory_view_action_set_wallpaper (FilesAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param);
static void _files_abstract_directory_view_action_set_wallpaper_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN FilesAbstractDirectoryView* files_abstract_directory_view_construct (GType object_type,
                                                                     FilesViewSlot* _slot);
VALA_EXTERN GType files_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesApplication, g_object_unref)
VALA_EXTERN FilesClipboardManager* files_application_get_clipboard_manager (FilesApplication* self);
VALA_EXTERN GtkRecentManager* files_application_get_recent_manager (FilesApplication* self);
static void __lambda120_ (FilesAbstractDirectoryView* self,
                   guint req);
static void files_abstract_directory_view_draw_when_idle (FilesAbstractDirectoryView* self);
static void ___lambda120__files_thumbnailer_finished (FilesThumbnailer* _sender,
                                               guint request,
                                               gpointer self);
static void files_abstract_directory_view_set_should_thumbnail (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_set_up__menu_actions (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_set_up_directory_view (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_connect_drag_drop_signals (FilesAbstractDirectoryView* self,
                                                              GtkWidget* widget);
static gboolean _files_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                      cairo_t* cr,
                                                                      gpointer self);
static void ___lambda129_ (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (FilesAbstractDirectoryView* self);
static void ____lambda129__gtk_widget_realize (GtkWidget* _sender,
                                        gpointer self);
static void _files_abstract_directory_view_on_scroll_event_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                                        gdouble dx,
                                                                                        gdouble dy,
                                                                                        gpointer self);
static gboolean _files_abstract_directory_view_on_view_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                                      guint keyval,
                                                                                                      guint keycode,
                                                                                                      GdkModifierType state,
                                                                                                      gpointer self);
static gboolean ___lambda130_ (FilesAbstractDirectoryView* self);
static gboolean ____lambda130__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                              guint keyval,
                                                              guint keycode,
                                                              GdkModifierType state,
                                                              gpointer self);
static void ___lambda131_ (FilesAbstractDirectoryView* self);
static void ____lambda131__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                           guint keyval,
                                                           guint keycode,
                                                           GdkModifierType state,
                                                           gpointer self);
static gboolean ___lambda132_ (FilesAbstractDirectoryView* self);
static gboolean ____lambda132__gtk_widget_button_press_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void _files_abstract_directory_view_on_view_button_press_event_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                                                gint n_press,
                                                                                                gdouble x,
                                                                                                gdouble y,
                                                                                                gpointer self);
static void _files_abstract_directory_view_on_view_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                                   gint n_press,
                                                                                                   gdouble x,
                                                                                                   gdouble y,
                                                                                                   gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_motion_notify_event (FilesAbstractDirectoryView* self,
                                                           gdouble x,
                                                           gdouble y);
static void _files_abstract_directory_view_on_motion_notify_event_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                                               gdouble x,
                                                                                               gdouble y,
                                                                                               gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_leave_notify_event (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_leave_notify_event_gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                                                             gpointer self);
VALA_EXTERN void files_abstract_directory_view_connect_directory_handlers (FilesAbstractDirectoryView* self,
                                                               FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_set_up_name_renderer (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_on_name_edited (FilesAbstractDirectoryView* self,
                                                   const gchar* path_string,
                                                   const gchar* _new_name);
static void _files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                                  const gchar* path,
                                                                                  const gchar* new_text,
                                                                                  gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_name_editing_canceled (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                                 gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_name_editing_started (FilesAbstractDirectoryView* self,
                                                            GtkCellEditable* editable,
                                                            const gchar* path_string);
static void _files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                               GtkCellEditable* editable,
                                                                                               const gchar* path,
                                                                                               gpointer self);
static gboolean files_abstract_directory_view_on_popup_menu (FilesAbstractDirectoryView* self);
static gboolean _files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                             gpointer self);
static void __lambda121_ (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_on_clipboard_changed (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed (FilesClipboardManager* _sender,
                                                                                          gpointer self);
static void ___lambda121__gtk_widget_unrealize (GtkWidget* _sender,
                                         gpointer self);
static void __lambda122_ (FilesAbstractDirectoryView* self);
static void ___lambda122__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self);
static void __lambda123_ (FilesAbstractDirectoryView* self);
static void ___lambda123__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                 gpointer self);
static void __lambda124_ (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_get_renaming (FilesAbstractDirectoryView* self);
static void ___lambda124__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void files_abstract_directory_view_on_show_hidden_files_changed (FilesAbstractDirectoryView* self,
                                                                 GObject* prefs,
                                                                 GParamSpec* pspec);
static void _files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self);
static void files_abstract_directory_view_on_show_thumbnails_changed (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_show_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                GParamSpec* pspec,
                                                                                gpointer self);
static void files_abstract_directory_view_on_sort_directories_first_changed (FilesAbstractDirectoryView* self,
                                                                      GObject* prefs,
                                                                      GParamSpec* pspec);
static void _files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                                       GParamSpec* pspec,
                                                                                       gpointer self);
static void _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                               GtkTreePath* path,
                                                                               gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_sort_column_changed (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                                  gpointer self);
VALA_EXTERN void files_abstract_directory_view_zoom_in (FilesAbstractDirectoryView* self);
VALA_EXTERN FilesZoomLevel files_abstract_directory_view_get_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_zoom_level (FilesAbstractDirectoryView* self,
                                                   FilesZoomLevel value);
VALA_EXTERN void files_abstract_directory_view_zoom_out (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_zoom_normal (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_focus_first_for_empty_selection (FilesAbstractDirectoryView* self,
                                                                    gboolean select);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda65_ (Block17Data* _data17_);
VALA_EXTERN gboolean files_abstract_directory_view_get_tree_frozen (FilesAbstractDirectoryView* self);
static gboolean ____lambda65__gsource_func (gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_glib_files_when_thawed (FilesAbstractDirectoryView* self,
                                                                  GList* location_list,
                                                                  GFile* focus_location);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda63_ (Block18Data* _data18_,
                  GFile* loc);
static void ___lambda63__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda64_ (Block18Data* _data18_);
static void files_abstract_directory_view_select_files_and_update_if_thawed (FilesAbstractDirectoryView* self,
                                                                      GeeLinkedList* files_to_select,
                                                                      GFile* focus_file);
static void ____lambda64__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
VALA_EXTERN void files_abstract_directory_view_unselect_all (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_on_view_selection_changed (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_update_selected_files_and_menu (FilesAbstractDirectoryView* self);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
VALA_EXTERN GList* files_abstract_directory_view_get_open_with_apps (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_abstract_directory_view_get_default_app (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_grab_focus (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_view_slot_get_is_active (FilesViewSlot* self);
VALA_EXTERN void files_abstract_directory_view_set_active_slot (FilesAbstractDirectoryView* self,
                                                    gboolean scroll);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_files (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_load_location (FilesAbstractDirectoryView* self,
                                                  GFile* location);
VALA_EXTERN void files_abstract_directory_view_load_root_location (FilesAbstractDirectoryView* self,
                                                       GFile* location);
VALA_EXTERN void files_abstract_directory_view_activate_selected_items (FilesAbstractDirectoryView* self,
                                                            FilesOpenFlag flag,
                                                            GList* selection);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
VALA_EXTERN gboolean files_abstract_directory_view_get_is_frozen (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_activate_file (FilesAbstractDirectoryView* self,
                                                  FilesFile* _file,
                                                  GdkScreen* screen,
                                                  FilesOpenFlag flag,
                                                  gboolean only_one_file);
static gboolean files_abstract_directory_view_app_is_this_app (FilesAbstractDirectoryView* self,
                                                        GAppInfo* ai);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static gboolean _______lambda78_ (Block20Data* _data20_);
static gboolean ________lambda78__gsource_func (gpointer self);
static gboolean _______lambda79_ (Block20Data* _data20_);
static void files_abstract_directory_view_open_file (FilesAbstractDirectoryView* self,
                                              FilesFile* file,
                                              GdkScreen* screen,
                                              GAppInfo* app_info);
static gboolean ________lambda79__gsource_func (gpointer self);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static gboolean _____lambda80_ (Block21Data* _data21_);
static void files_abstract_directory_view_open_files_with (FilesAbstractDirectoryView* self,
                                                    GAppInfo* app,
                                                    GList* files);
static gboolean ______lambda80__gsource_func (gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_gof_file (FilesAbstractDirectoryView* self,
                                                    FilesFile* file);
VALA_EXTERN void files_abstract_directory_view_select_and_scroll_to_gof_file (FilesAbstractDirectoryView* self,
                                                                  FilesFile* file);
VALA_EXTERN void files_abstract_directory_view_add_gof_file_to_selection (FilesAbstractDirectoryView* self,
                                                              FilesFile* file);
static void files_abstract_directory_view_on_directory_file_added (FilesAbstractDirectoryView* self,
                                                            FilesDirectory* dir,
                                                            FilesFile* file,
                                                            gboolean is_internal);
static void _files_abstract_directory_view_on_directory_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                        FilesFile* file,
                                                                                        gboolean is_internal,
                                                                                        gpointer self);
static void files_abstract_directory_view_on_directory_file_changed (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_directory_file_deleted (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_directory_file_icon_changed (FilesAbstractDirectoryView* self,
                                                                   FilesDirectory* dir,
                                                                   FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed (FilesDirectory* _sender,
                                                                                                 FilesFile* file,
                                                                                                 gpointer self);
VALA_EXTERN void files_abstract_directory_view_connect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                       FilesDirectory* dir);
static void files_abstract_directory_view_on_directory_file_loaded (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir,
                                                             FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded (FilesDirectory* _sender,
                                                                                          FilesFile* file,
                                                                                          gpointer self);
static void files_abstract_directory_view_on_directory_done_loading (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir);
static void _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading (FilesDirectory* _sender,
                                                                                            gpointer self);
VALA_EXTERN void files_abstract_directory_view_disconnect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                          FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_disconnect_directory_handlers (FilesAbstractDirectoryView* self,
                                                                  FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_change_directory (FilesAbstractDirectoryView* self,
                                                     FilesDirectory* old_dir,
                                                     FilesDirectory* new_dir);
static void files_abstract_directory_view_clear (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_prepare_reload (FilesAbstractDirectoryView* self,
                                                   FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_block_model (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_unblock_model (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_on_drag_drop (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     gint x,
                                                     gint y,
                                                     guint timestamp);
static gboolean _files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                                           GdkDragContext* context,
                                                                           gint x,
                                                                           gint y,
                                                                           guint time_,
                                                                           gpointer self);
static void files_abstract_directory_view_on_drag_data_received (FilesAbstractDirectoryView* self,
                                                          GdkDragContext* context,
                                                          gint x,
                                                          gint y,
                                                          GtkSelectionData* selection_data,
                                                          guint info,
                                                          guint timestamp);
static void _files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                         GdkDragContext* context,
                                                                                         gint x,
                                                                                         gint y,
                                                                                         GtkSelectionData* selection_data,
                                                                                         guint info,
                                                                                         guint time_,
                                                                                         gpointer self);
static void files_abstract_directory_view_on_drag_leave (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         guint time_,
                                                                         gpointer self);
static gboolean files_abstract_directory_view_on_drag_motion (FilesAbstractDirectoryView* self,
                                                       GdkDragContext* context,
                                                       gint x,
                                                       gint y,
                                                       guint timestamp);
static gboolean _files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                               GdkDragContext* context,
                                                                               gint x,
                                                                               gint y,
                                                                               guint time_,
                                                                               gpointer self);
static void files_abstract_directory_view_on_drag_begin (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         gpointer self);
static void files_abstract_directory_view_on_drag_data_get (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     GtkSelectionData* selection_data,
                                                     guint info,
                                                     guint timestamp);
static void _files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                               GdkDragContext* context,
                                                                               GtkSelectionData* selection_data,
                                                                               guint info,
                                                                               guint time_,
                                                                               gpointer self);
static void files_abstract_directory_view_on_drag_data_delete (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                                     GdkDragContext* context,
                                                                                     gpointer self);
static void files_abstract_directory_view_on_drag_end (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                                     GdkDragContext* context,
                                                                     gpointer self);
VALA_EXTERN void files_abstract_directory_view_cancel_thumbnailing (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_cancel_timeout (FilesAbstractDirectoryView* self,
                                                   guint* id);
VALA_EXTERN gboolean files_abstract_directory_view_selection_only_contains_folders (FilesAbstractDirectoryView* self,
                                                                        GList* list);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void __lambda45_ (Block22Data* _data22_,
                  FilesFile* file);
static void ___lambda45__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_files_for_transfer (FilesAbstractDirectoryView* self,
                                                                      GList* selection);
VALA_EXTERN gboolean files_abstract_directory_view_get_in_recent (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_mime_actions_get_default_application_for_file (FilesFile* file);
VALA_EXTERN GType files_view_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewWindow, g_object_unref)
VALA_EXTERN FilesViewWindow* files_abstract_directory_view_get_window (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_can_open_file (FilesAbstractDirectoryView* self,
                                                      FilesFile* file,
                                                      gboolean show_error_dialog);
VALA_EXTERN void files_mime_actions_open_glib_file_request (GFile* file_to_open,
                                                GtkWidget* parent,
                                                GAppInfo* app);
static void files_abstract_directory_view_trash_or_delete_files (FilesAbstractDirectoryView* self,
                                                          GList* file_list,
                                                          gboolean delete_if_already_in_trash,
                                                          gboolean delete_immediately);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void ___lambda107_ (Block23Data* _data23_,
                    FilesFile* file);
static void ____lambda107__gfunc (gconstpointer data,
                           gpointer self);
static void ___lambda108_ (Block23Data* _data23_,
                    FilesFile* file);
static void ____lambda108__gfunc (gconstpointer data,
                           gpointer self);
static void ___lambda109_ (FilesAbstractDirectoryView* self,
                    GObject* obj,
                    GAsyncResult* res);
VALA_EXTERN void files_abstract_directory_view_after_trash_or_delete (FilesAbstractDirectoryView* self);
static void ____lambda109__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void files_abstract_directory_view_add_file (FilesAbstractDirectoryView* self,
                                             FilesFile* file,
                                             FilesDirectory* dir,
                                             gboolean is_internal);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda58_ (Block25Data* _data25_);
static void ____lambda58__gtk_tree_model_rows_reordered (GtkTreeModel* _sender,
                                                  GtkTreePath* path,
                                                  GtkTreeIter* iter,
                                                  gint* new_order,
                                                  gpointer self);
static void files_abstract_directory_view_handle_free_space_change (FilesAbstractDirectoryView* self);
static gboolean ___lambda59_ (FilesAbstractDirectoryView* self);
static gboolean ____lambda59__gsource_func (gpointer self);
static void files_abstract_directory_view_new_empty_file (FilesAbstractDirectoryView* self,
                                                   const gchar* parent_uri);
static void __lambda116_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
VALA_EXTERN void files_abstract_directory_view_create_file_done (GFile* new_file,
                                                     FilesAbstractDirectoryView* self);
static void ___lambda116__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void files_abstract_directory_view_new_empty_folder (FilesAbstractDirectoryView* self);
static void __lambda112_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda112__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void files_abstract_directory_view_after_new_file_added (FilesAbstractDirectoryView* self,
                                                         FilesFile* file);
static void _files_abstract_directory_view_after_new_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                     FilesFile* file,
                                                                                     gboolean is_internal,
                                                                                     gpointer self);
VALA_EXTERN void files_abstract_directory_view_rename_file (FilesAbstractDirectoryView* self,
                                                FilesFile* file_to_rename);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static gboolean ___lambda105_ (Block26Data* _data26_);
static void files_abstract_directory_view_start_renaming_file (FilesAbstractDirectoryView* self,
                                                        FilesFile* file);
static gboolean ____lambda105__gsource_func (gpointer self);
static void files_abstract_directory_view_unblock_directory_monitor (FilesAbstractDirectoryView* self);
static gboolean __lambda110_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda110__gsource_func (gpointer self);
static gboolean __lambda111_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda111__gsource_func (gpointer self);
static void files_abstract_directory_view_trash_or_delete_selected_files (FilesAbstractDirectoryView* self,
                                                                   gboolean delete_immediately);
static void files_abstract_directory_view_view_selected_file (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_forget_selected_file (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_rename_selection (FilesAbstractDirectoryView* self);
VALA_EXTERN GType files_renamer_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesRenamerDialog, g_object_unref)
VALA_EXTERN FilesViewWindow* files_view_slot_get_window (FilesViewSlot* self);
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_new (GList* files,
                                              const gchar* basename);
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_construct (GType object_type,
                                                    GList* files,
                                                    const gchar* basename);
VALA_EXTERN void files_clipboard_manager_cut_files (FilesClipboardManager* self,
                                        GList* files);
VALA_EXTERN gboolean files_is_admin (void);
static GList* files_abstract_directory_view_get_files_for_action (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_view_window_bookmark_uri (FilesViewWindow* self,
                                     const gchar* uri,
                                     const gchar* custom_name);
VALA_EXTERN void files_view_window_change_state_show_hidden (FilesViewWindow* self,
                                                 GSimpleAction* action);
static void files_abstract_directory_view_create_from_template (FilesAbstractDirectoryView* self,
                                                         GFile* template);
static void files_abstract_directory_view_set_sort (FilesAbstractDirectoryView* self,
                                             const gchar* col_name,
                                             gboolean reverse);
static void _vala_XdpParent_free (XdpParent* self);
static XdpParent* _vala_XdpParent_copy (XdpParent* self);
VALA_EXTERN FilesViewPropertiesWindow* files_view_properties_window_new (GList* _files,
                                                             FilesAbstractDirectoryView* _view,
                                                             GtkWindow* parent);
VALA_EXTERN FilesViewPropertiesWindow* files_view_properties_window_construct (GType object_type,
                                                                   GList* _files,
                                                                   FilesAbstractDirectoryView* _view,
                                                                   GtkWindow* parent);
VALA_EXTERN GType files_view_abstract_properties_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewAbstractPropertiesDialog, g_object_unref)
VALA_EXTERN GType files_view_properties_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewPropertiesWindow, g_object_unref)
VALA_EXTERN void files_clipboard_manager_copy_link_files (FilesClipboardManager* self,
                                              GList* files);
VALA_EXTERN void files_clipboard_manager_copy_files (FilesClipboardManager* self,
                                         GList* files);
VALA_EXTERN gboolean files_clipboard_manager_get_can_paste (FilesClipboardManager* self);
VALA_EXTERN gboolean files_clipboard_manager_get_files_linked (FilesClipboardManager* self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
VALA_EXTERN void files_clipboard_manager_paste_files (FilesClipboardManager* self,
                                          GFile* target_file,
                                          GtkWidget* widget,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void files_clipboard_manager_paste_files_finish (FilesClipboardManager* self,
                                                 GAsyncResult* _res_);
static void ___lambda119_ (Block27Data* _data27_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda119__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
VALA_EXTERN gboolean files_clipboard_manager_has_file (FilesClipboardManager* self,
                                           FilesFile* file);
static void ___lambda118_ (Block28Data* _data28_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda118__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_all (FilesAbstractDirectoryView* self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static gboolean ___lambda60_ (Block29Data* _data29_);
static void files_abstract_directory_view_update_icon_and_plugins (FilesAbstractDirectoryView* self,
                                                            FilesFile* file);
static gboolean ____lambda60__gsource_func (gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static gboolean __lambda61_ (Block30Data* _data30_);
static gboolean ___lambda61__gsource_func (gpointer self);
static void files_abstract_directory_view_set_in_recent (FilesAbstractDirectoryView* self,
                                                  gboolean value);
static gboolean __lambda53_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda53__gsource_func (gpointer self);
static void files_abstract_directory_view_on_zoom_level_changed (FilesAbstractDirectoryView* self,
                                                          FilesZoomLevel zoom);
VALA_EXTERN gint files_abstract_directory_view_get_icon_size (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_directory_hidden_changed (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir,
                                                             gboolean show);
static void files_abstract_directory_view_action_set_state (FilesAbstractDirectoryView* self,
                                                     GSimpleActionGroup* action_group,
                                                     const gchar* name,
                                                     GVariant* val);
static GVariant* _variant_new1 (gboolean value);
VALA_EXTERN void files_abstract_directory_view_show_context_menu (FilesAbstractDirectoryView* self,
                                                      GdkEvent* event);
static void _vala_GdkEvent_free (GdkEvent* self);
static void files_abstract_directory_view_real_on_row_deleted (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
static void files_abstract_directory_view_check_destination_actions_and_target_file (FilesAbstractDirectoryView* self,
                                                                              GdkDragContext* context,
                                                                              gint x,
                                                                              gint y,
                                                                              guint timestamp);
static void files_abstract_directory_view_get_drag_data (FilesAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  guint timestamp);
static void files_abstract_directory_view_start_drag_scroll_timer (FilesAbstractDirectoryView* self,
                                                            GdkDevice* pointer);
static FilesFile* files_abstract_directory_view_get_drop_target_file (FilesAbstractDirectoryView* self,
                                                               gint win_x,
                                                               gint win_y);
VALA_EXTERN GtkWindow* files_get_active_window (void);
static gboolean ____lambda126_ (FilesAbstractDirectoryView* self);
static gboolean _____lambda126__gsource_func (gpointer self);
static void files_abstract_directory_view_clear_destination_drag_data (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_icon_renderer_set_drop_file (FilesIconRenderer* self,
                                        FilesFile* value);
static gboolean files_abstract_directory_view_get_drop_highlight (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_set_drop_highlight (FilesAbstractDirectoryView* self,
                                                       gboolean value);
static void files_abstract_directory_view_highlight_drop_file (FilesAbstractDirectoryView* self,
                                                        FilesFile* drop_file,
                                                        GdkDragAction action,
                                                        GtkTreePath* path);
static gboolean files_abstract_directory_view_is_valid_drop_folder (FilesAbstractDirectoryView* self,
                                                             FilesFile* file);
static gboolean _____lambda127_ (FilesAbstractDirectoryView* self);
static gboolean ______lambda127__gsource_func (gpointer self);
static void files_abstract_directory_view_update_menu_actions (FilesAbstractDirectoryView* self);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (const gchar* value);
VALA_EXTERN GList* files_mime_actions_get_applications_for_files (GList* files);
static void files_abstract_directory_view_filter_default_app_from_open_with_apps (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_filter_this_app_from_open_with_apps (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_valid_selection_for_restore (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_valid_selection_for_edit (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_view_window_can_bookmark_uri (FilesViewWindow* self,
                                             const gchar* uri);
VALA_EXTERN gboolean files_clipboard_manager_has_cutted_file (FilesClipboardManager* self,
                                                  FilesFile* file);
static FilesAbstractDirectoryViewSortSubMenuItem* files_abstract_directory_view_sort_sub_menu_item_new (void);
static FilesAbstractDirectoryViewSortSubMenuItem* files_abstract_directory_view_sort_sub_menu_item_construct (GType object_type);
static GType files_abstract_directory_view_sort_sub_menu_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryViewSortSubMenuItem, g_object_unref)
static FilesAbstractDirectoryViewNewSubMenuItem* files_abstract_directory_view_new_sub_menu_item_new (void);
static FilesAbstractDirectoryViewNewSubMenuItem* files_abstract_directory_view_new_sub_menu_item_construct (GType object_type);
static GType files_abstract_directory_view_new_sub_menu_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryViewNewSubMenuItem, g_object_unref)
static void files_abstract_directory_view_action_set_enabled (FilesAbstractDirectoryView* self,
                                                       GSimpleActionGroup* action_group,
                                                       const gchar* name,
                                                       gboolean enabled);
static void files_abstract_directory_view_update_default_app (FilesAbstractDirectoryView* self,
                                                       GList* selection);
static void files_abstract_directory_view_update_menu_actions_sort (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_mime_actions_get_default_application_for_files (GList* files);
static void files_abstract_directory_view_load_templates_from_folder (GFile* template_folder);
static gint ___lambda83_ (GFile* a,
                   GFile* b);
static gint ____lambda83__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void ___lambda84_ (GFile* folder);
static void ____lambda84__gfunc (gconstpointer data,
                          gpointer self);
static void __lambda117_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda117__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void files_mime_actions_open_multiple_gof_files_request (GList* gofs_to_open,
                                                         GtkWidget* parent,
                                                         GAppInfo* app);
static gboolean __lambda54_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda54__gsource_func (gpointer self);
VALA_EXTERN gint files_view_slot_get_displayed_files_count (FilesViewSlot* self);
static gboolean __lambda55_ (FilesAbstractDirectoryView* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static gboolean ___lambda55__gsource_func (gpointer self);
static gboolean __lambda56_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda56__gsource_func (gpointer self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static gboolean __lambda128_ (Block31Data* _data31_);
static void files_abstract_directory_view_scroll_if_near_edge (FilesAbstractDirectoryView* self,
                                                        gint pos,
                                                        gint dim,
                                                        gint threshold,
                                                        GtkAdjustment* adj);
static gboolean ___lambda128__gsource_func (gpointer self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void ____lambda44_ (Block32Data* _data32_,
                    FilesFile* file);
static void _____lambda44__gfunc (gconstpointer data,
                           gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_view_items_activated (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                                     guint original_keyval,
                                                                     guint keycode,
                                                                     GdkModifierType state);
static void files_abstract_directory_view_cancel_hover (FilesAbstractDirectoryView* self);
VALA_EXTERN guint files_abstract_directory_view_map_key (guint original_keyval,
                                             guint keycode,
                                             GdkModifierType* consumed_mods);
VALA_EXTERN GType files_abstract_tree_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractTreeView, g_object_unref)
VALA_EXTERN GType files_column_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesColumnView, g_object_unref)
VALA_EXTERN GType files_view_view_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewViewContainer, g_object_unref)
VALA_EXTERN FilesViewViewContainer* files_view_slot_get_ctab (FilesViewSlot* self);
VALA_EXTERN GType files_view_miller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewMiller, g_object_unref)
VALA_EXTERN gboolean files_view_miller_on_miller_key_pressed (FilesViewMiller* self,
                                                  guint keyval,
                                                  guint keycode,
                                                  GdkModifierType state);
static gboolean __lambda113_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda113__gsource_func (gpointer self);
VALA_EXTERN gboolean files_abstract_directory_view_get_singleclick_select (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_on_scroll_event (FilesAbstractDirectoryView* self,
                                                         gdouble dx,
                                                         gdouble dy);
VALA_EXTERN GType files_abstract_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractEditableLabel, g_object_unref)
VALA_EXTERN gchar* files_abstract_editable_label_get_chars (FilesAbstractEditableLabel* self,
                                                gint start_pos,
                                                gint end_pos);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
VALA_EXTERN void files_abstract_editable_label_select_region (FilesAbstractEditableLabel* self,
                                                  gint start_pos,
                                                  gint end_pos);
VALA_EXTERN void files_abstract_directory_view_set_is_frozen (FilesAbstractDirectoryView* self,
                                                  gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_renaming (FilesAbstractDirectoryView* self,
                                                 gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_file_display_name (FilesAbstractDirectoryView* self,
                                                          GFile* old_location,
                                                          const gchar* new_name,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN GFile* files_abstract_directory_view_set_file_display_name_finish (FilesAbstractDirectoryView* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error);
static void ____lambda74_ (FilesAbstractDirectoryView* self,
                    GObject* obj,
                    GAsyncResult* res);
static void _____lambda74__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void files_abstract_directory_view_set_file_display_name_data_free (gpointer _data);
static gboolean files_abstract_directory_view_set_file_display_name_co (FilesAbstractDirectoryViewSetFileDisplayNameData* _data_);
static void files_abstract_directory_view_after_renamed_file_added (FilesAbstractDirectoryView* self,
                                                             FilesFile* new_file);
static void _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                         FilesFile* file,
                                                                                         gboolean is_internal,
                                                                                         gpointer self);
static void files_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static gboolean ___lambda73_ (Block33Data* _data33_);
static gboolean ____lambda73__gsource_func (gpointer self);
static gboolean files_abstract_directory_view_real_on_view_draw (FilesAbstractDirectoryView* self,
                                                          cairo_t* cr);
VALA_EXTERN gchar* files_view_slot_get_empty_message (FilesViewSlot* self);
static PangoRectangle* _pango_rectangle_dup (PangoRectangle* self);
static gboolean files_abstract_directory_view_real_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                         guint n_press,
                                                                         GdkModifierType mods,
                                                                         GtkTreePath* path);
VALA_EXTERN void files_abstract_directory_view_block_drag_and_drop (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_unblock_drag_and_drop (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y);
VALA_EXTERN void files_text_renderer_end_editing (FilesTextRenderer* self,
                                      gboolean cancel);
static void files_abstract_directory_view_real_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                      gint n_press,
                                                                      gdouble x,
                                                                      gdouble y);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static gboolean ____lambda133_ (Block34Data* _data34_);
static gboolean _____lambda133__gsource_func (gpointer self);
static gboolean __lambda134_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda134__gsource_func (gpointer self);
static void files_abstract_directory_view_real_change_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_icon_renderer_set_zoom_level (FilesIconRenderer* self,
                                         FilesZoomLevel value);
VALA_EXTERN void files_text_renderer_set_zoom_level (FilesTextRenderer* self,
                                         FilesZoomLevel value);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static gboolean __lambda106_ (Block35Data* _data35_);
static gboolean ___lambda106__gsource_func (gpointer self);
static Block36Data* block36_data_ref (Block36Data* _data36_);
static void block36_data_unref (void * _userdata_);
static void ___lambda125_ (Block36Data* _data36_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda125__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN guint files_abstract_directory_view_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                                   GList** selected_files);
static gboolean files_abstract_directory_view_real_expand_collapse (FilesAbstractDirectoryView* self,
                                                             GtkTreePath* path);
static gboolean files_abstract_directory_view_real_handle_default_button_click (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                                   GtkTreeIter* iter,
                                                                   gboolean recurse);
static void files_abstract_directory_view_real_cancel (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_close (FilesAbstractDirectoryView* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreeRowReference* _vala_GtkTreeRowReference_copy (GtkTreeRowReference* self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static void __vala_GtkTreeRowReference_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreeRowReference_free0_ (GList* self);
VALA_EXTERN void files_abstract_directory_view_unselect_others (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_highlight_path (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
static GtkTreePath* files_abstract_directory_view_real_up (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path);
static GtkTreePath* files_abstract_directory_view_real_down (FilesAbstractDirectoryView* self,
                                                      GtkTreePath* path);
static GSettings* files_abstract_directory_view_real_get_view_settings (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_set_up_zoom_level (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_view_has_focus (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path,
                                                        gboolean scroll_to_top);
VALA_EXTERN gboolean files_abstract_directory_view_match_keycode (GdkKeymap* keymap,
                                                      guint keyval,
                                                      guint code,
                                                      gint level);
static void _vala_GdkEventKey_free (GdkEventKey* self);
static GList* files_abstract_directory_view_real_get_selected_paths (FilesAbstractDirectoryView* self);
static GtkTreePath* files_abstract_directory_view_real_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                                 gint x,
                                                                 gint win);
static GtkTreePath* files_abstract_directory_view_real_get_path_at_cursor (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_select_all (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_unselect_all (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_unselect_others (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_select_path (FilesAbstractDirectoryView* self,
                                                     GtkTreePath* path,
                                                     gboolean cursor_follows);
static void files_abstract_directory_view_real_unselect_path (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path);
static gboolean files_abstract_directory_view_real_path_is_selected (FilesAbstractDirectoryView* self,
                                                              GtkTreePath* path);
static gboolean files_abstract_directory_view_real_get_visible_range (FilesAbstractDirectoryView* self,
                                                               GtkTreePath** start_path,
                                                               GtkTreePath** end_path);
static void files_abstract_directory_view_real_set_cursor (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path,
                                                    gboolean start_editing,
                                                    gboolean select,
                                                    gboolean scroll_to_top);
static gboolean files_abstract_directory_view_real_move_cursor (FilesAbstractDirectoryView* self,
                                                         guint keyval,
                                                         gboolean only_shift_pressed,
                                                         gboolean control_pressed);
static gboolean files_abstract_directory_view_real_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                                      gboolean no_mods,
                                                                      gboolean only_control_pressed,
                                                                      gboolean only_shift_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_is_on_icon (FilesAbstractDirectoryView* self,
                                                   gint x,
                                                   gint y,
                                                   gboolean* on_helper);
static gboolean files_abstract_directory_view_real_handle_multi_select (FilesAbstractDirectoryView* self,
                                                                 GtkTreePath* path);
static GtkWidget* files_abstract_directory_view_real_create_view (FilesAbstractDirectoryView* self);
static guint files_abstract_directory_view_real_get_event_position_info (FilesAbstractDirectoryView* self,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  GtkTreePath** path,
                                                                  gboolean rubberband);
static void files_abstract_directory_view_real_scroll_to_path (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path,
                                                        gboolean scroll_to_top);
static void files_abstract_directory_view_real_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                            GtkTreePath* path,
                                                            GtkCellRenderer* renderer,
                                                            gboolean start_editing,
                                                            gboolean scroll_to_top);
static void files_abstract_directory_view_real_freeze_tree (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_thaw_tree (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_freeze_child_notify (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_thaw_child_notify (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_connect_tree_signals (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_disconnect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_singleclick_select (FilesAbstractDirectoryView* self,
                                                           gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_tree_frozen (FilesAbstractDirectoryView* self,
                                                    gboolean value);
VALA_EXTERN FilesViewWindow* files_view_view_container_get_window (FilesViewViewContainer* self);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static GObject * files_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                                        guint n_construct_properties,
                                                                        GObjectConstructParam * construct_properties);
static GVariant* _variant_new4 (const gchar* value);
static GVariant* _variant_new5 (const gchar* value);
static GVariant* _variant_new6 (const gchar* value);
static GVariant* _variant_new7 (const gchar* value);
static GType files_abstract_directory_view_sort_sub_menu_item_get_type_once (void);
static GObject * files_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                                       guint n_construct_properties,
                                                                       GObjectConstructParam * construct_properties);
static GVariant* _variant_new8 (const gchar* value);
static GVariant* _variant_new9 (const gchar* value);
static GType files_abstract_directory_view_new_sub_menu_item_get_type_once (void);
static void files_abstract_directory_view_finalize (GObject * obj);
static GType files_abstract_directory_view_get_type_once (void);
static void _vala_files_abstract_directory_view_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_files_abstract_directory_view_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GtkTargetEntry FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}};
static const GtkTargetEntry FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_NETSCAPE_URL}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES[12] = {{"open", _files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback}, {"open-with-app", _files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback, "u"}, {"open-with-default", _files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback}, {"open-with-other-app", _files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback}, {"rename", _files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback}, {"view-in-location", _files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback}, {"forget", _files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback}, {"cut", _files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback}, {"trash", _files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback}, {"delete", _files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback}, {"restore", _files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback}, {"invert-selection", _files_abstract_directory_view_invert_selection_gsimple_action_activate_callback}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES[6] = {{"new", _files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback, "s"}, {"create-from", _files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback, "s"}, {"sort-by", _files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback, "s", "'name'"}, {"reverse", _files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback, NULL, "false"}, {"folders-first", _files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback, NULL, "true"}, {"show-hidden", NULL, NULL, "false", _files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES[9] = {{"copy", _files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback}, {"paste-into", _files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback}, {"paste", _files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback}, {"open-in", _files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback, "s"}, {"bookmark", _files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback}, {"properties", _files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback}, {"copy-link", _files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback}, {"select-all", _files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback}, {"set-wallpaper", _files_abstract_directory_view_action_set_wallpaper_gsimple_action_activate_callback}};

static inline gpointer
files_abstract_directory_view_get_instance_private (FilesAbstractDirectoryView* self)
{
	return G_STRUCT_MEMBER_P (self, FilesAbstractDirectoryView_private_offset);
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_click_zone_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER", "expander"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER", "helper"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON", "icon"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME", "name"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH", "blank-path"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH", "blank-no-path"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID", "invalid"}, {0, NULL, NULL}};
	GType files_abstract_directory_view_click_zone_type_id;
	files_abstract_directory_view_click_zone_type_id = g_enum_register_static ("FilesAbstractDirectoryViewClickZone", values);
	return files_abstract_directory_view_click_zone_type_id;
}

GType
files_abstract_directory_view_click_zone_get_type (void)
{
	static volatile gsize files_abstract_directory_view_click_zone_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_click_zone_type_id__once)) {
		GType files_abstract_directory_view_click_zone_type_id;
		files_abstract_directory_view_click_zone_type_id = files_abstract_directory_view_click_zone_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_click_zone_type_id__once, files_abstract_directory_view_click_zone_type_id);
	}
	return files_abstract_directory_view_click_zone_type_id__once;
}

static void
_files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                     GVariant* parameter,
                                                                                                     gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_executable ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1836 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                   GVariant* parameter,
                                                                                                   gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_app ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1846 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_default ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1856 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                         GVariant* parameter,
                                                                                                         gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_other_app ((FilesAbstractDirectoryView*) self);
#line 1866 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_rename ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1876 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_view_in_location ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1886 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_forget ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1896 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_cut ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1906 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_trash ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1916 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_delete ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1926 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_restore ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1936 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_invert_selection_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_invert_selection ((FilesAbstractDirectoryView*) self);
#line 1946 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_new ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1956 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_create_from ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1966 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_sort_by_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1976 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_reverse_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1986 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                            GVariant* parameter,
                                                                                                            gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_folders_first_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1996 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                              GVariant* value,
                                                                                              gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_state_show_hidden ((FilesAbstractDirectoryView*) self, action);
#line 2006 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_copy ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2016 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_paste_into ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2026 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_paste ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2036 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_open_in ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2046 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_bookmark ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2056 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_properties ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2066 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_copy_link ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2076 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_toggle_select_all ((FilesAbstractDirectoryView*) self);
#line 2086 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_action_set_wallpaper_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self)
{
#line 82 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_wallpaper ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2096 "AbstractDirectoryView.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 129 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2104 "AbstractDirectoryView.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 129 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2112 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 185 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2120 "AbstractDirectoryView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 293 "../src/View/AbstractDirectoryView.vala"
	return self ? g_object_ref (self) : NULL;
#line 2128 "AbstractDirectoryView.c"
}

static void
__lambda120_ (FilesAbstractDirectoryView* self,
              guint req)
{
#line 301 "../src/View/AbstractDirectoryView.vala"
	if (req == ((guint) self->priv->thumbnail_request)) {
#line 302 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = -1;
#line 2139 "AbstractDirectoryView.c"
	}
#line 305 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_draw_when_idle (self);
#line 2143 "AbstractDirectoryView.c"
}

static void
___lambda120__files_thumbnailer_finished (FilesThumbnailer* _sender,
                                          guint request,
                                          gpointer self)
{
#line 300 "../src/View/AbstractDirectoryView.vala"
	__lambda120_ ((FilesAbstractDirectoryView*) self, request);
#line 2153 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                             cairo_t* cr,
                                                             gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_draw ((FilesAbstractDirectoryView*) self, cr);
#line 326 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2165 "AbstractDirectoryView.c"
}

static void
___lambda129_ (FilesAbstractDirectoryView* self)
{
#line 328 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 2173 "AbstractDirectoryView.c"
}

static void
____lambda129__gtk_widget_realize (GtkWidget* _sender,
                                   gpointer self)
{
#line 327 "../src/View/AbstractDirectoryView.vala"
	___lambda129_ ((FilesAbstractDirectoryView*) self);
#line 2182 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_scroll_event_gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                                   gdouble dx,
                                                                                   gdouble dy,
                                                                                   gpointer self)
{
#line 332 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_scroll_event ((FilesAbstractDirectoryView*) self, dx, dy);
#line 2193 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                             guint keyval,
                                                                                             guint keycode,
                                                                                             GdkModifierType state,
                                                                                             gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_key_press_event ((FilesAbstractDirectoryView*) self, keyval, keycode, state);
#line 337 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2207 "AbstractDirectoryView.c"
}

static gboolean
___lambda130_ (FilesAbstractDirectoryView* self)
{
	GtkEventControllerScroll* _tmp0_;
	gboolean result;
#line 341 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->scroll_controller;
#line 341 "../src/View/AbstractDirectoryView.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL);
#line 341 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 341 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2223 "AbstractDirectoryView.c"
}

static gboolean
____lambda130__gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                     guint keyval,
                                                     guint keycode,
                                                     GdkModifierType state,
                                                     gpointer self)
{
	gboolean result;
	result = ___lambda130_ ((FilesAbstractDirectoryView*) self);
#line 341 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2237 "AbstractDirectoryView.c"
}

static void
___lambda131_ (FilesAbstractDirectoryView* self)
{
	GtkEventControllerScroll* _tmp0_;
#line 342 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->scroll_controller;
#line 342 "../src/View/AbstractDirectoryView.vala"
	gtk_event_controller_scroll_set_flags (_tmp0_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 2248 "AbstractDirectoryView.c"
}

static void
____lambda131__gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                      guint keyval,
                                                      guint keycode,
                                                      GdkModifierType state,
                                                      gpointer self)
{
#line 342 "../src/View/AbstractDirectoryView.vala"
	___lambda131_ ((FilesAbstractDirectoryView*) self);
#line 2260 "AbstractDirectoryView.c"
}

static gboolean
___lambda132_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 348 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->button_press_disabled;
#line 348 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2271 "AbstractDirectoryView.c"
}

static gboolean
____lambda132__gtk_widget_button_press_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = ___lambda132_ ((FilesAbstractDirectoryView*) self);
#line 347 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2283 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_view_button_press_event_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                                           gint n_press,
                                                                                           gdouble x,
                                                                                           gdouble y,
                                                                                           gpointer self)
{
#line 355 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_view_button_press_event ((FilesAbstractDirectoryView*) self, n_press, x, y);
#line 2295 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_view_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                              gint n_press,
                                                                                              gdouble x,
                                                                                              gdouble y,
                                                                                              gpointer self)
{
#line 356 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_view_button_release_event ((FilesAbstractDirectoryView*) self, n_press, x, y);
#line 2307 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_motion_notify_event_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                                          gdouble x,
                                                                                          gdouble y,
                                                                                          gpointer self)
{
#line 361 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_motion_notify_event ((FilesAbstractDirectoryView*) self, x, y);
#line 2318 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_leave_notify_event_gtk_event_controller_motion_leave (GtkEventControllerMotion* _sender,
                                                                                        gpointer self)
{
#line 362 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_leave_notify_event ((FilesAbstractDirectoryView*) self);
#line 2327 "AbstractDirectoryView.c"
}

FilesAbstractDirectoryView*
files_abstract_directory_view_construct (GType object_type,
                                         FilesViewSlot* _slot)
{
	FilesAbstractDirectoryView * self = NULL;
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	FilesApplication* app = NULL;
	GApplication* _tmp6_;
	FilesApplication* _tmp7_;
	FilesApplication* _tmp8_;
	FilesClipboardManager* _tmp9_;
	FilesApplication* _tmp10_;
	GtkRecentManager* _tmp11_;
	FilesApplication* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	FilesApplication* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	FilesThumbnailer* _tmp20_;
	FilesThumbnailer* _tmp21_;
	FilesListModel* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* _tmp24_;
	FilesViewSlot* _tmp46_;
	FilesDirectory* _tmp47_;
	FilesDirectory* _tmp48_;
#line 287 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (_slot != NULL, NULL);
#line 287 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryView*) g_object_new (object_type, NULL);
#line 288 "../src/View/AbstractDirectoryView.vala"
	self->slot = _slot;
#line 289 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gdk_display_get_default ();
#line 289 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = gdk_cursor_new_from_name (_tmp0_, "text");
#line 289 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->editable_cursor);
#line 289 "../src/View/AbstractDirectoryView.vala"
	self->priv->editable_cursor = _tmp1_;
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = gdk_display_get_default ();
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gdk_cursor_new_from_name (_tmp2_, "pointer");
#line 290 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->activatable_cursor);
#line 290 "../src/View/AbstractDirectoryView.vala"
	self->priv->activatable_cursor = _tmp3_;
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = gdk_display_get_default ();
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = gdk_cursor_new_from_name (_tmp4_, "default");
#line 291 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selectable_cursor);
#line 291 "../src/View/AbstractDirectoryView.vala"
	self->priv->selectable_cursor = _tmp5_;
#line 293 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = g_application_get_default ();
#line 293 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, FILES_TYPE_APPLICATION, FilesApplication));
#line 293 "../src/View/AbstractDirectoryView.vala"
	app = _tmp7_;
#line 294 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = app;
#line 294 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_application_get_clipboard_manager (_tmp8_);
#line 294 "../src/View/AbstractDirectoryView.vala"
	self->priv->clipboard = _tmp9_;
#line 295 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = app;
#line 295 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_application_get_recent_manager (_tmp10_);
#line 295 "../src/View/AbstractDirectoryView.vala"
	self->recent = _tmp11_;
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = app;
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = g_strdup ("<Ctrl>A");
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp14_[0] = _tmp13_;
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _tmp14_;
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp15__length1 = 1;
#line 296 "../src/View/AbstractDirectoryView.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp12_, "common.select-all", _tmp15_);
#line 296 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = app;
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = g_strdup ("<Shift><Ctrl>A");
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = g_new0 (gchar*, 1 + 1);
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp18_[0] = _tmp17_;
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = _tmp18_;
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp19__length1 = 1;
#line 297 "../src/View/AbstractDirectoryView.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp16_, "selection.invert-selection", _tmp19_);
#line 297 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 299 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = files_thumbnailer_get ();
#line 299 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->thumbnailer);
#line 299 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnailer = _tmp20_;
#line 300 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = self->priv->thumbnailer;
#line 300 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp21_, "finished", (GCallback) ___lambda120__files_thumbnailer_finished, self, 0);
#line 308 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_should_thumbnail (self);
#line 310 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = files_list_model_new ();
#line 310 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->model);
#line 310 "../src/View/AbstractDirectoryView.vala"
	self->model = _tmp22_;
#line 317 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up__menu_actions (self);
#line 318 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up_directory_view (self);
#line 319 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = files_abstract_directory_view_create_view (self);
#line 319 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->view);
#line 319 "../src/View/AbstractDirectoryView.vala"
	self->priv->view = _tmp23_;
#line 321 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = self->priv->view;
#line 321 "../src/View/AbstractDirectoryView.vala"
	if (_tmp24_ != NULL) {
#line 2478 "AbstractDirectoryView.c"
		GtkWidget* _tmp25_;
		GtkWidget* _tmp26_;
		GtkWidget* _tmp27_;
		GtkWidget* _tmp28_;
		GtkWidget* _tmp29_;
		GtkEventControllerScroll* _tmp30_;
		GtkEventControllerScroll* _tmp31_;
		GtkWidget* _tmp32_;
		GtkEventControllerKey* _tmp33_ = NULL;
		GtkEventControllerKey* _tmp34_;
		GtkEventControllerKey* _tmp35_;
		GtkEventControllerKey* _tmp36_;
		GtkWidget* _tmp37_;
		GtkWidget* _tmp38_;
		GtkGestureMultiPress* _tmp39_ = NULL;
		GtkGestureMultiPress* _tmp40_;
		GtkGestureMultiPress* _tmp41_;
		GtkWidget* _tmp42_;
		GtkEventControllerMotion* _tmp43_ = NULL;
		GtkEventControllerMotion* _tmp44_;
		GtkEventControllerMotion* _tmp45_;
#line 322 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = self->priv->view;
#line 322 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkContainer*) self, "child", _tmp25_, NULL);
#line 323 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 324 "../src/View/AbstractDirectoryView.vala"
		_tmp26_ = self->priv->view;
#line 324 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_connect_drag_drop_signals (self, _tmp26_);
#line 326 "../src/View/AbstractDirectoryView.vala"
		_tmp27_ = self->priv->view;
#line 326 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp27_, "draw", (GCallback) _files_abstract_directory_view_on_view_draw_gtk_widget_draw, self, 0);
#line 327 "../src/View/AbstractDirectoryView.vala"
		_tmp28_ = self->priv->view;
#line 327 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp28_, "realize", (GCallback) ____lambda129__gtk_widget_realize, self, 0);
#line 331 "../src/View/AbstractDirectoryView.vala"
		_tmp29_ = self->priv->view;
#line 331 "../src/View/AbstractDirectoryView.vala"
		_tmp30_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (_tmp29_, GTK_EVENT_CONTROLLER_SCROLL_NONE);
#line 331 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self->scroll_controller);
#line 331 "../src/View/AbstractDirectoryView.vala"
		self->scroll_controller = _tmp30_;
#line 332 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = self->scroll_controller;
#line 332 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp31_, "scroll", (GCallback) _files_abstract_directory_view_on_scroll_event_gtk_event_controller_scroll_scroll, self, 0);
#line 334 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = self->priv->view;
#line 334 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = (GtkEventControllerKey*) gtk_event_controller_key_new (_tmp32_);
#line 334 "../src/View/AbstractDirectoryView.vala"
		gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp33_, GTK_PHASE_BUBBLE);
#line 334 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self->key_controller);
#line 334 "../src/View/AbstractDirectoryView.vala"
		self->key_controller = _tmp33_;
#line 337 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = self->key_controller;
#line 337 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp34_, "key-pressed", (GCallback) _files_abstract_directory_view_on_view_key_press_event_gtk_event_controller_key_key_pressed, self, 0);
#line 341 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = self->key_controller;
#line 341 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp35_, "key-pressed", (GCallback) ____lambda130__gtk_event_controller_key_key_pressed, self, 0);
#line 342 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = self->key_controller;
#line 342 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp36_, "key-released", (GCallback) ____lambda131__gtk_event_controller_key_key_released, self, 0);
#line 347 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = self->priv->view;
#line 347 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp37_, "button-press-event", (GCallback) ____lambda132__gtk_widget_button_press_event, self, 0);
#line 351 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = self->priv->view;
#line 351 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new (_tmp38_);
#line 351 "../src/View/AbstractDirectoryView.vala"
		gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp39_, GTK_PHASE_CAPTURE);
#line 351 "../src/View/AbstractDirectoryView.vala"
		gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp39_, (guint) 0);
#line 351 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self->button_controller);
#line 351 "../src/View/AbstractDirectoryView.vala"
		self->button_controller = _tmp39_;
#line 355 "../src/View/AbstractDirectoryView.vala"
		_tmp40_ = self->button_controller;
#line 355 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp40_, "pressed", (GCallback) _files_abstract_directory_view_on_view_button_press_event_gtk_gesture_multi_press_pressed, self, 0);
#line 356 "../src/View/AbstractDirectoryView.vala"
		_tmp41_ = self->button_controller;
#line 356 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp41_, "released", (GCallback) _files_abstract_directory_view_on_view_button_release_event_gtk_gesture_multi_press_released, self, 0);
#line 358 "../src/View/AbstractDirectoryView.vala"
		_tmp42_ = self->priv->view;
#line 358 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new (_tmp42_);
#line 358 "../src/View/AbstractDirectoryView.vala"
		gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp43_, GTK_PHASE_CAPTURE);
#line 358 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self->motion_controller);
#line 358 "../src/View/AbstractDirectoryView.vala"
		self->motion_controller = _tmp43_;
#line 361 "../src/View/AbstractDirectoryView.vala"
		_tmp44_ = self->motion_controller;
#line 361 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp44_, "motion", (GCallback) _files_abstract_directory_view_on_motion_notify_event_gtk_event_controller_motion_motion, self, 0);
#line 362 "../src/View/AbstractDirectoryView.vala"
		_tmp45_ = self->motion_controller;
#line 362 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp45_, "leave", (GCallback) _files_abstract_directory_view_on_leave_notify_event_gtk_event_controller_motion_leave, self, 0);
#line 2594 "AbstractDirectoryView.c"
	}
#line 365 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_tree (self);
#line 366 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up_zoom_level (self);
#line 368 "../src/View/AbstractDirectoryView.vala"
	_tmp46_ = self->slot;
#line 368 "../src/View/AbstractDirectoryView.vala"
	_tmp47_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp46_);
#line 368 "../src/View/AbstractDirectoryView.vala"
	_tmp48_ = _tmp47_;
#line 368 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_handlers (self, _tmp48_);
#line 287 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (app);
#line 287 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 2612 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                             const gchar* path,
                                                                             const gchar* new_text,
                                                                             gpointer self)
{
#line 377 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_edited ((FilesAbstractDirectoryView*) self, path, new_text);
#line 2623 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                            gpointer self)
{
#line 378 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_canceled ((FilesAbstractDirectoryView*) self);
#line 2632 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                          GtkCellEditable* editable,
                                                                                          const gchar* path,
                                                                                          gpointer self)
{
#line 379 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_started ((FilesAbstractDirectoryView*) self, editable, path);
#line 2643 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_up_name_renderer (FilesAbstractDirectoryView* self)
{
	FilesTextRenderer* _tmp0_;
	FilesTextRenderer* _tmp1_;
	FilesTextRenderer* _tmp2_;
	FilesTextRenderer* _tmp3_;
#line 375 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->name_renderer;
#line 376 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
#line 377 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->name_renderer;
#line 377 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRendererText*) _tmp1_, "edited", (GCallback) _files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited, self, 0);
#line 378 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->name_renderer;
#line 378 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp2_, "editing-canceled", (GCallback) _files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
#line 379 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->name_renderer;
#line 379 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp3_, "editing-started", (GCallback) _files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started, self, 0);
#line 2671 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                    gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_popup_menu ((FilesAbstractDirectoryView*) self);
#line 386 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2682 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed (FilesClipboardManager* _sender,
                                                                                     gpointer self)
{
#line 389 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_clipboard_changed ((FilesAbstractDirectoryView*) self);
#line 2691 "AbstractDirectoryView.c"
}

static void
__lambda121_ (FilesAbstractDirectoryView* self)
{
	FilesClipboardManager* _tmp0_;
	guint _tmp1_;
#line 389 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 389 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("changed", FILES_TYPE_CLIPBOARD_MANAGER, &_tmp1_, NULL, FALSE);
#line 389 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self);
#line 2705 "AbstractDirectoryView.c"
}

static void
___lambda121__gtk_widget_unrealize (GtkWidget* _sender,
                                    gpointer self)
{
#line 388 "../src/View/AbstractDirectoryView.vala"
	__lambda121_ ((FilesAbstractDirectoryView*) self);
#line 2714 "AbstractDirectoryView.c"
}

static void
__lambda122_ (FilesAbstractDirectoryView* self)
{
	FilesClipboardManager* _tmp0_;
#line 393 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 393 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self, 0);
#line 394 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_clipboard_changed (self);
#line 2727 "AbstractDirectoryView.c"
}

static void
___lambda122__gtk_widget_realize (GtkWidget* _sender,
                                  gpointer self)
{
#line 392 "../src/View/AbstractDirectoryView.vala"
	__lambda122_ ((FilesAbstractDirectoryView*) self);
#line 2736 "AbstractDirectoryView.c"
}

static void
__lambda123_ (FilesAbstractDirectoryView* self)
{
#line 398 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 2744 "AbstractDirectoryView.c"
}

static void
___lambda123__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                            gpointer self)
{
#line 397 "../src/View/AbstractDirectoryView.vala"
	__lambda123_ ((FilesAbstractDirectoryView*) self);
#line 2753 "AbstractDirectoryView.c"
}

static void
__lambda124_ (FilesAbstractDirectoryView* self)
{
	GtkWidget* vscroll_bar = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_;
#line 404 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_scrolled_window_get_vscrollbar ((GtkScrolledWindow*) self);
#line 404 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 404 "../src/View/AbstractDirectoryView.vala"
	vscroll_bar = _tmp1_;
#line 405 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->_renaming;
#line 405 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_set_visible (vscroll_bar, !_tmp2_);
#line 401 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (vscroll_bar);
#line 2775 "AbstractDirectoryView.c"
}

static void
___lambda124__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 401 "../src/View/AbstractDirectoryView.vala"
	__lambda124_ ((FilesAbstractDirectoryView*) self);
#line 2785 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self)
{
#line 410 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_show_hidden_files_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2795 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_show_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self)
{
#line 411 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_show_thumbnails_changed ((FilesAbstractDirectoryView*) self);
#line 2805 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self)
{
#line 413 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_sort_directories_first_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2815 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                          GtkTreePath* path,
                                                                          gpointer self)
{
#line 419 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_row_deleted ((FilesAbstractDirectoryView*) self, path);
#line 2825 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                             gpointer self)
{
#line 421 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_sort_column_changed ((FilesAbstractDirectoryView*) self);
#line 2834 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_up_directory_view (FilesAbstractDirectoryView* self)
{
	GtkAdjustment* _tmp0_;
	FilesPreferences* prefs = NULL;
	FilesPreferences* _tmp1_;
	FilesListModel* _tmp2_;
	FilesPreferences* _tmp3_;
	FilesPreferences* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	FilesListModel* _tmp7_;
	FilesListModel* _tmp8_;
#line 382 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 383 "../src/View/AbstractDirectoryView.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 384 "../src/View/AbstractDirectoryView.vala"
	gtk_scrolled_window_set_shadow_type ((GtkScrolledWindow*) self, GTK_SHADOW_NONE);
#line 386 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "popup-menu", (GCallback) _files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu, self, 0);
#line 388 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "unrealize", (GCallback) ___lambda121__gtk_widget_unrealize, self, 0);
#line 392 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda122__gtk_widget_realize, self, 0);
#line 397 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 397 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp0_, "value-changed", (GCallback) ___lambda123__gtk_adjustment_value_changed, self, G_CONNECT_AFTER);
#line 401 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) self, "notify::renaming", (GCallback) ___lambda124__g_object_notify, self, 0);
#line 409 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_preferences_get_default ();
#line 409 "../src/View/AbstractDirectoryView.vala"
	prefs = _tmp1_;
#line 410 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-hidden-files", (GCallback) _files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify, self, 0);
#line 411 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-remote-thumbnails", (GCallback) _files_abstract_directory_view_on_show_thumbnails_changed_g_object_notify, self, 0);
#line 412 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-local-thumbnails", (GCallback) _files_abstract_directory_view_on_show_thumbnails_changed_g_object_notify, self, 0);
#line 413 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::sort-directories-first", (GCallback) _files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify, self, 0);
#line 414 "../src/View/AbstractDirectoryView.vala"
	g_object_bind_property_with_closures ((GObject*) prefs, "singleclick-select", (GObject*) self, "singleclick_select", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 418 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 418 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_preferences_get_default ();
#line 418 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 418 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_preferences_get_sort_directories_first (_tmp4_);
#line 418 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 418 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_should_sort_directories_first (_tmp2_, _tmp6_);
#line 418 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp4_);
#line 419 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->model;
#line 419 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-deleted", (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
#line 421 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->model;
#line 421 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeSortable*) _tmp8_, "sort-column-changed", (GCallback) _files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed, self, 0);
#line 382 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (prefs);
#line 2906 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_up__menu_actions (FilesAbstractDirectoryView* self)
{
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GSimpleActionGroup* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GSimpleActionGroup* _tmp8_;
#line 424 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 425 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selection_actions);
#line 425 "../src/View/AbstractDirectoryView.vala"
	self->priv->selection_actions = _tmp0_;
#line 426 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->selection_actions;
#line 426 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES), self);
#line 427 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->selection_actions;
#line 427 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "selection", (GActionGroup*) _tmp2_);
#line 429 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_simple_action_group_new ();
#line 429 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->background_actions);
#line 429 "../src/View/AbstractDirectoryView.vala"
	self->priv->background_actions = _tmp3_;
#line 430 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->priv->background_actions;
#line 430 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp4_, FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES), self);
#line 431 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->priv->background_actions;
#line 431 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "background", (GActionGroup*) _tmp5_);
#line 433 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = g_simple_action_group_new ();
#line 433 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->common_actions);
#line 433 "../src/View/AbstractDirectoryView.vala"
	self->priv->common_actions = _tmp6_;
#line 434 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->priv->common_actions;
#line 434 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp7_, FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES), self);
#line 435 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->priv->common_actions;
#line 435 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "common", (GActionGroup*) _tmp8_);
#line 2965 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_zoom_in (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel _tmp0_;
	FilesZoomLevel _tmp1_;
#line 438 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 439 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_zoom_level (self);
#line 439 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 439 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_zoom_level (self, _tmp1_ + 1);
#line 2981 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_zoom_out (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel _tmp0_;
	FilesZoomLevel _tmp1_;
#line 442 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 443 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_zoom_level (self);
#line 443 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 443 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ > 0) {
#line 2997 "AbstractDirectoryView.c"
		FilesZoomLevel _tmp2_;
		FilesZoomLevel _tmp3_;
#line 444 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_zoom_level (self);
#line 444 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 444 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, _tmp3_ - 1);
#line 3006 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_zoom_normal (FilesAbstractDirectoryView* self)
{
	GSettings* view_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 448 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_view_settings (self);
#line 449 "../src/View/AbstractDirectoryView.vala"
	view_settings = _tmp0_;
#line 450 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = view_settings;
#line 450 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ == NULL) {
#line 451 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, FILES_ZOOM_LEVEL_NORMAL);
#line 3028 "AbstractDirectoryView.c"
	} else {
		GSettings* _tmp2_;
#line 453 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = view_settings;
#line 453 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, (FilesZoomLevel) g_settings_get_enum (_tmp2_, "default-zoom-level"));
#line 3035 "AbstractDirectoryView.c"
	}
#line 448 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (view_settings);
#line 3039 "AbstractDirectoryView.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 460 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 460 "../src/View/AbstractDirectoryView.vala"
	return _data17_;
#line 3049 "AbstractDirectoryView.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 460 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 3059 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 460 "../src/View/AbstractDirectoryView.vala"
		self = _data17_->self;
#line 460 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 460 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block17Data, _data17_);
#line 3067 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda65_ (Block17Data* _data17_)
{
	FilesAbstractDirectoryView* self;
	gboolean _tmp0_;
	gboolean result;
#line 462 "../src/View/AbstractDirectoryView.vala"
	self = _data17_->self;
#line 463 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_tree_frozen;
#line 463 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp0_) {
#line 3083 "AbstractDirectoryView.c"
		GtkTreePath* _tmp1_;
		GtkTreePath* _tmp2_;
#line 464 "../src/View/AbstractDirectoryView.vala"
		self->priv->set_cursor_timeout_id = (guint) 0;
#line 465 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = gtk_tree_path_new_from_indices (0, -1);
#line 465 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 465 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_cursor (self, _tmp2_, FALSE, _data17_->select, TRUE);
#line 465 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_tmp2_);
#line 466 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 466 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 3100 "AbstractDirectoryView.c"
	} else {
#line 468 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 468 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 3106 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda65__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda65_ (self);
#line 462 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3117 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_focus_first_for_empty_selection (FilesAbstractDirectoryView* self,
                                                               gboolean select)
{
	Block17Data* _data17_;
	GList* _tmp0_;
#line 460 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/View/AbstractDirectoryView.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 460 "../src/View/AbstractDirectoryView.vala"
	_data17_->_ref_count_ = 1;
#line 460 "../src/View/AbstractDirectoryView.vala"
	_data17_->self = g_object_ref (self);
#line 460 "../src/View/AbstractDirectoryView.vala"
	_data17_->select = select;
#line 461 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 461 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 462 "../src/View/AbstractDirectoryView.vala"
		self->priv->set_cursor_timeout_id = g_idle_add_full (G_PRIORITY_LOW, ____lambda65__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 3142 "AbstractDirectoryView.c"
	}
#line 460 "../src/View/AbstractDirectoryView.vala"
	block17_data_unref (_data17_);
#line 460 "../src/View/AbstractDirectoryView.vala"
	_data17_ = NULL;
#line 3148 "AbstractDirectoryView.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 479 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 479 "../src/View/AbstractDirectoryView.vala"
	return _data18_;
#line 3158 "AbstractDirectoryView.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 479 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 3168 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 479 "../src/View/AbstractDirectoryView.vala"
		self = _data18_->self;
#line 479 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data18_->focus_after_select);
#line 479 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data18_->files_to_select_list);
#line 479 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 479 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block18Data, _data18_);
#line 3180 "AbstractDirectoryView.c"
	}
}

static void
__lambda63_ (Block18Data* _data18_,
             GFile* loc)
{
	FilesAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	FilesFile* _tmp1_;
	FilesFile* _tmp2_;
#line 481 "../src/View/AbstractDirectoryView.vala"
	self = _data18_->self;
#line 481 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (loc != NULL);
#line 482 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data18_->files_to_select_list;
#line 482 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_file_get (loc);
#line 482 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 482 "../src/View/AbstractDirectoryView.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp2_);
#line 482 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp2_);
#line 3206 "AbstractDirectoryView.c"
}

static void
___lambda63__gfunc (gconstpointer data,
                    gpointer self)
{
#line 481 "../src/View/AbstractDirectoryView.vala"
	__lambda63_ (self, (GFile*) data);
#line 3215 "AbstractDirectoryView.c"
}

static void
___lambda64_ (Block18Data* _data18_)
{
	FilesAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_;
#line 492 "../src/View/AbstractDirectoryView.vala"
	self = _data18_->self;
#line 493 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data18_->files_to_select_list;
#line 493 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data18_->focus_after_select;
#line 493 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp0_, _tmp1_);
#line 3232 "AbstractDirectoryView.c"
}

static void
____lambda64__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 492 "../src/View/AbstractDirectoryView.vala"
	___lambda64_ (self);
#line 3242 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_glib_files_when_thawed (FilesAbstractDirectoryView* self,
                                                             GList* location_list,
                                                             GFile* focus_location)
{
	Block18Data* _data18_;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* _tmp3_;
	gboolean _tmp4_;
#line 479 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 479 "../src/View/AbstractDirectoryView.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 479 "../src/View/AbstractDirectoryView.vala"
	_data18_->_ref_count_ = 1;
#line 479 "../src/View/AbstractDirectoryView.vala"
	_data18_->self = g_object_ref (self);
#line 480 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gee_linked_list_new (FILES_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 480 "../src/View/AbstractDirectoryView.vala"
	_data18_->files_to_select_list = _tmp0_;
#line 481 "../src/View/AbstractDirectoryView.vala"
	g_list_foreach (location_list, ___lambda63__gfunc, _data18_);
#line 485 "../src/View/AbstractDirectoryView.vala"
	if (focus_location != NULL) {
#line 3271 "AbstractDirectoryView.c"
		GFile* _tmp2_;
#line 485 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = g_file_dup (focus_location);
#line 485 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 485 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp2_;
#line 3279 "AbstractDirectoryView.c"
	} else {
#line 485 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 485 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = NULL;
#line 3285 "AbstractDirectoryView.c"
	}
#line 485 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (_tmp1_);
#line 485 "../src/View/AbstractDirectoryView.vala"
	_data18_->focus_after_select = _tmp3_;
#line 491 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->priv->_tree_frozen;
#line 491 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 3295 "AbstractDirectoryView.c"
		gulong _tmp5_;
#line 492 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_signal_connect_data ((GObject*) self, "notify::tree-frozen", (GCallback) ____lambda64__g_object_notify, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 492 "../src/View/AbstractDirectoryView.vala"
		self->priv->select_source_handler = _tmp5_;
#line 3301 "AbstractDirectoryView.c"
	} else {
		GeeLinkedList* _tmp6_;
		GFile* _tmp7_;
#line 496 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _data18_->files_to_select_list;
#line 496 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _data18_->focus_after_select;
#line 496 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp6_, _tmp7_);
#line 3311 "AbstractDirectoryView.c"
	}
#line 479 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp1_);
#line 479 "../src/View/AbstractDirectoryView.vala"
	block18_data_unref (_data18_);
#line 479 "../src/View/AbstractDirectoryView.vala"
	_data18_ = NULL;
#line 3319 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 500 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 3327 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_select_files_and_update_if_thawed (FilesAbstractDirectoryView* self,
                                                                 GeeLinkedList* files_to_select,
                                                                 GFile* focus_file)
{
	gboolean _tmp0_;
	guint count = 0U;
	GtkTreeIter* iter = NULL;
#line 500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (files_to_select != NULL);
#line 502 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_tree_frozen;
#line 502 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 503 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3348 "AbstractDirectoryView.c"
	}
#line 507 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->set_cursor_timeout_id > ((guint) 0)) {
#line 508 "../src/View/AbstractDirectoryView.vala"
		g_source_remove (self->priv->set_cursor_timeout_id);
#line 509 "../src/View/AbstractDirectoryView.vala"
		self->priv->set_cursor_timeout_id = (guint) 0;
#line 3356 "AbstractDirectoryView.c"
	}
#line 512 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->select_source_handler > ((gulong) 0)) {
#line 513 "../src/View/AbstractDirectoryView.vala"
		g_signal_handler_disconnect ((GObject*) self, self->priv->select_source_handler);
#line 514 "../src/View/AbstractDirectoryView.vala"
		self->priv->select_source_handler = (gulong) 0;
#line 3364 "AbstractDirectoryView.c"
	}
#line 517 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_tree_signals (self);
#line 518 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 520 "../src/View/AbstractDirectoryView.vala"
	count = (guint) 0;
#line 3372 "AbstractDirectoryView.c"
	{
		GeeLinkedList* _f_list = NULL;
		gint _f_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _f_index = 0;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_f_list = files_to_select;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _f_list;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_f_size = _tmp3_;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_f_index = -1;
#line 522 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 3394 "AbstractDirectoryView.c"
			gint _tmp4_;
			gint _tmp5_;
			FilesFile* f = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GtkTreePath* path = NULL;
			FilesListModel* _tmp8_;
			FilesFile* _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreePath* _tmp11_;
#line 522 "../src/View/AbstractDirectoryView.vala"
			_f_index = _f_index + 1;
#line 522 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = _f_index;
#line 522 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = _f_size;
#line 522 "../src/View/AbstractDirectoryView.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 522 "../src/View/AbstractDirectoryView.vala"
				break;
#line 3415 "AbstractDirectoryView.c"
			}
#line 522 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = _f_list;
#line 522 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _f_index);
#line 522 "../src/View/AbstractDirectoryView.vala"
			f = (FilesFile*) _tmp7_;
#line 524 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->model;
#line 524 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = f;
#line 524 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = files_list_model_get_path_for_first_file (_tmp8_, _tmp9_);
#line 524 "../src/View/AbstractDirectoryView.vala"
			path = _tmp10_;
#line 525 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = path;
#line 525 "../src/View/AbstractDirectoryView.vala"
			if (_tmp11_ != NULL) {
#line 3435 "AbstractDirectoryView.c"
				guint _tmp12_;
				gboolean _tmp13_ = FALSE;
				GtkTreePath* _tmp17_;
#line 526 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = count;
#line 526 "../src/View/AbstractDirectoryView.vala"
				count = _tmp12_ + 1;
#line 528 "../src/View/AbstractDirectoryView.vala"
				if (focus_file != NULL) {
#line 3445 "AbstractDirectoryView.c"
					FilesFile* _tmp14_;
					GFile* _tmp15_;
					GFile* _tmp16_;
#line 528 "../src/View/AbstractDirectoryView.vala"
					_tmp14_ = f;
#line 528 "../src/View/AbstractDirectoryView.vala"
					_tmp15_ = files_file_get_location (_tmp14_);
#line 528 "../src/View/AbstractDirectoryView.vala"
					_tmp16_ = _tmp15_;
#line 528 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = g_file_equal (focus_file, _tmp16_);
#line 3457 "AbstractDirectoryView.c"
				} else {
#line 528 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = FALSE;
#line 3461 "AbstractDirectoryView.c"
				}
#line 528 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = path;
#line 528 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_select_path (self, _tmp17_, _tmp13_);
#line 3467 "AbstractDirectoryView.c"
			}
#line 522 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (path);
#line 522 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (f);
#line 3473 "AbstractDirectoryView.c"
		}
	}
#line 532 "../src/View/AbstractDirectoryView.vala"
	if (count == ((guint) 0)) {
#line 533 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_focus_first_for_empty_selection (self, FALSE);
#line 3480 "AbstractDirectoryView.c"
	}
#line 536 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_tree_signals (self);
#line 537 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_view_selection_changed (self);
#line 539 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 500 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 3490 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_open_with_apps (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result;
#line 542 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 543 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 543 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 543 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3506 "AbstractDirectoryView.c"
}

GAppInfo*
files_abstract_directory_view_get_default_app (FilesAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	GAppInfo* _tmp1_;
	GAppInfo* result;
#line 546 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 547 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 547 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 547 "../src/View/AbstractDirectoryView.vala"
	result = _tmp1_;
#line 547 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3525 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_grab_focus (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
#line 550 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 551 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->view;
#line 551 "../src/View/AbstractDirectoryView.vala"
	if (gtk_widget_get_realized (_tmp0_)) {
#line 3538 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkWidget* _tmp4_;
#line 553 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->slot;
#line 553 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_view_slot_get_is_active (_tmp1_);
#line 553 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 553 "../src/View/AbstractDirectoryView.vala"
		if (!_tmp3_) {
#line 554 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_set_active_slot (self, TRUE);
#line 3553 "AbstractDirectoryView.c"
		}
#line 557 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->priv->view;
#line 557 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_grab_focus (_tmp4_);
#line 3559 "AbstractDirectoryView.c"
	}
}

GList*
files_abstract_directory_view_get_selected_files (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result;
#line 561 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 562 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 563 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 563 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 563 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3578 "AbstractDirectoryView.c"
}

/*** Protected Methods */
void
files_abstract_directory_view_set_active_slot (FilesAbstractDirectoryView* self,
                                               gboolean scroll)
{
	FilesViewSlot* _tmp0_;
#line 567 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 568 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 568 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name ((FilesAbstractSlot*) _tmp0_, "active", scroll, TRUE);
#line 3593 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_load_location (FilesAbstractDirectoryView* self,
                                             GFile* location)
{
#line 571 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (location != NULL);
#line 572 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, FILES_OPEN_FLAG_DEFAULT, FALSE);
#line 3606 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_load_root_location (FilesAbstractDirectoryView* self,
                                                  GFile* location)
{
#line 575 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (location != NULL);
#line 576 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, FILES_OPEN_FLAG_DEFAULT, TRUE);
#line 3619 "AbstractDirectoryView.c"
}

/** Operations on selections */
static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 580 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 580 "../src/View/AbstractDirectoryView.vala"
	return _data19_;
#line 3630 "AbstractDirectoryView.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 580 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 3640 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 580 "../src/View/AbstractDirectoryView.vala"
		self = _data19_->self;
#line 580 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 580 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block19Data, _data19_);
#line 3648 "AbstractDirectoryView.c"
	}
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 601 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 601 "../src/View/AbstractDirectoryView.vala"
	return _data20_;
#line 3659 "AbstractDirectoryView.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 601 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 3669 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 601 "../src/View/AbstractDirectoryView.vala"
		self = _data20_->_data19_->self;
#line 601 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data20_->file);
#line 601 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data20_->_data19_);
#line 601 "../src/View/AbstractDirectoryView.vala"
		_data20_->_data19_ = NULL;
#line 601 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block20Data, _data20_);
#line 3681 "AbstractDirectoryView.c"
	}
}

static gboolean
_______lambda78_ (Block20Data* _data20_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	FilesFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result;
#line 609 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data20_->_data19_;
#line 609 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 610 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data20_->file;
#line 610 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data19_->screen;
#line 610 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_file (self, _tmp0_, _tmp1_, _data19_->flag, FALSE);
#line 611 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 611 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3707 "AbstractDirectoryView.c"
}

static gboolean
________lambda78__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda78_ (self);
#line 609 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3717 "AbstractDirectoryView.c"
}

static gboolean
_______lambda79_ (Block20Data* _data20_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	FilesFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result;
#line 614 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data20_->_data19_;
#line 614 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 615 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data20_->file;
#line 615 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data19_->screen;
#line 615 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_file (self, _tmp0_, _tmp1_, NULL);
#line 616 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 616 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3742 "AbstractDirectoryView.c"
}

static gboolean
________lambda79__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda79_ (self);
#line 614 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3752 "AbstractDirectoryView.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 620 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 620 "../src/View/AbstractDirectoryView.vala"
	return _data21_;
#line 3762 "AbstractDirectoryView.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 620 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 3772 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 620 "../src/View/AbstractDirectoryView.vala"
		self = _data21_->_data19_->self;
#line 620 "../src/View/AbstractDirectoryView.vala"
		(_data21_->files_to_open == NULL) ? NULL : (_data21_->files_to_open = (_g_list_free__g_object_unref0_ (_data21_->files_to_open), NULL));
#line 620 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data21_->_data19_);
#line 620 "../src/View/AbstractDirectoryView.vala"
		_data21_->_data19_ = NULL;
#line 620 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block21Data, _data21_);
#line 3784 "AbstractDirectoryView.c"
	}
}

static gboolean
_____lambda80_ (Block21Data* _data21_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	GAppInfo* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 623 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data21_->_data19_;
#line 623 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data21_->files_to_open;
#line 624 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_files_with (self, _tmp0_, _tmp1_);
#line 625 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 625 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3810 "AbstractDirectoryView.c"
}

static gboolean
______lambda80__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda80_ (self);
#line 623 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3820 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_activate_selected_items (FilesAbstractDirectoryView* self,
                                                       FilesOpenFlag flag,
                                                       GList* selection)
{
	Block19Data* _data19_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GdkScreen* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
#line 580 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 580 "../src/View/AbstractDirectoryView.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 580 "../src/View/AbstractDirectoryView.vala"
	_data19_->_ref_count_ = 1;
#line 580 "../src/View/AbstractDirectoryView.vala"
	_data19_->self = g_object_ref (self);
#line 580 "../src/View/AbstractDirectoryView.vala"
	_data19_->flag = flag;
#line 583 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 583 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 583 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 583 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 3853 "AbstractDirectoryView.c"
	} else {
#line 583 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = selection == NULL;
#line 3857 "AbstractDirectoryView.c"
	}
#line 583 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 584 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data19_);
#line 584 "../src/View/AbstractDirectoryView.vala"
		_data19_ = NULL;
#line 584 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3867 "AbstractDirectoryView.c"
	}
#line 587 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 587 "../src/View/AbstractDirectoryView.vala"
	_data19_->screen = _tmp3_;
#line 589 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = g_list_first (selection);
#line 589 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_->next;
#line 589 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_ == NULL) {
#line 3879 "AbstractDirectoryView.c"
		gconstpointer _tmp6_;
		GdkScreen* _tmp7_;
#line 590 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = selection->data;
#line 590 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _data19_->screen;
#line 590 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_activate_file (self, (FilesFile*) _tmp6_, _tmp7_, _data19_->flag, TRUE);
#line 591 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data19_);
#line 591 "../src/View/AbstractDirectoryView.vala"
		_data19_ = NULL;
#line 591 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3894 "AbstractDirectoryView.c"
	}
#line 594 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->in_trash) {
#line 3898 "AbstractDirectoryView.c"
		gboolean _tmp8_ = FALSE;
		gconstpointer _tmp9_;
#line 598 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = g_list_nth_data (selection, (guint) 11);
#line 598 "../src/View/AbstractDirectoryView.vala"
		if (((FilesFile*) _tmp9_) == NULL) {
#line 3905 "AbstractDirectoryView.c"
			gboolean _tmp10_ = FALSE;
			GAppInfo* _tmp11_;
#line 599 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->priv->default_app;
#line 599 "../src/View/AbstractDirectoryView.vala"
			if (_tmp11_ == NULL) {
#line 599 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = TRUE;
#line 3914 "AbstractDirectoryView.c"
			} else {
				GAppInfo* _tmp12_;
#line 599 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = self->priv->default_app;
#line 599 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = files_abstract_directory_view_app_is_this_app (self, _tmp12_);
#line 3921 "AbstractDirectoryView.c"
			}
#line 599 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = _tmp10_;
#line 3925 "AbstractDirectoryView.c"
		} else {
#line 598 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = FALSE;
#line 3929 "AbstractDirectoryView.c"
		}
#line 598 "../src/View/AbstractDirectoryView.vala"
		if (_tmp8_) {
#line 3933 "AbstractDirectoryView.c"
			{
				GList* file_collection = NULL;
				GList* file_it = NULL;
#line 601 "../src/View/AbstractDirectoryView.vala"
				file_collection = selection;
#line 601 "../src/View/AbstractDirectoryView.vala"
				for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 3941 "AbstractDirectoryView.c"
					FilesFile* _tmp13_;
					FilesFile* file = NULL;
#line 601 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 601 "../src/View/AbstractDirectoryView.vala"
					file = _tmp13_;
#line 3948 "AbstractDirectoryView.c"
					{
						Block20Data* _data20_;
						FilesFile* _tmp14_;
#line 601 "../src/View/AbstractDirectoryView.vala"
						_data20_ = g_slice_new0 (Block20Data);
#line 601 "../src/View/AbstractDirectoryView.vala"
						_data20_->_ref_count_ = 1;
#line 601 "../src/View/AbstractDirectoryView.vala"
						_data20_->_data19_ = block19_data_ref (_data19_);
#line 601 "../src/View/AbstractDirectoryView.vala"
						_data20_->file = file;
#line 603 "../src/View/AbstractDirectoryView.vala"
						_tmp14_ = _data20_->file;
#line 603 "../src/View/AbstractDirectoryView.vala"
						if (files_file_is_folder (_tmp14_)) {
#line 605 "../src/View/AbstractDirectoryView.vala"
							if (_data19_->flag == FILES_OPEN_FLAG_DEFAULT) {
#line 606 "../src/View/AbstractDirectoryView.vala"
								_data19_->flag = FILES_OPEN_FLAG_NEW_TAB;
#line 3968 "AbstractDirectoryView.c"
							}
#line 609 "../src/View/AbstractDirectoryView.vala"
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda78__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 3972 "AbstractDirectoryView.c"
						} else {
#line 614 "../src/View/AbstractDirectoryView.vala"
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda79__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 3976 "AbstractDirectoryView.c"
						}
#line 601 "../src/View/AbstractDirectoryView.vala"
						block20_data_unref (_data20_);
#line 601 "../src/View/AbstractDirectoryView.vala"
						_data20_ = NULL;
#line 3982 "AbstractDirectoryView.c"
					}
				}
			}
		} else {
			GAppInfo* _tmp15_;
#line 620 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = self->priv->default_app;
#line 620 "../src/View/AbstractDirectoryView.vala"
			if (_tmp15_ != NULL) {
#line 3992 "AbstractDirectoryView.c"
				Block21Data* _data21_;
				GList* _tmp16_;
#line 620 "../src/View/AbstractDirectoryView.vala"
				_data21_ = g_slice_new0 (Block21Data);
#line 620 "../src/View/AbstractDirectoryView.vala"
				_data21_->_ref_count_ = 1;
#line 620 "../src/View/AbstractDirectoryView.vala"
				_data21_->_data19_ = block19_data_ref (_data19_);
#line 622 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
#line 622 "../src/View/AbstractDirectoryView.vala"
				_data21_->files_to_open = _tmp16_;
#line 623 "../src/View/AbstractDirectoryView.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda80__gsource_func, block21_data_ref (_data21_), block21_data_unref);
#line 620 "../src/View/AbstractDirectoryView.vala"
				block21_data_unref (_data21_);
#line 620 "../src/View/AbstractDirectoryView.vala"
				_data21_ = NULL;
#line 4011 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 629 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:629: Cannot open files in trash");
#line 4017 "AbstractDirectoryView.c"
	}
#line 580 "../src/View/AbstractDirectoryView.vala"
	block19_data_unref (_data19_);
#line 580 "../src/View/AbstractDirectoryView.vala"
	_data19_ = NULL;
#line 4023 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_gof_file (FilesAbstractDirectoryView* self,
                                               FilesFile* file)
{
	GtkTreePath* path = NULL;
	FilesListModel* _tmp0_;
	GtkTreePath* _tmp1_;
#line 633 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 633 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 634 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 634 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_path_for_first_file (_tmp0_, file);
#line 634 "../src/View/AbstractDirectoryView.vala"
	path = _tmp1_;
#line 635 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, path, FALSE, TRUE, FALSE);
#line 633 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 4047 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_and_scroll_to_gof_file (FilesAbstractDirectoryView* self,
                                                             FilesFile* file)
{
	GtkTreePath* path = NULL;
	FilesListModel* _tmp0_;
	GtkTreePath* _tmp1_;
#line 638 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 639 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 639 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_path_for_first_file (_tmp0_, file);
#line 639 "../src/View/AbstractDirectoryView.vala"
	path = _tmp1_;
#line 640 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, path, FALSE, TRUE, TRUE);
#line 638 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 4071 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_add_gof_file_to_selection (FilesAbstractDirectoryView* self,
                                                         FilesFile* file)
{
	FilesListModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
#line 643 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 643 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 644 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 644 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_path_for_first_file (_tmp0_, file);
#line 644 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 644 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_path (self, _tmp2_, FALSE);
#line 644 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 4095 "AbstractDirectoryView.c"
}

/** Directory signal handlers. */
static void
_files_abstract_directory_view_on_directory_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                   FilesFile* file,
                                                                                   gboolean is_internal,
                                                                                   gpointer self)
{
#line 650 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_added ((FilesAbstractDirectoryView*) self, _sender, file, is_internal);
#line 4107 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed (FilesDirectory* _sender,
                                                                                       FilesFile* file,
                                                                                       gpointer self)
{
#line 651 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_changed ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4117 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted (FilesDirectory* _sender,
                                                                                       FilesFile* file,
                                                                                       gpointer self)
{
#line 652 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_deleted ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4127 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self)
{
#line 653 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_icon_changed ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4137 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_directory_handlers (FilesAbstractDirectoryView* self,
                                                          FilesDirectory* dir)
{
#line 649 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 649 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 650 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-added", (GCallback) _files_abstract_directory_view_on_directory_file_added_files_directory_file_added, self, 0);
#line 651 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-changed", (GCallback) _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed, self, 0);
#line 652 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-deleted", (GCallback) _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted, self, 0);
#line 653 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "icon-changed", (GCallback) _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed, self, 0);
#line 654 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 4158 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded (FilesDirectory* _sender,
                                                                                     FilesFile* file,
                                                                                     gpointer self)
{
#line 659 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_loaded ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4168 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading (FilesDirectory* _sender,
                                                                                       gpointer self)
{
#line 660 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_done_loading ((FilesAbstractDirectoryView*) self, _sender);
#line 4177 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                  FilesDirectory* dir)
{
	FilesListModel* _tmp0_;
#line 657 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 657 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 658 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 658 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_sorting_off (_tmp0_);
#line 659 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-loaded", (GCallback) _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded, self, 0);
#line 660 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "done-loading", (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self, 0);
#line 4197 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                     FilesDirectory* dir)
{
	FilesListModel* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 663 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 663 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 664 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 664 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_sorting_on (_tmp0_);
#line 665 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-loaded", FILES_TYPE_DIRECTORY, &_tmp1_, NULL, FALSE);
#line 665 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded, self);
#line 666 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("done-loading", FILES_TYPE_DIRECTORY, &_tmp2_, NULL, FALSE);
#line 666 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self);
#line 4223 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_directory_handlers (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 669 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 669 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 672 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_loading (dir)) {
#line 673 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
#line 4243 "AbstractDirectoryView.c"
	}
#line 676 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp0_, NULL, FALSE);
#line 676 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_added_files_directory_file_added, self);
#line 677 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-changed", FILES_TYPE_DIRECTORY, &_tmp1_, NULL, FALSE);
#line 677 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed, self);
#line 678 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-deleted", FILES_TYPE_DIRECTORY, &_tmp2_, NULL, FALSE);
#line 678 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted, self);
#line 679 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("icon-changed", FILES_TYPE_DIRECTORY, &_tmp3_, NULL, FALSE);
#line 679 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed, self);
#line 680 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("done-loading", FILES_TYPE_DIRECTORY, &_tmp4_, NULL, FALSE);
#line 680 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self);
#line 4265 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_change_directory (FilesAbstractDirectoryView* self,
                                                FilesDirectory* old_dir,
                                                FilesDirectory* new_dir)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 683 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 683 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (old_dir != NULL);
#line 683 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (new_dir != NULL);
#line 684 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 684 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 684 "../src/View/AbstractDirectoryView.vala"
	style_context = _tmp1_;
#line 685 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = style_context;
#line 685 "../src/View/AbstractDirectoryView.vala"
	if (gtk_style_context_has_class (_tmp2_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 4293 "AbstractDirectoryView.c"
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
#line 686 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = style_context;
#line 686 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_remove_class (_tmp3_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 687 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = style_context;
#line 687 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_remove_class (_tmp4_, GTK_STYLE_CLASS_VIEW);
#line 4304 "AbstractDirectoryView.c"
	}
#line 690 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 691 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear (self);
#line 692 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_directory_handlers (self, old_dir);
#line 693 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_handlers (self, new_dir);
#line 683 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (style_context);
#line 4316 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_prepare_reload (FilesAbstractDirectoryView* self,
                                              FilesDirectory* dir)
{
#line 696 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 697 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 698 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear (self);
#line 699 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 4333 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_clear (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
#line 702 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 705 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_tree (self);
#line 706 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_block_model (self);
#line 707 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 707 "../src/View/AbstractDirectoryView.vala"
	files_list_model_clear (_tmp0_);
#line 708 "../src/View/AbstractDirectoryView.vala"
	self->priv->all_selected = FALSE;
#line 710 "../src/View/AbstractDirectoryView.vala"
	self->on_directory = FALSE;
#line 711 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_model (self);
#line 4356 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  gint x,
                                                                  gint y,
                                                                  guint time_,
                                                                  gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_drop ((FilesAbstractDirectoryView*) self, context, x, y, time_);
#line 717 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4371 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                    GdkDragContext* context,
                                                                                    gint x,
                                                                                    gint y,
                                                                                    GtkSelectionData* selection_data,
                                                                                    guint info,
                                                                                    guint time_,
                                                                                    gpointer self)
{
#line 718 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_received ((FilesAbstractDirectoryView*) self, context, x, y, selection_data, info, time_);
#line 4386 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    guint time_,
                                                                    gpointer self)
{
#line 719 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_leave ((FilesAbstractDirectoryView*) self);
#line 4397 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      gint x,
                                                                      gint y,
                                                                      guint time_,
                                                                      gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_motion ((FilesAbstractDirectoryView*) self, context, x, y, time_);
#line 720 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4412 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    gpointer self)
{
#line 729 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_begin ((FilesAbstractDirectoryView*) self);
#line 4422 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                          GdkDragContext* context,
                                                                          GtkSelectionData* selection_data,
                                                                          guint info,
                                                                          guint time_,
                                                                          gpointer self)
{
#line 730 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_get ((FilesAbstractDirectoryView*) self, context, selection_data, info, time_);
#line 4435 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                                GdkDragContext* context,
                                                                                gpointer self)
{
#line 731 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_delete ((FilesAbstractDirectoryView*) self);
#line 4445 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                                GdkDragContext* context,
                                                                gpointer self)
{
#line 732 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_end ((FilesAbstractDirectoryView*) self);
#line 4455 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_drag_drop_signals (FilesAbstractDirectoryView* self,
                                                         GtkWidget* widget)
{
#line 714 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 714 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (widget != NULL);
#line 716 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_dest_set (widget, GTK_DEST_DEFAULT_MOTION, FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS), GDK_ACTION_ASK | FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
#line 717 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-drop", (GCallback) _files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop, self, 0);
#line 718 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-received", (GCallback) _files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received, self, 0);
#line 719 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-leave", (GCallback) _files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave, self, 0);
#line 720 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-motion", (GCallback) _files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion, self, 0);
#line 723 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_source_set (widget, GDK_BUTTON1_MASK | GDK_CONTROL_MASK, FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS), FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
#line 729 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-begin", (GCallback) _files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin, self, 0);
#line 730 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-get", (GCallback) _files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 731 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-delete", (GCallback) _files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete, self, 0);
#line 732 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-end", (GCallback) _files_abstract_directory_view_on_drag_end_gtk_widget_drag_end, self, 0);
#line 4486 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel_thumbnailing (FilesAbstractDirectoryView* self)
{
#line 735 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 736 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->thumbnail_request >= 0) {
#line 4496 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp0_;
#line 737 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->thumbnailer;
#line 737 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_dequeue (_tmp0_, self->priv->thumbnail_request);
#line 738 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = -1;
#line 4504 "AbstractDirectoryView.c"
	}
#line 741 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
#line 4508 "AbstractDirectoryView.c"
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 744 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 744 "../src/View/AbstractDirectoryView.vala"
	return _data22_;
#line 4518 "AbstractDirectoryView.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 744 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 4528 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 744 "../src/View/AbstractDirectoryView.vala"
		self = _data22_->self;
#line 744 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 744 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block22Data, _data22_);
#line 4536 "AbstractDirectoryView.c"
	}
}

static void
__lambda45_ (Block22Data* _data22_,
             FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	gboolean _tmp0_ = FALSE;
#line 747 "../src/View/AbstractDirectoryView.vala"
	self = _data22_->self;
#line 747 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 748 "../src/View/AbstractDirectoryView.vala"
	if (files_file_is_folder (file)) {
#line 748 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 4554 "AbstractDirectoryView.c"
	} else {
#line 748 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_file_is_root_network_folder (file);
#line 4558 "AbstractDirectoryView.c"
	}
#line 748 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp0_) {
#line 749 "../src/View/AbstractDirectoryView.vala"
		_data22_->only_folders = FALSE;
#line 4564 "AbstractDirectoryView.c"
	}
}

static void
___lambda45__gfunc (gconstpointer data,
                    gpointer self)
{
#line 747 "../src/View/AbstractDirectoryView.vala"
	__lambda45_ (self, (FilesFile*) data);
#line 4574 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_selection_only_contains_folders (FilesAbstractDirectoryView* self,
                                                               GList* list)
{
	Block22Data* _data22_;
	gboolean result;
#line 744 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 744 "../src/View/AbstractDirectoryView.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 744 "../src/View/AbstractDirectoryView.vala"
	_data22_->_ref_count_ = 1;
#line 744 "../src/View/AbstractDirectoryView.vala"
	_data22_->self = g_object_ref (self);
#line 745 "../src/View/AbstractDirectoryView.vala"
	_data22_->only_folders = TRUE;
#line 747 "../src/View/AbstractDirectoryView.vala"
	g_list_foreach (list, ___lambda45__gfunc, _data22_);
#line 753 "../src/View/AbstractDirectoryView.vala"
	result = _data22_->only_folders;
#line 753 "../src/View/AbstractDirectoryView.vala"
	block22_data_unref (_data22_);
#line 753 "../src/View/AbstractDirectoryView.vala"
	_data22_ = NULL;
#line 753 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4603 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_selected_files_for_transfer (FilesAbstractDirectoryView* self,
                                                               GList* selection)
{
	GList* _tmp0_;
	GList* result;
#line 756 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 758 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
#line 758 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 758 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4620 "AbstractDirectoryView.c"
}

/** File operations */
static void
files_abstract_directory_view_activate_file (FilesAbstractDirectoryView* self,
                                             FilesFile* _file,
                                             GdkScreen* screen,
                                             FilesOpenFlag flag,
                                             gboolean only_one_file)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesFile* file = NULL;
	FilesFile* _tmp2_;
	gboolean _tmp3_;
	FilesFile* _tmp8_;
	GAppInfo* _tmp9_;
	GFile* location = NULL;
	FilesFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 764 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 764 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (_file != NULL);
#line 765 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 765 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 765 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 766 "../src/View/AbstractDirectoryView.vala"
		return;
#line 4656 "AbstractDirectoryView.c"
	}
#line 769 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _g_object_ref0 (_file);
#line 769 "../src/View/AbstractDirectoryView.vala"
	file = _tmp2_;
#line 770 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->priv->_in_recent;
#line 770 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 4666 "AbstractDirectoryView.c"
		FilesFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		FilesFile* _tmp7_;
#line 771 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = file;
#line 771 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_display_target_uri (_tmp4_);
#line 771 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 771 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = files_file_get_by_uri (_tmp6_);
#line 771 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 771 "../src/View/AbstractDirectoryView.vala"
		file = _tmp7_;
#line 771 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp6_);
#line 4685 "AbstractDirectoryView.c"
	}
#line 774 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = file;
#line 774 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_mime_actions_get_default_application_for_file (_tmp8_);
#line 774 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 774 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = _tmp9_;
#line 775 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = file;
#line 775 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_file_get_target_location (_tmp10_);
#line 775 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 775 "../src/View/AbstractDirectoryView.vala"
	location = _tmp12_;
#line 777 "../src/View/AbstractDirectoryView.vala"
	if (screen == NULL) {
#line 4705 "AbstractDirectoryView.c"
		GdkScreen* _tmp13_;
#line 778 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 778 "../src/View/AbstractDirectoryView.vala"
		screen = _tmp13_;
#line 4711 "AbstractDirectoryView.c"
	}
#line 781 "../src/View/AbstractDirectoryView.vala"
	if (flag != FILES_OPEN_FLAG_APP) {
#line 4715 "AbstractDirectoryView.c"
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		FilesFile* _tmp17_;
#line 781 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = file;
#line 781 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp17_)) {
#line 781 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = TRUE;
#line 4725 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp18_;
			const gchar* _tmp19_;
#line 782 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = file;
#line 782 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = files_file_get_ftype (_tmp18_);
#line 782 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = g_strcmp0 (_tmp19_, "inode/directory") == 0;
#line 4735 "AbstractDirectoryView.c"
		}
#line 781 "../src/View/AbstractDirectoryView.vala"
		if (_tmp16_) {
#line 781 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = TRUE;
#line 4741 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp20_;
#line 783 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = file;
#line 783 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = files_file_is_root_network_folder (_tmp20_);
#line 4748 "AbstractDirectoryView.c"
		}
#line 781 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp15_;
#line 4752 "AbstractDirectoryView.c"
	} else {
#line 781 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = FALSE;
#line 4756 "AbstractDirectoryView.c"
	}
#line 781 "../src/View/AbstractDirectoryView.vala"
	if (_tmp14_) {
#line 785 "../src/View/AbstractDirectoryView.vala"
		switch (flag) {
#line 785 "../src/View/AbstractDirectoryView.vala"
			case FILES_OPEN_FLAG_NEW_TAB:
#line 785 "../src/View/AbstractDirectoryView.vala"
			case FILES_OPEN_FLAG_NEW_WINDOW:
#line 4766 "AbstractDirectoryView.c"
			{
				GFile* _tmp21_;
#line 788 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = location;
#line 788 "../src/View/AbstractDirectoryView.vala"
				g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp21_, flag, TRUE);
#line 789 "../src/View/AbstractDirectoryView.vala"
				break;
#line 4775 "AbstractDirectoryView.c"
			}
			default:
			{
#line 792 "../src/View/AbstractDirectoryView.vala"
				if (only_one_file) {
#line 4781 "AbstractDirectoryView.c"
					GFile* _tmp22_;
#line 793 "../src/View/AbstractDirectoryView.vala"
					_tmp22_ = location;
#line 793 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_load_location (self, _tmp22_);
#line 4787 "AbstractDirectoryView.c"
				}
#line 796 "../src/View/AbstractDirectoryView.vala"
				break;
#line 4791 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 798 "../src/View/AbstractDirectoryView.vala"
		if (!self->priv->in_trash) {
#line 799 "../src/View/AbstractDirectoryView.vala"
			if (only_one_file) {
#line 4799 "AbstractDirectoryView.c"
				FilesFile* _tmp23_;
#line 800 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = file;
#line 800 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_executable (_tmp23_)) {
#line 4805 "AbstractDirectoryView.c"
					gchar* content_type = NULL;
					FilesFile* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
#line 801 "../src/View/AbstractDirectoryView.vala"
					_tmp24_ = file;
#line 801 "../src/View/AbstractDirectoryView.vala"
					_tmp25_ = files_file_get_ftype (_tmp24_);
#line 801 "../src/View/AbstractDirectoryView.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 801 "../src/View/AbstractDirectoryView.vala"
					content_type = _tmp26_;
#line 803 "../src/View/AbstractDirectoryView.vala"
					_tmp27_ = content_type;
#line 803 "../src/View/AbstractDirectoryView.vala"
					if (g_content_type_is_a (_tmp27_, "text/plain")) {
#line 4823 "AbstractDirectoryView.c"
						FilesFile* _tmp28_;
						GAppInfo* _tmp29_;
#line 804 "../src/View/AbstractDirectoryView.vala"
						_tmp28_ = file;
#line 804 "../src/View/AbstractDirectoryView.vala"
						_tmp29_ = self->priv->default_app;
#line 804 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_open_file (self, _tmp28_, screen, _tmp29_);
#line 4832 "AbstractDirectoryView.c"
					} else {
						{
							FilesFile* _tmp30_;
#line 807 "../src/View/AbstractDirectoryView.vala"
							_tmp30_ = file;
#line 807 "../src/View/AbstractDirectoryView.vala"
							files_file_execute (_tmp30_, NULL, &_inner_error0_);
#line 807 "../src/View/AbstractDirectoryView.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4842 "AbstractDirectoryView.c"
								goto __catch0_g_error;
							}
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							GError* _tmp31_;
							const gchar* _tmp32_;
							FilesViewWindow* _tmp33_;
							FilesViewWindow* _tmp34_;
							GraniteMessageDialog* _tmp35_;
							GraniteMessageDialog* _tmp36_;
#line 806 "../src/View/AbstractDirectoryView.vala"
							e = _inner_error0_;
#line 806 "../src/View/AbstractDirectoryView.vala"
							_inner_error0_ = NULL;
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp31_ = e;
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = _tmp31_->message;
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp33_ = files_abstract_directory_view_get_window (self);
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp34_ = _tmp33_;
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp35_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp32_, (GtkWindow*) _tmp34_);
#line 809 "../src/View/AbstractDirectoryView.vala"
							_tmp36_ = _tmp35_;
#line 809 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp36_);
#line 806 "../src/View/AbstractDirectoryView.vala"
							_g_error_free0 (e);
#line 4876 "AbstractDirectoryView.c"
						}
						__finally0:
#line 806 "../src/View/AbstractDirectoryView.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 806 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (content_type);
#line 806 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (location);
#line 806 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (file);
#line 806 "../src/View/AbstractDirectoryView.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 806 "../src/View/AbstractDirectoryView.vala"
							g_clear_error (&_inner_error0_);
#line 806 "../src/View/AbstractDirectoryView.vala"
							return;
#line 4893 "AbstractDirectoryView.c"
						}
					}
#line 800 "../src/View/AbstractDirectoryView.vala"
					_g_free0 (content_type);
#line 4898 "AbstractDirectoryView.c"
				} else {
					FilesFile* _tmp37_;
					GAppInfo* _tmp38_;
#line 813 "../src/View/AbstractDirectoryView.vala"
					_tmp37_ = file;
#line 813 "../src/View/AbstractDirectoryView.vala"
					_tmp38_ = self->priv->default_app;
#line 813 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_open_file (self, _tmp37_, screen, _tmp38_);
#line 4908 "AbstractDirectoryView.c"
				}
			}
		} else {
			FilesFile* _tmp39_;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			FilesViewWindow* _tmp44_;
			FilesViewWindow* _tmp45_;
			GraniteMessageDialog* _tmp46_;
			GraniteMessageDialog* _tmp47_;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp39_ = file;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp40_ = files_file_get_basename (_tmp39_);
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp41_ = _tmp40_;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp42_ = g_strdup_printf (_ ("“%s” must be moved from Trash before opening"), _tmp41_);
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp43_ = _tmp42_;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp44_ = files_abstract_directory_view_get_window (self);
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = _tmp44_;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp46_ = pf_dialogs_show_error_dialog (_tmp43_, _ ("Files inside Trash cannot be opened. To open this file, it must be mov" \
"ed elsewhere."), (GtkWindow*) _tmp45_);
#line 817 "../src/View/AbstractDirectoryView.vala"
			_tmp47_ = _tmp46_;
#line 817 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp47_);
#line 817 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (_tmp43_);
#line 4943 "AbstractDirectoryView.c"
		}
	}
#line 764 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (location);
#line 764 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 4950 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_open_file (FilesAbstractDirectoryView* self,
                                         FilesFile* file,
                                         GdkScreen* screen,
                                         GAppInfo* app_info)
{
#line 827 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 827 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 828 "../src/View/AbstractDirectoryView.vala"
	if (files_abstract_directory_view_can_open_file (self, file, TRUE)) {
#line 4965 "AbstractDirectoryView.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 829 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_file_get_location (file);
#line 829 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_;
#line 829 "../src/View/AbstractDirectoryView.vala"
		files_mime_actions_open_glib_file_request (_tmp1_, (GtkWidget*) self, app_info);
#line 4974 "AbstractDirectoryView.c"
	}
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 4984 "AbstractDirectoryView.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 4992 "AbstractDirectoryView.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 5001 "AbstractDirectoryView.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 5021 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_can_open_file (FilesAbstractDirectoryView* self,
                                             FilesFile* file,
                                             gboolean show_error_dialog)
{
	gchar* err_msg1 = NULL;
	gchar* _tmp0_;
	gchar* err_msg2 = NULL;
	gchar* _tmp1_;
	gchar* content_type = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp12_;
	gboolean success = FALSE;
	const gchar* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gboolean _tmp43_ = FALSE;
	gboolean result;
#line 834 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 834 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 835 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_strdup (_ ("Cannot open this file"));
#line 835 "../src/View/AbstractDirectoryView.vala"
	err_msg1 = _tmp0_;
#line 836 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 836 "../src/View/AbstractDirectoryView.vala"
	err_msg2 = _tmp1_;
#line 837 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_ftype (file);
#line 837 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 837 "../src/View/AbstractDirectoryView.vala"
	content_type = _tmp3_;
#line 839 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = content_type;
#line 839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ == NULL) {
#line 5066 "AbstractDirectoryView.c"
		gboolean result_uncertain = FALSE;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 840 "../src/View/AbstractDirectoryView.vala"
		result_uncertain = TRUE;
#line 841 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_basename (file);
#line 841 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 841 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = g_content_type_guess (_tmp6_, NULL, (gsize) 0, &_tmp7_);
#line 841 "../src/View/AbstractDirectoryView.vala"
		result_uncertain = _tmp7_;
#line 841 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (content_type);
#line 841 "../src/View/AbstractDirectoryView.vala"
		content_type = _tmp8_;
#line 842 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = content_type;
#line 842 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = bool_to_string (result_uncertain);
#line 842 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 842 "../src/View/AbstractDirectoryView.vala"
		g_debug ("AbstractDirectoryView.vala:842: Guessed content type to be %s from nam" \
"e - result_uncertain %s", _tmp9_, _tmp11_);
#line 842 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp11_);
#line 5099 "AbstractDirectoryView.c"
	}
#line 847 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = content_type;
#line 847 "../src/View/AbstractDirectoryView.vala"
	if (_tmp12_ == NULL) {
#line 5105 "AbstractDirectoryView.c"
		gchar* _tmp13_;
#line 848 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = g_strdup (_ ("Cannot identify file type to open"));
#line 848 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (err_msg2);
#line 848 "../src/View/AbstractDirectoryView.vala"
		err_msg2 = _tmp13_;
#line 5113 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp14_;
		FilesDirectory* _tmp15_;
		FilesDirectory* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 849 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = self->slot;
#line 849 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp14_);
#line 849 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = _tmp15_;
#line 849 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = files_directory_get_can_open_files (_tmp16_);
#line 849 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = _tmp17_;
#line 849 "../src/View/AbstractDirectoryView.vala"
		if (!_tmp18_) {
#line 5132 "AbstractDirectoryView.c"
			FilesViewSlot* _tmp19_;
			FilesDirectory* _tmp20_;
			FilesDirectory* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = self->slot;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp19_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = _tmp20_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = files_directory_get_scheme (_tmp21_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = _tmp22_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = g_strdup_printf ("Cannot open files with this protocol (%s)", _tmp23_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (err_msg2);
#line 850 "../src/View/AbstractDirectoryView.vala"
			err_msg2 = _tmp24_;
#line 5155 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp25_ = FALSE;
			FilesViewSlot* _tmp26_;
			FilesDirectory* _tmp27_;
			FilesDirectory* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
#line 851 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = self->slot;
#line 851 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp26_);
#line 851 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = _tmp27_;
#line 851 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = files_directory_get_can_stream_files (_tmp28_);
#line 851 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = _tmp29_;
#line 851 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp30_) {
#line 5175 "AbstractDirectoryView.c"
				gboolean _tmp31_ = FALSE;
				const gchar* _tmp32_;
#line 852 "../src/View/AbstractDirectoryView.vala"
				_tmp32_ = content_type;
#line 852 "../src/View/AbstractDirectoryView.vala"
				if (string_contains (_tmp32_, "video")) {
#line 852 "../src/View/AbstractDirectoryView.vala"
					_tmp31_ = TRUE;
#line 5184 "AbstractDirectoryView.c"
				} else {
					const gchar* _tmp33_;
#line 852 "../src/View/AbstractDirectoryView.vala"
					_tmp33_ = content_type;
#line 852 "../src/View/AbstractDirectoryView.vala"
					_tmp31_ = string_contains (_tmp33_, "audio");
#line 5191 "AbstractDirectoryView.c"
				}
#line 852 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = _tmp31_;
#line 5195 "AbstractDirectoryView.c"
			} else {
#line 851 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = FALSE;
#line 5199 "AbstractDirectoryView.c"
			}
#line 851 "../src/View/AbstractDirectoryView.vala"
			if (_tmp25_) {
#line 5203 "AbstractDirectoryView.c"
				FilesViewSlot* _tmp34_;
				FilesDirectory* _tmp35_;
				FilesDirectory* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = self->slot;
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp34_);
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = _tmp35_;
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = files_directory_get_scheme (_tmp36_);
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = _tmp37_;
#line 854 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = g_strdup_printf ("Cannot stream from this protocol (%s)", _tmp38_);
#line 854 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (err_msg2);
#line 854 "../src/View/AbstractDirectoryView.vala"
				err_msg2 = _tmp39_;
#line 5226 "AbstractDirectoryView.c"
			}
		}
	}
#line 857 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = err_msg2;
#line 857 "../src/View/AbstractDirectoryView.vala"
	_tmp41_ = strlen (_tmp40_);
#line 857 "../src/View/AbstractDirectoryView.vala"
	_tmp42_ = _tmp41_;
#line 857 "../src/View/AbstractDirectoryView.vala"
	success = _tmp42_ < 1;
#line 858 "../src/View/AbstractDirectoryView.vala"
	if (!success) {
#line 858 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = show_error_dialog;
#line 5242 "AbstractDirectoryView.c"
	} else {
#line 858 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = FALSE;
#line 5246 "AbstractDirectoryView.c"
	}
#line 858 "../src/View/AbstractDirectoryView.vala"
	if (_tmp43_) {
#line 5250 "AbstractDirectoryView.c"
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		FilesViewWindow* _tmp46_;
		FilesViewWindow* _tmp47_;
		GraniteMessageDialog* _tmp48_;
		GraniteMessageDialog* _tmp49_;
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp44_ = err_msg1;
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp45_ = err_msg2;
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp46_ = files_abstract_directory_view_get_window (self);
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp47_ = _tmp46_;
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = pf_dialogs_show_warning_dialog (_tmp44_, _tmp45_, (GtkWindow*) _tmp47_);
#line 859 "../src/View/AbstractDirectoryView.vala"
		_tmp49_ = _tmp48_;
#line 859 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp49_);
#line 5271 "AbstractDirectoryView.c"
	}
#line 862 "../src/View/AbstractDirectoryView.vala"
	result = success;
#line 862 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (content_type);
#line 862 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (err_msg2);
#line 862 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (err_msg1);
#line 862 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 5283 "AbstractDirectoryView.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 865 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 865 "../src/View/AbstractDirectoryView.vala"
	return _data23_;
#line 5293 "AbstractDirectoryView.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 865 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 5303 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 865 "../src/View/AbstractDirectoryView.vala"
		self = _data23_->self;
#line 865 "../src/View/AbstractDirectoryView.vala"
		(_data23_->locations == NULL) ? NULL : (_data23_->locations = (_g_list_free__g_object_unref0_ (_data23_->locations), NULL));
#line 865 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 865 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block23Data, _data23_);
#line 5313 "AbstractDirectoryView.c"
	}
}

static void
___lambda107_ (Block23Data* _data23_,
               FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
#line 871 "../src/View/AbstractDirectoryView.vala"
	self = _data23_->self;
#line 871 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 872 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_display_target_uri (file);
#line 872 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 872 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 872 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = g_list_prepend (_data23_->locations, _tmp2_);
#line 872 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp1_);
#line 5339 "AbstractDirectoryView.c"
}

static void
____lambda107__gfunc (gconstpointer data,
                      gpointer self)
{
#line 871 "../src/View/AbstractDirectoryView.vala"
	___lambda107_ (self, (FilesFile*) data);
#line 5348 "AbstractDirectoryView.c"
}

static void
___lambda108_ (Block23Data* _data23_,
               FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 875 "../src/View/AbstractDirectoryView.vala"
	self = _data23_->self;
#line 875 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 876 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_location (file);
#line 876 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 876 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 876 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = g_list_prepend (_data23_->locations, _tmp2_);
#line 5371 "AbstractDirectoryView.c"
}

static void
____lambda108__gfunc (gconstpointer data,
                      gpointer self)
{
#line 875 "../src/View/AbstractDirectoryView.vala"
	___lambda108_ (self, (FilesFile*) data);
#line 5380 "AbstractDirectoryView.c"
}

static void
___lambda109_ (FilesAbstractDirectoryView* self,
               GObject* obj,
               GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 891 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5391 "AbstractDirectoryView.c"
	{
#line 893 "../src/View/AbstractDirectoryView.vala"
		marlin_file_operations_delete_finish (res, &_inner_error0_);
#line 893 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5397 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 892 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 895 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = e;
#line 895 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_->message;
#line 895 "../src/View/AbstractDirectoryView.vala"
		g_debug ("AbstractDirectoryView.vala:895: %s", _tmp1_);
#line 892 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5419 "AbstractDirectoryView.c"
	}
	__finally0:
#line 892 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 892 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 892 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 892 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5430 "AbstractDirectoryView.c"
	}
#line 898 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_trash_or_delete (self);
#line 5434 "AbstractDirectoryView.c"
}

static void
____lambda109__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 886 "../src/View/AbstractDirectoryView.vala"
	___lambda109_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 886 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5446 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_trash_or_delete_files (FilesAbstractDirectoryView* self,
                                                     GList* file_list,
                                                     gboolean delete_if_already_in_trash,
                                                     gboolean delete_immediately)
{
	Block23Data* _data23_;
	gboolean _tmp0_;
	FilesListModel* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GtkTreePath* _tmp4_;
	GList* _tmp5_;
	gboolean _tmp12_;
#line 865 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 865 "../src/View/AbstractDirectoryView.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 865 "../src/View/AbstractDirectoryView.vala"
	_data23_->_ref_count_ = 1;
#line 865 "../src/View/AbstractDirectoryView.vala"
	_data23_->self = g_object_ref (self);
#line 869 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = NULL;
#line 870 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_in_recent;
#line 870 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 871 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (file_list, ____lambda107__gfunc, _data23_);
#line 5479 "AbstractDirectoryView.c"
	} else {
#line 875 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (file_list, ____lambda108__gfunc, _data23_);
#line 5483 "AbstractDirectoryView.c"
	}
#line 880 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->model;
#line 880 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_first (file_list);
#line 880 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_->data;
#line 880 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_list_model_get_path_for_first_file (_tmp1_, (FilesFile*) _tmp3_);
#line 880 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
#line 880 "../src/View/AbstractDirectoryView.vala"
	self->priv->deleted_path = _tmp4_;
#line 882 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _data23_->locations;
#line 882 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_ != NULL) {
#line 5501 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp6_;
		FilesDirectory* _tmp7_;
		FilesDirectory* _tmp8_;
		GList* _tmp9_;
		FilesViewWindow* _tmp10_;
		FilesViewWindow* _tmp11_;
#line 883 "../src/View/AbstractDirectoryView.vala"
		_data23_->locations = g_list_reverse (_data23_->locations);
#line 885 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->slot;
#line 885 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp6_);
#line 885 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 885 "../src/View/AbstractDirectoryView.vala"
		files_directory_block_monitor (_tmp8_);
#line 886 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _data23_->locations;
#line 886 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_abstract_directory_view_get_window (self);
#line 886 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 886 "../src/View/AbstractDirectoryView.vala"
		marlin_file_operations_delete (_tmp9_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp11_) : NULL, !delete_immediately, NULL, ____lambda109__gasync_ready_callback, g_object_ref (self));
#line 5526 "AbstractDirectoryView.c"
	}
#line 904 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = self->priv->_in_recent;
#line 904 "../src/View/AbstractDirectoryView.vala"
	if (_tmp12_) {
#line 5532 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp13_;
#line 905 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = self->slot;
#line 905 "../src/View/AbstractDirectoryView.vala"
		files_abstract_slot_reload ((FilesAbstractSlot*) _tmp13_, FALSE);
#line 5538 "AbstractDirectoryView.c"
	}
#line 865 "../src/View/AbstractDirectoryView.vala"
	block23_data_unref (_data23_);
#line 865 "../src/View/AbstractDirectoryView.vala"
	_data23_ = NULL;
#line 5544 "AbstractDirectoryView.c"
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 911 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 911 "../src/View/AbstractDirectoryView.vala"
	return _data24_;
#line 5554 "AbstractDirectoryView.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 911 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 5564 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 911 "../src/View/AbstractDirectoryView.vala"
		self = _data24_->self;
#line 911 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data24_->file);
#line 911 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 911 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block24Data, _data24_);
#line 5574 "AbstractDirectoryView.c"
	}
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 913 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 913 "../src/View/AbstractDirectoryView.vala"
	return _data25_;
#line 5585 "AbstractDirectoryView.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 913 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 5595 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 913 "../src/View/AbstractDirectoryView.vala"
		self = _data25_->_data24_->self;
#line 913 "../src/View/AbstractDirectoryView.vala"
		block24_data_unref (_data25_->_data24_);
#line 913 "../src/View/AbstractDirectoryView.vala"
		_data25_->_data24_ = NULL;
#line 913 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block25Data, _data25_);
#line 5605 "AbstractDirectoryView.c"
	}
}

static void
___lambda58_ (Block25Data* _data25_)
{
	Block24Data* _data24_;
	FilesAbstractDirectoryView* self;
	FilesListModel* _tmp0_;
#line 916 "../src/View/AbstractDirectoryView.vala"
	_data24_ = _data25_->_data24_;
#line 916 "../src/View/AbstractDirectoryView.vala"
	self = _data24_->self;
#line 917 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 917 "../src/View/AbstractDirectoryView.vala"
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data25_->model_resorted);
#line 918 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_add_gof_file_to_selection (self, _data24_->file);
#line 5625 "AbstractDirectoryView.c"
}

static void
____lambda58__gtk_tree_model_rows_reordered (GtkTreeModel* _sender,
                                             GtkTreePath* path,
                                             GtkTreeIter* iter,
                                             gint* new_order,
                                             gpointer self)
{
#line 916 "../src/View/AbstractDirectoryView.vala"
	___lambda58_ (self);
#line 5637 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_add_file (FilesAbstractDirectoryView* self,
                                        FilesFile* file,
                                        FilesDirectory* dir,
                                        gboolean is_internal)
{
	Block24Data* _data24_;
	FilesFile* _tmp0_;
	FilesListModel* _tmp1_;
#line 911 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 911 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 911 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_data24_->_ref_count_ = 1;
#line 911 "../src/View/AbstractDirectoryView.vala"
	_data24_->self = g_object_ref (self);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data24_->file);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_data24_->file = _tmp0_;
#line 912 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->model;
#line 912 "../src/View/AbstractDirectoryView.vala"
	files_list_model_insert_sorted (_tmp1_, _data24_->file, dir);
#line 913 "../src/View/AbstractDirectoryView.vala"
	if (is_internal) {
#line 5673 "AbstractDirectoryView.c"
		Block25Data* _data25_;
		FilesListModel* _tmp2_;
		gulong _tmp3_;
#line 913 "../src/View/AbstractDirectoryView.vala"
		_data25_ = g_slice_new0 (Block25Data);
#line 913 "../src/View/AbstractDirectoryView.vala"
		_data25_->_ref_count_ = 1;
#line 913 "../src/View/AbstractDirectoryView.vala"
		_data25_->_data24_ = block24_data_ref (_data24_);
#line 915 "../src/View/AbstractDirectoryView.vala"
		_data25_->model_resorted = (gulong) 0;
#line 916 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->model;
#line 916 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = g_signal_connect_data ((GtkTreeModel*) _tmp2_, "rows-reordered", (GCallback) ____lambda58__gtk_tree_model_rows_reordered, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 916 "../src/View/AbstractDirectoryView.vala"
		_data25_->model_resorted = _tmp3_;
#line 913 "../src/View/AbstractDirectoryView.vala"
		block25_data_unref (_data25_);
#line 913 "../src/View/AbstractDirectoryView.vala"
		_data25_ = NULL;
#line 5695 "AbstractDirectoryView.c"
	}
#line 911 "../src/View/AbstractDirectoryView.vala"
	block24_data_unref (_data24_);
#line 911 "../src/View/AbstractDirectoryView.vala"
	_data24_ = NULL;
#line 5701 "AbstractDirectoryView.c"
}

static gboolean
___lambda59_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 928 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->signal_free_space_change) {
#line 5710 "AbstractDirectoryView.c"
		FilesViewWindow* _tmp0_;
		FilesViewWindow* _tmp1_;
#line 929 "../src/View/AbstractDirectoryView.vala"
		self->priv->add_remove_file_timeout_id = (guint) 0;
#line 930 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_abstract_directory_view_get_window (self);
#line 930 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_;
#line 930 "../src/View/AbstractDirectoryView.vala"
		g_signal_emit_by_name (_tmp1_, "free-space-change");
#line 931 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 931 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 5725 "AbstractDirectoryView.c"
	} else {
#line 933 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = TRUE;
#line 934 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 934 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 5733 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda59__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda59_ ((FilesAbstractDirectoryView*) self);
#line 927 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 5744 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_handle_free_space_change (FilesAbstractDirectoryView* self)
{
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
#line 923 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 923 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_window (self);
#line 923 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 923 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "window != null");
#line 925 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->add_remove_file_timeout_id == ((guint) 0)) {
#line 926 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = FALSE;
#line 927 "../src/View/AbstractDirectoryView.vala"
		self->priv->add_remove_file_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda59__gsource_func, g_object_ref (self), g_object_unref);
#line 5766 "AbstractDirectoryView.c"
	} else {
#line 938 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = FALSE;
#line 5770 "AbstractDirectoryView.c"
	}
}

static void
__lambda116_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 956 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5782 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 958 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_file_finish (res, &_inner_error0_);
#line 958 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 958 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5792 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 959 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 957 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 5799 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 957 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 957 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 961 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 961 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 961 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:961: %s", _tmp2_);
#line 957 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5819 "AbstractDirectoryView.c"
	}
	__finally0:
#line 957 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 957 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 957 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 957 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5830 "AbstractDirectoryView.c"
	}
}

static void
___lambda116__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 949 "../src/View/AbstractDirectoryView.vala"
	__lambda116_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 949 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5843 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_empty_file (FilesAbstractDirectoryView* self,
                                              const gchar* parent_uri)
{
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
#line 942 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 943 "../src/View/AbstractDirectoryView.vala"
	if (parent_uri == NULL) {
#line 5857 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp0_;
		FilesDirectory* _tmp1_;
		FilesDirectory* _tmp2_;
		FilesFile* _tmp3_;
		FilesFile* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->slot;
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_directory_get_file (_tmp2_);
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_uri (_tmp4_);
#line 944 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 944 "../src/View/AbstractDirectoryView.vala"
		parent_uri = _tmp6_;
#line 5881 "AbstractDirectoryView.c"
	}
#line 948 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 948 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 948 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 948 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp9_);
#line 949 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_file ((GtkWidget*) self, parent_uri, NULL, NULL, 0, NULL, ___lambda116__gasync_ready_callback, g_object_ref (self));
#line 5893 "AbstractDirectoryView.c"
}

static void
__lambda112_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 970 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5904 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 972 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_folder_finish (res, &_inner_error0_);
#line 972 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 972 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5914 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 973 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 971 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 5921 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 971 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 971 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 975 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:975: %s", _tmp2_);
#line 971 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5941 "AbstractDirectoryView.c"
	}
	__finally0:
#line 971 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 971 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 971 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 971 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5952 "AbstractDirectoryView.c"
	}
}

static void
___lambda112__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 970 "../src/View/AbstractDirectoryView.vala"
	__lambda112_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 970 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5965 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_empty_folder (FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	FilesViewSlot* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 967 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 969 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 969 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 969 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 969 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp2_);
#line 970 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->slot;
#line 970 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp3_);
#line 970 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 970 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_folder ((GtkWidget*) self, _tmp5_, NULL, ___lambda112__gasync_ready_callback, g_object_ref (self));
#line 5995 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_after_new_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                FilesFile* file,
                                                                                gboolean is_internal,
                                                                                gpointer self)
{
#line 981 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_new_file_added ((FilesAbstractDirectoryView*) self, file);
#line 6006 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_after_new_file_added (FilesAbstractDirectoryView* self,
                                                    FilesFile* file)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	guint _tmp3_;
#line 980 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 981 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 981 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 981 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 981 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp3_, NULL, FALSE);
#line 981 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_abstract_directory_view_after_new_file_added_files_directory_file_added, self);
#line 982 "../src/View/AbstractDirectoryView.vala"
	if (file != NULL) {
#line 983 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_rename_file (self, file);
#line 6033 "AbstractDirectoryView.c"
	}
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 987 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 987 "../src/View/AbstractDirectoryView.vala"
	return _data26_;
#line 6044 "AbstractDirectoryView.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 987 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 6054 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 987 "../src/View/AbstractDirectoryView.vala"
		self = _data26_->self;
#line 987 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data26_->file_to_rename);
#line 987 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 987 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block26Data, _data26_);
#line 6064 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda105_ (Block26Data* _data26_)
{
	FilesAbstractDirectoryView* self;
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 996 "../src/View/AbstractDirectoryView.vala"
	self = _data26_->self;
#line 997 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 997 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_sort_pending (_tmp0_);
#line 997 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 997 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 998 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 998 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 6090 "AbstractDirectoryView.c"
	} else {
#line 1000 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_start_renaming_file (self, _data26_->file_to_rename);
#line 1001 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 1001 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 6098 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda105__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda105_ (self);
#line 996 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6109 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_rename_file (FilesAbstractDirectoryView* self,
                                           FilesFile* file_to_rename)
{
	Block26Data* _data26_;
	FilesFile* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
#line 987 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 987 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file_to_rename != NULL);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_data26_ = g_slice_new0 (Block26Data);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_data26_->_ref_count_ = 1;
#line 987 "../src/View/AbstractDirectoryView.vala"
	_data26_->self = g_object_ref (self);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file_to_rename);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data26_->file_to_rename);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_data26_->file_to_rename = _tmp0_;
#line 988 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 988 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 6140 "AbstractDirectoryView.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 989 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_file_get_basename (_data26_->file_to_rename);
#line 989 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 989 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:989: already renaming %s", _tmp3_);
#line 990 "../src/View/AbstractDirectoryView.vala"
		block26_data_unref (_data26_);
#line 990 "../src/View/AbstractDirectoryView.vala"
		_data26_ = NULL;
#line 990 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6155 "AbstractDirectoryView.c"
	}
#line 994 "../src/View/AbstractDirectoryView.vala"
	if (self->is_writable) {
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = TRUE;
#line 6161 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp5_;
		FilesDirectory* _tmp6_;
		FilesDirectory* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->slot;
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_directory_get_is_local (_tmp7_);
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 994 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = !_tmp9_;
#line 6180 "AbstractDirectoryView.c"
	}
#line 994 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 996 "../src/View/AbstractDirectoryView.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ____lambda105__gsource_func, block26_data_ref (_data26_), block26_data_unref);
#line 6186 "AbstractDirectoryView.c"
	} else {
#line 1006 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:1006: You do not have permission to rename " \
"this file");
#line 6190 "AbstractDirectoryView.c"
	}
#line 987 "../src/View/AbstractDirectoryView.vala"
	block26_data_unref (_data26_);
#line 987 "../src/View/AbstractDirectoryView.vala"
	_data26_ = NULL;
#line 6196 "AbstractDirectoryView.c"
}

/** File operation callbacks */
void
files_abstract_directory_view_create_file_done (GFile* new_file,
                                                FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
#line 1012 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1013 "../src/View/AbstractDirectoryView.vala"
	if (new_file == NULL) {
#line 1014 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6213 "AbstractDirectoryView.c"
	}
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1018 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp2_, "file-added", (GCallback) _files_abstract_directory_view_after_new_file_added_files_directory_file_added, self, G_CONNECT_AFTER);
#line 1019 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_directory_monitor (self);
#line 6225 "AbstractDirectoryView.c"
}

static gboolean
__lambda110_ (FilesAbstractDirectoryView* self)
{
	GtkTreePath* _tmp0_;
	gboolean result;
#line 1025 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->deleted_path;
#line 1025 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, _tmp0_, FALSE, FALSE, FALSE);
#line 1026 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_directory_monitor (self);
#line 1027 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1027 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6243 "AbstractDirectoryView.c"
}

static gboolean
___lambda110__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda110_ ((FilesAbstractDirectoryView*) self);
#line 1024 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6253 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_after_trash_or_delete (FilesAbstractDirectoryView* self)
{
#line 1022 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1024 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda110__gsource_func, g_object_ref (self), g_object_unref);
#line 6263 "AbstractDirectoryView.c"
}

static gboolean
__lambda111_ (FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gboolean result;
#line 1036 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1036 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1036 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1036 "../src/View/AbstractDirectoryView.vala"
	files_directory_unblock_monitor (_tmp2_);
#line 1037 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1037 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6285 "AbstractDirectoryView.c"
}

static gboolean
___lambda111__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda111_ ((FilesAbstractDirectoryView*) self);
#line 1035 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6295 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_unblock_directory_monitor (FilesAbstractDirectoryView* self)
{
#line 1032 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1035 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_LOW, ___lambda111__gsource_func, g_object_ref (self), g_object_unref);
#line 6305 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_trash_or_delete_selected_files (FilesAbstractDirectoryView* self,
                                                              gboolean delete_immediately)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 1041 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1046 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1046 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1046 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1047 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = selection;
#line 1047 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 6328 "AbstractDirectoryView.c"
		GList* _tmp3_;
#line 1048 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = selection;
#line 1048 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_trash_or_delete_files (self, _tmp3_, TRUE, delete_immediately);
#line 6334 "AbstractDirectoryView.c"
	}
#line 1041 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6338 "AbstractDirectoryView.c"
}

/** Selection actions */
static void
files_abstract_directory_view_on_selection_action_view_in_location (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* param)
{
#line 1057 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1057 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1058 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_view_selected_file (self);
#line 6353 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_view_selected_file (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 1061 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1062 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1062 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1063 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6369 "AbstractDirectoryView.c"
	}
#line 1066 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 6373 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 1066 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp1_;
#line 1066 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 6381 "AbstractDirectoryView.c"
			FilesFile* _tmp2_;
			FilesFile* file = NULL;
#line 1066 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1066 "../src/View/AbstractDirectoryView.vala"
			file = _tmp2_;
#line 6388 "AbstractDirectoryView.c"
			{
				GFile* loc = NULL;
				FilesFile* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = file;
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = files_file_get_display_target_uri (_tmp3_);
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = _tmp6_;
#line 1067 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp5_);
#line 1067 "../src/View/AbstractDirectoryView.vala"
				loc = _tmp7_;
#line 1068 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = loc;
#line 1068 "../src/View/AbstractDirectoryView.vala"
				g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp8_, FILES_OPEN_FLAG_NEW_TAB, TRUE);
#line 1066 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (loc);
#line 1066 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 6419 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_selection_action_forget (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1072 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1072 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1073 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_forget_selected_file (self);
#line 6436 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_forget_selected_file (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1076 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1077 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1078 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6452 "AbstractDirectoryView.c"
	}
	{
		GList* _tmp1_;
#line 1082 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->selected_files;
#line 6458 "AbstractDirectoryView.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 1082 "../src/View/AbstractDirectoryView.vala"
			file_collection = _tmp1_;
#line 1082 "../src/View/AbstractDirectoryView.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 6466 "AbstractDirectoryView.c"
				FilesFile* _tmp2_;
				FilesFile* file = NULL;
#line 1082 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1082 "../src/View/AbstractDirectoryView.vala"
				file = _tmp2_;
#line 6473 "AbstractDirectoryView.c"
				{
					GtkRecentManager* _tmp3_;
					FilesFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 1083 "../src/View/AbstractDirectoryView.vala"
					_tmp3_ = self->recent;
#line 1083 "../src/View/AbstractDirectoryView.vala"
					_tmp4_ = file;
#line 1083 "../src/View/AbstractDirectoryView.vala"
					_tmp5_ = files_file_get_display_target_uri (_tmp4_);
#line 1083 "../src/View/AbstractDirectoryView.vala"
					_tmp6_ = _tmp5_;
#line 1083 "../src/View/AbstractDirectoryView.vala"
					gtk_recent_manager_remove_item (_tmp3_, _tmp6_, &_inner_error0_);
#line 1083 "../src/View/AbstractDirectoryView.vala"
					_g_free0 (_tmp6_);
#line 1083 "../src/View/AbstractDirectoryView.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1083 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (file);
#line 6495 "AbstractDirectoryView.c"
						goto __catch0_g_error;
					}
#line 1082 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (file);
#line 6500 "AbstractDirectoryView.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 1081 "../src/View/AbstractDirectoryView.vala"
		err = _inner_error0_;
#line 1081 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 1086 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = err;
#line 1086 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_->message;
#line 1086 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:1086: %s", _tmp8_);
#line 1081 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (err);
#line 6523 "AbstractDirectoryView.c"
	}
	__finally0:
#line 1081 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1081 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1081 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 1081 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6534 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_selection_action_rename (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1090 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1090 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1091 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_rename_selection (self);
#line 6549 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_rename_selection (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 1094 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1095 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1095 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1096 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6566 "AbstractDirectoryView.c"
	}
#line 1099 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 1099 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_->next;
#line 1099 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 6574 "AbstractDirectoryView.c"
		FilesRenamerDialog* rename_dialog = NULL;
		GList* _tmp3_;
		FilesViewSlot* _tmp4_;
		FilesViewWindow* _tmp5_;
		FilesViewWindow* _tmp6_;
		GtkWindow* _tmp7_;
		FilesRenamerDialog* _tmp8_ = NULL;
		FilesRenamerDialog* _tmp9_;
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->selected_files;
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->slot;
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_view_slot_get_window (_tmp4_);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _g_object_ref0 ((GtkWindow*) _tmp6_);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_renamer_dialog_new (_tmp3_, NULL);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp8_, _tmp7_);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp7_);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp8_);
#line 1100 "../src/View/AbstractDirectoryView.vala"
		rename_dialog = _tmp8_;
#line 1103 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = rename_dialog;
#line 1103 "../src/View/AbstractDirectoryView.vala"
		gtk_window_present ((GtkWindow*) _tmp9_);
#line 1099 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (rename_dialog);
#line 6609 "AbstractDirectoryView.c"
	} else {
		GList* _tmp10_;
		gconstpointer _tmp11_;
#line 1105 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->selected_files;
#line 1105 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->data;
#line 1105 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_rename_file (self, (FilesFile*) _tmp11_);
#line 6619 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_selection_action_cut (FilesAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	FilesClipboardManager* _tmp2_;
#line 1109 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1109 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1110 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1110 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1110 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1111 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->clipboard;
#line 1111 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_cut_files (_tmp2_, selection);
#line 1109 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6648 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_trash (FilesAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param)
{
#line 1114 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1114 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1115 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_trash_or_delete_selected_files (self, files_is_admin ());
#line 6662 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_delete (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1118 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1118 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1119 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_trash_or_delete_selected_files (self, TRUE);
#line 6676 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_restore (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	FilesViewWindow* _tmp2_;
	FilesViewWindow* _tmp3_;
#line 1122 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1122 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1123 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1123 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1123 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1124 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_window (self);
#line 1124 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1124 "../src/View/AbstractDirectoryView.vala"
	files_file_utils_restore_files_from_trash (selection, (GtkWidget*) _tmp3_);
#line 1122 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6707 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_executable (FilesAbstractDirectoryView* self,
                                                                   GSimpleAction* action,
                                                                   GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	FilesFile* file = NULL;
	gconstpointer _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1128 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1128 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1129 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1129 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp0_;
#line 1130 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = selection->data;
#line 1130 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = (FilesFile*) _tmp1_;
#line 1130 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, FILES_TYPE_FILE) ? ((FilesFile*) _tmp2_) : NULL);
#line 1130 "../src/View/AbstractDirectoryView.vala"
	file = _tmp3_;
#line 6738 "AbstractDirectoryView.c"
	{
#line 1132 "../src/View/AbstractDirectoryView.vala"
		files_file_execute (file, NULL, &_inner_error0_);
#line 1132 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6744 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		FilesViewWindow* _tmp6_;
		FilesViewWindow* _tmp7_;
		GraniteMessageDialog* _tmp8_;
		GraniteMessageDialog* _tmp9_;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = e;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_->message;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_abstract_directory_view_get_window (self);
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp5_, (GtkWindow*) _tmp7_);
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp9_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 6778 "AbstractDirectoryView.c"
	}
	__finally0:
#line 1131 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 1131 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6793 "AbstractDirectoryView.c"
	}
#line 1128 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 1128 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6799 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_default (FilesAbstractDirectoryView* self,
                                                                     GSimpleAction* action,
                                                                     GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 1138 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1138 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1139 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1139 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1139 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_APP, _tmp1_);
#line 1139 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 6821 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_app (FilesAbstractDirectoryView* self,
                                                                 GSimpleAction* action,
                                                                 GVariant* param)
{
	GList* _tmp0_;
	gconstpointer _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 1142 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1142 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1143 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 1143 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_list_nth_data (_tmp0_, (guint) g_variant_get_uint32 (param));
#line 1143 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_files_for_action (self);
#line 1143 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1143 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_files_with (self, (GAppInfo*) _tmp1_, _tmp3_);
#line 1143 "../src/View/AbstractDirectoryView.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
#line 6849 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_other_app (FilesAbstractDirectoryView* self)
{
	GList* selection = NULL;
	GList* _tmp0_;
	FilesFile* file = NULL;
	gconstpointer _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
#line 1146 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1147 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1147 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp0_;
#line 1148 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = selection->data;
#line 1148 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = (FilesFile*) _tmp1_;
#line 1148 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, FILES_TYPE_FILE) ? ((FilesFile*) _tmp2_) : NULL);
#line 1148 "../src/View/AbstractDirectoryView.vala"
	file = _tmp3_;
#line 1149 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_file (self, file, NULL, NULL);
#line 1146 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 1146 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6881 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_bookmark (FilesAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param)
{
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
	GFile* location = NULL;
	GList* _tmp2_;
	FilesViewWindow* _tmp14_;
	FilesViewWindow* _tmp15_;
	GFile* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 1152 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1152 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1152 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_window (self);
#line 1152 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1152 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "window != null");
#line 1154 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->selected_files;
#line 1154 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 6912 "AbstractDirectoryView.c"
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 1155 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->selected_files;
#line 1155 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_->data;
#line 1155 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_target_location ((FilesFile*) _tmp4_);
#line 1155 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1155 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 1155 "../src/View/AbstractDirectoryView.vala"
		location = _tmp6_;
#line 6929 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesDirectory* _tmp9_;
		FilesFile* _tmp10_;
		FilesFile* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->slot;
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_directory_get_file (_tmp9_);
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = files_file_get_target_location (_tmp11_);
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1157 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 1157 "../src/View/AbstractDirectoryView.vala"
		location = _tmp13_;
#line 6956 "AbstractDirectoryView.c"
	}
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = files_abstract_directory_view_get_window (self);
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _tmp14_;
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = location;
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = g_file_get_uri (_tmp16_);
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = _tmp17_;
#line 1160 "../src/View/AbstractDirectoryView.vala"
	files_view_window_bookmark_uri (_tmp15_, _tmp18_, "");
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp18_);
#line 1152 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (location);
#line 6974 "AbstractDirectoryView.c"
}

/** Background actions */
static void
files_abstract_directory_view_change_state_show_hidden (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action)
{
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
	FilesViewWindow* _tmp2_;
	FilesViewWindow* _tmp3_;
#line 1165 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1165 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1165 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_window (self);
#line 1165 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1165 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "window != null");
#line 1166 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_window (self);
#line 1166 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1166 "../src/View/AbstractDirectoryView.vala"
	files_view_window_change_state_show_hidden (_tmp3_, action);
#line 7002 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_new (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 1170 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label0 = 0;
#line 1170 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label1 = 0;
#line 1169 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1169 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1170 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("FOLDER")))) {
#line 1170 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7031 "AbstractDirectoryView.c"
			default:
			{
#line 1172 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_folder (self);
#line 1173 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7038 "AbstractDirectoryView.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("FILE")))) {
#line 1170 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7044 "AbstractDirectoryView.c"
			default:
			{
#line 1176 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_file (self, NULL);
#line 1177 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7051 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1170 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7057 "AbstractDirectoryView.c"
			default:
			{
#line 1180 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7062 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_background_action_create_from (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param)
{
	gint index = 0;
	const gchar* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
#line 1184 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1184 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1185 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1185 "../src/View/AbstractDirectoryView.vala"
	index = atoi (_tmp0_);
#line 1186 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_templates;
#line 1186 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) index);
#line 1186 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_create_from_template (self, (GFile*) _tmp2_);
#line 7091 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_sort_by_changed (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* val)
{
	const gchar* _tmp0_ = NULL;
#line 1189 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1189 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1190 "../src/View/AbstractDirectoryView.vala"
	if (val != NULL) {
#line 7106 "AbstractDirectoryView.c"
		const gchar* _tmp1_;
#line 1190 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_variant_get_string (val, NULL);
#line 1190 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_;
#line 7112 "AbstractDirectoryView.c"
	} else {
#line 1190 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = NULL;
#line 7116 "AbstractDirectoryView.c"
	}
#line 1190 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_sort (self, _tmp0_, FALSE);
#line 7120 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_reverse_changed (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* val)
{
#line 1193 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1193 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1194 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_sort (self, NULL, TRUE);
#line 7134 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_folders_first_changed (FilesAbstractDirectoryView* self,
                                                                          GSimpleAction* action,
                                                                          GVariant* val)
{
	FilesPreferences* prefs = NULL;
	FilesPreferences* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1197 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1197 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1198 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_default ();
#line 1198 "../src/View/AbstractDirectoryView.vala"
	prefs = _tmp0_;
#line 1199 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_preferences_get_sort_directories_first (prefs);
#line 1199 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1199 "../src/View/AbstractDirectoryView.vala"
	files_preferences_set_sort_directories_first (prefs, !_tmp2_);
#line 1197 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (prefs);
#line 7162 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_sort (FilesAbstractDirectoryView* self,
                                        const gchar* col_name,
                                        gboolean reverse)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FilesListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
#line 1202 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1206 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1206 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
#line 1206 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = _tmp1_;
#line 1206 "../src/View/AbstractDirectoryView.vala"
	sort_order = _tmp2_;
#line 1206 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 7188 "AbstractDirectoryView.c"
		FilesListModel* _tmp4_;
#line 1207 "../src/View/AbstractDirectoryView.vala"
		if (col_name != NULL) {
#line 1208 "../src/View/AbstractDirectoryView.vala"
			sort_column_id = (gint) files_list_model_column_id_from_string (col_name);
#line 7194 "AbstractDirectoryView.c"
		}
#line 1211 "../src/View/AbstractDirectoryView.vala"
		if (reverse) {
#line 1212 "../src/View/AbstractDirectoryView.vala"
			if (sort_order == GTK_SORT_ASCENDING) {
#line 1213 "../src/View/AbstractDirectoryView.vala"
				sort_order = GTK_SORT_DESCENDING;
#line 7202 "AbstractDirectoryView.c"
			} else {
#line 1215 "../src/View/AbstractDirectoryView.vala"
				sort_order = GTK_SORT_ASCENDING;
#line 7206 "AbstractDirectoryView.c"
			}
		}
#line 1219 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->model;
#line 1219 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp4_, sort_column_id, sort_order);
#line 7213 "AbstractDirectoryView.c"
	} else {
#line 1221 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:1221: Set Sort: The model is unsorted - thi" \
"s should not happen");
#line 7217 "AbstractDirectoryView.c"
	}
}

/** Common actions */
static void
_vala_XdpParent_free (XdpParent* self)
{
#line 1230 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (xdp_parent_get_type (), self);
#line 7227 "AbstractDirectoryView.c"
}

static XdpParent*
_vala_XdpParent_copy (XdpParent* self)
{
#line 1230 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (xdp_parent_get_type (), self);
#line 7235 "AbstractDirectoryView.c"
}

static gpointer
__vala_XdpParent_copy0 (gpointer self)
{
#line 1230 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_XdpParent_copy (self) : NULL;
#line 7243 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_action_set_wallpaper (FilesAbstractDirectoryView* self,
                                                    GSimpleAction* action,
                                                    GVariant* param)
{
	FilesFile* file = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	FilesFile* _tmp3_;
	FilesFile* _tmp4_;
	GtkWindow* active_window = NULL;
	GtkWidget* _tmp5_;
	GtkWindow* _tmp6_;
	XdpParent* _tmp7_ = NULL;
	GtkWindow* _tmp8_;
	XdpParent* parent = NULL;
	XdpParent* _tmp11_;
	XdpPortal* portal = NULL;
	XdpPortal* _tmp12_;
	FilesFile* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
#line 1226 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1227 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1227 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1227 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
#line 1227 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 ((FilesFile*) _tmp2_);
#line 1227 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1227 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 1227 "../src/View/AbstractDirectoryView.vala"
	file = _tmp4_;
#line 1229 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 1229 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_window_get_type (), GtkWindow));
#line 1229 "../src/View/AbstractDirectoryView.vala"
	active_window = _tmp6_;
#line 1230 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = active_window;
#line 1230 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_ != NULL) {
#line 7297 "AbstractDirectoryView.c"
		GtkWindow* _tmp9_;
		XdpParent* _tmp10_;
#line 1230 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = active_window;
#line 1230 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = xdp_parent_new_gtk (_tmp9_);
#line 1230 "../src/View/AbstractDirectoryView.vala"
		__vala_XdpParent_free0 (_tmp7_);
#line 1230 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp10_;
#line 7308 "AbstractDirectoryView.c"
	} else {
#line 1230 "../src/View/AbstractDirectoryView.vala"
		__vala_XdpParent_free0 (_tmp7_);
#line 1230 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = NULL;
#line 7314 "AbstractDirectoryView.c"
	}
#line 1230 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = __vala_XdpParent_copy0 (_tmp7_);
#line 1230 "../src/View/AbstractDirectoryView.vala"
	parent = _tmp11_;
#line 1232 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = xdp_portal_new ();
#line 1232 "../src/View/AbstractDirectoryView.vala"
	portal = _tmp12_;
#line 1233 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = file;
#line 1233 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = files_file_get_uri (_tmp13_);
#line 1233 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _tmp14_;
#line 1233 "../src/View/AbstractDirectoryView.vala"
	xdp_portal_set_wallpaper (portal, parent, _tmp15_, XDP_WALLPAPER_FLAG_NONE, NULL, NULL, NULL);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (portal);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	__vala_XdpParent_free0 (parent);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	__vala_XdpParent_free0 (_tmp7_);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (active_window);
#line 1226 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 7342 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_open_in (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 1239 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label0 = 0;
#line 1239 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label1 = 0;
#line 1236 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1236 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1237 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 1237 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = NULL;
#line 1239 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1239 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1239 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 1239 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("TAB")))) {
#line 1239 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7375 "AbstractDirectoryView.c"
			default:
			{
				GList* _tmp4_;
				GList* _tmp5_;
#line 1241 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = files_abstract_directory_view_get_files_for_action (self);
#line 1241 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 1241 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp5_);
#line 1241 "../src/View/AbstractDirectoryView.vala"
				(_tmp5_ == NULL) ? NULL : (_tmp5_ = (_g_list_free__g_object_unref0_ (_tmp5_), NULL));
#line 1242 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7390 "AbstractDirectoryView.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("WINDOW")))) {
#line 1239 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7396 "AbstractDirectoryView.c"
			default:
			{
				GList* _tmp6_;
				GList* _tmp7_;
#line 1245 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = files_abstract_directory_view_get_files_for_action (self);
#line 1245 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = _tmp6_;
#line 1245 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_WINDOW, _tmp7_);
#line 1245 "../src/View/AbstractDirectoryView.vala"
				(_tmp7_ == NULL) ? NULL : (_tmp7_ = (_g_list_free__g_object_unref0_ (_tmp7_), NULL));
#line 1246 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7411 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1239 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7417 "AbstractDirectoryView.c"
			default:
			{
#line 1249 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7422 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_common_action_properties (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
	FilesViewWindow* _tmp2_;
	FilesViewWindow* _tmp3_;
	FilesViewPropertiesWindow* _tmp4_;
	FilesViewPropertiesWindow* _tmp5_;
#line 1253 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1253 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_window (self);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_view_properties_window_new (_tmp1_, self, (GtkWindow*) _tmp3_);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp4_);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 1254 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp5_);
#line 1254 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 7461 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_copy_link (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
	FilesClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 1257 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1257 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1258 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1258 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_files_for_action (self);
#line 1258 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1258 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
#line 1258 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1258 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_copy_link_files (_tmp0_, _tmp4_);
#line 1258 "../src/View/AbstractDirectoryView.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 1258 "../src/View/AbstractDirectoryView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 7494 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_copy (FilesAbstractDirectoryView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param)
{
	FilesClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 1261 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1261 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1262 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1262 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_files_for_action (self);
#line 1262 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1262 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
#line 1262 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1262 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_copy_files (_tmp0_, _tmp4_);
#line 1262 "../src/View/AbstractDirectoryView.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 1262 "../src/View/AbstractDirectoryView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 7527 "AbstractDirectoryView.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 1266 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 1266 "../src/View/AbstractDirectoryView.vala"
	return _data27_;
#line 7537 "AbstractDirectoryView.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 1266 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 7547 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		self = _data27_->self;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data27_->target);
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1266 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block27Data, _data27_);
#line 7557 "AbstractDirectoryView.c"
	}
}

static void
___lambda119_ (Block27Data* _data27_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	FilesClipboardManager* _tmp0_;
	GFile* _tmp1_;
#line 1268 "../src/View/AbstractDirectoryView.vala"
	self = _data27_->self;
#line 1268 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 1269 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1269 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_paste_files_finish (_tmp0_, res);
#line 1270 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data27_->target;
#line 1270 "../src/View/AbstractDirectoryView.vala"
	if (g_file_has_uri_scheme (_tmp1_, "trash")) {
#line 1272 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_after_trash_or_delete (self);
#line 7583 "AbstractDirectoryView.c"
	}
}

static void
____lambda119__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1268 "../src/View/AbstractDirectoryView.vala"
	___lambda119_ (self, source_object, res);
#line 1268 "../src/View/AbstractDirectoryView.vala"
	block27_data_unref (self);
#line 7596 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_paste (FilesAbstractDirectoryView* self,
                                                      GSimpleAction* action,
                                                      GVariant* param)
{
	gboolean _tmp0_ = FALSE;
	FilesClipboardManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1265 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1265 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1266 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->clipboard;
#line 1266 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_clipboard_manager_get_can_paste (_tmp1_);
#line 1266 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1266 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 7620 "AbstractDirectoryView.c"
		gboolean _tmp4_ = FALSE;
		FilesClipboardManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->clipboard;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_clipboard_manager_get_files_linked (_tmp5_);
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_) {
#line 1266 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = self->priv->in_trash;
#line 7635 "AbstractDirectoryView.c"
		} else {
#line 1266 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = FALSE;
#line 7639 "AbstractDirectoryView.c"
		}
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp4_;
#line 7643 "AbstractDirectoryView.c"
	} else {
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 7647 "AbstractDirectoryView.c"
	}
#line 1266 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 7651 "AbstractDirectoryView.c"
		Block27Data* _data27_;
		FilesViewSlot* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		FilesClipboardManager* _tmp12_;
		GFile* _tmp13_;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_data27_ = g_slice_new0 (Block27Data);
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_data27_->_ref_count_ = 1;
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_data27_->self = g_object_ref (self);
#line 1267 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->slot;
#line 1267 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp8_);
#line 1267 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1267 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1267 "../src/View/AbstractDirectoryView.vala"
		_data27_->target = _tmp11_;
#line 1268 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->priv->clipboard;
#line 1268 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _data27_->target;
#line 1268 "../src/View/AbstractDirectoryView.vala"
		files_clipboard_manager_paste_files (_tmp12_, _tmp13_, G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, ____lambda119__gasync_ready_callback, block27_data_ref (_data27_));
#line 1266 "../src/View/AbstractDirectoryView.vala"
		block27_data_unref (_data27_);
#line 1266 "../src/View/AbstractDirectoryView.vala"
		_data27_ = NULL;
#line 7685 "AbstractDirectoryView.c"
	}
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 1281 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 1281 "../src/View/AbstractDirectoryView.vala"
	return _data28_;
#line 7696 "AbstractDirectoryView.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 7706 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		self = _data28_->self;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data28_->target);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block28Data, _data28_);
#line 7716 "AbstractDirectoryView.c"
	}
}

static void
___lambda118_ (Block28Data* _data28_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	FilesClipboardManager* _tmp0_;
	GFile* _tmp1_;
#line 1290 "../src/View/AbstractDirectoryView.vala"
	self = _data28_->self;
#line 1290 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 1291 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1291 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_paste_files_finish (_tmp0_, res);
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data28_->target;
#line 1292 "../src/View/AbstractDirectoryView.vala"
	if (g_file_has_uri_scheme (_tmp1_, "trash")) {
#line 1294 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_after_trash_or_delete (self);
#line 7742 "AbstractDirectoryView.c"
	}
}

static void
____lambda118__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1290 "../src/View/AbstractDirectoryView.vala"
	___lambda118_ (self, source_object, res);
#line 1290 "../src/View/AbstractDirectoryView.vala"
	block28_data_unref (self);
#line 7755 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_paste_into (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	FilesFile* file = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	FilesFile* _tmp3_;
	FilesFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	FilesFile* _tmp7_;
#line 1278 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1278 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1279 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1279 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1279 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
#line 1279 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 ((FilesFile*) _tmp2_);
#line 1279 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1279 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 1279 "../src/View/AbstractDirectoryView.vala"
	file = _tmp4_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = file;
#line 1281 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_ != NULL) {
#line 7794 "AbstractDirectoryView.c"
		FilesClipboardManager* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->priv->clipboard;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_clipboard_manager_get_can_paste (_tmp8_);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp10_;
#line 7806 "AbstractDirectoryView.c"
	} else {
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = FALSE;
#line 7810 "AbstractDirectoryView.c"
	}
#line 1281 "../src/View/AbstractDirectoryView.vala"
	if (_tmp6_) {
#line 7814 "AbstractDirectoryView.c"
		gboolean _tmp11_ = FALSE;
		FilesClipboardManager* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->priv->clipboard;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = files_clipboard_manager_get_files_linked (_tmp12_);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp13_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		if (_tmp14_) {
#line 1281 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->priv->in_trash;
#line 7829 "AbstractDirectoryView.c"
		} else {
#line 1281 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = FALSE;
#line 7833 "AbstractDirectoryView.c"
		}
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = !_tmp11_;
#line 7837 "AbstractDirectoryView.c"
	} else {
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = FALSE;
#line 7841 "AbstractDirectoryView.c"
	}
#line 1281 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_) {
#line 7845 "AbstractDirectoryView.c"
		Block28Data* _data28_;
		gboolean _tmp15_ = FALSE;
		FilesFile* _tmp16_;
		FilesClipboardManager* _tmp26_;
		GFile* _tmp27_;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_data28_ = g_slice_new0 (Block28Data);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_data28_->_ref_count_ = 1;
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_data28_->self = g_object_ref (self);
#line 1284 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = file;
#line 1284 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp16_)) {
#line 7861 "AbstractDirectoryView.c"
			FilesClipboardManager* _tmp17_;
			FilesFile* _tmp18_;
#line 1284 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->priv->clipboard;
#line 1284 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = file;
#line 1284 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = !files_clipboard_manager_has_file (_tmp17_, _tmp18_);
#line 7870 "AbstractDirectoryView.c"
		} else {
#line 1284 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = FALSE;
#line 7874 "AbstractDirectoryView.c"
		}
#line 1284 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_) {
#line 7878 "AbstractDirectoryView.c"
			FilesFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
#line 1285 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = file;
#line 1285 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = files_file_get_target_location (_tmp19_);
#line 1285 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1285 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_data28_->target);
#line 1285 "../src/View/AbstractDirectoryView.vala"
			_data28_->target = _tmp21_;
#line 7892 "AbstractDirectoryView.c"
		} else {
			FilesViewSlot* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = self->slot;
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp22_);
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = _tmp23_;
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_data28_->target);
#line 1287 "../src/View/AbstractDirectoryView.vala"
			_data28_->target = _tmp25_;
#line 7910 "AbstractDirectoryView.c"
		}
#line 1290 "../src/View/AbstractDirectoryView.vala"
		_tmp26_ = self->priv->clipboard;
#line 1290 "../src/View/AbstractDirectoryView.vala"
		_tmp27_ = _data28_->target;
#line 1290 "../src/View/AbstractDirectoryView.vala"
		files_clipboard_manager_paste_files (_tmp26_, _tmp27_, G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, ____lambda118__gasync_ready_callback, block28_data_ref (_data28_));
#line 1281 "../src/View/AbstractDirectoryView.vala"
		block28_data_unref (_data28_);
#line 1281 "../src/View/AbstractDirectoryView.vala"
		_data28_ = NULL;
#line 7922 "AbstractDirectoryView.c"
	}
#line 1278 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 7926 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_toggle_select_all (FilesAbstractDirectoryView* self)
{
#line 1300 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1301 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 1302 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->all_selected) {
#line 1303 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_unselect_all (self);
#line 7940 "AbstractDirectoryView.c"
	} else {
#line 1305 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_all (self);
#line 7944 "AbstractDirectoryView.c"
	}
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 1309 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	return _data29_;
#line 7955 "AbstractDirectoryView.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 1309 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 7965 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1309 "../src/View/AbstractDirectoryView.vala"
		self = _data29_->self;
#line 1309 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data29_->file);
#line 1309 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1309 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block29Data, _data29_);
#line 7975 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda60_ (Block29Data* _data29_)
{
	FilesAbstractDirectoryView* self;
	gboolean result;
#line 1313 "../src/View/AbstractDirectoryView.vala"
	self = _data29_->self;
#line 1314 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_icon_and_plugins (self, _data29_->file);
#line 1315 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1315 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 7992 "AbstractDirectoryView.c"
}

static gboolean
____lambda60__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda60_ (self);
#line 1313 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8002 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_added (FilesAbstractDirectoryView* self,
                                                       FilesDirectory* dir,
                                                       FilesFile* file,
                                                       gboolean is_internal)
{
	Block29Data* _data29_;
	FilesFile* _tmp0_;
#line 1309 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_data29_->_ref_count_ = 1;
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_data29_->self = g_object_ref (self);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data29_->file);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_data29_->file = _tmp0_;
#line 1310 "../src/View/AbstractDirectoryView.vala"
	if (_data29_->file != NULL) {
#line 1311 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_add_file (self, _data29_->file, dir, is_internal);
#line 1312 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_handle_free_space_change (self);
#line 1313 "../src/View/AbstractDirectoryView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda60__gsource_func, block29_data_ref (_data29_), block29_data_unref);
#line 8037 "AbstractDirectoryView.c"
	} else {
#line 1318 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:1318: Null file added");
#line 8041 "AbstractDirectoryView.c"
	}
#line 1309 "../src/View/AbstractDirectoryView.vala"
	block29_data_unref (_data29_);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_data29_ = NULL;
#line 8047 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_loaded (FilesAbstractDirectoryView* self,
                                                        FilesDirectory* dir,
                                                        FilesFile* file)
{
	FilesListModel* _tmp0_;
#line 1322 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1322 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1322 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1324 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1324 "../src/View/AbstractDirectoryView.vala"
	files_list_model_add_file (_tmp0_, file, dir);
#line 8066 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_changed (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir,
                                                         FilesFile* file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 1327 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1327 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1327 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_location (file);
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_directory_get_file (dir);
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_file_get_location (_tmp3_);
#line 1328 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 1328 "../src/View/AbstractDirectoryView.vala"
	if (g_file_equal (_tmp1_, _tmp5_)) {
#line 8100 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp6_;
		FilesDirectory* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesFile* _tmp9_;
		FilesFile* _tmp10_;
#line 1330 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->slot;
#line 1330 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp6_);
#line 1330 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 1330 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_directory_get_file (_tmp8_);
#line 1330 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1330 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = files_file_is_writable (_tmp10_);
#line 8118 "AbstractDirectoryView.c"
	} else {
#line 1332 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_directory_file_icon_changed (self, dir, file);
#line 8122 "AbstractDirectoryView.c"
	}
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 1336 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	return _data30_;
#line 8133 "AbstractDirectoryView.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 1336 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 8143 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1336 "../src/View/AbstractDirectoryView.vala"
		self = _data30_->self;
#line 1336 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data30_->file);
#line 1336 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1336 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block30Data, _data30_);
#line 8153 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda61_ (Block30Data* _data30_)
{
	FilesAbstractDirectoryView* self;
	gboolean result;
#line 1342 "../src/View/AbstractDirectoryView.vala"
	self = _data30_->self;
#line 1343 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_icon_and_plugins (self, _data30_->file);
#line 1344 "../src/View/AbstractDirectoryView.vala"
	if (self->should_thumbnail) {
#line 8168 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp0_;
#line 1345 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->thumbnailer;
#line 1345 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_queue_file (_tmp0_, _data30_->file, NULL);
#line 8174 "AbstractDirectoryView.c"
	}
#line 1348 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1348 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8180 "AbstractDirectoryView.c"
}

static gboolean
___lambda61__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda61_ (self);
#line 1342 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8190 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_icon_changed (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file)
{
	Block30Data* _data30_;
	FilesFile* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	FilesListModel* _tmp3_;
#line 1336 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_data30_->_ref_count_ = 1;
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_data30_->self = g_object_ref (self);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data30_->file);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_data30_->file = _tmp0_;
#line 1337 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 1337 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1337 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1338 "../src/View/AbstractDirectoryView.vala"
		block30_data_unref (_data30_);
#line 1338 "../src/View/AbstractDirectoryView.vala"
		_data30_ = NULL;
#line 1338 "../src/View/AbstractDirectoryView.vala"
		return;
#line 8233 "AbstractDirectoryView.c"
	}
#line 1341 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->model;
#line 1341 "../src/View/AbstractDirectoryView.vala"
	files_list_model_file_changed (_tmp3_, _data30_->file, dir);
#line 1342 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda61__gsource_func, block30_data_ref (_data30_), block30_data_unref);
#line 1351 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_draw_when_idle (self);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	block30_data_unref (_data30_);
#line 1336 "../src/View/AbstractDirectoryView.vala"
	_data30_ = NULL;
#line 8247 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_deleted (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir,
                                                         FilesFile* file)
{
	FilesListModel* _tmp0_;
	FilesPluginManager* _tmp1_;
#line 1354 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1354 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1354 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1357 "../src/View/AbstractDirectoryView.vala"
	files_file_set_exists (file, FALSE);
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1358 "../src/View/AbstractDirectoryView.vala"
	files_list_model_remove_file (_tmp0_, file, dir);
#line 1360 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = plugins;
#line 1360 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 8273 "AbstractDirectoryView.c"
		FilesPluginManager* _tmp2_;
#line 1361 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = plugins;
#line 1361 "../src/View/AbstractDirectoryView.vala"
		files_plugin_manager_update_file_info (_tmp2_, file);
#line 8279 "AbstractDirectoryView.c"
	}
#line 1364 "../src/View/AbstractDirectoryView.vala"
	if (files_file_is_folder (file)) {
#line 8283 "AbstractDirectoryView.c"
		FilesDirectory* file_dir = NULL;
		GFile* _tmp3_;
		GFile* _tmp4_;
		FilesDirectory* _tmp5_;
		FilesDirectory* _tmp6_;
#line 1366 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_file_get_location (file);
#line 1366 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 1366 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_directory_cache_lookup (_tmp4_);
#line 1366 "../src/View/AbstractDirectoryView.vala"
		file_dir = _tmp5_;
#line 1367 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = file_dir;
#line 1367 "../src/View/AbstractDirectoryView.vala"
		if (_tmp6_ != NULL) {
#line 8301 "AbstractDirectoryView.c"
			FilesDirectory* _tmp7_;
			FilesViewSlot* _tmp8_;
			FilesDirectory* _tmp9_;
#line 1368 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = file_dir;
#line 1368 "../src/View/AbstractDirectoryView.vala"
			files_directory_purge_dir_from_cache (_tmp7_);
#line 1369 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->slot;
#line 1369 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = file_dir;
#line 1369 "../src/View/AbstractDirectoryView.vala"
			g_signal_emit_by_name (_tmp8_, "folder-deleted", file, _tmp9_);
#line 8315 "AbstractDirectoryView.c"
		}
#line 1364 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file_dir);
#line 8319 "AbstractDirectoryView.c"
	}
#line 1373 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_handle_free_space_change (self);
#line 8323 "AbstractDirectoryView.c"
}

static gboolean
__lambda53_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 1396 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_thaw_tree (self);
#line 1397 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 1398 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1398 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8338 "AbstractDirectoryView.c"
}

static gboolean
___lambda53__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda53_ ((FilesAbstractDirectoryView*) self);
#line 1395 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8348 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_done_loading (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	FilesViewSlot* _tmp5_;
	FilesDirectory* _tmp6_;
	FilesDirectory* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	FilesViewSlot* _tmp10_;
	FilesDirectory* _tmp11_;
	FilesDirectory* _tmp12_;
	FilesFile* _tmp13_;
	FilesFile* _tmp14_;
	FilesViewSlot* _tmp15_;
	FilesDirectory* _tmp16_;
	FilesDirectory* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
#line 1376 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1376 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1378 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
#line 1379 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1379 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1379 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1379 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_directory_get_is_trash (_tmp2_);
#line 1379 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1379 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_trash = _tmp4_;
#line 1380 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->slot;
#line 1380 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 1380 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = _tmp6_;
#line 1380 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_directory_get_is_recent (_tmp7_);
#line 1380 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 1380 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_in_recent (self, _tmp9_);
#line 1381 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = self->slot;
#line 1381 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp10_);
#line 1381 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _tmp11_;
#line 1381 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = files_directory_get_file (_tmp12_);
#line 1381 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = _tmp13_;
#line 1381 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_network_root = files_file_is_root_network_folder (_tmp14_);
#line 1383 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = self->slot;
#line 1383 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp15_);
#line 1383 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 1383 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = files_directory_get_can_load (_tmp17_);
#line 1383 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = _tmp18_;
#line 1383 "../src/View/AbstractDirectoryView.vala"
	if (_tmp19_) {
#line 8429 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp20_;
		FilesDirectory* _tmp21_;
		FilesDirectory* _tmp22_;
		FilesFile* _tmp23_;
		FilesFile* _tmp24_;
		gboolean _tmp25_;
#line 1384 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = self->slot;
#line 1384 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp20_);
#line 1384 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = _tmp21_;
#line 1384 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = files_directory_get_file (_tmp22_);
#line 1384 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = _tmp23_;
#line 1384 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = files_file_is_writable (_tmp24_);
#line 1385 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = self->priv->_in_recent;
#line 1385 "../src/View/AbstractDirectoryView.vala"
		if (_tmp25_) {
#line 8452 "AbstractDirectoryView.c"
			FilesListModel* _tmp26_;
#line 1386 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = self->model;
#line 1386 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp26_, (gint) FILES_LIST_MODEL_COLUMN_ID_MODIFIED, GTK_SORT_DESCENDING);
#line 8458 "AbstractDirectoryView.c"
		} else {
			FilesViewSlot* _tmp27_;
			FilesDirectory* _tmp28_;
			FilesDirectory* _tmp29_;
			FilesFile* _tmp30_;
			FilesFile* _tmp31_;
			GFileInfo* _tmp32_;
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = self->slot;
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp27_);
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = _tmp28_;
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = files_directory_get_file (_tmp29_);
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp31_ = _tmp30_;
#line 1387 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = _tmp31_->info;
#line 1387 "../src/View/AbstractDirectoryView.vala"
			if (_tmp32_ != NULL) {
#line 8480 "AbstractDirectoryView.c"
				FilesListModel* _tmp33_;
				FilesViewSlot* _tmp34_;
				FilesDirectory* _tmp35_;
				FilesDirectory* _tmp36_;
				FilesFile* _tmp37_;
				FilesFile* _tmp38_;
				FilesViewSlot* _tmp39_;
				FilesDirectory* _tmp40_;
				FilesDirectory* _tmp41_;
				FilesFile* _tmp42_;
				FilesFile* _tmp43_;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = self->model;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = self->slot;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp34_);
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = _tmp35_;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = files_directory_get_file (_tmp36_);
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = _tmp37_;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = self->slot;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp39_);
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp41_ = _tmp40_;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp42_ = files_directory_get_file (_tmp41_);
#line 1388 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = _tmp42_;
#line 1388 "../src/View/AbstractDirectoryView.vala"
				gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp33_, _tmp38_->sort_column_id, _tmp43_->sort_order);
#line 8516 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1391 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = FALSE;
#line 8522 "AbstractDirectoryView.c"
	}
#line 1395 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda53__gsource_func, g_object_ref (self), g_object_unref);
#line 8526 "AbstractDirectoryView.c"
}

/** Handle zoom level change */
static void
files_abstract_directory_view_on_zoom_level_changed (FilesAbstractDirectoryView* self,
                                                     FilesZoomLevel zoom)
{
	FilesListModel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1403 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1404 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1404 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_icon_size (self);
#line 1404 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1404 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_icon_size (_tmp0_, _tmp2_);
#line 1405 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_zoom_level (self);
#line 8549 "AbstractDirectoryView.c"
}

/** Handle Preference changes */
static GVariant*
_variant_new1 (gboolean value)
{
#line 1433 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8558 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_show_hidden_files_changed (FilesAbstractDirectoryView* self,
                                                            GObject* prefs,
                                                            GParamSpec* pspec)
{
	gboolean show = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesListModel* _tmp2_;
	FilesViewSlot* _tmp4_;
	FilesDirectory* _tmp5_;
	FilesDirectory* _tmp6_;
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
	GList* _tmp10_;
	GSimpleActionGroup* _tmp14_;
	GVariant* _tmp15_;
#line 1409 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1409 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1409 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1410 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_show_hidden_files (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1410 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1410 "../src/View/AbstractDirectoryView.vala"
	show = _tmp1_;
#line 1411 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 1411 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_show_hidden_files (_tmp2_, show);
#line 1412 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 1414 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 1416 "../src/View/AbstractDirectoryView.vala"
	if (!show) {
#line 8601 "AbstractDirectoryView.c"
		FilesListModel* _tmp3_;
#line 1417 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_block_model (self);
#line 1418 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->model;
#line 1418 "../src/View/AbstractDirectoryView.vala"
		files_list_model_clear (_tmp3_);
#line 8609 "AbstractDirectoryView.c"
	}
#line 1421 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->slot;
#line 1421 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp4_);
#line 1421 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 1421 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_directory_hidden_changed (self, _tmp6_, show);
#line 1423 "../src/View/AbstractDirectoryView.vala"
	if (!show) {
#line 1424 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_unblock_model (self);
#line 8623 "AbstractDirectoryView.c"
	}
#line 1427 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 1427 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 1427 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = files_directory_get_files (_tmp9_);
#line 8633 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 1427 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp10_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 8641 "AbstractDirectoryView.c"
			FilesFile* _tmp11_;
			FilesFile* file = NULL;
#line 1427 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1427 "../src/View/AbstractDirectoryView.vala"
			file = _tmp11_;
#line 8648 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp12_;
#line 1428 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = file;
#line 1428 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_folder (_tmp12_)) {
#line 8655 "AbstractDirectoryView.c"
					FilesFile* _tmp13_;
#line 1429 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = file;
#line 1429 "../src/View/AbstractDirectoryView.vala"
					files_file_ensure_size (_tmp13_);
#line 8661 "AbstractDirectoryView.c"
				}
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 8665 "AbstractDirectoryView.c"
			}
		}
#line 1427 "../src/View/AbstractDirectoryView.vala"
		(file_collection == NULL) ? NULL : (file_collection = (g_list_free (file_collection), NULL));
#line 8670 "AbstractDirectoryView.c"
	}
#line 1433 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = self->priv->background_actions;
#line 1433 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _variant_new1 (show);
#line 1433 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp14_, "show-hidden", _tmp15_);
#line 1433 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp15_);
#line 8680 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_should_thumbnail (FilesAbstractDirectoryView* self)
{
	FilesPreferences* prefs = NULL;
	FilesPreferences* _tmp0_;
	FilesViewSlot* _tmp1_;
	FilesDirectory* _tmp2_;
	FilesDirectory* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 1436 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1437 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_default ();
#line 1437 "../src/View/AbstractDirectoryView.vala"
	prefs = _tmp0_;
#line 1438 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->slot;
#line 1438 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp1_);
#line 1438 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1438 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_directory_get_is_network (_tmp3_);
#line 1438 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 1438 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_) {
#line 8711 "AbstractDirectoryView.c"
		gboolean _tmp6_ = FALSE;
		FilesViewSlot* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesDirectory* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 1439 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->slot;
#line 1439 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 1439 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 1439 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_directory_get_can_open_files (_tmp9_);
#line 1439 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 1439 "../src/View/AbstractDirectoryView.vala"
		if (_tmp11_) {
#line 8730 "AbstractDirectoryView.c"
			FilesPreferences* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 1439 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = prefs;
#line 1439 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = files_preferences_get_show_remote_thumbnails (_tmp12_);
#line 1439 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = _tmp13_;
#line 1439 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = _tmp14_;
#line 8742 "AbstractDirectoryView.c"
		} else {
#line 1439 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = FALSE;
#line 8746 "AbstractDirectoryView.c"
		}
#line 1439 "../src/View/AbstractDirectoryView.vala"
		self->should_thumbnail = _tmp6_;
#line 8750 "AbstractDirectoryView.c"
	} else {
		FilesPreferences* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 1441 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = prefs;
#line 1441 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = files_preferences_get_show_local_thumbnails (_tmp15_);
#line 1441 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = _tmp16_;
#line 1441 "../src/View/AbstractDirectoryView.vala"
		self->should_thumbnail = _tmp17_;
#line 8763 "AbstractDirectoryView.c"
	}
#line 1436 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (prefs);
#line 8767 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_show_thumbnails_changed (FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
#line 1445 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1446 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_should_thumbnail (self);
#line 1447 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1447 "../src/View/AbstractDirectoryView.vala"
	files_abstract_slot_reload ((FilesAbstractSlot*) _tmp0_, FALSE);
#line 8782 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_sort_directories_first_changed (FilesAbstractDirectoryView* self,
                                                                 GObject* prefs,
                                                                 GParamSpec* pspec)
{
	gboolean sort_directories_first = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesListModel* _tmp2_;
#line 1450 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1450 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1450 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1451 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_sort_directories_first (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1451 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1451 "../src/View/AbstractDirectoryView.vala"
	sort_directories_first = _tmp1_;
#line 1452 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 1452 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_should_sort_directories_first (_tmp2_, sort_directories_first);
#line 8810 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_directory_hidden_changed (FilesAbstractDirectoryView* self,
                                                        FilesDirectory* dir,
                                                        gboolean show)
{
#line 1455 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1455 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1457 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 1458 "../src/View/AbstractDirectoryView.vala"
	files_directory_load_hiddens (dir);
#line 8826 "AbstractDirectoryView.c"
}

/** Handle popup menu events */
static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 1465 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 8835 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_on_popup_menu (FilesAbstractDirectoryView* self)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	gboolean result;
#line 1462 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1463 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_get_current_event ();
#line 1463 "../src/View/AbstractDirectoryView.vala"
	event = _tmp0_;
#line 1464 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_show_context_menu (self, event);
#line 1465 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1465 "../src/View/AbstractDirectoryView.vala"
	__vala_GdkEvent_free0 (event);
#line 1465 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8858 "AbstractDirectoryView.c"
}

/** Handle TreeModel events */
static void
files_abstract_directory_view_real_on_row_deleted (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
#line 1469 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path != NULL);
#line 1470 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 8870 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_row_deleted (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 1469 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1469 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 1469 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_row_deleted) {
#line 1469 "../src/View/AbstractDirectoryView.vala"
		_klass_->on_row_deleted (self, path);
#line 8886 "AbstractDirectoryView.c"
	}
}

/** Handle clipboard signal */
static void
files_abstract_directory_view_on_clipboard_changed (FilesAbstractDirectoryView* self)
{
#line 1474 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1476 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 8898 "AbstractDirectoryView.c"
}

/** DRAG AND DROP SOURCE */
static void
files_abstract_directory_view_on_drag_begin (FilesAbstractDirectoryView* self)
{
#line 1482 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1483 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 8909 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_get (FilesAbstractDirectoryView* self,
                                                GdkDragContext* context,
                                                GtkSelectionData* selection_data,
                                                guint info,
                                                guint timestamp)
{
	GList* _tmp0_;
	GList* _tmp3_;
	FilesFile* file = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	FilesFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
	FilesFile* _tmp9_;
	GList* _tmp14_;
#line 1488 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1488 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1488 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (selection_data != NULL);
#line 1493 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->source_drag_file_list;
#line 1493 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 8939 "AbstractDirectoryView.c"
		GList* _tmp1_;
		GList* _tmp2_;
#line 1494 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_directory_view_get_selected_files (self);
#line 1494 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp1_);
#line 1494 "../src/View/AbstractDirectoryView.vala"
		(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 1494 "../src/View/AbstractDirectoryView.vala"
		self->source_drag_file_list = _tmp2_;
#line 8950 "AbstractDirectoryView.c"
	}
#line 1497 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->source_drag_file_list;
#line 1497 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == NULL) {
#line 1498 "../src/View/AbstractDirectoryView.vala"
		return;
#line 8958 "AbstractDirectoryView.c"
	}
#line 1501 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->source_drag_file_list;
#line 1501 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_list_first (_tmp4_);
#line 1501 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_->data;
#line 1501 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = _g_object_ref0 ((FilesFile*) _tmp6_);
#line 1501 "../src/View/AbstractDirectoryView.vala"
	file = _tmp7_;
#line 1503 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = file;
#line 1503 "../src/View/AbstractDirectoryView.vala"
	if (_tmp9_ != NULL) {
#line 8974 "AbstractDirectoryView.c"
		FilesFile* _tmp10_;
		GdkPixbuf* _tmp11_;
#line 1503 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = file;
#line 1503 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->pix;
#line 1503 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp11_ != NULL;
#line 8983 "AbstractDirectoryView.c"
	} else {
#line 1503 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = FALSE;
#line 8987 "AbstractDirectoryView.c"
	}
#line 1503 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_) {
#line 8991 "AbstractDirectoryView.c"
		FilesFile* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 1504 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = file;
#line 1504 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_->pix;
#line 1504 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_set_icon_gicon (context, (GIcon*) _tmp13_, 0, 0);
#line 9000 "AbstractDirectoryView.c"
	} else {
#line 1506 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_set_icon_name (context, "stock-file", 0, 0);
#line 9004 "AbstractDirectoryView.c"
	}
#line 1509 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = self->source_drag_file_list;
#line 1509 "../src/View/AbstractDirectoryView.vala"
	files_dnd_handler_set_selection_data_from_file_list (selection_data, _tmp14_, "");
#line 1488 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 9012 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_delete (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
#line 1513 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1515 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1515 "../src/View/AbstractDirectoryView.vala"
	g_signal_stop_emission_by_name (_tmp0_, "drag-data-delete");
#line 9025 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_end (FilesAbstractDirectoryView* self)
{
#line 1519 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1520 "../src/View/AbstractDirectoryView.vala"
	(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 1520 "../src/View/AbstractDirectoryView.vala"
	self->source_drag_file_list = NULL;
#line 9037 "AbstractDirectoryView.c"
}

/** DRAG AND DROP DESTINATION */
static gboolean
files_abstract_directory_view_on_drag_motion (FilesAbstractDirectoryView* self,
                                              GdkDragContext* context,
                                              gint x,
                                              gint y,
                                              guint timestamp)
{
	gboolean result;
#line 1526 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1526 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1531 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->destination_data_ready) {
#line 1533 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_check_destination_actions_and_target_file (self, context, x, y, timestamp);
#line 9057 "AbstractDirectoryView.c"
	} else {
#line 1536 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_get_drag_data (self, context, x, y, timestamp);
#line 1537 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 1537 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 9065 "AbstractDirectoryView.c"
	}
#line 1540 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->drag_scroll_timer_id == ((guint) 0)) {
#line 9069 "AbstractDirectoryView.c"
		GdkDevice* _tmp0_;
#line 1541 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = gtk_get_current_event_device ();
#line 1541 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_start_drag_scroll_timer (self, _tmp0_);
#line 9075 "AbstractDirectoryView.c"
	}
#line 1544 "../src/View/AbstractDirectoryView.vala"
	gdk_drag_status (context, self->priv->current_suggested_action, (guint32) timestamp);
#line 1545 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1545 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9083 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_on_drag_drop (FilesAbstractDirectoryView* self,
                                            GdkDragContext* context,
                                            gint x,
                                            gint y,
                                            guint timestamp)
{
	GtkTargetList* list = NULL;
	gchar* uri = NULL;
	GdkAtom target = (GdkAtom) 0U;
	GtkWidget* _tmp0_;
	GtkTargetList* _tmp1_;
	GtkWidget* _tmp22_;
	gboolean result;
#line 1549 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1549 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1554 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 1555 "../src/View/AbstractDirectoryView.vala"
	uri = NULL;
#line 1556 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_occurred = TRUE;
#line 1558 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1558 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = list;
#line 1558 "../src/View/AbstractDirectoryView.vala"
	target = gtk_drag_dest_find_target (_tmp0_, context, _tmp1_);
#line 1559 "../src/View/AbstractDirectoryView.vala"
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 9118 "AbstractDirectoryView.c"
		FilesFile* target_file = NULL;
		FilesFile* _tmp2_;
		gchar* filename = NULL;
		FilesDndHandler* _tmp3_;
		GdkWindow* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		FilesFile* _tmp7_;
#line 1560 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_drop_target_file (self, x, y);
#line 1560 "../src/View/AbstractDirectoryView.vala"
		target_file = _tmp2_;
#line 1562 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_directory_view_dnd_handler;
#line 1562 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = gdk_drag_context_get_source_window (context);
#line 1562 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_dnd_handler_get_source_filename (_tmp3_, _tmp4_);
#line 1562 "../src/View/AbstractDirectoryView.vala"
		filename = _tmp5_;
#line 1563 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = target_file;
#line 1563 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_ != NULL) {
#line 9143 "AbstractDirectoryView.c"
			const gchar* _tmp8_;
#line 1563 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = filename;
#line 1563 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = _tmp8_ != NULL;
#line 9149 "AbstractDirectoryView.c"
		} else {
#line 1563 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = FALSE;
#line 9153 "AbstractDirectoryView.c"
		}
#line 1563 "../src/View/AbstractDirectoryView.vala"
		if (_tmp6_) {
#line 9157 "AbstractDirectoryView.c"
			FilesFile* _tmp9_;
			GFile* _tmp10_;
			const gchar* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			gchar* _tmp14_;
			FilesDndHandler* _tmp15_;
			GdkWindow* _tmp16_;
			const gchar* _tmp17_;
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = target_file;
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = files_file_get_target_location (_tmp9_);
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = filename;
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = g_file_resolve_relative_path (_tmp10_, _tmp11_);
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = _tmp12_;
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = g_file_get_uri (_tmp13_);
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (uri);
#line 1565 "../src/View/AbstractDirectoryView.vala"
			uri = _tmp14_;
#line 1565 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp13_);
#line 1567 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = files_abstract_directory_view_dnd_handler;
#line 1567 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = gdk_drag_context_get_source_window (context);
#line 1567 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = uri;
#line 1567 "../src/View/AbstractDirectoryView.vala"
			files_dnd_handler_set_source_uri (_tmp15_, _tmp16_, _tmp17_);
#line 9193 "AbstractDirectoryView.c"
		} else {
			FilesViewWindow* _tmp18_;
			FilesViewWindow* _tmp19_;
			GraniteMessageDialog* _tmp20_;
			GraniteMessageDialog* _tmp21_;
#line 1569 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = files_abstract_directory_view_get_window (self);
#line 1569 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = _tmp18_;
#line 1569 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = pf_dialogs_show_error_dialog (_ ("Cannot drop this file"), _ ("Invalid file name provided"), (GtkWindow*) _tmp19_);
#line 1569 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = _tmp20_;
#line 1569 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp21_);
#line 1572 "../src/View/AbstractDirectoryView.vala"
			result = FALSE;
#line 1572 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (filename);
#line 1572 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (target_file);
#line 1572 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (uri);
#line 1572 "../src/View/AbstractDirectoryView.vala"
			_gtk_target_list_unref0 (list);
#line 1572 "../src/View/AbstractDirectoryView.vala"
			return result;
#line 9221 "AbstractDirectoryView.c"
		}
#line 1559 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (filename);
#line 1559 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (target_file);
#line 9227 "AbstractDirectoryView.c"
	}
#line 1578 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = gtk_bin_get_child ((GtkBin*) self);
#line 1578 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_get_data (_tmp22_, context, target, (guint32) timestamp);
#line 1580 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1580 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (uri);
#line 1580 "../src/View/AbstractDirectoryView.vala"
	_gtk_target_list_unref0 (list);
#line 1580 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9241 "AbstractDirectoryView.c"
}

static gboolean
____lambda126_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 1640 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 1641 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1641 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9254 "AbstractDirectoryView.c"
}

static gboolean
_____lambda126__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda126_ ((FilesAbstractDirectoryView*) self);
#line 1639 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9264 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_received (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     gint x,
                                                     gint y,
                                                     GtkSelectionData* selection_data,
                                                     guint info,
                                                     guint timestamp)
{
	gboolean _tmp0_ = FALSE;
#line 1586 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1586 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1586 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (selection_data != NULL);
#line 1595 "../src/View/AbstractDirectoryView.vala"
	if (info == ((guint) FILES_TARGET_TYPE_TEXT_URI_LIST)) {
#line 9285 "AbstractDirectoryView.c"
		GList* _tmp1_;
#line 1595 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->priv->destination_drop_file_list;
#line 1595 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 9291 "AbstractDirectoryView.c"
	} else {
#line 1595 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 9295 "AbstractDirectoryView.c"
	}
#line 1595 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 9299 "AbstractDirectoryView.c"
		gchar* text = NULL;
		gchar* _tmp2_ = NULL;
		gboolean _tmp3_;
#line 1597 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_dnd_handler_selection_data_is_uri_list (selection_data, info, &_tmp2_);
#line 1597 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (text);
#line 1597 "../src/View/AbstractDirectoryView.vala"
		text = _tmp2_;
#line 1597 "../src/View/AbstractDirectoryView.vala"
		if (_tmp3_) {
#line 9311 "AbstractDirectoryView.c"
			const gchar* _tmp4_;
			GList* _tmp5_;
#line 1598 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = text;
#line 1598 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = files_file_utils_files_from_uris (_tmp4_);
#line 1598 "../src/View/AbstractDirectoryView.vala"
			(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 1598 "../src/View/AbstractDirectoryView.vala"
			self->priv->destination_drop_file_list = _tmp5_;
#line 1599 "../src/View/AbstractDirectoryView.vala"
			self->priv->destination_data_ready = TRUE;
#line 9324 "AbstractDirectoryView.c"
		}
#line 1595 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (text);
#line 9328 "AbstractDirectoryView.c"
	}
#line 1603 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->drop_occurred) {
#line 9332 "AbstractDirectoryView.c"
		gboolean success = FALSE;
#line 1604 "../src/View/AbstractDirectoryView.vala"
		success = FALSE;
#line 1605 "../src/View/AbstractDirectoryView.vala"
		self->priv->drop_occurred = FALSE;
#line 1607 "../src/View/AbstractDirectoryView.vala"
		switch (info) {
#line 1607 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_XDND_DIRECT_SAVE0:
#line 9342 "AbstractDirectoryView.c"
			{
				FilesDndHandler* _tmp6_;
				GdkWindow* _tmp7_;
				FilesFile* _tmp8_;
#line 1609 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = files_abstract_directory_view_dnd_handler;
#line 1609 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = gdk_drag_context_get_source_window (context);
#line 1609 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = self->priv->drop_target_file;
#line 1609 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_xdnddirectsave (_tmp6_, _tmp7_, _tmp8_, selection_data);
#line 1612 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9357 "AbstractDirectoryView.c"
			}
#line 1607 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_NETSCAPE_URL:
#line 9361 "AbstractDirectoryView.c"
			{
				FilesDndHandler* _tmp9_;
				GdkWindow* _tmp10_;
				FilesFile* _tmp11_;
#line 1615 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = files_abstract_directory_view_dnd_handler;
#line 1615 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = gdk_drag_context_get_source_window (context);
#line 1615 "../src/View/AbstractDirectoryView.vala"
				_tmp11_ = self->priv->drop_target_file;
#line 1615 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_netscape_url (_tmp9_, _tmp10_, _tmp11_, selection_data);
#line 1618 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9376 "AbstractDirectoryView.c"
			}
#line 1607 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 9380 "AbstractDirectoryView.c"
			{
				GList* _tmp12_;
				FilesDndHandler* _tmp13_;
				GtkWidget* _tmp14_;
				FilesFile* _tmp15_;
				GList* _tmp16_;
				GtkWindow* _tmp17_;
				GtkApplicationWindow* _tmp18_;
#line 1621 "../src/View/AbstractDirectoryView.vala"
				if ((self->priv->current_actions & FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS) == 0) {
#line 1622 "../src/View/AbstractDirectoryView.vala"
					break;
#line 9393 "AbstractDirectoryView.c"
				}
#line 1625 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = self->selected_files;
#line 1625 "../src/View/AbstractDirectoryView.vala"
				if (_tmp12_ != NULL) {
#line 1626 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_all (self);
#line 9401 "AbstractDirectoryView.c"
				}
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp13_ = files_abstract_directory_view_dnd_handler;
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = gtk_bin_get_child ((GtkBin*) self);
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = self->priv->drop_target_file;
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->destination_drop_file_list;
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = files_get_active_window ();
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 1629 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_file_drag_actions (_tmp13_, _tmp14_, _tmp15_, _tmp16_, self->priv->current_actions, self->priv->current_suggested_action, _tmp18_, (guint32) timestamp);
#line 1629 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp18_);
#line 1639 "../src/View/AbstractDirectoryView.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda126__gsource_func, g_object_ref (self), g_object_unref);
#line 1644 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9423 "AbstractDirectoryView.c"
			}
			default:
			{
#line 1647 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9429 "AbstractDirectoryView.c"
			}
		}
#line 1651 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_finish (context, success, FALSE, (guint32) timestamp);
#line 1652 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_clear_destination_drag_data (self);
#line 9436 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_drag_leave (FilesAbstractDirectoryView* self)
{
	FilesIconRenderer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1657 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1659 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->icon_renderer;
#line 1659 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_drop_file (_tmp0_, NULL);
#line 1661 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 1662 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
#line 1665 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_drop_highlight (self);
#line 1665 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1665 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1666 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_drop_highlight (self, FALSE);
#line 1667 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 9466 "AbstractDirectoryView.c"
	}
#line 1671 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_highlight_path (self, NULL);
#line 1674 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear_destination_drag_data (self);
#line 9472 "AbstractDirectoryView.c"
}

/** DnD destination helpers */
static void
files_abstract_directory_view_clear_destination_drag_data (FilesAbstractDirectoryView* self)
{
#line 1679 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1680 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_data_ready = FALSE;
#line 1681 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = GDK_NONE;
#line 1682 "../src/View/AbstractDirectoryView.vala"
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 1682 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_drop_file_list = NULL;
#line 1683 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 9491 "AbstractDirectoryView.c"
}

static FilesFile*
files_abstract_directory_view_get_drop_target_file (FilesAbstractDirectoryView* self,
                                                    gint win_x,
                                                    gint win_y)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	FilesFile* file = NULL;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp15_;
	FilesFile* result;
#line 1686 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1687 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_path_at_pos (self, win_x, win_y);
#line 1687 "../src/View/AbstractDirectoryView.vala"
	path = _tmp0_;
#line 1688 "../src/View/AbstractDirectoryView.vala"
	file = NULL;
#line 1690 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = path;
#line 1690 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 9517 "AbstractDirectoryView.c"
		FilesListModel* _tmp2_;
		GtkTreePath* _tmp3_;
		FilesFile* _tmp4_;
		FilesFile* _tmp5_;
#line 1691 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->model;
#line 1691 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = path;
#line 1691 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_list_model_file_for_path (_tmp2_, _tmp3_);
#line 1691 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1691 "../src/View/AbstractDirectoryView.vala"
		file = _tmp4_;
#line 1692 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = file;
#line 1692 "../src/View/AbstractDirectoryView.vala"
		if (_tmp5_ == NULL) {
#line 9536 "AbstractDirectoryView.c"
			GtkTreePath* folder_path = NULL;
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
			FilesListModel* _tmp9_;
			GtkTreePath* _tmp10_;
			FilesFile* _tmp11_;
#line 1694 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = path;
#line 1694 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = gtk_tree_path_copy (_tmp6_);
#line 1694 "../src/View/AbstractDirectoryView.vala"
			folder_path = _tmp7_;
#line 1695 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = folder_path;
#line 1695 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_path_up (_tmp8_);
#line 1696 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->model;
#line 1696 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = folder_path;
#line 1696 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = files_list_model_file_for_path (_tmp9_, _tmp10_);
#line 1696 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 1696 "../src/View/AbstractDirectoryView.vala"
			file = _tmp11_;
#line 1692 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (folder_path);
#line 9566 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp12_ = FALSE;
			FilesFile* _tmp13_;
#line 1699 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = file;
#line 1699 "../src/View/AbstractDirectoryView.vala"
			if (!files_file_is_folder (_tmp13_)) {
#line 9574 "AbstractDirectoryView.c"
				FilesFile* _tmp14_;
#line 1699 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = file;
#line 1699 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = !files_file_is_executable (_tmp14_);
#line 9580 "AbstractDirectoryView.c"
			} else {
#line 1699 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = FALSE;
#line 9584 "AbstractDirectoryView.c"
			}
#line 1699 "../src/View/AbstractDirectoryView.vala"
			if (_tmp12_) {
#line 1700 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 1700 "../src/View/AbstractDirectoryView.vala"
				file = NULL;
#line 1701 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 1701 "../src/View/AbstractDirectoryView.vala"
				path = NULL;
#line 9596 "AbstractDirectoryView.c"
			}
		}
	}
#line 1706 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = path;
#line 1706 "../src/View/AbstractDirectoryView.vala"
	if (_tmp15_ == NULL) {
#line 9604 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp16_;
		FilesDirectory* _tmp17_;
		FilesDirectory* _tmp18_;
		FilesFile* _tmp19_;
		FilesFile* _tmp20_;
		FilesFile* _tmp21_;
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = self->slot;
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp16_);
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = _tmp17_;
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = files_directory_get_file (_tmp18_);
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = _tmp19_;
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1708 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1708 "../src/View/AbstractDirectoryView.vala"
		file = _tmp21_;
#line 9627 "AbstractDirectoryView.c"
	}
#line 1711 "../src/View/AbstractDirectoryView.vala"
	result = file;
#line 1711 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 1711 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9635 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_get_drag_data (FilesAbstractDirectoryView* self,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             guint timestamp)
{
	GtkTargetList* list = NULL;
	GdkAtom target = (GdkAtom) 0U;
	GtkWidget* _tmp0_;
	GtkTargetList* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1715 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1715 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1716 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 1717 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1717 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = list;
#line 1717 "../src/View/AbstractDirectoryView.vala"
	target = gtk_drag_dest_find_target (_tmp0_, context, _tmp1_);
#line 1718 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = target;
#line 1721 "../src/View/AbstractDirectoryView.vala"
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 1721 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = TRUE;
#line 9668 "AbstractDirectoryView.c"
	} else {
#line 1722 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = target == gdk_atom_intern_static_string ("_NETSCAPE_URL");
#line 9672 "AbstractDirectoryView.c"
	}
#line 1721 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 9676 "AbstractDirectoryView.c"
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		FilesFile* _tmp5_;
#line 1724 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->drop_target_file;
#line 1724 "../src/View/AbstractDirectoryView.vala"
		if (_tmp5_ != NULL) {
#line 9684 "AbstractDirectoryView.c"
			FilesFile* _tmp6_;
#line 1725 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = self->priv->drop_target_file;
#line 1725 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = files_file_is_folder (_tmp6_);
#line 9690 "AbstractDirectoryView.c"
		} else {
#line 1724 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = FALSE;
#line 9694 "AbstractDirectoryView.c"
		}
#line 1724 "../src/View/AbstractDirectoryView.vala"
		if (_tmp4_) {
#line 9698 "AbstractDirectoryView.c"
			FilesFile* _tmp7_;
#line 1726 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = self->priv->drop_target_file;
#line 1726 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = files_file_is_writable (_tmp7_);
#line 9704 "AbstractDirectoryView.c"
		} else {
#line 1724 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = FALSE;
#line 9708 "AbstractDirectoryView.c"
		}
#line 1724 "../src/View/AbstractDirectoryView.vala"
		if (_tmp3_) {
#line 9712 "AbstractDirectoryView.c"
			FilesIconRenderer* _tmp8_;
			FilesFile* _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreePath* _tmp11_;
#line 1728 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->icon_renderer;
#line 1728 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->priv->drop_target_file;
#line 1728 "../src/View/AbstractDirectoryView.vala"
			g_object_set ((GObject*) _tmp8_, "drop-file", _tmp9_, NULL);
#line 1729 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = files_abstract_directory_view_get_path_at_pos (self, x, y);
#line 1729 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp10_;
#line 1729 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_highlight_path (self, _tmp11_);
#line 1729 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (_tmp11_);
#line 9731 "AbstractDirectoryView.c"
		}
#line 1732 "../src/View/AbstractDirectoryView.vala"
		self->priv->destination_data_ready = TRUE;
#line 9735 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp12_ = FALSE;
#line 1733 "../src/View/AbstractDirectoryView.vala"
		if (target != GDK_NONE) {
#line 9740 "AbstractDirectoryView.c"
			GList* _tmp13_;
#line 1733 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = self->priv->destination_drop_file_list;
#line 1733 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = _tmp13_ == NULL;
#line 9746 "AbstractDirectoryView.c"
		} else {
#line 1733 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = FALSE;
#line 9750 "AbstractDirectoryView.c"
		}
#line 1733 "../src/View/AbstractDirectoryView.vala"
		if (_tmp12_) {
#line 9754 "AbstractDirectoryView.c"
			GtkWidget* _tmp14_;
#line 1736 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = gtk_bin_get_child ((GtkBin*) self);
#line 1736 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_get_data (_tmp14_, context, target, (guint32) timestamp);
#line 9760 "AbstractDirectoryView.c"
		}
	}
#line 1715 "../src/View/AbstractDirectoryView.vala"
	_gtk_target_list_unref0 (list);
#line 9765 "AbstractDirectoryView.c"
}

static gboolean
_____lambda127_ (FilesAbstractDirectoryView* self)
{
	FilesFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 1774 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->drop_target_file;
#line 1774 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_file_get_target_location (_tmp0_);
#line 1774 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_load_location (self, _tmp1_);
#line 1775 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_enter_timer_id = (guint) 0;
#line 1776 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1776 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9786 "AbstractDirectoryView.c"
}

static gboolean
______lambda127__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda127_ ((FilesAbstractDirectoryView*) self);
#line 1770 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9796 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_check_destination_actions_and_target_file (FilesAbstractDirectoryView* self,
                                                                         GdkDragContext* context,
                                                                         gint x,
                                                                         gint y,
                                                                         guint timestamp)
{
	const gchar* _tmp0_ = NULL;
	FilesFile* _tmp1_;
	gchar* current_uri = NULL;
	gchar* _tmp5_;
	FilesFile* _tmp6_;
	const gchar* _tmp7_ = NULL;
	FilesFile* _tmp8_;
	gchar* uri = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 1741 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1741 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1742 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->drop_target_file;
#line 1742 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 9825 "AbstractDirectoryView.c"
		FilesFile* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1742 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->priv->drop_target_file;
#line 1742 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_file_get_uri (_tmp2_);
#line 1742 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 1742 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp4_;
#line 9837 "AbstractDirectoryView.c"
	} else {
#line 1742 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = "";
#line 9841 "AbstractDirectoryView.c"
	}
#line 1742 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 1742 "../src/View/AbstractDirectoryView.vala"
	current_uri = _tmp5_;
#line 1743 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = files_abstract_directory_view_get_drop_target_file (self, x, y);
#line 1743 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->drop_target_file);
#line 1743 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_target_file = _tmp6_;
#line 1744 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->priv->drop_target_file;
#line 1744 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_ != NULL) {
#line 9857 "AbstractDirectoryView.c"
		FilesFile* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1744 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = self->priv->drop_target_file;
#line 1744 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_file_get_uri (_tmp9_);
#line 1744 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 1744 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp11_;
#line 9869 "AbstractDirectoryView.c"
	} else {
#line 1744 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = "";
#line 9873 "AbstractDirectoryView.c"
	}
#line 1744 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = g_strdup (_tmp7_);
#line 1744 "../src/View/AbstractDirectoryView.vala"
	uri = _tmp12_;
#line 1746 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = uri;
#line 1746 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = current_uri;
#line 1746 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp13_, _tmp14_) != 0) {
#line 9885 "AbstractDirectoryView.c"
		FilesFile* _tmp15_;
#line 1747 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
#line 1748 "../src/View/AbstractDirectoryView.vala"
		self->priv->current_actions = GDK_ACTION_DEFAULT;
#line 1749 "../src/View/AbstractDirectoryView.vala"
		self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
#line 1751 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = self->priv->drop_target_file;
#line 1751 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_ != NULL) {
#line 9897 "AbstractDirectoryView.c"
			FilesFile* _tmp20_;
			GtkTreePath* _tmp21_;
			GtkTreePath* _tmp22_;
			gboolean _tmp23_ = FALSE;
			FilesFile* _tmp24_;
#line 1752 "../src/View/AbstractDirectoryView.vala"
			if (self->current_target_type == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 1753 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_suggested_action = GDK_ACTION_COPY;
#line 1754 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_actions = self->priv->current_suggested_action;
#line 9909 "AbstractDirectoryView.c"
			} else {
				FilesFile* _tmp16_;
				GList* _tmp17_;
				GdkDragAction _tmp18_ = 0U;
				GdkDragAction _tmp19_;
#line 1757 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->drop_target_file;
#line 1757 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = self->priv->destination_drop_file_list;
#line 1757 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = files_dnd_handler_file_accepts_drop (_tmp16_, _tmp17_, gdk_drag_context_get_selected_action (context), gdk_drag_context_get_actions (context), &_tmp18_);
#line 1757 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_suggested_action = _tmp18_;
#line 1757 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_actions = _tmp19_;
#line 9925 "AbstractDirectoryView.c"
			}
#line 1766 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = self->priv->drop_target_file;
#line 1766 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = files_abstract_directory_view_get_path_at_pos (self, x, y);
#line 1766 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = _tmp21_;
#line 1766 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_highlight_drop_file (self, _tmp20_, self->priv->current_actions, _tmp22_);
#line 1766 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (_tmp22_);
#line 1768 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = self->priv->drop_target_file;
#line 1768 "../src/View/AbstractDirectoryView.vala"
			if (files_file_is_folder (_tmp24_)) {
#line 9941 "AbstractDirectoryView.c"
				FilesFile* _tmp25_;
#line 1768 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = self->priv->drop_target_file;
#line 1768 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = files_abstract_directory_view_is_valid_drop_folder (self, _tmp25_);
#line 9947 "AbstractDirectoryView.c"
			} else {
#line 1768 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = FALSE;
#line 9951 "AbstractDirectoryView.c"
			}
#line 1768 "../src/View/AbstractDirectoryView.vala"
			if (_tmp23_) {
#line 1770 "../src/View/AbstractDirectoryView.vala"
				self->priv->drag_enter_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 1000, ______lambda127__gsource_func, g_object_ref (self), g_object_unref);
#line 9957 "AbstractDirectoryView.c"
			}
		}
	}
#line 1741 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (uri);
#line 1741 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (current_uri);
#line 9965 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_is_valid_drop_folder (FilesAbstractDirectoryView* self,
                                                    FilesFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	FilesViewSlot* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 1783 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1783 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1785 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_uri (file);
#line 1785 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1785 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->slot;
#line 1785 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_slot_get_uri ((FilesAbstractSlot*) _tmp4_);
#line 1785 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 1785 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp3_, _tmp6_) != 0) {
#line 9996 "AbstractDirectoryView.c"
		GList* _tmp7_;
#line 1786 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->source_drag_file_list;
#line 1786 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp7_ != NULL;
#line 10002 "AbstractDirectoryView.c"
	} else {
#line 1785 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = FALSE;
#line 10006 "AbstractDirectoryView.c"
	}
#line 1785 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 10010 "AbstractDirectoryView.c"
		GList* _tmp8_;
#line 1787 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->source_drag_file_list;
#line 1787 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_list_index (_tmp8_, file) < 0;
#line 10016 "AbstractDirectoryView.c"
	} else {
#line 1785 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 10020 "AbstractDirectoryView.c"
	}
#line 1785 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 1789 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 1789 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 10028 "AbstractDirectoryView.c"
	} else {
#line 1791 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 1791 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 10034 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_highlight_drop_file (FilesAbstractDirectoryView* self,
                                                   FilesFile* drop_file,
                                                   GdkDragAction action,
                                                   GtkTreePath* path)
{
	gboolean can_drop = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesFile* _tmp2_ = NULL;
	FilesIconRenderer* _tmp3_;
	GtkTreePath* _tmp4_ = NULL;
#line 1795 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1795 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (drop_file != NULL);
#line 1796 "../src/View/AbstractDirectoryView.vala"
	can_drop = action > GDK_ACTION_DEFAULT;
#line 1798 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_drop_highlight (self);
#line 1798 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1798 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != can_drop) {
#line 1799 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_drop_highlight (self, can_drop);
#line 1800 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 10066 "AbstractDirectoryView.c"
	}
#line 1804 "../src/View/AbstractDirectoryView.vala"
	if (can_drop) {
#line 1804 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = drop_file;
#line 10072 "AbstractDirectoryView.c"
	} else {
#line 1804 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = NULL;
#line 10076 "AbstractDirectoryView.c"
	}
#line 1804 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->icon_renderer;
#line 1804 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_drop_file (_tmp3_, _tmp2_);
#line 1806 "../src/View/AbstractDirectoryView.vala"
	if (can_drop) {
#line 1806 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = path;
#line 10086 "AbstractDirectoryView.c"
	} else {
#line 1806 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = NULL;
#line 10090 "AbstractDirectoryView.c"
	}
#line 1806 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_highlight_path (self, _tmp4_);
#line 10094 "AbstractDirectoryView.c"
}

/** MENU FUNCTIONS */
static GVariant*
_variant_new2 (const gchar* value)
{
#line 1855 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 10103 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new3 (const gchar* value)
{
#line 1871 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 10111 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_show_context_menu (FilesAbstractDirectoryView* self,
                                                 GdkEvent* event)
{
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
	GtkMenu* menu = NULL;
	GtkMenu* _tmp2_;
	GList* selection = NULL;
	GList* _tmp3_;
	FilesFile* selected_file = NULL;
	GList* _tmp4_;
	gconstpointer _tmp5_;
	FilesFile* _tmp6_;
	GtkMenu* open_submenu = NULL;
	GtkMenu* _tmp7_;
	GSimpleActionGroup* _tmp8_;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	FilesFile* _tmp42_;
	GtkMenuItem* open_submenu_item = NULL;
	GtkMenuItem* _tmp125_;
	GtkMenu* _tmp126_;
	GList* _tmp127_;
	GList* _tmp128_;
	gboolean _tmp129_;
	GtkMenuItem* paste_menuitem = NULL;
	GtkMenuItem* _tmp139_;
	GtkMenuItem* _tmp140_;
	GtkMenuItem* bookmark_menuitem = NULL;
	GtkMenuItem* _tmp141_;
	GtkMenuItem* _tmp142_;
	GraniteAccelLabel* _tmp143_;
	GraniteAccelLabel* _tmp144_;
	GtkMenuItem* _tmp145_;
	GtkMenuItem* properties_menuitem = NULL;
	GtkMenuItem* _tmp146_;
	GtkMenuItem* _tmp147_;
	GraniteAccelLabel* _tmp148_;
	GraniteAccelLabel* _tmp149_;
	GtkMenuItem* _tmp150_;
	GtkMenuItem* select_all_menuitem = NULL;
	GtkMenuItem* deselect_all_menuitem = NULL;
	GtkMenuItem* invert_selection_menuitem = NULL;
	GList* _tmp176_;
	GtkMenu* _tmp434_;
	GtkMenu* _tmp435_;
	FilesViewSlot* _tmp436_;
	FilesDirectory* _tmp437_;
	FilesDirectory* _tmp438_;
	GtkMenu* _tmp441_;
	GtkMenu* _tmp442_;
#line 1828 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (event != NULL);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_window (self);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "window != null");
#line 1830 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 1832 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = (GtkMenu*) gtk_menu_new ();
#line 1832 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp2_);
#line 1832 "../src/View/AbstractDirectoryView.vala"
	menu = _tmp2_;
#line 1834 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_directory_view_get_files_for_action (self);
#line 1834 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp3_;
#line 1835 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = selection;
#line 1835 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_->data;
#line 1835 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _g_object_ref0 ((FilesFile*) _tmp5_);
#line 1835 "../src/View/AbstractDirectoryView.vala"
	selected_file = _tmp6_;
#line 1837 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = (GtkMenu*) gtk_menu_new ();
#line 1837 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp7_);
#line 1837 "../src/View/AbstractDirectoryView.vala"
	open_submenu = _tmp7_;
#line 1839 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->priv->common_actions;
#line 1839 "../src/View/AbstractDirectoryView.vala"
	if (g_action_group_get_action_enabled ((GActionGroup*) _tmp8_, "open-in")) {
#line 10206 "AbstractDirectoryView.c"
		GtkMenuItem* new_tab_menuitem = NULL;
		GtkMenuItem* _tmp9_;
		GList* _tmp10_;
		GtkMenuItem* _tmp19_;
		GVariant* _tmp20_;
		GtkMenuItem* new_window_menuitem = NULL;
		GtkMenuItem* _tmp21_;
		GList* _tmp22_;
		GtkMenuItem* _tmp31_;
		GVariant* _tmp32_;
		GtkMenu* _tmp33_;
		GtkMenuItem* _tmp34_;
		GtkMenu* _tmp35_;
		GtkMenuItem* _tmp36_;
		GtkMenu* _tmp37_;
		GtkSeparatorMenuItem* _tmp38_;
		GtkSeparatorMenuItem* _tmp39_;
#line 1840 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1840 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp9_);
#line 1840 "../src/View/AbstractDirectoryView.vala"
		new_tab_menuitem = _tmp9_;
#line 1841 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->selected_files;
#line 1841 "../src/View/AbstractDirectoryView.vala"
		if (_tmp10_ != NULL) {
#line 10234 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp11_;
			GraniteAccelLabel* _tmp12_;
			GraniteAccelLabel* _tmp13_;
			GtkMenuItem* _tmp14_;
#line 1842 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = new_tab_menuitem;
#line 1842 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = granite_accel_label_new (_ ("New Tab"), "<Shift>Return");
#line 1842 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp12_);
#line 1842 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = _tmp12_;
#line 1842 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp13_);
#line 1842 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp13_);
#line 1846 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = new_tab_menuitem;
#line 1846 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp14_, "common.open-in");
#line 10255 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp15_;
			GraniteAccelLabel* _tmp16_;
			GraniteAccelLabel* _tmp17_;
			GtkMenuItem* _tmp18_;
#line 1848 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = new_tab_menuitem;
#line 1848 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = granite_accel_label_new_from_action_name (_ ("New Tab"), "win.tab::TAB");
#line 1848 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp16_);
#line 1848 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = _tmp16_;
#line 1848 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp17_);
#line 1848 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp17_);
#line 1852 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = new_tab_menuitem;
#line 1852 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp18_, "win.tab");
#line 10277 "AbstractDirectoryView.c"
		}
#line 1855 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = new_tab_menuitem;
#line 1855 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = _variant_new2 ("TAB");
#line 1855 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkActionable*) _tmp19_, "action-target", _tmp20_, NULL);
#line 1855 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (_tmp20_);
#line 1857 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1857 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp21_);
#line 1857 "../src/View/AbstractDirectoryView.vala"
		new_window_menuitem = _tmp21_;
#line 1858 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = self->selected_files;
#line 1858 "../src/View/AbstractDirectoryView.vala"
		if (_tmp22_ != NULL) {
#line 10297 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp23_;
			GraniteAccelLabel* _tmp24_;
			GraniteAccelLabel* _tmp25_;
			GtkMenuItem* _tmp26_;
#line 1859 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = new_window_menuitem;
#line 1859 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = granite_accel_label_new (_ ("New Window"), "<Shift><Ctrl>Return");
#line 1859 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp24_);
#line 1859 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = _tmp24_;
#line 1859 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp25_);
#line 1859 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp25_);
#line 1863 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = new_window_menuitem;
#line 1863 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp26_, "common.open-in");
#line 10318 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp27_;
			GraniteAccelLabel* _tmp28_;
			GraniteAccelLabel* _tmp29_;
			GtkMenuItem* _tmp30_;
#line 1865 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = new_window_menuitem;
#line 1865 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = granite_accel_label_new_from_action_name (_ ("New Window"), "win.tab::WINDOW");
#line 1865 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp28_);
#line 1865 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = _tmp28_;
#line 1865 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp29_);
#line 1865 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp29_);
#line 1869 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = new_window_menuitem;
#line 1869 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp30_, "win.tab");
#line 10340 "AbstractDirectoryView.c"
		}
#line 1871 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = new_window_menuitem;
#line 1871 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = _variant_new3 ("WINDOW");
#line 1871 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkActionable*) _tmp31_, "action-target", _tmp32_, NULL);
#line 1871 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (_tmp32_);
#line 1873 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = open_submenu;
#line 1873 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = new_tab_menuitem;
#line 1873 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 1874 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = open_submenu;
#line 1874 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = new_window_menuitem;
#line 1874 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
#line 1875 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = open_submenu;
#line 1875 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1875 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp38_);
#line 1875 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = _tmp38_;
#line 1875 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp39_);
#line 1875 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp39_);
#line 1839 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (new_window_menuitem);
#line 1839 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (new_tab_menuitem);
#line 10378 "AbstractDirectoryView.c"
	}
#line 1878 "../src/View/AbstractDirectoryView.vala"
	_tmp42_ = selected_file;
#line 1878 "../src/View/AbstractDirectoryView.vala"
	if (!files_file_is_mountable (_tmp42_)) {
#line 10384 "AbstractDirectoryView.c"
		FilesFile* _tmp43_;
#line 1879 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = selected_file;
#line 1879 "../src/View/AbstractDirectoryView.vala"
		_tmp41_ = !files_file_is_root_network_folder (_tmp43_);
#line 10390 "AbstractDirectoryView.c"
	} else {
#line 1878 "../src/View/AbstractDirectoryView.vala"
		_tmp41_ = FALSE;
#line 10394 "AbstractDirectoryView.c"
	}
#line 1878 "../src/View/AbstractDirectoryView.vala"
	if (_tmp41_) {
#line 10398 "AbstractDirectoryView.c"
		FilesFile* _tmp44_;
#line 1880 "../src/View/AbstractDirectoryView.vala"
		_tmp44_ = selected_file;
#line 1880 "../src/View/AbstractDirectoryView.vala"
		_tmp40_ = files_abstract_directory_view_can_open_file (self, _tmp44_, FALSE);
#line 10404 "AbstractDirectoryView.c"
	} else {
#line 1878 "../src/View/AbstractDirectoryView.vala"
		_tmp40_ = FALSE;
#line 10408 "AbstractDirectoryView.c"
	}
#line 1878 "../src/View/AbstractDirectoryView.vala"
	if (_tmp40_) {
#line 10412 "AbstractDirectoryView.c"
		gboolean _tmp45_ = FALSE;
		FilesFile* _tmp46_;
		GList* _tmp67_;
		GList* _tmp68_;
		FilesFile* _tmp69_;
		gboolean _tmp70_ = FALSE;
		GList* _tmp71_;
		gboolean _tmp116_ = FALSE;
		GList* _tmp117_;
#line 1882 "../src/View/AbstractDirectoryView.vala"
		_tmp46_ = selected_file;
#line 1882 "../src/View/AbstractDirectoryView.vala"
		if (!files_file_is_folder (_tmp46_)) {
#line 10426 "AbstractDirectoryView.c"
			FilesFile* _tmp47_;
#line 1882 "../src/View/AbstractDirectoryView.vala"
			_tmp47_ = selected_file;
#line 1882 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = files_file_is_executable (_tmp47_);
#line 10432 "AbstractDirectoryView.c"
		} else {
#line 1882 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = FALSE;
#line 10436 "AbstractDirectoryView.c"
		}
#line 1882 "../src/View/AbstractDirectoryView.vala"
		if (_tmp45_) {
#line 10440 "AbstractDirectoryView.c"
			GtkMenuItem* run_menuitem = NULL;
			GtkMenuItem* _tmp48_;
			GtkMenuItem* _tmp49_;
			GtkMenu* _tmp50_;
			GtkMenuItem* _tmp51_;
#line 1883 "../src/View/AbstractDirectoryView.vala"
			_tmp48_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Run"));
#line 1883 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp48_);
#line 1883 "../src/View/AbstractDirectoryView.vala"
			run_menuitem = _tmp48_;
#line 1884 "../src/View/AbstractDirectoryView.vala"
			_tmp49_ = run_menuitem;
#line 1884 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp49_, "selection.open");
#line 1886 "../src/View/AbstractDirectoryView.vala"
			_tmp50_ = menu;
#line 1886 "../src/View/AbstractDirectoryView.vala"
			_tmp51_ = run_menuitem;
#line 1886 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 1882 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (run_menuitem);
#line 10464 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp52_ = FALSE;
			GAppInfo* _tmp53_;
#line 1887 "../src/View/AbstractDirectoryView.vala"
			_tmp53_ = self->priv->default_app;
#line 1887 "../src/View/AbstractDirectoryView.vala"
			if (_tmp53_ != NULL) {
#line 10472 "AbstractDirectoryView.c"
				GAppInfo* _tmp54_;
				const gchar* _tmp55_;
#line 1887 "../src/View/AbstractDirectoryView.vala"
				_tmp54_ = self->priv->default_app;
#line 1887 "../src/View/AbstractDirectoryView.vala"
				_tmp55_ = g_app_info_get_id (_tmp54_);
#line 1887 "../src/View/AbstractDirectoryView.vala"
				_tmp52_ = g_strcmp0 (_tmp55_, FILES_APP_ID ".desktop") != 0;
#line 10481 "AbstractDirectoryView.c"
			} else {
#line 1887 "../src/View/AbstractDirectoryView.vala"
				_tmp52_ = FALSE;
#line 10485 "AbstractDirectoryView.c"
			}
#line 1887 "../src/View/AbstractDirectoryView.vala"
			if (_tmp52_) {
#line 10489 "AbstractDirectoryView.c"
				GtkMenuItem* open_menuitem = NULL;
				GtkMenuItem* _tmp56_;
				GtkMenuItem* _tmp57_;
				GAppInfo* _tmp58_;
				const gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				GraniteAccelLabel* _tmp62_;
				GraniteAccelLabel* _tmp63_;
				GtkMenuItem* _tmp64_;
				GtkMenu* _tmp65_;
				GtkMenuItem* _tmp66_;
#line 1888 "../src/View/AbstractDirectoryView.vala"
				_tmp56_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1888 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp56_);
#line 1888 "../src/View/AbstractDirectoryView.vala"
				open_menuitem = _tmp56_;
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp57_ = open_menuitem;
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp58_ = self->priv->default_app;
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp59_ = g_app_info_get_display_name (_tmp58_);
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = g_strdup_printf (_ ("Open in %s"), _tmp59_);
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp61_ = _tmp60_;
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp62_ = granite_accel_label_new (_tmp61_, "Return");
#line 1889 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp62_);
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_tmp63_ = _tmp62_;
#line 1889 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp63_);
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp63_);
#line 1889 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp61_);
#line 1893 "../src/View/AbstractDirectoryView.vala"
				_tmp64_ = open_menuitem;
#line 1893 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp64_, "selection.open-with-default");
#line 1895 "../src/View/AbstractDirectoryView.vala"
				_tmp65_ = menu;
#line 1895 "../src/View/AbstractDirectoryView.vala"
				_tmp66_ = open_menuitem;
#line 1895 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp65_, (GtkWidget*) _tmp66_);
#line 1887 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (open_menuitem);
#line 10542 "AbstractDirectoryView.c"
			}
		}
#line 1898 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = selection;
#line 1898 "../src/View/AbstractDirectoryView.vala"
		_tmp68_ = files_mime_actions_get_applications_for_files (_tmp67_);
#line 1898 "../src/View/AbstractDirectoryView.vala"
		(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
#line 1898 "../src/View/AbstractDirectoryView.vala"
		self->priv->open_with_apps = _tmp68_;
#line 1900 "../src/View/AbstractDirectoryView.vala"
		_tmp69_ = selected_file;
#line 1900 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_executable (_tmp69_) == FALSE) {
#line 1901 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_filter_default_app_from_open_with_apps (self);
#line 10559 "AbstractDirectoryView.c"
		}
#line 1904 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_filter_this_app_from_open_with_apps (self);
#line 1906 "../src/View/AbstractDirectoryView.vala"
		_tmp71_ = self->priv->open_with_apps;
#line 1906 "../src/View/AbstractDirectoryView.vala"
		if (_tmp71_ != NULL) {
#line 10567 "AbstractDirectoryView.c"
			GList* _tmp72_;
			gconstpointer _tmp73_;
#line 1906 "../src/View/AbstractDirectoryView.vala"
			_tmp72_ = self->priv->open_with_apps;
#line 1906 "../src/View/AbstractDirectoryView.vala"
			_tmp73_ = _tmp72_->data;
#line 1906 "../src/View/AbstractDirectoryView.vala"
			_tmp70_ = ((GAppInfo*) _tmp73_) != NULL;
#line 10576 "AbstractDirectoryView.c"
		} else {
#line 1906 "../src/View/AbstractDirectoryView.vala"
			_tmp70_ = FALSE;
#line 10580 "AbstractDirectoryView.c"
		}
#line 1906 "../src/View/AbstractDirectoryView.vala"
		if (_tmp70_) {
#line 10584 "AbstractDirectoryView.c"
			const gchar* last_label = NULL;
			const gchar* last_exec = NULL;
			guint count = 0U;
			GList* _tmp74_;
#line 1907 "../src/View/AbstractDirectoryView.vala"
			last_label = "";
#line 1908 "../src/View/AbstractDirectoryView.vala"
			last_exec = "";
#line 1909 "../src/View/AbstractDirectoryView.vala"
			count = (guint) 0;
#line 1911 "../src/View/AbstractDirectoryView.vala"
			_tmp74_ = self->priv->open_with_apps;
#line 10597 "AbstractDirectoryView.c"
			{
				GList* app_info_collection = NULL;
				GList* app_info_it = NULL;
#line 1911 "../src/View/AbstractDirectoryView.vala"
				app_info_collection = _tmp74_;
#line 1911 "../src/View/AbstractDirectoryView.vala"
				for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
#line 10605 "AbstractDirectoryView.c"
					GAppInfo* app_info = NULL;
#line 1911 "../src/View/AbstractDirectoryView.vala"
					app_info = (GAppInfo*) app_info_it->data;
#line 10609 "AbstractDirectoryView.c"
					{
						const gchar* label = NULL;
						GAppInfo* _tmp75_;
						const gchar* _tmp76_;
						const gchar* exec = NULL;
						GAppInfo* _tmp77_;
						const gchar* _tmp78_;
						gchar** _tmp79_;
						gchar** _tmp80_;
						gchar** _tmp81_;
						gint _tmp81__length1;
						const gchar* _tmp82_;
						const gchar* _tmp83_;
						gboolean _tmp84_ = FALSE;
						const gchar* _tmp85_;
						const gchar* _tmp86_;
						const gchar* _tmp110_;
						const gchar* _tmp111_;
						guint _tmp112_;
#line 1913 "../src/View/AbstractDirectoryView.vala"
						_tmp75_ = app_info;
#line 1913 "../src/View/AbstractDirectoryView.vala"
						_tmp76_ = g_app_info_get_display_name (_tmp75_);
#line 1913 "../src/View/AbstractDirectoryView.vala"
						label = _tmp76_;
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp77_ = app_info;
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp78_ = g_app_info_get_executable (_tmp77_);
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp80_ = _tmp79_ = g_strsplit (_tmp78_, " ", 0);
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = _tmp80_;
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp81__length1 = _vala_array_length (_tmp79_);
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp82_ = _tmp81_[0];
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp83_ = _tmp82_;
#line 1914 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = (_vala_array_free (_tmp81_, _tmp81__length1, (GDestroyNotify) g_free), NULL);
#line 1914 "../src/View/AbstractDirectoryView.vala"
						exec = _tmp83_;
#line 1915 "../src/View/AbstractDirectoryView.vala"
						_tmp85_ = label;
#line 1915 "../src/View/AbstractDirectoryView.vala"
						_tmp86_ = last_label;
#line 1915 "../src/View/AbstractDirectoryView.vala"
						if (g_strcmp0 (_tmp85_, _tmp86_) != 0) {
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_tmp84_ = TRUE;
#line 10661 "AbstractDirectoryView.c"
						} else {
							const gchar* _tmp87_;
							const gchar* _tmp88_;
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_tmp87_ = exec;
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_tmp88_ = last_exec;
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_tmp84_ = g_strcmp0 (_tmp87_, _tmp88_) != 0;
#line 10671 "AbstractDirectoryView.c"
						}
#line 1915 "../src/View/AbstractDirectoryView.vala"
						if (_tmp84_) {
#line 10675 "AbstractDirectoryView.c"
							GtkImage* app_image = NULL;
							GAppInfo* _tmp89_;
							GIcon* _tmp90_;
							GtkImage* _tmp91_;
							GtkImage* _tmp92_;
							GtkGrid* label_grid = NULL;
							GtkGrid* _tmp93_;
							GtkGrid* _tmp94_;
							GtkImage* _tmp95_;
							GtkGrid* _tmp96_;
							const gchar* _tmp97_;
							GtkLabel* _tmp98_;
							GtkLabel* _tmp99_;
							GtkMenuItem* menuitem = NULL;
							GtkMenuItem* _tmp100_;
							GtkMenuItem* _tmp101_;
							GtkGrid* _tmp102_;
							GtkMenuItem* _tmp103_;
							GVariant* _tmp104_;
							GVariant* _tmp105_;
							gchar* _tmp106_;
							gchar* _tmp107_;
							GtkMenu* _tmp108_;
							GtkMenuItem* _tmp109_;
#line 1916 "../src/View/AbstractDirectoryView.vala"
							_tmp89_ = app_info;
#line 1916 "../src/View/AbstractDirectoryView.vala"
							_tmp90_ = g_app_info_get_icon (_tmp89_);
#line 1916 "../src/View/AbstractDirectoryView.vala"
							_tmp91_ = (GtkImage*) gtk_image_new_from_gicon (_tmp90_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 1916 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp91_);
#line 1916 "../src/View/AbstractDirectoryView.vala"
							app_image = _tmp91_;
#line 1920 "../src/View/AbstractDirectoryView.vala"
							_tmp92_ = app_image;
#line 1920 "../src/View/AbstractDirectoryView.vala"
							gtk_image_set_pixel_size (_tmp92_, 16);
#line 1922 "../src/View/AbstractDirectoryView.vala"
							_tmp93_ = (GtkGrid*) gtk_grid_new ();
#line 1922 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp93_);
#line 1922 "../src/View/AbstractDirectoryView.vala"
							label_grid = _tmp93_;
#line 1923 "../src/View/AbstractDirectoryView.vala"
							_tmp94_ = label_grid;
#line 1923 "../src/View/AbstractDirectoryView.vala"
							_tmp95_ = app_image;
#line 1923 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp95_);
#line 1924 "../src/View/AbstractDirectoryView.vala"
							_tmp96_ = label_grid;
#line 1924 "../src/View/AbstractDirectoryView.vala"
							_tmp97_ = label;
#line 1924 "../src/View/AbstractDirectoryView.vala"
							_tmp98_ = (GtkLabel*) gtk_label_new (_tmp97_);
#line 1924 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp98_);
#line 1924 "../src/View/AbstractDirectoryView.vala"
							_tmp99_ = _tmp98_;
#line 1924 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp96_, (GtkWidget*) _tmp99_);
#line 1924 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp99_);
#line 1926 "../src/View/AbstractDirectoryView.vala"
							_tmp100_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1926 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp100_);
#line 1926 "../src/View/AbstractDirectoryView.vala"
							menuitem = _tmp100_;
#line 1927 "../src/View/AbstractDirectoryView.vala"
							_tmp101_ = menuitem;
#line 1927 "../src/View/AbstractDirectoryView.vala"
							_tmp102_ = label_grid;
#line 1927 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp101_, (GtkWidget*) _tmp102_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_tmp103_ = menuitem;
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_tmp104_ = g_variant_new_uint32 ((guint32) count);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							g_variant_ref_sink (_tmp104_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_tmp105_ = _tmp104_;
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_tmp106_ = g_action_print_detailed_name ("selection.open-with-app", _tmp105_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_tmp107_ = _tmp106_;
#line 1928 "../src/View/AbstractDirectoryView.vala"
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp103_, _tmp107_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp107_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
							_g_variant_unref0 (_tmp105_);
#line 1933 "../src/View/AbstractDirectoryView.vala"
							_tmp108_ = open_submenu;
#line 1933 "../src/View/AbstractDirectoryView.vala"
							_tmp109_ = menuitem;
#line 1933 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp108_, (GtkWidget*) _tmp109_);
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (menuitem);
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (label_grid);
#line 1915 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (app_image);
#line 10782 "AbstractDirectoryView.c"
						}
#line 1936 "../src/View/AbstractDirectoryView.vala"
						_tmp110_ = label;
#line 1936 "../src/View/AbstractDirectoryView.vala"
						last_label = _tmp110_;
#line 1937 "../src/View/AbstractDirectoryView.vala"
						_tmp111_ = exec;
#line 1937 "../src/View/AbstractDirectoryView.vala"
						last_exec = _tmp111_;
#line 1938 "../src/View/AbstractDirectoryView.vala"
						_tmp112_ = count;
#line 1938 "../src/View/AbstractDirectoryView.vala"
						count = _tmp112_ + 1;
#line 10796 "AbstractDirectoryView.c"
					}
				}
			}
#line 1941 "../src/View/AbstractDirectoryView.vala"
			if (count > ((guint) 0)) {
#line 10802 "AbstractDirectoryView.c"
				GtkMenu* _tmp113_;
				GtkSeparatorMenuItem* _tmp114_;
				GtkSeparatorMenuItem* _tmp115_;
#line 1942 "../src/View/AbstractDirectoryView.vala"
				_tmp113_ = open_submenu;
#line 1942 "../src/View/AbstractDirectoryView.vala"
				_tmp114_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1942 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp114_);
#line 1942 "../src/View/AbstractDirectoryView.vala"
				_tmp115_ = _tmp114_;
#line 1942 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp113_, (GtkWidget*) _tmp115_);
#line 1942 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp115_);
#line 10818 "AbstractDirectoryView.c"
			}
		}
#line 1946 "../src/View/AbstractDirectoryView.vala"
		_tmp117_ = selection;
#line 1946 "../src/View/AbstractDirectoryView.vala"
		if (_tmp117_ != NULL) {
#line 10825 "AbstractDirectoryView.c"
			GList* _tmp118_;
			GList* _tmp119_;
			GList* _tmp120_;
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_tmp118_ = selection;
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_tmp119_ = g_list_first (_tmp118_);
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_tmp120_ = _tmp119_->next;
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_tmp116_ = _tmp120_ == NULL;
#line 10837 "AbstractDirectoryView.c"
		} else {
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_tmp116_ = FALSE;
#line 10841 "AbstractDirectoryView.c"
		}
#line 1946 "../src/View/AbstractDirectoryView.vala"
		if (_tmp116_) {
#line 10845 "AbstractDirectoryView.c"
			GtkMenuItem* other_apps_menuitem = NULL;
			GtkMenuItem* _tmp121_;
			GtkMenuItem* _tmp122_;
			GtkMenu* _tmp123_;
			GtkMenuItem* _tmp124_;
#line 1947 "../src/View/AbstractDirectoryView.vala"
			_tmp121_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Other Application…"));
#line 1947 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp121_);
#line 1947 "../src/View/AbstractDirectoryView.vala"
			other_apps_menuitem = _tmp121_;
#line 1948 "../src/View/AbstractDirectoryView.vala"
			_tmp122_ = other_apps_menuitem;
#line 1948 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp122_, "selection.open-with-other-app");
#line 1950 "../src/View/AbstractDirectoryView.vala"
			_tmp123_ = open_submenu;
#line 1950 "../src/View/AbstractDirectoryView.vala"
			_tmp124_ = other_apps_menuitem;
#line 1950 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp123_, (GtkWidget*) _tmp124_);
#line 1946 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (other_apps_menuitem);
#line 10869 "AbstractDirectoryView.c"
		}
	}
#line 1954 "../src/View/AbstractDirectoryView.vala"
	_tmp125_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1954 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp125_);
#line 1954 "../src/View/AbstractDirectoryView.vala"
	open_submenu_item = _tmp125_;
#line 1955 "../src/View/AbstractDirectoryView.vala"
	_tmp126_ = open_submenu;
#line 1955 "../src/View/AbstractDirectoryView.vala"
	_tmp127_ = gtk_container_get_children ((GtkContainer*) _tmp126_);
#line 1955 "../src/View/AbstractDirectoryView.vala"
	_tmp128_ = _tmp127_;
#line 1955 "../src/View/AbstractDirectoryView.vala"
	_tmp129_ = g_list_length (_tmp128_) > ((guint) 0);
#line 1955 "../src/View/AbstractDirectoryView.vala"
	(_tmp128_ == NULL) ? NULL : (_tmp128_ = (g_list_free (_tmp128_), NULL));
#line 1955 "../src/View/AbstractDirectoryView.vala"
	if (_tmp129_) {
#line 10890 "AbstractDirectoryView.c"
		GtkMenuItem* _tmp130_;
		GtkMenu* _tmp131_;
		gboolean _tmp132_ = FALSE;
		FilesFile* _tmp133_;
		GtkMenu* _tmp137_;
		GtkMenuItem* _tmp138_;
#line 1956 "../src/View/AbstractDirectoryView.vala"
		_tmp130_ = open_submenu_item;
#line 1956 "../src/View/AbstractDirectoryView.vala"
		_tmp131_ = open_submenu;
#line 1956 "../src/View/AbstractDirectoryView.vala"
		gtk_menu_item_set_submenu (_tmp130_, _tmp131_);
#line 1958 "../src/View/AbstractDirectoryView.vala"
		_tmp133_ = selected_file;
#line 1958 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp133_)) {
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp132_ = TRUE;
#line 10909 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp134_;
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp134_ = selected_file;
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp132_ = files_file_is_root_network_folder (_tmp134_);
#line 10916 "AbstractDirectoryView.c"
		}
#line 1958 "../src/View/AbstractDirectoryView.vala"
		if (_tmp132_) {
#line 10920 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp135_;
#line 1959 "../src/View/AbstractDirectoryView.vala"
			_tmp135_ = open_submenu_item;
#line 1959 "../src/View/AbstractDirectoryView.vala"
			gtk_menu_item_set_label (_tmp135_, _ ("Open in"));
#line 10926 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp136_;
#line 1961 "../src/View/AbstractDirectoryView.vala"
			_tmp136_ = open_submenu_item;
#line 1961 "../src/View/AbstractDirectoryView.vala"
			gtk_menu_item_set_label (_tmp136_, _ ("Open with"));
#line 10933 "AbstractDirectoryView.c"
		}
#line 1964 "../src/View/AbstractDirectoryView.vala"
		_tmp137_ = menu;
#line 1964 "../src/View/AbstractDirectoryView.vala"
		_tmp138_ = open_submenu_item;
#line 1964 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp137_, (GtkWidget*) _tmp138_);
#line 10941 "AbstractDirectoryView.c"
	}
#line 1967 "../src/View/AbstractDirectoryView.vala"
	_tmp139_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1967 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp139_);
#line 1967 "../src/View/AbstractDirectoryView.vala"
	paste_menuitem = _tmp139_;
#line 1968 "../src/View/AbstractDirectoryView.vala"
	_tmp140_ = paste_menuitem;
#line 1968 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp140_, "common.paste");
#line 1970 "../src/View/AbstractDirectoryView.vala"
	_tmp141_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1970 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp141_);
#line 1970 "../src/View/AbstractDirectoryView.vala"
	bookmark_menuitem = _tmp141_;
#line 1971 "../src/View/AbstractDirectoryView.vala"
	_tmp142_ = bookmark_menuitem;
#line 1971 "../src/View/AbstractDirectoryView.vala"
	_tmp143_ = granite_accel_label_new (_ ("Add to Bookmarks"), "<Ctrl>d");
#line 1971 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp143_);
#line 1971 "../src/View/AbstractDirectoryView.vala"
	_tmp144_ = _tmp143_;
#line 1971 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp142_, (GtkWidget*) _tmp144_);
#line 1971 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp144_);
#line 1975 "../src/View/AbstractDirectoryView.vala"
	_tmp145_ = bookmark_menuitem;
#line 1975 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp145_, "common.bookmark");
#line 1977 "../src/View/AbstractDirectoryView.vala"
	_tmp146_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1977 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp146_);
#line 1977 "../src/View/AbstractDirectoryView.vala"
	properties_menuitem = _tmp146_;
#line 1978 "../src/View/AbstractDirectoryView.vala"
	_tmp147_ = properties_menuitem;
#line 1978 "../src/View/AbstractDirectoryView.vala"
	_tmp148_ = granite_accel_label_new (_ ("Properties"), "<Alt>Return");
#line 1978 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp148_);
#line 1978 "../src/View/AbstractDirectoryView.vala"
	_tmp149_ = _tmp148_;
#line 1978 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp147_, (GtkWidget*) _tmp149_);
#line 1978 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp149_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
	_tmp150_ = properties_menuitem;
#line 1982 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp150_, "common.properties");
#line 1984 "../src/View/AbstractDirectoryView.vala"
	select_all_menuitem = NULL;
#line 1985 "../src/View/AbstractDirectoryView.vala"
	deselect_all_menuitem = NULL;
#line 1986 "../src/View/AbstractDirectoryView.vala"
	invert_selection_menuitem = NULL;
#line 1987 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->all_selected) {
#line 11005 "AbstractDirectoryView.c"
		gchar* _tmp151_;
		GtkMenuItem* _tmp152_ = NULL;
		GtkMenuItem* _tmp153_;
		GtkMenuItem* _tmp154_;
		const gchar* _tmp155_;
		const gchar* _tmp156_;
		GraniteAccelLabel* _tmp157_;
		GraniteAccelLabel* _tmp158_;
		GList* _tmp159_;
#line 1988 "../src/View/AbstractDirectoryView.vala"
		_tmp151_ = g_strdup ("common.select-all");
#line 1988 "../src/View/AbstractDirectoryView.vala"
		_tmp152_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1988 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp152_, _tmp151_);
#line 1988 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp151_);
#line 1988 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp152_);
#line 1988 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (select_all_menuitem);
#line 1988 "../src/View/AbstractDirectoryView.vala"
		select_all_menuitem = _tmp152_;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp153_ = select_all_menuitem;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp154_ = select_all_menuitem;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp155_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp154_);
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp156_ = _tmp155_;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp157_ = granite_accel_label_new_from_action_name (_ ("Select All"), _tmp156_);
#line 1991 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp157_);
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp158_ = _tmp157_;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp153_, (GtkWidget*) _tmp158_);
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp158_);
#line 1996 "../src/View/AbstractDirectoryView.vala"
		_tmp159_ = files_abstract_directory_view_get_selected_files (self);
#line 1996 "../src/View/AbstractDirectoryView.vala"
		if (_tmp159_ != NULL) {
#line 11051 "AbstractDirectoryView.c"
			gchar* _tmp160_;
			GtkMenuItem* _tmp161_ = NULL;
			GtkMenuItem* _tmp162_;
			GtkMenuItem* _tmp163_;
			const gchar* _tmp164_;
			const gchar* _tmp165_;
			GraniteAccelLabel* _tmp166_;
			GraniteAccelLabel* _tmp167_;
#line 1997 "../src/View/AbstractDirectoryView.vala"
			_tmp160_ = g_strdup ("selection.invert-selection");
#line 1997 "../src/View/AbstractDirectoryView.vala"
			_tmp161_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1997 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp161_, _tmp160_);
#line 1997 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (_tmp160_);
#line 1997 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp161_);
#line 1997 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (invert_selection_menuitem);
#line 1997 "../src/View/AbstractDirectoryView.vala"
			invert_selection_menuitem = _tmp161_;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp162_ = invert_selection_menuitem;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp163_ = invert_selection_menuitem;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp164_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp163_);
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp165_ = _tmp164_;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp166_ = granite_accel_label_new_from_action_name (_ ("Invert Selection"), _tmp165_);
#line 2000 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp166_);
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_tmp167_ = _tmp166_;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp162_, (GtkWidget*) _tmp167_);
#line 2000 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp167_);
#line 11092 "AbstractDirectoryView.c"
		}
	} else {
		gchar* _tmp168_;
		GtkMenuItem* _tmp169_ = NULL;
		GtkMenuItem* _tmp170_;
		GtkMenuItem* _tmp171_;
		const gchar* _tmp172_;
		const gchar* _tmp173_;
		GraniteAccelLabel* _tmp174_;
		GraniteAccelLabel* _tmp175_;
#line 2006 "../src/View/AbstractDirectoryView.vala"
		_tmp168_ = g_strdup ("common.select-all");
#line 2006 "../src/View/AbstractDirectoryView.vala"
		_tmp169_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2006 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp169_, _tmp168_);
#line 2006 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp168_);
#line 2006 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp169_);
#line 2006 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (deselect_all_menuitem);
#line 2006 "../src/View/AbstractDirectoryView.vala"
		deselect_all_menuitem = _tmp169_;
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp170_ = deselect_all_menuitem;
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp171_ = deselect_all_menuitem;
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp172_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp171_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp173_ = _tmp172_;
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp174_ = granite_accel_label_new_from_action_name (_ ("Deselect All"), _tmp173_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp174_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_tmp175_ = _tmp174_;
#line 2009 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp170_, (GtkWidget*) _tmp175_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp175_);
#line 11135 "AbstractDirectoryView.c"
	}
#line 2015 "../src/View/AbstractDirectoryView.vala"
	_tmp176_ = files_abstract_directory_view_get_selected_files (self);
#line 2015 "../src/View/AbstractDirectoryView.vala"
	if (_tmp176_ != NULL) {
#line 11141 "AbstractDirectoryView.c"
		GtkMenuItem* cut_menuitem = NULL;
		GtkMenuItem* _tmp177_;
		GtkMenuItem* _tmp178_;
		GraniteAccelLabel* _tmp179_;
		GraniteAccelLabel* _tmp180_;
		GtkMenuItem* _tmp181_;
		GtkMenuItem* copy_menuitem = NULL;
		GtkMenuItem* _tmp182_;
		GtkMenuItem* _tmp183_;
		GraniteAccelLabel* _tmp184_;
		GraniteAccelLabel* _tmp185_;
		GtkMenuItem* _tmp186_;
		GtkMenuItem* trash_menuitem = NULL;
		GtkMenuItem* _tmp187_;
		GtkMenuItem* _tmp188_;
		GraniteAccelLabel* _tmp189_;
		GraniteAccelLabel* _tmp190_;
		GtkMenuItem* _tmp191_;
		GtkMenuItem* delete_menuitem = NULL;
		gchar* _tmp192_;
		GtkMenuItem* _tmp193_ = NULL;
		GtkMenuItem* _tmp194_;
		GtkStyleContext* _tmp195_;
		gboolean _tmp196_ = FALSE;
#line 2016 "../src/View/AbstractDirectoryView.vala"
		_tmp177_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2016 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp177_);
#line 2016 "../src/View/AbstractDirectoryView.vala"
		cut_menuitem = _tmp177_;
#line 2017 "../src/View/AbstractDirectoryView.vala"
		_tmp178_ = cut_menuitem;
#line 2017 "../src/View/AbstractDirectoryView.vala"
		_tmp179_ = granite_accel_label_new (_ ("Cut"), "<Ctrl>x");
#line 2017 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp179_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
		_tmp180_ = _tmp179_;
#line 2017 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp178_, (GtkWidget*) _tmp180_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp180_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
		_tmp181_ = cut_menuitem;
#line 2021 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp181_, "selection.cut");
#line 2023 "../src/View/AbstractDirectoryView.vala"
		_tmp182_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2023 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp182_);
#line 2023 "../src/View/AbstractDirectoryView.vala"
		copy_menuitem = _tmp182_;
#line 2025 "../src/View/AbstractDirectoryView.vala"
		_tmp183_ = copy_menuitem;
#line 2025 "../src/View/AbstractDirectoryView.vala"
		_tmp184_ = granite_accel_label_new (_ ("Copy"), "<Ctrl>c");
#line 2025 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp184_);
#line 2025 "../src/View/AbstractDirectoryView.vala"
		_tmp185_ = _tmp184_;
#line 2025 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp183_, (GtkWidget*) _tmp185_);
#line 2025 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp185_);
#line 2029 "../src/View/AbstractDirectoryView.vala"
		_tmp186_ = copy_menuitem;
#line 2029 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp186_, "common.copy");
#line 2031 "../src/View/AbstractDirectoryView.vala"
		_tmp187_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2031 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp187_);
#line 2031 "../src/View/AbstractDirectoryView.vala"
		trash_menuitem = _tmp187_;
#line 2032 "../src/View/AbstractDirectoryView.vala"
		_tmp188_ = trash_menuitem;
#line 2032 "../src/View/AbstractDirectoryView.vala"
		_tmp189_ = granite_accel_label_new (_ ("Move to Trash"), "Delete");
#line 2032 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp189_);
#line 2032 "../src/View/AbstractDirectoryView.vala"
		_tmp190_ = _tmp189_;
#line 2032 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp188_, (GtkWidget*) _tmp190_);
#line 2032 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp190_);
#line 2036 "../src/View/AbstractDirectoryView.vala"
		_tmp191_ = trash_menuitem;
#line 2036 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp191_, "selection.trash");
#line 2038 "../src/View/AbstractDirectoryView.vala"
		_tmp192_ = g_strdup ("selection.delete");
#line 2038 "../src/View/AbstractDirectoryView.vala"
		_tmp193_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete Permanently"));
#line 2038 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp193_, _tmp192_);
#line 2038 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp192_);
#line 2038 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp193_);
#line 2038 "../src/View/AbstractDirectoryView.vala"
		delete_menuitem = _tmp193_;
#line 2041 "../src/View/AbstractDirectoryView.vala"
		_tmp194_ = delete_menuitem;
#line 2041 "../src/View/AbstractDirectoryView.vala"
		_tmp195_ = gtk_widget_get_style_context ((GtkWidget*) _tmp194_);
#line 2041 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_add_class (_tmp195_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 2044 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->in_trash) {
#line 2044 "../src/View/AbstractDirectoryView.vala"
			_tmp196_ = files_abstract_directory_view_valid_selection_for_restore (self);
#line 11254 "AbstractDirectoryView.c"
		} else {
#line 2044 "../src/View/AbstractDirectoryView.vala"
			_tmp196_ = FALSE;
#line 11258 "AbstractDirectoryView.c"
		}
#line 2044 "../src/View/AbstractDirectoryView.vala"
		if (_tmp196_) {
#line 11262 "AbstractDirectoryView.c"
			GtkMenuItem* restore_menuitem = NULL;
			GtkMenuItem* _tmp197_;
			GtkMenuItem* _tmp198_;
			GtkMenu* _tmp199_;
			GtkSeparatorMenuItem* _tmp200_;
			GtkSeparatorMenuItem* _tmp201_;
			GtkMenu* _tmp202_;
			GtkMenuItem* _tmp203_;
			GtkMenu* _tmp204_;
			GtkMenuItem* _tmp205_;
			GtkMenu* _tmp206_;
			GtkSeparatorMenuItem* _tmp207_;
			GtkSeparatorMenuItem* _tmp208_;
			GtkMenu* _tmp209_;
			GtkMenuItem* _tmp210_;
			GtkMenuItem* _tmp211_;
			GtkMenuItem* _tmp214_;
			GtkMenuItem* _tmp217_;
			GtkMenu* _tmp220_;
			GtkSeparatorMenuItem* _tmp221_;
			GtkSeparatorMenuItem* _tmp222_;
			GtkMenu* _tmp223_;
			GtkMenuItem* _tmp224_;
#line 2045 "../src/View/AbstractDirectoryView.vala"
			_tmp197_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restore from Trash"));
#line 2045 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp197_);
#line 2045 "../src/View/AbstractDirectoryView.vala"
			restore_menuitem = _tmp197_;
#line 2046 "../src/View/AbstractDirectoryView.vala"
			_tmp198_ = restore_menuitem;
#line 2046 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp198_, "selection.restore");
#line 2048 "../src/View/AbstractDirectoryView.vala"
			_tmp199_ = menu;
#line 2048 "../src/View/AbstractDirectoryView.vala"
			_tmp200_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2048 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp200_);
#line 2048 "../src/View/AbstractDirectoryView.vala"
			_tmp201_ = _tmp200_;
#line 2048 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp199_, (GtkWidget*) _tmp201_);
#line 2048 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp201_);
#line 2049 "../src/View/AbstractDirectoryView.vala"
			_tmp202_ = menu;
#line 2049 "../src/View/AbstractDirectoryView.vala"
			_tmp203_ = restore_menuitem;
#line 2049 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp202_, (GtkWidget*) _tmp203_);
#line 2050 "../src/View/AbstractDirectoryView.vala"
			_tmp204_ = menu;
#line 2050 "../src/View/AbstractDirectoryView.vala"
			_tmp205_ = delete_menuitem;
#line 2050 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp204_, (GtkWidget*) _tmp205_);
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp206_ = menu;
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp207_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2051 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp207_);
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp208_ = _tmp207_;
#line 2051 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp206_, (GtkWidget*) _tmp208_);
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp208_);
#line 2052 "../src/View/AbstractDirectoryView.vala"
			_tmp209_ = menu;
#line 2052 "../src/View/AbstractDirectoryView.vala"
			_tmp210_ = cut_menuitem;
#line 2052 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp209_, (GtkWidget*) _tmp210_);
#line 2053 "../src/View/AbstractDirectoryView.vala"
			_tmp211_ = select_all_menuitem;
#line 2053 "../src/View/AbstractDirectoryView.vala"
			if (_tmp211_ != NULL) {
#line 11342 "AbstractDirectoryView.c"
				GtkMenu* _tmp212_;
				GtkMenuItem* _tmp213_;
#line 2054 "../src/View/AbstractDirectoryView.vala"
				_tmp212_ = menu;
#line 2054 "../src/View/AbstractDirectoryView.vala"
				_tmp213_ = select_all_menuitem;
#line 2054 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp212_, (GtkWidget*) _tmp213_);
#line 11351 "AbstractDirectoryView.c"
			}
#line 2057 "../src/View/AbstractDirectoryView.vala"
			_tmp214_ = deselect_all_menuitem;
#line 2057 "../src/View/AbstractDirectoryView.vala"
			if (_tmp214_ != NULL) {
#line 11357 "AbstractDirectoryView.c"
				GtkMenu* _tmp215_;
				GtkMenuItem* _tmp216_;
#line 2058 "../src/View/AbstractDirectoryView.vala"
				_tmp215_ = menu;
#line 2058 "../src/View/AbstractDirectoryView.vala"
				_tmp216_ = deselect_all_menuitem;
#line 2058 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp215_, (GtkWidget*) _tmp216_);
#line 11366 "AbstractDirectoryView.c"
			}
#line 2061 "../src/View/AbstractDirectoryView.vala"
			_tmp217_ = invert_selection_menuitem;
#line 2061 "../src/View/AbstractDirectoryView.vala"
			if (_tmp217_ != NULL) {
#line 11372 "AbstractDirectoryView.c"
				GtkMenu* _tmp218_;
				GtkMenuItem* _tmp219_;
#line 2062 "../src/View/AbstractDirectoryView.vala"
				_tmp218_ = menu;
#line 2062 "../src/View/AbstractDirectoryView.vala"
				_tmp219_ = invert_selection_menuitem;
#line 2062 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp218_, (GtkWidget*) _tmp219_);
#line 11381 "AbstractDirectoryView.c"
			}
#line 2065 "../src/View/AbstractDirectoryView.vala"
			_tmp220_ = menu;
#line 2065 "../src/View/AbstractDirectoryView.vala"
			_tmp221_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2065 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp221_);
#line 2065 "../src/View/AbstractDirectoryView.vala"
			_tmp222_ = _tmp221_;
#line 2065 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp220_, (GtkWidget*) _tmp222_);
#line 2065 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp222_);
#line 2066 "../src/View/AbstractDirectoryView.vala"
			_tmp223_ = menu;
#line 2066 "../src/View/AbstractDirectoryView.vala"
			_tmp224_ = properties_menuitem;
#line 2066 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp223_, (GtkWidget*) _tmp224_);
#line 2044 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (restore_menuitem);
#line 11403 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp225_;
#line 2067 "../src/View/AbstractDirectoryView.vala"
			_tmp225_ = self->priv->_in_recent;
#line 2067 "../src/View/AbstractDirectoryView.vala"
			if (_tmp225_) {
#line 11410 "AbstractDirectoryView.c"
				GtkMenuItem* open_parent_menuitem = NULL;
				GtkMenuItem* _tmp226_;
				GtkMenuItem* _tmp227_;
				GtkMenuItem* forget_menuitem = NULL;
				GtkMenuItem* _tmp228_;
				GtkMenuItem* _tmp229_;
				GtkMenu* _tmp230_;
				GtkMenuItem* _tmp231_;
				GtkMenu* _tmp232_;
				GtkSeparatorMenuItem* _tmp233_;
				GtkSeparatorMenuItem* _tmp234_;
				GtkMenu* _tmp235_;
				GtkMenuItem* _tmp236_;
				GtkMenu* _tmp237_;
				GtkMenuItem* _tmp238_;
				GtkMenuItem* _tmp239_;
				GtkMenuItem* _tmp242_;
				GtkMenuItem* _tmp245_;
				GtkMenu* _tmp248_;
				GtkMenuItem* _tmp249_;
				GtkMenu* _tmp250_;
				GtkSeparatorMenuItem* _tmp251_;
				GtkSeparatorMenuItem* _tmp252_;
				GtkMenu* _tmp253_;
				GtkMenuItem* _tmp254_;
#line 2068 "../src/View/AbstractDirectoryView.vala"
				_tmp226_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open Parent Folder"));
#line 2068 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp226_);
#line 2068 "../src/View/AbstractDirectoryView.vala"
				open_parent_menuitem = _tmp226_;
#line 2069 "../src/View/AbstractDirectoryView.vala"
				_tmp227_ = open_parent_menuitem;
#line 2069 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp227_, "selection.view-in-location");
#line 2071 "../src/View/AbstractDirectoryView.vala"
				_tmp228_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove from History"));
#line 2071 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp228_);
#line 2071 "../src/View/AbstractDirectoryView.vala"
				forget_menuitem = _tmp228_;
#line 2072 "../src/View/AbstractDirectoryView.vala"
				_tmp229_ = forget_menuitem;
#line 2072 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp229_, "selection.forget");
#line 2074 "../src/View/AbstractDirectoryView.vala"
				_tmp230_ = menu;
#line 2074 "../src/View/AbstractDirectoryView.vala"
				_tmp231_ = open_parent_menuitem;
#line 2074 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp230_, (GtkWidget*) _tmp231_);
#line 2075 "../src/View/AbstractDirectoryView.vala"
				_tmp232_ = menu;
#line 2075 "../src/View/AbstractDirectoryView.vala"
				_tmp233_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2075 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp233_);
#line 2075 "../src/View/AbstractDirectoryView.vala"
				_tmp234_ = _tmp233_;
#line 2075 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp232_, (GtkWidget*) _tmp234_);
#line 2075 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp234_);
#line 2076 "../src/View/AbstractDirectoryView.vala"
				_tmp235_ = menu;
#line 2076 "../src/View/AbstractDirectoryView.vala"
				_tmp236_ = forget_menuitem;
#line 2076 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp235_, (GtkWidget*) _tmp236_);
#line 2077 "../src/View/AbstractDirectoryView.vala"
				_tmp237_ = menu;
#line 2077 "../src/View/AbstractDirectoryView.vala"
				_tmp238_ = copy_menuitem;
#line 2077 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp237_, (GtkWidget*) _tmp238_);
#line 2078 "../src/View/AbstractDirectoryView.vala"
				_tmp239_ = select_all_menuitem;
#line 2078 "../src/View/AbstractDirectoryView.vala"
				if (_tmp239_ != NULL) {
#line 11490 "AbstractDirectoryView.c"
					GtkMenu* _tmp240_;
					GtkMenuItem* _tmp241_;
#line 2079 "../src/View/AbstractDirectoryView.vala"
					_tmp240_ = menu;
#line 2079 "../src/View/AbstractDirectoryView.vala"
					_tmp241_ = select_all_menuitem;
#line 2079 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp240_, (GtkWidget*) _tmp241_);
#line 11499 "AbstractDirectoryView.c"
				}
#line 2082 "../src/View/AbstractDirectoryView.vala"
				_tmp242_ = deselect_all_menuitem;
#line 2082 "../src/View/AbstractDirectoryView.vala"
				if (_tmp242_ != NULL) {
#line 11505 "AbstractDirectoryView.c"
					GtkMenu* _tmp243_;
					GtkMenuItem* _tmp244_;
#line 2083 "../src/View/AbstractDirectoryView.vala"
					_tmp243_ = menu;
#line 2083 "../src/View/AbstractDirectoryView.vala"
					_tmp244_ = deselect_all_menuitem;
#line 2083 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp243_, (GtkWidget*) _tmp244_);
#line 11514 "AbstractDirectoryView.c"
				}
#line 2086 "../src/View/AbstractDirectoryView.vala"
				_tmp245_ = invert_selection_menuitem;
#line 2086 "../src/View/AbstractDirectoryView.vala"
				if (_tmp245_ != NULL) {
#line 11520 "AbstractDirectoryView.c"
					GtkMenu* _tmp246_;
					GtkMenuItem* _tmp247_;
#line 2087 "../src/View/AbstractDirectoryView.vala"
					_tmp246_ = menu;
#line 2087 "../src/View/AbstractDirectoryView.vala"
					_tmp247_ = invert_selection_menuitem;
#line 2087 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp246_, (GtkWidget*) _tmp247_);
#line 11529 "AbstractDirectoryView.c"
				}
#line 2090 "../src/View/AbstractDirectoryView.vala"
				_tmp248_ = menu;
#line 2090 "../src/View/AbstractDirectoryView.vala"
				_tmp249_ = trash_menuitem;
#line 2090 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp248_, (GtkWidget*) _tmp249_);
#line 2091 "../src/View/AbstractDirectoryView.vala"
				_tmp250_ = menu;
#line 2091 "../src/View/AbstractDirectoryView.vala"
				_tmp251_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2091 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp251_);
#line 2091 "../src/View/AbstractDirectoryView.vala"
				_tmp252_ = _tmp251_;
#line 2091 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp250_, (GtkWidget*) _tmp252_);
#line 2091 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp252_);
#line 2092 "../src/View/AbstractDirectoryView.vala"
				_tmp253_ = menu;
#line 2092 "../src/View/AbstractDirectoryView.vala"
				_tmp254_ = properties_menuitem;
#line 2092 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp253_, (GtkWidget*) _tmp254_);
#line 2067 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (forget_menuitem);
#line 2067 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (open_parent_menuitem);
#line 11559 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp336_ = FALSE;
				GSimpleActionGroup* _tmp337_;
				GtkMenu* _tmp346_;
				GtkSeparatorMenuItem* _tmp347_;
				GtkSeparatorMenuItem* _tmp348_;
				GtkMenu* _tmp349_;
				GtkMenuItem* _tmp350_;
#line 2094 "../src/View/AbstractDirectoryView.vala"
				if (files_abstract_directory_view_valid_selection_for_edit (self)) {
#line 11570 "AbstractDirectoryView.c"
					GtkMenuItem* rename_menuitem = NULL;
					GtkMenuItem* _tmp255_;
					GtkMenuItem* _tmp256_;
					GraniteAccelLabel* _tmp257_;
					GraniteAccelLabel* _tmp258_;
					GtkMenuItem* _tmp259_;
					GtkMenuItem* copy_link_menuitem = NULL;
					GtkMenuItem* _tmp260_;
					GtkMenuItem* _tmp261_;
					GraniteAccelLabel* _tmp262_;
					GraniteAccelLabel* _tmp263_;
					GtkMenuItem* _tmp264_;
					GtkMenu* _tmp265_;
					GList* _tmp266_;
					GList* _tmp267_;
					GtkMenuItem* _tmp268_;
					GList* _tmp269_;
					gboolean _tmp270_;
					GtkMenu* _tmp274_;
					GtkMenuItem* _tmp275_;
					GtkMenu* _tmp276_;
					GtkMenuItem* _tmp277_;
					GtkMenu* _tmp278_;
					GtkMenuItem* _tmp279_;
					gboolean _tmp280_ = FALSE;
					gboolean _tmp281_ = FALSE;
					GSimpleActionGroup* _tmp282_;
					GtkMenuItem* _tmp312_;
					GtkMenuItem* _tmp315_;
					GtkMenuItem* _tmp318_;
					GtkMenu* _tmp321_;
					GtkSeparatorMenuItem* _tmp322_;
					GtkSeparatorMenuItem* _tmp323_;
					gboolean _tmp324_ = FALSE;
					FilesViewSlot* _tmp325_;
					FilesDirectory* _tmp326_;
					FilesDirectory* _tmp327_;
					gboolean _tmp328_;
					gboolean _tmp329_;
					GtkMenu* _tmp334_;
					GtkMenuItem* _tmp335_;
#line 2095 "../src/View/AbstractDirectoryView.vala"
					_tmp255_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2095 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp255_);
#line 2095 "../src/View/AbstractDirectoryView.vala"
					rename_menuitem = _tmp255_;
#line 2096 "../src/View/AbstractDirectoryView.vala"
					_tmp256_ = rename_menuitem;
#line 2096 "../src/View/AbstractDirectoryView.vala"
					_tmp257_ = granite_accel_label_new (_ ("Rename…"), "F2");
#line 2096 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp257_);
#line 2096 "../src/View/AbstractDirectoryView.vala"
					_tmp258_ = _tmp257_;
#line 2096 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp256_, (GtkWidget*) _tmp258_);
#line 2096 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp258_);
#line 2100 "../src/View/AbstractDirectoryView.vala"
					_tmp259_ = rename_menuitem;
#line 2100 "../src/View/AbstractDirectoryView.vala"
					gtk_actionable_set_action_name ((GtkActionable*) _tmp259_, "selection.rename");
#line 2102 "../src/View/AbstractDirectoryView.vala"
					_tmp260_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2102 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp260_);
#line 2102 "../src/View/AbstractDirectoryView.vala"
					copy_link_menuitem = _tmp260_;
#line 2103 "../src/View/AbstractDirectoryView.vala"
					_tmp261_ = copy_link_menuitem;
#line 2103 "../src/View/AbstractDirectoryView.vala"
					_tmp262_ = granite_accel_label_new (_ ("Copy as Link"), "<Shift><Ctrl>c");
#line 2103 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp262_);
#line 2103 "../src/View/AbstractDirectoryView.vala"
					_tmp263_ = _tmp262_;
#line 2103 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp261_, (GtkWidget*) _tmp263_);
#line 2103 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp263_);
#line 2107 "../src/View/AbstractDirectoryView.vala"
					_tmp264_ = copy_link_menuitem;
#line 2107 "../src/View/AbstractDirectoryView.vala"
					gtk_actionable_set_action_name ((GtkActionable*) _tmp264_, "common.copy-link");
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp265_ = menu;
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp266_ = gtk_container_get_children ((GtkContainer*) _tmp265_);
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp267_ = _tmp266_;
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp268_ = open_submenu_item;
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp269_ = g_list_find (_tmp267_, (GtkWidget*) _tmp268_);
#line 2109 "../src/View/AbstractDirectoryView.vala"
					_tmp270_ = _tmp269_ != NULL;
#line 2109 "../src/View/AbstractDirectoryView.vala"
					(_tmp267_ == NULL) ? NULL : (_tmp267_ = (g_list_free (_tmp267_), NULL));
#line 2109 "../src/View/AbstractDirectoryView.vala"
					if (_tmp270_) {
#line 11672 "AbstractDirectoryView.c"
						GtkMenu* _tmp271_;
						GtkSeparatorMenuItem* _tmp272_;
						GtkSeparatorMenuItem* _tmp273_;
#line 2110 "../src/View/AbstractDirectoryView.vala"
						_tmp271_ = menu;
#line 2110 "../src/View/AbstractDirectoryView.vala"
						_tmp272_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2110 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp272_);
#line 2110 "../src/View/AbstractDirectoryView.vala"
						_tmp273_ = _tmp272_;
#line 2110 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp271_, (GtkWidget*) _tmp273_);
#line 2110 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp273_);
#line 11688 "AbstractDirectoryView.c"
					}
#line 2113 "../src/View/AbstractDirectoryView.vala"
					_tmp274_ = menu;
#line 2113 "../src/View/AbstractDirectoryView.vala"
					_tmp275_ = cut_menuitem;
#line 2113 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp274_, (GtkWidget*) _tmp275_);
#line 2114 "../src/View/AbstractDirectoryView.vala"
					_tmp276_ = menu;
#line 2114 "../src/View/AbstractDirectoryView.vala"
					_tmp277_ = copy_menuitem;
#line 2114 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp276_, (GtkWidget*) _tmp277_);
#line 2115 "../src/View/AbstractDirectoryView.vala"
					_tmp278_ = menu;
#line 2115 "../src/View/AbstractDirectoryView.vala"
					_tmp279_ = copy_link_menuitem;
#line 2115 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp278_, (GtkWidget*) _tmp279_);
#line 2119 "../src/View/AbstractDirectoryView.vala"
					_tmp282_ = self->priv->common_actions;
#line 2119 "../src/View/AbstractDirectoryView.vala"
					if (g_action_group_get_action_enabled ((GActionGroup*) _tmp282_, "paste-into")) {
#line 11712 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp283_;
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp283_ = self->priv->clipboard;
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp281_ = _tmp283_ != NULL;
#line 11718 "AbstractDirectoryView.c"
					} else {
#line 2119 "../src/View/AbstractDirectoryView.vala"
						_tmp281_ = FALSE;
#line 11722 "AbstractDirectoryView.c"
					}
#line 2119 "../src/View/AbstractDirectoryView.vala"
					if (_tmp281_) {
#line 11726 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp284_;
						gboolean _tmp285_;
						gboolean _tmp286_;
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp284_ = self->priv->clipboard;
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp285_ = files_clipboard_manager_get_can_paste (_tmp284_);
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp286_ = _tmp285_;
#line 2120 "../src/View/AbstractDirectoryView.vala"
						_tmp280_ = _tmp286_;
#line 11738 "AbstractDirectoryView.c"
					} else {
#line 2119 "../src/View/AbstractDirectoryView.vala"
						_tmp280_ = FALSE;
#line 11742 "AbstractDirectoryView.c"
					}
#line 2119 "../src/View/AbstractDirectoryView.vala"
					if (_tmp280_) {
#line 11746 "AbstractDirectoryView.c"
						GtkMenuItem* paste_into_menuitem = NULL;
						gchar* _tmp287_;
						GtkMenuItem* _tmp288_ = NULL;
						FilesClipboardManager* _tmp289_;
						gboolean _tmp290_;
						gboolean _tmp291_;
						GtkMenu* _tmp298_;
						GtkMenuItem* _tmp299_;
#line 2121 "../src/View/AbstractDirectoryView.vala"
						_tmp287_ = g_strdup ("common.paste-into");
#line 2121 "../src/View/AbstractDirectoryView.vala"
						_tmp288_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2121 "../src/View/AbstractDirectoryView.vala"
						gtk_actionable_set_action_name ((GtkActionable*) _tmp288_, _tmp287_);
#line 2121 "../src/View/AbstractDirectoryView.vala"
						_g_free0 (_tmp287_);
#line 2121 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp288_);
#line 2121 "../src/View/AbstractDirectoryView.vala"
						paste_into_menuitem = _tmp288_;
#line 2125 "../src/View/AbstractDirectoryView.vala"
						_tmp289_ = self->priv->clipboard;
#line 2125 "../src/View/AbstractDirectoryView.vala"
						_tmp290_ = files_clipboard_manager_get_files_linked (_tmp289_);
#line 2125 "../src/View/AbstractDirectoryView.vala"
						_tmp291_ = _tmp290_;
#line 2125 "../src/View/AbstractDirectoryView.vala"
						if (_tmp291_) {
#line 11775 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp292_;
							GraniteAccelLabel* _tmp293_;
							GraniteAccelLabel* _tmp294_;
#line 2126 "../src/View/AbstractDirectoryView.vala"
							_tmp292_ = paste_into_menuitem;
#line 2126 "../src/View/AbstractDirectoryView.vala"
							_tmp293_ = granite_accel_label_new (_ ("Paste Link into Folder"), "<Shift><Ctrl>v");
#line 2126 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp293_);
#line 2126 "../src/View/AbstractDirectoryView.vala"
							_tmp294_ = _tmp293_;
#line 2126 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp292_, (GtkWidget*) _tmp294_);
#line 2126 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp294_);
#line 11791 "AbstractDirectoryView.c"
						} else {
							GtkMenuItem* _tmp295_;
							GraniteAccelLabel* _tmp296_;
							GraniteAccelLabel* _tmp297_;
#line 2131 "../src/View/AbstractDirectoryView.vala"
							_tmp295_ = paste_into_menuitem;
#line 2131 "../src/View/AbstractDirectoryView.vala"
							_tmp296_ = granite_accel_label_new (_ ("Paste into Folder"), "<Shift><Ctrl>v");
#line 2131 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp296_);
#line 2131 "../src/View/AbstractDirectoryView.vala"
							_tmp297_ = _tmp296_;
#line 2131 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp295_, (GtkWidget*) _tmp297_);
#line 2131 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp297_);
#line 11808 "AbstractDirectoryView.c"
						}
#line 2137 "../src/View/AbstractDirectoryView.vala"
						_tmp298_ = menu;
#line 2137 "../src/View/AbstractDirectoryView.vala"
						_tmp299_ = paste_into_menuitem;
#line 2137 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp298_, (GtkWidget*) _tmp299_);
#line 2119 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (paste_into_menuitem);
#line 11818 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp300_ = FALSE;
						gboolean _tmp301_ = FALSE;
						GSimpleActionGroup* _tmp302_;
#line 2138 "../src/View/AbstractDirectoryView.vala"
						_tmp302_ = self->priv->common_actions;
#line 2138 "../src/View/AbstractDirectoryView.vala"
						if (g_action_group_get_action_enabled ((GActionGroup*) _tmp302_, "paste")) {
#line 11827 "AbstractDirectoryView.c"
							FilesClipboardManager* _tmp303_;
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp303_ = self->priv->clipboard;
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp301_ = _tmp303_ != NULL;
#line 11833 "AbstractDirectoryView.c"
						} else {
#line 2138 "../src/View/AbstractDirectoryView.vala"
							_tmp301_ = FALSE;
#line 11837 "AbstractDirectoryView.c"
						}
#line 2138 "../src/View/AbstractDirectoryView.vala"
						if (_tmp301_) {
#line 11841 "AbstractDirectoryView.c"
							FilesClipboardManager* _tmp304_;
							gboolean _tmp305_;
							gboolean _tmp306_;
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp304_ = self->priv->clipboard;
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp305_ = files_clipboard_manager_get_can_paste (_tmp304_);
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp306_ = _tmp305_;
#line 2139 "../src/View/AbstractDirectoryView.vala"
							_tmp300_ = _tmp306_;
#line 11853 "AbstractDirectoryView.c"
						} else {
#line 2138 "../src/View/AbstractDirectoryView.vala"
							_tmp300_ = FALSE;
#line 11857 "AbstractDirectoryView.c"
						}
#line 2138 "../src/View/AbstractDirectoryView.vala"
						if (_tmp300_) {
#line 11861 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp307_;
							GraniteAccelLabel* _tmp308_;
							GraniteAccelLabel* _tmp309_;
							GtkMenu* _tmp310_;
							GtkMenuItem* _tmp311_;
#line 2141 "../src/View/AbstractDirectoryView.vala"
							_tmp307_ = paste_menuitem;
#line 2141 "../src/View/AbstractDirectoryView.vala"
							_tmp308_ = granite_accel_label_new (_ ("Paste"), "<Ctrl>v");
#line 2141 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp308_);
#line 2141 "../src/View/AbstractDirectoryView.vala"
							_tmp309_ = _tmp308_;
#line 2141 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp307_, (GtkWidget*) _tmp309_);
#line 2141 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp309_);
#line 2145 "../src/View/AbstractDirectoryView.vala"
							_tmp310_ = menu;
#line 2145 "../src/View/AbstractDirectoryView.vala"
							_tmp311_ = paste_menuitem;
#line 2145 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp310_, (GtkWidget*) _tmp311_);
#line 11885 "AbstractDirectoryView.c"
						}
					}
#line 2148 "../src/View/AbstractDirectoryView.vala"
					_tmp312_ = select_all_menuitem;
#line 2148 "../src/View/AbstractDirectoryView.vala"
					if (_tmp312_ != NULL) {
#line 11892 "AbstractDirectoryView.c"
						GtkMenu* _tmp313_;
						GtkMenuItem* _tmp314_;
#line 2149 "../src/View/AbstractDirectoryView.vala"
						_tmp313_ = menu;
#line 2149 "../src/View/AbstractDirectoryView.vala"
						_tmp314_ = select_all_menuitem;
#line 2149 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp313_, (GtkWidget*) _tmp314_);
#line 11901 "AbstractDirectoryView.c"
					}
#line 2152 "../src/View/AbstractDirectoryView.vala"
					_tmp315_ = deselect_all_menuitem;
#line 2152 "../src/View/AbstractDirectoryView.vala"
					if (_tmp315_ != NULL) {
#line 11907 "AbstractDirectoryView.c"
						GtkMenu* _tmp316_;
						GtkMenuItem* _tmp317_;
#line 2153 "../src/View/AbstractDirectoryView.vala"
						_tmp316_ = menu;
#line 2153 "../src/View/AbstractDirectoryView.vala"
						_tmp317_ = deselect_all_menuitem;
#line 2153 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp316_, (GtkWidget*) _tmp317_);
#line 11916 "AbstractDirectoryView.c"
					}
#line 2156 "../src/View/AbstractDirectoryView.vala"
					_tmp318_ = invert_selection_menuitem;
#line 2156 "../src/View/AbstractDirectoryView.vala"
					if (_tmp318_ != NULL) {
#line 11922 "AbstractDirectoryView.c"
						GtkMenu* _tmp319_;
						GtkMenuItem* _tmp320_;
#line 2157 "../src/View/AbstractDirectoryView.vala"
						_tmp319_ = menu;
#line 2157 "../src/View/AbstractDirectoryView.vala"
						_tmp320_ = invert_selection_menuitem;
#line 2157 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp319_, (GtkWidget*) _tmp320_);
#line 11931 "AbstractDirectoryView.c"
					}
#line 2160 "../src/View/AbstractDirectoryView.vala"
					_tmp321_ = menu;
#line 2160 "../src/View/AbstractDirectoryView.vala"
					_tmp322_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2160 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp322_);
#line 2160 "../src/View/AbstractDirectoryView.vala"
					_tmp323_ = _tmp322_;
#line 2160 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp321_, (GtkWidget*) _tmp323_);
#line 2160 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp323_);
#line 2161 "../src/View/AbstractDirectoryView.vala"
					_tmp325_ = self->slot;
#line 2161 "../src/View/AbstractDirectoryView.vala"
					_tmp326_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp325_);
#line 2161 "../src/View/AbstractDirectoryView.vala"
					_tmp327_ = _tmp326_;
#line 2161 "../src/View/AbstractDirectoryView.vala"
					_tmp328_ = files_directory_get_has_trash_dirs (_tmp327_);
#line 2161 "../src/View/AbstractDirectoryView.vala"
					_tmp329_ = _tmp328_;
#line 2161 "../src/View/AbstractDirectoryView.vala"
					if (_tmp329_) {
#line 2161 "../src/View/AbstractDirectoryView.vala"
						_tmp324_ = !files_is_admin ();
#line 11959 "AbstractDirectoryView.c"
					} else {
#line 2161 "../src/View/AbstractDirectoryView.vala"
						_tmp324_ = FALSE;
#line 11963 "AbstractDirectoryView.c"
					}
#line 2161 "../src/View/AbstractDirectoryView.vala"
					if (_tmp324_) {
#line 11967 "AbstractDirectoryView.c"
						GtkMenu* _tmp330_;
						GtkMenuItem* _tmp331_;
#line 2162 "../src/View/AbstractDirectoryView.vala"
						_tmp330_ = menu;
#line 2162 "../src/View/AbstractDirectoryView.vala"
						_tmp331_ = trash_menuitem;
#line 2162 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp330_, (GtkWidget*) _tmp331_);
#line 11976 "AbstractDirectoryView.c"
					} else {
						GtkMenu* _tmp332_;
						GtkMenuItem* _tmp333_;
#line 2164 "../src/View/AbstractDirectoryView.vala"
						_tmp332_ = menu;
#line 2164 "../src/View/AbstractDirectoryView.vala"
						_tmp333_ = delete_menuitem;
#line 2164 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp332_, (GtkWidget*) _tmp333_);
#line 11986 "AbstractDirectoryView.c"
					}
#line 2167 "../src/View/AbstractDirectoryView.vala"
					_tmp334_ = menu;
#line 2167 "../src/View/AbstractDirectoryView.vala"
					_tmp335_ = rename_menuitem;
#line 2167 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp334_, (GtkWidget*) _tmp335_);
#line 2094 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (copy_link_menuitem);
#line 2094 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (rename_menuitem);
#line 11998 "AbstractDirectoryView.c"
				}
#line 2171 "../src/View/AbstractDirectoryView.vala"
				_tmp337_ = self->priv->common_actions;
#line 2171 "../src/View/AbstractDirectoryView.vala"
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp337_, "bookmark")) {
#line 12004 "AbstractDirectoryView.c"
					FilesViewWindow* _tmp338_;
					FilesViewWindow* _tmp339_;
					GList* _tmp340_;
					gconstpointer _tmp341_;
					const gchar* _tmp342_;
					const gchar* _tmp343_;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp338_ = files_abstract_directory_view_get_window (self);
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp339_ = _tmp338_;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp340_ = self->selected_files;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp341_ = _tmp340_->data;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp342_ = files_file_get_uri ((FilesFile*) _tmp341_);
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp343_ = _tmp342_;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp336_ = files_view_window_can_bookmark_uri (_tmp339_, _tmp343_);
#line 12025 "AbstractDirectoryView.c"
				} else {
#line 2171 "../src/View/AbstractDirectoryView.vala"
					_tmp336_ = FALSE;
#line 12029 "AbstractDirectoryView.c"
				}
#line 2171 "../src/View/AbstractDirectoryView.vala"
				if (_tmp336_) {
#line 12033 "AbstractDirectoryView.c"
					GtkMenu* _tmp344_;
					GtkMenuItem* _tmp345_;
#line 2174 "../src/View/AbstractDirectoryView.vala"
					_tmp344_ = menu;
#line 2174 "../src/View/AbstractDirectoryView.vala"
					_tmp345_ = bookmark_menuitem;
#line 2174 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp344_, (GtkWidget*) _tmp345_);
#line 12042 "AbstractDirectoryView.c"
				}
#line 2177 "../src/View/AbstractDirectoryView.vala"
				_tmp346_ = menu;
#line 2177 "../src/View/AbstractDirectoryView.vala"
				_tmp347_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2177 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp347_);
#line 2177 "../src/View/AbstractDirectoryView.vala"
				_tmp348_ = _tmp347_;
#line 2177 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp346_, (GtkWidget*) _tmp348_);
#line 2177 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp348_);
#line 2178 "../src/View/AbstractDirectoryView.vala"
				_tmp349_ = menu;
#line 2178 "../src/View/AbstractDirectoryView.vala"
				_tmp350_ = properties_menuitem;
#line 2178 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp349_, (GtkWidget*) _tmp350_);
#line 12062 "AbstractDirectoryView.c"
			}
		}
#line 2015 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (delete_menuitem);
#line 2015 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (trash_menuitem);
#line 2015 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (copy_menuitem);
#line 2015 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (cut_menuitem);
#line 12073 "AbstractDirectoryView.c"
	} else {
#line 2181 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->in_trash) {
#line 12077 "AbstractDirectoryView.c"
			gboolean _tmp351_ = FALSE;
			FilesClipboardManager* _tmp352_;
#line 2182 "../src/View/AbstractDirectoryView.vala"
			_tmp352_ = self->priv->clipboard;
#line 2182 "../src/View/AbstractDirectoryView.vala"
			if (_tmp352_ != NULL) {
#line 12084 "AbstractDirectoryView.c"
				FilesClipboardManager* _tmp353_;
#line 2182 "../src/View/AbstractDirectoryView.vala"
				_tmp353_ = self->priv->clipboard;
#line 2182 "../src/View/AbstractDirectoryView.vala"
				_tmp351_ = files_clipboard_manager_has_cutted_file (_tmp353_, NULL);
#line 12090 "AbstractDirectoryView.c"
			} else {
#line 2182 "../src/View/AbstractDirectoryView.vala"
				_tmp351_ = FALSE;
#line 12094 "AbstractDirectoryView.c"
			}
#line 2182 "../src/View/AbstractDirectoryView.vala"
			if (_tmp351_) {
#line 12098 "AbstractDirectoryView.c"
				GtkMenuItem* _tmp354_;
				GraniteAccelLabel* _tmp355_;
				GraniteAccelLabel* _tmp356_;
				GtkMenu* _tmp357_;
				GtkMenuItem* _tmp358_;
				GtkMenuItem* _tmp359_;
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_tmp354_ = paste_menuitem;
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_tmp355_ = granite_accel_label_new (_ ("Paste into Folder"), "<Ctrl>v");
#line 2183 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp355_);
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_tmp356_ = _tmp355_;
#line 2183 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp354_, (GtkWidget*) _tmp356_);
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp356_);
#line 2187 "../src/View/AbstractDirectoryView.vala"
				_tmp357_ = menu;
#line 2187 "../src/View/AbstractDirectoryView.vala"
				_tmp358_ = paste_menuitem;
#line 2187 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp357_, (GtkWidget*) _tmp358_);
#line 2188 "../src/View/AbstractDirectoryView.vala"
				_tmp359_ = select_all_menuitem;
#line 2188 "../src/View/AbstractDirectoryView.vala"
				if (_tmp359_ != NULL) {
#line 12127 "AbstractDirectoryView.c"
					GtkMenu* _tmp360_;
					GtkMenuItem* _tmp361_;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_tmp360_ = menu;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_tmp361_ = select_all_menuitem;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp360_, (GtkWidget*) _tmp361_);
#line 12136 "AbstractDirectoryView.c"
				}
			}
		} else {
			gboolean _tmp362_;
#line 2192 "../src/View/AbstractDirectoryView.vala"
			_tmp362_ = self->priv->_in_recent;
#line 2192 "../src/View/AbstractDirectoryView.vala"
			if (_tmp362_) {
#line 12145 "AbstractDirectoryView.c"
				GtkMenuItem* _tmp363_;
				GtkMenu* _tmp366_;
				GtkSeparatorMenuItem* _tmp367_;
				GtkSeparatorMenuItem* _tmp368_;
				GtkMenu* _tmp369_;
				FilesAbstractDirectoryViewSortSubMenuItem* _tmp370_;
				FilesAbstractDirectoryViewSortSubMenuItem* _tmp371_;
				GtkMenu* _tmp372_;
				GtkSeparatorMenuItem* _tmp373_;
				GtkSeparatorMenuItem* _tmp374_;
#line 2193 "../src/View/AbstractDirectoryView.vala"
				_tmp363_ = select_all_menuitem;
#line 2193 "../src/View/AbstractDirectoryView.vala"
				if (_tmp363_ != NULL) {
#line 12160 "AbstractDirectoryView.c"
					GtkMenu* _tmp364_;
					GtkMenuItem* _tmp365_;
#line 2194 "../src/View/AbstractDirectoryView.vala"
					_tmp364_ = menu;
#line 2194 "../src/View/AbstractDirectoryView.vala"
					_tmp365_ = select_all_menuitem;
#line 2194 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp364_, (GtkWidget*) _tmp365_);
#line 12169 "AbstractDirectoryView.c"
				}
#line 2197 "../src/View/AbstractDirectoryView.vala"
				_tmp366_ = menu;
#line 2197 "../src/View/AbstractDirectoryView.vala"
				_tmp367_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2197 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp367_);
#line 2197 "../src/View/AbstractDirectoryView.vala"
				_tmp368_ = _tmp367_;
#line 2197 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp366_, (GtkWidget*) _tmp368_);
#line 2197 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp368_);
#line 2198 "../src/View/AbstractDirectoryView.vala"
				_tmp369_ = menu;
#line 2198 "../src/View/AbstractDirectoryView.vala"
				_tmp370_ = files_abstract_directory_view_sort_sub_menu_item_new ();
#line 2198 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp370_);
#line 2198 "../src/View/AbstractDirectoryView.vala"
				_tmp371_ = _tmp370_;
#line 2198 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp369_, (GtkWidget*) _tmp371_);
#line 2198 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp371_);
#line 2199 "../src/View/AbstractDirectoryView.vala"
				_tmp372_ = menu;
#line 2199 "../src/View/AbstractDirectoryView.vala"
				_tmp373_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2199 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp373_);
#line 2199 "../src/View/AbstractDirectoryView.vala"
				_tmp374_ = _tmp373_;
#line 2199 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp372_, (GtkWidget*) _tmp374_);
#line 2199 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp374_);
#line 12207 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp403_ = FALSE;
				GSimpleActionGroup* _tmp404_;
#line 2201 "../src/View/AbstractDirectoryView.vala"
				if (!self->priv->in_network_root) {
#line 12213 "AbstractDirectoryView.c"
					GtkMenu* _tmp375_;
					GtkSeparatorMenuItem* _tmp376_;
					GtkSeparatorMenuItem* _tmp377_;
					gboolean _tmp378_ = FALSE;
					FilesClipboardManager* _tmp379_;
					GtkMenu* _tmp392_;
					GtkMenuItem* _tmp393_;
					GtkMenuItem* _tmp394_;
					GtkMenu* _tmp400_;
					FilesAbstractDirectoryViewSortSubMenuItem* _tmp401_;
					FilesAbstractDirectoryViewSortSubMenuItem* _tmp402_;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp375_ = menu;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp376_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2202 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp376_);
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp377_ = _tmp376_;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp375_, (GtkWidget*) _tmp377_);
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp377_);
#line 2204 "../src/View/AbstractDirectoryView.vala"
					_tmp379_ = self->priv->clipboard;
#line 2204 "../src/View/AbstractDirectoryView.vala"
					if (_tmp379_ != NULL) {
#line 12241 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp380_;
						gboolean _tmp381_;
						gboolean _tmp382_;
#line 2204 "../src/View/AbstractDirectoryView.vala"
						_tmp380_ = self->priv->clipboard;
#line 2204 "../src/View/AbstractDirectoryView.vala"
						_tmp381_ = files_clipboard_manager_get_can_paste (_tmp380_);
#line 2204 "../src/View/AbstractDirectoryView.vala"
						_tmp382_ = _tmp381_;
#line 2204 "../src/View/AbstractDirectoryView.vala"
						_tmp378_ = _tmp382_;
#line 12253 "AbstractDirectoryView.c"
					} else {
#line 2204 "../src/View/AbstractDirectoryView.vala"
						_tmp378_ = FALSE;
#line 12257 "AbstractDirectoryView.c"
					}
#line 2204 "../src/View/AbstractDirectoryView.vala"
					if (_tmp378_) {
#line 12261 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp383_;
						gboolean _tmp384_;
						gboolean _tmp385_;
#line 2205 "../src/View/AbstractDirectoryView.vala"
						_tmp383_ = self->priv->clipboard;
#line 2205 "../src/View/AbstractDirectoryView.vala"
						_tmp384_ = files_clipboard_manager_get_files_linked (_tmp383_);
#line 2205 "../src/View/AbstractDirectoryView.vala"
						_tmp385_ = _tmp384_;
#line 2205 "../src/View/AbstractDirectoryView.vala"
						if (_tmp385_) {
#line 12273 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp386_;
							GraniteAccelLabel* _tmp387_;
							GraniteAccelLabel* _tmp388_;
#line 2206 "../src/View/AbstractDirectoryView.vala"
							_tmp386_ = paste_menuitem;
#line 2206 "../src/View/AbstractDirectoryView.vala"
							_tmp387_ = granite_accel_label_new (_ ("Paste Link into Folder"), "<Ctrl>v");
#line 2206 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp387_);
#line 2206 "../src/View/AbstractDirectoryView.vala"
							_tmp388_ = _tmp387_;
#line 2206 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp386_, (GtkWidget*) _tmp388_);
#line 2206 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp388_);
#line 12289 "AbstractDirectoryView.c"
						} else {
							GtkMenuItem* _tmp389_;
							GraniteAccelLabel* _tmp390_;
							GraniteAccelLabel* _tmp391_;
#line 2211 "../src/View/AbstractDirectoryView.vala"
							_tmp389_ = paste_menuitem;
#line 2211 "../src/View/AbstractDirectoryView.vala"
							_tmp390_ = granite_accel_label_new (_ ("Paste"), "<Ctrl>v");
#line 2211 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp390_);
#line 2211 "../src/View/AbstractDirectoryView.vala"
							_tmp391_ = _tmp390_;
#line 2211 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp389_, (GtkWidget*) _tmp391_);
#line 2211 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp391_);
#line 12306 "AbstractDirectoryView.c"
						}
					}
#line 2218 "../src/View/AbstractDirectoryView.vala"
					_tmp392_ = menu;
#line 2218 "../src/View/AbstractDirectoryView.vala"
					_tmp393_ = paste_menuitem;
#line 2218 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp392_, (GtkWidget*) _tmp393_);
#line 2219 "../src/View/AbstractDirectoryView.vala"
					_tmp394_ = select_all_menuitem;
#line 2219 "../src/View/AbstractDirectoryView.vala"
					if (_tmp394_ != NULL) {
#line 12319 "AbstractDirectoryView.c"
						GtkMenu* _tmp395_;
						GtkMenuItem* _tmp396_;
#line 2220 "../src/View/AbstractDirectoryView.vala"
						_tmp395_ = menu;
#line 2220 "../src/View/AbstractDirectoryView.vala"
						_tmp396_ = select_all_menuitem;
#line 2220 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp395_, (GtkWidget*) _tmp396_);
#line 12328 "AbstractDirectoryView.c"
					}
#line 2223 "../src/View/AbstractDirectoryView.vala"
					if (self->is_writable) {
#line 12332 "AbstractDirectoryView.c"
						GtkMenu* _tmp397_;
						FilesAbstractDirectoryViewNewSubMenuItem* _tmp398_;
						FilesAbstractDirectoryViewNewSubMenuItem* _tmp399_;
#line 2224 "../src/View/AbstractDirectoryView.vala"
						_tmp397_ = menu;
#line 2224 "../src/View/AbstractDirectoryView.vala"
						_tmp398_ = files_abstract_directory_view_new_sub_menu_item_new ();
#line 2224 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp398_);
#line 2224 "../src/View/AbstractDirectoryView.vala"
						_tmp399_ = _tmp398_;
#line 2224 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp397_, (GtkWidget*) _tmp399_);
#line 2224 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp399_);
#line 12348 "AbstractDirectoryView.c"
					}
#line 2227 "../src/View/AbstractDirectoryView.vala"
					_tmp400_ = menu;
#line 2227 "../src/View/AbstractDirectoryView.vala"
					_tmp401_ = files_abstract_directory_view_sort_sub_menu_item_new ();
#line 2227 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp401_);
#line 2227 "../src/View/AbstractDirectoryView.vala"
					_tmp402_ = _tmp401_;
#line 2227 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp400_, (GtkWidget*) _tmp402_);
#line 2227 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp402_);
#line 12362 "AbstractDirectoryView.c"
				}
#line 2231 "../src/View/AbstractDirectoryView.vala"
				_tmp404_ = self->priv->common_actions;
#line 2231 "../src/View/AbstractDirectoryView.vala"
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp404_, "bookmark")) {
#line 12368 "AbstractDirectoryView.c"
					FilesViewWindow* _tmp405_;
					FilesViewWindow* _tmp406_;
					FilesViewSlot* _tmp407_;
					FilesDirectory* _tmp408_;
					FilesDirectory* _tmp409_;
					FilesFile* _tmp410_;
					FilesFile* _tmp411_;
					const gchar* _tmp412_;
					const gchar* _tmp413_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp405_ = files_abstract_directory_view_get_window (self);
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp406_ = _tmp405_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp407_ = self->slot;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp408_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp407_);
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp409_ = _tmp408_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp410_ = files_directory_get_file (_tmp409_);
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp411_ = _tmp410_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp412_ = files_file_get_uri (_tmp411_);
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp413_ = _tmp412_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
					_tmp403_ = files_view_window_can_bookmark_uri (_tmp406_, _tmp413_);
#line 12398 "AbstractDirectoryView.c"
				} else {
#line 2231 "../src/View/AbstractDirectoryView.vala"
					_tmp403_ = FALSE;
#line 12402 "AbstractDirectoryView.c"
				}
#line 2231 "../src/View/AbstractDirectoryView.vala"
				if (_tmp403_) {
#line 12406 "AbstractDirectoryView.c"
					GtkMenu* _tmp414_;
					GtkMenuItem* _tmp415_;
#line 2234 "../src/View/AbstractDirectoryView.vala"
					_tmp414_ = menu;
#line 2234 "../src/View/AbstractDirectoryView.vala"
					_tmp415_ = bookmark_menuitem;
#line 2234 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp414_, (GtkWidget*) _tmp415_);
#line 12415 "AbstractDirectoryView.c"
				}
#line 2237 "../src/View/AbstractDirectoryView.vala"
				if (!self->priv->in_network_root) {
#line 12419 "AbstractDirectoryView.c"
					GtkMenu* _tmp416_;
					GtkSeparatorMenuItem* _tmp417_;
					GtkSeparatorMenuItem* _tmp418_;
					GtkMenu* _tmp419_;
					GtkMenuItem* _tmp420_;
#line 2238 "../src/View/AbstractDirectoryView.vala"
					_tmp416_ = menu;
#line 2238 "../src/View/AbstractDirectoryView.vala"
					_tmp417_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2238 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp417_);
#line 2238 "../src/View/AbstractDirectoryView.vala"
					_tmp418_ = _tmp417_;
#line 2238 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp416_, (GtkWidget*) _tmp418_);
#line 2238 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp418_);
#line 2239 "../src/View/AbstractDirectoryView.vala"
					_tmp419_ = menu;
#line 2239 "../src/View/AbstractDirectoryView.vala"
					_tmp420_ = properties_menuitem;
#line 2239 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp419_, (GtkWidget*) _tmp420_);
#line 12443 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2244 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->in_trash) {
#line 12450 "AbstractDirectoryView.c"
		FilesPluginManager* _tmp421_;
		GtkMenu* _tmp422_;
		GList* _tmp423_;
		gboolean _tmp424_ = FALSE;
		GList* _tmp425_;
#line 2247 "../src/View/AbstractDirectoryView.vala"
		_tmp421_ = plugins;
#line 2247 "../src/View/AbstractDirectoryView.vala"
		_tmp422_ = menu;
#line 2247 "../src/View/AbstractDirectoryView.vala"
		_tmp423_ = files_abstract_directory_view_get_selected_files (self);
#line 2247 "../src/View/AbstractDirectoryView.vala"
		files_plugin_manager_hook_context_menu (_tmp421_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp422_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp422_) : NULL, _tmp423_);
#line 2249 "../src/View/AbstractDirectoryView.vala"
		_tmp425_ = selection;
#line 2249 "../src/View/AbstractDirectoryView.vala"
		if (g_list_length (_tmp425_) == ((guint) 1)) {
#line 12468 "AbstractDirectoryView.c"
			GList* _tmp426_;
			gconstpointer _tmp427_;
			GFileInfo* _tmp428_;
			const gchar* _tmp429_;
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp426_ = selection;
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp427_ = g_list_nth_data (_tmp426_, (guint) 0);
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp428_ = ((FilesFile*) _tmp427_)->info;
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp429_ = g_file_info_get_content_type (_tmp428_);
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp424_ = string_contains (_tmp429_, "image");
#line 12483 "AbstractDirectoryView.c"
		} else {
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_tmp424_ = FALSE;
#line 12487 "AbstractDirectoryView.c"
		}
#line 2249 "../src/View/AbstractDirectoryView.vala"
		if (_tmp424_) {
#line 12491 "AbstractDirectoryView.c"
			GtkMenuItem* wallpaper_menuitem = NULL;
			gchar* _tmp430_;
			GtkMenuItem* _tmp431_ = NULL;
			GtkMenu* _tmp432_;
			GtkMenuItem* _tmp433_;
#line 2250 "../src/View/AbstractDirectoryView.vala"
			_tmp430_ = g_strdup ("common.set-wallpaper");
#line 2250 "../src/View/AbstractDirectoryView.vala"
			_tmp431_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Set as Wallpaper"));
#line 2250 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp431_, _tmp430_);
#line 2250 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (_tmp430_);
#line 2250 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp431_);
#line 2250 "../src/View/AbstractDirectoryView.vala"
			wallpaper_menuitem = _tmp431_;
#line 2254 "../src/View/AbstractDirectoryView.vala"
			_tmp432_ = menu;
#line 2254 "../src/View/AbstractDirectoryView.vala"
			_tmp433_ = wallpaper_menuitem;
#line 2254 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp432_, (GtkWidget*) _tmp433_);
#line 2249 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (wallpaper_menuitem);
#line 12517 "AbstractDirectoryView.c"
		}
	}
#line 2258 "../src/View/AbstractDirectoryView.vala"
	_tmp434_ = menu;
#line 2258 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_set_screen (_tmp434_, NULL);
#line 2259 "../src/View/AbstractDirectoryView.vala"
	_tmp435_ = menu;
#line 2259 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_attach_to_widget (_tmp435_, (GtkWidget*) self, NULL);
#line 2262 "../src/View/AbstractDirectoryView.vala"
	_tmp436_ = self->slot;
#line 2262 "../src/View/AbstractDirectoryView.vala"
	_tmp437_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp436_);
#line 2262 "../src/View/AbstractDirectoryView.vala"
	_tmp438_ = _tmp437_;
#line 2262 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_empty (_tmp438_)) {
#line 12536 "AbstractDirectoryView.c"
		GtkMenu* _tmp439_;
		GtkStyleContext* _tmp440_;
#line 2263 "../src/View/AbstractDirectoryView.vala"
		_tmp439_ = menu;
#line 2263 "../src/View/AbstractDirectoryView.vala"
		_tmp440_ = gtk_widget_get_style_context ((GtkWidget*) _tmp439_);
#line 2263 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_add_class (_tmp440_, GTK_STYLE_CLASS_CONTEXT_MENU);
#line 12545 "AbstractDirectoryView.c"
	}
#line 2266 "../src/View/AbstractDirectoryView.vala"
	_tmp441_ = menu;
#line 2266 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp441_);
#line 2267 "../src/View/AbstractDirectoryView.vala"
	_tmp442_ = menu;
#line 2267 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_popup_at_pointer (_tmp442_, event);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (invert_selection_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (deselect_all_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (select_all_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (properties_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (bookmark_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (paste_menuitem);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (open_submenu_item);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (open_submenu);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (selected_file);
#line 1828 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 1828 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (menu);
#line 12577 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_valid_selection_for_edit (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result;
#line 2376 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2377 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 12589 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 2377 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp0_;
#line 2377 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 12597 "AbstractDirectoryView.c"
			FilesFile* file = NULL;
#line 2377 "../src/View/AbstractDirectoryView.vala"
			file = (FilesFile*) file_it->data;
#line 12601 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp1_;
#line 2378 "../src/View/AbstractDirectoryView.vala"
				_tmp1_ = file;
#line 2378 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_root_network_folder (_tmp1_)) {
#line 2379 "../src/View/AbstractDirectoryView.vala"
					result = FALSE;
#line 2379 "../src/View/AbstractDirectoryView.vala"
					return result;
#line 12612 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2383 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 2383 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 12621 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_valid_selection_for_restore (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result;
#line 2386 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2387 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 12633 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 2387 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp0_;
#line 2387 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 12641 "AbstractDirectoryView.c"
			FilesFile* file = NULL;
#line 2387 "../src/View/AbstractDirectoryView.vala"
			file = (FilesFile*) file_it->data;
#line 12645 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp1_;
				GFile* _tmp2_;
				GFile* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gboolean _tmp6_;
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp1_ = file;
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = files_file_get_directory (_tmp1_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = _tmp2_;
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = g_file_get_basename (_tmp3_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = !(g_strcmp0 (_tmp5_, "/") == 0);
#line 2388 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp5_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
				if (_tmp6_) {
#line 2389 "../src/View/AbstractDirectoryView.vala"
					result = FALSE;
#line 2389 "../src/View/AbstractDirectoryView.vala"
					return result;
#line 12673 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2393 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 2393 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 12682 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_menu_actions (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GList* selection = NULL;
	GList* _tmp8_;
	FilesFile* file = NULL;
	gboolean is_selected = FALSE;
	GList* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean more_than_one_selected = FALSE;
	gboolean single_folder = FALSE;
	gboolean only_folders = FALSE;
	GList* _tmp14_;
	gboolean can_rename = FALSE;
	gboolean can_show_properties = FALSE;
	gboolean can_copy = FALSE;
	gboolean can_open = FALSE;
	gboolean can_paste_into = FALSE;
	gboolean can_bookmark = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	FilesFile* _tmp46_;
	FilesFile* _tmp47_;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_;
	GSimpleActionGroup* _tmp52_;
	GSimpleActionGroup* _tmp53_;
	gboolean _tmp54_;
	GSimpleActionGroup* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_;
	GSimpleActionGroup* _tmp59_;
	GSimpleActionGroup* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_;
	GSimpleActionGroup* _tmp66_;
	gboolean _tmp67_ = FALSE;
	gboolean _tmp68_;
	GSimpleActionGroup* _tmp69_;
	gboolean _tmp70_ = FALSE;
	gboolean _tmp71_;
	GSimpleActionGroup* _tmp72_;
	gboolean _tmp73_ = FALSE;
	gboolean _tmp74_;
	GSimpleActionGroup* _tmp75_;
	gboolean _tmp76_ = FALSE;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_;
	GSimpleActionGroup* _tmp79_;
	gboolean _tmp80_ = FALSE;
	gboolean _tmp81_ = FALSE;
	gboolean _tmp82_;
	GSimpleActionGroup* _tmp88_;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_;
	GSimpleActionGroup* _tmp91_;
	gboolean _tmp92_ = FALSE;
	gboolean _tmp93_;
	GSimpleActionGroup* _tmp94_;
	gboolean _tmp95_ = FALSE;
	gboolean _tmp96_;
	GSimpleActionGroup* _tmp97_;
	gboolean _tmp98_ = FALSE;
	gboolean _tmp99_;
	GSimpleActionGroup* _tmp100_;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp102_;
	GSimpleActionGroup* _tmp103_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_ = FALSE;
	gboolean _tmp106_;
	GSimpleActionGroup* _tmp107_;
	gboolean _tmp108_ = FALSE;
	gboolean _tmp109_ = FALSE;
	gboolean _tmp110_ = FALSE;
	gboolean _tmp111_;
	GSimpleActionGroup* _tmp113_;
	gboolean _tmp114_ = FALSE;
	gboolean _tmp115_;
	GSimpleActionGroup* _tmp116_;
	gboolean _tmp117_ = FALSE;
	gboolean _tmp118_;
	GSimpleActionGroup* _tmp119_;
	GList* _tmp120_;
#line 2396 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2397 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 12788 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp3_;
		FilesDirectory* _tmp4_;
		FilesDirectory* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->slot;
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp3_);
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_;
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_directory_get_can_load (_tmp5_);
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 2397 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp7_;
#line 12807 "AbstractDirectoryView.c"
	}
#line 2397 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 2398 "../src/View/AbstractDirectoryView.vala"
		return;
#line 12813 "AbstractDirectoryView.c"
	}
#line 2401 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_directory_view_get_files_for_action (self);
#line 2401 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp8_;
#line 2404 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = selection;
#line 2404 "../src/View/AbstractDirectoryView.vala"
	is_selected = _tmp9_ != NULL;
#line 2405 "../src/View/AbstractDirectoryView.vala"
	if (is_selected) {
#line 12825 "AbstractDirectoryView.c"
		GList* _tmp11_;
		GList* _tmp12_;
		GList* _tmp13_;
#line 2405 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = selection;
#line 2405 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = g_list_first (_tmp11_);
#line 2405 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_->next;
#line 2405 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp13_ != NULL;
#line 12837 "AbstractDirectoryView.c"
	} else {
#line 2405 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = FALSE;
#line 12841 "AbstractDirectoryView.c"
	}
#line 2405 "../src/View/AbstractDirectoryView.vala"
	more_than_one_selected = _tmp10_;
#line 2406 "../src/View/AbstractDirectoryView.vala"
	single_folder = FALSE;
#line 2407 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = selection;
#line 2407 "../src/View/AbstractDirectoryView.vala"
	only_folders = files_abstract_directory_view_selection_only_contains_folders (self, _tmp14_);
#line 2408 "../src/View/AbstractDirectoryView.vala"
	can_rename = FALSE;
#line 2409 "../src/View/AbstractDirectoryView.vala"
	can_show_properties = FALSE;
#line 2410 "../src/View/AbstractDirectoryView.vala"
	can_copy = FALSE;
#line 2411 "../src/View/AbstractDirectoryView.vala"
	can_open = FALSE;
#line 2412 "../src/View/AbstractDirectoryView.vala"
	can_paste_into = FALSE;
#line 2413 "../src/View/AbstractDirectoryView.vala"
	can_bookmark = FALSE;
#line 2415 "../src/View/AbstractDirectoryView.vala"
	if (is_selected) {
#line 12865 "AbstractDirectoryView.c"
		GList* _tmp15_;
		gconstpointer _tmp16_;
		FilesFile* _tmp17_;
		FilesFile* _tmp18_;
#line 2416 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = selection;
#line 2416 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = _tmp15_->data;
#line 2416 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = _g_object_ref0 ((FilesFile*) _tmp16_);
#line 2416 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 2416 "../src/View/AbstractDirectoryView.vala"
		file = _tmp17_;
#line 2417 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = file;
#line 2417 "../src/View/AbstractDirectoryView.vala"
		if (_tmp18_ != NULL) {
#line 12884 "AbstractDirectoryView.c"
			gboolean _tmp19_ = FALSE;
			gboolean _tmp21_ = FALSE;
#line 2418 "../src/View/AbstractDirectoryView.vala"
			if (!more_than_one_selected) {
#line 12889 "AbstractDirectoryView.c"
				FilesFile* _tmp20_;
#line 2418 "../src/View/AbstractDirectoryView.vala"
				_tmp20_ = file;
#line 2418 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = files_file_is_folder (_tmp20_);
#line 12895 "AbstractDirectoryView.c"
			} else {
#line 2418 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = FALSE;
#line 12899 "AbstractDirectoryView.c"
			}
#line 2418 "../src/View/AbstractDirectoryView.vala"
			single_folder = _tmp19_;
#line 2419 "../src/View/AbstractDirectoryView.vala"
			can_rename = self->is_writable;
#line 2420 "../src/View/AbstractDirectoryView.vala"
			if (single_folder) {
#line 12907 "AbstractDirectoryView.c"
				FilesFile* _tmp22_;
#line 2420 "../src/View/AbstractDirectoryView.vala"
				_tmp22_ = file;
#line 2420 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = files_file_is_writable (_tmp22_);
#line 12913 "AbstractDirectoryView.c"
			} else {
#line 2420 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = FALSE;
#line 12917 "AbstractDirectoryView.c"
			}
#line 2420 "../src/View/AbstractDirectoryView.vala"
			can_paste_into = _tmp21_;
#line 12921 "AbstractDirectoryView.c"
		} else {
#line 2422 "../src/View/AbstractDirectoryView.vala"
			g_critical ("AbstractDirectoryView.vala:2422: File in selection is null");
#line 12925 "AbstractDirectoryView.c"
		}
	} else {
		FilesViewSlot* _tmp23_;
		FilesDirectory* _tmp24_;
		FilesDirectory* _tmp25_;
		FilesFile* _tmp26_;
		FilesFile* _tmp27_;
		FilesFile* _tmp28_;
		gboolean _tmp29_ = FALSE;
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = self->slot;
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp23_);
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = _tmp24_;
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp26_ = files_directory_get_file (_tmp25_);
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp27_ = _tmp26_;
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 2425 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 2425 "../src/View/AbstractDirectoryView.vala"
		file = _tmp28_;
#line 2426 "../src/View/AbstractDirectoryView.vala"
		if (!more_than_one_selected) {
#line 12953 "AbstractDirectoryView.c"
			FilesFile* _tmp30_;
#line 2426 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = file;
#line 2426 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = files_file_is_folder (_tmp30_);
#line 12959 "AbstractDirectoryView.c"
		} else {
#line 2426 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = FALSE;
#line 12963 "AbstractDirectoryView.c"
		}
#line 2426 "../src/View/AbstractDirectoryView.vala"
		single_folder = _tmp29_;
#line 2427 "../src/View/AbstractDirectoryView.vala"
		can_paste_into = self->is_writable;
#line 12969 "AbstractDirectoryView.c"
	}
#line 2432 "../src/View/AbstractDirectoryView.vala"
	if (!more_than_one_selected) {
#line 2432 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = TRUE;
#line 12975 "AbstractDirectoryView.c"
	} else {
#line 2432 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = single_folder;
#line 12979 "AbstractDirectoryView.c"
	}
#line 2432 "../src/View/AbstractDirectoryView.vala"
	if (_tmp32_) {
#line 12983 "AbstractDirectoryView.c"
		gboolean _tmp33_ = FALSE;
		gboolean _tmp34_ = FALSE;
		FilesViewSlot* _tmp35_;
		FilesDirectory* _tmp36_;
		FilesDirectory* _tmp37_;
		gboolean _tmp38_;
		gboolean _tmp39_;
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = self->slot;
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp35_);
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = _tmp36_;
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = files_directory_get_is_local (_tmp37_);
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = _tmp38_;
#line 2433 "../src/View/AbstractDirectoryView.vala"
		if (_tmp39_) {
#line 2433 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = TRUE;
#line 13005 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp40_ = FALSE;
			FilesFile* _tmp41_;
			const gchar* _tmp42_;
#line 2434 "../src/View/AbstractDirectoryView.vala"
			_tmp41_ = file;
#line 2434 "../src/View/AbstractDirectoryView.vala"
			_tmp42_ = files_file_get_ftype (_tmp41_);
#line 2434 "../src/View/AbstractDirectoryView.vala"
			if (_tmp42_ != NULL) {
#line 13016 "AbstractDirectoryView.c"
				FilesFile* _tmp43_;
				const gchar* _tmp44_;
#line 2434 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = file;
#line 2434 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = files_file_get_ftype (_tmp43_);
#line 2434 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = g_strcmp0 (_tmp44_, "inode/directory") == 0;
#line 13025 "AbstractDirectoryView.c"
			} else {
#line 2434 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = FALSE;
#line 13029 "AbstractDirectoryView.c"
			}
#line 2434 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = _tmp40_;
#line 13033 "AbstractDirectoryView.c"
		}
#line 2433 "../src/View/AbstractDirectoryView.vala"
		if (_tmp34_) {
#line 2433 "../src/View/AbstractDirectoryView.vala"
			_tmp33_ = TRUE;
#line 13039 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp45_;
#line 2435 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = file;
#line 2435 "../src/View/AbstractDirectoryView.vala"
			_tmp33_ = files_file_is_smb_server (_tmp45_);
#line 13046 "AbstractDirectoryView.c"
		}
#line 2433 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = _tmp33_;
#line 13050 "AbstractDirectoryView.c"
	} else {
#line 2432 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = FALSE;
#line 13054 "AbstractDirectoryView.c"
	}
#line 2432 "../src/View/AbstractDirectoryView.vala"
	can_bookmark = _tmp31_;
#line 2437 "../src/View/AbstractDirectoryView.vala"
	_tmp46_ = file;
#line 2437 "../src/View/AbstractDirectoryView.vala"
	can_copy = files_file_is_readable (_tmp46_);
#line 2438 "../src/View/AbstractDirectoryView.vala"
	_tmp47_ = file;
#line 2438 "../src/View/AbstractDirectoryView.vala"
	can_open = files_abstract_directory_view_can_open_file (self, _tmp47_, FALSE);
#line 2439 "../src/View/AbstractDirectoryView.vala"
	_tmp49_ = self->priv->_in_recent;
#line 2439 "../src/View/AbstractDirectoryView.vala"
	if (_tmp49_) {
#line 2439 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = more_than_one_selected;
#line 13072 "AbstractDirectoryView.c"
	} else {
#line 2439 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = FALSE;
#line 13076 "AbstractDirectoryView.c"
	}
#line 2439 "../src/View/AbstractDirectoryView.vala"
	can_show_properties = !_tmp48_;
#line 2441 "../src/View/AbstractDirectoryView.vala"
	_tmp51_ = self->priv->_in_recent;
#line 2441 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp51_) {
#line 2441 "../src/View/AbstractDirectoryView.vala"
		_tmp50_ = self->is_writable;
#line 13086 "AbstractDirectoryView.c"
	} else {
#line 2441 "../src/View/AbstractDirectoryView.vala"
		_tmp50_ = FALSE;
#line 13090 "AbstractDirectoryView.c"
	}
#line 2441 "../src/View/AbstractDirectoryView.vala"
	_tmp52_ = self->priv->common_actions;
#line 2441 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp52_, "paste", _tmp50_);
#line 2442 "../src/View/AbstractDirectoryView.vala"
	_tmp53_ = self->priv->common_actions;
#line 2442 "../src/View/AbstractDirectoryView.vala"
	_tmp54_ = self->priv->_renaming;
#line 2442 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp53_, "paste-into", (!_tmp54_) & can_paste_into);
#line 2443 "../src/View/AbstractDirectoryView.vala"
	_tmp55_ = self->priv->common_actions;
#line 2443 "../src/View/AbstractDirectoryView.vala"
	_tmp56_ = self->priv->_renaming;
#line 2443 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp55_, "open-in", (!_tmp56_) & only_folders);
#line 2444 "../src/View/AbstractDirectoryView.vala"
	_tmp58_ = self->priv->_renaming;
#line 2444 "../src/View/AbstractDirectoryView.vala"
	if ((!_tmp58_) & is_selected) {
#line 2444 "../src/View/AbstractDirectoryView.vala"
		_tmp57_ = can_rename;
#line 13114 "AbstractDirectoryView.c"
	} else {
#line 2444 "../src/View/AbstractDirectoryView.vala"
		_tmp57_ = FALSE;
#line 13118 "AbstractDirectoryView.c"
	}
#line 2444 "../src/View/AbstractDirectoryView.vala"
	_tmp59_ = self->priv->selection_actions;
#line 2444 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp59_, "rename", _tmp57_);
#line 2445 "../src/View/AbstractDirectoryView.vala"
	_tmp60_ = self->priv->selection_actions;
#line 2445 "../src/View/AbstractDirectoryView.vala"
	_tmp61_ = self->priv->_renaming;
#line 2445 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp60_, "view-in-location", (!_tmp61_) & is_selected);
#line 2446 "../src/View/AbstractDirectoryView.vala"
	_tmp65_ = self->priv->_renaming;
#line 2446 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp65_) {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp64_ = is_selected;
#line 13136 "AbstractDirectoryView.c"
	} else {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp64_ = FALSE;
#line 13140 "AbstractDirectoryView.c"
	}
#line 2446 "../src/View/AbstractDirectoryView.vala"
	if (_tmp64_) {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp63_ = !more_than_one_selected;
#line 13146 "AbstractDirectoryView.c"
	} else {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp63_ = FALSE;
#line 13150 "AbstractDirectoryView.c"
	}
#line 2446 "../src/View/AbstractDirectoryView.vala"
	if (_tmp63_) {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp62_ = can_open;
#line 13156 "AbstractDirectoryView.c"
	} else {
#line 2446 "../src/View/AbstractDirectoryView.vala"
		_tmp62_ = FALSE;
#line 13160 "AbstractDirectoryView.c"
	}
#line 2446 "../src/View/AbstractDirectoryView.vala"
	_tmp66_ = self->priv->selection_actions;
#line 2446 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp66_, "open", _tmp62_);
#line 2447 "../src/View/AbstractDirectoryView.vala"
	_tmp68_ = self->priv->_renaming;
#line 2447 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp68_) {
#line 2447 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = can_open;
#line 13172 "AbstractDirectoryView.c"
	} else {
#line 2447 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = FALSE;
#line 13176 "AbstractDirectoryView.c"
	}
#line 2447 "../src/View/AbstractDirectoryView.vala"
	_tmp69_ = self->priv->selection_actions;
#line 2447 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp69_, "open-with-app", _tmp67_);
#line 2448 "../src/View/AbstractDirectoryView.vala"
	_tmp71_ = self->priv->_renaming;
#line 2448 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp71_) {
#line 2448 "../src/View/AbstractDirectoryView.vala"
		_tmp70_ = can_open;
#line 13188 "AbstractDirectoryView.c"
	} else {
#line 2448 "../src/View/AbstractDirectoryView.vala"
		_tmp70_ = FALSE;
#line 13192 "AbstractDirectoryView.c"
	}
#line 2448 "../src/View/AbstractDirectoryView.vala"
	_tmp72_ = self->priv->selection_actions;
#line 2448 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp72_, "open-with-default", _tmp70_);
#line 2449 "../src/View/AbstractDirectoryView.vala"
	_tmp74_ = self->priv->_renaming;
#line 2449 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp74_) {
#line 2449 "../src/View/AbstractDirectoryView.vala"
		_tmp73_ = can_open;
#line 13204 "AbstractDirectoryView.c"
	} else {
#line 2449 "../src/View/AbstractDirectoryView.vala"
		_tmp73_ = FALSE;
#line 13208 "AbstractDirectoryView.c"
	}
#line 2449 "../src/View/AbstractDirectoryView.vala"
	_tmp75_ = self->priv->selection_actions;
#line 2449 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp75_, "open-with-other-app", _tmp73_);
#line 2450 "../src/View/AbstractDirectoryView.vala"
	_tmp78_ = self->priv->_renaming;
#line 2450 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp78_) {
#line 2450 "../src/View/AbstractDirectoryView.vala"
		_tmp77_ = self->is_writable;
#line 13220 "AbstractDirectoryView.c"
	} else {
#line 2450 "../src/View/AbstractDirectoryView.vala"
		_tmp77_ = FALSE;
#line 13224 "AbstractDirectoryView.c"
	}
#line 2450 "../src/View/AbstractDirectoryView.vala"
	if (_tmp77_) {
#line 2450 "../src/View/AbstractDirectoryView.vala"
		_tmp76_ = is_selected;
#line 13230 "AbstractDirectoryView.c"
	} else {
#line 2450 "../src/View/AbstractDirectoryView.vala"
		_tmp76_ = FALSE;
#line 13234 "AbstractDirectoryView.c"
	}
#line 2450 "../src/View/AbstractDirectoryView.vala"
	_tmp79_ = self->priv->selection_actions;
#line 2450 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp79_, "cut", _tmp76_);
#line 2451 "../src/View/AbstractDirectoryView.vala"
	_tmp82_ = self->priv->_renaming;
#line 2451 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp82_) {
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp81_ = self->is_writable;
#line 13246 "AbstractDirectoryView.c"
	} else {
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp81_ = FALSE;
#line 13250 "AbstractDirectoryView.c"
	}
#line 2451 "../src/View/AbstractDirectoryView.vala"
	if (_tmp81_) {
#line 13254 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp83_;
		FilesDirectory* _tmp84_;
		FilesDirectory* _tmp85_;
		gboolean _tmp86_;
		gboolean _tmp87_;
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp83_ = self->slot;
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp84_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp83_);
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp85_ = _tmp84_;
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp86_ = files_directory_get_has_trash_dirs (_tmp85_);
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp87_ = _tmp86_;
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp80_ = _tmp87_;
#line 13272 "AbstractDirectoryView.c"
	} else {
#line 2451 "../src/View/AbstractDirectoryView.vala"
		_tmp80_ = FALSE;
#line 13276 "AbstractDirectoryView.c"
	}
#line 2451 "../src/View/AbstractDirectoryView.vala"
	_tmp88_ = self->priv->selection_actions;
#line 2451 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp88_, "trash", _tmp80_);
#line 2452 "../src/View/AbstractDirectoryView.vala"
	_tmp90_ = self->priv->_renaming;
#line 2452 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp90_) {
#line 2452 "../src/View/AbstractDirectoryView.vala"
		_tmp89_ = self->is_writable;
#line 13288 "AbstractDirectoryView.c"
	} else {
#line 2452 "../src/View/AbstractDirectoryView.vala"
		_tmp89_ = FALSE;
#line 13292 "AbstractDirectoryView.c"
	}
#line 2452 "../src/View/AbstractDirectoryView.vala"
	_tmp91_ = self->priv->selection_actions;
#line 2452 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp91_, "delete", _tmp89_);
#line 2453 "../src/View/AbstractDirectoryView.vala"
	_tmp93_ = self->priv->_renaming;
#line 2453 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp93_) {
#line 2453 "../src/View/AbstractDirectoryView.vala"
		_tmp92_ = is_selected;
#line 13304 "AbstractDirectoryView.c"
	} else {
#line 2453 "../src/View/AbstractDirectoryView.vala"
		_tmp92_ = FALSE;
#line 13308 "AbstractDirectoryView.c"
	}
#line 2453 "../src/View/AbstractDirectoryView.vala"
	_tmp94_ = self->priv->selection_actions;
#line 2453 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp94_, "invert-selection", _tmp92_);
#line 2454 "../src/View/AbstractDirectoryView.vala"
	_tmp96_ = self->priv->_renaming;
#line 2454 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp96_) {
#line 2454 "../src/View/AbstractDirectoryView.vala"
		_tmp95_ = is_selected;
#line 13320 "AbstractDirectoryView.c"
	} else {
#line 2454 "../src/View/AbstractDirectoryView.vala"
		_tmp95_ = FALSE;
#line 13324 "AbstractDirectoryView.c"
	}
#line 2454 "../src/View/AbstractDirectoryView.vala"
	_tmp97_ = self->priv->common_actions;
#line 2454 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp97_, "select-all", _tmp95_);
#line 2455 "../src/View/AbstractDirectoryView.vala"
	_tmp99_ = self->priv->_renaming;
#line 2455 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp99_) {
#line 2455 "../src/View/AbstractDirectoryView.vala"
		_tmp98_ = can_show_properties;
#line 13336 "AbstractDirectoryView.c"
	} else {
#line 2455 "../src/View/AbstractDirectoryView.vala"
		_tmp98_ = FALSE;
#line 13340 "AbstractDirectoryView.c"
	}
#line 2455 "../src/View/AbstractDirectoryView.vala"
	_tmp100_ = self->priv->common_actions;
#line 2455 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp100_, "properties", _tmp98_);
#line 2456 "../src/View/AbstractDirectoryView.vala"
	_tmp102_ = self->priv->_renaming;
#line 2456 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp102_) {
#line 2456 "../src/View/AbstractDirectoryView.vala"
		_tmp101_ = can_bookmark;
#line 13352 "AbstractDirectoryView.c"
	} else {
#line 2456 "../src/View/AbstractDirectoryView.vala"
		_tmp101_ = FALSE;
#line 13356 "AbstractDirectoryView.c"
	}
#line 2456 "../src/View/AbstractDirectoryView.vala"
	_tmp103_ = self->priv->common_actions;
#line 2456 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp103_, "bookmark", _tmp101_);
#line 2457 "../src/View/AbstractDirectoryView.vala"
	_tmp106_ = self->priv->_renaming;
#line 2457 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp106_) {
#line 2457 "../src/View/AbstractDirectoryView.vala"
		_tmp105_ = !self->priv->in_trash;
#line 13368 "AbstractDirectoryView.c"
	} else {
#line 2457 "../src/View/AbstractDirectoryView.vala"
		_tmp105_ = FALSE;
#line 13372 "AbstractDirectoryView.c"
	}
#line 2457 "../src/View/AbstractDirectoryView.vala"
	if (_tmp105_) {
#line 2457 "../src/View/AbstractDirectoryView.vala"
		_tmp104_ = can_copy;
#line 13378 "AbstractDirectoryView.c"
	} else {
#line 2457 "../src/View/AbstractDirectoryView.vala"
		_tmp104_ = FALSE;
#line 13382 "AbstractDirectoryView.c"
	}
#line 2457 "../src/View/AbstractDirectoryView.vala"
	_tmp107_ = self->priv->common_actions;
#line 2457 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp107_, "copy", _tmp104_);
#line 2458 "../src/View/AbstractDirectoryView.vala"
	_tmp111_ = self->priv->_renaming;
#line 2458 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp111_) {
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp110_ = !self->priv->in_trash;
#line 13394 "AbstractDirectoryView.c"
	} else {
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp110_ = FALSE;
#line 13398 "AbstractDirectoryView.c"
	}
#line 2458 "../src/View/AbstractDirectoryView.vala"
	if (_tmp110_) {
#line 13402 "AbstractDirectoryView.c"
		gboolean _tmp112_;
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp112_ = self->priv->_in_recent;
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp109_ = !_tmp112_;
#line 13408 "AbstractDirectoryView.c"
	} else {
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp109_ = FALSE;
#line 13412 "AbstractDirectoryView.c"
	}
#line 2458 "../src/View/AbstractDirectoryView.vala"
	if (_tmp109_) {
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp108_ = can_copy;
#line 13418 "AbstractDirectoryView.c"
	} else {
#line 2458 "../src/View/AbstractDirectoryView.vala"
		_tmp108_ = FALSE;
#line 13422 "AbstractDirectoryView.c"
	}
#line 2458 "../src/View/AbstractDirectoryView.vala"
	_tmp113_ = self->priv->common_actions;
#line 2458 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp113_, "copy-link", _tmp108_);
#line 2459 "../src/View/AbstractDirectoryView.vala"
	_tmp115_ = self->priv->_renaming;
#line 2459 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp115_) {
#line 2459 "../src/View/AbstractDirectoryView.vala"
		_tmp114_ = !more_than_one_selected;
#line 13434 "AbstractDirectoryView.c"
	} else {
#line 2459 "../src/View/AbstractDirectoryView.vala"
		_tmp114_ = FALSE;
#line 13438 "AbstractDirectoryView.c"
	}
#line 2459 "../src/View/AbstractDirectoryView.vala"
	_tmp116_ = self->priv->common_actions;
#line 2459 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp116_, "bookmark", _tmp114_);
#line 2460 "../src/View/AbstractDirectoryView.vala"
	_tmp118_ = self->priv->_renaming;
#line 2460 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp118_) {
#line 2460 "../src/View/AbstractDirectoryView.vala"
		_tmp117_ = !more_than_one_selected;
#line 13450 "AbstractDirectoryView.c"
	} else {
#line 2460 "../src/View/AbstractDirectoryView.vala"
		_tmp117_ = FALSE;
#line 13454 "AbstractDirectoryView.c"
	}
#line 2460 "../src/View/AbstractDirectoryView.vala"
	_tmp119_ = self->priv->common_actions;
#line 2460 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp119_, "set-wallpaper", _tmp117_);
#line 2462 "../src/View/AbstractDirectoryView.vala"
	_tmp120_ = selection;
#line 2462 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_default_app (self, _tmp120_);
#line 2463 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions_sort (self);
#line 2396 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 2396 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 13470 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_menu_actions_sort (FilesAbstractDirectoryView* self)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FilesListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
#line 2466 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2470 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2470 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
#line 2470 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = _tmp1_;
#line 2470 "../src/View/AbstractDirectoryView.vala"
	sort_order = _tmp2_;
#line 2470 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 13494 "AbstractDirectoryView.c"
		GVariant* val = NULL;
		const gchar* _tmp4_;
		GVariant* _tmp5_;
		GSimpleActionGroup* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GSimpleActionGroup* _tmp9_;
		GVariant* _tmp10_;
		FilesPreferences* _tmp11_;
		FilesPreferences* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		GVariant* _tmp15_;
		GSimpleActionGroup* _tmp16_;
		GVariant* _tmp17_;
#line 2471 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_list_model_column_id_to_string ((FilesListModelColumnID) sort_column_id);
#line 2471 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_variant_new_string (_tmp4_);
#line 2471 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp5_);
#line 2471 "../src/View/AbstractDirectoryView.vala"
		val = _tmp5_;
#line 2472 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->priv->background_actions;
#line 2472 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = val;
#line 2472 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp6_, "sort-by", _tmp7_);
#line 2473 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = g_variant_new_boolean (sort_order == GTK_SORT_DESCENDING);
#line 2473 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp8_);
#line 2473 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 2473 "../src/View/AbstractDirectoryView.vala"
		val = _tmp8_;
#line 2474 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = self->priv->background_actions;
#line 2474 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = val;
#line 2474 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp9_, "reverse", _tmp10_);
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_preferences_get_default ();
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = _tmp11_;
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = files_preferences_get_sort_directories_first (_tmp12_);
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp13_;
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = g_variant_new_boolean (_tmp14_);
#line 2475 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp15_);
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 2475 "../src/View/AbstractDirectoryView.vala"
		val = _tmp15_;
#line 2475 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp12_);
#line 2476 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = self->priv->background_actions;
#line 2476 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = val;
#line 2476 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp16_, "folders-first", _tmp17_);
#line 2470 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 13564 "AbstractDirectoryView.c"
	} else {
#line 2478 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:2478: Update menu actions sort: The model i" \
"s unsorted - this should not happen");
#line 13568 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_update_default_app (FilesAbstractDirectoryView* self,
                                                  GList* selection)
{
	GAppInfo* _tmp0_;
#line 2482 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2483 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_mime_actions_get_default_application_for_files (selection);
#line 2483 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 2483 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = _tmp0_;
#line 2484 "../src/View/AbstractDirectoryView.vala"
	return;
#line 13587 "AbstractDirectoryView.c"
}

/** Menu helpers */
static void
files_abstract_directory_view_action_set_enabled (FilesAbstractDirectoryView* self,
                                                  GSimpleActionGroup* action_group,
                                                  const gchar* name,
                                                  gboolean enabled)
{
#line 2489 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2489 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (name != NULL);
#line 2490 "../src/View/AbstractDirectoryView.vala"
	if (action_group != NULL) {
#line 13603 "AbstractDirectoryView.c"
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
#line 2491 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
#line 2491 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
#line 2491 "../src/View/AbstractDirectoryView.vala"
		action = _tmp1_;
#line 2492 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = action;
#line 2492 "../src/View/AbstractDirectoryView.vala"
		if (_tmp2_ != NULL) {
#line 13618 "AbstractDirectoryView.c"
			GSimpleAction* _tmp3_;
#line 2493 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = action;
#line 2493 "../src/View/AbstractDirectoryView.vala"
			g_simple_action_set_enabled (_tmp3_, enabled);
#line 2494 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (action);
#line 2494 "../src/View/AbstractDirectoryView.vala"
			return;
#line 13628 "AbstractDirectoryView.c"
		}
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (action);
#line 13632 "AbstractDirectoryView.c"
	}
#line 2497 "../src/View/AbstractDirectoryView.vala"
	g_critical ("AbstractDirectoryView.vala:2497: Action name not found: %s - cannot en" \
"able", name);
#line 13636 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_action_set_state (FilesAbstractDirectoryView* self,
                                                GSimpleActionGroup* action_group,
                                                const gchar* name,
                                                GVariant* val)
{
#line 2500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (name != NULL);
#line 2500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (val != NULL);
#line 2501 "../src/View/AbstractDirectoryView.vala"
	if (action_group != NULL) {
#line 13653 "AbstractDirectoryView.c"
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
#line 2502 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
#line 2502 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
#line 2502 "../src/View/AbstractDirectoryView.vala"
		action = _tmp1_;
#line 2503 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = action;
#line 2503 "../src/View/AbstractDirectoryView.vala"
		if (_tmp2_ != NULL) {
#line 13668 "AbstractDirectoryView.c"
			GSimpleAction* _tmp3_;
#line 2504 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = action;
#line 2504 "../src/View/AbstractDirectoryView.vala"
			g_simple_action_set_state (_tmp3_, val);
#line 2505 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (action);
#line 2505 "../src/View/AbstractDirectoryView.vala"
			return;
#line 13678 "AbstractDirectoryView.c"
		}
#line 2501 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (action);
#line 13682 "AbstractDirectoryView.c"
	}
#line 2508 "../src/View/AbstractDirectoryView.vala"
	g_critical ("AbstractDirectoryView.vala:2508: Action name not found: %s - cannot se" \
"t state", name);
#line 13686 "AbstractDirectoryView.c"
}

static gint
___lambda83_ (GFile* a,
              GFile* b)
{
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint _tmp9_;
	gint result;
#line 2542 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 2542 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_file_get_basename (a);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_file_get_basename (b);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _tmp7_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp8_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp6_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp4_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp2_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	result = _tmp9_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 13740 "AbstractDirectoryView.c"
}

static gint
____lambda83__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda83_ ((GFile*) a, (GFile*) b);
#line 2542 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 13751 "AbstractDirectoryView.c"
}

static void
___lambda84_ (GFile* folder)
{
#line 2555 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (folder != NULL);
#line 2556 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_load_templates_from_folder (folder);
#line 13761 "AbstractDirectoryView.c"
}

static void
____lambda84__gfunc (gconstpointer data,
                     gpointer self)
{
#line 2555 "../src/View/AbstractDirectoryView.vala"
	___lambda84_ ((GFile*) data);
#line 13770 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_load_templates_from_folder (GFile* template_folder)
{
	GList* file_list = NULL;
	GList* folder_list = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileQueryInfoFlags flags = 0U;
	GList* _tmp24_;
	GList* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 2511 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (template_folder != NULL);
#line 2512 "../src/View/AbstractDirectoryView.vala"
	file_list = NULL;
#line 2513 "../src/View/AbstractDirectoryView.vala"
	folder_list = NULL;
#line 2516 "../src/View/AbstractDirectoryView.vala"
	flags = G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS;
#line 13791 "AbstractDirectoryView.c"
	{
		GFileEnumerator* _tmp0_ = NULL;
		GFileEnumerator* _tmp1_;
		GFileEnumerator* _tmp2_;
		guint count = 0U;
		GList* _tmp3_;
		GFile* location = NULL;
		GFileInfo* info = NULL;
		GFileEnumerator* _tmp4_;
		GFileInfo* _tmp5_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_file_enumerate_children (template_folder, "standard::*", flags, NULL, &_inner_error0_);
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13808 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp0_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = NULL;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2518 "../src/View/AbstractDirectoryView.vala"
		enumerator = _tmp2_;
#line 2519 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_directory_view_templates;
#line 2519 "../src/View/AbstractDirectoryView.vala"
		count = g_list_length (_tmp3_);
#line 2521 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = enumerator;
#line 2521 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 2521 "../src/View/AbstractDirectoryView.vala"
		info = _tmp5_;
#line 2521 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2521 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (location);
#line 2521 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp0_);
#line 13835 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2523 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 13840 "AbstractDirectoryView.c"
			gboolean _tmp6_ = FALSE;
			gboolean _tmp8_ = FALSE;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp20_ = NULL;
			GFileEnumerator* _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
#line 2523 "../src/View/AbstractDirectoryView.vala"
			if (count < ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES)) {
#line 13850 "AbstractDirectoryView.c"
				GFileInfo* _tmp7_;
#line 2523 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = info;
#line 2523 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = _tmp7_ != NULL;
#line 13856 "AbstractDirectoryView.c"
			} else {
#line 2523 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = FALSE;
#line 13860 "AbstractDirectoryView.c"
			}
#line 2523 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp6_) {
#line 2523 "../src/View/AbstractDirectoryView.vala"
				break;
#line 13866 "AbstractDirectoryView.c"
			}
#line 2524 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = info;
#line 2524 "../src/View/AbstractDirectoryView.vala"
			if (!g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN)) {
#line 13872 "AbstractDirectoryView.c"
				GFileInfo* _tmp10_;
#line 2525 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = info;
#line 2525 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = !g_file_info_get_attribute_boolean (_tmp10_, G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP);
#line 13878 "AbstractDirectoryView.c"
			} else {
#line 2524 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = FALSE;
#line 13882 "AbstractDirectoryView.c"
			}
#line 2524 "../src/View/AbstractDirectoryView.vala"
			if (_tmp8_) {
#line 13886 "AbstractDirectoryView.c"
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
				GFileInfo* _tmp14_;
#line 2526 "../src/View/AbstractDirectoryView.vala"
				_tmp11_ = info;
#line 2526 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = g_file_info_get_name (_tmp11_);
#line 2526 "../src/View/AbstractDirectoryView.vala"
				_tmp13_ = g_file_get_child (template_folder, _tmp12_);
#line 2526 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (location);
#line 2526 "../src/View/AbstractDirectoryView.vala"
				location = _tmp13_;
#line 2527 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = info;
#line 2527 "../src/View/AbstractDirectoryView.vala"
				if (g_file_info_get_file_type (_tmp14_) == G_FILE_TYPE_DIRECTORY) {
#line 13905 "AbstractDirectoryView.c"
					GFile* _tmp15_;
					GFile* _tmp16_;
#line 2528 "../src/View/AbstractDirectoryView.vala"
					_tmp15_ = location;
#line 2528 "../src/View/AbstractDirectoryView.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 2528 "../src/View/AbstractDirectoryView.vala"
					folder_list = g_list_prepend (folder_list, _tmp16_);
#line 13914 "AbstractDirectoryView.c"
				} else {
					GFile* _tmp17_;
					GFile* _tmp18_;
					guint _tmp19_;
#line 2530 "../src/View/AbstractDirectoryView.vala"
					_tmp17_ = location;
#line 2530 "../src/View/AbstractDirectoryView.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 2530 "../src/View/AbstractDirectoryView.vala"
					file_list = g_list_prepend (file_list, _tmp18_);
#line 2531 "../src/View/AbstractDirectoryView.vala"
					_tmp19_ = count;
#line 2531 "../src/View/AbstractDirectoryView.vala"
					count = _tmp19_ + 1;
#line 13929 "AbstractDirectoryView.c"
				}
			}
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = enumerator;
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = g_file_enumerator_next_file (_tmp21_, NULL, &_inner_error0_);
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = _tmp22_;
#line 2535 "../src/View/AbstractDirectoryView.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2535 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (info);
#line 2535 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (location);
#line 2535 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp0_);
#line 13946 "AbstractDirectoryView.c"
				goto __catch0_g_error;
			}
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = _tmp20_;
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = NULL;
#line 2535 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (info);
#line 2535 "../src/View/AbstractDirectoryView.vala"
			info = _tmp23_;
#line 2523 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp20_);
#line 13959 "AbstractDirectoryView.c"
		}
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (info);
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp0_);
#line 13967 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 2517 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2538 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2538 "../src/View/AbstractDirectoryView.vala"
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2538 "../src/View/AbstractDirectoryView.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 2538 "../src/View/AbstractDirectoryView.vala"
		return;
#line 13982 "AbstractDirectoryView.c"
	}
	__finally0:
#line 2517 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2517 "../src/View/AbstractDirectoryView.vala"
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2517 "../src/View/AbstractDirectoryView.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 2517 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2517 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2517 "../src/View/AbstractDirectoryView.vala"
		return;
#line 13999 "AbstractDirectoryView.c"
	}
#line 2541 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = file_list;
#line 2541 "../src/View/AbstractDirectoryView.vala"
	if (g_list_length (_tmp24_) > ((guint) 0)) {
#line 14005 "AbstractDirectoryView.c"
		GList* _tmp25_;
		GFile* _tmp29_;
#line 2542 "../src/View/AbstractDirectoryView.vala"
		file_list = g_list_sort (file_list, ____lambda83__gcompare_func);
#line 2546 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = file_list;
#line 14012 "AbstractDirectoryView.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 2546 "../src/View/AbstractDirectoryView.vala"
			file_collection = _tmp25_;
#line 2546 "../src/View/AbstractDirectoryView.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 14020 "AbstractDirectoryView.c"
				GFile* _tmp26_;
				GFile* file = NULL;
#line 2546 "../src/View/AbstractDirectoryView.vala"
				_tmp26_ = _g_object_ref0 ((GFile*) file_it->data);
#line 2546 "../src/View/AbstractDirectoryView.vala"
				file = _tmp26_;
#line 14027 "AbstractDirectoryView.c"
				{
					GFile* _tmp27_;
					GFile* _tmp28_;
#line 2547 "../src/View/AbstractDirectoryView.vala"
					_tmp27_ = file;
#line 2547 "../src/View/AbstractDirectoryView.vala"
					_tmp28_ = _g_object_ref0 (_tmp27_);
#line 2547 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_templates = g_list_append (files_abstract_directory_view_templates, _tmp28_);
#line 2546 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (file);
#line 14039 "AbstractDirectoryView.c"
				}
			}
		}
#line 2550 "../src/View/AbstractDirectoryView.vala"
		_tmp29_ = _g_object_ref0 (template_folder);
#line 2550 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_templates = g_list_append (files_abstract_directory_view_templates, _tmp29_);
#line 14047 "AbstractDirectoryView.c"
	}
#line 2553 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = folder_list;
#line 2553 "../src/View/AbstractDirectoryView.vala"
	if (g_list_length (_tmp30_) > ((guint) 0)) {
#line 14053 "AbstractDirectoryView.c"
		GList* _tmp31_;
#line 2555 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = folder_list;
#line 2555 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (_tmp31_, ____lambda84__gfunc, NULL);
#line 14059 "AbstractDirectoryView.c"
	}
#line 2511 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (enumerator);
#line 2511 "../src/View/AbstractDirectoryView.vala"
	(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2511 "../src/View/AbstractDirectoryView.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 14067 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_filter_this_app_from_open_with_apps (FilesAbstractDirectoryView* self)
{
	GList* l = NULL;
	GList* _tmp0_;
#line 2561 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2562 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 2562 "../src/View/AbstractDirectoryView.vala"
	l = _tmp0_;
#line 2564 "../src/View/AbstractDirectoryView.vala"
	while (TRUE) {
#line 14083 "AbstractDirectoryView.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		GList* _tmp10_;
		GList* _tmp11_;
#line 2564 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = l;
#line 2564 "../src/View/AbstractDirectoryView.vala"
		if (!(_tmp1_ != NULL)) {
#line 2564 "../src/View/AbstractDirectoryView.vala"
			break;
#line 14095 "AbstractDirectoryView.c"
		}
#line 2565 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = l;
#line 2565 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_->data;
#line 2565 "../src/View/AbstractDirectoryView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp3_, g_app_info_get_type ())) {
#line 14103 "AbstractDirectoryView.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
#line 2566 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = l;
#line 2566 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = _tmp4_->data;
#line 2566 "../src/View/AbstractDirectoryView.vala"
			if (files_abstract_directory_view_app_is_this_app (self, (GAppInfo*) _tmp5_)) {
#line 14112 "AbstractDirectoryView.c"
				GList* _tmp6_;
#line 2567 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = l;
#line 2567 "../src/View/AbstractDirectoryView.vala"
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp6_);
#line 2568 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14120 "AbstractDirectoryView.c"
			}
		} else {
			GList* _tmp7_;
			GList* _tmp8_;
			GList* _tmp9_;
#line 2571 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = l;
#line 2571 "../src/View/AbstractDirectoryView.vala"
			self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp7_);
#line 2572 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->priv->open_with_apps;
#line 2572 "../src/View/AbstractDirectoryView.vala"
			l = _tmp8_;
#line 2573 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = l;
#line 2573 "../src/View/AbstractDirectoryView.vala"
			if (_tmp9_ == NULL) {
#line 2574 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14140 "AbstractDirectoryView.c"
			}
		}
#line 2578 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = l;
#line 2578 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->next;
#line 2578 "../src/View/AbstractDirectoryView.vala"
		l = _tmp11_;
#line 14149 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_app_is_this_app (FilesAbstractDirectoryView* self,
                                               GAppInfo* ai)
{
	gchar* exec_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 2582 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2582 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (ai != NULL, FALSE);
#line 2583 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_app_info_get_executable (ai);
#line 2583 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 2583 "../src/View/AbstractDirectoryView.vala"
	exec_name = _tmp1_;
#line 2585 "../src/View/AbstractDirectoryView.vala"
	result = g_strcmp0 (exec_name, APP_NAME) == 0;
#line 2585 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (exec_name);
#line 2585 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14177 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_filter_default_app_from_open_with_apps (FilesAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	gchar* id1 = NULL;
	gchar* id2 = NULL;
	GAppInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
#line 2588 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2589 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 2589 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 2590 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14198 "AbstractDirectoryView.c"
	}
#line 2594 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->default_app;
#line 2594 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_app_info_get_id (_tmp1_);
#line 2594 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 2594 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id2);
#line 2594 "../src/View/AbstractDirectoryView.vala"
	id2 = _tmp3_;
#line 2596 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = id2;
#line 2596 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ != NULL) {
#line 14214 "AbstractDirectoryView.c"
		GList* l = NULL;
		GList* _tmp5_;
#line 2597 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->open_with_apps;
#line 2597 "../src/View/AbstractDirectoryView.vala"
		l = _tmp5_;
#line 2599 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14223 "AbstractDirectoryView.c"
			gboolean _tmp6_ = FALSE;
			GList* _tmp7_;
			GList* _tmp10_;
			gconstpointer _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			const gchar* _tmp15_;
			GList* _tmp19_;
			GList* _tmp20_;
#line 2599 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = l;
#line 2599 "../src/View/AbstractDirectoryView.vala"
			if (_tmp7_ != NULL) {
#line 14238 "AbstractDirectoryView.c"
				GList* _tmp8_;
				gconstpointer _tmp9_;
#line 2599 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = l;
#line 2599 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = _tmp8_->data;
#line 2599 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp9_, g_app_info_get_type ());
#line 14247 "AbstractDirectoryView.c"
			} else {
#line 2599 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = FALSE;
#line 14251 "AbstractDirectoryView.c"
			}
#line 2599 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp6_) {
#line 2599 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14257 "AbstractDirectoryView.c"
			}
#line 2600 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = l;
#line 2600 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp10_->data;
#line 2600 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = g_app_info_get_id ((GAppInfo*) _tmp11_);
#line 2600 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 2600 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (id1);
#line 2600 "../src/View/AbstractDirectoryView.vala"
			id1 = _tmp13_;
#line 2602 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = id1;
#line 2602 "../src/View/AbstractDirectoryView.vala"
			if (_tmp15_ != NULL) {
#line 14275 "AbstractDirectoryView.c"
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 2602 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = id1;
#line 2602 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = id2;
#line 2602 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = g_strcmp0 (_tmp16_, _tmp17_) == 0;
#line 14284 "AbstractDirectoryView.c"
			} else {
#line 2602 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = FALSE;
#line 14288 "AbstractDirectoryView.c"
			}
#line 2602 "../src/View/AbstractDirectoryView.vala"
			if (_tmp14_) {
#line 14292 "AbstractDirectoryView.c"
				GList* _tmp18_;
#line 2603 "../src/View/AbstractDirectoryView.vala"
				_tmp18_ = l;
#line 2603 "../src/View/AbstractDirectoryView.vala"
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp18_);
#line 2604 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14300 "AbstractDirectoryView.c"
			}
#line 2607 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = l;
#line 2607 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = _tmp19_->next;
#line 2607 "../src/View/AbstractDirectoryView.vala"
			l = _tmp20_;
#line 14308 "AbstractDirectoryView.c"
		}
	}
#line 2588 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id2);
#line 2588 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id1);
#line 14315 "AbstractDirectoryView.c"
}

/** Menu action functions */
static void
__lambda117_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 2624 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 14327 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 2626 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_file_from_template_finish (res, &_inner_error0_);
#line 2626 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 2626 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14337 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2627 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 2625 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 14344 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 2625 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 2625 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 2629 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 2629 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 2629 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:2629: %s", _tmp2_);
#line 2625 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 14364 "AbstractDirectoryView.c"
	}
	__finally0:
#line 2625 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2625 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2625 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2625 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14375 "AbstractDirectoryView.c"
	}
}

static void
___lambda117__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 2618 "../src/View/AbstractDirectoryView.vala"
	__lambda117_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 2618 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 14388 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_create_from_template (FilesAbstractDirectoryView* self,
                                                    GFile* template)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gchar* new_name = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	FilesViewSlot* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
#line 2614 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2614 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (template != NULL);
#line 2616 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 2616 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 2616 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2616 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp2_);
#line 2617 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_file_get_basename (template);
#line 2617 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 2617 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_strdup_printf (_ ("Untitled %s"), _tmp4_);
#line 2617 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 2617 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp4_);
#line 2617 "../src/View/AbstractDirectoryView.vala"
	new_name = _tmp6_;
#line 2618 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 2618 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp7_);
#line 2618 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 2618 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_file_from_template ((GtkWidget*) self, _tmp9_, new_name, template, NULL, ___lambda117__gasync_ready_callback, g_object_ref (self));
#line 2614 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (new_name);
#line 14440 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_open_files_with (FilesAbstractDirectoryView* self,
                                               GAppInfo* app,
                                               GList* files)
{
#line 2634 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2634 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (app != NULL);
#line 2635 "../src/View/AbstractDirectoryView.vala"
	files_mime_actions_open_multiple_gof_files_request (files, (GtkWidget*) self, app);
#line 14454 "AbstractDirectoryView.c"
}

/** Thumbnail and color tag handling */
static gboolean
__lambda54_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 2664 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->thumbnail_source_id > ((guint) 0)) {
#line 2665 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 2665 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 14468 "AbstractDirectoryView.c"
	}
#line 2668 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_thaw_child_notify (self);
#line 2669 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = (guint) 0;
#line 2670 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2670 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14478 "AbstractDirectoryView.c"
}

static gboolean
___lambda54__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda54_ ((FilesAbstractDirectoryView*) self);
#line 2663 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14488 "AbstractDirectoryView.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 2687 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 14496 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 2687 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 14504 "AbstractDirectoryView.c"
}

static gboolean
__lambda55_ (FilesAbstractDirectoryView* self)
{
	GtkTreePath* start_path = NULL;
	GtkTreePath* end_path = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* sp = NULL;
	GtkTreePath* ep = NULL;
	GtkTreeIter iter = {0};
	gboolean valid_iter = FALSE;
	FilesFile* file = NULL;
	GList* visible_files = NULL;
	guint actually_visible = 0U;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp38_ = FALSE;
	gboolean result;
#line 2684 "../src/View/AbstractDirectoryView.vala"
	visible_files = NULL;
#line 2685 "../src/View/AbstractDirectoryView.vala"
	actually_visible = (guint) 0;
#line 2686 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
#line 2686 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start_path);
#line 2686 "../src/View/AbstractDirectoryView.vala"
	start_path = _tmp0_;
#line 2686 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end_path);
#line 2686 "../src/View/AbstractDirectoryView.vala"
	end_path = _tmp1_;
#line 2686 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 14541 "AbstractDirectoryView.c"
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreePath* _tmp6_;
		gint count = 0;
		FilesListModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GtkTreeIter _tmp14_ = {0};
		gboolean _tmp15_;
#line 2687 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = start_path;
#line 2687 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = __vala_GtkTreePath_copy0 (_tmp3_);
#line 2687 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (sp);
#line 2687 "../src/View/AbstractDirectoryView.vala"
		sp = _tmp4_;
#line 2688 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = end_path;
#line 2688 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = __vala_GtkTreePath_copy0 (_tmp5_);
#line 2688 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (ep);
#line 2688 "../src/View/AbstractDirectoryView.vala"
		ep = _tmp6_;
#line 2693 "../src/View/AbstractDirectoryView.vala"
		count = 50;
#line 2694 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14571 "AbstractDirectoryView.c"
			gboolean _tmp7_ = FALSE;
			GtkTreePath* _tmp8_;
			gint _tmp9_;
#line 2694 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = start_path;
#line 2694 "../src/View/AbstractDirectoryView.vala"
			if (gtk_tree_path_prev (_tmp8_)) {
#line 2694 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = count > 0;
#line 14581 "AbstractDirectoryView.c"
			} else {
#line 2694 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = FALSE;
#line 14585 "AbstractDirectoryView.c"
			}
#line 2694 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp7_) {
#line 2694 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14591 "AbstractDirectoryView.c"
			}
#line 2695 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = count;
#line 2695 "../src/View/AbstractDirectoryView.vala"
			count = _tmp9_ - 1;
#line 14597 "AbstractDirectoryView.c"
		}
#line 2698 "../src/View/AbstractDirectoryView.vala"
		count = 50;
#line 2699 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14603 "AbstractDirectoryView.c"
			GtkTreePath* _tmp10_;
			gint _tmp11_;
#line 2699 "../src/View/AbstractDirectoryView.vala"
			if (!(count > 0)) {
#line 2699 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14610 "AbstractDirectoryView.c"
			}
#line 2700 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = end_path;
#line 2700 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_path_next (_tmp10_);
#line 2701 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = count;
#line 2701 "../src/View/AbstractDirectoryView.vala"
			count = _tmp11_ - 1;
#line 14620 "AbstractDirectoryView.c"
		}
#line 2705 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->model;
#line 2705 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = start_path;
#line 2705 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp12_, &_tmp14_, _tmp13_);
#line 2705 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp14_;
#line 2705 "../src/View/AbstractDirectoryView.vala"
		valid_iter = _tmp15_;
#line 2706 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14634 "AbstractDirectoryView.c"
			gboolean _tmp16_ = FALSE;
			FilesListModel* _tmp17_;
			GtkTreeIter _tmp18_;
			FilesFile* _tmp19_;
			FilesListModel* _tmp20_;
			GtkTreeIter _tmp21_;
			GtkTreePath* _tmp22_;
			FilesFile* _tmp23_;
			GtkTreePath* _tmp35_;
			GtkTreePath* _tmp36_;
#line 2706 "../src/View/AbstractDirectoryView.vala"
			if (valid_iter) {
#line 2706 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->thumbnail_source_id > ((guint) 0);
#line 14649 "AbstractDirectoryView.c"
			} else {
#line 2706 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = FALSE;
#line 14653 "AbstractDirectoryView.c"
			}
#line 2706 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp16_) {
#line 2706 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14659 "AbstractDirectoryView.c"
			}
#line 2707 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->model;
#line 2707 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = iter;
#line 2707 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = files_list_model_file_for_iter (_tmp17_, &_tmp18_);
#line 2707 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 2707 "../src/View/AbstractDirectoryView.vala"
			file = _tmp19_;
#line 2708 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = self->model;
#line 2708 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = iter;
#line 2708 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp20_, &_tmp21_);
#line 2708 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (path);
#line 2708 "../src/View/AbstractDirectoryView.vala"
			path = _tmp22_;
#line 2709 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = file;
#line 2709 "../src/View/AbstractDirectoryView.vala"
			if (_tmp23_ != NULL) {
#line 14685 "AbstractDirectoryView.c"
				FilesFile* _tmp24_;
#line 2710 "../src/View/AbstractDirectoryView.vala"
				_tmp24_ = file;
#line 2710 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_update_icon_and_plugins (self, _tmp24_);
#line 2712 "../src/View/AbstractDirectoryView.vala"
				if (self->should_thumbnail) {
#line 14693 "AbstractDirectoryView.c"
					FilesFile* _tmp25_;
#line 2713 "../src/View/AbstractDirectoryView.vala"
					_tmp25_ = file;
#line 2713 "../src/View/AbstractDirectoryView.vala"
					if (_tmp25_->thumbstate == ((guint) FILES_FILE_THUMB_STATE_UNKNOWN)) {
#line 14699 "AbstractDirectoryView.c"
						FilesFile* _tmp26_;
						FilesFile* _tmp27_;
						gboolean _tmp28_ = FALSE;
						GtkTreePath* _tmp29_;
						GtkTreePath* _tmp30_;
#line 2714 "../src/View/AbstractDirectoryView.vala"
						_tmp26_ = file;
#line 2714 "../src/View/AbstractDirectoryView.vala"
						_tmp27_ = _g_object_ref0 (_tmp26_);
#line 2714 "../src/View/AbstractDirectoryView.vala"
						visible_files = g_list_prepend (visible_files, _tmp27_);
#line 2715 "../src/View/AbstractDirectoryView.vala"
						_tmp29_ = path;
#line 2715 "../src/View/AbstractDirectoryView.vala"
						_tmp30_ = sp;
#line 2715 "../src/View/AbstractDirectoryView.vala"
						if (gtk_tree_path_compare (_tmp29_, _tmp30_) >= 0) {
#line 14717 "AbstractDirectoryView.c"
							GtkTreePath* _tmp31_;
							GtkTreePath* _tmp32_;
#line 2715 "../src/View/AbstractDirectoryView.vala"
							_tmp31_ = path;
#line 2715 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = ep;
#line 2715 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = gtk_tree_path_compare (_tmp31_, _tmp32_) <= 0;
#line 14726 "AbstractDirectoryView.c"
						} else {
#line 2715 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = FALSE;
#line 14730 "AbstractDirectoryView.c"
						}
#line 2715 "../src/View/AbstractDirectoryView.vala"
						if (_tmp28_) {
#line 14734 "AbstractDirectoryView.c"
							guint _tmp33_;
#line 2716 "../src/View/AbstractDirectoryView.vala"
							_tmp33_ = actually_visible;
#line 2716 "../src/View/AbstractDirectoryView.vala"
							actually_visible = _tmp33_ + 1;
#line 14740 "AbstractDirectoryView.c"
						}
					}
				} else {
					FilesFile* _tmp34_;
#line 2720 "../src/View/AbstractDirectoryView.vala"
					_tmp34_ = file;
#line 2720 "../src/View/AbstractDirectoryView.vala"
					_tmp34_->thumbstate = (guint) FILES_FILE_THUMB_STATE_NONE;
#line 14749 "AbstractDirectoryView.c"
				}
			}
#line 2724 "../src/View/AbstractDirectoryView.vala"
			_tmp35_ = path;
#line 2724 "../src/View/AbstractDirectoryView.vala"
			_tmp36_ = end_path;
#line 2724 "../src/View/AbstractDirectoryView.vala"
			if (gtk_tree_path_compare (_tmp35_, _tmp36_) != 0) {
#line 14758 "AbstractDirectoryView.c"
				gboolean _tmp37_;
#line 2725 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = files_abstract_directory_view_get_next_visible_iter (self, &iter, TRUE);
#line 2725 "../src/View/AbstractDirectoryView.vala"
				valid_iter = _tmp37_;
#line 14764 "AbstractDirectoryView.c"
			} else {
#line 2727 "../src/View/AbstractDirectoryView.vala"
				valid_iter = FALSE;
#line 14768 "AbstractDirectoryView.c"
			}
		}
	}
#line 2738 "../src/View/AbstractDirectoryView.vala"
	if (actually_visible > ((guint) 0)) {
#line 2738 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = self->priv->thumbnail_source_id > ((guint) 0);
#line 14776 "AbstractDirectoryView.c"
	} else {
#line 2738 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = FALSE;
#line 14780 "AbstractDirectoryView.c"
	}
#line 2738 "../src/View/AbstractDirectoryView.vala"
	if (_tmp38_) {
#line 14784 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp39_;
		GList* _tmp40_;
		gint _tmp41_ = 0;
#line 2739 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = self->priv->thumbnailer;
#line 2739 "../src/View/AbstractDirectoryView.vala"
		_tmp40_ = visible_files;
#line 2739 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_queue_files (_tmp39_, _tmp40_, &_tmp41_);
#line 2739 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = _tmp41_;
#line 14796 "AbstractDirectoryView.c"
	}
#line 2743 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_draw_when_idle (self);
#line 2745 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = (guint) 0;
#line 2747 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2747 "../src/View/AbstractDirectoryView.vala"
	(visible_files == NULL) ? NULL : (visible_files = (_g_list_free__g_object_unref0_ (visible_files), NULL));
#line 2747 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (ep);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (sp);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end_path);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start_path);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14820 "AbstractDirectoryView.c"
}

static gboolean
___lambda55__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda55_ ((FilesAbstractDirectoryView*) self);
#line 2676 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14830 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	FilesViewSlot* _tmp1_;
	gboolean _tmp5_ = FALSE;
	FilesViewSlot* _tmp6_;
	FilesDirectory* _tmp7_;
	FilesDirectory* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	guint delay = 0U;
	FilesViewSlot* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	guint _tmp17_;
#line 2640 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2646 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->slot;
#line 2646 "../src/View/AbstractDirectoryView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, FILES_TYPE_ABSTRACT_SLOT)) {
#line 14855 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp2_;
		FilesDirectory* _tmp3_;
		FilesDirectory* _tmp4_;
#line 2646 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->slot;
#line 2646 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp2_);
#line 2646 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 2646 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 14867 "AbstractDirectoryView.c"
	} else {
#line 2646 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 14871 "AbstractDirectoryView.c"
	}
#line 2646 "../src/View/AbstractDirectoryView.vala"
	_vala_assert (_tmp0_, "slot is Files.AbstractSlot && slot.directory != null");
#line 2649 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->slot;
#line 2649 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp6_);
#line 2649 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _tmp7_;
#line 2649 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_directory_get_can_open_files (_tmp8_);
#line 2649 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _tmp9_;
#line 2649 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp10_) {
#line 2649 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = TRUE;
#line 14889 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp11_;
		FilesDirectory* _tmp12_;
		FilesDirectory* _tmp13_;
#line 2650 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = self->slot;
#line 2650 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp11_);
#line 2650 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_;
#line 2650 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_directory_is_loading (_tmp13_);
#line 14902 "AbstractDirectoryView.c"
	}
#line 2649 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_) {
#line 2652 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14908 "AbstractDirectoryView.c"
	}
#line 2657 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
#line 2661 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->freeze_source_id);
#line 2662 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_child_notify (self);
#line 2663 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda54__gsource_func, g_object_ref (self), g_object_unref);
#line 2675 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = self->slot;
#line 2675 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = files_view_slot_get_displayed_files_count (_tmp14_);
#line 2675 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = _tmp15_;
#line 2675 "../src/View/AbstractDirectoryView.vala"
	delay = MIN ((guint) (50 + (_tmp16_ / 10)), (guint) 500);
#line 2676 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = delay;
#line 2676 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp17_, ___lambda55__gsource_func, g_object_ref (self), g_object_unref);
#line 14930 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_icon_and_plugins (FilesAbstractDirectoryView* self,
                                                       FilesFile* file)
{
#line 2753 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2753 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 2753 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (file != NULL, "file != null");
#line 2754 "../src/View/AbstractDirectoryView.vala"
	if (!file->is_gone) {
#line 14945 "AbstractDirectoryView.c"
		FilesPluginManager* _tmp0_;
#line 2756 "../src/View/AbstractDirectoryView.vala"
		if (self->should_thumbnail) {
#line 2757 "../src/View/AbstractDirectoryView.vala"
			files_file_update_icon (file, -1, -1);
#line 14951 "AbstractDirectoryView.c"
		}
#line 2761 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = plugins;
#line 2761 "../src/View/AbstractDirectoryView.vala"
		if (_tmp0_ != NULL) {
#line 14957 "AbstractDirectoryView.c"
			FilesPluginManager* _tmp1_;
#line 2762 "../src/View/AbstractDirectoryView.vala"
			_tmp1_ = plugins;
#line 2762 "../src/View/AbstractDirectoryView.vala"
			files_plugin_manager_update_file_info (_tmp1_, file);
#line 14963 "AbstractDirectoryView.c"
		}
	}
}

static gboolean
__lambda56_ (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	gboolean result;
#line 2775 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = (guint) 0;
#line 2776 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->view;
#line 2776 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_queue_draw (_tmp0_);
#line 2777 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2777 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14983 "AbstractDirectoryView.c"
}

static gboolean
___lambda56__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda56_ ((FilesAbstractDirectoryView*) self);
#line 2774 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14993 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_draw_when_idle (FilesAbstractDirectoryView* self)
{
#line 2769 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2770 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->draw_timeout_id > ((guint) 0)) {
#line 2771 "../src/View/AbstractDirectoryView.vala"
		return;
#line 15005 "AbstractDirectoryView.c"
	}
#line 2774 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda56__gsource_func, g_object_ref (self), g_object_unref);
#line 15009 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_block_model (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
	guint _tmp1_;
#line 2781 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2782 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2782 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("row-deleted", gtk_tree_model_get_type (), &_tmp1_, NULL, FALSE);
#line 2782 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched ((GtkTreeModel*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self);
#line 15025 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unblock_model (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
#line 2785 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2786 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2786 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeModel*) _tmp0_, "row-deleted", (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
#line 15038 "AbstractDirectoryView.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 2789 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	return _data31_;
#line 15048 "AbstractDirectoryView.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 2789 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 15058 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 2789 "../src/View/AbstractDirectoryView.vala"
		self = _data31_->self;
#line 2789 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data31_->pointer);
#line 2789 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 2789 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block31Data, _data31_);
#line 15068 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda128_ (Block31Data* _data31_)
{
	FilesAbstractDirectoryView* self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gboolean result;
#line 2792 "../src/View/AbstractDirectoryView.vala"
	self = _data31_->self;
#line 2793 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 2793 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2793 "../src/View/AbstractDirectoryView.vala"
	widget = _tmp1_;
#line 2794 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = widget;
#line 2794 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 15093 "AbstractDirectoryView.c"
		GdkWindow* window = NULL;
		GtkWidget* _tmp3_;
		GdkWindow* _tmp4_;
		GdkWindow* _tmp5_;
		gint x = 0;
		gint y = 0;
		gint w = 0;
		gint h = 0;
		GdkWindow* _tmp6_;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		GdkWindow* _tmp9_;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		GtkAdjustment* _tmp12_;
		GtkAdjustment* _tmp13_;
#line 2795 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = widget;
#line 2795 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = gtk_widget_get_window (_tmp3_);
#line 2795 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 2795 "../src/View/AbstractDirectoryView.vala"
		window = _tmp5_;
#line 2798 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = window;
#line 2798 "../src/View/AbstractDirectoryView.vala"
		gdk_window_get_device_position (_tmp6_, _data31_->pointer, &_tmp7_, &_tmp8_, NULL);
#line 2798 "../src/View/AbstractDirectoryView.vala"
		x = _tmp7_;
#line 2798 "../src/View/AbstractDirectoryView.vala"
		y = _tmp8_;
#line 2799 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = window;
#line 2799 "../src/View/AbstractDirectoryView.vala"
		gdk_window_get_geometry (_tmp9_, NULL, NULL, &_tmp10_, &_tmp11_);
#line 2799 "../src/View/AbstractDirectoryView.vala"
		w = _tmp10_;
#line 2799 "../src/View/AbstractDirectoryView.vala"
		h = _tmp11_;
#line 2801 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 2801 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_scroll_if_near_edge (self, y, h, 20, _tmp12_);
#line 2802 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = gtk_scrolled_window_get_hadjustment ((GtkScrolledWindow*) self);
#line 2802 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_scroll_if_near_edge (self, x, w, 20, _tmp13_);
#line 2803 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 2803 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (window);
#line 2803 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 2803 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15150 "AbstractDirectoryView.c"
	} else {
#line 2805 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 2805 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 2805 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15158 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda128__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda128_ (self);
#line 2790 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15169 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_start_drag_scroll_timer (FilesAbstractDirectoryView* self,
                                                       GdkDevice* pointer)
{
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
	Block31Data* _data31_;
	GdkDevice* _tmp2_;
#line 2789 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pointer != NULL);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_window (self);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_vala_return_if_fail (_tmp1_ != NULL, "window != null");
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_data31_->_ref_count_ = 1;
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_data31_->self = g_object_ref (self);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _g_object_ref0 (pointer);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data31_->pointer);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_data31_->pointer = _tmp2_;
#line 2790 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_scroll_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 50, ___lambda128__gsource_func, block31_data_ref (_data31_), block31_data_unref);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	block31_data_unref (_data31_);
#line 2789 "../src/View/AbstractDirectoryView.vala"
	_data31_ = NULL;
#line 15208 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_scroll_if_near_edge (FilesAbstractDirectoryView* self,
                                                   gint pos,
                                                   gint dim,
                                                   gint threshold,
                                                   GtkAdjustment* adj)
{
	gint band = 0;
	gint offset = 0;
#line 2810 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2810 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (adj != NULL);
#line 2812 "../src/View/AbstractDirectoryView.vala"
	band = 2 * threshold;
#line 2813 "../src/View/AbstractDirectoryView.vala"
	offset = pos - band;
#line 2814 "../src/View/AbstractDirectoryView.vala"
	if (offset > 0) {
#line 2815 "../src/View/AbstractDirectoryView.vala"
		offset = MAX (band - (dim - pos), 0);
#line 15232 "AbstractDirectoryView.c"
	}
#line 2818 "../src/View/AbstractDirectoryView.vala"
	if (offset != 0) {
#line 15236 "AbstractDirectoryView.c"
		gdouble val = 0.0;
		gdouble lower = 0.0;
		gdouble upper = 0.0;
		gdouble page = 0.0;
#line 2820 "../src/View/AbstractDirectoryView.vala"
		val = gtk_adjustment_get_value (adj);
#line 2821 "../src/View/AbstractDirectoryView.vala"
		lower = gtk_adjustment_get_lower (adj);
#line 2822 "../src/View/AbstractDirectoryView.vala"
		upper = gtk_adjustment_get_upper (adj);
#line 2823 "../src/View/AbstractDirectoryView.vala"
		page = gtk_adjustment_get_page_size (adj);
#line 2825 "../src/View/AbstractDirectoryView.vala"
		val = CLAMP (val + (2 * offset), lower, upper - page);
#line 2826 "../src/View/AbstractDirectoryView.vala"
		gtk_adjustment_set_value (adj, val);
#line 15253 "AbstractDirectoryView.c"
	}
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 2835 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 2835 "../src/View/AbstractDirectoryView.vala"
	return _data32_;
#line 15264 "AbstractDirectoryView.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 2835 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 15274 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		self = _data32_->self;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		(_data32_->action_files == NULL) ? NULL : (_data32_->action_files = (_g_list_free__g_object_unref0_ (_data32_->action_files), NULL));
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 2835 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block32Data, _data32_);
#line 15284 "AbstractDirectoryView.c"
	}
}

static void
____lambda44_ (Block32Data* _data32_,
               FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	FilesFile* goffile = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	FilesFile* _tmp4_;
#line 2842 "../src/View/AbstractDirectoryView.vala"
	self = _data32_->self;
#line 2842 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 2843 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_display_target_uri (file);
#line 2843 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 2843 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_by_uri (_tmp1_);
#line 2843 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 2843 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp1_);
#line 2843 "../src/View/AbstractDirectoryView.vala"
	goffile = _tmp3_;
#line 2844 "../src/View/AbstractDirectoryView.vala"
	files_file_query_update (goffile);
#line 2845 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _g_object_ref0 (goffile);
#line 2845 "../src/View/AbstractDirectoryView.vala"
	_data32_->action_files = g_list_append (_data32_->action_files, _tmp4_);
#line 2842 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (goffile);
#line 15323 "AbstractDirectoryView.c"
}

static void
_____lambda44__gfunc (gconstpointer data,
                      gpointer self)
{
#line 2842 "../src/View/AbstractDirectoryView.vala"
	____lambda44_ (self, (FilesFile*) data);
#line 15332 "AbstractDirectoryView.c"
}

static GList*
files_abstract_directory_view_get_files_for_action (FilesAbstractDirectoryView* self)
{
	Block32Data* _data32_;
	GList* _tmp0_;
	GList* _tmp11_;
	GList* result;
#line 2835 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2835 "../src/View/AbstractDirectoryView.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 2835 "../src/View/AbstractDirectoryView.vala"
	_data32_->_ref_count_ = 1;
#line 2835 "../src/View/AbstractDirectoryView.vala"
	_data32_->self = g_object_ref (self);
#line 2836 "../src/View/AbstractDirectoryView.vala"
	_data32_->action_files = NULL;
#line 2837 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 2839 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 2839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 15358 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp1_;
		FilesDirectory* _tmp2_;
		FilesDirectory* _tmp3_;
		FilesFile* _tmp4_;
		FilesFile* _tmp5_;
		FilesFile* _tmp6_;
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->slot;
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp1_);
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_directory_get_file (_tmp3_);
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_;
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 2840 "../src/View/AbstractDirectoryView.vala"
		_data32_->action_files = g_list_prepend (_data32_->action_files, _tmp6_);
#line 15379 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp7_;
#line 2841 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->priv->_in_recent;
#line 2841 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_) {
#line 15386 "AbstractDirectoryView.c"
			GList* _tmp8_;
#line 2842 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->selected_files;
#line 2842 "../src/View/AbstractDirectoryView.vala"
			g_list_foreach (_tmp8_, _____lambda44__gfunc, _data32_);
#line 15392 "AbstractDirectoryView.c"
		} else {
			GList* _tmp9_;
			GList* _tmp10_;
#line 2848 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->selected_files;
#line 2848 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = g_list_copy_deep (_tmp9_, (GCopyFunc) g_object_ref, NULL);
#line 2848 "../src/View/AbstractDirectoryView.vala"
			(_data32_->action_files == NULL) ? NULL : (_data32_->action_files = (_g_list_free__g_object_unref0_ (_data32_->action_files), NULL));
#line 2848 "../src/View/AbstractDirectoryView.vala"
			_data32_->action_files = _tmp10_;
#line 15404 "AbstractDirectoryView.c"
		}
	}
#line 2851 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = _data32_->action_files;
#line 2851 "../src/View/AbstractDirectoryView.vala"
	_data32_->action_files = NULL;
#line 2851 "../src/View/AbstractDirectoryView.vala"
	result = _tmp11_;
#line 2851 "../src/View/AbstractDirectoryView.vala"
	block32_data_unref (_data32_);
#line 2851 "../src/View/AbstractDirectoryView.vala"
	_data32_ = NULL;
#line 2851 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15419 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_items_activated (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
#line 2854 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2855 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 2855 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp0_);
#line 15432 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_selection_changed (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
#line 2858 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2859 "../src/View/AbstractDirectoryView.vala"
	self->priv->selected_files_invalid = TRUE;
#line 2860 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 2860 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ == NULL) {
#line 2860 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 15450 "AbstractDirectoryView.c"
	} else {
		GList* _tmp2_;
		GList* _tmp3_;
#line 2860 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->selected_files;
#line 2860 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_->next;
#line 2860 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 15460 "AbstractDirectoryView.c"
	}
#line 2860 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = _tmp0_;
#line 15464 "AbstractDirectoryView.c"
}

/** Keyboard event handling **/
static gboolean
__lambda113_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 3126 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3127 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3127 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15478 "AbstractDirectoryView.c"
}

static gboolean
___lambda113__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda113_ ((FilesAbstractDirectoryView*) self);
#line 3125 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15488 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                            guint original_keyval,
                                                            guint keycode,
                                                            GdkModifierType state)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkEvent* event = NULL;
	GdkEvent* _tmp2_;
	GdkModifierType consumed_mods = 0U;
	guint keyval = 0U;
	GdkModifierType _tmp3_ = 0U;
	guint _tmp4_;
	GdkModifierType mods = 0U;
	gboolean no_mods = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean control_pressed = FALSE;
	gboolean alt_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean only_alt_pressed = FALSE;
	gboolean in_trash = FALSE;
	FilesViewSlot* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gboolean in_recent = FALSE;
	FilesViewSlot* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gboolean res = FALSE;
	gboolean result;
#line 2865 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 2865 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 2865 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 2866 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 2866 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15537 "AbstractDirectoryView.c"
	}
#line 2869 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = gtk_get_current_event ();
#line 2869 "../src/View/AbstractDirectoryView.vala"
	event = _tmp2_;
#line 2870 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 2873 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_abstract_directory_view_map_key (original_keyval, keycode, &_tmp3_);
#line 2873 "../src/View/AbstractDirectoryView.vala"
	consumed_mods = _tmp3_;
#line 2873 "../src/View/AbstractDirectoryView.vala"
	keyval = _tmp4_;
#line 2875 "../src/View/AbstractDirectoryView.vala"
	mods = (state & (~consumed_mods)) & gtk_accelerator_get_default_mod_mask ();
#line 2876 "../src/View/AbstractDirectoryView.vala"
	no_mods = mods == 0;
#line 2877 "../src/View/AbstractDirectoryView.vala"
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
#line 2878 "../src/View/AbstractDirectoryView.vala"
	if (shift_pressed) {
#line 2878 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = (mods & (~GDK_SHIFT_MASK)) == 0;
#line 15561 "AbstractDirectoryView.c"
	} else {
#line 2878 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = FALSE;
#line 15565 "AbstractDirectoryView.c"
	}
#line 2878 "../src/View/AbstractDirectoryView.vala"
	only_shift_pressed = _tmp5_;
#line 2879 "../src/View/AbstractDirectoryView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 2880 "../src/View/AbstractDirectoryView.vala"
	alt_pressed = (mods & GDK_MOD1_MASK) != 0;
#line 2881 "../src/View/AbstractDirectoryView.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 2882 "../src/View/AbstractDirectoryView.vala"
	if (control_pressed) {
#line 2882 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = !other_mod_pressed;
#line 15579 "AbstractDirectoryView.c"
	} else {
#line 2882 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = FALSE;
#line 15583 "AbstractDirectoryView.c"
	}
#line 2882 "../src/View/AbstractDirectoryView.vala"
	only_control_pressed = _tmp6_;
#line 2883 "../src/View/AbstractDirectoryView.vala"
	if (alt_pressed) {
#line 2883 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = (mods & (~GDK_MOD1_MASK)) == 0;
#line 15591 "AbstractDirectoryView.c"
	} else {
#line 2883 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = FALSE;
#line 15595 "AbstractDirectoryView.c"
	}
#line 2883 "../src/View/AbstractDirectoryView.vala"
	only_alt_pressed = _tmp7_;
#line 2884 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->slot;
#line 2884 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp8_);
#line 2884 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _tmp9_;
#line 2884 "../src/View/AbstractDirectoryView.vala"
	in_trash = g_file_has_uri_scheme (_tmp10_, "trash");
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = self->slot;
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp11_);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = _tmp12_;
#line 2885 "../src/View/AbstractDirectoryView.vala"
	in_recent = g_file_has_uri_scheme (_tmp13_, "recent");
#line 2886 "../src/View/AbstractDirectoryView.vala"
	res = FALSE;
#line 2888 "../src/View/AbstractDirectoryView.vala"
	switch (keyval) {
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_F10:
#line 15621 "AbstractDirectoryView.c"
		{
#line 2890 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 15625 "AbstractDirectoryView.c"
				GdkEvent* _tmp14_;
#line 2891 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = event;
#line 2891 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_show_context_menu (self, _tmp14_);
#line 2892 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 15633 "AbstractDirectoryView.c"
			}
#line 2895 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15637 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_F2:
#line 15641 "AbstractDirectoryView.c"
		{
			gboolean _tmp15_ = FALSE;
#line 2898 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 15646 "AbstractDirectoryView.c"
				GSimpleActionGroup* _tmp16_;
#line 2898 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->selection_actions;
#line 2898 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = g_action_group_get_action_enabled ((GActionGroup*) _tmp16_, "rename");
#line 15652 "AbstractDirectoryView.c"
			} else {
#line 2898 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = FALSE;
#line 15656 "AbstractDirectoryView.c"
			}
#line 2898 "../src/View/AbstractDirectoryView.vala"
			if (_tmp15_) {
#line 2899 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_rename_selection (self);
#line 2900 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 15664 "AbstractDirectoryView.c"
			}
#line 2903 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15668 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Delete:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_KP_Delete:
#line 15674 "AbstractDirectoryView.c"
		{
#line 2907 "../src/View/AbstractDirectoryView.vala"
			if (!self->is_writable) {
#line 15678 "AbstractDirectoryView.c"
				FilesViewWindow* _tmp17_;
				FilesViewWindow* _tmp18_;
				GraniteMessageDialog* _tmp19_;
				GraniteMessageDialog* _tmp20_;
#line 2908 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = files_abstract_directory_view_get_window (self);
#line 2908 "../src/View/AbstractDirectoryView.vala"
				_tmp18_ = _tmp17_;
#line 2908 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp18_) : NULL);
#line 2908 "../src/View/AbstractDirectoryView.vala"
				_tmp20_ = _tmp19_;
#line 2908 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp20_);
#line 15693 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp21_;
#line 2911 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = self->priv->_renaming;
#line 2911 "../src/View/AbstractDirectoryView.vala"
				if (!_tmp21_) {
#line 15700 "AbstractDirectoryView.c"
					gboolean _tmp22_ = FALSE;
					gboolean _tmp23_ = FALSE;
#line 2912 "../src/View/AbstractDirectoryView.vala"
					if (in_trash) {
#line 2912 "../src/View/AbstractDirectoryView.vala"
						_tmp23_ = TRUE;
#line 15707 "AbstractDirectoryView.c"
					} else {
#line 2912 "../src/View/AbstractDirectoryView.vala"
						_tmp23_ = files_is_admin ();
#line 15711 "AbstractDirectoryView.c"
					}
#line 2912 "../src/View/AbstractDirectoryView.vala"
					if (_tmp23_) {
#line 2912 "../src/View/AbstractDirectoryView.vala"
						_tmp22_ = TRUE;
#line 15717 "AbstractDirectoryView.c"
					} else {
#line 2912 "../src/View/AbstractDirectoryView.vala"
						_tmp22_ = only_shift_pressed;
#line 15721 "AbstractDirectoryView.c"
					}
#line 2912 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_trash_or_delete_selected_files (self, _tmp22_);
#line 2913 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 15727 "AbstractDirectoryView.c"
				}
			}
#line 2916 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15732 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_space:
#line 15736 "AbstractDirectoryView.c"
		{
			gboolean _tmp24_ = FALSE;
#line 2919 "../src/View/AbstractDirectoryView.vala"
			if (files_abstract_directory_view_view_has_focus (self)) {
#line 2919 "../src/View/AbstractDirectoryView.vala"
				_tmp24_ = !in_trash;
#line 15743 "AbstractDirectoryView.c"
			} else {
#line 2919 "../src/View/AbstractDirectoryView.vala"
				_tmp24_ = FALSE;
#line 15747 "AbstractDirectoryView.c"
			}
#line 2919 "../src/View/AbstractDirectoryView.vala"
			if (_tmp24_) {
#line 15751 "AbstractDirectoryView.c"
				GList* _tmp25_;
#line 2920 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = files_abstract_directory_view_get_selected_files (self);
#line 2920 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp25_);
#line 2921 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 15759 "AbstractDirectoryView.c"
			}
#line 2924 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15763 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Return:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_KP_Enter:
#line 15769 "AbstractDirectoryView.c"
		{
#line 2928 "../src/View/AbstractDirectoryView.vala"
			if (in_trash) {
#line 2929 "../src/View/AbstractDirectoryView.vala"
				break;
#line 15775 "AbstractDirectoryView.c"
			} else {
#line 2930 "../src/View/AbstractDirectoryView.vala"
				if (in_recent) {
#line 15779 "AbstractDirectoryView.c"
					GList* _tmp26_;
#line 2931 "../src/View/AbstractDirectoryView.vala"
					_tmp26_ = files_abstract_directory_view_get_selected_files (self);
#line 2931 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp26_);
#line 15785 "AbstractDirectoryView.c"
				} else {
#line 2932 "../src/View/AbstractDirectoryView.vala"
					if (only_shift_pressed) {
#line 15789 "AbstractDirectoryView.c"
						GList* _tmp27_;
#line 2933 "../src/View/AbstractDirectoryView.vala"
						_tmp27_ = files_abstract_directory_view_get_selected_files (self);
#line 2933 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp27_);
#line 15795 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp28_ = FALSE;
						gboolean _tmp29_ = FALSE;
#line 2934 "../src/View/AbstractDirectoryView.vala"
						if (shift_pressed) {
#line 2934 "../src/View/AbstractDirectoryView.vala"
							_tmp29_ = control_pressed;
#line 15803 "AbstractDirectoryView.c"
						} else {
#line 2934 "../src/View/AbstractDirectoryView.vala"
							_tmp29_ = FALSE;
#line 15807 "AbstractDirectoryView.c"
						}
#line 2934 "../src/View/AbstractDirectoryView.vala"
						if (_tmp29_) {
#line 2934 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = !alt_pressed;
#line 15813 "AbstractDirectoryView.c"
						} else {
#line 2934 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = FALSE;
#line 15817 "AbstractDirectoryView.c"
						}
#line 2934 "../src/View/AbstractDirectoryView.vala"
						if (_tmp28_) {
#line 15821 "AbstractDirectoryView.c"
							GList* _tmp30_;
#line 2935 "../src/View/AbstractDirectoryView.vala"
							_tmp30_ = files_abstract_directory_view_get_selected_files (self);
#line 2935 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_WINDOW, _tmp30_);
#line 15827 "AbstractDirectoryView.c"
						} else {
#line 2936 "../src/View/AbstractDirectoryView.vala"
							if (only_alt_pressed) {
#line 15831 "AbstractDirectoryView.c"
								GSimpleActionGroup* _tmp31_;
#line 2937 "../src/View/AbstractDirectoryView.vala"
								_tmp31_ = self->priv->common_actions;
#line 2937 "../src/View/AbstractDirectoryView.vala"
								g_action_group_activate_action ((GActionGroup*) _tmp31_, "properties", NULL);
#line 15837 "AbstractDirectoryView.c"
							} else {
#line 2938 "../src/View/AbstractDirectoryView.vala"
								if (no_mods) {
#line 15841 "AbstractDirectoryView.c"
									GList* _tmp32_;
#line 2939 "../src/View/AbstractDirectoryView.vala"
									_tmp32_ = files_abstract_directory_view_get_selected_files (self);
#line 2939 "../src/View/AbstractDirectoryView.vala"
									files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp32_);
#line 15847 "AbstractDirectoryView.c"
								} else {
#line 2941 "../src/View/AbstractDirectoryView.vala"
									break;
#line 15851 "AbstractDirectoryView.c"
								}
							}
						}
					}
				}
			}
#line 2944 "../src/View/AbstractDirectoryView.vala"
			res = TRUE;
#line 2945 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15862 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_minus:
#line 15866 "AbstractDirectoryView.c"
		{
			gboolean _tmp33_ = FALSE;
#line 2948 "../src/View/AbstractDirectoryView.vala"
			if (alt_pressed) {
#line 2948 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = control_pressed;
#line 15873 "AbstractDirectoryView.c"
			} else {
#line 2948 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = FALSE;
#line 15877 "AbstractDirectoryView.c"
			}
#line 2948 "../src/View/AbstractDirectoryView.vala"
			if (_tmp33_) {
#line 15881 "AbstractDirectoryView.c"
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp34_;
				gboolean _tmp35_ = FALSE;
				GtkTreePath* _tmp36_;
#line 2949 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = files_abstract_directory_view_get_path_at_cursor (self);
#line 2949 "../src/View/AbstractDirectoryView.vala"
				path = _tmp34_;
#line 2950 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = path;
#line 2950 "../src/View/AbstractDirectoryView.vala"
				if (_tmp36_ != NULL) {
#line 15894 "AbstractDirectoryView.c"
					GtkTreePath* _tmp37_;
#line 2950 "../src/View/AbstractDirectoryView.vala"
					_tmp37_ = path;
#line 2950 "../src/View/AbstractDirectoryView.vala"
					_tmp35_ = files_abstract_directory_view_path_is_selected (self, _tmp37_);
#line 15900 "AbstractDirectoryView.c"
				} else {
#line 2950 "../src/View/AbstractDirectoryView.vala"
					_tmp35_ = FALSE;
#line 15904 "AbstractDirectoryView.c"
				}
#line 2950 "../src/View/AbstractDirectoryView.vala"
				if (_tmp35_) {
#line 15908 "AbstractDirectoryView.c"
					GtkTreePath* _tmp38_;
#line 2951 "../src/View/AbstractDirectoryView.vala"
					_tmp38_ = path;
#line 2951 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_path (self, _tmp38_);
#line 15914 "AbstractDirectoryView.c"
				}
#line 2954 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 2948 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 15920 "AbstractDirectoryView.c"
			}
#line 2957 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15924 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_plus:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_equal:
#line 15930 "AbstractDirectoryView.c"
		{
			gboolean _tmp39_ = FALSE;
#line 2961 "../src/View/AbstractDirectoryView.vala"
			if (alt_pressed) {
#line 2961 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = control_pressed;
#line 15937 "AbstractDirectoryView.c"
			} else {
#line 2961 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = FALSE;
#line 15941 "AbstractDirectoryView.c"
			}
#line 2961 "../src/View/AbstractDirectoryView.vala"
			if (_tmp39_) {
#line 15945 "AbstractDirectoryView.c"
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp40_;
				gboolean _tmp41_ = FALSE;
				GtkTreePath* _tmp42_;
#line 2962 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = files_abstract_directory_view_get_path_at_cursor (self);
#line 2962 "../src/View/AbstractDirectoryView.vala"
				path = _tmp40_;
#line 2963 "../src/View/AbstractDirectoryView.vala"
				_tmp42_ = path;
#line 2963 "../src/View/AbstractDirectoryView.vala"
				if (_tmp42_ != NULL) {
#line 15958 "AbstractDirectoryView.c"
					GtkTreePath* _tmp43_;
#line 2963 "../src/View/AbstractDirectoryView.vala"
					_tmp43_ = path;
#line 2963 "../src/View/AbstractDirectoryView.vala"
					_tmp41_ = !files_abstract_directory_view_path_is_selected (self, _tmp43_);
#line 15964 "AbstractDirectoryView.c"
				} else {
#line 2963 "../src/View/AbstractDirectoryView.vala"
					_tmp41_ = FALSE;
#line 15968 "AbstractDirectoryView.c"
				}
#line 2963 "../src/View/AbstractDirectoryView.vala"
				if (_tmp41_) {
#line 15972 "AbstractDirectoryView.c"
					GtkTreePath* _tmp44_;
#line 2964 "../src/View/AbstractDirectoryView.vala"
					_tmp44_ = path;
#line 2964 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp44_, FALSE);
#line 15978 "AbstractDirectoryView.c"
				}
#line 2967 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 2961 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 15984 "AbstractDirectoryView.c"
			}
#line 2970 "../src/View/AbstractDirectoryView.vala"
			break;
#line 15988 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Escape:
#line 15992 "AbstractDirectoryView.c"
		{
#line 2973 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 2974 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_unselect_all (self);
#line 15998 "AbstractDirectoryView.c"
			}
#line 2977 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16002 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Menu:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_MenuKB:
#line 16008 "AbstractDirectoryView.c"
		{
#line 2981 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 16012 "AbstractDirectoryView.c"
				GdkEvent* _tmp45_;
#line 2982 "../src/View/AbstractDirectoryView.vala"
				_tmp45_ = event;
#line 2982 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_show_context_menu (self, _tmp45_);
#line 2983 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16020 "AbstractDirectoryView.c"
			}
#line 2986 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16024 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_N:
#line 16028 "AbstractDirectoryView.c"
		{
#line 2989 "../src/View/AbstractDirectoryView.vala"
			if (control_pressed) {
#line 2990 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_folder (self);
#line 2991 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16036 "AbstractDirectoryView.c"
			}
#line 2994 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16040 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Up:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Down:
#line 16046 "AbstractDirectoryView.c"
		{
			GList* selection = NULL;
			GList* _tmp46_;
			gboolean _tmp47_ = FALSE;
#line 2998 "../src/View/AbstractDirectoryView.vala"
			_tmp46_ = files_abstract_directory_view_get_selected_files (self);
#line 2998 "../src/View/AbstractDirectoryView.vala"
			selection = _tmp46_;
#line 2999 "../src/View/AbstractDirectoryView.vala"
			if (only_alt_pressed) {
#line 2999 "../src/View/AbstractDirectoryView.vala"
				_tmp47_ = keyval == GDK_KEY_Down;
#line 16059 "AbstractDirectoryView.c"
			} else {
#line 2999 "../src/View/AbstractDirectoryView.vala"
				_tmp47_ = FALSE;
#line 16063 "AbstractDirectoryView.c"
			}
#line 2999 "../src/View/AbstractDirectoryView.vala"
			if (_tmp47_) {
#line 16067 "AbstractDirectoryView.c"
				gboolean _tmp48_ = FALSE;
				gboolean _tmp49_ = FALSE;
				GList* _tmp50_;
#line 3002 "../src/View/AbstractDirectoryView.vala"
				_tmp50_ = selection;
#line 3002 "../src/View/AbstractDirectoryView.vala"
				if (_tmp50_ != NULL) {
#line 16075 "AbstractDirectoryView.c"
					GList* _tmp51_;
					GList* _tmp52_;
					GList* _tmp53_;
#line 3003 "../src/View/AbstractDirectoryView.vala"
					_tmp51_ = selection;
#line 3003 "../src/View/AbstractDirectoryView.vala"
					_tmp52_ = g_list_first (_tmp51_);
#line 3003 "../src/View/AbstractDirectoryView.vala"
					_tmp53_ = _tmp52_->next;
#line 3003 "../src/View/AbstractDirectoryView.vala"
					_tmp49_ = _tmp53_ == NULL;
#line 16087 "AbstractDirectoryView.c"
				} else {
#line 3002 "../src/View/AbstractDirectoryView.vala"
					_tmp49_ = FALSE;
#line 16091 "AbstractDirectoryView.c"
				}
#line 3002 "../src/View/AbstractDirectoryView.vala"
				if (_tmp49_) {
#line 16095 "AbstractDirectoryView.c"
					GList* _tmp54_;
					gconstpointer _tmp55_;
#line 3004 "../src/View/AbstractDirectoryView.vala"
					_tmp54_ = selection;
#line 3004 "../src/View/AbstractDirectoryView.vala"
					_tmp55_ = _tmp54_->data;
#line 3004 "../src/View/AbstractDirectoryView.vala"
					_tmp48_ = files_file_is_folder ((FilesFile*) _tmp55_);
#line 16104 "AbstractDirectoryView.c"
				} else {
#line 3002 "../src/View/AbstractDirectoryView.vala"
					_tmp48_ = FALSE;
#line 16108 "AbstractDirectoryView.c"
				}
#line 3002 "../src/View/AbstractDirectoryView.vala"
				if (_tmp48_) {
#line 16112 "AbstractDirectoryView.c"
					GList* _tmp56_;
					gconstpointer _tmp57_;
					GFile* _tmp58_;
					GFile* _tmp59_;
#line 3006 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = selection;
#line 3006 "../src/View/AbstractDirectoryView.vala"
					_tmp57_ = _tmp56_->data;
#line 3006 "../src/View/AbstractDirectoryView.vala"
					_tmp58_ = files_file_get_location ((FilesFile*) _tmp57_);
#line 3006 "../src/View/AbstractDirectoryView.vala"
					_tmp59_ = _tmp58_;
#line 3006 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_load_location (self, _tmp59_);
#line 3007 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16129 "AbstractDirectoryView.c"
				}
#line 3010 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16133 "AbstractDirectoryView.c"
			}
#line 3013 "../src/View/AbstractDirectoryView.vala"
			res = files_abstract_directory_view_move_cursor (self, keyval, only_shift_pressed, control_pressed);
#line 3014 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16139 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Left:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Right:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_BackSpace:
#line 16147 "AbstractDirectoryView.c"
		{
			gboolean _tmp60_ = FALSE;
#line 3019 "../src/View/AbstractDirectoryView.vala"
			if (FILES_IS_COLUMN_VIEW (self)) {
#line 3019 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = no_mods;
#line 16154 "AbstractDirectoryView.c"
			} else {
#line 3019 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = FALSE;
#line 16158 "AbstractDirectoryView.c"
			}
#line 3019 "../src/View/AbstractDirectoryView.vala"
			if (_tmp60_) {
#line 16162 "AbstractDirectoryView.c"
				FilesViewSlot* _tmp61_;
				FilesViewViewContainer* _tmp62_;
				FilesViewViewContainer* _tmp63_;
				FilesAbstractSlot* _tmp64_;
#line 3020 "../src/View/AbstractDirectoryView.vala"
				_tmp61_ = self->slot;
#line 3020 "../src/View/AbstractDirectoryView.vala"
				_tmp62_ = files_view_slot_get_ctab (_tmp61_);
#line 3020 "../src/View/AbstractDirectoryView.vala"
				_tmp63_ = _tmp62_;
#line 3020 "../src/View/AbstractDirectoryView.vala"
				_tmp64_ = _tmp63_->view;
#line 3020 "../src/View/AbstractDirectoryView.vala"
				files_view_miller_on_miller_key_pressed (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, FILES_VIEW_TYPE_MILLER, FilesViewMiller), keyval, keycode, state);
#line 3021 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 3022 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16181 "AbstractDirectoryView.c"
			}
#line 3025 "../src/View/AbstractDirectoryView.vala"
			res = files_abstract_directory_view_move_cursor (self, keyval, only_shift_pressed, control_pressed);
#line 3026 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16187 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Home:
#line 16191 "AbstractDirectoryView.c"
		{
			gboolean _tmp65_ = FALSE;
#line 3029 "../src/View/AbstractDirectoryView.vala"
			if (only_shift_pressed) {
#line 16196 "AbstractDirectoryView.c"
				GtkTreePath* _tmp66_;
				GtkTreePath* _tmp67_;
#line 3030 "../src/View/AbstractDirectoryView.vala"
				_tmp66_ = gtk_tree_path_new_from_indices (0, -1);
#line 3030 "../src/View/AbstractDirectoryView.vala"
				_tmp67_ = _tmp66_;
#line 3030 "../src/View/AbstractDirectoryView.vala"
				_tmp65_ = files_abstract_directory_view_handle_multi_select (self, _tmp67_);
#line 3030 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (_tmp67_);
#line 16207 "AbstractDirectoryView.c"
			} else {
#line 3029 "../src/View/AbstractDirectoryView.vala"
				_tmp65_ = FALSE;
#line 16211 "AbstractDirectoryView.c"
			}
#line 3029 "../src/View/AbstractDirectoryView.vala"
			res = _tmp65_;
#line 3032 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16217 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_End:
#line 16221 "AbstractDirectoryView.c"
		{
			gboolean _tmp68_ = FALSE;
#line 3035 "../src/View/AbstractDirectoryView.vala"
			if (only_shift_pressed) {
#line 16226 "AbstractDirectoryView.c"
				FilesListModel* _tmp69_;
				GtkTreePath* _tmp70_;
				GtkTreePath* _tmp71_;
#line 3036 "../src/View/AbstractDirectoryView.vala"
				_tmp69_ = self->model;
#line 3036 "../src/View/AbstractDirectoryView.vala"
				_tmp70_ = gtk_tree_path_new_from_indices (files_list_model_get_length (_tmp69_), -1);
#line 3036 "../src/View/AbstractDirectoryView.vala"
				_tmp71_ = _tmp70_;
#line 3036 "../src/View/AbstractDirectoryView.vala"
				_tmp68_ = files_abstract_directory_view_handle_multi_select (self, _tmp71_);
#line 3036 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (_tmp71_);
#line 16240 "AbstractDirectoryView.c"
			} else {
#line 3035 "../src/View/AbstractDirectoryView.vala"
				_tmp68_ = FALSE;
#line 16244 "AbstractDirectoryView.c"
			}
#line 3035 "../src/View/AbstractDirectoryView.vala"
			res = _tmp68_;
#line 3038 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16250 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_c:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_C:
#line 16256 "AbstractDirectoryView.c"
		{
#line 3042 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 16260 "AbstractDirectoryView.c"
				gboolean caps_on = FALSE;
				GdkDisplay* _tmp72_;
				GdkKeymap* _tmp73_;
				gboolean cap_c = FALSE;
#line 3044 "../src/View/AbstractDirectoryView.vala"
				_tmp72_ = gtk_widget_get_display ((GtkWidget*) self);
#line 3044 "../src/View/AbstractDirectoryView.vala"
				_tmp73_ = gdk_keymap_get_for_display (_tmp72_);
#line 3044 "../src/View/AbstractDirectoryView.vala"
				caps_on = gdk_keymap_get_caps_lock_state (_tmp73_);
#line 3045 "../src/View/AbstractDirectoryView.vala"
				cap_c = keyval == GDK_KEY_C;
#line 3047 "../src/View/AbstractDirectoryView.vala"
				if (caps_on != cap_c) {
#line 16275 "AbstractDirectoryView.c"
					GSimpleActionGroup* _tmp74_;
#line 3048 "../src/View/AbstractDirectoryView.vala"
					_tmp74_ = self->priv->common_actions;
#line 3048 "../src/View/AbstractDirectoryView.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp74_, "copy-link", NULL);
#line 16281 "AbstractDirectoryView.c"
				} else {
#line 3051 "../src/View/AbstractDirectoryView.vala"
					if (in_trash) {
#line 16285 "AbstractDirectoryView.c"
						FilesViewWindow* _tmp75_;
						FilesViewWindow* _tmp76_;
						GraniteMessageDialog* _tmp77_;
						GraniteMessageDialog* _tmp78_;
						GSimpleActionGroup* _tmp79_;
#line 3052 "../src/View/AbstractDirectoryView.vala"
						_tmp75_ = files_abstract_directory_view_get_window (self);
#line 3052 "../src/View/AbstractDirectoryView.vala"
						_tmp76_ = _tmp75_;
#line 3052 "../src/View/AbstractDirectoryView.vala"
						_tmp77_ = pf_dialogs_show_warning_dialog (_ ("Cannot copy files that are in the trash"), _ ("Cutting the selection instead"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp76_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp76_) : NULL);
#line 3052 "../src/View/AbstractDirectoryView.vala"
						_tmp78_ = _tmp77_;
#line 3052 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp78_);
#line 3056 "../src/View/AbstractDirectoryView.vala"
						_tmp79_ = self->priv->selection_actions;
#line 3056 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp79_, "cut", NULL);
#line 16305 "AbstractDirectoryView.c"
					} else {
						GSimpleActionGroup* _tmp80_;
#line 3058 "../src/View/AbstractDirectoryView.vala"
						_tmp80_ = self->priv->common_actions;
#line 3058 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp80_, "copy", NULL);
#line 16312 "AbstractDirectoryView.c"
					}
				}
#line 3062 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16317 "AbstractDirectoryView.c"
			}
#line 3065 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16321 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_v:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_V:
#line 16327 "AbstractDirectoryView.c"
		{
#line 3069 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 3070 "../src/View/AbstractDirectoryView.vala"
				if (shift_pressed) {
#line 16333 "AbstractDirectoryView.c"
					gboolean _tmp81_ = FALSE;
#line 3071 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3072 "../src/View/AbstractDirectoryView.vala"
					if (!in_recent) {
#line 3072 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = self->is_writable;
#line 16341 "AbstractDirectoryView.c"
					} else {
#line 3072 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = FALSE;
#line 16345 "AbstractDirectoryView.c"
					}
#line 3072 "../src/View/AbstractDirectoryView.vala"
					if (_tmp81_) {
#line 16349 "AbstractDirectoryView.c"
						gboolean _tmp82_ = FALSE;
						GList* _tmp83_;
						GList* _tmp84_;
#line 3073 "../src/View/AbstractDirectoryView.vala"
						_tmp83_ = self->selected_files;
#line 3073 "../src/View/AbstractDirectoryView.vala"
						_tmp84_ = g_list_first (_tmp83_);
#line 3073 "../src/View/AbstractDirectoryView.vala"
						if (_tmp84_ != NULL) {
#line 16359 "AbstractDirectoryView.c"
							GList* _tmp85_;
							GList* _tmp86_;
							GList* _tmp87_;
#line 3073 "../src/View/AbstractDirectoryView.vala"
							_tmp85_ = self->selected_files;
#line 3073 "../src/View/AbstractDirectoryView.vala"
							_tmp86_ = g_list_first (_tmp85_);
#line 3073 "../src/View/AbstractDirectoryView.vala"
							_tmp87_ = _tmp86_->next;
#line 3073 "../src/View/AbstractDirectoryView.vala"
							_tmp82_ = _tmp87_ != NULL;
#line 16371 "AbstractDirectoryView.c"
						} else {
#line 3073 "../src/View/AbstractDirectoryView.vala"
							_tmp82_ = FALSE;
#line 16375 "AbstractDirectoryView.c"
						}
#line 3073 "../src/View/AbstractDirectoryView.vala"
						if (_tmp82_) {
#line 3075 "../src/View/AbstractDirectoryView.vala"
							gdk_beep ();
#line 3076 "../src/View/AbstractDirectoryView.vala"
							g_warning ("AbstractDirectoryView.vala:3076: Cannot paste into a multiple selectio" \
"n");
#line 16383 "AbstractDirectoryView.c"
						} else {
							GSimpleActionGroup* _tmp88_;
							GSimpleActionGroup* _tmp89_;
#line 3079 "../src/View/AbstractDirectoryView.vala"
							_tmp88_ = self->priv->common_actions;
#line 3079 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_action_set_enabled (self, _tmp88_, "paste-into", TRUE);
#line 3080 "../src/View/AbstractDirectoryView.vala"
							_tmp89_ = self->priv->common_actions;
#line 3080 "../src/View/AbstractDirectoryView.vala"
							g_action_group_activate_action ((GActionGroup*) _tmp89_, "paste-into", NULL);
#line 16395 "AbstractDirectoryView.c"
						}
					} else {
						FilesViewWindow* _tmp90_;
						FilesViewWindow* _tmp91_;
						GraniteMessageDialog* _tmp92_;
						GraniteMessageDialog* _tmp93_;
#line 3083 "../src/View/AbstractDirectoryView.vala"
						_tmp90_ = files_abstract_directory_view_get_window (self);
#line 3083 "../src/View/AbstractDirectoryView.vala"
						_tmp91_ = _tmp90_;
#line 3083 "../src/View/AbstractDirectoryView.vala"
						_tmp92_ = pf_dialogs_show_warning_dialog (_ ("Cannot paste files here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp91_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp91_) : NULL);
#line 3083 "../src/View/AbstractDirectoryView.vala"
						_tmp93_ = _tmp92_;
#line 3083 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp93_);
#line 16412 "AbstractDirectoryView.c"
					}
#line 3088 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16416 "AbstractDirectoryView.c"
				} else {
					gboolean _tmp94_ = FALSE;
#line 3090 "../src/View/AbstractDirectoryView.vala"
					if (!in_recent) {
#line 3090 "../src/View/AbstractDirectoryView.vala"
						_tmp94_ = self->is_writable;
#line 16423 "AbstractDirectoryView.c"
					} else {
#line 3090 "../src/View/AbstractDirectoryView.vala"
						_tmp94_ = FALSE;
#line 16427 "AbstractDirectoryView.c"
					}
#line 3090 "../src/View/AbstractDirectoryView.vala"
					if (_tmp94_) {
#line 16431 "AbstractDirectoryView.c"
						GSimpleActionGroup* _tmp95_;
						GSimpleActionGroup* _tmp96_;
#line 3091 "../src/View/AbstractDirectoryView.vala"
						_tmp95_ = self->priv->common_actions;
#line 3091 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_action_set_enabled (self, _tmp95_, "paste", TRUE);
#line 3092 "../src/View/AbstractDirectoryView.vala"
						_tmp96_ = self->priv->common_actions;
#line 3092 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp96_, "paste", NULL);
#line 16442 "AbstractDirectoryView.c"
					} else {
						FilesViewWindow* _tmp97_;
						FilesViewWindow* _tmp98_;
						GraniteMessageDialog* _tmp99_;
						GraniteMessageDialog* _tmp100_;
#line 3094 "../src/View/AbstractDirectoryView.vala"
						_tmp97_ = files_abstract_directory_view_get_window (self);
#line 3094 "../src/View/AbstractDirectoryView.vala"
						_tmp98_ = _tmp97_;
#line 3094 "../src/View/AbstractDirectoryView.vala"
						_tmp99_ = pf_dialogs_show_warning_dialog (_ ("Cannot paste files here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp98_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp98_) : NULL);
#line 3094 "../src/View/AbstractDirectoryView.vala"
						_tmp100_ = _tmp99_;
#line 3094 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp100_);
#line 16458 "AbstractDirectoryView.c"
					}
#line 3099 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16462 "AbstractDirectoryView.c"
				}
			}
#line 3103 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16467 "AbstractDirectoryView.c"
		}
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_x:
#line 2888 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_X:
#line 16473 "AbstractDirectoryView.c"
		{
#line 3107 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 3108 "../src/View/AbstractDirectoryView.vala"
				if (self->is_writable) {
#line 16479 "AbstractDirectoryView.c"
					GSimpleActionGroup* _tmp101_;
#line 3109 "../src/View/AbstractDirectoryView.vala"
					_tmp101_ = self->priv->selection_actions;
#line 3109 "../src/View/AbstractDirectoryView.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp101_, "cut", NULL);
#line 16485 "AbstractDirectoryView.c"
				} else {
					FilesViewWindow* _tmp102_;
					FilesViewWindow* _tmp103_;
					GraniteMessageDialog* _tmp104_;
					GraniteMessageDialog* _tmp105_;
#line 3111 "../src/View/AbstractDirectoryView.vala"
					_tmp102_ = files_abstract_directory_view_get_window (self);
#line 3111 "../src/View/AbstractDirectoryView.vala"
					_tmp103_ = _tmp102_;
#line 3111 "../src/View/AbstractDirectoryView.vala"
					_tmp104_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp103_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp103_) : NULL);
#line 3111 "../src/View/AbstractDirectoryView.vala"
					_tmp105_ = _tmp104_;
#line 3111 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp105_);
#line 16501 "AbstractDirectoryView.c"
				}
#line 3116 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16505 "AbstractDirectoryView.c"
			}
#line 3119 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16509 "AbstractDirectoryView.c"
		}
		default:
		{
#line 3122 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16515 "AbstractDirectoryView.c"
		}
	}
#line 3125 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda113__gsource_func, g_object_ref (self), g_object_unref);
#line 3130 "../src/View/AbstractDirectoryView.vala"
	result = res;
#line 3130 "../src/View/AbstractDirectoryView.vala"
	__vala_GdkEvent_free0 (event);
#line 3130 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 16526 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                       guint original_keyval,
                                                       guint keycode,
                                                       GdkModifierType state)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 2864 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2864 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 2864 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_key_press_event) {
#line 2864 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_key_press_event (self, original_keyval, keycode, state);
#line 16544 "AbstractDirectoryView.c"
	}
#line 2864 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 16548 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_motion_notify_event (FilesAbstractDirectoryView* self,
                                                      gdouble x,
                                                      gdouble y)
{
	GtkTreePath* path = NULL;
	FilesFile* file = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkTreePath* _tmp4_ = NULL;
	guint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GtkTreePath* _tmp9_;
#line 3133 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3135 "../src/View/AbstractDirectoryView.vala"
	path = NULL;
#line 3136 "../src/View/AbstractDirectoryView.vala"
	file = NULL;
#line 3138 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3138 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3138 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 16578 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 3138 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_is_frozen (self);
#line 3138 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 3138 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp3_;
#line 16588 "AbstractDirectoryView.c"
	}
#line 3138 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3139 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3139 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 3139 "../src/View/AbstractDirectoryView.vala"
		return;
#line 16598 "AbstractDirectoryView.c"
	}
#line 3142 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_directory_view_get_event_position_info (self, x, y, &_tmp4_, FALSE);
#line 3142 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3142 "../src/View/AbstractDirectoryView.vala"
	path = _tmp4_;
#line 3142 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = _tmp5_;
#line 3144 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = path;
#line 3144 "../src/View/AbstractDirectoryView.vala"
	if (_tmp9_ != NULL) {
#line 16612 "AbstractDirectoryView.c"
		GtkTreePath* _tmp10_;
#line 3144 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->priv->hover_path;
#line 3144 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 16618 "AbstractDirectoryView.c"
	} else {
#line 3144 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = FALSE;
#line 16622 "AbstractDirectoryView.c"
	}
#line 3144 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_) {
#line 3144 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = TRUE;
#line 16628 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp11_ = FALSE;
		GtkTreePath* _tmp12_;
#line 3145 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = path;
#line 3145 "../src/View/AbstractDirectoryView.vala"
		if (_tmp12_ == NULL) {
#line 16636 "AbstractDirectoryView.c"
			GtkTreePath* _tmp13_;
#line 3145 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = self->priv->hover_path;
#line 3145 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 16642 "AbstractDirectoryView.c"
		} else {
#line 3145 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = FALSE;
#line 16646 "AbstractDirectoryView.c"
		}
#line 3145 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp11_;
#line 16650 "AbstractDirectoryView.c"
	}
#line 3144 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_) {
#line 3144 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = TRUE;
#line 16656 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GtkTreePath* _tmp16_;
#line 3146 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = path;
#line 3146 "../src/View/AbstractDirectoryView.vala"
		if (_tmp16_ != NULL) {
#line 16665 "AbstractDirectoryView.c"
			GtkTreePath* _tmp17_;
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->priv->hover_path;
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = _tmp17_ != NULL;
#line 16671 "AbstractDirectoryView.c"
		} else {
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = FALSE;
#line 16675 "AbstractDirectoryView.c"
		}
#line 3146 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_) {
#line 16679 "AbstractDirectoryView.c"
			GtkTreePath* _tmp18_;
			GtkTreePath* _tmp19_;
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = path;
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = self->priv->hover_path;
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = gtk_tree_path_compare (_tmp18_, _tmp19_) != 0;
#line 16688 "AbstractDirectoryView.c"
		} else {
#line 3146 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = FALSE;
#line 16692 "AbstractDirectoryView.c"
		}
#line 3146 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp14_;
#line 16696 "AbstractDirectoryView.c"
	}
#line 3144 "../src/View/AbstractDirectoryView.vala"
	if (_tmp6_) {
#line 16700 "AbstractDirectoryView.c"
		gboolean _tmp20_ = FALSE;
		FilesViewSlot* _tmp21_;
		FilesDirectory* _tmp22_;
		FilesDirectory* _tmp23_;
		gboolean _tmp24_;
		gboolean _tmp25_;
#line 3148 "../src/View/AbstractDirectoryView.vala"
		self->on_directory = FALSE;
#line 3150 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = self->slot;
#line 3150 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp21_);
#line 3150 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = _tmp22_;
#line 3150 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_directory_get_is_local (_tmp23_);
#line 3150 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = _tmp24_;
#line 3150 "../src/View/AbstractDirectoryView.vala"
		if (_tmp25_) {
#line 3150 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = TRUE;
#line 16723 "AbstractDirectoryView.c"
		} else {
			GNetworkMonitor* _tmp26_;
#line 3150 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = g_network_monitor_get_default ();
#line 3150 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = g_network_monitor_get_network_available (_tmp26_);
#line 16730 "AbstractDirectoryView.c"
		}
#line 3150 "../src/View/AbstractDirectoryView.vala"
		if (_tmp20_) {
#line 16734 "AbstractDirectoryView.c"
			FilesFile* target_file = NULL;
			FilesFile* _tmp27_ = NULL;
			GtkTreePath* _tmp28_;
			FilesFile* _tmp32_;
			gboolean _tmp33_ = FALSE;
			FilesFile* _tmp34_;
			FilesFile* _tmp47_;
			GtkTreePath* _tmp49_;
			GtkTreePath* _tmp50_;
#line 3153 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = path;
#line 3153 "../src/View/AbstractDirectoryView.vala"
			if (_tmp28_ != NULL) {
#line 16748 "AbstractDirectoryView.c"
				FilesListModel* _tmp29_;
				GtkTreePath* _tmp30_;
				FilesFile* _tmp31_;
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_tmp29_ = self->model;
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_tmp30_ = path;
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_tmp31_ = files_list_model_file_for_path (_tmp29_, _tmp30_);
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp27_);
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_tmp27_ = _tmp31_;
#line 16762 "AbstractDirectoryView.c"
			} else {
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp27_);
#line 3153 "../src/View/AbstractDirectoryView.vala"
				_tmp27_ = NULL;
#line 16768 "AbstractDirectoryView.c"
			}
#line 3153 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = _g_object_ref0 (_tmp27_);
#line 3153 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 3153 "../src/View/AbstractDirectoryView.vala"
			file = _tmp32_;
#line 3156 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = file;
#line 3156 "../src/View/AbstractDirectoryView.vala"
			if (_tmp34_ != NULL) {
#line 16780 "AbstractDirectoryView.c"
				FilesViewSlot* _tmp35_;
				FilesDirectory* _tmp36_;
				FilesDirectory* _tmp37_;
				gboolean _tmp38_;
				gboolean _tmp39_;
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = self->slot;
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp35_);
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = _tmp36_;
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = files_directory_get_is_recent (_tmp37_);
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = _tmp38_;
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = _tmp39_;
#line 16798 "AbstractDirectoryView.c"
			} else {
#line 3156 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = FALSE;
#line 16802 "AbstractDirectoryView.c"
			}
#line 3156 "../src/View/AbstractDirectoryView.vala"
			if (_tmp33_) {
#line 16806 "AbstractDirectoryView.c"
				FilesFile* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				FilesFile* _tmp43_;
				FilesFile* _tmp44_;
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = file;
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_tmp41_ = files_file_get_display_target_uri (_tmp40_);
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_tmp42_ = _tmp41_;
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = files_file_get_by_uri (_tmp42_);
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (target_file);
#line 3157 "../src/View/AbstractDirectoryView.vala"
				target_file = _tmp43_;
#line 3157 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp42_);
#line 3158 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = target_file;
#line 3158 "../src/View/AbstractDirectoryView.vala"
				files_file_ensure_query_info (_tmp44_);
#line 16830 "AbstractDirectoryView.c"
			} else {
				FilesFile* _tmp45_;
				FilesFile* _tmp46_;
#line 3160 "../src/View/AbstractDirectoryView.vala"
				_tmp45_ = file;
#line 3160 "../src/View/AbstractDirectoryView.vala"
				_tmp46_ = _g_object_ref0 (_tmp45_);
#line 3160 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (target_file);
#line 3160 "../src/View/AbstractDirectoryView.vala"
				target_file = _tmp46_;
#line 16842 "AbstractDirectoryView.c"
			}
#line 3163 "../src/View/AbstractDirectoryView.vala"
			_tmp47_ = target_file;
#line 3163 "../src/View/AbstractDirectoryView.vala"
			if (_tmp47_ != NULL) {
#line 16848 "AbstractDirectoryView.c"
				FilesFile* _tmp48_;
#line 3164 "../src/View/AbstractDirectoryView.vala"
				_tmp48_ = target_file;
#line 3164 "../src/View/AbstractDirectoryView.vala"
				self->on_directory = _tmp48_->is_directory;
#line 16854 "AbstractDirectoryView.c"
			}
#line 3167 "../src/View/AbstractDirectoryView.vala"
			_tmp49_ = path;
#line 3167 "../src/View/AbstractDirectoryView.vala"
			_tmp50_ = __vala_GtkTreePath_copy0 (_tmp49_);
#line 3167 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3167 "../src/View/AbstractDirectoryView.vala"
			self->priv->hover_path = _tmp50_;
#line 3150 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp27_);
#line 3150 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (target_file);
#line 16868 "AbstractDirectoryView.c"
		}
	}
#line 3171 "../src/View/AbstractDirectoryView.vala"
	if (self->click_zone != self->previous_click_zone) {
#line 16873 "AbstractDirectoryView.c"
		GdkWindow* win = NULL;
		GtkWidget* _tmp51_;
		GdkWindow* _tmp52_;
		GdkWindow* _tmp53_;
		GdkWindow* _tmp54_;
		GdkCursor* _tmp55_;
#line 3172 "../src/View/AbstractDirectoryView.vala"
		_tmp51_ = self->priv->view;
#line 3172 "../src/View/AbstractDirectoryView.vala"
		_tmp52_ = gtk_widget_get_window (_tmp51_);
#line 3172 "../src/View/AbstractDirectoryView.vala"
		_tmp53_ = _g_object_ref0 (_tmp52_);
#line 3172 "../src/View/AbstractDirectoryView.vala"
		win = _tmp53_;
#line 3173 "../src/View/AbstractDirectoryView.vala"
		_tmp54_ = win;
#line 3173 "../src/View/AbstractDirectoryView.vala"
		_tmp55_ = self->priv->selectable_cursor;
#line 3173 "../src/View/AbstractDirectoryView.vala"
		gdk_window_set_cursor (_tmp54_, _tmp55_);
#line 3175 "../src/View/AbstractDirectoryView.vala"
		switch (self->click_zone) {
#line 3175 "../src/View/AbstractDirectoryView.vala"
			case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3175 "../src/View/AbstractDirectoryView.vala"
			case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 16900 "AbstractDirectoryView.c"
			{
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
#line 3178 "../src/View/AbstractDirectoryView.vala"
				if (self->on_directory) {
#line 3178 "../src/View/AbstractDirectoryView.vala"
					_tmp57_ = self->one_or_less;
#line 16908 "AbstractDirectoryView.c"
				} else {
#line 3178 "../src/View/AbstractDirectoryView.vala"
					_tmp57_ = FALSE;
#line 16912 "AbstractDirectoryView.c"
				}
#line 3178 "../src/View/AbstractDirectoryView.vala"
				if (_tmp57_) {
#line 16916 "AbstractDirectoryView.c"
					gboolean _tmp58_;
#line 3178 "../src/View/AbstractDirectoryView.vala"
					_tmp58_ = self->priv->_singleclick_select;
#line 3178 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = !_tmp58_;
#line 16922 "AbstractDirectoryView.c"
				} else {
#line 3178 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = FALSE;
#line 16926 "AbstractDirectoryView.c"
				}
#line 3178 "../src/View/AbstractDirectoryView.vala"
				if (_tmp56_) {
#line 16930 "AbstractDirectoryView.c"
					GdkWindow* _tmp59_;
					GdkCursor* _tmp60_;
#line 3179 "../src/View/AbstractDirectoryView.vala"
					_tmp59_ = win;
#line 3179 "../src/View/AbstractDirectoryView.vala"
					_tmp60_ = self->priv->activatable_cursor;
#line 3179 "../src/View/AbstractDirectoryView.vala"
					gdk_window_set_cursor (_tmp59_, _tmp60_);
#line 16939 "AbstractDirectoryView.c"
				}
#line 3182 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16943 "AbstractDirectoryView.c"
			}
			default:
			{
#line 3185 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16949 "AbstractDirectoryView.c"
			}
		}
#line 3188 "../src/View/AbstractDirectoryView.vala"
		self->previous_click_zone = self->click_zone;
#line 3171 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (win);
#line 16956 "AbstractDirectoryView.c"
	}
#line 3133 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 3133 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 16962 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_leave_notify_event (FilesAbstractDirectoryView* self)
{
#line 3192 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3193 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3193 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 16974 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_on_scroll_event (FilesAbstractDirectoryView* self,
                                                    gdouble dx,
                                                    gdouble dy)
{
	GdkModifierType state = 0U;
	GdkModifierType _tmp0_ = 0U;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 3198 "../src/View/AbstractDirectoryView.vala"
	gtk_get_current_event_state (&_tmp0_);
#line 3198 "../src/View/AbstractDirectoryView.vala"
	state = _tmp0_;
#line 3200 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_is_frozen (self);
#line 3200 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 3200 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp3_) {
#line 3200 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = (state & GDK_CONTROL_MASK) > 0;
#line 16999 "AbstractDirectoryView.c"
	} else {
#line 3200 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = FALSE;
#line 17003 "AbstractDirectoryView.c"
	}
#line 3200 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3203 "../src/View/AbstractDirectoryView.vala"
		self->priv->total_delta_y = self->priv->total_delta_y + dy;
#line 3205 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->total_delta_y >= 0.5) {
#line 3206 "../src/View/AbstractDirectoryView.vala"
			self->priv->total_delta_y = (gdouble) 0;
#line 3207 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_zoom_out (self);
#line 17015 "AbstractDirectoryView.c"
		} else {
#line 3208 "../src/View/AbstractDirectoryView.vala"
			if (self->priv->total_delta_y <= (-0.5)) {
#line 3209 "../src/View/AbstractDirectoryView.vala"
				self->priv->total_delta_y = (gdouble) 0;
#line 3210 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_zoom_in (self);
#line 17023 "AbstractDirectoryView.c"
			}
		}
	}
}

void
files_abstract_directory_view_on_scroll_event (FilesAbstractDirectoryView* self,
                                               gdouble dx,
                                               gdouble dy)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3196 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3196 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3196 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_scroll_event) {
#line 3196 "../src/View/AbstractDirectoryView.vala"
		_klass_->on_scroll_event (self, dx, dy);
#line 17043 "AbstractDirectoryView.c"
	}
}

/** name renderer signals */
static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 3224 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 17053 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 3224 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 17061 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_editing_started (FilesAbstractDirectoryView* self,
                                                       GtkCellEditable* editable,
                                                       const gchar* path_string)
{
	FilesAbstractEditableLabel* editable_widget = NULL;
	FilesAbstractEditableLabel* _tmp0_;
	FilesAbstractEditableLabel* _tmp1_;
#line 3218 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3218 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path_string != NULL);
#line 3219 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (FILES_IS_ABSTRACT_EDITABLE_LABEL (editable) ? ((FilesAbstractEditableLabel*) editable) : NULL);
#line 3219 "../src/View/AbstractDirectoryView.vala"
	editable_widget = _tmp0_;
#line 3220 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = editable_widget;
#line 3220 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 17084 "AbstractDirectoryView.c"
		FilesAbstractEditableLabel* _tmp2_;
		gchar* _tmp3_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp4_;
		GtkTreeIter* iter = NULL;
		FilesListModel* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreeIter _tmp7_ = {0};
		GtkTreeIter _tmp8_;
		GtkTreeIter* _tmp9_;
		FilesFile* file = NULL;
		FilesListModel* _tmp10_;
		GtkTreeIter* _tmp11_;
		GtkTreeIter _tmp12_;
		FilesFile* _tmp13_ = NULL;
		gint start_offset = 0;
		gint end_offset = 0;
		FilesFile* _tmp14_;
		FilesAbstractEditableLabel* _tmp18_;
#line 3221 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = editable_widget;
#line 3221 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_editable_label_get_chars (_tmp2_, 0, -1);
#line 3221 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (self->original_name);
#line 3221 "../src/View/AbstractDirectoryView.vala"
		self->original_name = _tmp3_;
#line 3222 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = gtk_tree_path_new_from_string (path_string);
#line 3222 "../src/View/AbstractDirectoryView.vala"
		path = _tmp4_;
#line 3223 "../src/View/AbstractDirectoryView.vala"
		iter = NULL;
#line 3224 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->model;
#line 3224 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = path;
#line 3224 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
#line 3224 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3224 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 3224 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = __vala_GtkTreeIter_copy0 (&_tmp8_);
#line 3224 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp9_;
#line 3225 "../src/View/AbstractDirectoryView.vala"
		file = NULL;
#line 3226 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->model;
#line 3226 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = iter;
#line 3226 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = *_tmp11_;
#line 3226 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp12_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp13_, -1);
#line 3226 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3226 "../src/View/AbstractDirectoryView.vala"
		file = _tmp13_;
#line 3227 "../src/View/AbstractDirectoryView.vala"
		start_offset = 0;
#line 3227 "../src/View/AbstractDirectoryView.vala"
		end_offset = -1;
#line 3229 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = file;
#line 3229 "../src/View/AbstractDirectoryView.vala"
		if (!files_file_is_folder (_tmp14_)) {
#line 17154 "AbstractDirectoryView.c"
			const gchar* _tmp15_;
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
#line 3230 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = self->original_name;
#line 3230 "../src/View/AbstractDirectoryView.vala"
			files_file_utils_get_rename_region (_tmp15_, &_tmp16_, &_tmp17_, FALSE);
#line 3230 "../src/View/AbstractDirectoryView.vala"
			start_offset = _tmp16_;
#line 3230 "../src/View/AbstractDirectoryView.vala"
			end_offset = _tmp17_;
#line 17166 "AbstractDirectoryView.c"
		}
#line 3232 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = editable_widget;
#line 3232 "../src/View/AbstractDirectoryView.vala"
		files_abstract_editable_label_select_region (_tmp18_, start_offset, end_offset);
#line 3220 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3220 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3220 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 17178 "AbstractDirectoryView.c"
	} else {
#line 3234 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3234: Editable widget is null");
#line 3235 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 17184 "AbstractDirectoryView.c"
	}
#line 3218 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (editable_widget);
#line 17188 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_editing_canceled (FilesAbstractDirectoryView* self)
{
	FilesTextRenderer* _tmp0_;
	gchar* _tmp1_;
#line 3239 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3240 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, FALSE);
#line 3241 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_renaming (self, FALSE);
#line 3242 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->name_renderer;
#line 3242 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
#line 3243 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 3243 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 3243 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp1_;
#line 3245 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 3246 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 17216 "AbstractDirectoryView.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 17237 "AbstractDirectoryView.c"
}

static void
____lambda74_ (FilesAbstractDirectoryView* self,
               GObject* obj,
               GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 3277 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 17248 "AbstractDirectoryView.c"
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3279 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_abstract_directory_view_set_file_display_name_finish (self, res, &_inner_error0_);
#line 3279 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_;
#line 3279 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 3279 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17260 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3278 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 17269 "AbstractDirectoryView.c"
	}
	__finally0:
#line 3278 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3278 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3278 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 3278 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17280 "AbstractDirectoryView.c"
	}
#line 3282 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_canceled (self);
#line 17284 "AbstractDirectoryView.c"
}

static void
_____lambda74__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 3277 "../src/View/AbstractDirectoryView.vala"
	____lambda74_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 3277 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 17296 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_edited (FilesAbstractDirectoryView* self,
                                              const gchar* path_string,
                                              const gchar* _new_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* new_name = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 3249 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3249 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path_string != NULL);
#line 3251 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3251 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp1_) {
#line 3251 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 17322 "AbstractDirectoryView.c"
	} else {
#line 3251 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _new_name == NULL;
#line 17326 "AbstractDirectoryView.c"
	}
#line 3251 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3252 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 3253 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17334 "AbstractDirectoryView.c"
	}
#line 3256 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = string_strip (_new_name);
#line 3256 "../src/View/AbstractDirectoryView.vala"
	new_name = _tmp2_;
#line 3257 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = new_name;
#line 3257 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp4_, "") == 0) {
#line 3257 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = TRUE;
#line 17346 "AbstractDirectoryView.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 3257 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->proposed_name;
#line 3257 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = new_name;
#line 3257 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 17356 "AbstractDirectoryView.c"
	}
#line 3257 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 3258 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3258: Blank name or name unchanged");
#line 3259 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 3260 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (new_name);
#line 3260 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17368 "AbstractDirectoryView.c"
	}
#line 3263 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = g_strdup ("");
#line 3263 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 3263 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp7_;
#line 3264 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = new_name;
#line 3264 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp8_, "") != 0) {
#line 17380 "AbstractDirectoryView.c"
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp9_;
		GtkTreeIter* iter = NULL;
		FilesListModel* _tmp10_;
		GtkTreePath* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		GtkTreeIter _tmp13_;
		GtkTreeIter* _tmp14_;
		FilesFile* file = NULL;
		FilesListModel* _tmp15_;
		GtkTreeIter* _tmp16_;
		GtkTreeIter _tmp17_;
		FilesFile* _tmp18_ = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 3265 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = gtk_tree_path_new_from_string (path_string);
#line 3265 "../src/View/AbstractDirectoryView.vala"
		path = _tmp9_;
#line 3266 "../src/View/AbstractDirectoryView.vala"
		iter = NULL;
#line 3267 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->model;
#line 3267 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = path;
#line 3267 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp10_, &_tmp12_, _tmp11_);
#line 3267 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3267 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_;
#line 3267 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = __vala_GtkTreeIter_copy0 (&_tmp13_);
#line 3267 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp14_;
#line 3269 "../src/View/AbstractDirectoryView.vala"
		file = NULL;
#line 3270 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = self->model;
#line 3270 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = iter;
#line 3270 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = *_tmp16_;
#line 3270 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp15_, &_tmp17_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp18_, -1);
#line 3270 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3270 "../src/View/AbstractDirectoryView.vala"
		file = _tmp18_;
#line 3275 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = new_name;
#line 3275 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = self->original_name;
#line 3275 "../src/View/AbstractDirectoryView.vala"
		if (g_strcmp0 (_tmp19_, _tmp20_) != 0) {
#line 17436 "AbstractDirectoryView.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
			FilesFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			const gchar* _tmp26_;
#line 3276 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = new_name;
#line 3276 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 3276 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (self->proposed_name);
#line 3276 "../src/View/AbstractDirectoryView.vala"
			self->proposed_name = _tmp22_;
#line 3277 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = file;
#line 3277 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = files_file_get_location (_tmp23_);
#line 3277 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = _tmp24_;
#line 3277 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = new_name;
#line 3277 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_set_file_display_name (self, _tmp25_, _tmp26_, NULL, _____lambda74__gasync_ready_callback, g_object_ref (self));
#line 17461 "AbstractDirectoryView.c"
		} else {
#line 3285 "../src/View/AbstractDirectoryView.vala"
			g_warning ("AbstractDirectoryView.vala:3285: Name unchanged");
#line 3286 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_on_name_editing_canceled (self);
#line 17467 "AbstractDirectoryView.c"
		}
#line 3264 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3264 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3264 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 17475 "AbstractDirectoryView.c"
	} else {
#line 3289 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3289: No new name");
#line 3290 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 17481 "AbstractDirectoryView.c"
	}
#line 3249 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (new_name);
#line 17485 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_file_display_name_data_free (gpointer _data)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
	_data_ = _data;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_data_->new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->result);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_slice_free (FilesAbstractDirectoryViewSetFileDisplayNameData, _data_);
#line 17505 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_file_display_name (FilesAbstractDirectoryView* self,
                                                     GFile* old_location,
                                                     const gchar* new_name,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
	FilesAbstractDirectoryView* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (old_location != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (new_name != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_ = g_slice_new0 (FilesAbstractDirectoryViewSetFileDisplayNameData);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, files_abstract_directory_view_set_file_display_name_data_free);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->self = _tmp0_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->old_location = _tmp1_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_strdup (new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_data_->new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->new_name = _tmp2_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->cancellable = _tmp3_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_file_display_name_co (_data_);
#line 17557 "AbstractDirectoryView.c"
}

GFile*
files_abstract_directory_view_set_file_display_name_finish (FilesAbstractDirectoryView* self,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	GFile* result;
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/View/AbstractDirectoryView.vala"
	if (NULL == _data_) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		return NULL;
#line 17573 "AbstractDirectoryView.c"
	}
#line 29 "../src/View/AbstractDirectoryView.vala"
	result = _data_->result;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->result = NULL;
#line 29 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17581 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_after_renamed_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                    FilesFile* file,
                                                                                    gboolean is_internal,
                                                                                    gpointer self)
{
#line 3300 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_renamed_file_added ((FilesAbstractDirectoryView*) self, file);
#line 17592 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
	_data_ = _user_data_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
	_data_->_source_object_ = source_object;
#line 3302 "../src/View/AbstractDirectoryView.vala"
	_data_->_res_ = _res_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_file_display_name_co (_data_);
#line 17609 "AbstractDirectoryView.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 3304 "../src/View/AbstractDirectoryView.vala"
	return self ? g_error_copy (self) : NULL;
#line 17617 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_set_file_display_name_co (FilesAbstractDirectoryViewSetFileDisplayNameData* _data_)
{
#line 3296 "../src/View/AbstractDirectoryView.vala"
	switch (_data_->_state_) {
#line 3296 "../src/View/AbstractDirectoryView.vala"
		case 0:
#line 17627 "AbstractDirectoryView.c"
		goto _state_0;
#line 3296 "../src/View/AbstractDirectoryView.vala"
		case 1:
#line 17631 "AbstractDirectoryView.c"
		goto _state_1;
		default:
#line 3296 "../src/View/AbstractDirectoryView.vala"
		g_assert_not_reached ();
#line 17636 "AbstractDirectoryView.c"
	}
	_state_0:
#line 3300 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp0_ = _data_->self->slot;
#line 3300 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _data_->_tmp0_);
#line 3300 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 3300 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_data_->_tmp2_, "file-added", (GCallback) _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added, _data_->self, G_CONNECT_AFTER);
#line 17647 "AbstractDirectoryView.c"
	{
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->_state_ = 1;
#line 3302 "../src/View/AbstractDirectoryView.vala"
		files_file_utils_set_file_display_name (_data_->old_location, _data_->new_name, _data_->cancellable, files_abstract_directory_view_set_file_display_name_ready, _data_);
#line 3302 "../src/View/AbstractDirectoryView.vala"
		return FALSE;
#line 17655 "AbstractDirectoryView.c"
		_state_1:
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp4_ = files_file_utils_set_file_display_name_finish (_data_->_res_, &_data_->_inner_error0_);
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp3_ = _data_->_tmp4_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 17663 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp5_ = _data_->_tmp3_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp3_ = NULL;
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_data_->result = _data_->_tmp5_;
#line 3302 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 3302 "../src/View/AbstractDirectoryView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 3302 "../src/View/AbstractDirectoryView.vala"
		if (_data_->_state_ != 0) {
#line 3302 "../src/View/AbstractDirectoryView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 3302 "../src/View/AbstractDirectoryView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 17682 "AbstractDirectoryView.c"
			}
		}
#line 3302 "../src/View/AbstractDirectoryView.vala"
		g_object_unref (_data_->_async_result);
#line 3302 "../src/View/AbstractDirectoryView.vala"
		return FALSE;
#line 17689 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3301 "../src/View/AbstractDirectoryView.vala"
		_data_->e = _data_->_inner_error0_;
#line 3301 "../src/View/AbstractDirectoryView.vala"
		_data_->_inner_error0_ = NULL;
#line 3304 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp6_ = _data_->e;
#line 3304 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 3304 "../src/View/AbstractDirectoryView.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 3304 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (_data_->e);
#line 17706 "AbstractDirectoryView.c"
		goto __finally0;
	}
	__finally0:
#line 3301 "../src/View/AbstractDirectoryView.vala"
	g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 3301 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (_data_->_async_result);
#line 3301 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 17716 "AbstractDirectoryView.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 3308 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	return _data33_;
#line 17726 "AbstractDirectoryView.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 3308 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 17736 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3308 "../src/View/AbstractDirectoryView.vala"
		self = _data33_->self;
#line 3308 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data33_->new_file);
#line 3308 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3308 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block33Data, _data33_);
#line 17746 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda73_ (Block33Data* _data33_)
{
	FilesAbstractDirectoryView* self;
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 3313 "../src/View/AbstractDirectoryView.vala"
	self = _data33_->self;
#line 3314 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 3314 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_sort_pending (_tmp0_);
#line 3314 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 3314 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 3315 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 3315 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 17772 "AbstractDirectoryView.c"
	} else {
#line 3317 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_and_scroll_to_gof_file (self, _data33_->new_file);
#line 3318 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 3318 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 17780 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda73__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda73_ (self);
#line 3313 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17791 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_after_renamed_file_added (FilesAbstractDirectoryView* self,
                                                        FilesFile* new_file)
{
	Block33Data* _data33_;
	FilesFile* _tmp0_;
	FilesViewSlot* _tmp1_;
	FilesDirectory* _tmp2_;
	FilesDirectory* _tmp3_;
	guint _tmp4_;
#line 3308 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_data33_->_ref_count_ = 1;
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_data33_->self = g_object_ref (self);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (new_file);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data33_->new_file);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_data33_->new_file = _tmp0_;
#line 3309 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->slot;
#line 3309 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp1_);
#line 3309 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 3309 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp4_, NULL, FALSE);
#line 3309 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added, self);
#line 3311 "../src/View/AbstractDirectoryView.vala"
	if (_data33_->new_file != NULL) {
#line 3312 "../src/View/AbstractDirectoryView.vala"
		self->priv->selected_files_invalid = TRUE;
#line 3313 "../src/View/AbstractDirectoryView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda73__gsource_func, block33_data_ref (_data33_), block33_data_unref);
#line 17834 "AbstractDirectoryView.c"
	}
#line 3308 "../src/View/AbstractDirectoryView.vala"
	block33_data_unref (_data33_);
#line 3308 "../src/View/AbstractDirectoryView.vala"
	_data33_ = NULL;
#line 17840 "AbstractDirectoryView.c"
}

static PangoRectangle*
_pango_rectangle_dup (PangoRectangle* self)
{
	PangoRectangle* dup;
#line 3339 "../src/View/AbstractDirectoryView.vala"
	dup = g_new0 (PangoRectangle, 1);
#line 3339 "../src/View/AbstractDirectoryView.vala"
	memcpy (dup, self, sizeof (PangoRectangle));
#line 3339 "../src/View/AbstractDirectoryView.vala"
	return dup;
#line 17853 "AbstractDirectoryView.c"
}

static gpointer
__pango_rectangle_dup0 (gpointer self)
{
#line 3339 "../src/View/AbstractDirectoryView.vala"
	return self ? _pango_rectangle_dup (self) : NULL;
#line 17861 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_view_draw (FilesAbstractDirectoryView* self,
                                                 cairo_t* cr)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	FilesViewSlot* _tmp2_;
	FilesDirectory* _tmp3_;
	FilesDirectory* _tmp4_;
	gboolean result;
#line 3324 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 3327 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 3327 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 3327 "../src/View/AbstractDirectoryView.vala"
	style_context = _tmp1_;
#line 3328 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->slot;
#line 3328 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp2_);
#line 3328 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 3328 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_empty (_tmp4_)) {
#line 17891 "AbstractDirectoryView.c"
		PangoLayout* layout = NULL;
		PangoLayout* _tmp5_;
		GtkStyleContext* _tmp6_;
		PangoLayout* _tmp9_;
		FilesViewSlot* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PangoRectangle* extents = NULL;
		PangoLayout* _tmp13_;
		PangoRectangle _tmp14_ = {0};
		PangoRectangle _tmp15_;
		PangoRectangle* _tmp16_;
		gdouble width = 0.0;
		PangoRectangle* _tmp17_;
		gdouble height = 0.0;
		PangoRectangle* _tmp18_;
		gdouble x = 0.0;
		gdouble y = 0.0;
		GtkStyleContext* _tmp19_;
		PangoLayout* _tmp20_;
#line 3329 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
#line 3329 "../src/View/AbstractDirectoryView.vala"
		layout = _tmp5_;
#line 3331 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = style_context;
#line 3331 "../src/View/AbstractDirectoryView.vala"
		if (!gtk_style_context_has_class (_tmp6_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 17920 "AbstractDirectoryView.c"
			GtkStyleContext* _tmp7_;
			GtkStyleContext* _tmp8_;
#line 3332 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = style_context;
#line 3332 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 3333 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = style_context;
#line 3333 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_VIEW);
#line 17931 "AbstractDirectoryView.c"
		}
#line 3336 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = layout;
#line 3336 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->slot;
#line 3336 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_view_slot_get_empty_message (_tmp10_);
#line 3336 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = _tmp11_;
#line 3336 "../src/View/AbstractDirectoryView.vala"
		pango_layout_set_markup (_tmp9_, _tmp12_, -1);
#line 3336 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp12_);
#line 3338 "../src/View/AbstractDirectoryView.vala"
		extents = NULL;
#line 3339 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = layout;
#line 3339 "../src/View/AbstractDirectoryView.vala"
		pango_layout_get_extents (_tmp13_, NULL, &_tmp14_);
#line 3339 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (extents);
#line 3339 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = _tmp14_;
#line 3339 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = __pango_rectangle_dup0 (&_tmp15_);
#line 3339 "../src/View/AbstractDirectoryView.vala"
		extents = _tmp16_;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = extents;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		width = pango_units_to_double ((*_tmp17_).width);
#line 3342 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = extents;
#line 3342 "../src/View/AbstractDirectoryView.vala"
		height = pango_units_to_double ((*_tmp18_).height);
#line 3344 "../src/View/AbstractDirectoryView.vala"
		x = (((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / 2) - (width / 2);
#line 3345 "../src/View/AbstractDirectoryView.vala"
		y = (((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / 2) - (height / 2);
#line 3346 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 3346 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = layout;
#line 3346 "../src/View/AbstractDirectoryView.vala"
		gtk_render_layout (_tmp19_, cr, x, y, _tmp20_);
#line 3348 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3348 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (extents);
#line 3348 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (layout);
#line 3348 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (style_context);
#line 3348 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 17987 "AbstractDirectoryView.c"
	} else {
		GtkStyleContext* _tmp21_;
#line 3349 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = style_context;
#line 3349 "../src/View/AbstractDirectoryView.vala"
		if (gtk_style_context_has_class (_tmp21_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 17994 "AbstractDirectoryView.c"
			GtkStyleContext* _tmp22_;
			GtkStyleContext* _tmp23_;
#line 3350 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = style_context;
#line 3350 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_remove_class (_tmp22_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 3351 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = style_context;
#line 3351 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_remove_class (_tmp23_, GTK_STYLE_CLASS_VIEW);
#line 18005 "AbstractDirectoryView.c"
		}
	}
#line 3354 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3354 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (style_context);
#line 3354 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18014 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_draw (FilesAbstractDirectoryView* self,
                                            cairo_t* cr)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3324 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3324 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3324 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_draw) {
#line 3324 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_draw (self, cr);
#line 18030 "AbstractDirectoryView.c"
	}
#line 3324 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18034 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                guint n_press,
                                                                GdkModifierType mods,
                                                                GtkTreePath* path)
{
	gboolean result;
#line 3358 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3358 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18048 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                           guint n_press,
                                                           GdkModifierType mods,
                                                           GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3357 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3357 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3357 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_primary_button_click) {
#line 3357 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_primary_button_click (self, n_press, mods, path);
#line 18066 "AbstractDirectoryView.c"
	}
#line 3357 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18070 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_block_drag_and_drop (FilesAbstractDirectoryView* self)
{
#line 3361 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3362 "../src/View/AbstractDirectoryView.vala"
	if (!self->dnd_disabled) {
#line 18080 "AbstractDirectoryView.c"
		GtkWidget* _tmp0_;
		gconstpointer _tmp1_;
		GtkWidget* _tmp2_;
		void* _tmp3_;
#line 3363 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->view;
#line 3363 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_object_get_data ((GObject*) _tmp0_, "gtk-site-data");
#line 3363 "../src/View/AbstractDirectoryView.vala"
		self->priv->drag_data = _tmp1_;
#line 3364 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->priv->view;
#line 3364 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->priv->drag_data;
#line 3364 "../src/View/AbstractDirectoryView.vala"
		g_signal_handlers_block_matched (_tmp2_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp3_);
#line 3365 "../src/View/AbstractDirectoryView.vala"
		self->dnd_disabled = TRUE;
#line 18099 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_unblock_drag_and_drop (FilesAbstractDirectoryView* self)
{
#line 3369 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3370 "../src/View/AbstractDirectoryView.vala"
	if (self->dnd_disabled) {
#line 18110 "AbstractDirectoryView.c"
		GtkWidget* _tmp0_;
		void* _tmp1_;
#line 3371 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->view;
#line 3371 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->priv->drag_data;
#line 3371 "../src/View/AbstractDirectoryView.vala"
		g_signal_handlers_unblock_matched (_tmp0_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp1_);
#line 3372 "../src/View/AbstractDirectoryView.vala"
		self->dnd_disabled = FALSE;
#line 18121 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y)
{
	gboolean _tmp0_;
	GtkTreePath* path = NULL;
	guint button = 0U;
	GtkGestureMultiPress* _tmp2_;
	GdkModifierType state = 0U;
	GdkModifierType _tmp3_ = 0U;
	GtkTreePath* _tmp4_ = NULL;
	guint _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreePath* _tmp7_;
	GdkModifierType mods = 0U;
	gboolean no_mods = FALSE;
	gboolean control_pressed = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean _tmp11_ = FALSE;
	GtkTreePath* _tmp12_;
	gboolean path_selected = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean on_blank = FALSE;
	gboolean double_click_event = FALSE;
#line 3377 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_renaming;
#line 3377 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 18161 "AbstractDirectoryView.c"
		FilesTextRenderer* _tmp1_;
#line 3379 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->name_renderer;
#line 3379 "../src/View/AbstractDirectoryView.vala"
		files_text_renderer_end_editing (_tmp1_, FALSE);
#line 18167 "AbstractDirectoryView.c"
	}
#line 3381 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 3382 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 3384 "../src/View/AbstractDirectoryView.vala"
	path = NULL;
#line 3386 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_x = x;
#line 3387 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_y = y;
#line 3388 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->button_controller;
#line 3388 "../src/View/AbstractDirectoryView.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp2_);
#line 3390 "../src/View/AbstractDirectoryView.vala"
	gtk_get_current_event_state (&_tmp3_);
#line 3390 "../src/View/AbstractDirectoryView.vala"
	state = _tmp3_;
#line 3393 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_directory_view_get_event_position_info (self, x, y, &_tmp4_, button == ((guint) GDK_BUTTON_PRIMARY));
#line 3393 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3393 "../src/View/AbstractDirectoryView.vala"
	path = _tmp4_;
#line 3393 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = _tmp5_;
#line 3394 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = path;
#line 3394 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = __vala_GtkTreePath_copy0 (_tmp6_);
#line 3394 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 3394 "../src/View/AbstractDirectoryView.vala"
	self->click_path = _tmp7_;
#line 3395 "../src/View/AbstractDirectoryView.vala"
	mods = state & gtk_accelerator_get_default_mod_mask ();
#line 3396 "../src/View/AbstractDirectoryView.vala"
	no_mods = mods == 0;
#line 3397 "../src/View/AbstractDirectoryView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 3398 "../src/View/AbstractDirectoryView.vala"
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
#line 3399 "../src/View/AbstractDirectoryView.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 3400 "../src/View/AbstractDirectoryView.vala"
	if (control_pressed) {
#line 3400 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = !other_mod_pressed;
#line 18217 "AbstractDirectoryView.c"
	} else {
#line 3400 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = FALSE;
#line 18221 "AbstractDirectoryView.c"
	}
#line 3400 "../src/View/AbstractDirectoryView.vala"
	only_control_pressed = _tmp8_;
#line 3401 "../src/View/AbstractDirectoryView.vala"
	if (shift_pressed) {
#line 3401 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = !control_pressed;
#line 18229 "AbstractDirectoryView.c"
	} else {
#line 3401 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = FALSE;
#line 18233 "AbstractDirectoryView.c"
	}
#line 3401 "../src/View/AbstractDirectoryView.vala"
	if (_tmp10_) {
#line 3401 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = !other_mod_pressed;
#line 18239 "AbstractDirectoryView.c"
	} else {
#line 3401 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = FALSE;
#line 18243 "AbstractDirectoryView.c"
	}
#line 3401 "../src/View/AbstractDirectoryView.vala"
	only_shift_pressed = _tmp9_;
#line 3402 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = path;
#line 3402 "../src/View/AbstractDirectoryView.vala"
	if (_tmp12_ != NULL) {
#line 18251 "AbstractDirectoryView.c"
		GtkTreePath* _tmp13_;
#line 3402 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = path;
#line 3402 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_abstract_directory_view_path_is_selected (self, _tmp13_);
#line 18257 "AbstractDirectoryView.c"
	} else {
#line 3402 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = FALSE;
#line 18261 "AbstractDirectoryView.c"
	}
#line 3402 "../src/View/AbstractDirectoryView.vala"
	path_selected = _tmp11_;
#line 3403 "../src/View/AbstractDirectoryView.vala"
	if (self->click_zone == ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH)) {
#line 3403 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = TRUE;
#line 18269 "AbstractDirectoryView.c"
	} else {
#line 3403 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = self->click_zone == ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH);
#line 18273 "AbstractDirectoryView.c"
	}
#line 3403 "../src/View/AbstractDirectoryView.vala"
	on_blank = _tmp14_;
#line 3404 "../src/View/AbstractDirectoryView.vala"
	double_click_event = n_press == 2;
#line 3408 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_block_drag_and_drop (self);
#line 3410 "../src/View/AbstractDirectoryView.vala"
	if (!files_abstract_directory_view_will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed)) {
#line 3411 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 3411 "../src/View/AbstractDirectoryView.vala"
		return;
#line 18287 "AbstractDirectoryView.c"
	}
#line 3414 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 3415 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 3416 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 3419 "../src/View/AbstractDirectoryView.vala"
	switch (button) {
#line 3419 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_PRIMARY:
#line 18299 "AbstractDirectoryView.c"
		{
#line 3421 "../src/View/AbstractDirectoryView.vala"
			switch (self->click_zone) {
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH:
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID:
#line 18307 "AbstractDirectoryView.c"
				{
#line 3426 "../src/View/AbstractDirectoryView.vala"
					if (no_mods) {
#line 3427 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 18313 "AbstractDirectoryView.c"
					}
#line 3430 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18317 "AbstractDirectoryView.c"
				}
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH:
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 18325 "AbstractDirectoryView.c"
				{
					gboolean _tmp15_ = FALSE;
					gboolean _tmp16_ = FALSE;
					gboolean _tmp21_ = FALSE;
#line 3437 "../src/View/AbstractDirectoryView.vala"
					if (only_control_pressed) {
#line 3437 "../src/View/AbstractDirectoryView.vala"
						_tmp15_ = path_selected;
#line 18334 "AbstractDirectoryView.c"
					} else {
#line 3437 "../src/View/AbstractDirectoryView.vala"
						_tmp15_ = FALSE;
#line 18338 "AbstractDirectoryView.c"
					}
#line 3437 "../src/View/AbstractDirectoryView.vala"
					self->should_deselect = _tmp15_;
#line 3441 "../src/View/AbstractDirectoryView.vala"
					if (no_mods) {
#line 3441 "../src/View/AbstractDirectoryView.vala"
						_tmp16_ = self->one_or_less;
#line 18346 "AbstractDirectoryView.c"
					} else {
#line 3441 "../src/View/AbstractDirectoryView.vala"
						_tmp16_ = FALSE;
#line 18350 "AbstractDirectoryView.c"
					}
#line 3441 "../src/View/AbstractDirectoryView.vala"
					if (_tmp16_) {
#line 18354 "AbstractDirectoryView.c"
						gboolean _tmp17_ = FALSE;
						gboolean _tmp18_ = FALSE;
						gboolean _tmp19_ = FALSE;
#line 3442 "../src/View/AbstractDirectoryView.vala"
						if (self->on_directory) {
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp19_ = !on_blank;
#line 18362 "AbstractDirectoryView.c"
						} else {
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp19_ = FALSE;
#line 18366 "AbstractDirectoryView.c"
						}
#line 3442 "../src/View/AbstractDirectoryView.vala"
						if (_tmp19_) {
#line 18370 "AbstractDirectoryView.c"
							gboolean _tmp20_;
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp20_ = self->priv->_singleclick_select;
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp18_ = !_tmp20_;
#line 18376 "AbstractDirectoryView.c"
						} else {
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp18_ = FALSE;
#line 18380 "AbstractDirectoryView.c"
						}
#line 3442 "../src/View/AbstractDirectoryView.vala"
						if (_tmp18_) {
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp17_ = TRUE;
#line 18386 "AbstractDirectoryView.c"
						} else {
#line 3442 "../src/View/AbstractDirectoryView.vala"
							_tmp17_ = double_click_event;
#line 18390 "AbstractDirectoryView.c"
						}
#line 3442 "../src/View/AbstractDirectoryView.vala"
						self->should_activate = _tmp17_;
#line 18394 "AbstractDirectoryView.c"
					}
#line 3448 "../src/View/AbstractDirectoryView.vala"
					if (!no_mods) {
#line 3448 "../src/View/AbstractDirectoryView.vala"
						_tmp21_ = TRUE;
#line 18400 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp22_ = FALSE;
#line 3448 "../src/View/AbstractDirectoryView.vala"
						if (on_blank) {
#line 3448 "../src/View/AbstractDirectoryView.vala"
							_tmp22_ = !path_selected;
#line 18407 "AbstractDirectoryView.c"
						} else {
#line 3448 "../src/View/AbstractDirectoryView.vala"
							_tmp22_ = FALSE;
#line 18411 "AbstractDirectoryView.c"
						}
#line 3448 "../src/View/AbstractDirectoryView.vala"
						_tmp21_ = _tmp22_;
#line 18415 "AbstractDirectoryView.c"
					}
#line 3448 "../src/View/AbstractDirectoryView.vala"
					if (_tmp21_) {
#line 18419 "AbstractDirectoryView.c"
						gboolean _tmp23_ = FALSE;
#line 3449 "../src/View/AbstractDirectoryView.vala"
						if (only_shift_pressed) {
#line 18423 "AbstractDirectoryView.c"
							GtkTreePath* _tmp24_;
#line 3449 "../src/View/AbstractDirectoryView.vala"
							_tmp24_ = path;
#line 3449 "../src/View/AbstractDirectoryView.vala"
							_tmp23_ = files_abstract_directory_view_handle_multi_select (self, _tmp24_);
#line 18429 "AbstractDirectoryView.c"
						} else {
#line 3449 "../src/View/AbstractDirectoryView.vala"
							_tmp23_ = FALSE;
#line 18433 "AbstractDirectoryView.c"
						}
#line 3449 "../src/View/AbstractDirectoryView.vala"
						if (_tmp23_) {
#line 18437 "AbstractDirectoryView.c"
							GtkGestureMultiPress* _tmp25_;
#line 3450 "../src/View/AbstractDirectoryView.vala"
							_tmp25_ = self->button_controller;
#line 3450 "../src/View/AbstractDirectoryView.vala"
							gtk_gesture_set_state ((GtkGesture*) _tmp25_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 18443 "AbstractDirectoryView.c"
						}
#line 3454 "../src/View/AbstractDirectoryView.vala"
						self->should_select = TRUE;
#line 18447 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GtkTreePath* _tmp27_;
						GtkTreePath* _tmp28_;
#line 3456 "../src/View/AbstractDirectoryView.vala"
						if (no_mods) {
#line 3456 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = !path_selected;
#line 18456 "AbstractDirectoryView.c"
						} else {
#line 3456 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = FALSE;
#line 18460 "AbstractDirectoryView.c"
						}
#line 3456 "../src/View/AbstractDirectoryView.vala"
						if (_tmp26_) {
#line 3457 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_unselect_all (self);
#line 18466 "AbstractDirectoryView.c"
						}
#line 3460 "../src/View/AbstractDirectoryView.vala"
						_tmp27_ = path;
#line 3460 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_select_path (self, _tmp27_, TRUE);
#line 3462 "../src/View/AbstractDirectoryView.vala"
						_tmp28_ = path;
#line 3462 "../src/View/AbstractDirectoryView.vala"
						if (files_abstract_directory_view_handle_primary_button_click (self, (guint) n_press, mods, _tmp28_)) {
#line 18476 "AbstractDirectoryView.c"
							GtkGestureMultiPress* _tmp29_;
#line 3463 "../src/View/AbstractDirectoryView.vala"
							_tmp29_ = self->button_controller;
#line 3463 "../src/View/AbstractDirectoryView.vala"
							gtk_gesture_set_state ((GtkGesture*) _tmp29_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 18482 "AbstractDirectoryView.c"
						}
#line 3466 "../src/View/AbstractDirectoryView.vala"
						self->priv->button_press_disabled = TRUE;
#line 3467 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unblock_drag_and_drop (self);
#line 18488 "AbstractDirectoryView.c"
					}
#line 3470 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3471 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18494 "AbstractDirectoryView.c"
				}
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER:
#line 18498 "AbstractDirectoryView.c"
				{
					gboolean _tmp30_ = FALSE;
#line 3474 "../src/View/AbstractDirectoryView.vala"
					if (only_control_pressed) {
#line 3474 "../src/View/AbstractDirectoryView.vala"
						_tmp30_ = TRUE;
#line 18505 "AbstractDirectoryView.c"
					} else {
#line 3474 "../src/View/AbstractDirectoryView.vala"
						_tmp30_ = only_shift_pressed;
#line 18509 "AbstractDirectoryView.c"
					}
#line 3474 "../src/View/AbstractDirectoryView.vala"
					if (_tmp30_) {
#line 18513 "AbstractDirectoryView.c"
						gboolean _tmp31_ = FALSE;
#line 3475 "../src/View/AbstractDirectoryView.vala"
						if (only_shift_pressed) {
#line 18517 "AbstractDirectoryView.c"
							GtkTreePath* _tmp32_;
#line 3475 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = path;
#line 3475 "../src/View/AbstractDirectoryView.vala"
							_tmp31_ = files_abstract_directory_view_handle_multi_select (self, _tmp32_);
#line 18523 "AbstractDirectoryView.c"
						} else {
#line 3475 "../src/View/AbstractDirectoryView.vala"
							_tmp31_ = FALSE;
#line 18527 "AbstractDirectoryView.c"
						}
#line 3475 "../src/View/AbstractDirectoryView.vala"
						if (_tmp31_) {
#line 18531 "AbstractDirectoryView.c"
							GtkGestureMultiPress* _tmp33_;
#line 3476 "../src/View/AbstractDirectoryView.vala"
							_tmp33_ = self->button_controller;
#line 3476 "../src/View/AbstractDirectoryView.vala"
							gtk_gesture_set_state ((GtkGesture*) _tmp33_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 18537 "AbstractDirectoryView.c"
						}
					} else {
						GtkGestureMultiPress* _tmp35_;
#line 3479 "../src/View/AbstractDirectoryView.vala"
						if (path_selected) {
#line 3481 "../src/View/AbstractDirectoryView.vala"
							self->should_deselect = TRUE;
#line 18545 "AbstractDirectoryView.c"
						} else {
							GtkTreePath* _tmp34_;
#line 3483 "../src/View/AbstractDirectoryView.vala"
							_tmp34_ = path;
#line 3483 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_select_path (self, _tmp34_, TRUE);
#line 18552 "AbstractDirectoryView.c"
						}
#line 3486 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3487 "../src/View/AbstractDirectoryView.vala"
						_tmp35_ = self->button_controller;
#line 3487 "../src/View/AbstractDirectoryView.vala"
						gtk_gesture_set_state ((GtkGesture*) _tmp35_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 18560 "AbstractDirectoryView.c"
					}
#line 3489 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18564 "AbstractDirectoryView.c"
				}
#line 3421 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER:
#line 18568 "AbstractDirectoryView.c"
				{
					GtkTreePath* _tmp36_;
					GtkGestureMultiPress* _tmp37_;
#line 3494 "../src/View/AbstractDirectoryView.vala"
					_tmp36_ = path;
#line 3494 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_expand_collapse (self, _tmp36_);
#line 3495 "../src/View/AbstractDirectoryView.vala"
					_tmp37_ = self->button_controller;
#line 3495 "../src/View/AbstractDirectoryView.vala"
					gtk_gesture_set_state ((GtkGesture*) _tmp37_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 3496 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18582 "AbstractDirectoryView.c"
				}
				default:
				{
#line 3499 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18588 "AbstractDirectoryView.c"
				}
			}
#line 3502 "../src/View/AbstractDirectoryView.vala"
			break;
#line 18593 "AbstractDirectoryView.c"
		}
#line 3419 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_MIDDLE:
#line 18597 "AbstractDirectoryView.c"
		{
			GtkTreePath* _tmp38_;
#line 3505 "../src/View/AbstractDirectoryView.vala"
			_tmp38_ = path;
#line 3505 "../src/View/AbstractDirectoryView.vala"
			if (!files_abstract_directory_view_path_is_selected (self, _tmp38_)) {
#line 18604 "AbstractDirectoryView.c"
				GtkTreePath* _tmp39_;
#line 3506 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = path;
#line 3506 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_select_path (self, _tmp39_, TRUE);
#line 18610 "AbstractDirectoryView.c"
			}
#line 3509 "../src/View/AbstractDirectoryView.vala"
			self->should_activate = TRUE;
#line 3510 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3511 "../src/View/AbstractDirectoryView.vala"
			break;
#line 18618 "AbstractDirectoryView.c"
		}
#line 3419 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_SECONDARY:
#line 18622 "AbstractDirectoryView.c"
		{
			GtkGestureMultiPress* _tmp40_;
#line 3516 "../src/View/AbstractDirectoryView.vala"
			_tmp40_ = self->button_controller;
#line 3516 "../src/View/AbstractDirectoryView.vala"
			gtk_gesture_set_state ((GtkGesture*) _tmp40_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 3518 "../src/View/AbstractDirectoryView.vala"
			switch (self->click_zone) {
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH:
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID:
#line 18635 "AbstractDirectoryView.c"
				{
#line 3521 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_all (self);
#line 3522 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18641 "AbstractDirectoryView.c"
				}
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH:
#line 18645 "AbstractDirectoryView.c"
				{
					gboolean _tmp41_ = FALSE;
#line 3525 "../src/View/AbstractDirectoryView.vala"
					if (!path_selected) {
#line 3525 "../src/View/AbstractDirectoryView.vala"
						_tmp41_ = no_mods;
#line 18652 "AbstractDirectoryView.c"
					} else {
#line 3525 "../src/View/AbstractDirectoryView.vala"
						_tmp41_ = FALSE;
#line 18656 "AbstractDirectoryView.c"
					}
#line 3525 "../src/View/AbstractDirectoryView.vala"
					if (_tmp41_) {
#line 3526 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 18662 "AbstractDirectoryView.c"
					}
#line 3529 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18666 "AbstractDirectoryView.c"
				}
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3518 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER:
#line 18674 "AbstractDirectoryView.c"
				{
					gboolean _tmp42_ = FALSE;
					GtkTreePath* _tmp43_;
#line 3534 "../src/View/AbstractDirectoryView.vala"
					if (!path_selected) {
#line 3534 "../src/View/AbstractDirectoryView.vala"
						_tmp42_ = no_mods;
#line 18682 "AbstractDirectoryView.c"
					} else {
#line 3534 "../src/View/AbstractDirectoryView.vala"
						_tmp42_ = FALSE;
#line 18686 "AbstractDirectoryView.c"
					}
#line 3534 "../src/View/AbstractDirectoryView.vala"
					if (_tmp42_) {
#line 3535 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 18692 "AbstractDirectoryView.c"
					}
#line 3538 "../src/View/AbstractDirectoryView.vala"
					_tmp43_ = path;
#line 3538 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp43_, FALSE);
#line 3539 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18700 "AbstractDirectoryView.c"
				}
				default:
				{
#line 3542 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18706 "AbstractDirectoryView.c"
				}
			}
#line 3546 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3547 "../src/View/AbstractDirectoryView.vala"
			break;
#line 18713 "AbstractDirectoryView.c"
		}
		default:
		{
#line 3550 "../src/View/AbstractDirectoryView.vala"
			if (files_abstract_directory_view_handle_default_button_click (self)) {
#line 18719 "AbstractDirectoryView.c"
				GtkGestureMultiPress* _tmp44_;
#line 3551 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = self->button_controller;
#line 3551 "../src/View/AbstractDirectoryView.vala"
				gtk_gesture_set_state ((GtkGesture*) _tmp44_, GTK_EVENT_SEQUENCE_CLAIMED);
#line 18725 "AbstractDirectoryView.c"
			}
#line 3553 "../src/View/AbstractDirectoryView.vala"
			break;
#line 18729 "AbstractDirectoryView.c"
		}
	}
#line 3376 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 18734 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                          gint n_press,
                                                          gdouble x,
                                                          gdouble y)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3376 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3376 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3376 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_button_press_event) {
#line 3376 "../src/View/AbstractDirectoryView.vala"
		_klass_->on_view_button_press_event (self, n_press, x, y);
#line 18752 "AbstractDirectoryView.c"
	}
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
#line 3557 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data34_->_ref_count_);
#line 3557 "../src/View/AbstractDirectoryView.vala"
	return _data34_;
#line 18763 "AbstractDirectoryView.c"
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
#line 3557 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
#line 18773 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3557 "../src/View/AbstractDirectoryView.vala"
		self = _data34_->self;
#line 3557 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3557 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block34Data, _data34_);
#line 18781 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda133_ (Block34Data* _data34_)
{
	FilesAbstractDirectoryView* self;
	FilesOpenFlag _tmp0_ = 0;
	FilesOpenFlag flag = 0;
	GList* _tmp1_;
	gboolean result;
#line 3575 "../src/View/AbstractDirectoryView.vala"
	self = _data34_->self;
#line 3576 "../src/View/AbstractDirectoryView.vala"
	if (_data34_->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 3576 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FILES_OPEN_FLAG_NEW_TAB;
#line 18799 "AbstractDirectoryView.c"
	} else {
#line 3576 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FILES_OPEN_FLAG_DEFAULT;
#line 18803 "AbstractDirectoryView.c"
	}
#line 3576 "../src/View/AbstractDirectoryView.vala"
	flag = _tmp0_;
#line 3577 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files (self);
#line 3577 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, flag, _tmp1_);
#line 3578 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3578 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18815 "AbstractDirectoryView.c"
}

static gboolean
_____lambda133__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda133_ (self);
#line 3575 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18825 "AbstractDirectoryView.c"
}

static gboolean
__lambda134_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 3592 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3593 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3593 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18838 "AbstractDirectoryView.c"
}

static gboolean
___lambda134__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda134_ ((FilesAbstractDirectoryView*) self);
#line 3591 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18848 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y)
{
	Block34Data* _data34_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkGestureMultiPress* _tmp2_;
	FilesViewSlot* _tmp3_;
	GtkWidget* _tmp4_;
#line 3557 "../src/View/AbstractDirectoryView.vala"
	_data34_ = g_slice_new0 (Block34Data);
#line 3557 "../src/View/AbstractDirectoryView.vala"
	_data34_->_ref_count_ = 1;
#line 3557 "../src/View/AbstractDirectoryView.vala"
	_data34_->self = g_object_ref (self);
#line 3558 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3559 "../src/View/AbstractDirectoryView.vala"
	self->priv->button_press_disabled = FALSE;
#line 3564 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3564 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3564 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 18879 "AbstractDirectoryView.c"
	} else {
#line 3564 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !files_abstract_directory_view_view_has_focus (self);
#line 18883 "AbstractDirectoryView.c"
	}
#line 3564 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3565 "../src/View/AbstractDirectoryView.vala"
		block34_data_unref (_data34_);
#line 3565 "../src/View/AbstractDirectoryView.vala"
		_data34_ = NULL;
#line 3565 "../src/View/AbstractDirectoryView.vala"
		return;
#line 18893 "AbstractDirectoryView.c"
	}
#line 3568 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->button_controller;
#line 3568 "../src/View/AbstractDirectoryView.vala"
	_data34_->button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp2_);
#line 3569 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->slot;
#line 3569 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name ((FilesAbstractSlot*) _tmp3_, "active", _data34_->button == ((guint) GDK_BUTTON_SECONDARY), TRUE);
#line 3572 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = gtk_bin_get_child ((GtkBin*) self);
#line 3572 "../src/View/AbstractDirectoryView.vala"
	if (!gtk_drag_check_threshold (_tmp4_, (gint) self->priv->drag_x, (gint) self->priv->drag_y, (gint) x, (gint) y)) {
#line 3573 "../src/View/AbstractDirectoryView.vala"
		if (self->should_activate) {
#line 3575 "../src/View/AbstractDirectoryView.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda133__gsource_func, block34_data_ref (_data34_), block34_data_unref);
#line 18911 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 3580 "../src/View/AbstractDirectoryView.vala"
			if (self->should_deselect) {
#line 18916 "AbstractDirectoryView.c"
				GtkTreePath* _tmp6_;
#line 3580 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = self->click_path;
#line 3580 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp6_ != NULL;
#line 18922 "AbstractDirectoryView.c"
			} else {
#line 3580 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = FALSE;
#line 18926 "AbstractDirectoryView.c"
			}
#line 3580 "../src/View/AbstractDirectoryView.vala"
			if (_tmp5_) {
#line 18930 "AbstractDirectoryView.c"
				GtkTreePath* _tmp7_;
#line 3581 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = self->click_path;
#line 3581 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_unselect_path (self, _tmp7_);
#line 18936 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp8_ = FALSE;
#line 3582 "../src/View/AbstractDirectoryView.vala"
				if (self->should_select) {
#line 18941 "AbstractDirectoryView.c"
					GtkTreePath* _tmp9_;
#line 3582 "../src/View/AbstractDirectoryView.vala"
					_tmp9_ = self->click_path;
#line 3582 "../src/View/AbstractDirectoryView.vala"
					_tmp8_ = _tmp9_ != NULL;
#line 18947 "AbstractDirectoryView.c"
				} else {
#line 3582 "../src/View/AbstractDirectoryView.vala"
					_tmp8_ = FALSE;
#line 18951 "AbstractDirectoryView.c"
				}
#line 3582 "../src/View/AbstractDirectoryView.vala"
				if (_tmp8_) {
#line 18955 "AbstractDirectoryView.c"
					GtkTreePath* _tmp10_;
#line 3583 "../src/View/AbstractDirectoryView.vala"
					_tmp10_ = self->click_path;
#line 3583 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp10_, FALSE);
#line 18961 "AbstractDirectoryView.c"
				} else {
#line 3584 "../src/View/AbstractDirectoryView.vala"
					if (_data34_->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 3585 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_on_popup_menu (self);
#line 18967 "AbstractDirectoryView.c"
					}
				}
			}
		}
	}
#line 3591 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda134__gsource_func, g_object_ref (self), g_object_unref);
#line 3596 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 3597 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 3598 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 3599 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 3599 "../src/View/AbstractDirectoryView.vala"
	self->click_path = NULL;
#line 3600 "../src/View/AbstractDirectoryView.vala"
	block34_data_unref (_data34_);
#line 3600 "../src/View/AbstractDirectoryView.vala"
	_data34_ = NULL;
#line 3600 "../src/View/AbstractDirectoryView.vala"
	return;
#line 18991 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3557 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3557 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3557 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_button_release_event) {
#line 3557 "../src/View/AbstractDirectoryView.vala"
		_klass_->on_view_button_release_event (self, n_press, x, y);
#line 19009 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_change_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesIconRenderer* _tmp0_;
	FilesZoomLevel _tmp1_;
	FilesZoomLevel _tmp2_;
	FilesTextRenderer* _tmp3_;
	FilesZoomLevel _tmp4_;
	FilesZoomLevel _tmp5_;
	GtkWidget* _tmp6_;
#line 3604 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->icon_renderer;
#line 3604 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_zoom_level (self);
#line 3604 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 3604 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_zoom_level (_tmp0_, _tmp2_);
#line 3605 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->name_renderer;
#line 3605 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_abstract_directory_view_get_zoom_level (self);
#line 3605 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 3605 "../src/View/AbstractDirectoryView.vala"
	files_text_renderer_set_zoom_level (_tmp3_, _tmp5_);
#line 3606 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->priv->view;
#line 3606 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name (_tmp6_, "style-updated");
#line 19043 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_change_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3603 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3603 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3603 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->change_zoom_level) {
#line 3603 "../src/View/AbstractDirectoryView.vala"
		_klass_->change_zoom_level (self);
#line 19058 "AbstractDirectoryView.c"
	}
}

static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
#line 3609 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data35_->_ref_count_);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	return _data35_;
#line 19069 "AbstractDirectoryView.c"
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
#line 3609 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
#line 19079 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3609 "../src/View/AbstractDirectoryView.vala"
		self = _data35_->self;
#line 3609 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data35_->start_path);
#line 3609 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data35_->path);
#line 3609 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3609 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block35Data, _data35_);
#line 19091 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda106_ (Block35Data* _data35_)
{
	FilesAbstractDirectoryView* self;
	GtkTreePath* start = NULL;
	GtkTreePath* end = NULL;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	guint _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkTreePath* _tmp4_;
	FilesTextRenderer* _tmp10_;
	GtkTreePath* _tmp11_;
	FilesTextRenderer* _tmp12_;
	gboolean result;
#line 3632 "../src/View/AbstractDirectoryView.vala"
	self = _data35_->self;
#line 3636 "../src/View/AbstractDirectoryView.vala"
	start = NULL;
#line 3637 "../src/View/AbstractDirectoryView.vala"
	end = NULL;
#line 3638 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
#line 3638 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start);
#line 3638 "../src/View/AbstractDirectoryView.vala"
	start = _tmp0_;
#line 3638 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end);
#line 3638 "../src/View/AbstractDirectoryView.vala"
	end = _tmp1_;
#line 3639 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _data35_->count;
#line 3639 "../src/View/AbstractDirectoryView.vala"
	_data35_->count = _tmp2_ + 1;
#line 3641 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _data35_->start_path;
#line 3641 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ == NULL) {
#line 3641 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = TRUE;
#line 19136 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 3641 "../src/View/AbstractDirectoryView.vala"
		if (_data35_->count < ((guint) 20)) {
#line 19141 "AbstractDirectoryView.c"
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
#line 3641 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = start;
#line 3641 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = _data35_->start_path;
#line 3641 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = gtk_tree_path_compare (_tmp6_, _tmp7_) != 0;
#line 19150 "AbstractDirectoryView.c"
		} else {
#line 3641 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = FALSE;
#line 19154 "AbstractDirectoryView.c"
		}
#line 3641 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp5_;
#line 19158 "AbstractDirectoryView.c"
	}
#line 3641 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 19162 "AbstractDirectoryView.c"
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
#line 3642 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = start;
#line 3642 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = __vala_GtkTreePath_copy0 (_tmp8_);
#line 3642 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data35_->start_path);
#line 3642 "../src/View/AbstractDirectoryView.vala"
		_data35_->start_path = _tmp9_;
#line 3643 "../src/View/AbstractDirectoryView.vala"
		_data35_->ok_next_time = FALSE;
#line 3644 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 3644 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (end);
#line 3644 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (start);
#line 3644 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 19183 "AbstractDirectoryView.c"
	} else {
#line 3645 "../src/View/AbstractDirectoryView.vala"
		if (!_data35_->ok_next_time) {
#line 3646 "../src/View/AbstractDirectoryView.vala"
			_data35_->ok_next_time = TRUE;
#line 3647 "../src/View/AbstractDirectoryView.vala"
			result = G_SOURCE_CONTINUE;
#line 3647 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (end);
#line 3647 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (start);
#line 3647 "../src/View/AbstractDirectoryView.vala"
			return result;
#line 19197 "AbstractDirectoryView.c"
		}
	}
#line 3651 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = self->name_renderer;
#line 3651 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp10_, "editable", TRUE, NULL);
#line 3652 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = _data35_->path;
#line 3652 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = self->name_renderer;
#line 3652 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor_on_cell (self, _tmp11_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp12_) : NULL, TRUE, FALSE);
#line 3653 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3653 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end);
#line 3653 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start);
#line 3653 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19218 "AbstractDirectoryView.c"
}

static gboolean
___lambda106__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda106_ (self);
#line 3632 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19228 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_start_renaming_file (FilesAbstractDirectoryView* self,
                                                   FilesFile* file)
{
	Block35Data* _data35_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesListModel* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	FilesTextRenderer* _tmp6_;
#line 3609 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	_data35_ = g_slice_new0 (Block35Data);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	_data35_->_ref_count_ = 1;
#line 3609 "../src/View/AbstractDirectoryView.vala"
	_data35_->self = g_object_ref (self);
#line 3610 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 3610 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 3610 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3611 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3611: Trying to rename when frozen");
#line 3612 "../src/View/AbstractDirectoryView.vala"
		block35_data_unref (_data35_);
#line 3612 "../src/View/AbstractDirectoryView.vala"
		_data35_ = NULL;
#line 3612 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19267 "AbstractDirectoryView.c"
	}
#line 3615 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 3615 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_list_model_get_path_for_first_file (_tmp2_, file);
#line 3615 "../src/View/AbstractDirectoryView.vala"
	_data35_->path = _tmp3_;
#line 3616 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _data35_->path;
#line 3616 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ == NULL) {
#line 3617 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:3617: Failed to find rename file in model");
#line 3618 "../src/View/AbstractDirectoryView.vala"
		block35_data_unref (_data35_);
#line 3618 "../src/View/AbstractDirectoryView.vala"
		_data35_ = NULL;
#line 3618 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19287 "AbstractDirectoryView.c"
	}
#line 3622 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_renaming (self, TRUE);
#line 3623 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 3624 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, TRUE);
#line 3625 "../src/View/AbstractDirectoryView.vala"
	_data35_->count = (guint) 0;
#line 3626 "../src/View/AbstractDirectoryView.vala"
	_data35_->ok_next_time = FALSE;
#line 3627 "../src/View/AbstractDirectoryView.vala"
	_data35_->start_path = NULL;
#line 3631 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _data35_->path;
#line 3631 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->name_renderer;
#line 3631 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor_on_cell (self, _tmp5_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp6_) : NULL, FALSE, FALSE);
#line 3632 "../src/View/AbstractDirectoryView.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda106__gsource_func, block35_data_ref (_data35_), block35_data_unref);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	block35_data_unref (_data35_);
#line 3609 "../src/View/AbstractDirectoryView.vala"
	_data35_ = NULL;
#line 19313 "AbstractDirectoryView.c"
}

static Block36Data*
block36_data_ref (Block36Data* _data36_)
{
#line 3658 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data36_->_ref_count_);
#line 3658 "../src/View/AbstractDirectoryView.vala"
	return _data36_;
#line 19323 "AbstractDirectoryView.c"
}

static void
block36_data_unref (void * _userdata_)
{
	Block36Data* _data36_;
	_data36_ = (Block36Data*) _userdata_;
#line 3658 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data36_->_ref_count_)) {
#line 19333 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3658 "../src/View/AbstractDirectoryView.vala"
		self = _data36_->self;
#line 3658 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data36_->dir);
#line 3658 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3658 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block36Data, _data36_);
#line 19343 "AbstractDirectoryView.c"
	}
}

static void
___lambda125_ (Block36Data* _data36_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	GError* _inner_error0_ = NULL;
#line 3693 "../src/View/AbstractDirectoryView.vala"
	self = _data36_->self;
#line 3693 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 19358 "AbstractDirectoryView.c"
	{
		GFileInfo* inf = NULL;
		FilesDirectory* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
#line 3696 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _data36_->dir;
#line 3696 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_directory_get_location (_tmp0_);
#line 3696 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 3696 "../src/View/AbstractDirectoryView.vala"
		g_file_set_attributes_finish (_tmp2_, res, &_tmp3_, &_inner_error0_);
#line 3696 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (inf);
#line 3696 "../src/View/AbstractDirectoryView.vala"
		inf = _tmp3_;
#line 3696 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3696 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (inf);
#line 19381 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 3694 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (inf);
#line 19386 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 3694 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 3694 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 3698 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = e;
#line 3698 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_->message;
#line 3698 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3698: Could not set file attributes: %s", _tmp5_);
#line 3694 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 19406 "AbstractDirectoryView.c"
	}
	__finally0:
#line 3694 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3694 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3694 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 3694 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19417 "AbstractDirectoryView.c"
	}
}

static void
____lambda125__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 3689 "../src/View/AbstractDirectoryView.vala"
	___lambda125_ (self, source_object, res);
#line 3689 "../src/View/AbstractDirectoryView.vala"
	block36_data_unref (self);
#line 19430 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_sort_column_changed (FilesAbstractDirectoryView* self)
{
	Block36Data* _data36_;
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
	FilesDirectory* _tmp10_;
	const gchar* sort_col_s = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	const gchar* sort_order_s = NULL;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	GFileInfo* _tmp15_;
	const gchar* _tmp16_;
	FilesDirectory* _tmp17_;
	FilesFile* _tmp18_;
	FilesFile* _tmp19_;
	GFileInfo* _tmp20_;
	const gchar* _tmp21_;
	FilesDirectory* _tmp22_;
	FilesFile* _tmp23_;
	FilesFile* _tmp24_;
	GFileInfo* _tmp25_;
	const gchar* _tmp26_;
	FilesDirectory* _tmp27_;
	FilesFile* _tmp28_;
	FilesFile* _tmp29_;
	FilesDirectory* _tmp30_;
	FilesFile* _tmp31_;
	FilesFile* _tmp32_;
#line 3658 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3658 "../src/View/AbstractDirectoryView.vala"
	_data36_ = g_slice_new0 (Block36Data);
#line 3658 "../src/View/AbstractDirectoryView.vala"
	_data36_->_ref_count_ = 1;
#line 3658 "../src/View/AbstractDirectoryView.vala"
	_data36_->self = g_object_ref (self);
#line 3659 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = 0;
#line 3660 "../src/View/AbstractDirectoryView.vala"
	sort_order = 0;
#line 3663 "../src/View/AbstractDirectoryView.vala"
	if (files_is_admin ()) {
#line 3664 "../src/View/AbstractDirectoryView.vala"
		block36_data_unref (_data36_);
#line 3664 "../src/View/AbstractDirectoryView.vala"
		_data36_ = NULL;
#line 3664 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19491 "AbstractDirectoryView.c"
	}
#line 3671 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_tree_frozen;
#line 3671 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3671 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 19499 "AbstractDirectoryView.c"
	} else {
		FilesListModel* _tmp2_;
		gint _tmp3_ = 0;
		GtkSortType _tmp4_ = 0;
		gboolean _tmp5_;
#line 3671 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->model;
#line 3671 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp2_, &_tmp3_, &_tmp4_);
#line 3671 "../src/View/AbstractDirectoryView.vala"
		sort_column_id = _tmp3_;
#line 3671 "../src/View/AbstractDirectoryView.vala"
		sort_order = _tmp4_;
#line 3671 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp5_;
#line 19515 "AbstractDirectoryView.c"
	}
#line 3671 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3672 "../src/View/AbstractDirectoryView.vala"
		block36_data_unref (_data36_);
#line 3672 "../src/View/AbstractDirectoryView.vala"
		_data36_ = NULL;
#line 3672 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19525 "AbstractDirectoryView.c"
	}
#line 3675 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = g_file_info_new ();
#line 3675 "../src/View/AbstractDirectoryView.vala"
	info = _tmp6_;
#line 3676 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 3676 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 3676 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 3676 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 3676 "../src/View/AbstractDirectoryView.vala"
	_data36_->dir = _tmp10_;
#line 3677 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_list_model_column_id_to_string ((FilesListModelColumnID) sort_column_id);
#line 3677 "../src/View/AbstractDirectoryView.vala"
	sort_col_s = _tmp11_;
#line 3678 "../src/View/AbstractDirectoryView.vala"
	if (sort_order == GTK_SORT_DESCENDING) {
#line 3678 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = "true";
#line 19549 "AbstractDirectoryView.c"
	} else {
#line 3678 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = "false";
#line 19553 "AbstractDirectoryView.c"
	}
#line 3678 "../src/View/AbstractDirectoryView.vala"
	sort_order_s = _tmp12_;
#line 3679 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = info;
#line 3679 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = sort_col_s;
#line 3679 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp13_, "metadata::marlin-sort-column-id", _tmp14_);
#line 3680 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = info;
#line 3680 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = sort_order_s;
#line 3680 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp15_, "metadata::marlin-sort-reversed", _tmp16_);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _data36_->dir;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = files_directory_get_file (_tmp17_);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = _tmp18_;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = _tmp19_->info;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = sort_col_s;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp20_, "metadata::marlin-sort-column-id", _tmp21_);
#line 3684 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = _data36_->dir;
#line 3684 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = files_directory_get_file (_tmp22_);
#line 3684 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = _tmp23_;
#line 3684 "../src/View/AbstractDirectoryView.vala"
	_tmp25_ = _tmp24_->info;
#line 3684 "../src/View/AbstractDirectoryView.vala"
	_tmp26_ = sort_order_s;
#line 3684 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp25_, "metadata::marlin-sort-reversed", _tmp26_);
#line 3685 "../src/View/AbstractDirectoryView.vala"
	_tmp27_ = _data36_->dir;
#line 3685 "../src/View/AbstractDirectoryView.vala"
	_tmp28_ = files_directory_get_file (_tmp27_);
#line 3685 "../src/View/AbstractDirectoryView.vala"
	_tmp29_ = _tmp28_;
#line 3685 "../src/View/AbstractDirectoryView.vala"
	_tmp29_->sort_column_id = sort_column_id;
#line 3686 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = _data36_->dir;
#line 3686 "../src/View/AbstractDirectoryView.vala"
	_tmp31_ = files_directory_get_file (_tmp30_);
#line 3686 "../src/View/AbstractDirectoryView.vala"
	_tmp32_ = _tmp31_;
#line 3686 "../src/View/AbstractDirectoryView.vala"
	_tmp32_->sort_order = sort_order;
#line 3688 "../src/View/AbstractDirectoryView.vala"
	if (!files_is_admin ()) {
#line 19611 "AbstractDirectoryView.c"
		FilesDirectory* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFileInfo* _tmp36_;
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = _data36_->dir;
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = files_directory_get_location (_tmp33_);
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = _tmp34_;
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = info;
#line 3689 "../src/View/AbstractDirectoryView.vala"
		g_file_set_attributes_async (_tmp35_, _tmp36_, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, ____lambda125__gasync_ready_callback, block36_data_ref (_data36_));
#line 19626 "AbstractDirectoryView.c"
	}
#line 3658 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (info);
#line 3658 "../src/View/AbstractDirectoryView.vala"
	block36_data_unref (_data36_);
#line 3658 "../src/View/AbstractDirectoryView.vala"
	_data36_ = NULL;
#line 19634 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel_timeout (FilesAbstractDirectoryView* self,
                                              guint* id)
{
#line 3704 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3705 "../src/View/AbstractDirectoryView.vala"
	if ((*id) > ((guint) 0)) {
#line 3706 "../src/View/AbstractDirectoryView.vala"
		g_source_remove (*id);
#line 3707 "../src/View/AbstractDirectoryView.vala"
		*id = (guint) 0;
#line 19649 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_update_selected_files_and_menu (FilesAbstractDirectoryView* self)
{
	gboolean _tmp6_ = FALSE;
	GList* _tmp7_;
#line 3711 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3712 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->selected_files_invalid) {
#line 19662 "AbstractDirectoryView.c"
		guint selected_count = 0U;
		GList* _tmp0_ = NULL;
		guint _tmp1_;
		FilesViewSlot* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GList* _tmp5_;
#line 3713 "../src/View/AbstractDirectoryView.vala"
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 3713 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = NULL;
#line 3715 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_directory_view_get_selected_files_from_model (self, &_tmp0_);
#line 3715 "../src/View/AbstractDirectoryView.vala"
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 3715 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = _tmp0_;
#line 3715 "../src/View/AbstractDirectoryView.vala"
		selected_count = _tmp1_;
#line 3716 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->slot;
#line 3716 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_view_slot_get_displayed_files_count (_tmp2_);
#line 3716 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 3716 "../src/View/AbstractDirectoryView.vala"
		self->priv->all_selected = selected_count == ((guint) _tmp4_);
#line 3717 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = g_list_reverse (self->selected_files);
#line 3718 "../src/View/AbstractDirectoryView.vala"
		self->priv->selected_files_invalid = FALSE;
#line 3719 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_update_menu_actions (self);
#line 3720 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->selected_files;
#line 3720 "../src/View/AbstractDirectoryView.vala"
		g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp5_);
#line 19700 "AbstractDirectoryView.c"
	}
#line 3723 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->selected_files;
#line 3723 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_ == NULL) {
#line 3723 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = TRUE;
#line 19708 "AbstractDirectoryView.c"
	} else {
		GList* _tmp8_;
		GList* _tmp9_;
#line 3723 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->selected_files;
#line 3723 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_->next;
#line 3723 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp9_ == NULL;
#line 19718 "AbstractDirectoryView.c"
	}
#line 3723 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = _tmp6_;
#line 19722 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_expand_collapse (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path)
{
	gboolean result;
#line 3727 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 3727 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19734 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_expand_collapse (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3726 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3726 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3726 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->expand_collapse) {
#line 3726 "../src/View/AbstractDirectoryView.vala"
		return _klass_->expand_collapse (self, path);
#line 19750 "AbstractDirectoryView.c"
	}
#line 3726 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 19754 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_default_button_click (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 3732 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3732 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19765 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_default_button_click (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3730 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3730 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3730 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_default_button_click) {
#line 3730 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_default_button_click (self);
#line 19780 "AbstractDirectoryView.c"
	}
#line 3730 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 19784 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                          GtkTreeIter* iter,
                                                          gboolean recurse)
{
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 3735 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 3736 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 3736 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp0_, iter);
#line 3736 "../src/View/AbstractDirectoryView.vala"
	result = _tmp1_;
#line 3736 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19805 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                     GtkTreeIter* iter,
                                                     gboolean recurse)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3735 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3735 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3735 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_next_visible_iter) {
#line 3735 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_next_visible_iter (self, iter, recurse);
#line 19822 "AbstractDirectoryView.c"
	}
#line 3735 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 19826 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_cancel (FilesAbstractDirectoryView* self)
{
#line 3740 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 3741 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 3742 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_thumbnailing (self);
#line 3743 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 3744 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->add_remove_file_timeout_id);
#line 3745 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->set_cursor_timeout_id);
#line 3746 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->draw_timeout_id);
#line 19846 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3739 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3739 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3739 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->cancel) {
#line 3739 "../src/View/AbstractDirectoryView.vala"
		_klass_->cancel (self);
#line 19861 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_cancel_hover (FilesAbstractDirectoryView* self)
{
#line 3750 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3751 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3751 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 19874 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_close (FilesAbstractDirectoryView* self)
{
#line 3754 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3755 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, TRUE);
#line 3756 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 3757 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 19888 "AbstractDirectoryView.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 3763 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 19896 "AbstractDirectoryView.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 3763 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 19904 "AbstractDirectoryView.c"
}

static GtkTreeRowReference*
_vala_GtkTreeRowReference_copy (GtkTreeRowReference* self)
{
#line 3770 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_row_reference_get_type (), self);
#line 19912 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreeRowReference_copy0 (gpointer self)
{
#line 3770 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreeRowReference_copy (self) : NULL;
#line 19920 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
#line 3770 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
#line 19928 "AbstractDirectoryView.c"
}

static void
__vala_GtkTreeRowReference_free0_ (gpointer var)
{
#line 3760 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL));
#line 19936 "AbstractDirectoryView.c"
}

static inline void
_g_list_free___vala_GtkTreeRowReference_free0_ (GList* self)
{
#line 3760 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreeRowReference_free0_);
#line 19944 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_invert_selection (FilesAbstractDirectoryView* self)
{
	GList* selected_row_refs = NULL;
	GList* _tmp0_;
	GList* _tmp5_;
#line 3760 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3761 "../src/View/AbstractDirectoryView.vala"
	selected_row_refs = NULL;
#line 3763 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_paths (self);
#line 19959 "AbstractDirectoryView.c"
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
#line 3763 "../src/View/AbstractDirectoryView.vala"
		p_collection = _tmp0_;
#line 3763 "../src/View/AbstractDirectoryView.vala"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 19967 "AbstractDirectoryView.c"
			GtkTreePath* _tmp1_;
			GtkTreePath* p = NULL;
#line 3763 "../src/View/AbstractDirectoryView.vala"
			_tmp1_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) p_it->data);
#line 3763 "../src/View/AbstractDirectoryView.vala"
			p = _tmp1_;
#line 19974 "AbstractDirectoryView.c"
			{
				FilesListModel* _tmp2_;
				GtkTreePath* _tmp3_;
				GtkTreeRowReference* _tmp4_;
#line 3764 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = self->model;
#line 3764 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = p;
#line 3764 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = gtk_tree_row_reference_new ((GtkTreeModel*) _tmp2_, _tmp3_);
#line 3764 "../src/View/AbstractDirectoryView.vala"
				selected_row_refs = g_list_prepend (selected_row_refs, _tmp4_);
#line 3763 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (p);
#line 19989 "AbstractDirectoryView.c"
			}
		}
#line 3763 "../src/View/AbstractDirectoryView.vala"
		(p_collection == NULL) ? NULL : (p_collection = (_g_list_free___vala_GtkTreePath_free0_ (p_collection), NULL));
#line 19994 "AbstractDirectoryView.c"
	}
#line 3767 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_all (self);
#line 3769 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = selected_row_refs;
#line 3769 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_ != NULL) {
#line 20002 "AbstractDirectoryView.c"
		GList* _tmp6_;
#line 3770 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = selected_row_refs;
#line 20006 "AbstractDirectoryView.c"
		{
			GList* r_collection = NULL;
			GList* r_it = NULL;
#line 3770 "../src/View/AbstractDirectoryView.vala"
			r_collection = _tmp6_;
#line 3770 "../src/View/AbstractDirectoryView.vala"
			for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 20014 "AbstractDirectoryView.c"
				GtkTreeRowReference* _tmp7_;
				GtkTreeRowReference* r = NULL;
#line 3770 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = __vala_GtkTreeRowReference_copy0 ((GtkTreeRowReference*) r_it->data);
#line 3770 "../src/View/AbstractDirectoryView.vala"
				r = _tmp7_;
#line 20021 "AbstractDirectoryView.c"
				{
					GtkTreePath* p = NULL;
					GtkTreeRowReference* _tmp8_;
					GtkTreePath* _tmp9_;
					GtkTreePath* _tmp10_;
#line 3771 "../src/View/AbstractDirectoryView.vala"
					_tmp8_ = r;
#line 3771 "../src/View/AbstractDirectoryView.vala"
					_tmp9_ = gtk_tree_row_reference_get_path (_tmp8_);
#line 3771 "../src/View/AbstractDirectoryView.vala"
					p = _tmp9_;
#line 3772 "../src/View/AbstractDirectoryView.vala"
					_tmp10_ = p;
#line 3772 "../src/View/AbstractDirectoryView.vala"
					if (_tmp10_ != NULL) {
#line 20037 "AbstractDirectoryView.c"
						GtkTreePath* _tmp11_;
#line 3773 "../src/View/AbstractDirectoryView.vala"
						_tmp11_ = p;
#line 3773 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_path (self, _tmp11_);
#line 20043 "AbstractDirectoryView.c"
					}
#line 3770 "../src/View/AbstractDirectoryView.vala"
					__vala_GtkTreePath_free0 (p);
#line 3770 "../src/View/AbstractDirectoryView.vala"
					__vala_GtkTreeRowReference_free0 (r);
#line 20049 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 3760 "../src/View/AbstractDirectoryView.vala"
	(selected_row_refs == NULL) ? NULL : (selected_row_refs = (_g_list_free___vala_GtkTreeRowReference_free0_ (selected_row_refs), NULL));
#line 20056 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_all (FilesAbstractDirectoryView* self)
{
#line 3779 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3780 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_select_all (self);
#line 3781 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20068 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_all (FilesAbstractDirectoryView* self)
{
#line 3784 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3785 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_unselect_all (self);
#line 3786 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20080 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_others (FilesAbstractDirectoryView* self)
{
#line 3789 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3790 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_unselect_others (self);
#line 3791 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20092 "AbstractDirectoryView.c"
}

guint
files_abstract_directory_view_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                             GList** selected_files)
{
	GList* _vala_selected_files = NULL;
	GList* list = NULL;
	guint count = 0U;
	GList* selected_paths = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp9_;
	guint result;
#line 3794 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 3795 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 3796 "../src/View/AbstractDirectoryView.vala"
	count = (guint) 0;
#line 3797 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_paths (self);
#line 3797 "../src/View/AbstractDirectoryView.vala"
	selected_paths = _tmp0_;
#line 3798 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = selected_paths;
#line 20119 "AbstractDirectoryView.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 3798 "../src/View/AbstractDirectoryView.vala"
		path_collection = _tmp1_;
#line 3798 "../src/View/AbstractDirectoryView.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 20127 "AbstractDirectoryView.c"
			GtkTreePath* _tmp2_;
			GtkTreePath* path = NULL;
#line 3798 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
#line 3798 "../src/View/AbstractDirectoryView.vala"
			path = _tmp2_;
#line 20134 "AbstractDirectoryView.c"
			{
				FilesFile* file = NULL;
				FilesListModel* _tmp3_;
				GtkTreePath* _tmp4_;
				FilesFile* _tmp5_;
				FilesFile* _tmp6_;
#line 3799 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = self->model;
#line 3799 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = path;
#line 3799 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = files_list_model_file_for_path (_tmp3_, _tmp4_);
#line 3799 "../src/View/AbstractDirectoryView.vala"
				file = _tmp5_;
#line 3800 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = file;
#line 3800 "../src/View/AbstractDirectoryView.vala"
				if (_tmp6_ != NULL) {
#line 20153 "AbstractDirectoryView.c"
					FilesFile* _tmp7_;
					guint _tmp8_;
#line 3801 "../src/View/AbstractDirectoryView.vala"
					_tmp7_ = file;
#line 3801 "../src/View/AbstractDirectoryView.vala"
					file = NULL;
#line 3801 "../src/View/AbstractDirectoryView.vala"
					list = g_list_prepend (list, _tmp7_);
#line 3802 "../src/View/AbstractDirectoryView.vala"
					_tmp8_ = count;
#line 3802 "../src/View/AbstractDirectoryView.vala"
					count = _tmp8_ + 1;
#line 20166 "AbstractDirectoryView.c"
				} else {
#line 3804 "../src/View/AbstractDirectoryView.vala"
					g_critical ("AbstractDirectoryView.vala:3804: Null file in model");
#line 20170 "AbstractDirectoryView.c"
				}
#line 3798 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 3798 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 20176 "AbstractDirectoryView.c"
			}
		}
	}
#line 3807 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = list;
#line 3807 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 3807 "../src/View/AbstractDirectoryView.vala"
	(_vala_selected_files == NULL) ? NULL : (_vala_selected_files = (_g_list_free__g_object_unref0_ (_vala_selected_files), NULL));
#line 3807 "../src/View/AbstractDirectoryView.vala"
	_vala_selected_files = _tmp9_;
#line 3808 "../src/View/AbstractDirectoryView.vala"
	result = count;
#line 3808 "../src/View/AbstractDirectoryView.vala"
	(selected_paths == NULL) ? NULL : (selected_paths = (_g_list_free___vala_GtkTreePath_free0_ (selected_paths), NULL));
#line 3808 "../src/View/AbstractDirectoryView.vala"
	(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 3808 "../src/View/AbstractDirectoryView.vala"
	if (selected_files) {
#line 3808 "../src/View/AbstractDirectoryView.vala"
		*selected_files = _vala_selected_files;
#line 20198 "AbstractDirectoryView.c"
	} else {
#line 3808 "../src/View/AbstractDirectoryView.vala"
		(_vala_selected_files == NULL) ? NULL : (_vala_selected_files = (_g_list_free__g_object_unref0_ (_vala_selected_files), NULL));
#line 20202 "AbstractDirectoryView.c"
	}
#line 3808 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20206 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_highlight_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
}

void
files_abstract_directory_view_highlight_path (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3811 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3811 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3811 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->highlight_path) {
#line 3811 "../src/View/AbstractDirectoryView.vala"
		_klass_->highlight_path (self, path);
#line 20228 "AbstractDirectoryView.c"
	}
}

static GtkTreePath*
files_abstract_directory_view_real_up (FilesAbstractDirectoryView* self,
                                       GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result;
#line 3812 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 3812 "../src/View/AbstractDirectoryView.vala"
	gtk_tree_path_up (path);
#line 3812 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
#line 3812 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 3812 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20248 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_up (FilesAbstractDirectoryView* self,
                                  GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3812 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3812 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3812 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->up) {
#line 3812 "../src/View/AbstractDirectoryView.vala"
		return _klass_->up (self, path);
#line 20264 "AbstractDirectoryView.c"
	}
#line 3812 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20268 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_down (FilesAbstractDirectoryView* self,
                                         GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	gtk_tree_path_down (path);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20287 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_down (FilesAbstractDirectoryView* self,
                                    GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->down) {
#line 3813 "../src/View/AbstractDirectoryView.vala"
		return _klass_->down (self, path);
#line 20303 "AbstractDirectoryView.c"
	}
#line 3813 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20307 "AbstractDirectoryView.c"
}

static GSettings*
files_abstract_directory_view_real_get_view_settings (FilesAbstractDirectoryView* self)
{
	GSettings* result;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	result = NULL;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20318 "AbstractDirectoryView.c"
}

GSettings*
files_abstract_directory_view_get_view_settings (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3814 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_view_settings) {
#line 3814 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_view_settings (self);
#line 20333 "AbstractDirectoryView.c"
	}
#line 3814 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20337 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_set_up_zoom_level (FilesAbstractDirectoryView* self)
{
	GSettings* view_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 3816 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_view_settings (self);
#line 3816 "../src/View/AbstractDirectoryView.vala"
	view_settings = _tmp0_;
#line 3817 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = view_settings;
#line 3817 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ == NULL) {
#line 3818 "../src/View/AbstractDirectoryView.vala"
		self->minimum_zoom = FILES_ZOOM_LEVEL_SMALLEST;
#line 3819 "../src/View/AbstractDirectoryView.vala"
		self->maximum_zoom = FILES_ZOOM_LEVEL_LARGEST;
#line 3820 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, FILES_ZOOM_LEVEL_NORMAL);
#line 20360 "AbstractDirectoryView.c"
	} else {
		GSettings* _tmp2_;
		GSettings* _tmp3_;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
#line 3822 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = view_settings;
#line 3822 "../src/View/AbstractDirectoryView.vala"
		self->minimum_zoom = (FilesZoomLevel) g_settings_get_enum (_tmp2_, "minimum-zoom-level");
#line 3823 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = view_settings;
#line 3823 "../src/View/AbstractDirectoryView.vala"
		self->maximum_zoom = (FilesZoomLevel) g_settings_get_enum (_tmp3_, "maximum-zoom-level");
#line 3824 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = view_settings;
#line 3824 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, (FilesZoomLevel) g_settings_get_enum (_tmp4_, "zoom-level"));
#line 3826 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = view_settings;
#line 3826 "../src/View/AbstractDirectoryView.vala"
		g_settings_bind (_tmp5_, "zoom-level", (GObject*) self, "zoom-level", G_SETTINGS_BIND_SET);
#line 20382 "AbstractDirectoryView.c"
	}
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (view_settings);
#line 20386 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_up_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3815 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3815 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_up_zoom_level) {
#line 3815 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_up_zoom_level (self);
#line 20401 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_view_has_focus (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 3835 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->view;
#line 3835 "../src/View/AbstractDirectoryView.vala"
	g_object_get (_tmp0_, "has-focus", &_tmp1_, NULL);
#line 3835 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 3835 "../src/View/AbstractDirectoryView.vala"
	result = _tmp2_;
#line 3835 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20422 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_view_has_focus (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3834 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3834 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3834 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->view_has_focus) {
#line 3834 "../src/View/AbstractDirectoryView.vala"
		return _klass_->view_has_focus (self);
#line 20437 "AbstractDirectoryView.c"
	}
#line 3834 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20441 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 3839 "../src/View/AbstractDirectoryView.vala"
	if (path == NULL) {
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = TRUE;
#line 20457 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp4_;
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->slot;
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp4_ == NULL;
#line 20464 "AbstractDirectoryView.c"
	}
#line 3839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = TRUE;
#line 20470 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp5_;
		FilesDirectory* _tmp6_;
		FilesDirectory* _tmp7_;
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->slot;
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp7_ == NULL;
#line 20483 "AbstractDirectoryView.c"
	}
#line 3839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = TRUE;
#line 20489 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp8_;
		FilesDirectory* _tmp9_;
		FilesDirectory* _tmp10_;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->slot;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp8_);
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp10_->permission_denied;
#line 20502 "AbstractDirectoryView.c"
	}
#line 3839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3839 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 20508 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp11_;
		FilesDirectory* _tmp12_;
		FilesDirectory* _tmp13_;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = self->slot;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp11_);
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_;
#line 3840 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_directory_is_empty (_tmp13_);
#line 20521 "AbstractDirectoryView.c"
	}
#line 3839 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3842 "../src/View/AbstractDirectoryView.vala"
		return;
#line 20527 "AbstractDirectoryView.c"
	}
#line 3845 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_scroll_to_path (self, path, scroll_to_top);
#line 20531 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_scroll_to_cell (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path,
                                              gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3838 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3838 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3838 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->scroll_to_cell) {
#line 3838 "../src/View/AbstractDirectoryView.vala"
		_klass_->scroll_to_cell (self, path, scroll_to_top);
#line 20548 "AbstractDirectoryView.c"
	}
}

static void
_vala_GdkEventKey_free (GdkEventKey* self)
{
#line 3853 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 20557 "AbstractDirectoryView.c"
}

guint
files_abstract_directory_view_map_key (guint original_keyval,
                                       guint keycode,
                                       GdkModifierType* consumed_mods)
{
	GdkModifierType _vala_consumed_mods = 0U;
	guint keyval = 0U;
	guint result;
#line 3850 "../src/View/AbstractDirectoryView.vala"
	keyval = original_keyval;
#line 3851 "../src/View/AbstractDirectoryView.vala"
	_vala_consumed_mods = 0;
#line 3853 "../src/View/AbstractDirectoryView.vala"
	if (keyval > ((guint) 127)) {
#line 20574 "AbstractDirectoryView.c"
		gint eff_grp = 0;
		gint level = 0;
		GdkEventKey* event = NULL;
		GdkEvent* _tmp0_;
		GdkDisplay* display = NULL;
		GdkDevice* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkDisplay* _tmp3_;
		GdkKeymap* keymap = NULL;
		GdkDisplay* _tmp4_;
		GdkKeymap* _tmp5_;
		GdkKeymap* _tmp6_;
		GdkKeymap* _tmp7_;
		GdkEventKey* _tmp8_;
		GdkEventKey* _tmp9_;
		GdkEventKey* _tmp10_;
		guint _tmp11_ = 0U;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		GdkModifierType _tmp14_ = 0U;
		gboolean _tmp15_;
#line 3855 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = gtk_get_current_event ();
#line 3855 "../src/View/AbstractDirectoryView.vala"
		event = (GdkEventKey*) _tmp0_;
#line 3856 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = gtk_get_current_event_device ();
#line 3856 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = gdk_device_get_display (_tmp1_);
#line 3856 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 3856 "../src/View/AbstractDirectoryView.vala"
		display = _tmp3_;
#line 3857 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = display;
#line 3857 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gdk_keymap_get_for_display (_tmp4_);
#line 3857 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 3857 "../src/View/AbstractDirectoryView.vala"
		keymap = _tmp6_;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = keymap;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = event;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = event;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = event;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = gdk_keymap_translate_keyboard_state (_tmp7_, (guint) _tmp8_->hardware_keycode, _tmp9_->state, (gint) _tmp10_->group, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 3858 "../src/View/AbstractDirectoryView.vala"
		keyval = _tmp11_;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		eff_grp = _tmp12_;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		level = _tmp13_;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		_vala_consumed_mods = _tmp14_;
#line 3858 "../src/View/AbstractDirectoryView.vala"
		if (!_tmp15_) {
#line 3864 "../src/View/AbstractDirectoryView.vala"
			g_warning ("AbstractDirectoryView.vala:3864: translate keyboard state failed");
#line 3865 "../src/View/AbstractDirectoryView.vala"
			keyval = original_keyval;
#line 3866 "../src/View/AbstractDirectoryView.vala"
			_vala_consumed_mods = 0;
#line 20642 "AbstractDirectoryView.c"
		} else {
#line 3868 "../src/View/AbstractDirectoryView.vala"
			keyval = (guint) 0;
#line 20646 "AbstractDirectoryView.c"
			{
				guint key = 0U;
#line 3869 "../src/View/AbstractDirectoryView.vala"
				key = (guint) 32;
#line 20651 "AbstractDirectoryView.c"
				{
					gboolean _tmp16_ = FALSE;
#line 3869 "../src/View/AbstractDirectoryView.vala"
					_tmp16_ = TRUE;
#line 3869 "../src/View/AbstractDirectoryView.vala"
					while (TRUE) {
#line 20658 "AbstractDirectoryView.c"
						GdkKeymap* _tmp18_;
						GdkEventKey* _tmp19_;
#line 3869 "../src/View/AbstractDirectoryView.vala"
						if (!_tmp16_) {
#line 20663 "AbstractDirectoryView.c"
							guint _tmp17_;
#line 3869 "../src/View/AbstractDirectoryView.vala"
							_tmp17_ = key;
#line 3869 "../src/View/AbstractDirectoryView.vala"
							key = _tmp17_ + 1;
#line 20669 "AbstractDirectoryView.c"
						}
#line 3869 "../src/View/AbstractDirectoryView.vala"
						_tmp16_ = FALSE;
#line 3869 "../src/View/AbstractDirectoryView.vala"
						if (!(key < ((guint) 128))) {
#line 3869 "../src/View/AbstractDirectoryView.vala"
							break;
#line 20677 "AbstractDirectoryView.c"
						}
#line 3870 "../src/View/AbstractDirectoryView.vala"
						_tmp18_ = keymap;
#line 3870 "../src/View/AbstractDirectoryView.vala"
						_tmp19_ = event;
#line 3870 "../src/View/AbstractDirectoryView.vala"
						if (files_abstract_directory_view_match_keycode (_tmp18_, key, (guint) _tmp19_->hardware_keycode, level)) {
#line 3871 "../src/View/AbstractDirectoryView.vala"
							keyval = key;
#line 3872 "../src/View/AbstractDirectoryView.vala"
							break;
#line 20689 "AbstractDirectoryView.c"
						}
					}
				}
			}
#line 3876 "../src/View/AbstractDirectoryView.vala"
			if (keyval == ((guint) 0)) {
#line 3877 "../src/View/AbstractDirectoryView.vala"
				g_debug ("AbstractDirectoryView.vala:3877: Could not match hardware code to ASCI" \
"I hotkey");
#line 3878 "../src/View/AbstractDirectoryView.vala"
				keyval = original_keyval;
#line 3879 "../src/View/AbstractDirectoryView.vala"
				_vala_consumed_mods = 0;
#line 20702 "AbstractDirectoryView.c"
			}
		}
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (keymap);
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (display);
#line 3853 "../src/View/AbstractDirectoryView.vala"
		__vala_GdkEventKey_free0 (event);
#line 20711 "AbstractDirectoryView.c"
	}
#line 3884 "../src/View/AbstractDirectoryView.vala"
	result = keyval;
#line 3884 "../src/View/AbstractDirectoryView.vala"
	if (consumed_mods) {
#line 3884 "../src/View/AbstractDirectoryView.vala"
		*consumed_mods = _vala_consumed_mods;
#line 20719 "AbstractDirectoryView.c"
	}
#line 3884 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20723 "AbstractDirectoryView.c"
}

/** Returns true if the code parameter matches the keycode of the keyval parameter for
      * any keyboard group or level (in order to allow for non-QWERTY keyboards) **/
gboolean
files_abstract_directory_view_match_keycode (GdkKeymap* keymap,
                                             guint keyval,
                                             guint code,
                                             gint level)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkKeymapKey* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gboolean _tmp2_;
	gboolean result;
#line 3889 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (keymap != NULL, FALSE);
#line 3891 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = gdk_keymap_get_entries_for_keyval (keymap, keyval, &_tmp0_, &_tmp1_);
#line 3891 "../src/View/AbstractDirectoryView.vala"
	keys = (g_free (keys), NULL);
#line 3891 "../src/View/AbstractDirectoryView.vala"
	keys = _tmp0_;
#line 3891 "../src/View/AbstractDirectoryView.vala"
	keys_length1 = _tmp1_;
#line 3891 "../src/View/AbstractDirectoryView.vala"
	_keys_size_ = keys_length1;
#line 3891 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 20755 "AbstractDirectoryView.c"
		GdkKeymapKey* _tmp3_;
		gint _tmp3__length1;
#line 3892 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = keys;
#line 3892 "../src/View/AbstractDirectoryView.vala"
		_tmp3__length1 = keys_length1;
#line 20762 "AbstractDirectoryView.c"
		{
			GdkKeymapKey* key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 3892 "../src/View/AbstractDirectoryView.vala"
			key_collection = _tmp3_;
#line 3892 "../src/View/AbstractDirectoryView.vala"
			key_collection_length1 = _tmp3__length1;
#line 3892 "../src/View/AbstractDirectoryView.vala"
			for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 20774 "AbstractDirectoryView.c"
				GdkKeymapKey key = {0};
#line 3892 "../src/View/AbstractDirectoryView.vala"
				key = key_collection[key_it];
#line 20778 "AbstractDirectoryView.c"
				{
					gboolean _tmp4_ = FALSE;
					GdkKeymapKey _tmp5_;
#line 3893 "../src/View/AbstractDirectoryView.vala"
					_tmp5_ = key;
#line 3893 "../src/View/AbstractDirectoryView.vala"
					if (code == _tmp5_.keycode) {
#line 20786 "AbstractDirectoryView.c"
						GdkKeymapKey _tmp6_;
#line 3893 "../src/View/AbstractDirectoryView.vala"
						_tmp6_ = key;
#line 3893 "../src/View/AbstractDirectoryView.vala"
						_tmp4_ = level == _tmp6_.level;
#line 20792 "AbstractDirectoryView.c"
					} else {
#line 3893 "../src/View/AbstractDirectoryView.vala"
						_tmp4_ = FALSE;
#line 20796 "AbstractDirectoryView.c"
					}
#line 3893 "../src/View/AbstractDirectoryView.vala"
					if (_tmp4_) {
#line 3894 "../src/View/AbstractDirectoryView.vala"
						result = TRUE;
#line 3894 "../src/View/AbstractDirectoryView.vala"
						keys = (g_free (keys), NULL);
#line 3894 "../src/View/AbstractDirectoryView.vala"
						return result;
#line 20806 "AbstractDirectoryView.c"
					}
				}
			}
		}
	}
#line 3899 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3899 "../src/View/AbstractDirectoryView.vala"
	keys = (g_free (keys), NULL);
#line 3899 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20818 "AbstractDirectoryView.c"
}

/** Abstract methods - must be overridden*/
static GList*
files_abstract_directory_view_real_get_selected_paths (FilesAbstractDirectoryView* self)
{
#line 3903 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_selected_paths'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3903 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20829 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_selected_paths (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3903 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3903 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3903 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_selected_paths) {
#line 3903 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_selected_paths (self);
#line 20844 "AbstractDirectoryView.c"
	}
#line 3903 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20848 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                    gint x,
                                                    gint win)
{
#line 3904 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_path_at_pos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3904 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20860 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_get_path_at_pos (FilesAbstractDirectoryView* self,
                                               gint x,
                                               gint win)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3904 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3904 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3904 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_path_at_pos) {
#line 3904 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_path_at_pos (self, x, win);
#line 20877 "AbstractDirectoryView.c"
	}
#line 3904 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20881 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_get_path_at_cursor (FilesAbstractDirectoryView* self)
{
#line 3905 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_path_at_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3905 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20891 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_get_path_at_cursor (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3905 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3905 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3905 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_path_at_cursor) {
#line 3905 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_path_at_cursor (self);
#line 20906 "AbstractDirectoryView.c"
	}
#line 3905 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20910 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_tree_select_all (FilesAbstractDirectoryView* self)
{
#line 3906 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_tree_select_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3906 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20920 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_tree_select_all (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3906 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3906 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3906 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_select_all) {
#line 3906 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_select_all (self);
#line 20935 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_tree_unselect_all (FilesAbstractDirectoryView* self)
{
#line 3907 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_tree_unselect_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3907 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20946 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_tree_unselect_all (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3907 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3907 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3907 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_unselect_all) {
#line 3907 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_unselect_all (self);
#line 20961 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_tree_unselect_others (FilesAbstractDirectoryView* self)
{
}

void
files_abstract_directory_view_tree_unselect_others (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3908 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3908 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3908 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_unselect_others) {
#line 3908 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_unselect_others (self);
#line 20982 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_select_path (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean cursor_follows)
{
#line 3909 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_select_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3909 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20995 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_path (FilesAbstractDirectoryView* self,
                                           GtkTreePath* path,
                                           gboolean cursor_follows)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3909 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3909 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3909 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->select_path) {
#line 3909 "../src/View/AbstractDirectoryView.vala"
		_klass_->select_path (self, path, cursor_follows);
#line 21012 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_unselect_path (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path)
{
#line 3910 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_unselect_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3910 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21024 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_path (FilesAbstractDirectoryView* self,
                                             GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3910 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3910 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3910 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->unselect_path) {
#line 3910 "../src/View/AbstractDirectoryView.vala"
		_klass_->unselect_path (self, path);
#line 21040 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_path_is_selected (FilesAbstractDirectoryView* self,
                                                     GtkTreePath* path)
{
	gboolean _tmp0_ = FALSE;
#line 3911 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_path_is_selected'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3911 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21053 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_path_is_selected (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3911 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3911 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3911 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->path_is_selected) {
#line 3911 "../src/View/AbstractDirectoryView.vala"
		return _klass_->path_is_selected (self, path);
#line 21069 "AbstractDirectoryView.c"
	}
#line 3911 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21073 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_get_visible_range (FilesAbstractDirectoryView* self,
                                                      GtkTreePath** start_path,
                                                      GtkTreePath** end_path)
{
	gboolean _tmp0_ = FALSE;
#line 3912 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_visible_range'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3912 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21086 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_visible_range (FilesAbstractDirectoryView* self,
                                                 GtkTreePath** start_path,
                                                 GtkTreePath** end_path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3912 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3912 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3912 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_visible_range) {
#line 3912 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_visible_range (self, start_path, end_path);
#line 21103 "AbstractDirectoryView.c"
	}
#line 3912 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21107 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_set_cursor (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path,
                                               gboolean start_editing,
                                               gboolean select,
                                               gboolean scroll_to_top)
{
#line 3913 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_set_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3913 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21121 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_cursor (FilesAbstractDirectoryView* self,
                                          GtkTreePath* path,
                                          gboolean start_editing,
                                          gboolean select,
                                          gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3913 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3913 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3913 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_cursor) {
#line 3913 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_cursor (self, path, start_editing, select, scroll_to_top);
#line 21140 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_move_cursor (FilesAbstractDirectoryView* self,
                                                guint keyval,
                                                gboolean only_shift_pressed,
                                                gboolean control_pressed)
{
	gboolean result;
#line 3920 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3920 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21155 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_move_cursor (FilesAbstractDirectoryView* self,
                                           guint keyval,
                                           gboolean only_shift_pressed,
                                           gboolean control_pressed)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3919 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3919 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3919 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->move_cursor) {
#line 3919 "../src/View/AbstractDirectoryView.vala"
		return _klass_->move_cursor (self, keyval, only_shift_pressed, control_pressed);
#line 21173 "AbstractDirectoryView.c"
	}
#line 3919 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21177 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                             gboolean no_mods,
                                                             gboolean only_control_pressed,
                                                             gboolean only_shift_pressed)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 3925 "../src/View/AbstractDirectoryView.vala"
	if (!no_mods) {
#line 3925 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !only_control_pressed;
#line 21192 "AbstractDirectoryView.c"
	} else {
#line 3925 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 21196 "AbstractDirectoryView.c"
	}
#line 3925 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3926 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 3926 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 21204 "AbstractDirectoryView.c"
	} else {
#line 3928 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3928 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 21210 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                        gboolean no_mods,
                                                        gboolean only_control_pressed,
                                                        gboolean only_shift_pressed)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3923 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3923 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3923 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->will_handle_button_press) {
#line 3923 "../src/View/AbstractDirectoryView.vala"
		return _klass_->will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed);
#line 21229 "AbstractDirectoryView.c"
	}
#line 3923 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21233 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_is_on_icon (FilesAbstractDirectoryView* self,
                                          gint x,
                                          gint y,
                                          gboolean* on_helper)
{
	GdkRectangle pointer_rect = {0};
	GdkRectangle _tmp0_ = {0};
	gboolean on_icon = FALSE;
	FilesIconRenderer* _tmp1_;
	GdkRectangle _tmp2_;
	FilesIconRenderer* _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result;
#line 3932 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3934 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.x = x - 2;
#line 3934 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.y = y - 2;
#line 3934 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.width = 4;
#line 3934 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.height = 4;
#line 3934 "../src/View/AbstractDirectoryView.vala"
	pointer_rect = _tmp0_;
#line 3935 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->icon_renderer;
#line 3935 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_->hover_rect;
#line 3935 "../src/View/AbstractDirectoryView.vala"
	on_icon = gdk_rectangle_intersect (&pointer_rect, &_tmp2_, NULL);
#line 3936 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->icon_renderer;
#line 3936 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_->hover_helper_rect;
#line 3936 "../src/View/AbstractDirectoryView.vala"
	*on_helper = gdk_rectangle_intersect (&pointer_rect, &_tmp4_, NULL);
#line 3937 "../src/View/AbstractDirectoryView.vala"
	result = on_icon;
#line 3937 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21278 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_multi_select (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path)
{
	gboolean result;
#line 3942 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 3942 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3942 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21292 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_multi_select (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3942 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3942 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3942 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_multi_select) {
#line 3942 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_multi_select (self, path);
#line 21308 "AbstractDirectoryView.c"
	}
#line 3942 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21312 "AbstractDirectoryView.c"
}

static GtkWidget*
files_abstract_directory_view_real_create_view (FilesAbstractDirectoryView* self)
{
#line 3944 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3944 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 21322 "AbstractDirectoryView.c"
}

GtkWidget*
files_abstract_directory_view_create_view (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3944 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3944 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3944 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->create_view) {
#line 3944 "../src/View/AbstractDirectoryView.vala"
		return _klass_->create_view (self);
#line 21337 "AbstractDirectoryView.c"
	}
#line 3944 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 21341 "AbstractDirectoryView.c"
}

static guint
files_abstract_directory_view_real_get_event_position_info (FilesAbstractDirectoryView* self,
                                                            gdouble x,
                                                            gdouble y,
                                                            GtkTreePath** path,
                                                            gboolean rubberband)
{
	guint _tmp0_ = 0U;
#line 3946 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_event_position_info'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3946 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21356 "AbstractDirectoryView.c"
}

guint
files_abstract_directory_view_get_event_position_info (FilesAbstractDirectoryView* self,
                                                       gdouble x,
                                                       gdouble y,
                                                       GtkTreePath** path,
                                                       gboolean rubberband)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3946 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 3946 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3946 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_event_position_info) {
#line 3946 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_event_position_info (self, x, y, path, rubberband);
#line 21375 "AbstractDirectoryView.c"
	}
#line 3946 "../src/View/AbstractDirectoryView.vala"
	return 0U;
#line 21379 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_scroll_to_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top)
{
#line 3950 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_scroll_to_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3950 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21391 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_scroll_to_path (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path,
                                              gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3950 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3950 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3950 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->scroll_to_path) {
#line 3950 "../src/View/AbstractDirectoryView.vala"
		_klass_->scroll_to_path (self, path, scroll_to_top);
#line 21408 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path,
                                                       GtkCellRenderer* renderer,
                                                       gboolean start_editing,
                                                       gboolean scroll_to_top)
{
#line 3951 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_set_cursor_on_cell'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3951 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21423 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path,
                                                  GtkCellRenderer* renderer,
                                                  gboolean start_editing,
                                                  gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3951 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3951 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3951 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_cursor_on_cell) {
#line 3951 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_cursor_on_cell (self, path, renderer, start_editing, scroll_to_top);
#line 21442 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_freeze_tree (FilesAbstractDirectoryView* self)
{
#line 3955 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_freeze_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3955 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21453 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_freeze_tree (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3955 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3955 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3955 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->freeze_tree) {
#line 3955 "../src/View/AbstractDirectoryView.vala"
		_klass_->freeze_tree (self);
#line 21468 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_thaw_tree (FilesAbstractDirectoryView* self)
{
#line 3956 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_thaw_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3956 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21479 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_thaw_tree (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3956 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3956 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3956 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->thaw_tree) {
#line 3956 "../src/View/AbstractDirectoryView.vala"
		_klass_->thaw_tree (self);
#line 21494 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_freeze_child_notify (FilesAbstractDirectoryView* self)
{
#line 3957 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_freeze_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3957 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21505 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_freeze_child_notify (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3957 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3957 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3957 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->freeze_child_notify) {
#line 3957 "../src/View/AbstractDirectoryView.vala"
		_klass_->freeze_child_notify (self);
#line 21520 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_thaw_child_notify (FilesAbstractDirectoryView* self)
{
#line 3958 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_thaw_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3958 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21531 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_thaw_child_notify (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3958 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3958 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3958 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->thaw_child_notify) {
#line 3958 "../src/View/AbstractDirectoryView.vala"
		_klass_->thaw_child_notify (self);
#line 21546 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_connect_tree_signals (FilesAbstractDirectoryView* self)
{
#line 3959 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_connect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3959 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21557 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_tree_signals (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3959 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3959 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3959 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->connect_tree_signals) {
#line 3959 "../src/View/AbstractDirectoryView.vala"
		_klass_->connect_tree_signals (self);
#line 21572 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_disconnect_tree_signals (FilesAbstractDirectoryView* self)
{
#line 3960 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_disconnect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3960 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21583 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_tree_signals (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3960 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3960 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3960 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->disconnect_tree_signals) {
#line 3960 "../src/View/AbstractDirectoryView.vala"
		_klass_->disconnect_tree_signals (self);
#line 21598 "AbstractDirectoryView.c"
	}
}

FilesZoomLevel
files_abstract_directory_view_get_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel result;
#line 100 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 101 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_zoom_level;
#line 101 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21612 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_zoom_level (FilesAbstractDirectoryView* self,
                                              FilesZoomLevel value)
{
#line 104 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/View/AbstractDirectoryView.vala"
	if (value > self->maximum_zoom) {
#line 106 "../src/View/AbstractDirectoryView.vala"
		self->priv->_zoom_level = self->maximum_zoom;
#line 21625 "AbstractDirectoryView.c"
	} else {
#line 107 "../src/View/AbstractDirectoryView.vala"
		if (value < self->minimum_zoom) {
#line 108 "../src/View/AbstractDirectoryView.vala"
			self->priv->_zoom_level = self->minimum_zoom;
#line 21631 "AbstractDirectoryView.c"
		} else {
#line 110 "../src/View/AbstractDirectoryView.vala"
			self->priv->_zoom_level = value;
#line 21635 "AbstractDirectoryView.c"
		}
	}
#line 113 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_zoom_level_changed (self, self->priv->_zoom_level);
#line 104 "../src/View/AbstractDirectoryView.vala"
	g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY]);
#line 21642 "AbstractDirectoryView.c"
}

gint
files_abstract_directory_view_get_icon_size (FilesAbstractDirectoryView* self)
{
	gint result;
#line 118 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 119 "../src/View/AbstractDirectoryView.vala"
	result = (gint) files_zoom_level_to_icon_size (self->priv->_zoom_level);
#line 119 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21655 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_get_drop_highlight (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 143 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 144 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_drop_highlight;
#line 144 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21668 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_drop_highlight (FilesAbstractDirectoryView* self,
                                                  gboolean value)
{
#line 147 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/View/AbstractDirectoryView.vala"
	if (value != self->priv->_drop_highlight) {
#line 149 "../src/View/AbstractDirectoryView.vala"
		if (value) {
#line 150 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_highlight ((GtkWidget*) self);
#line 21683 "AbstractDirectoryView.c"
		} else {
#line 152 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_unhighlight ((GtkWidget*) self);
#line 21687 "AbstractDirectoryView.c"
		}
	}
#line 156 "../src/View/AbstractDirectoryView.vala"
	self->priv->_drop_highlight = value;
#line 21692 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_singleclick_select (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 195 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 195 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_singleclick_select;
#line 195 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21705 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_singleclick_select (FilesAbstractDirectoryView* self,
                                                      gboolean value)
{
	gboolean old_value;
#line 195 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_singleclick_select (self);
#line 195 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 195 "../src/View/AbstractDirectoryView.vala"
		self->priv->_singleclick_select = value;
#line 195 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY]);
#line 21723 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_renaming (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 220 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_renaming;
#line 220 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21737 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_renaming (FilesAbstractDirectoryView* self,
                                            gboolean value)
{
	gboolean old_value;
#line 220 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_renaming (self);
#line 220 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 220 "../src/View/AbstractDirectoryView.vala"
		self->priv->_renaming = value;
#line 220 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY]);
#line 21755 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_is_frozen (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 249 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_is_frozen;
#line 250 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21769 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_is_frozen (FilesAbstractDirectoryView* self,
                                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 224 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 225 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 225 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != value) {
#line 21786 "AbstractDirectoryView.c"
		GtkPropagationPhase _tmp9_ = 0;
		GtkEventControllerKey* _tmp10_;
#line 226 "../src/View/AbstractDirectoryView.vala"
		self->priv->_is_frozen = value;
#line 227 "../src/View/AbstractDirectoryView.vala"
		if (value) {
#line 21793 "AbstractDirectoryView.c"
			GSimpleActionGroup* _tmp2_;
			GSimpleActionGroup* _tmp3_;
			GSimpleActionGroup* _tmp4_;
			GSimpleActionGroup* _tmp5_;
			FilesClipboardManager* _tmp6_;
			guint _tmp7_;
#line 228 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = self->priv->selection_actions;
#line 228 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp2_, "cut", FALSE);
#line 229 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = self->priv->common_actions;
#line 229 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp3_, "copy", FALSE);
#line 230 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = self->priv->common_actions;
#line 230 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp4_, "paste-into", FALSE);
#line 231 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = self->priv->common_actions;
#line 231 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp5_, "paste", FALSE);
#line 236 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_disconnect_tree_signals (self);
#line 237 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = self->priv->clipboard;
#line 237 "../src/View/AbstractDirectoryView.vala"
			g_signal_parse_name ("changed", FILES_TYPE_CLIPBOARD_MANAGER, &_tmp7_, NULL, FALSE);
#line 237 "../src/View/AbstractDirectoryView.vala"
			g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self);
#line 21824 "AbstractDirectoryView.c"
		} else {
			FilesClipboardManager* _tmp8_;
#line 239 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->priv->clipboard;
#line 239 "../src/View/AbstractDirectoryView.vala"
			g_signal_connect_object (_tmp8_, "changed", (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self, 0);
#line 240 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_connect_tree_signals (self);
#line 242 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_update_menu_actions (self);
#line 21835 "AbstractDirectoryView.c"
		}
#line 245 "../src/View/AbstractDirectoryView.vala"
		if (value) {
#line 245 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = GTK_PHASE_NONE;
#line 21841 "AbstractDirectoryView.c"
		} else {
#line 245 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = GTK_PHASE_BUBBLE;
#line 21845 "AbstractDirectoryView.c"
		}
#line 245 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->key_controller;
#line 245 "../src/View/AbstractDirectoryView.vala"
		gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp10_, _tmp9_);
#line 21851 "AbstractDirectoryView.c"
	}
#line 224 "../src/View/AbstractDirectoryView.vala"
	g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY]);
#line 21855 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_in_recent (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 254 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 254 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_in_recent;
#line 254 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21868 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_in_recent (FilesAbstractDirectoryView* self,
                                             gboolean value)
{
	gboolean old_value;
#line 254 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_in_recent (self);
#line 254 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 254 "../src/View/AbstractDirectoryView.vala"
		self->priv->_in_recent = value;
#line 254 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY]);
#line 21886 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_tree_frozen (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 256 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 256 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_tree_frozen;
#line 256 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21900 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_tree_frozen (FilesAbstractDirectoryView* self,
                                               gboolean value)
{
	gboolean old_value;
#line 256 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_tree_frozen (self);
#line 256 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 256 "../src/View/AbstractDirectoryView.vala"
		self->priv->_tree_frozen = value;
#line 256 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY]);
#line 21918 "AbstractDirectoryView.c"
	}
}

FilesViewWindow*
files_abstract_directory_view_get_window (FilesAbstractDirectoryView* self)
{
	FilesViewWindow* result;
	FilesViewSlot* _tmp0_;
	FilesViewViewContainer* _tmp1_;
	FilesViewViewContainer* _tmp2_;
	FilesViewWindow* _tmp3_;
	FilesViewWindow* _tmp4_;
#line 271 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 272 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 272 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_view_slot_get_ctab (_tmp0_);
#line 272 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 272 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_view_view_container_get_window (_tmp2_);
#line 272 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 272 "../src/View/AbstractDirectoryView.vala"
	result = _tmp4_;
#line 272 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21947 "AbstractDirectoryView.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (gpointer data1, gpointer arg_1, gint arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (n_param_values == 4);
#line 29 "../src/View/AbstractDirectoryView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		data1 = closure->data;
#line 29 "../src/View/AbstractDirectoryView.vala"
		data2 = param_values->data[0].v_pointer;
#line 21972 "AbstractDirectoryView.c"
	} else {
#line 29 "../src/View/AbstractDirectoryView.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/View/AbstractDirectoryView.vala"
		data2 = closure->data;
#line 21978 "AbstractDirectoryView.c"
	}
#line 29 "../src/View/AbstractDirectoryView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/View/AbstractDirectoryView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), g_value_get_boolean (param_values + 3), data2);
#line 21984 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewSortSubMenuItem*
files_abstract_directory_view_sort_sub_menu_item_construct (GType object_type)
{
	FilesAbstractDirectoryViewSortSubMenuItem * self = NULL;
#line 2270 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryViewSortSubMenuItem*) g_object_new (object_type, NULL);
#line 2270 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 21995 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewSortSubMenuItem*
files_abstract_directory_view_sort_sub_menu_item_new (void)
{
#line 2270 "../src/View/AbstractDirectoryView.vala"
	return files_abstract_directory_view_sort_sub_menu_item_construct (FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM);
#line 22003 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new4 (const gchar* value)
{
#line 2274 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22011 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new5 (const gchar* value)
{
#line 2279 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22019 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new6 (const gchar* value)
{
#line 2284 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22027 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new7 (const gchar* value)
{
#line 2289 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22035 "AbstractDirectoryView.c"
}

static GObject *
files_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesAbstractDirectoryViewSortSubMenuItem * self;
	GtkCheckMenuItem* name_radioitem = NULL;
	GtkCheckMenuItem* _tmp0_;
	GtkCheckMenuItem* _tmp1_;
	GtkCheckMenuItem* _tmp2_;
	GVariant* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	GtkCheckMenuItem* size_radioitem = NULL;
	GtkCheckMenuItem* _tmp5_;
	GtkCheckMenuItem* _tmp6_;
	GtkCheckMenuItem* _tmp7_;
	GVariant* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* type_radioitem = NULL;
	GtkCheckMenuItem* _tmp10_;
	GtkCheckMenuItem* _tmp11_;
	GtkCheckMenuItem* _tmp12_;
	GVariant* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* date_radioitem = NULL;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GVariant* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* reversed_checkitem = NULL;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* _tmp21_;
	GtkCheckMenuItem* folders_first_checkitem = NULL;
	GtkCheckMenuItem* _tmp22_;
	GtkCheckMenuItem* _tmp23_;
	GtkMenu* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GtkCheckMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkMenu* _tmp30_;
	GtkCheckMenuItem* _tmp31_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkCheckMenuItem* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkCheckMenuItem* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenu* _tmp39_;
	GtkSeparatorMenuItem* _tmp40_;
	GtkSeparatorMenuItem* _tmp41_;
	GtkMenu* _tmp42_;
	GtkMenu* _tmp43_;
	GtkCheckMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GtkCheckMenuItem* _tmp47_;
#line 2271 "../src/View/AbstractDirectoryView.vala"
	parent_class = G_OBJECT_CLASS (files_abstract_directory_view_sort_sub_menu_item_parent_class);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItem);
#line 2272 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Name"));
#line 2272 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp0_);
#line 2272 "../src/View/AbstractDirectoryView.vala"
	name_radioitem = _tmp0_;
#line 2273 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = name_radioitem;
#line 2273 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp1_, "background.sort-by");
#line 2274 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = name_radioitem;
#line 2274 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _variant_new4 ("name");
#line 2274 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp2_, "action-target", _tmp3_, NULL);
#line 2274 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp3_);
#line 2275 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = name_radioitem;
#line 2275 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp4_, TRUE);
#line 2277 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Size"));
#line 2277 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp5_);
#line 2277 "../src/View/AbstractDirectoryView.vala"
	size_radioitem = _tmp5_;
#line 2278 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = size_radioitem;
#line 2278 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, "background.sort-by");
#line 2279 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = size_radioitem;
#line 2279 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _variant_new5 ("size");
#line 2279 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp7_, "action-target", _tmp8_, NULL);
#line 2279 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp8_);
#line 2280 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = size_radioitem;
#line 2280 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp9_, TRUE);
#line 2282 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Type"));
#line 2282 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp10_);
#line 2282 "../src/View/AbstractDirectoryView.vala"
	type_radioitem = _tmp10_;
#line 2283 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = type_radioitem;
#line 2283 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp11_, "background.sort-by");
#line 2284 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = type_radioitem;
#line 2284 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = _variant_new6 ("type");
#line 2284 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp12_, "action-target", _tmp13_, NULL);
#line 2284 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp13_);
#line 2285 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = type_radioitem;
#line 2285 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp14_, TRUE);
#line 2287 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Date"));
#line 2287 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp15_);
#line 2287 "../src/View/AbstractDirectoryView.vala"
	date_radioitem = _tmp15_;
#line 2288 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = date_radioitem;
#line 2288 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, "background.sort-by");
#line 2289 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = date_radioitem;
#line 2289 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = _variant_new7 ("modified");
#line 2289 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp17_, "action-target", _tmp18_, NULL);
#line 2289 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp18_);
#line 2290 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = date_radioitem;
#line 2290 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp19_, TRUE);
#line 2292 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Reversed Order"));
#line 2292 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp20_);
#line 2292 "../src/View/AbstractDirectoryView.vala"
	reversed_checkitem = _tmp20_;
#line 2293 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = reversed_checkitem;
#line 2293 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp21_, "background.reverse");
#line 2295 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Folders Before Files"));
#line 2295 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp22_);
#line 2295 "../src/View/AbstractDirectoryView.vala"
	folders_first_checkitem = _tmp22_;
#line 2296 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = folders_first_checkitem;
#line 2296 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp23_, "background.folders-first");
#line 2298 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = (GtkMenu*) gtk_menu_new ();
#line 2298 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp24_);
#line 2298 "../src/View/AbstractDirectoryView.vala"
	_tmp25_ = _tmp24_;
#line 2298 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp25_);
#line 2298 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp25_);
#line 2299 "../src/View/AbstractDirectoryView.vala"
	_tmp26_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2299 "../src/View/AbstractDirectoryView.vala"
	_tmp27_ = _tmp26_;
#line 2299 "../src/View/AbstractDirectoryView.vala"
	_tmp28_ = name_radioitem;
#line 2299 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 2300 "../src/View/AbstractDirectoryView.vala"
	_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2300 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = _tmp29_;
#line 2300 "../src/View/AbstractDirectoryView.vala"
	_tmp31_ = size_radioitem;
#line 2300 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 2301 "../src/View/AbstractDirectoryView.vala"
	_tmp32_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2301 "../src/View/AbstractDirectoryView.vala"
	_tmp33_ = _tmp32_;
#line 2301 "../src/View/AbstractDirectoryView.vala"
	_tmp34_ = type_radioitem;
#line 2301 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 2302 "../src/View/AbstractDirectoryView.vala"
	_tmp35_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2302 "../src/View/AbstractDirectoryView.vala"
	_tmp36_ = _tmp35_;
#line 2302 "../src/View/AbstractDirectoryView.vala"
	_tmp37_ = date_radioitem;
#line 2302 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 2303 "../src/View/AbstractDirectoryView.vala"
	_tmp38_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2303 "../src/View/AbstractDirectoryView.vala"
	_tmp39_ = _tmp38_;
#line 2303 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2303 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp40_);
#line 2303 "../src/View/AbstractDirectoryView.vala"
	_tmp41_ = _tmp40_;
#line 2303 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp41_);
#line 2303 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp41_);
#line 2304 "../src/View/AbstractDirectoryView.vala"
	_tmp42_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2304 "../src/View/AbstractDirectoryView.vala"
	_tmp43_ = _tmp42_;
#line 2304 "../src/View/AbstractDirectoryView.vala"
	_tmp44_ = reversed_checkitem;
#line 2304 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 2305 "../src/View/AbstractDirectoryView.vala"
	_tmp45_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2305 "../src/View/AbstractDirectoryView.vala"
	_tmp46_ = _tmp45_;
#line 2305 "../src/View/AbstractDirectoryView.vala"
	_tmp47_ = folders_first_checkitem;
#line 2305 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 2307 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("Sort by"));
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (folders_first_checkitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (reversed_checkitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (date_radioitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (type_radioitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (size_radioitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (name_radioitem);
#line 2271 "../src/View/AbstractDirectoryView.vala"
	return obj;
#line 22302 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_sort_sub_menu_item_class_init (FilesAbstractDirectoryViewSortSubMenuItemClass * klass,
                                                             gpointer klass_data)
{
#line 2270 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_sort_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 2270 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->constructor = files_abstract_directory_view_sort_sub_menu_item_constructor;
#line 22313 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_sort_sub_menu_item_instance_init (FilesAbstractDirectoryViewSortSubMenuItem * self,
                                                                gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_sort_sub_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewSortSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_sort_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryViewSortSubMenuItem), 0, (GInstanceInitFunc) files_abstract_directory_view_sort_sub_menu_item_instance_init, NULL };
	GType files_abstract_directory_view_sort_sub_menu_item_type_id;
	files_abstract_directory_view_sort_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FilesAbstractDirectoryViewSortSubMenuItem", &g_define_type_info, 0);
	return files_abstract_directory_view_sort_sub_menu_item_type_id;
}

static GType
files_abstract_directory_view_sort_sub_menu_item_get_type (void)
{
	static volatile gsize files_abstract_directory_view_sort_sub_menu_item_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_sort_sub_menu_item_type_id__once)) {
		GType files_abstract_directory_view_sort_sub_menu_item_type_id;
		files_abstract_directory_view_sort_sub_menu_item_type_id = files_abstract_directory_view_sort_sub_menu_item_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_sort_sub_menu_item_type_id__once, files_abstract_directory_view_sort_sub_menu_item_type_id);
	}
	return files_abstract_directory_view_sort_sub_menu_item_type_id__once;
}

static FilesAbstractDirectoryViewNewSubMenuItem*
files_abstract_directory_view_new_sub_menu_item_construct (GType object_type)
{
	FilesAbstractDirectoryViewNewSubMenuItem * self = NULL;
#line 2311 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryViewNewSubMenuItem*) g_object_new (object_type, NULL);
#line 2311 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 22351 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewNewSubMenuItem*
files_abstract_directory_view_new_sub_menu_item_new (void)
{
#line 2311 "../src/View/AbstractDirectoryView.vala"
	return files_abstract_directory_view_new_sub_menu_item_construct (FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM);
#line 22359 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new8 (const gchar* value)
{
#line 2319 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22367 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new9 (const gchar* value)
{
#line 2323 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22375 "AbstractDirectoryView.c"
}

static GObject *
files_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesAbstractDirectoryViewNewSubMenuItem * self;
	GtkMenuItem* folder_menuitem = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GraniteAccelLabel* _tmp2_;
	GraniteAccelLabel* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GVariant* _tmp6_;
	GtkMenuItem* file_menuitem = NULL;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GVariant* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenu* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	const gchar* template_path = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 2312 "../src/View/AbstractDirectoryView.vala"
	parent_class = G_OBJECT_CLASS (files_abstract_directory_view_new_sub_menu_item_parent_class);
#line 2312 "../src/View/AbstractDirectoryView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2312 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItem);
#line 2313 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2313 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp0_);
#line 2313 "../src/View/AbstractDirectoryView.vala"
	folder_menuitem = _tmp0_;
#line 2314 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = folder_menuitem;
#line 2314 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = granite_accel_label_new (_ ("Folder"), "<Ctrl><Shift>n");
#line 2314 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp2_);
#line 2314 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 2314 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp3_);
#line 2314 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp3_);
#line 2318 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = folder_menuitem;
#line 2318 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, "background.new");
#line 2319 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = folder_menuitem;
#line 2319 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _variant_new8 ("FOLDER");
#line 2319 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp5_, "action-target", _tmp6_, NULL);
#line 2319 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp6_);
#line 2321 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Empty File"));
#line 2321 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp7_);
#line 2321 "../src/View/AbstractDirectoryView.vala"
	file_menuitem = _tmp7_;
#line 2322 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = file_menuitem;
#line 2322 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp8_, "background.new");
#line 2323 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = file_menuitem;
#line 2323 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _variant_new9 ("FILE");
#line 2323 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp9_, "action-target", _tmp10_, NULL);
#line 2323 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp10_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = (GtkMenu*) gtk_menu_new ();
#line 2325 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp11_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _tmp11_;
#line 2325 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp12_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp12_);
#line 2326 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2326 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = _tmp13_;
#line 2326 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = folder_menuitem;
#line 2326 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 2327 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2327 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 2327 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = file_menuitem;
#line 2327 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 2330 "../src/View/AbstractDirectoryView.vala"
	(files_abstract_directory_view_templates == NULL) ? NULL : (files_abstract_directory_view_templates = (_g_list_free__g_object_unref0_ (files_abstract_directory_view_templates), NULL));
#line 2330 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_templates = NULL;
#line 2331 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = g_get_user_special_dir (G_USER_DIRECTORY_TEMPLATES);
#line 2331 "../src/View/AbstractDirectoryView.vala"
	template_path = _tmp19_;
#line 2332 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = template_path;
#line 2332 "../src/View/AbstractDirectoryView.vala"
	if (_tmp20_ != NULL) {
#line 22502 "AbstractDirectoryView.c"
		GFile* template_folder = NULL;
		const gchar* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GList* _tmp24_;
#line 2333 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = template_path;
#line 2333 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = g_file_new_for_path (_tmp21_);
#line 2333 "../src/View/AbstractDirectoryView.vala"
		template_folder = _tmp22_;
#line 2334 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = template_folder;
#line 2334 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_load_templates_from_folder (_tmp23_);
#line 2336 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_abstract_directory_view_templates;
#line 2336 "../src/View/AbstractDirectoryView.vala"
		if (g_list_length (_tmp24_) > ((guint) 0)) {
#line 22522 "AbstractDirectoryView.c"
			GtkMenu* _tmp25_;
			GtkMenu* _tmp26_;
			GtkSeparatorMenuItem* _tmp27_;
			GtkSeparatorMenuItem* _tmp28_;
			GtkMenu* active_submenu = NULL;
			GtkMenu* _tmp29_;
			GtkMenu* _tmp30_;
			GtkMenu* _tmp31_;
			gint index = 0;
			GList* _tmp32_;
#line 2337 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2337 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = _tmp25_;
#line 2337 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2337 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp27_);
#line 2337 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = _tmp27_;
#line 2337 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp28_);
#line 2337 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp28_);
#line 2340 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_templates = g_list_reverse (files_abstract_directory_view_templates);
#line 2342 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2342 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = _tmp29_;
#line 2342 "../src/View/AbstractDirectoryView.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 2342 "../src/View/AbstractDirectoryView.vala"
			active_submenu = _tmp31_;
#line 2343 "../src/View/AbstractDirectoryView.vala"
			index = 0;
#line 2344 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = files_abstract_directory_view_templates;
#line 22561 "AbstractDirectoryView.c"
			{
				GList* template_collection = NULL;
				GList* template_it = NULL;
#line 2344 "../src/View/AbstractDirectoryView.vala"
				template_collection = _tmp32_;
#line 2344 "../src/View/AbstractDirectoryView.vala"
				for (template_it = template_collection; template_it != NULL; template_it = template_it->next) {
#line 22569 "AbstractDirectoryView.c"
					GFile* template = NULL;
#line 2344 "../src/View/AbstractDirectoryView.vala"
					template = (GFile*) template_it->data;
#line 22573 "AbstractDirectoryView.c"
					{
						gchar* label = NULL;
						GFile* _tmp33_;
						gchar* _tmp34_;
						GFileType ftype = 0;
						GFile* _tmp35_;
						gint _tmp58_;
#line 2345 "../src/View/AbstractDirectoryView.vala"
						_tmp33_ = template;
#line 2345 "../src/View/AbstractDirectoryView.vala"
						_tmp34_ = g_file_get_basename (_tmp33_);
#line 2345 "../src/View/AbstractDirectoryView.vala"
						label = _tmp34_;
#line 2346 "../src/View/AbstractDirectoryView.vala"
						_tmp35_ = template;
#line 2346 "../src/View/AbstractDirectoryView.vala"
						ftype = g_file_query_file_type (_tmp35_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 2347 "../src/View/AbstractDirectoryView.vala"
						if (ftype == G_FILE_TYPE_DIRECTORY) {
#line 22593 "AbstractDirectoryView.c"
							GFile* _tmp36_;
							GFile* _tmp37_;
#line 2348 "../src/View/AbstractDirectoryView.vala"
							_tmp36_ = template;
#line 2348 "../src/View/AbstractDirectoryView.vala"
							_tmp37_ = template_folder;
#line 2348 "../src/View/AbstractDirectoryView.vala"
							if (_tmp36_ == _tmp37_) {
#line 22602 "AbstractDirectoryView.c"
								GtkMenu* _tmp38_;
								GtkMenu* _tmp39_;
								GtkMenu* _tmp40_;
#line 2349 "../src/View/AbstractDirectoryView.vala"
								_tmp38_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2349 "../src/View/AbstractDirectoryView.vala"
								_tmp39_ = _tmp38_;
#line 2349 "../src/View/AbstractDirectoryView.vala"
								_tmp40_ = _g_object_ref0 (_tmp39_);
#line 2349 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (active_submenu);
#line 2349 "../src/View/AbstractDirectoryView.vala"
								active_submenu = _tmp40_;
#line 22616 "AbstractDirectoryView.c"
							} else {
								GtkMenu* _tmp41_;
								GtkMenuItem* submenu_item = NULL;
								const gchar* _tmp42_;
								GtkMenuItem* _tmp43_;
								GtkMenuItem* _tmp44_;
								GtkMenu* _tmp45_;
								GtkMenu* _tmp46_;
								GtkMenu* _tmp47_;
								GtkMenuItem* _tmp48_;
#line 2351 "../src/View/AbstractDirectoryView.vala"
								_tmp41_ = (GtkMenu*) gtk_menu_new ();
#line 2351 "../src/View/AbstractDirectoryView.vala"
								g_object_ref_sink (_tmp41_);
#line 2351 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (active_submenu);
#line 2351 "../src/View/AbstractDirectoryView.vala"
								active_submenu = _tmp41_;
#line 2353 "../src/View/AbstractDirectoryView.vala"
								_tmp42_ = label;
#line 2353 "../src/View/AbstractDirectoryView.vala"
								_tmp43_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp42_);
#line 2353 "../src/View/AbstractDirectoryView.vala"
								g_object_ref_sink (_tmp43_);
#line 2353 "../src/View/AbstractDirectoryView.vala"
								submenu_item = _tmp43_;
#line 2354 "../src/View/AbstractDirectoryView.vala"
								_tmp44_ = submenu_item;
#line 2354 "../src/View/AbstractDirectoryView.vala"
								_tmp45_ = active_submenu;
#line 2354 "../src/View/AbstractDirectoryView.vala"
								gtk_menu_item_set_submenu (_tmp44_, _tmp45_);
#line 2356 "../src/View/AbstractDirectoryView.vala"
								_tmp46_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2356 "../src/View/AbstractDirectoryView.vala"
								_tmp47_ = _tmp46_;
#line 2356 "../src/View/AbstractDirectoryView.vala"
								_tmp48_ = submenu_item;
#line 2356 "../src/View/AbstractDirectoryView.vala"
								gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 2348 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (submenu_item);
#line 22659 "AbstractDirectoryView.c"
							}
						} else {
							GtkMenuItem* template_menuitem = NULL;
							const gchar* _tmp49_;
							GtkMenuItem* _tmp50_;
							GtkMenuItem* _tmp51_;
							gchar* _tmp52_;
							gchar* _tmp53_;
							gchar* _tmp54_;
							gchar* _tmp55_;
							GtkMenu* _tmp56_;
							GtkMenuItem* _tmp57_;
#line 2359 "../src/View/AbstractDirectoryView.vala"
							_tmp49_ = label;
#line 2359 "../src/View/AbstractDirectoryView.vala"
							_tmp50_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp49_);
#line 2359 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp50_);
#line 2359 "../src/View/AbstractDirectoryView.vala"
							template_menuitem = _tmp50_;
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_tmp51_ = template_menuitem;
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_tmp52_ = g_strdup_printf ("%i", index);
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_tmp53_ = _tmp52_;
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_tmp54_ = g_strconcat ("background.create-from::", _tmp53_, NULL);
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_tmp55_ = _tmp54_;
#line 2360 "../src/View/AbstractDirectoryView.vala"
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp51_, _tmp55_);
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp55_);
#line 2360 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp53_);
#line 2363 "../src/View/AbstractDirectoryView.vala"
							_tmp56_ = active_submenu;
#line 2363 "../src/View/AbstractDirectoryView.vala"
							_tmp57_ = template_menuitem;
#line 2363 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 2347 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (template_menuitem);
#line 22704 "AbstractDirectoryView.c"
						}
#line 2367 "../src/View/AbstractDirectoryView.vala"
						_tmp58_ = index;
#line 2367 "../src/View/AbstractDirectoryView.vala"
						index = _tmp58_ + 1;
#line 2344 "../src/View/AbstractDirectoryView.vala"
						_g_free0 (label);
#line 22712 "AbstractDirectoryView.c"
					}
				}
			}
#line 2336 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (active_submenu);
#line 22718 "AbstractDirectoryView.c"
		}
#line 2332 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (template_folder);
#line 22722 "AbstractDirectoryView.c"
	}
#line 2372 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("New"));
#line 2312 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file_menuitem);
#line 2312 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (folder_menuitem);
#line 2312 "../src/View/AbstractDirectoryView.vala"
	return obj;
#line 22732 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_sub_menu_item_class_init (FilesAbstractDirectoryViewNewSubMenuItemClass * klass,
                                                            gpointer klass_data)
{
#line 2311 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_new_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 2311 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->constructor = files_abstract_directory_view_new_sub_menu_item_constructor;
#line 22743 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_sub_menu_item_instance_init (FilesAbstractDirectoryViewNewSubMenuItem * self,
                                                               gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_new_sub_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewNewSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_new_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryViewNewSubMenuItem), 0, (GInstanceInitFunc) files_abstract_directory_view_new_sub_menu_item_instance_init, NULL };
	GType files_abstract_directory_view_new_sub_menu_item_type_id;
	files_abstract_directory_view_new_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FilesAbstractDirectoryViewNewSubMenuItem", &g_define_type_info, 0);
	return files_abstract_directory_view_new_sub_menu_item_type_id;
}

static GType
files_abstract_directory_view_new_sub_menu_item_get_type (void)
{
	static volatile gsize files_abstract_directory_view_new_sub_menu_item_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_new_sub_menu_item_type_id__once)) {
		GType files_abstract_directory_view_new_sub_menu_item_type_id;
		files_abstract_directory_view_new_sub_menu_item_type_id = files_abstract_directory_view_new_sub_menu_item_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_new_sub_menu_item_type_id__once, files_abstract_directory_view_new_sub_menu_item_type_id);
	}
	return files_abstract_directory_view_new_sub_menu_item_type_id__once;
}

static void
files_abstract_directory_view_class_init (FilesAbstractDirectoryViewClass * klass,
                                          gpointer klass_data)
{
	FilesDndHandler* _tmp0_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_type_class_adjust_private_offset (klass, &FilesAbstractDirectoryView_private_offset);
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_row_deleted = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_on_row_deleted;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_key_press_event = (gboolean (*) (FilesAbstractDirectoryView*, guint, guint, GdkModifierType)) files_abstract_directory_view_real_on_view_key_press_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_scroll_event = (void (*) (FilesAbstractDirectoryView*, gdouble, gdouble)) files_abstract_directory_view_real_on_scroll_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_draw = (gboolean (*) (FilesAbstractDirectoryView*, cairo_t*)) files_abstract_directory_view_real_on_view_draw;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_primary_button_click = (gboolean (*) (FilesAbstractDirectoryView*, guint, GdkModifierType, GtkTreePath*)) files_abstract_directory_view_real_handle_primary_button_click;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_button_press_event = (void (*) (FilesAbstractDirectoryView*, gint, gdouble, gdouble)) files_abstract_directory_view_real_on_view_button_press_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_button_release_event = (void (*) (FilesAbstractDirectoryView*, gint, gdouble, gdouble)) files_abstract_directory_view_real_on_view_button_release_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->change_zoom_level = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_change_zoom_level;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->expand_collapse = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_expand_collapse;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_default_button_click = (gboolean (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_handle_default_button_click;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_next_visible_iter = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreeIter*, gboolean)) files_abstract_directory_view_real_get_next_visible_iter;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->cancel = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_cancel;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->highlight_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_highlight_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->up = (GtkTreePath* (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_up;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->down = (GtkTreePath* (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_down;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_view_settings = (GSettings* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_view_settings;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_up_zoom_level = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_set_up_zoom_level;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->view_has_focus = (gboolean (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_view_has_focus;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->scroll_to_cell = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean)) files_abstract_directory_view_real_scroll_to_cell;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_selected_paths = (GList* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_selected_paths;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_path_at_pos = (GtkTreePath* (*) (FilesAbstractDirectoryView*, gint, gint)) files_abstract_directory_view_real_get_path_at_pos;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_path_at_cursor = (GtkTreePath* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_path_at_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_select_all = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_select_all;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_unselect_all = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_unselect_all;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_unselect_others = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_unselect_others;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->select_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean)) files_abstract_directory_view_real_select_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->unselect_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_unselect_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->path_is_selected = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_path_is_selected;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_visible_range = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath**, GtkTreePath**)) files_abstract_directory_view_real_get_visible_range;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_cursor = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean, gboolean, gboolean)) files_abstract_directory_view_real_set_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->move_cursor = (gboolean (*) (FilesAbstractDirectoryView*, guint, gboolean, gboolean)) files_abstract_directory_view_real_move_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->will_handle_button_press = (gboolean (*) (FilesAbstractDirectoryView*, gboolean, gboolean, gboolean)) files_abstract_directory_view_real_will_handle_button_press;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_multi_select = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_handle_multi_select;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->create_view = (GtkWidget* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_create_view;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_event_position_info = (guint (*) (FilesAbstractDirectoryView*, gdouble, gdouble, GtkTreePath**, gboolean)) files_abstract_directory_view_real_get_event_position_info;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->scroll_to_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean)) files_abstract_directory_view_real_scroll_to_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_cursor_on_cell = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, GtkCellRenderer*, gboolean, gboolean)) files_abstract_directory_view_real_set_cursor_on_cell;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->freeze_tree = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_freeze_tree;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->thaw_tree = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_thaw_tree;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->freeze_child_notify = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_freeze_child_notify;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->thaw_child_notify = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_thaw_child_notify;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->connect_tree_signals = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_connect_tree_signals;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->disconnect_tree_signals = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_disconnect_tree_signals;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_abstract_directory_view_get_property;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_abstract_directory_view_set_property;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->finalize = files_abstract_directory_view_finalize;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY] = g_param_spec_enum ("zoom-level", "zoom-level", "zoom-level", FILES_TYPE_ZOOM_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY] = g_param_spec_boolean ("singleclick-select", "singleclick-select", "singleclick-select", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY] = g_param_spec_boolean ("renaming", "renaming", "renaming", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY] = g_param_spec_boolean ("is-frozen", "is-frozen", "is-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY] = g_param_spec_boolean ("in-recent", "in-recent", "in-recent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY] = g_param_spec_boolean ("tree-frozen", "tree-frozen", "tree-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_WINDOW_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", FILES_VIEW_TYPE_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL] = g_signal_new ("path-change-request", FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN, G_TYPE_NONE, 3, g_file_get_type (), FILES_TYPE_OPEN_FLAG, G_TYPE_BOOLEAN);
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 275 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_dnd_handler_new ();
#line 275 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_dnd_handler = _tmp0_;
#line 22898 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_instance_init (FilesAbstractDirectoryView * self,
                                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	self->priv = files_abstract_directory_view_get_instance_private (self);
#line 98 "../src/View/AbstractDirectoryView.vala"
	self->priv->_zoom_level = FILES_ZOOM_LEVEL_NORMAL;
#line 123 "../src/View/AbstractDirectoryView.vala"
	self->minimum_zoom = FILES_ZOOM_LEVEL_SMALLEST;
#line 124 "../src/View/AbstractDirectoryView.vala"
	self->maximum_zoom = FILES_ZOOM_LEVEL_LARGEST;
#line 127 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_x = (gdouble) 0;
#line 128 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_y = (gdouble) 0;
#line 129 "../src/View/AbstractDirectoryView.vala"
	self->source_drag_file_list = NULL;
#line 130 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = GDK_NONE;
#line 133 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_scroll_timer_id = (guint) 0;
#line 134 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_enter_timer_id = (guint) 0;
#line 135 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_data_ready = FALSE;
#line 136 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_occurred = FALSE;
#line 137 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_target_file = NULL;
#line 138 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_drop_file_list = NULL;
#line 139 "../src/View/AbstractDirectoryView.vala"
	self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
#line 140 "../src/View/AbstractDirectoryView.vala"
	self->priv->current_actions = GDK_ACTION_DEFAULT;
#line 161 "../src/View/AbstractDirectoryView.vala"
	self->dnd_disabled = FALSE;
#line 163 "../src/View/AbstractDirectoryView.vala"
	self->priv->button_press_disabled = FALSE;
#line 167 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_request = -1;
#line 168 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = (guint) 0;
#line 169 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = (guint) 0;
#line 170 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnailer = NULL;
#line 173 "../src/View/AbstractDirectoryView.vala"
	self->priv->add_remove_file_timeout_id = (guint) 0;
#line 174 "../src/View/AbstractDirectoryView.vala"
	self->priv->signal_free_space_change = FALSE;
#line 177 "../src/View/AbstractDirectoryView.vala"
	self->name_renderer = NULL;
#line 178 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_strdup ("");
#line 178 "../src/View/AbstractDirectoryView.vala"
	self->original_name = _tmp0_;
#line 179 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 179 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp1_;
#line 182 "../src/View/AbstractDirectoryView.vala"
	self->priv->total_delta_y = 0.0;
#line 188 "../src/View/AbstractDirectoryView.vala"
	self->right_margin_unselects_all = FALSE;
#line 189 "../src/View/AbstractDirectoryView.vala"
	self->on_directory = FALSE;
#line 190 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = TRUE;
#line 191 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 192 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 193 "../src/View/AbstractDirectoryView.vala"
	self->should_thumbnail = TRUE;
#line 197 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 198 "../src/View/AbstractDirectoryView.vala"
	self->click_path = NULL;
#line 199 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = (guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
#line 200 "../src/View/AbstractDirectoryView.vala"
	self->previous_click_zone = (guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
#line 212 "../src/View/AbstractDirectoryView.vala"
	self->selected_files = NULL;
#line 213 "../src/View/AbstractDirectoryView.vala"
	self->priv->selected_files_invalid = TRUE;
#line 218 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 220 "../src/View/AbstractDirectoryView.vala"
	self->priv->_renaming = FALSE;
#line 222 "../src/View/AbstractDirectoryView.vala"
	self->priv->_is_frozen = FALSE;
#line 254 "../src/View/AbstractDirectoryView.vala"
	self->priv->_in_recent = FALSE;
#line 256 "../src/View/AbstractDirectoryView.vala"
	self->priv->_tree_frozen = FALSE;
#line 257 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_trash = FALSE;
#line 258 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_network_root = FALSE;
#line 259 "../src/View/AbstractDirectoryView.vala"
	self->is_writable = FALSE;
#line 263 "../src/View/AbstractDirectoryView.vala"
	self->priv->all_selected = FALSE;
#line 459 "../src/View/AbstractDirectoryView.vala"
	self->priv->set_cursor_timeout_id = (guint) 0;
#line 478 "../src/View/AbstractDirectoryView.vala"
	self->priv->select_source_handler = (gulong) 0;
#line 2768 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = (guint) 0;
#line 23015 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_finalize (GObject * obj)
{
	FilesAbstractDirectoryView * self;
#line 29 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 372 "../src/View/AbstractDirectoryView.vala"
	g_debug ("AbstractDirectoryView.vala:372: ADV destruct");
#line 94 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->common_actions);
#line 95 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selection_actions);
#line 96 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->background_actions);
#line 129 "../src/View/AbstractDirectoryView.vala"
	(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 137 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->drop_target_file);
#line 138 "../src/View/AbstractDirectoryView.vala"
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 170 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->thumbnailer);
#line 177 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->name_renderer);
#line 178 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->original_name);
#line 179 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 185 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
#line 198 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 203 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->editable_cursor);
#line 204 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->activatable_cursor);
#line 205 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selectable_cursor);
#line 207 "../src/View/AbstractDirectoryView.vala"
	(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
#line 212 "../src/View/AbstractDirectoryView.vala"
	(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 217 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 218 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 265 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->view);
#line 267 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->model);
#line 268 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->icon_renderer);
#line 279 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->key_controller);
#line 280 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->button_controller);
#line 281 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->scroll_controller);
#line 282 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->motion_controller);
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (files_abstract_directory_view_parent_class)->finalize (obj);
#line 23080 "AbstractDirectoryView.c"
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryView), 0, (GInstanceInitFunc) files_abstract_directory_view_instance_init, NULL };
	GType files_abstract_directory_view_type_id;
	files_abstract_directory_view_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "FilesAbstractDirectoryView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	FilesAbstractDirectoryView_private_offset = g_type_add_instance_private (files_abstract_directory_view_type_id, sizeof (FilesAbstractDirectoryViewPrivate));
	return files_abstract_directory_view_type_id;
}

GType
files_abstract_directory_view_get_type (void)
{
	static volatile gsize files_abstract_directory_view_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_type_id__once)) {
		GType files_abstract_directory_view_type_id;
		files_abstract_directory_view_type_id = files_abstract_directory_view_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_type_id__once, files_abstract_directory_view_type_id);
	}
	return files_abstract_directory_view_type_id__once;
}

static void
_vala_files_abstract_directory_view_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	FilesAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 29 "../src/View/AbstractDirectoryView.vala"
	switch (property_id) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_enum (value, files_abstract_directory_view_get_zoom_level (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_int (value, files_abstract_directory_view_get_icon_size (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_singleclick_select (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_renaming (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_is_frozen (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_in_recent (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_tree_frozen (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_WINDOW_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_object (value, files_abstract_directory_view_get_window (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23163 "AbstractDirectoryView.c"
		default:
#line 29 "../src/View/AbstractDirectoryView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23169 "AbstractDirectoryView.c"
	}
}

static void
_vala_files_abstract_directory_view_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	FilesAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 29 "../src/View/AbstractDirectoryView.vala"
	switch (property_id) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, g_value_get_enum (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_singleclick_select (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_renaming (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_is_frozen (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_in_recent (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_tree_frozen (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23219 "AbstractDirectoryView.c"
		default:
#line 29 "../src/View/AbstractDirectoryView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23225 "AbstractDirectoryView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

