/* AbstractMountableRow.c generated by valac 0.56.17, the Vala compiler
 * generated from AbstractMountableRow.vala, do not modify */

/* DeviceRow.vala
 *
 * Copyright 2021 elementary LLC. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors : Jeremy Wootten <jeremy@elementaryos.org>
 */
/* Used to determine first level sort order.*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include "pantheon-files-core.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	MOUNTABLE_TYPE_VOLUMELESS_MOUNT,
	MOUNTABLE_TYPE_VOLUME,
	MOUNTABLE_TYPE_EMPTY_DRIVE
} MountableType;

#define TYPE_MOUNTABLE_TYPE (mountable_type_get_type ())

#define SIDEBAR_TYPE_BOOKMARK_ROW (sidebar_bookmark_row_get_type ())
#define SIDEBAR_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow))
#define SIDEBAR_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))
#define SIDEBAR_IS_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_IS_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_BOOKMARK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))

typedef struct _SidebarBookmarkRow SidebarBookmarkRow;
typedef struct _SidebarBookmarkRowClass SidebarBookmarkRowClass;
typedef struct _SidebarBookmarkRowPrivate SidebarBookmarkRowPrivate;

#define SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW (sidebar_abstract_mountable_row_get_type ())
#define SIDEBAR_ABSTRACT_MOUNTABLE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRow))
#define SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRowClass))
#define SIDEBAR_IS_ABSTRACT_MOUNTABLE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW))
#define SIDEBAR_IS_ABSTRACT_MOUNTABLE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW))
#define SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRowClass))

typedef struct _SidebarAbstractMountableRow SidebarAbstractMountableRow;
typedef struct _SidebarAbstractMountableRowClass SidebarAbstractMountableRowClass;
typedef struct _SidebarAbstractMountableRowPrivate SidebarAbstractMountableRowPrivate;
enum  {
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_0_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_IS_MOUNTED_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_UNMOUNT_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_EJECT_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY,
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_NUM_PROPERTIES
};
static GParamSpec* sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SidebarAbstractMountableRowUnmountMountData SidebarAbstractMountableRowUnmountMountData;
typedef struct _SidebarAbstractMountableRowEjectMountData SidebarAbstractMountableRowEjectMountData;
typedef struct _SidebarAbstractMountableRowSafelyRemoveDriveData SidebarAbstractMountableRowSafelyRemoveDriveData;
typedef struct _SidebarAbstractMountableRowEjectDriveData SidebarAbstractMountableRowEjectDriveData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SidebarAbstractMountableRowGetFilesystemSpaceForRootData SidebarAbstractMountableRowGetFilesystemSpaceForRootData;
typedef struct _SidebarAbstractMountableRowGetStorageTextData SidebarAbstractMountableRowGetStorageTextData;
typedef struct _SidebarAbstractMountableRowAddMountableTooltipData SidebarAbstractMountableRowAddMountableTooltipData;
typedef struct _SidebarAbstractMountableRowGetFilesystemSpaceData SidebarAbstractMountableRowGetFilesystemSpaceData;

struct _SidebarBookmarkRow {
	GtkListBoxRow parent_instance;
	SidebarBookmarkRowPrivate * priv;
	GtkGrid* content_grid;
	GtkGrid* icon_label_grid;
	GtkStack* label_stack;
	GtkEntry* editable;
	GtkLabel* label;
	GtkRevealer* drop_revealer;
};

struct _SidebarBookmarkRowClass {
	GtkListBoxRowClass parent_class;
	gboolean (*on_key_press_event) (SidebarBookmarkRow* self, guint keyval, guint keycode, GdkModifierType state);
	void (*on_button_release_event) (SidebarBookmarkRow* self, gint n_press, gdouble x, gdouble y);
	void (*popup_context_menu) (SidebarBookmarkRow* self);
};

struct _SidebarAbstractMountableRow {
	SidebarBookmarkRow parent_instance;
	SidebarAbstractMountableRowPrivate * priv;
	gboolean valid;
};

struct _SidebarAbstractMountableRowClass {
	SidebarBookmarkRowClass parent_class;
	void (*update_free_space) (SidebarAbstractMountableRow* self);
	void (*add_mountable_tooltip) (SidebarAbstractMountableRow* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*add_mountable_tooltip_finish) (SidebarAbstractMountableRow* self, GAsyncResult* _res_);
	void (*on_mount_removed) (SidebarAbstractMountableRow* self, GMount* removed_mount);
	void (*on_mount_added) (SidebarAbstractMountableRow* self, GMount* added_mount);
	void (*show_mount_info) (SidebarAbstractMountableRow* self);
	void (*get_filesystem_space) (SidebarAbstractMountableRow* self, GCancellable* update_cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*get_filesystem_space_finish) (SidebarAbstractMountableRow* self, GAsyncResult* _res_);
	gboolean (*get_is_mounted) (SidebarAbstractMountableRow* self);
	gboolean (*get_can_unmount) (SidebarAbstractMountableRow* self);
	gboolean (*get_can_eject) (SidebarAbstractMountableRow* self);
};

struct _SidebarAbstractMountableRowPrivate {
	gdouble storage_capacity;
	gdouble storage_free;
	gchar* _sort_key;
	GtkStack* unmount_eject_working_stack;
	GtkRevealer* unmount_eject_revealer;
	GtkSpinner* working_spinner;
	GtkButton* unmount_eject_button;
	GtkLevelBar* storage_levelbar;
	GMount* _mount;
	GDrive* _drive;
	gchar* _uuid;
	gboolean _working;
};

struct _SidebarAbstractMountableRowUnmountMountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean success;
	GMount* _tmp6_;
	GtkWindow* _tmp7_;
	GtkWindow* _tmp8_;
	gboolean _tmp9_;
};

struct _SidebarAbstractMountableRowEjectMountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean success;
	GMount* _tmp6_;
	GtkWindow* _tmp7_;
	GtkWindow* _tmp8_;
	gboolean _tmp9_;
};

struct _SidebarAbstractMountableRowSafelyRemoveDriveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GDrive* _tmp4_;
	GDrive* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GDrive* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GDrive* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GDrive* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GDrive* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GDrive* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GDrive* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GDrive* _tmp26_;
	GtkWindow* _tmp27_;
	GtkWindow* _tmp28_;
};

struct _SidebarAbstractMountableRowEjectDriveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GDrive* _tmp4_;
	GDrive* _tmp5_;
	GtkWindow* _tmp6_;
	GtkWindow* _tmp7_;
};

struct _SidebarAbstractMountableRowGetFilesystemSpaceForRootData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	GFile* root;
	GCancellable* update_cancellable;
	gboolean result;
	gchar* scheme;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GNetworkMonitor* net_mon;
	GNetworkMonitor* _tmp7_;
	GNetworkMonitor* _tmp8_;
	GNetworkMonitor* _tmp9_;
	GFileInfo* info;
	GFileInfo* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	GError* _error_;
	GError* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GError* _tmp16_;
	const gchar* _tmp17_;
	gboolean _tmp18_;
	GFileInfo* _tmp19_;
	GFileInfo* _tmp20_;
	GFileInfo* _tmp21_;
	GFileInfo* _tmp22_;
	GFileInfo* _tmp23_;
	GError* _inner_error0_;
};

struct _SidebarAbstractMountableRowGetStorageTextData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gchar* result;
	gchar* storage_text;
	gchar* _tmp0_;
	gchar* used_string;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* size_string;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GtkLevelBar* _tmp14_;
	GtkLevelBar* _tmp15_;
	GtkLevelBar* _tmp16_;
};

struct _SidebarAbstractMountableRowAddMountableTooltipData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	gchar* storage_text;
	gchar* _tmp0_;
	gchar* mount_text;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
};

struct _SidebarAbstractMountableRowGetFilesystemSpaceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SidebarAbstractMountableRow* self;
	GCancellable* update_cancellable;
	gboolean result;
};

static gint SidebarAbstractMountableRow_private_offset;
static gpointer sidebar_abstract_mountable_row_parent_class = NULL;
VALA_EXTERN GtkCssProvider* sidebar_abstract_mountable_row_devicerow_provider;
GtkCssProvider* sidebar_abstract_mountable_row_devicerow_provider = NULL;
VALA_EXTERN GVolumeMonitor* sidebar_abstract_mountable_row_volume_monitor;
GVolumeMonitor* sidebar_abstract_mountable_row_volume_monitor = NULL;
static SidebarSidebarItemInterfaceIface * sidebar_abstract_mountable_row_sidebar_sidebar_item_interface_parent_iface = NULL;

VALA_EXTERN GType mountable_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType sidebar_bookmark_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarBookmarkRow, g_object_unref)
VALA_EXTERN GType sidebar_abstract_mountable_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarAbstractMountableRow, g_object_unref)
VALA_EXTERN void sidebar_abstract_mountable_row_update_free_space (SidebarAbstractMountableRow* self);
VALA_EXTERN void sidebar_abstract_mountable_row_add_mountable_tooltip (SidebarAbstractMountableRow* self,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
VALA_EXTERN void sidebar_abstract_mountable_row_add_mountable_tooltip_finish (SidebarAbstractMountableRow* self,
                                                                  GAsyncResult* _res_);
VALA_EXTERN void sidebar_abstract_mountable_row_on_mount_removed (SidebarAbstractMountableRow* self,
                                                      GMount* removed_mount);
VALA_EXTERN void sidebar_abstract_mountable_row_on_mount_added (SidebarAbstractMountableRow* self,
                                                    GMount* added_mount);
VALA_EXTERN void sidebar_abstract_mountable_row_show_mount_info (SidebarAbstractMountableRow* self);
VALA_EXTERN void sidebar_abstract_mountable_row_get_filesystem_space (SidebarAbstractMountableRow* self,
                                                          GCancellable* update_cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_filesystem_space_finish (SidebarAbstractMountableRow* self,
                                                                     GAsyncResult* _res_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_is_mounted (SidebarAbstractMountableRow* self);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_can_unmount (SidebarAbstractMountableRow* self);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_can_eject (SidebarAbstractMountableRow* self);
VALA_EXTERN SidebarAbstractMountableRow* sidebar_abstract_mountable_row_construct (GType object_type,
                                                                       const gchar* name,
                                                                       const gchar* uri,
                                                                       GIcon* gicon,
                                                                       SidebarSidebarListInterface* list,
                                                                       gboolean pinned,
                                                                       gboolean permanent,
                                                                       const gchar* _uuid);
VALA_EXTERN void sidebar_abstract_mountable_row_update_visibilities (SidebarAbstractMountableRow* self);
static void sidebar_abstract_mountable_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                                             FilesSidebarPluginItem* item);
VALA_EXTERN void sidebar_abstract_mountable_row_set_working (SidebarAbstractMountableRow* self,
                                                 gboolean value);
static void sidebar_abstract_mountable_row_unmount_mount_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_unmount_mount (SidebarAbstractMountableRow* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_unmount_mount_finish (SidebarAbstractMountableRow* self,
                                                              GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_unmount_mount_co (SidebarAbstractMountableRowUnmountMountData* _data_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_working (SidebarAbstractMountableRow* self);
VALA_EXTERN GMount* sidebar_abstract_mountable_row_get_mount (SidebarAbstractMountableRow* self);
VALA_EXTERN GtkWindow* files_get_active_window (void);
static void sidebar_abstract_mountable_row_unmount_mount_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sidebar_abstract_mountable_row_eject_mount_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_eject_mount (SidebarAbstractMountableRow* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_eject_mount_finish (SidebarAbstractMountableRow* self,
                                                            GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_eject_mount_co (SidebarAbstractMountableRowEjectMountData* _data_);
static void sidebar_abstract_mountable_row_eject_mount_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void sidebar_abstract_mountable_row_safely_remove_drive_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_safely_remove_drive (SidebarAbstractMountableRow* self,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
VALA_EXTERN void sidebar_abstract_mountable_row_safely_remove_drive_finish (SidebarAbstractMountableRow* self,
                                                                GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_safely_remove_drive_co (SidebarAbstractMountableRowSafelyRemoveDriveData* _data_);
VALA_EXTERN GDrive* sidebar_abstract_mountable_row_get_drive (SidebarAbstractMountableRow* self);
static void sidebar_abstract_mountable_row_safely_remove_drive_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static void sidebar_abstract_mountable_row_eject_drive_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_eject_drive (SidebarAbstractMountableRow* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN void sidebar_abstract_mountable_row_eject_drive_finish (SidebarAbstractMountableRow* self,
                                                        GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_eject_drive_co (SidebarAbstractMountableRowEjectDriveData* _data_);
static void sidebar_abstract_mountable_row_eject_drive_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN void sidebar_abstract_mountable_row_add_extra_menu_items_for_mount (SidebarAbstractMountableRow* self,
                                                                    GMount* mount,
                                                                    GMenu* menu);
static void sidebar_abstract_mountable_row_get_filesystem_space_for_root_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_get_filesystem_space_for_root (SidebarAbstractMountableRow* self,
                                                                   GFile* root,
                                                                   GCancellable* update_cancellable,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_);
VALA_EXTERN gboolean sidebar_abstract_mountable_row_get_filesystem_space_for_root_finish (SidebarAbstractMountableRow* self,
                                                                              GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_get_filesystem_space_for_root_co (SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_);
static void sidebar_abstract_mountable_row_get_filesystem_space_for_root_ready (GObject* source_object,
                                                                         GAsyncResult* _res_,
                                                                         gpointer _user_data_);
static void sidebar_abstract_mountable_row_get_storage_text_data_free (gpointer _data);
VALA_EXTERN void sidebar_abstract_mountable_row_get_storage_text (SidebarAbstractMountableRow* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
VALA_EXTERN gchar* sidebar_abstract_mountable_row_get_storage_text_finish (SidebarAbstractMountableRow* self,
                                                               GAsyncResult* _res_);
static gboolean sidebar_abstract_mountable_row_get_storage_text_co (SidebarAbstractMountableRowGetStorageTextData* _data_);
static void sidebar_abstract_mountable_row_get_storage_text_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static void sidebar_abstract_mountable_row_real_update_free_space (SidebarAbstractMountableRow* self);
static void sidebar_abstract_mountable_row_real_add_mountable_tooltip_data_free (gpointer _data);
static void sidebar_abstract_mountable_row_real_add_mountable_tooltip (SidebarAbstractMountableRow* self,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_);
static gboolean sidebar_abstract_mountable_row_real_add_mountable_tooltip_co (SidebarAbstractMountableRowAddMountableTooltipData* _data_);
static void sidebar_abstract_mountable_row_add_mountable_tooltip_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
static void sidebar_abstract_mountable_row_real_on_mount_removed (SidebarAbstractMountableRow* self,
                                                           GMount* removed_mount);
static void sidebar_abstract_mountable_row_real_on_mount_added (SidebarAbstractMountableRow* self,
                                                         GMount* added_mount);
static void sidebar_abstract_mountable_row_real_show_mount_info (SidebarAbstractMountableRow* self);
static void sidebar_abstract_mountable_row_real_get_filesystem_space_data_free (gpointer _data);
static void sidebar_abstract_mountable_row_real_get_filesystem_space (SidebarAbstractMountableRow* self,
                                                               GCancellable* update_cancellable,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static gboolean sidebar_abstract_mountable_row_real_get_filesystem_space_co (SidebarAbstractMountableRowGetFilesystemSpaceData* _data_);
VALA_EXTERN const gchar* sidebar_abstract_mountable_row_get_sort_key (SidebarAbstractMountableRow* self);
VALA_EXTERN void sidebar_abstract_mountable_row_set_sort_key (SidebarAbstractMountableRow* self,
                                                  const gchar* value);
VALA_EXTERN void sidebar_abstract_mountable_row_set_mount (SidebarAbstractMountableRow* self,
                                               GMount* value);
static void sidebar_abstract_mountable_row_set_drive (SidebarAbstractMountableRow* self,
                                               GDrive* value);
VALA_EXTERN const gchar* sidebar_abstract_mountable_row_get_uuid (SidebarAbstractMountableRow* self);
VALA_EXTERN void sidebar_abstract_mountable_row_set_uuid (SidebarAbstractMountableRow* self,
                                              const gchar* value);
static GObject * sidebar_abstract_mountable_row_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static void _sidebar_abstract_mountable_row_on_mount_removed_g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void _sidebar_abstract_mountable_row_on_mount_added_g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                                  GMount* mount,
                                                                                  gpointer self);
static void _sidebar_abstract_mountable_row___lambda172_ (SidebarAbstractMountableRow* self);
static void __sidebar_abstract_mountable_row___lambda172__gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self);
static void _sidebar_abstract_mountable_row___lambda173_ (SidebarAbstractMountableRow* self);
static void __sidebar_abstract_mountable_row___lambda173__g_simple_action_activate (GSimpleAction* _sender,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void _sidebar_abstract_mountable_row___lambda174_ (SidebarAbstractMountableRow* self);
static void __sidebar_abstract_mountable_row___lambda174__g_simple_action_activate (GSimpleAction* _sender,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void _sidebar_abstract_mountable_row_show_mount_info_g_simple_action_activate (GSimpleAction* _sender,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void _sidebar_abstract_mountable_row___lambda175_ (SidebarAbstractMountableRow* self);
static void __sidebar_abstract_mountable_row___lambda175__g_simple_action_activate (GSimpleAction* _sender,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void _sidebar_abstract_mountable_row___lambda176_ (SidebarAbstractMountableRow* self);
static void __sidebar_abstract_mountable_row___lambda176__g_simple_action_activate (GSimpleAction* _sender,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void sidebar_abstract_mountable_row_finalize (GObject * obj);
static GType sidebar_abstract_mountable_row_get_type_once (void);
static void _vala_sidebar_abstract_mountable_row_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);
static void _vala_sidebar_abstract_mountable_row_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
mountable_type_get_type_once (void)
{
	static const GEnumValue values[] = {{MOUNTABLE_TYPE_VOLUMELESS_MOUNT, "MOUNTABLE_TYPE_VOLUMELESS_MOUNT", "volumeless-mount"}, {MOUNTABLE_TYPE_VOLUME, "MOUNTABLE_TYPE_VOLUME", "volume"}, {MOUNTABLE_TYPE_EMPTY_DRIVE, "MOUNTABLE_TYPE_EMPTY_DRIVE", "empty-drive"}, {0, NULL, NULL}};
	GType mountable_type_type_id;
	mountable_type_type_id = g_enum_register_static ("MountableType", values);
	return mountable_type_type_id;
}

GType
mountable_type_get_type (void)
{
	static volatile gsize mountable_type_type_id__once = 0;
	if (g_once_init_enter (&mountable_type_type_id__once)) {
		GType mountable_type_type_id;
		mountable_type_type_id = mountable_type_get_type_once ();
		g_once_init_leave (&mountable_type_type_id__once, mountable_type_type_id);
	}
	return mountable_type_type_id__once;
}

static inline gpointer
sidebar_abstract_mountable_row_get_instance_private (SidebarAbstractMountableRow* self)
{
	return G_STRUCT_MEMBER_P (self, SidebarAbstractMountableRow_private_offset);
}

SidebarAbstractMountableRow*
sidebar_abstract_mountable_row_construct (GType object_type,
                                          const gchar* name,
                                          const gchar* uri,
                                          GIcon* gicon,
                                          SidebarSidebarListInterface* list,
                                          gboolean pinned,
                                          gboolean permanent,
                                          const gchar* _uuid)
{
	SidebarAbstractMountableRow * self = NULL;
#line 91 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 91 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 91 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 91 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 94 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = (SidebarAbstractMountableRow*) g_object_new (object_type, "custom-name", name, "uri", uri, "gicon", gicon, "list", list, "pinned", pinned, "permanent", permanent, "uuid", _uuid, NULL);
#line 91 "../src/View/Sidebar/AbstractMountableRow.vala"
	return self;
#line 598 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_update_visibilities (SidebarAbstractMountableRow* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkButton* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkRevealer* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkLevelBar* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
#line 194 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = sidebar_abstract_mountable_row_get_can_eject (self);
#line 196 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = _tmp1_;
#line 196 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp2_) {
#line 196 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _ ("Eject '%s'");
#line 628 "AbstractMountableRow.c"
	} else {
#line 196 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _ ("Unmount '%s'");
#line 632 "AbstractMountableRow.c"
	}
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp3_ = self->priv->unmount_eject_button;
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp5_ = _tmp4_;
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp6_ = g_strdup_printf (_tmp0_, _tmp5_);
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp7_ = _tmp6_;
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp7_);
#line 195 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_tmp7_);
#line 197 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp8_ = self->priv->unmount_eject_revealer;
#line 197 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp9_ = sidebar_abstract_mountable_row_get_can_unmount (self);
#line 197 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp10_ = _tmp9_;
#line 197 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_revealer_set_reveal_child (_tmp8_, _tmp10_);
#line 198 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp11_ = self->priv->storage_levelbar;
#line 198 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp12_ = sidebar_abstract_mountable_row_get_is_mounted (self);
#line 198 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp13_ = _tmp12_;
#line 198 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp11_, _tmp13_);
#line 664 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                                        FilesSidebarPluginItem* item)
{
	SidebarAbstractMountableRow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 201 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = (SidebarAbstractMountableRow*) base;
#line 201 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (item != NULL);
#line 202 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_sidebar_sidebar_item_interface_parent_iface->update_plugin_data ((SidebarSidebarItemInterface*) G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow), item);
#line 203 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = files_sidebar_plugin_item_get_show_spinner (item);
#line 203 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = _tmp0_;
#line 203 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (self, _tmp1_);
#line 686 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_unmount_mount_data_free (gpointer _data)
{
	SidebarAbstractMountableRowUnmountMountData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowUnmountMountData, _data_);
#line 698 "AbstractMountableRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 706 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_unmount_mount (SidebarAbstractMountableRow* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SidebarAbstractMountableRowUnmountMountData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowUnmountMountData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_unmount_mount_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_unmount_mount_co (_data_);
#line 730 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_unmount_mount_finish (SidebarAbstractMountableRow* self,
                                                     GAsyncResult* _res_)
{
	gboolean result;
	SidebarAbstractMountableRowUnmountMountData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _data_->result;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 745 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_unmount_mount_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SidebarAbstractMountableRowUnmountMountData* _data_;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_unmount_mount_co (_data_);
#line 762 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_unmount_mount_co (SidebarAbstractMountableRowUnmountMountData* _data_)
{
#line 206 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 206 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 772 "AbstractMountableRow.c"
		goto _state_0;
#line 206 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 776 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 206 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 781 "AbstractMountableRow.c"
	}
	_state_0:
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = sidebar_abstract_mountable_row_get_working (_data_->self);
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp3_) {
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = TRUE;
#line 792 "AbstractMountableRow.c"
	} else {
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = !_data_->self->valid;
#line 796 "AbstractMountableRow.c"
	}
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp1_) {
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = TRUE;
#line 802 "AbstractMountableRow.c"
	} else {
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp4_ = sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) _data_->self);
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = _data_->_tmp5_;
#line 810 "AbstractMountableRow.c"
	}
#line 207 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp0_) {
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->result = FALSE;
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 824 "AbstractMountableRow.c"
			}
		}
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 208 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 831 "AbstractMountableRow.c"
	}
#line 211 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, TRUE);
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp6_ = _data_->self->priv->_mount;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp7_ = files_get_active_window ();
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_unmount_mount (_data_->_tmp6_, _data_->_tmp8_, sidebar_abstract_mountable_row_unmount_mount_ready, _data_);
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 847 "AbstractMountableRow.c"
	_state_1:
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp9_ = marlin_file_operations_unmount_mount_finish (_data_->_res_);
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 212 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->success = _data_->_tmp9_;
#line 213 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, FALSE);
#line 214 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_update_visibilities (_data_->self);
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->result = _data_->success;
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 869 "AbstractMountableRow.c"
		}
	}
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 215 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 876 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_eject_mount_data_free (gpointer _data)
{
	SidebarAbstractMountableRowEjectMountData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowEjectMountData, _data_);
#line 888 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_eject_mount (SidebarAbstractMountableRow* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SidebarAbstractMountableRowEjectMountData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowEjectMountData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_eject_mount_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_eject_mount_co (_data_);
#line 912 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_eject_mount_finish (SidebarAbstractMountableRow* self,
                                                   GAsyncResult* _res_)
{
	gboolean result;
	SidebarAbstractMountableRowEjectMountData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _data_->result;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 927 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_eject_mount_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	SidebarAbstractMountableRowEjectMountData* _data_;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_eject_mount_co (_data_);
#line 944 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_eject_mount_co (SidebarAbstractMountableRowEjectMountData* _data_)
{
#line 218 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 218 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 954 "AbstractMountableRow.c"
		goto _state_0;
#line 218 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 958 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 218 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 963 "AbstractMountableRow.c"
	}
	_state_0:
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = sidebar_abstract_mountable_row_get_working (_data_->self);
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp3_) {
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = TRUE;
#line 974 "AbstractMountableRow.c"
	} else {
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = !_data_->self->valid;
#line 978 "AbstractMountableRow.c"
	}
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp1_) {
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = TRUE;
#line 984 "AbstractMountableRow.c"
	} else {
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp4_ = sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) _data_->self);
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = _data_->_tmp5_;
#line 992 "AbstractMountableRow.c"
	}
#line 219 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp0_) {
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->result = FALSE;
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1006 "AbstractMountableRow.c"
			}
		}
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 220 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1013 "AbstractMountableRow.c"
	}
#line 223 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, TRUE);
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp6_ = _data_->self->priv->_mount;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp7_ = files_get_active_window ();
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_eject_mount (_data_->_tmp6_, _data_->_tmp8_, sidebar_abstract_mountable_row_eject_mount_ready, _data_);
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1029 "AbstractMountableRow.c"
	_state_1:
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp9_ = marlin_file_operations_eject_mount_finish (_data_->_res_);
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 224 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->success = _data_->_tmp9_;
#line 225 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, FALSE);
#line 226 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_update_visibilities (_data_->self);
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->result = _data_->success;
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1051 "AbstractMountableRow.c"
		}
	}
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 227 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1058 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_safely_remove_drive_data_free (gpointer _data)
{
	SidebarAbstractMountableRowSafelyRemoveDriveData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowSafelyRemoveDriveData, _data_);
#line 1070 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_safely_remove_drive (SidebarAbstractMountableRow* self,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	SidebarAbstractMountableRowSafelyRemoveDriveData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowSafelyRemoveDriveData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_safely_remove_drive_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_safely_remove_drive_co (_data_);
#line 1094 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_safely_remove_drive_finish (SidebarAbstractMountableRow* self,
                                                           GAsyncResult* _res_)
{
	SidebarAbstractMountableRowSafelyRemoveDriveData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1104 "AbstractMountableRow.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 1113 "AbstractMountableRow.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 1121 "AbstractMountableRow.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 1130 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_safely_remove_drive_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	SidebarAbstractMountableRowSafelyRemoveDriveData* _data_;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_safely_remove_drive_co (_data_);
#line 1148 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_safely_remove_drive_co (SidebarAbstractMountableRowSafelyRemoveDriveData* _data_)
{
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 1158 "AbstractMountableRow.c"
		goto _state_0;
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 1162 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 1167 "AbstractMountableRow.c"
	}
	_state_0:
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = sidebar_abstract_mountable_row_get_working (_data_->self);
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp3_) {
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = TRUE;
#line 1178 "AbstractMountableRow.c"
	} else {
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = !_data_->self->valid;
#line 1182 "AbstractMountableRow.c"
	}
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp1_) {
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = TRUE;
#line 1188 "AbstractMountableRow.c"
	} else {
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp4_ = _data_->self->priv->_drive;
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = _data_->_tmp4_ == NULL;
#line 1194 "AbstractMountableRow.c"
	}
#line 231 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp0_) {
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1206 "AbstractMountableRow.c"
			}
		}
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 232 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1213 "AbstractMountableRow.c"
	}
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp5_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp6_ = g_drive_get_name (_data_->_tmp5_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp8_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp9_ = bool_to_string (g_drive_can_eject (_data_->_tmp8_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp11_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp12_ = bool_to_string (g_drive_can_stop (_data_->_tmp11_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp14_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp15_ = bool_to_string (g_drive_can_start (_data_->_tmp14_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp17_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp18_ = bool_to_string (g_drive_can_start_degraded (_data_->_tmp17_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp20_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp21_ = bool_to_string (g_drive_is_media_removable (_data_->_tmp20_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp23_ = _data_->self->priv->_drive;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp24_ = bool_to_string (g_drive_is_removable (_data_->_tmp23_));
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_debug ("AbstractMountableRow.vala:235: Eject/stop drive %s: can_eject %s, can_" \
"stop %s, can start %s, can start degraded %s, media_removable %s, driv" \
"e removable %s", _data_->_tmp7_, _data_->_tmp10_, _data_->_tmp13_, _data_->_tmp16_, _data_->_tmp19_, _data_->_tmp22_, _data_->_tmp25_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp25_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp22_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp19_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp16_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp13_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp10_);
#line 235 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp7_);
#line 239 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, TRUE);
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp26_ = _data_->self->priv->_drive;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp27_ = files_get_active_window ();
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_safely_remove_drive (_data_->_tmp26_, _data_->_tmp28_, sidebar_abstract_mountable_row_safely_remove_drive_ready, _data_);
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1287 "AbstractMountableRow.c"
	_state_1:
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_safely_remove_drive_finish (_data_->_res_);
#line 240 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->_tmp28_);
#line 241 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, FALSE);
#line 242 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_update_visibilities (_data_->self);
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1305 "AbstractMountableRow.c"
		}
	}
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 230 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1312 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_eject_drive_data_free (gpointer _data)
{
	SidebarAbstractMountableRowEjectDriveData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowEjectDriveData, _data_);
#line 1324 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_eject_drive (SidebarAbstractMountableRow* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SidebarAbstractMountableRowEjectDriveData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowEjectDriveData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_eject_drive_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_eject_drive_co (_data_);
#line 1348 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_eject_drive_finish (SidebarAbstractMountableRow* self,
                                                   GAsyncResult* _res_)
{
	SidebarAbstractMountableRowEjectDriveData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1358 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_eject_drive_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	SidebarAbstractMountableRowEjectDriveData* _data_;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_eject_drive_co (_data_);
#line 1375 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_eject_drive_co (SidebarAbstractMountableRowEjectDriveData* _data_)
{
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 1385 "AbstractMountableRow.c"
		goto _state_0;
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 1389 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 1394 "AbstractMountableRow.c"
	}
	_state_0:
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = sidebar_abstract_mountable_row_get_working (_data_->self);
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp3_) {
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = TRUE;
#line 1405 "AbstractMountableRow.c"
	} else {
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp1_ = !_data_->self->valid;
#line 1409 "AbstractMountableRow.c"
	}
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp1_) {
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = TRUE;
#line 1415 "AbstractMountableRow.c"
	} else {
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp4_ = _data_->self->priv->_drive;
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp0_ = _data_->_tmp4_ == NULL;
#line 1421 "AbstractMountableRow.c"
	}
#line 246 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp0_) {
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1433 "AbstractMountableRow.c"
			}
		}
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 247 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1440 "AbstractMountableRow.c"
	}
#line 249 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, TRUE);
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp5_ = _data_->self->priv->_drive;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp6_ = files_get_active_window ();
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_eject_drive (_data_->_tmp5_, _data_->_tmp7_, sidebar_abstract_mountable_row_eject_drive_ready, _data_);
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1456 "AbstractMountableRow.c"
	_state_1:
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_eject_drive_finish (_data_->_res_);
#line 250 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->_tmp7_);
#line 251 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_set_working (_data_->self, FALSE);
#line 252 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_update_visibilities (_data_->self);
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1474 "AbstractMountableRow.c"
		}
	}
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 245 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 1481 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_add_extra_menu_items_for_mount (SidebarAbstractMountableRow* self,
                                                               GMount* mount,
                                                               GMenu* menu)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GMenu* properties_section = NULL;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	GMenu* _tmp8_;
#line 255 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (menu != NULL);
#line 257 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = sidebar_abstract_mountable_row_get_working (self);
#line 257 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = _tmp0_;
#line 257 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp1_) {
#line 258 "../src/View/Sidebar/AbstractMountableRow.vala"
		return;
#line 1507 "AbstractMountableRow.c"
	}
#line 261 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (mount != NULL) {
#line 1511 "AbstractMountableRow.c"
		GMenu* menu_section = NULL;
		GMenu* _tmp2_;
		GMenu* _tmp5_;
#line 262 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp2_ = g_menu_new ();
#line 262 "../src/View/Sidebar/AbstractMountableRow.vala"
		menu_section = _tmp2_;
#line 264 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (marlin_file_operations_has_trash_files (mount)) {
#line 1521 "AbstractMountableRow.c"
			GMenu* _tmp3_;
#line 266 "../src/View/Sidebar/AbstractMountableRow.vala"
			_tmp3_ = menu_section;
#line 266 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_menu_append (_tmp3_, _ ("Permanently Delete Trash on this Mount"), "mountable.empty-trash");
#line 1527 "AbstractMountableRow.c"
		}
#line 269 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (g_mount_can_unmount (mount)) {
#line 1531 "AbstractMountableRow.c"
			GMenu* _tmp4_;
#line 270 "../src/View/Sidebar/AbstractMountableRow.vala"
			_tmp4_ = menu_section;
#line 270 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_menu_append (_tmp4_, _ ("_Unmount"), "mountable.unmount");
#line 1537 "AbstractMountableRow.c"
		}
#line 273 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp5_ = menu_section;
#line 273 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_menu_append_section (menu, NULL, (GMenuModel*) _tmp5_);
#line 261 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (menu_section);
#line 1545 "AbstractMountableRow.c"
	}
#line 276 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp6_ = g_menu_new ();
#line 276 "../src/View/Sidebar/AbstractMountableRow.vala"
	properties_section = _tmp6_;
#line 277 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp7_ = properties_section;
#line 277 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_menu_append (_tmp7_, _ ("Properties"), "mountable.properties");
#line 279 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp8_ = properties_section;
#line 279 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_menu_append_section (menu, NULL, (GMenuModel*) _tmp8_);
#line 255 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (properties_section);
#line 1561 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_get_filesystem_space_for_root_data_free (gpointer _data)
{
	SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->root);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowGetFilesystemSpaceForRootData, _data_);
#line 1577 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_get_filesystem_space_for_root (SidebarAbstractMountableRow* self,
                                                              GFile* root,
                                                              GCancellable* update_cancellable,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_)
{
	SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (root != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowGetFilesystemSpaceForRootData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), update_cancellable, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_get_filesystem_space_for_root_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = _g_object_ref0 (root);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->root);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->root = _tmp1_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = _g_object_ref0 (update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->update_cancellable = _tmp2_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_filesystem_space_for_root_co (_data_);
#line 1619 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_get_filesystem_space_for_root_finish (SidebarAbstractMountableRow* self,
                                                                     GAsyncResult* _res_)
{
	gboolean result;
	SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (NULL == _data_) {
#line 1632 "AbstractMountableRow.c"
		gboolean _tmp0_ = FALSE;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _tmp0_;
#line 1636 "AbstractMountableRow.c"
	}
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _data_->result;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 1642 "AbstractMountableRow.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1661 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_get_filesystem_space_for_root_ready (GObject* source_object,
                                                                    GAsyncResult* _res_,
                                                                    gpointer _user_data_)
{
	SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_filesystem_space_for_root_co (_data_);
#line 1678 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_get_filesystem_space_for_root_co (SidebarAbstractMountableRowGetFilesystemSpaceForRootData* _data_)
{
#line 282 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 282 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 1688 "AbstractMountableRow.c"
		goto _state_0;
#line 282 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 1692 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 282 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 1697 "AbstractMountableRow.c"
	}
	_state_0:
#line 283 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self->priv->storage_capacity = (gdouble) 0;
#line 284 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self->priv->storage_free = (gdouble) 0;
#line 286 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp0_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) _data_->self);
#line 286 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 286 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = g_uri_parse_scheme (_data_->_tmp1_);
#line 286 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->scheme = _data_->_tmp2_;
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp4_ = _data_->scheme;
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp4_ == NULL) {
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp3_ = TRUE;
#line 1718 "AbstractMountableRow.c"
	} else {
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp5_ = _data_->scheme;
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp3_ = string_contains ("sftp davs", _data_->_tmp5_);
#line 1724 "AbstractMountableRow.c"
	}
#line 287 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp3_) {
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->result = FALSE;
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->scheme);
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1740 "AbstractMountableRow.c"
			}
		}
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 288 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1747 "AbstractMountableRow.c"
	}
#line 291 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp6_ = _data_->scheme;
#line 291 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (string_contains ("smb afp", _data_->_tmp6_)) {
#line 293 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp7_ = g_network_monitor_get_default ();
#line 293 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 293 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->net_mon = _data_->_tmp8_;
#line 294 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp9_ = _data_->net_mon;
#line 294 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (!g_network_monitor_get_network_available (_data_->_tmp9_)) {
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->result = FALSE;
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_object_unref0 (_data_->net_mon);
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->scheme);
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			if (_data_->_state_ != 0) {
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1777 "AbstractMountableRow.c"
				}
			}
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_object_unref (_data_->_async_result);
#line 295 "../src/View/Sidebar/AbstractMountableRow.vala"
			return FALSE;
#line 1784 "AbstractMountableRow.c"
		}
#line 291 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->net_mon);
#line 1788 "AbstractMountableRow.c"
	}
	{
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_state_ = 1;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_file_query_filesystem_info_async (_data_->root, "filesystem::*", 0, _data_->update_cancellable, sidebar_abstract_mountable_row_get_filesystem_space_for_root_ready, _data_);
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1797 "AbstractMountableRow.c"
		_state_1:
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp11_ = g_file_query_filesystem_info_finish (_data_->root, _data_->_res_, &_data_->_inner_error0_);
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp10_ = _data_->_tmp11_;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1805 "AbstractMountableRow.c"
			goto __catch0_g_error;
		}
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp12_ = _data_->_tmp10_;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp10_ = NULL;
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->info);
#line 301 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->info = _data_->_tmp12_;
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->_tmp10_);
#line 1818 "AbstractMountableRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_inner_error0_ = NULL;
#line 304 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp13_ = _data_->_error_;
#line 304 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (!g_error_matches (_data_->_tmp13_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp14_ = g_file_get_uri (_data_->root);
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp16_ = _data_->_error_;
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp17_ = _data_->_tmp16_->message;
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_warning ("AbstractMountableRow.vala:305: Error querying filesystem info for '%s'" \
": %s", _data_->_tmp15_, _data_->_tmp17_);
#line 305 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->_tmp15_);
#line 1843 "AbstractMountableRow.c"
		}
#line 308 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->info);
#line 308 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->info = NULL;
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_error_free0 (_data_->_error_);
#line 1851 "AbstractMountableRow.c"
	}
	__finally0:
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->info);
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->scheme);
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 300 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1868 "AbstractMountableRow.c"
	}
#line 311 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (g_cancellable_is_cancelled (_data_->update_cancellable)) {
#line 311 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp18_ = TRUE;
#line 1874 "AbstractMountableRow.c"
	} else {
#line 311 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp19_ = _data_->info;
#line 311 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp18_ = _data_->_tmp19_ == NULL;
#line 1880 "AbstractMountableRow.c"
	}
#line 311 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_tmp18_) {
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->result = FALSE;
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->info);
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->scheme);
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1898 "AbstractMountableRow.c"
			}
		}
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 312 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1905 "AbstractMountableRow.c"
	} else {
#line 314 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp20_ = _data_->info;
#line 314 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (g_file_info_has_attribute (_data_->_tmp20_, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE)) {
#line 315 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp21_ = _data_->info;
#line 315 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->self->priv->storage_capacity = (gdouble) g_file_info_get_attribute_uint64 (_data_->_tmp21_, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 1915 "AbstractMountableRow.c"
		}
#line 317 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp22_ = _data_->info;
#line 317 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (g_file_info_has_attribute (_data_->_tmp22_, G_FILE_ATTRIBUTE_FILESYSTEM_FREE)) {
#line 318 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp23_ = _data_->info;
#line 318 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->self->priv->storage_free = (gdouble) g_file_info_get_attribute_uint64 (_data_->_tmp23_, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 1925 "AbstractMountableRow.c"
		}
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->result = TRUE;
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (_data_->info);
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->scheme);
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->_state_ != 0) {
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1941 "AbstractMountableRow.c"
			}
		}
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_unref (_data_->_async_result);
#line 321 "../src/View/Sidebar/AbstractMountableRow.vala"
		return FALSE;
#line 1948 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_get_storage_text_data_free (gpointer _data)
{
	SidebarAbstractMountableRowGetStorageTextData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->result);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowGetStorageTextData, _data_);
#line 1963 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_get_storage_text (SidebarAbstractMountableRow* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SidebarAbstractMountableRowGetStorageTextData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowGetStorageTextData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_get_storage_text_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_storage_text_co (_data_);
#line 1987 "AbstractMountableRow.c"
}

gchar*
sidebar_abstract_mountable_row_get_storage_text_finish (SidebarAbstractMountableRow* self,
                                                        GAsyncResult* _res_)
{
	gchar* result;
	SidebarAbstractMountableRowGetStorageTextData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _data_->result;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->result = NULL;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2004 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_get_storage_text_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	SidebarAbstractMountableRowGetStorageTextData* _data_;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_storage_text_co (_data_);
#line 2021 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_get_storage_text_co (SidebarAbstractMountableRowGetStorageTextData* _data_)
{
#line 325 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 325 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 2031 "AbstractMountableRow.c"
		goto _state_0;
#line 325 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 2035 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 325 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 2040 "AbstractMountableRow.c"
	}
	_state_0:
#line 326 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp0_ = g_strdup ("");
#line 326 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->storage_text = _data_->_tmp0_;
#line 327 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self->priv->storage_capacity = (gdouble) 0;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_filesystem_space (_data_->self, NULL, sidebar_abstract_mountable_row_get_storage_text_ready, _data_);
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2055 "AbstractMountableRow.c"
	_state_1:
#line 329 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (sidebar_abstract_mountable_row_get_filesystem_space_finish (_data_->self, _data_->_res_)) {
#line 330 "../src/View/Sidebar/AbstractMountableRow.vala"
		if (_data_->self->priv->storage_capacity > ((gdouble) 0)) {
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp1_ = g_format_size_full ((guint64) _data_->self->priv->storage_free, G_FORMAT_SIZE_DEFAULT);
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp2_ = _data_->_tmp1_;
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp3_ = g_strdup_printf (_ ("%s free"), _data_->_tmp2_);
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp4_ = _data_->_tmp3_;
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->_tmp2_);
#line 331 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->used_string = _data_->_tmp4_;
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp5_ = g_format_size_full ((guint64) (_data_->self->priv->storage_capacity - _data_->self->priv->storage_free), G_FORMAT_SIZE_DEFAULT);
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp7_ = g_format_size_full ((guint64) _data_->self->priv->storage_capacity, G_FORMAT_SIZE_DEFAULT);
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp9_ = g_strdup_printf (_ ("%s used of %s"), _data_->_tmp6_, _data_->_tmp8_);
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->_tmp8_);
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->_tmp6_);
#line 332 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->size_string = _data_->_tmp10_;
#line 337 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp11_ = _data_->used_string;
#line 337 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp12_ = _data_->size_string;
#line 337 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp13_ = g_strdup_printf ("\n%s\n<span weight=\"600\" size=\"smaller\" alpha=\"75%\">%s</span>", _data_->_tmp11_, _data_->_tmp12_);
#line 337 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->storage_text);
#line 337 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->storage_text = _data_->_tmp13_;
#line 340 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp14_ = _data_->self->priv->storage_levelbar;
#line 340 "../src/View/Sidebar/AbstractMountableRow.vala"
			gtk_level_bar_set_value (_data_->_tmp14_, (_data_->self->priv->storage_capacity - _data_->self->priv->storage_free) / _data_->self->priv->storage_capacity);
#line 341 "../src/View/Sidebar/AbstractMountableRow.vala"
			_data_->_tmp15_ = _data_->self->priv->storage_levelbar;
#line 341 "../src/View/Sidebar/AbstractMountableRow.vala"
			gtk_widget_show ((GtkWidget*) _data_->_tmp15_);
#line 330 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->size_string);
#line 330 "../src/View/Sidebar/AbstractMountableRow.vala"
			_g_free0 (_data_->used_string);
#line 2113 "AbstractMountableRow.c"
		}
	}
#line 345 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->self->priv->storage_capacity == ((gdouble) 0)) {
#line 346 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp16_ = _data_->self->priv->storage_levelbar;
#line 346 "../src/View/Sidebar/AbstractMountableRow.vala"
		gtk_widget_hide ((GtkWidget*) _data_->_tmp16_);
#line 2122 "AbstractMountableRow.c"
	}
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->result = _data_->storage_text;
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2134 "AbstractMountableRow.c"
		}
	}
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 349 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2141 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_real_update_free_space (SidebarAbstractMountableRow* self)
{
#line 353 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_add_mountable_tooltip (self, NULL, NULL);
#line 2149 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_update_free_space (SidebarAbstractMountableRow* self)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 352 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 352 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 352 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->update_free_space) {
#line 352 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->update_free_space (self);
#line 2164 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_real_add_mountable_tooltip_data_free (gpointer _data)
{
	SidebarAbstractMountableRowAddMountableTooltipData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowAddMountableTooltipData, _data_);
#line 2177 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_real_add_mountable_tooltip (SidebarAbstractMountableRow* self,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_)
{
	SidebarAbstractMountableRowAddMountableTooltipData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowAddMountableTooltipData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_real_add_mountable_tooltip_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_real_add_mountable_tooltip_co (_data_);
#line 2199 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_real_add_mountable_tooltip_finish (SidebarAbstractMountableRow* self,
                                                                  GAsyncResult* _res_)
{
	SidebarAbstractMountableRowAddMountableTooltipData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2209 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_add_mountable_tooltip_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	SidebarAbstractMountableRowAddMountableTooltipData* _data_;
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = _user_data_;
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_source_object_ = source_object;
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_res_ = _res_;
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_real_add_mountable_tooltip_co (_data_);
#line 2226 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_add_mountable_tooltip_co (SidebarAbstractMountableRowAddMountableTooltipData* _data_)
{
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 2236 "AbstractMountableRow.c"
		goto _state_0;
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 1:
#line 2240 "AbstractMountableRow.c"
		goto _state_1;
		default:
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 2245 "AbstractMountableRow.c"
	}
	_state_0:
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_state_ = 1;
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_get_storage_text (_data_->self, sidebar_abstract_mountable_row_add_mountable_tooltip_ready, _data_);
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2254 "AbstractMountableRow.c"
	_state_1:
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp0_ = sidebar_abstract_mountable_row_get_storage_text_finish (_data_->self, _data_->_res_);
#line 357 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->storage_text = _data_->_tmp0_;
#line 359 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp1_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) _data_->self);
#line 359 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 359 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (g_strcmp0 (_data_->_tmp2_, "") != 0) {
#line 360 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp3_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) _data_->self);
#line 360 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 360 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp5_ = files_file_utils_sanitize_path (_data_->_tmp4_, NULL, FALSE);
#line 360 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->mount_text);
#line 360 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->mount_text = _data_->_tmp5_;
#line 2276 "AbstractMountableRow.c"
	} else {
#line 362 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp6_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) _data_->self);
#line 362 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 362 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->_tmp8_ = g_strdup_printf (_ ("%s (%s)"), _data_->_tmp7_, _ ("Not mounted"));
#line 362 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (_data_->mount_text);
#line 362 "../src/View/Sidebar/AbstractMountableRow.vala"
		_data_->mount_text = _data_->_tmp8_;
#line 2288 "AbstractMountableRow.c"
	}
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp9_ = _data_->mount_text;
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp10_ = _data_->storage_text;
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp11_ = g_strconcat (_data_->_tmp9_, _data_->_tmp10_, NULL);
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _data_->self, _data_->_tmp12_);
#line 365 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->_tmp12_);
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->mount_text);
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_data_->storage_text);
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2314 "AbstractMountableRow.c"
		}
	}
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 356 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2321 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_add_mountable_tooltip (SidebarAbstractMountableRow* self,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->add_mountable_tooltip) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->add_mountable_tooltip (self, _callback_, _user_data_);
#line 2336 "AbstractMountableRow.c"
	}
}

void
sidebar_abstract_mountable_row_add_mountable_tooltip_finish (SidebarAbstractMountableRow* self,
                                                             GAsyncResult* _res_)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->add_mountable_tooltip_finish) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->add_mountable_tooltip_finish (self, _res_);
#line 2351 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_real_on_mount_removed (SidebarAbstractMountableRow* self,
                                                      GMount* removed_mount)
{
#line 368 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (removed_mount != NULL);
#line 2361 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_on_mount_removed (SidebarAbstractMountableRow* self,
                                                 GMount* removed_mount)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 368 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 368 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 368 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->on_mount_removed) {
#line 368 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->on_mount_removed (self, removed_mount);
#line 2377 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_real_on_mount_added (SidebarAbstractMountableRow* self,
                                                    GMount* added_mount)
{
#line 369 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (added_mount != NULL);
#line 2387 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_on_mount_added (SidebarAbstractMountableRow* self,
                                               GMount* added_mount)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 369 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 369 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 369 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->on_mount_added) {
#line 369 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->on_mount_added (self, added_mount);
#line 2403 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_real_show_mount_info (SidebarAbstractMountableRow* self)
{
}

void
sidebar_abstract_mountable_row_show_mount_info (SidebarAbstractMountableRow* self)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 370 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 370 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->show_mount_info) {
#line 370 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->show_mount_info (self);
#line 2424 "AbstractMountableRow.c"
	}
}

static void
sidebar_abstract_mountable_row_real_get_filesystem_space_data_free (gpointer _data)
{
	SidebarAbstractMountableRowGetFilesystemSpaceData* _data_;
	_data_ = _data;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_slice_free (SidebarAbstractMountableRowGetFilesystemSpaceData, _data_);
#line 2439 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_real_get_filesystem_space (SidebarAbstractMountableRow* self,
                                                          GCancellable* update_cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	SidebarAbstractMountableRowGetFilesystemSpaceData* _data_;
	SidebarAbstractMountableRow* _tmp0_;
	GCancellable* _tmp1_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_slice_new0 (SidebarAbstractMountableRowGetFilesystemSpaceData);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), update_cancellable, _callback_, _user_data_);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sidebar_abstract_mountable_row_real_get_filesystem_space_data_free);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->self = _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = _g_object_ref0 (update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_data_->update_cancellable);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->update_cancellable = _tmp1_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_real_get_filesystem_space_co (_data_);
#line 2469 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_get_filesystem_space_finish (SidebarAbstractMountableRow* self,
                                                                 GAsyncResult* _res_)
{
	gboolean result;
	SidebarAbstractMountableRowGetFilesystemSpaceData* _data_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (NULL == _data_) {
#line 2482 "AbstractMountableRow.c"
		gboolean _tmp0_ = FALSE;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _tmp0_;
#line 2486 "AbstractMountableRow.c"
	}
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _data_->result;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2492 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_get_filesystem_space_co (SidebarAbstractMountableRowGetFilesystemSpaceData* _data_)
{
#line 371 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (_data_->_state_) {
#line 371 "../src/View/Sidebar/AbstractMountableRow.vala"
		case 0:
#line 2502 "AbstractMountableRow.c"
		goto _state_0;
		default:
#line 371 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_assert_not_reached ();
#line 2507 "AbstractMountableRow.c"
	}
	_state_0:
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
	_data_->result = FALSE;
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_data_->_state_ != 0) {
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2520 "AbstractMountableRow.c"
		}
	}
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_unref (_data_->_async_result);
#line 372 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2527 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_get_filesystem_space (SidebarAbstractMountableRow* self,
                                                     GCancellable* update_cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->get_filesystem_space) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		_klass_->get_filesystem_space (self, update_cancellable, _callback_, _user_data_);
#line 2543 "AbstractMountableRow.c"
	}
}

gboolean
sidebar_abstract_mountable_row_get_filesystem_space_finish (SidebarAbstractMountableRow* self,
                                                            GAsyncResult* _res_)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->get_filesystem_space_finish) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _klass_->get_filesystem_space_finish (self, _res_);
#line 2558 "AbstractMountableRow.c"
	}
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2562 "AbstractMountableRow.c"
}

const gchar*
sidebar_abstract_mountable_row_get_sort_key (SidebarAbstractMountableRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_sort_key;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2578 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_set_sort_key (SidebarAbstractMountableRow* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	old_value = sidebar_abstract_mountable_row_get_sort_key (self);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2592 "AbstractMountableRow.c"
		gchar* _tmp0_;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (self->priv->_sort_key);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
		self->priv->_sort_key = _tmp0_;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY]);
#line 2602 "AbstractMountableRow.c"
	}
}

GMount*
sidebar_abstract_mountable_row_get_mount (SidebarAbstractMountableRow* self)
{
	GMount* result;
	GMount* _tmp0_;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_mount;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2619 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_set_mount (SidebarAbstractMountableRow* self,
                                          GMount* value)
{
	GMount* old_value;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	old_value = sidebar_abstract_mountable_row_get_mount (self);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (old_value != value) {
#line 2633 "AbstractMountableRow.c"
		GMount* _tmp0_;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (self->priv->_mount);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
		self->priv->_mount = _tmp0_;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY]);
#line 2643 "AbstractMountableRow.c"
	}
}

GDrive*
sidebar_abstract_mountable_row_get_drive (SidebarAbstractMountableRow* self)
{
	GDrive* result;
	GDrive* _tmp0_;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_drive;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2660 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_set_drive (SidebarAbstractMountableRow* self,
                                          GDrive* value)
{
	GDrive* old_value;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	old_value = sidebar_abstract_mountable_row_get_drive (self);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (old_value != value) {
#line 2674 "AbstractMountableRow.c"
		GDrive* _tmp0_;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_object_unref0 (self->priv->_drive);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
		self->priv->_drive = _tmp0_;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY]);
#line 2684 "AbstractMountableRow.c"
	}
}

const gchar*
sidebar_abstract_mountable_row_get_uuid (SidebarAbstractMountableRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_uuid;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2701 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_set_uuid (SidebarAbstractMountableRow* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	old_value = sidebar_abstract_mountable_row_get_uuid (self);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2715 "AbstractMountableRow.c"
		gchar* _tmp0_;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
		_g_free0 (self->priv->_uuid);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
		self->priv->_uuid = _tmp0_;
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY]);
#line 2725 "AbstractMountableRow.c"
	}
}

gboolean
sidebar_abstract_mountable_row_get_is_mounted (SidebarAbstractMountableRow* self)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->get_is_mounted) {
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _klass_->get_is_mounted (self);
#line 2741 "AbstractMountableRow.c"
	}
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2745 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_get_is_mounted (SidebarAbstractMountableRow* base)
{
	gboolean result;
	SidebarAbstractMountableRow* self;
	GMount* _tmp0_;
#line 51 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = base;
#line 52 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_mount;
#line 52 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_ != NULL;
#line 52 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2762 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_get_can_unmount (SidebarAbstractMountableRow* self)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->get_can_unmount) {
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _klass_->get_can_unmount (self);
#line 2777 "AbstractMountableRow.c"
	}
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2781 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_get_can_unmount (SidebarAbstractMountableRow* base)
{
	gboolean result;
	SidebarAbstractMountableRow* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 57 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = base;
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = sidebar_abstract_mountable_row_get_is_mounted (self);
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp2_) {
#line 2800 "AbstractMountableRow.c"
		GMount* _tmp3_;
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp3_ = self->priv->_mount;
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = g_mount_can_unmount (_tmp3_);
#line 2806 "AbstractMountableRow.c"
	} else {
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = FALSE;
#line 2810 "AbstractMountableRow.c"
	}
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 58 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2816 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_get_can_eject (SidebarAbstractMountableRow* self)
{
	SidebarAbstractMountableRowClass* _klass_;
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
	_klass_ = SIDEBAR_ABSTRACT_MOUNTABLE_ROW_GET_CLASS (self);
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_klass_->get_can_eject) {
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
		return _klass_->get_can_eject (self);
#line 2831 "AbstractMountableRow.c"
	}
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
	return FALSE;
#line 2835 "AbstractMountableRow.c"
}

static gboolean
sidebar_abstract_mountable_row_real_get_can_eject (SidebarAbstractMountableRow* base)
{
	gboolean result;
	SidebarAbstractMountableRow* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 63 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = base;
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = sidebar_abstract_mountable_row_get_is_mounted (self);
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp2_) {
#line 2854 "AbstractMountableRow.c"
		GMount* _tmp3_;
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp3_ = self->priv->_mount;
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = g_mount_can_eject (_tmp3_);
#line 2860 "AbstractMountableRow.c"
	} else {
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = FALSE;
#line 2864 "AbstractMountableRow.c"
	}
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = _tmp0_;
#line 64 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2870 "AbstractMountableRow.c"
}

gboolean
sidebar_abstract_mountable_row_get_working (SidebarAbstractMountableRow* self)
{
	gboolean result;
#line 70 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../src/View/Sidebar/AbstractMountableRow.vala"
	result = self->priv->_working;
#line 71 "../src/View/Sidebar/AbstractMountableRow.vala"
	return result;
#line 2883 "AbstractMountableRow.c"
}

void
sidebar_abstract_mountable_row_set_working (SidebarAbstractMountableRow* self,
                                            gboolean value)
{
#line 74 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (!self->valid) {
#line 76 "../src/View/Sidebar/AbstractMountableRow.vala"
		return;
#line 2896 "AbstractMountableRow.c"
	}
#line 79 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->_working = value;
#line 81 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (value) {
#line 2902 "AbstractMountableRow.c"
		GtkSpinner* _tmp0_;
		GtkStack* _tmp1_;
		GtkSpinner* _tmp2_;
#line 82 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = self->priv->working_spinner;
#line 82 "../src/View/Sidebar/AbstractMountableRow.vala"
		gtk_spinner_start (_tmp0_);
#line 83 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp1_ = self->priv->unmount_eject_working_stack;
#line 83 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp2_ = self->priv->working_spinner;
#line 83 "../src/View/Sidebar/AbstractMountableRow.vala"
		gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 2916 "AbstractMountableRow.c"
	} else {
		GtkStack* _tmp3_;
		GtkRevealer* _tmp4_;
		GtkSpinner* _tmp5_;
#line 85 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp3_ = self->priv->unmount_eject_working_stack;
#line 85 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp4_ = self->priv->unmount_eject_revealer;
#line 85 "../src/View/Sidebar/AbstractMountableRow.vala"
		gtk_stack_set_visible_child (_tmp3_, (GtkWidget*) _tmp4_);
#line 86 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp5_ = self->priv->working_spinner;
#line 86 "../src/View/Sidebar/AbstractMountableRow.vala"
		gtk_spinner_stop (_tmp5_);
#line 2931 "AbstractMountableRow.c"
	}
#line 74 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_notify_by_pspec ((GObject *) self, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY]);
#line 2935 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row_on_mount_removed_g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
#line 153 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_on_mount_removed ((SidebarAbstractMountableRow*) self, mount);
#line 2945 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row_on_mount_added_g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                             GMount* mount,
                                                                             gpointer self)
{
#line 154 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_on_mount_added ((SidebarAbstractMountableRow*) self, mount);
#line 2955 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row___lambda172_ (SidebarAbstractMountableRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 156 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = sidebar_abstract_mountable_row_get_can_eject (self);
#line 156 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = _tmp0_;
#line 156 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp1_) {
#line 157 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_eject_mount (self, NULL, NULL);
#line 2971 "AbstractMountableRow.c"
	} else {
#line 159 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_unmount_mount (self, NULL, NULL);
#line 2975 "AbstractMountableRow.c"
	}
}

static void
__sidebar_abstract_mountable_row___lambda172__gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self)
{
#line 155 "../src/View/Sidebar/AbstractMountableRow.vala"
	_sidebar_abstract_mountable_row___lambda172_ ((SidebarAbstractMountableRow*) self);
#line 2985 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row___lambda173_ (SidebarAbstractMountableRow* self)
{
#line 170 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_safely_remove_drive (self, NULL, NULL);
#line 2993 "AbstractMountableRow.c"
}

static void
__sidebar_abstract_mountable_row___lambda173__g_simple_action_activate (GSimpleAction* _sender,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 170 "../src/View/Sidebar/AbstractMountableRow.vala"
	_sidebar_abstract_mountable_row___lambda173_ ((SidebarAbstractMountableRow*) self);
#line 3003 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row___lambda174_ (SidebarAbstractMountableRow* self)
{
#line 173 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_eject_drive (self, NULL, NULL);
#line 3011 "AbstractMountableRow.c"
}

static void
__sidebar_abstract_mountable_row___lambda174__g_simple_action_activate (GSimpleAction* _sender,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 173 "../src/View/Sidebar/AbstractMountableRow.vala"
	_sidebar_abstract_mountable_row___lambda174_ ((SidebarAbstractMountableRow*) self);
#line 3021 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row_show_mount_info_g_simple_action_activate (GSimpleAction* _sender,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 176 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_show_mount_info ((SidebarAbstractMountableRow*) self);
#line 3031 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row___lambda175_ (SidebarAbstractMountableRow* self)
{
#line 179 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_unmount_mount (self, NULL, NULL);
#line 3039 "AbstractMountableRow.c"
}

static void
__sidebar_abstract_mountable_row___lambda175__g_simple_action_activate (GSimpleAction* _sender,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 179 "../src/View/Sidebar/AbstractMountableRow.vala"
	_sidebar_abstract_mountable_row___lambda175_ ((SidebarAbstractMountableRow*) self);
#line 3049 "AbstractMountableRow.c"
}

static void
_sidebar_abstract_mountable_row___lambda176_ (SidebarAbstractMountableRow* self)
{
	GMount* _tmp0_;
#line 182 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = self->priv->_mount;
#line 182 "../src/View/Sidebar/AbstractMountableRow.vala"
	marlin_file_operations_empty_trash_for_mount ((GtkWidget*) self, _tmp0_);
#line 3060 "AbstractMountableRow.c"
}

static void
__sidebar_abstract_mountable_row___lambda176__g_simple_action_activate (GSimpleAction* _sender,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 182 "../src/View/Sidebar/AbstractMountableRow.vala"
	_sidebar_abstract_mountable_row___lambda176_ ((SidebarAbstractMountableRow*) self);
#line 3070 "AbstractMountableRow.c"
}

static GObject *
sidebar_abstract_mountable_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SidebarAbstractMountableRow * self;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GtkButton* _tmp6_ = NULL;
	GtkButton* _tmp7_;
	GtkStyleContext* _tmp8_;
	GtkCssProvider* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkButton* _tmp11_;
	GtkWidget* _tmp12_;
	GtkRevealer* _tmp13_ = NULL;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkStack* _tmp17_;
	GtkSpinner* _tmp18_;
	GtkGrid* _tmp19_;
	GtkStack* _tmp20_;
	GtkLevelBar* _tmp21_ = NULL;
	GtkLevelBar* _tmp22_;
	GtkLevelBar* _tmp23_;
	GtkLevelBar* _tmp24_;
	GtkStyleContext* storage_style_context = NULL;
	GtkLevelBar* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkStyleContext* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkStyleContext* _tmp29_;
	GtkCssProvider* _tmp30_;
	GtkGrid* _tmp31_;
	GtkLevelBar* _tmp32_;
	GVolumeMonitor* _tmp33_;
	GVolumeMonitor* _tmp34_;
	GtkButton* _tmp35_;
	GSimpleAction* safely_remove_action = NULL;
	GSimpleAction* _tmp36_;
	GSimpleAction* _tmp37_;
	GSimpleAction* eject_action = NULL;
	GSimpleAction* _tmp38_;
	GSimpleAction* _tmp39_;
	GSimpleAction* properties_action = NULL;
	GSimpleAction* _tmp40_;
	GSimpleAction* _tmp41_;
	GSimpleAction* unmount_action = NULL;
	GSimpleAction* _tmp42_;
	GSimpleAction* _tmp43_;
	GSimpleAction* empty_trash_action = NULL;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp46_;
	GSimpleActionGroup* _tmp47_;
	GSimpleAction* _tmp48_;
	GSimpleActionGroup* _tmp49_;
	GSimpleAction* _tmp50_;
	GSimpleActionGroup* _tmp51_;
	GSimpleAction* _tmp52_;
	GSimpleActionGroup* _tmp53_;
	GSimpleAction* _tmp54_;
	GSimpleActionGroup* _tmp55_;
	GSimpleAction* _tmp56_;
	GSimpleActionGroup* _tmp57_;
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	parent_class = G_OBJECT_CLASS (sidebar_abstract_mountable_row_parent_class);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRow);
#line 113 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = sidebar_abstract_mountable_row_get_can_eject (self);
#line 113 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = _tmp1_;
#line 113 "../src/View/Sidebar/AbstractMountableRow.vala"
	if (_tmp2_) {
#line 113 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _ ("Eject '%s'");
#line 3160 "AbstractMountableRow.c"
	} else {
#line 113 "../src/View/Sidebar/AbstractMountableRow.vala"
		_tmp0_ = _ ("Unmount '%s'");
#line 3164 "AbstractMountableRow.c"
	}
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp3_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp4_ = _tmp3_;
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp5_ = g_strdup_printf (_tmp0_, _tmp4_);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_from_icon_name ("media-eject-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _tmp5_);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (_tmp5_);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_ref_sink (_tmp6_);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_button);
#line 112 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->unmount_eject_button = _tmp6_;
#line 116 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp7_ = self->priv->unmount_eject_button;
#line 116 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp8_ = gtk_widget_get_style_context ((GtkWidget*) _tmp7_);
#line 116 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp9_ = sidebar_abstract_mountable_row_devicerow_provider;
#line 116 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_style_context_add_provider (_tmp8_, (GtkStyleProvider*) _tmp9_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 118 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
#line 118 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_ref_sink (_tmp10_);
#line 118 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->working_spinner);
#line 118 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->working_spinner = _tmp10_;
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp11_ = self->priv->unmount_eject_button;
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp13_ = (GtkRevealer*) gtk_revealer_new ();
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_set ((GtkContainer*) _tmp13_, "child", _tmp12_, NULL);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (_tmp12_);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_revealer_set_transition_type (_tmp13_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_revealer_set_reveal_child (_tmp13_, FALSE);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_ref_sink (_tmp13_);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_revealer);
#line 120 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->unmount_eject_revealer = _tmp13_;
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp14_ = (GtkStack*) gtk_stack_new ();
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp14_, 6);
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_stack_set_transition_type (_tmp14_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_ref_sink (_tmp14_);
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_working_stack);
#line 127 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->unmount_eject_working_stack = _tmp14_;
#line 132 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp15_ = self->priv->unmount_eject_working_stack;
#line 132 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp16_ = self->priv->unmount_eject_revealer;
#line 132 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 133 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp17_ = self->priv->unmount_eject_working_stack;
#line 133 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp18_ = self->priv->working_spinner;
#line 133 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 135 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp19_ = ((SidebarBookmarkRow*) self)->content_grid;
#line 135 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp20_ = self->priv->unmount_eject_working_stack;
#line 135 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 1, 0, 1, 1);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp21_ = (GtkLevelBar*) gtk_level_bar_new ();
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_level_bar_set_value (_tmp21_, 0.5);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp21_, TRUE);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp21_, TRUE);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_ref_sink (_tmp21_);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->storage_levelbar);
#line 137 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->storage_levelbar = _tmp21_;
#line 142 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp22_ = self->priv->storage_levelbar;
#line 142 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_level_bar_add_offset_value (_tmp22_, GTK_LEVEL_BAR_OFFSET_LOW, 0.9);
#line 143 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp23_ = self->priv->storage_levelbar;
#line 143 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_level_bar_add_offset_value (_tmp23_, GTK_LEVEL_BAR_OFFSET_HIGH, 0.95);
#line 144 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp24_ = self->priv->storage_levelbar;
#line 144 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_level_bar_add_offset_value (_tmp24_, GTK_LEVEL_BAR_OFFSET_FULL, (gdouble) 1);
#line 146 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp25_ = self->priv->storage_levelbar;
#line 146 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
#line 146 "../src/View/Sidebar/AbstractMountableRow.vala"
	storage_style_context = _tmp26_;
#line 147 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp27_ = storage_style_context;
#line 147 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_style_context_add_class (_tmp27_, GTK_STYLE_CLASS_FLAT);
#line 148 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp28_ = storage_style_context;
#line 148 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_style_context_add_class (_tmp28_, "inverted");
#line 149 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp29_ = storage_style_context;
#line 149 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp30_ = sidebar_abstract_mountable_row_devicerow_provider;
#line 149 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_style_context_add_provider (_tmp29_, (GtkStyleProvider*) _tmp30_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 151 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp31_ = ((SidebarBookmarkRow*) self)->icon_label_grid;
#line 151 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp32_ = self->priv->storage_levelbar;
#line 151 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_grid_attach (_tmp31_, (GtkWidget*) _tmp32_, 1, 1, 1, 1);
#line 153 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp33_ = sidebar_abstract_mountable_row_volume_monitor;
#line 153 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp33_, "mount-removed", (GCallback) _sidebar_abstract_mountable_row_on_mount_removed_g_volume_monitor_mount_removed, self, 0);
#line 154 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp34_ = sidebar_abstract_mountable_row_volume_monitor;
#line 154 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp34_, "mount-added", (GCallback) _sidebar_abstract_mountable_row_on_mount_added_g_volume_monitor_mount_added, self, 0);
#line 155 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp35_ = self->priv->unmount_eject_button;
#line 155 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp35_, "clicked", (GCallback) __sidebar_abstract_mountable_row___lambda172__gtk_button_clicked, self, 0);
#line 163 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 165 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_add_mountable_tooltip (self, NULL, NULL);
#line 167 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_update_visibilities (self);
#line 169 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp36_ = g_simple_action_new ("safely-remove", NULL);
#line 169 "../src/View/Sidebar/AbstractMountableRow.vala"
	safely_remove_action = _tmp36_;
#line 170 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp37_ = safely_remove_action;
#line 170 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp37_, "activate", (GCallback) __sidebar_abstract_mountable_row___lambda173__g_simple_action_activate, self, 0);
#line 172 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp38_ = g_simple_action_new ("eject", NULL);
#line 172 "../src/View/Sidebar/AbstractMountableRow.vala"
	eject_action = _tmp38_;
#line 173 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp39_ = eject_action;
#line 173 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp39_, "activate", (GCallback) __sidebar_abstract_mountable_row___lambda174__g_simple_action_activate, self, 0);
#line 175 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp40_ = g_simple_action_new ("properties", NULL);
#line 175 "../src/View/Sidebar/AbstractMountableRow.vala"
	properties_action = _tmp40_;
#line 176 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp41_ = properties_action;
#line 176 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp41_, "activate", (GCallback) _sidebar_abstract_mountable_row_show_mount_info_g_simple_action_activate, self, 0);
#line 178 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp42_ = g_simple_action_new ("unmount", NULL);
#line 178 "../src/View/Sidebar/AbstractMountableRow.vala"
	unmount_action = _tmp42_;
#line 179 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp43_ = unmount_action;
#line 179 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp43_, "activate", (GCallback) __sidebar_abstract_mountable_row___lambda175__g_simple_action_activate, self, 0);
#line 181 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp44_ = g_simple_action_new ("empty-trash", NULL);
#line 181 "../src/View/Sidebar/AbstractMountableRow.vala"
	empty_trash_action = _tmp44_;
#line 182 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp45_ = empty_trash_action;
#line 182 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_signal_connect_object (_tmp45_, "activate", (GCallback) __sidebar_abstract_mountable_row___lambda176__g_simple_action_activate, self, 0);
#line 184 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp46_ = g_simple_action_group_new ();
#line 184 "../src/View/Sidebar/AbstractMountableRow.vala"
	action_group = _tmp46_;
#line 185 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp47_ = action_group;
#line 185 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp48_ = safely_remove_action;
#line 185 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp47_, (GAction*) _tmp48_);
#line 186 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp49_ = action_group;
#line 186 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp50_ = eject_action;
#line 186 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp49_, (GAction*) _tmp50_);
#line 187 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp51_ = action_group;
#line 187 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp52_ = properties_action;
#line 187 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp51_, (GAction*) _tmp52_);
#line 188 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp53_ = action_group;
#line 188 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp54_ = unmount_action;
#line 188 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp53_, (GAction*) _tmp54_);
#line 189 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp55_ = action_group;
#line 189 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp56_ = empty_trash_action;
#line 189 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp55_, (GAction*) _tmp56_);
#line 191 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp57_ = action_group;
#line 191 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "mountable", (GActionGroup*) _tmp57_);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (action_group);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (empty_trash_action);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (unmount_action);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (properties_action);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (eject_action);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (safely_remove_action);
#line 111 "../src/View/Sidebar/AbstractMountableRow.vala"
	return obj;
#line 3414 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_class_init (SidebarAbstractMountableRowClass * klass,
                                           gpointer klass_data)
{
	GVolumeMonitor* _tmp0_;
	GtkCssProvider* _tmp1_;
	GtkCssProvider* _tmp2_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_type_class_adjust_private_offset (klass, &SidebarAbstractMountableRow_private_offset);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->update_free_space = (void (*) (SidebarAbstractMountableRow*)) sidebar_abstract_mountable_row_real_update_free_space;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->add_mountable_tooltip = (void (*) (SidebarAbstractMountableRow*, GAsyncReadyCallback, gpointer)) sidebar_abstract_mountable_row_real_add_mountable_tooltip;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->add_mountable_tooltip_finish = (void (*) (SidebarAbstractMountableRow*, GAsyncResult*)) sidebar_abstract_mountable_row_real_add_mountable_tooltip_finish;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->on_mount_removed = (void (*) (SidebarAbstractMountableRow*, GMount*)) sidebar_abstract_mountable_row_real_on_mount_removed;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->on_mount_added = (void (*) (SidebarAbstractMountableRow*, GMount*)) sidebar_abstract_mountable_row_real_on_mount_added;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->show_mount_info = (void (*) (SidebarAbstractMountableRow*)) sidebar_abstract_mountable_row_real_show_mount_info;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->get_filesystem_space = (void (*) (SidebarAbstractMountableRow*, GCancellable*, GAsyncReadyCallback, gpointer)) sidebar_abstract_mountable_row_real_get_filesystem_space;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	((SidebarAbstractMountableRowClass *) klass)->get_filesystem_space_finish = (gboolean (*) (SidebarAbstractMountableRow*, GAsyncResult*)) sidebar_abstract_mountable_row_real_get_filesystem_space_finish;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CLASS (klass)->get_is_mounted = (gboolean (*) (SidebarAbstractMountableRow*)) sidebar_abstract_mountable_row_real_get_is_mounted;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CLASS (klass)->get_can_unmount = (gboolean (*) (SidebarAbstractMountableRow*)) sidebar_abstract_mountable_row_real_get_can_unmount;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CLASS (klass)->get_can_eject = (gboolean (*) (SidebarAbstractMountableRow*)) sidebar_abstract_mountable_row_real_get_can_eject;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sidebar_abstract_mountable_row_get_property;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sidebar_abstract_mountable_row_set_property;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sidebar_abstract_mountable_row_constructor;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sidebar_abstract_mountable_row_finalize;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY] = g_param_spec_string ("sort-key", "sort-key", "sort-key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY] = g_param_spec_object ("mount", "mount", "mount", g_mount_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY] = g_param_spec_object ("drive", "drive", "drive", g_drive_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_IS_MOUNTED_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_UNMOUNT_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_UNMOUNT_PROPERTY] = g_param_spec_boolean ("can-unmount", "can-unmount", "can-unmount", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_EJECT_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_EJECT_PROPERTY] = g_param_spec_boolean ("can-eject", "can-eject", "can-eject", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY, sidebar_abstract_mountable_row_properties[SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY] = g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 106 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = g_volume_monitor_get ();
#line 106 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (sidebar_abstract_mountable_row_volume_monitor);
#line 106 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_volume_monitor = _tmp0_;
#line 107 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp1_ = gtk_css_provider_new ();
#line 107 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (sidebar_abstract_mountable_row_devicerow_provider);
#line 107 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_devicerow_provider = _tmp1_;
#line 108 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp2_ = sidebar_abstract_mountable_row_devicerow_provider;
#line 108 "../src/View/Sidebar/AbstractMountableRow.vala"
	gtk_css_provider_load_from_resource (_tmp2_, "/io/elementary/files/DiskRenderer.css");
#line 3490 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_sidebar_sidebar_item_interface_interface_init (SidebarSidebarItemInterfaceIface * iface,
                                                                              gpointer iface_data)
{
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	sidebar_abstract_mountable_row_sidebar_sidebar_item_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	iface->update_plugin_data = (void (*) (SidebarSidebarItemInterface*, FilesSidebarPluginItem*)) sidebar_abstract_mountable_row_real_update_plugin_data;
#line 3501 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_instance_init (SidebarAbstractMountableRow * self,
                                              gpointer klass)
{
	gchar* _tmp0_;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv = sidebar_abstract_mountable_row_get_instance_private (self);
#line 31 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->storage_capacity = (gdouble) 0;
#line 32 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->storage_free = (gdouble) 0;
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	_tmp0_ = g_strdup ("");
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->_sort_key = _tmp0_;
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->_mount = NULL;
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->_drive = NULL;
#line 47 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->valid = TRUE;
#line 68 "../src/View/Sidebar/AbstractMountableRow.vala"
	self->priv->_working = FALSE;
#line 3527 "AbstractMountableRow.c"
}

static void
sidebar_abstract_mountable_row_finalize (GObject * obj)
{
	SidebarAbstractMountableRow * self;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRow);
#line 33 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (self->priv->_sort_key);
#line 38 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_working_stack);
#line 39 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_revealer);
#line 40 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->working_spinner);
#line 41 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->unmount_eject_button);
#line 42 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->storage_levelbar);
#line 44 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->_mount);
#line 45 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_object_unref0 (self->priv->_drive);
#line 48 "../src/View/Sidebar/AbstractMountableRow.vala"
	_g_free0 (self->priv->_uuid);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	G_OBJECT_CLASS (sidebar_abstract_mountable_row_parent_class)->finalize (obj);
#line 3556 "AbstractMountableRow.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_abstract_mountable_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarAbstractMountableRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_abstract_mountable_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SidebarAbstractMountableRow), 0, (GInstanceInitFunc) sidebar_abstract_mountable_row_instance_init, NULL };
	static const GInterfaceInfo sidebar_sidebar_item_interface_info = { (GInterfaceInitFunc) sidebar_abstract_mountable_row_sidebar_sidebar_item_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType sidebar_abstract_mountable_row_type_id;
	sidebar_abstract_mountable_row_type_id = g_type_register_static (SIDEBAR_TYPE_BOOKMARK_ROW, "SidebarAbstractMountableRow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	g_type_add_interface_static (sidebar_abstract_mountable_row_type_id, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, &sidebar_sidebar_item_interface_info);
	SidebarAbstractMountableRow_private_offset = g_type_add_instance_private (sidebar_abstract_mountable_row_type_id, sizeof (SidebarAbstractMountableRowPrivate));
	return sidebar_abstract_mountable_row_type_id;
}

GType
sidebar_abstract_mountable_row_get_type (void)
{
	static volatile gsize sidebar_abstract_mountable_row_type_id__once = 0;
	if (g_once_init_enter (&sidebar_abstract_mountable_row_type_id__once)) {
		GType sidebar_abstract_mountable_row_type_id;
		sidebar_abstract_mountable_row_type_id = sidebar_abstract_mountable_row_get_type_once ();
		g_once_init_leave (&sidebar_abstract_mountable_row_type_id__once, sidebar_abstract_mountable_row_type_id);
	}
	return sidebar_abstract_mountable_row_type_id__once;
}

static void
_vala_sidebar_abstract_mountable_row_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	SidebarAbstractMountableRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRow);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (property_id) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_string (value, sidebar_abstract_mountable_row_get_sort_key (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_object (value, sidebar_abstract_mountable_row_get_mount (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_object (value, sidebar_abstract_mountable_row_get_drive (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_string (value, sidebar_abstract_mountable_row_get_uuid (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_IS_MOUNTED_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_boolean (value, sidebar_abstract_mountable_row_get_is_mounted (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_UNMOUNT_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_boolean (value, sidebar_abstract_mountable_row_get_can_unmount (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_CAN_EJECT_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_boolean (value, sidebar_abstract_mountable_row_get_can_eject (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		g_value_set_boolean (value, sidebar_abstract_mountable_row_get_working (self));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 3641 "AbstractMountableRow.c"
		default:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 3647 "AbstractMountableRow.c"
	}
}

static void
_vala_sidebar_abstract_mountable_row_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec)
{
	SidebarAbstractMountableRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_ABSTRACT_MOUNTABLE_ROW, SidebarAbstractMountableRow);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
	switch (property_id) {
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_SORT_KEY_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_set_sort_key (self, g_value_get_string (value));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_MOUNT_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_set_mount (self, g_value_get_object (value));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_DRIVE_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_set_drive (self, g_value_get_object (value));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_UUID_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_set_uuid (self, g_value_get_string (value));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		case SIDEBAR_ABSTRACT_MOUNTABLE_ROW_WORKING_PROPERTY:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		sidebar_abstract_mountable_row_set_working (self, g_value_get_boolean (value));
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 3691 "AbstractMountableRow.c"
		default:
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/View/Sidebar/AbstractMountableRow.vala"
		break;
#line 3697 "AbstractMountableRow.c"
	}
}

