/* BookmarkRow.c generated by valac 0.56.17, the Vala compiler
 * generated from BookmarkRow.vala, do not modify */

/* BookmarkRow.vala
 *
 * Copyright 2020 elementary LLC. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors: Jeremy Wootten <jeremy@elementaryos.org>
 */

#include <gtk/gtk.h>
#include "pantheon-files-core.h"
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <cairo-gobject.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SIDEBAR_TYPE_BOOKMARK_ROW (sidebar_bookmark_row_get_type ())
#define SIDEBAR_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow))
#define SIDEBAR_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))
#define SIDEBAR_IS_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_IS_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_BOOKMARK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))

typedef struct _SidebarBookmarkRow SidebarBookmarkRow;
typedef struct _SidebarBookmarkRowClass SidebarBookmarkRowClass;
typedef struct _SidebarBookmarkRowPrivate SidebarBookmarkRowPrivate;
enum  {
	SIDEBAR_BOOKMARK_ROW_0_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ID_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_URI_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY,
	SIDEBAR_BOOKMARK_ROW_NUM_PROPERTIES
};
static GParamSpec* sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _marlin_file_operations_common_job_unref0(var) ((var == NULL) ? NULL : (var = (marlin_file_operations_common_job_unref (var), NULL)))
#define _g_rand_free0(var) ((var == NULL) ? NULL : (var = (g_rand_free (var), NULL)))

struct _SidebarBookmarkRow {
	GtkListBoxRow parent_instance;
	SidebarBookmarkRowPrivate * priv;
	GtkGrid* content_grid;
	GtkGrid* icon_label_grid;
	GtkStack* label_stack;
	GtkEntry* editable;
	GtkLabel* label;
	GtkRevealer* drop_revealer;
};

struct _SidebarBookmarkRowClass {
	GtkListBoxRowClass parent_class;
	gboolean (*on_key_press_event) (SidebarBookmarkRow* self, guint keyval, guint keycode, GdkModifierType state);
	void (*on_button_release_event) (SidebarBookmarkRow* self, gint n_press, gdouble x, gdouble y);
	void (*popup_context_menu) (SidebarBookmarkRow* self);
};

struct _SidebarBookmarkRowPrivate {
	gboolean valid;
	GtkImage* icon;
	FilesFile* target_file;
	GList* drop_file_list;
	gchar* drop_text;
	gboolean drop_occurred;
	GdkDragAction* current_suggested_action;
	GtkEventControllerKey* key_controller;
	GtkGestureMultiPress* button_controller;
	gchar* _custom_name;
	SidebarSidebarListInterface* _list;
	guint32 _id;
	gchar* _uri;
	GIcon* _gicon;
	gboolean _pinned;
	gboolean _permanent;
	gboolean _can_insert_before;
	gboolean _can_insert_after;
	GMenuModel* _menu_model;
	GActionGroup* _action_group;
	gchar* _action_group_namespace;
	GSimpleAction* empty_all_trash_action;
};

static gint SidebarBookmarkRow_private_offset;
static gpointer sidebar_bookmark_row_parent_class = NULL;
static GtkTargetEntry* sidebar_bookmark_row_source_targets;
static gint sidebar_bookmark_row_source_targets_length1;
static GtkTargetEntry* sidebar_bookmark_row_source_targets = NULL;
static gint sidebar_bookmark_row_source_targets_length1 = 0;
static gint _sidebar_bookmark_row_source_targets_size_ = 0;
static GtkTargetEntry* sidebar_bookmark_row_dest_targets;
static gint sidebar_bookmark_row_dest_targets_length1;
static GtkTargetEntry* sidebar_bookmark_row_dest_targets = NULL;
static gint sidebar_bookmark_row_dest_targets_length1 = 0;
static gint _sidebar_bookmark_row_dest_targets_size_ = 0;
static GdkAtom sidebar_bookmark_row_text_data_atom;
static GdkAtom sidebar_bookmark_row_text_data_atom = 0U;
static SidebarSidebarItemInterfaceIface * sidebar_bookmark_row_sidebar_sidebar_item_interface_parent_iface = NULL;

VALA_EXTERN GType sidebar_bookmark_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarBookmarkRow, g_object_unref)
VALA_EXTERN gboolean sidebar_bookmark_row_on_key_press_event (SidebarBookmarkRow* self,
                                                  guint keyval,
                                                  guint keycode,
                                                  GdkModifierType state);
VALA_EXTERN void sidebar_bookmark_row_on_button_release_event (SidebarBookmarkRow* self,
                                                   gint n_press,
                                                   gdouble x,
                                                   gdouble y);
VALA_EXTERN void sidebar_bookmark_row_popup_context_menu (SidebarBookmarkRow* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static GdkDragAction* _gdk_drag_action_dup (GdkDragAction* self);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_new (const gchar* _custom_name,
                                              const gchar* uri,
                                              GIcon* gicon,
                                              SidebarSidebarListInterface* list,
                                              gboolean pinned,
                                              gboolean permanent);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_construct (GType object_type,
                                                    const gchar* _custom_name,
                                                    const gchar* uri,
                                                    GIcon* gicon,
                                                    SidebarSidebarListInterface* list,
                                                    gboolean pinned,
                                                    gboolean permanent);
static void sidebar_bookmark_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                                   FilesSidebarPluginItem* item);
static void sidebar_bookmark_row_rename (SidebarBookmarkRow* self);
VALA_EXTERN const gchar* sidebar_bookmark_row_get_display_name (SidebarBookmarkRow* self);
VALA_EXTERN void sidebar_bookmark_row_cancel_rename (SidebarBookmarkRow* self);
static void sidebar_bookmark_row_real_destroy_bookmark (SidebarSidebarItemInterface* base);
static gboolean sidebar_bookmark_row_real_on_key_press_event (SidebarBookmarkRow* self,
                                                       guint keyval,
                                                       guint keycode,
                                                       GdkModifierType state);
static void sidebar_bookmark_row_real_on_button_release_event (SidebarBookmarkRow* self,
                                                        gint n_press,
                                                        gdouble x,
                                                        gdouble y);
static void sidebar_bookmark_row_real_popup_context_menu (SidebarBookmarkRow* self);
static void sidebar_bookmark_row_real_add_extra_menu_items (SidebarSidebarItemInterface* base,
                                                     GMenu* menu);
static void sidebar_bookmark_row_set_up_drag (SidebarBookmarkRow* self);
static void __lambda150_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx);
static void ___lambda150__gtk_widget_drag_begin (GtkWidget* _sender,
                                          GdkDragContext* context,
                                          gpointer self);
static void __lambda151_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx,
                   GtkSelectionData* sel_data,
                   guint info,
                   guint time);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
static void ___lambda151__gtk_widget_drag_data_get (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self);
static void __lambda152_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx);
static void sidebar_bookmark_row_reset_drag_drop (SidebarBookmarkRow* self);
static void ___lambda152__gtk_widget_drag_end (GtkWidget* _sender,
                                        GdkDragContext* context,
                                        gpointer self);
static void sidebar_bookmark_row_set_up_drop (SidebarBookmarkRow* self);
static void __lambda153_ (SidebarBookmarkRow* self,
                   GdkDragContext* ctx,
                   gint x,
                   gint y,
                   GtkSelectionData* sel_data,
                   guint info,
                   guint time);
static gboolean sidebar_bookmark_row_process_dropped_row (SidebarBookmarkRow* self,
                                                   const gchar* drop_text,
                                                   gboolean dropped_between);
static gboolean sidebar_bookmark_row_process_dropped_uris (SidebarBookmarkRow* self,
                                                    GdkDragAction selected_action,
                                                    GdkDragAction possible_actions,
                                                    GList* drop_file_list,
                                                    gboolean dropped_between);
static void ___lambda153__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  GtkSelectionData* selection_data,
                                                  guint info,
                                                  guint time_,
                                                  gpointer self);
static gboolean __lambda154_ (SidebarBookmarkRow* self,
                       GdkDragContext* ctx,
                       gint x,
                       gint y,
                       guint time);
VALA_EXTERN gboolean sidebar_bookmark_row_reveal_drop_target (SidebarBookmarkRow* self,
                                                  gboolean reveal);
static gboolean _gdk_drag_action_equal (const GdkDragAction * s1,
                                 const GdkDragAction * s2);
VALA_EXTERN void sidebar_bookmark_row_highlight (SidebarBookmarkRow* self,
                                     gboolean show);
static gboolean ___lambda154__gtk_widget_drag_motion (GtkWidget* _sender,
                                               GdkDragContext* context,
                                               gint x,
                                               gint y,
                                               guint time_,
                                               gpointer self);
static void __lambda155_ (SidebarBookmarkRow* self);
static void ___lambda155__gtk_widget_drag_leave (GtkWidget* _sender,
                                          GdkDragContext* context,
                                          guint time_,
                                          gpointer self);
static gboolean __lambda156_ (SidebarBookmarkRow* self,
                       GdkDragContext* ctx,
                       gint x,
                       gint y,
                       guint time);
static gboolean ___lambda156__gtk_widget_drag_drop (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             guint time_,
                                             gpointer self);
VALA_EXTERN GtkWindow* files_get_active_window (void);
static GObject * sidebar_bookmark_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _sidebar_bookmark_row____lambda157_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row____lambda157__gtk_entry_activate (GtkEntry* _sender,
                                                              gpointer self);
static gboolean _sidebar_bookmark_row____lambda158_ (SidebarBookmarkRow* self);
static gboolean __sidebar_bookmark_row____lambda158__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static gboolean _sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                        guint keyval,
                                                                                        guint keycode,
                                                                                        GdkModifierType state,
                                                                                        gpointer self);
static void _sidebar_bookmark_row_on_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                     gint n_press,
                                                                                     gdouble x,
                                                                                     gdouble y,
                                                                                     gpointer self);
static void _sidebar_bookmark_row___lambda159_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda159__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sidebar_bookmark_row___lambda160_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda160__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sidebar_bookmark_row___lambda161_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda161__g_simple_action_activate (GSimpleAction* _sender,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void _sidebar_bookmark_row___lambda162_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda162__g_simple_action_activate (GSimpleAction* _sender,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void _sidebar_bookmark_row___lambda163_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda163__g_simple_action_activate (GSimpleAction* _sender,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void _sidebar_bookmark_row_rename_g_simple_action_activate (GSimpleAction* _sender,
                                                            GVariant* parameter,
                                                            gpointer self);
static void _sidebar_bookmark_row___lambda164_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda164__g_simple_action_activate (GSimpleAction* _sender,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void _sidebar_bookmark_row___lambda165_ (SidebarBookmarkRow* self);
static void __sidebar_bookmark_row___lambda165__g_simple_action_activate (GSimpleAction* _sender,
                                                                   GVariant* parameter,
                                                                   gpointer self);
static void sidebar_bookmark_row_finalize (GObject * obj);
static GType sidebar_bookmark_row_get_type_once (void);
static void _vala_sidebar_bookmark_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_sidebar_bookmark_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sidebar_bookmark_row_get_instance_private (SidebarBookmarkRow* self)
{
	return G_STRUCT_MEMBER_P (self, SidebarBookmarkRow_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 366 "BookmarkRow.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 374 "BookmarkRow.c"
}

static GdkDragAction*
_gdk_drag_action_dup (GdkDragAction* self)
{
	GdkDragAction* dup;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	dup = g_new0 (GdkDragAction, 1);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	memcpy (dup, self, sizeof (GdkDragAction));
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	return dup;
#line 387 "BookmarkRow.c"
}

static gpointer
__gdk_drag_action_dup0 (gpointer self)
{
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	return self ? _gdk_drag_action_dup (self) : NULL;
#line 395 "BookmarkRow.c"
}

SidebarBookmarkRow*
sidebar_bookmark_row_construct (GType object_type,
                                const gchar* _custom_name,
                                const gchar* uri,
                                GIcon* gicon,
                                SidebarSidebarListInterface* list,
                                gboolean pinned,
                                gboolean permanent)
{
	SidebarBookmarkRow * self = NULL;
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (_custom_name != NULL, NULL);
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 101 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) g_object_new (object_type, "custom-name", _custom_name, "uri", uri, "gicon", gicon, "list", list, "hexpand", TRUE, "pinned", pinned, "permanent", permanent, NULL);
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	return self;
#line 420 "BookmarkRow.c"
}

SidebarBookmarkRow*
sidebar_bookmark_row_new (const gchar* _custom_name,
                          const gchar* uri,
                          GIcon* gicon,
                          SidebarSidebarListInterface* list,
                          gboolean pinned,
                          gboolean permanent)
{
#line 95 "../src/View/Sidebar/BookmarkRow.vala"
	return sidebar_bookmark_row_construct (SIDEBAR_TYPE_BOOKMARK_ROW, _custom_name, uri, gicon, list, pinned, permanent);
#line 433 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_update_plugin_data (SidebarSidebarItemInterface* base,
                                              FilesSidebarPluginItem* item)
{
	SidebarBookmarkRow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GMenuModel* _tmp6_;
	GMenuModel* _tmp7_;
	GActionGroup* _tmp8_;
	GActionGroup* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 230 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 230 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (item != NULL);
#line 231 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = files_sidebar_plugin_item_get_name (item);
#line 231 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 231 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, _tmp1_);
#line 232 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = files_sidebar_plugin_item_get_uri (item);
#line 232 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 232 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_uri ((SidebarSidebarItemInterface*) self, _tmp3_);
#line 233 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = files_sidebar_plugin_item_get_icon (item);
#line 233 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 233 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_update_icon ((SidebarSidebarItemInterface*) self, _tmp5_);
#line 234 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = files_sidebar_plugin_item_get_menu_model (item);
#line 234 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 234 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_menu_model ((SidebarSidebarItemInterface*) self, _tmp7_);
#line 235 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = files_sidebar_plugin_item_get_action_group (item);
#line 235 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = _tmp8_;
#line 235 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_action_group ((SidebarSidebarItemInterface*) self, _tmp9_);
#line 236 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = files_sidebar_plugin_item_get_action_group_namespace (item);
#line 236 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = _tmp10_;
#line 236 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_action_group_namespace ((SidebarSidebarItemInterface*) self, _tmp11_);
#line 493 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_rename (SidebarBookmarkRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 239 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 240 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 240 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp1_) {
#line 509 "BookmarkRow.c"
		GtkEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		GtkStack* _tmp5_;
		GtkEntry* _tmp6_;
#line 241 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = self->editable;
#line 241 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = sidebar_bookmark_row_get_display_name (self);
#line 241 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = _tmp3_;
#line 241 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_entry_set_text (_tmp2_, _tmp4_);
#line 242 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = self->label_stack;
#line 242 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_stack_set_visible_child_name (_tmp5_, "editable");
#line 243 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = self->editable;
#line 243 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 531 "BookmarkRow.c"
	}
}

void
sidebar_bookmark_row_cancel_rename (SidebarBookmarkRow* self)
{
	GtkStack* _tmp0_;
#line 247 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 248 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "label");
#line 249 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_grab_focus ((GtkWidget*) self);
#line 547 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_destroy_bookmark (SidebarSidebarItemInterface* base)
{
	SidebarBookmarkRow * self;
	GeeHashMap* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
#line 252 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 254 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->valid = FALSE;
#line 255 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_lock (&sidebar_sidebar_item_interface_item_map_lock);
#line 256 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_item_id_map;
#line 256 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 256 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 256 "../src/View/Sidebar/BookmarkRow.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) _tmp2_), NULL);
#line 257 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_unlock (&sidebar_sidebar_item_interface_item_map_lock);
#line 258 "../src/View/Sidebar/BookmarkRow.vala"
	GTK_WIDGET_CLASS (sidebar_bookmark_row_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 575 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_real_on_key_press_event (SidebarBookmarkRow* self,
                                              guint keyval,
                                              guint keycode,
                                              GdkModifierType state)
{
	gboolean result;
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
	switch (keyval) {
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_KEY_Escape:
#line 589 "BookmarkRow.c"
		{
#line 264 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_cancel_rename (self);
#line 265 "../src/View/Sidebar/BookmarkRow.vala"
			result = TRUE;
#line 265 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 597 "BookmarkRow.c"
		}
#line 262 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_KEY_Menu:
#line 601 "BookmarkRow.c"
		{
#line 268 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_popup_context_menu (self);
#line 269 "../src/View/Sidebar/BookmarkRow.vala"
			result = TRUE;
#line 269 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 609 "BookmarkRow.c"
		}
		default:
		{
#line 272 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 615 "BookmarkRow.c"
		}
	}
#line 275 "../src/View/Sidebar/BookmarkRow.vala"
	result = FALSE;
#line 275 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 622 "BookmarkRow.c"
}

gboolean
sidebar_bookmark_row_on_key_press_event (SidebarBookmarkRow* self,
                                         guint keyval,
                                         guint keycode,
                                         GdkModifierType state)
{
	SidebarBookmarkRowClass* _klass_;
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->on_key_press_event) {
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
		return _klass_->on_key_press_event (self, keyval, keycode, state);
#line 640 "BookmarkRow.c"
	}
#line 261 "../src/View/Sidebar/BookmarkRow.vala"
	return FALSE;
#line 644 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_on_button_release_event (SidebarBookmarkRow* self,
                                                   gint n_press,
                                                   gdouble x,
                                                   gdouble y)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GdkModifierType state = 0U;
	GdkModifierType _tmp3_ = 0U;
	GdkModifierType mods = 0U;
	gboolean control_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean only_control_pressed = FALSE;
	GtkGestureMultiPress* _tmp5_;
#line 279 "../src/View/Sidebar/BookmarkRow.vala"
	if (!self->priv->valid) {
#line 280 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 668 "BookmarkRow.c"
	}
#line 283 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 283 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 283 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 283 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (_tmp2_, "editable") == 0) {
#line 284 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 680 "BookmarkRow.c"
	}
#line 288 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_get_current_event_state (&_tmp3_);
#line 288 "../src/View/Sidebar/BookmarkRow.vala"
	state = _tmp3_;
#line 289 "../src/View/Sidebar/BookmarkRow.vala"
	mods = state & gtk_accelerator_get_default_mod_mask ();
#line 290 "../src/View/Sidebar/BookmarkRow.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 291 "../src/View/Sidebar/BookmarkRow.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 292 "../src/View/Sidebar/BookmarkRow.vala"
	if (control_pressed) {
#line 292 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = !other_mod_pressed;
#line 696 "BookmarkRow.c"
	} else {
#line 292 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = FALSE;
#line 700 "BookmarkRow.c"
	}
#line 292 "../src/View/Sidebar/BookmarkRow.vala"
	only_control_pressed = _tmp4_;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = self->priv->button_controller;
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
	switch (gtk_gesture_single_get_current_button ((GtkGestureSingle*) _tmp5_)) {
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_PRIMARY:
#line 710 "BookmarkRow.c"
		{
#line 296 "../src/View/Sidebar/BookmarkRow.vala"
			if (only_control_pressed) {
#line 297 "../src/View/Sidebar/BookmarkRow.vala"
				sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 716 "BookmarkRow.c"
			}
#line 300 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 720 "BookmarkRow.c"
		}
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_SECONDARY:
#line 724 "BookmarkRow.c"
		{
#line 302 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_bookmark_row_popup_context_menu (self);
#line 303 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 730 "BookmarkRow.c"
		}
#line 294 "../src/View/Sidebar/BookmarkRow.vala"
		case GDK_BUTTON_MIDDLE:
#line 734 "BookmarkRow.c"
		{
#line 306 "../src/View/Sidebar/BookmarkRow.vala"
			sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 307 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 740 "BookmarkRow.c"
		}
		default:
		{
#line 310 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 746 "BookmarkRow.c"
		}
	}
}

void
sidebar_bookmark_row_on_button_release_event (SidebarBookmarkRow* self,
                                              gint n_press,
                                              gdouble x,
                                              gdouble y)
{
	SidebarBookmarkRowClass* _klass_;
#line 278 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 278 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->on_button_release_event) {
#line 278 "../src/View/Sidebar/BookmarkRow.vala"
		_klass_->on_button_release_event (self, n_press, x, y);
#line 766 "BookmarkRow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 775 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_popup_context_menu (SidebarBookmarkRow* self)
{
	GMenu* open_section = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp1_;
	GMenu* _tmp2_;
	GMenu* glib_menu = NULL;
	GMenu* _tmp3_;
	GMenu* _tmp4_;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	GtkMenu* popupmenu = NULL;
	GMenu* _tmp8_;
	GtkWidget* _tmp9_;
	GtkMenu* _tmp10_ = NULL;
	GMenuModel* _tmp11_;
	GMenuModel* _tmp12_;
	GtkMenu* _tmp21_;
#line 315 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = g_menu_new ();
#line 315 "../src/View/Sidebar/BookmarkRow.vala"
	open_section = _tmp0_;
#line 316 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = open_section;
#line 316 "../src/View/Sidebar/BookmarkRow.vala"
	g_menu_append (_tmp1_, _ ("Open in New _Tab"), "bookmark.open-tab");
#line 317 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = open_section;
#line 317 "../src/View/Sidebar/BookmarkRow.vala"
	g_menu_append (_tmp2_, _ ("Open in New _Window"), "bookmark.open-window");
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = g_menu_new ();
#line 319 "../src/View/Sidebar/BookmarkRow.vala"
	glib_menu = _tmp3_;
#line 320 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = glib_menu;
#line 320 "../src/View/Sidebar/BookmarkRow.vala"
	g_menu_append (_tmp4_, _ ("Open"), "bookmark.open");
#line 321 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = glib_menu;
#line 321 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = open_section;
#line 321 "../src/View/Sidebar/BookmarkRow.vala"
	g_menu_append_section (_tmp5_, NULL, (GMenuModel*) _tmp6_);
#line 323 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = glib_menu;
#line 323 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_add_extra_menu_items ((SidebarSidebarItemInterface*) self, _tmp7_);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = glib_menu;
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = _g_object_ref0 ((GtkWidget*) self);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) _tmp8_);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_set (_tmp10_, "attach-widget", _tmp9_, NULL);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp9_);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp10_);
#line 325 "../src/View/Sidebar/BookmarkRow.vala"
	popupmenu = _tmp10_;
#line 329 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self);
#line 329 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _tmp11_;
#line 329 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp12_ != NULL) {
#line 848 "BookmarkRow.c"
		GtkMenu* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		GActionGroup* _tmp16_;
		GActionGroup* _tmp17_;
		GMenu* _tmp18_;
		GMenuModel* _tmp19_;
		GMenuModel* _tmp20_;
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp13_ = popupmenu;
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp14_ = sidebar_sidebar_item_interface_get_action_group_namespace ((SidebarSidebarItemInterface*) self);
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp15_ = _tmp14_;
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp16_ = sidebar_sidebar_item_interface_get_action_group ((SidebarSidebarItemInterface*) self);
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp17_ = _tmp16_;
#line 330 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_widget_insert_action_group ((GtkWidget*) _tmp13_, _tmp15_, _tmp17_);
#line 331 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp18_ = glib_menu;
#line 331 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp19_ = sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self);
#line 331 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp20_ = _tmp19_;
#line 331 "../src/View/Sidebar/BookmarkRow.vala"
		g_menu_append_section (_tmp18_, NULL, _tmp20_);
#line 877 "BookmarkRow.c"
	}
#line 334 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp21_ = popupmenu;
#line 334 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_menu_popup_at_pointer (_tmp21_, NULL);
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (popupmenu);
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (glib_menu);
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (open_section);
#line 889 "BookmarkRow.c"
}

void
sidebar_bookmark_row_popup_context_menu (SidebarBookmarkRow* self)
{
	SidebarBookmarkRowClass* _klass_;
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	_klass_ = SIDEBAR_BOOKMARK_ROW_GET_CLASS (self);
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
	if (_klass_->popup_context_menu) {
#line 314 "../src/View/Sidebar/BookmarkRow.vala"
		_klass_->popup_context_menu (self);
#line 904 "BookmarkRow.c"
	}
}

static void
sidebar_bookmark_row_real_add_extra_menu_items (SidebarSidebarItemInterface* base,
                                                GMenu* menu)
{
	SidebarBookmarkRow * self;
	GMenu* menu_section = NULL;
	GMenu* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GMenu* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_;
#line 337 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 337 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (menu != NULL);
#line 339 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = g_menu_new ();
#line 339 "../src/View/Sidebar/BookmarkRow.vala"
	menu_section = _tmp0_;
#line 340 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) self);
#line 340 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 340 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp2_) {
#line 939 "BookmarkRow.c"
		GMenu* _tmp3_;
#line 341 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = menu_section;
#line 341 "../src/View/Sidebar/BookmarkRow.vala"
		g_menu_append (_tmp3_, _ ("Remove"), "bookmark.remove");
#line 945 "BookmarkRow.c"
	}
#line 344 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 344 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 344 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp5_) {
#line 953 "BookmarkRow.c"
		GMenu* _tmp6_;
#line 345 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = menu_section;
#line 345 "../src/View/Sidebar/BookmarkRow.vala"
		g_menu_append (_tmp6_, _ ("Rename"), "bookmark.rename");
#line 959 "BookmarkRow.c"
	}
#line 348 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = menu_section;
#line 348 "../src/View/Sidebar/BookmarkRow.vala"
	g_menu_append_section (menu, NULL, (GMenuModel*) _tmp7_);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = _tmp8_;
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = g_uri_parse_scheme (_tmp9_);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = _tmp10_;
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = g_strcmp0 (_tmp11_, "trash") == 0;
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp11_);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp12_) {
#line 979 "BookmarkRow.c"
		GVolumeMonitor* volume_monitor = NULL;
		GVolumeMonitor* _tmp13_;
		gint mounts_with_trash = 0;
		GVolumeMonitor* _tmp14_;
		GList* _tmp15_;
		const gchar* _tmp19_ = NULL;
		gchar* text = NULL;
		gchar* _tmp20_;
		GMenu* trash_section = NULL;
		GMenu* _tmp21_;
		GMenu* _tmp22_;
		const gchar* _tmp23_;
		GMenu* _tmp24_;
		GSimpleAction* _tmp25_;
		FilesTrashMonitor* _tmp26_;
		gboolean _tmp27_;
		gboolean _tmp28_;
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp13_ = g_volume_monitor_get ();
#line 351 "../src/View/Sidebar/BookmarkRow.vala"
		volume_monitor = _tmp13_;
#line 352 "../src/View/Sidebar/BookmarkRow.vala"
		mounts_with_trash = 0;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp14_ = volume_monitor;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp15_ = g_volume_monitor_get_mounts (_tmp14_);
#line 1007 "BookmarkRow.c"
		{
			GList* mount_collection = NULL;
			GList* mount_it = NULL;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
			mount_collection = _tmp15_;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
			for (mount_it = mount_collection; mount_it != NULL; mount_it = mount_it->next) {
#line 1015 "BookmarkRow.c"
				GMount* _tmp16_;
				GMount* mount = NULL;
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp16_ = _g_object_ref0 ((GMount*) mount_it->data);
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
				mount = _tmp16_;
#line 1022 "BookmarkRow.c"
				{
					GMount* _tmp17_;
#line 354 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp17_ = mount;
#line 354 "../src/View/Sidebar/BookmarkRow.vala"
					if (marlin_file_operations_mount_has_trash (_tmp17_)) {
#line 1029 "BookmarkRow.c"
						gint _tmp18_;
#line 355 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp18_ = mounts_with_trash;
#line 355 "../src/View/Sidebar/BookmarkRow.vala"
						mounts_with_trash = _tmp18_ + 1;
#line 1035 "BookmarkRow.c"
					}
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
					_g_object_unref0 (mount);
#line 1039 "BookmarkRow.c"
				}
			}
#line 353 "../src/View/Sidebar/BookmarkRow.vala"
			(mount_collection == NULL) ? NULL : (mount_collection = (_g_list_free__g_object_unref0_ (mount_collection), NULL));
#line 1044 "BookmarkRow.c"
		}
#line 359 "../src/View/Sidebar/BookmarkRow.vala"
		if (mounts_with_trash > 0) {
#line 359 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp19_ = _ ("Permanently Delete All Trash");
#line 1050 "BookmarkRow.c"
		} else {
#line 359 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp19_ = _ ("Permanently Delete Trash");
#line 1054 "BookmarkRow.c"
		}
#line 359 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 359 "../src/View/Sidebar/BookmarkRow.vala"
		text = _tmp20_;
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp21_ = g_menu_new ();
#line 361 "../src/View/Sidebar/BookmarkRow.vala"
		trash_section = _tmp21_;
#line 363 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp22_ = trash_section;
#line 363 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp23_ = text;
#line 363 "../src/View/Sidebar/BookmarkRow.vala"
		g_menu_append (_tmp22_, _tmp23_, "bookmark.empty-all-trash");
#line 365 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp24_ = trash_section;
#line 365 "../src/View/Sidebar/BookmarkRow.vala"
		g_menu_append_section (menu, NULL, (GMenuModel*) _tmp24_);
#line 367 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp25_ = self->priv->empty_all_trash_action;
#line 367 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp26_ = files_trash_monitor_get_default ();
#line 367 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp27_ = files_trash_monitor_get_is_empty (_tmp26_);
#line 367 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp28_ = _tmp27_;
#line 367 "../src/View/Sidebar/BookmarkRow.vala"
		g_simple_action_set_enabled (_tmp25_, !_tmp28_);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (trash_section);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (text);
#line 350 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (volume_monitor);
#line 1090 "BookmarkRow.c"
	}
#line 337 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (menu_section);
#line 1094 "BookmarkRow.c"
}

static void
__lambda150_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx)
{
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	cairo_surface_t* surface = NULL;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_t* cr = NULL;
	cairo_t* _tmp4_;
	gboolean _tmp5_ = FALSE;
	cairo_surface_t* surface2 = NULL;
	GtkAllocation _tmp6_;
	GtkAllocation _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* cr2 = NULL;
	cairo_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	GdkDevice* device = NULL;
	GdkDevice* _tmp11_;
	GdkDevice* _tmp12_;
	gint x = 0;
	gint y = 0;
	GdkModifierType mask = 0U;
	GdkWindow* _tmp13_;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	GdkModifierType _tmp16_ = 0U;
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 387 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp0_);
#line 387 "../src/View/Sidebar/BookmarkRow.vala"
	alloc = _tmp0_;
#line 388 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = alloc;
#line 388 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = alloc;
#line 388 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp1_.width, _tmp2_.height);
#line 388 "../src/View/Sidebar/BookmarkRow.vala"
	surface = _tmp3_;
#line 389 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = cairo_create (surface);
#line 389 "../src/View/Sidebar/BookmarkRow.vala"
	cr = _tmp4_;
#line 390 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_emit_by_name ((GtkWidget*) self, "draw", cr, &_tmp5_);
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = alloc;
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = alloc;
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp6_.width, _tmp7_.height);
#line 392 "../src/View/Sidebar/BookmarkRow.vala"
	surface2 = _tmp8_;
#line 393 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = cairo_create (surface2);
#line 393 "../src/View/Sidebar/BookmarkRow.vala"
	cr2 = _tmp9_;
#line 394 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = cairo_get_target (cr);
#line 394 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_set_source_surface (cr2, _tmp10_, (gdouble) 0, (gdouble) 1);
#line 395 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_set_operator (cr2, CAIRO_OPERATOR_OVER);
#line 396 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_paint_with_alpha (cr2, 0.5);
#line 399 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = gtk_get_current_event_device ();
#line 399 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 399 "../src/View/Sidebar/BookmarkRow.vala"
	device = _tmp12_;
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = gtk_widget_get_window ((GtkWidget*) self);
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	gdk_window_get_device_position (_tmp13_, device, &_tmp14_, &_tmp15_, &_tmp16_);
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	x = _tmp14_;
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	y = _tmp15_;
#line 402 "../src/View/Sidebar/BookmarkRow.vala"
	mask = _tmp16_;
#line 403 "../src/View/Sidebar/BookmarkRow.vala"
	cairo_surface_set_device_offset (surface2, (gdouble) (-x), (gdouble) 0);
#line 405 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_set_icon_surface (ctx, surface2);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (device);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_destroy0 (cr2);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_surface_destroy0 (surface2);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_destroy0 (cr);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	_cairo_surface_destroy0 (surface);
#line 1197 "BookmarkRow.c"
}

static void
___lambda150__gtk_widget_drag_begin (GtkWidget* _sender,
                                     GdkDragContext* context,
                                     gpointer self)
{
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda150_ ((SidebarBookmarkRow*) self, context);
#line 1207 "BookmarkRow.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1244 "BookmarkRow.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1250 "BookmarkRow.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	if (length > 0) {
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1261 "BookmarkRow.c"
	}
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	return NULL;
#line 1265 "BookmarkRow.c"
}

static void
__lambda151_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              GtkSelectionData* sel_data,
              guint info,
              guint time)
{
	guint8* data = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp5_ = 0;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint data_length1;
	gint _data_size_;
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (sel_data != NULL);
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = g_strdup_printf ("%u", _tmp1_);
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = string_get_data (_tmp3_, &_tmp5_);
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4__length1 = _tmp5_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = _tmp4_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6__length1 = _tmp4__length1;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup3 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7__length1 = _tmp6__length1;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = _tmp7_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8__length1 = _tmp7__length1;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp3_);
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	data = _tmp8_;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	data_length1 = _tmp8__length1;
#line 411 "../src/View/Sidebar/BookmarkRow.vala"
	_data_size_ = data_length1;
#line 412 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_selection_data_set (sel_data, sidebar_bookmark_row_text_data_atom, 8, data, (gint) data_length1);
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
	data = (g_free (data), NULL);
#line 1331 "BookmarkRow.c"
}

static void
___lambda151__gtk_widget_drag_data_get (GtkWidget* _sender,
                                        GdkDragContext* context,
                                        GtkSelectionData* selection_data,
                                        guint info,
                                        guint time_,
                                        gpointer self)
{
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda151_ ((SidebarBookmarkRow*) self, context, selection_data, info, time_);
#line 1344 "BookmarkRow.c"
}

static void
__lambda152_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx)
{
#line 415 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 416 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reset_drag_drop (self);
#line 1355 "BookmarkRow.c"
}

static void
___lambda152__gtk_widget_drag_end (GtkWidget* _sender,
                                   GdkDragContext* context,
                                   gpointer self)
{
#line 415 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda152_ ((SidebarBookmarkRow*) self, context);
#line 1365 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_set_up_drag (SidebarBookmarkRow* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTargetEntry* _tmp2_;
	gint _tmp2__length1;
#line 372 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 373 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 373 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp1_) {
#line 374 "../src/View/Sidebar/BookmarkRow.vala"
		return;
#line 1385 "BookmarkRow.c"
	}
#line 377 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = sidebar_bookmark_row_source_targets;
#line 377 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2__length1 = sidebar_bookmark_row_source_targets_length1;
#line 377 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp2_, (gint) _tmp2__length1, GDK_ACTION_MOVE);
#line 384 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) ___lambda150__gtk_widget_drag_begin, self, 0);
#line 410 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) ___lambda151__gtk_widget_drag_data_get, self, 0);
#line 415 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) ___lambda152__gtk_widget_drag_end, self, 0);
#line 1399 "BookmarkRow.c"
}

static void
__lambda153_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              GtkSelectionData* sel_data,
              guint info,
              guint time)
{
#line 442 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (ctx != NULL);
#line 442 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (sel_data != NULL);
#line 443 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 443 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 445 "../src/View/Sidebar/BookmarkRow.vala"
	switch (info) {
#line 445 "../src/View/Sidebar/BookmarkRow.vala"
		case FILES_TARGET_TYPE_BOOKMARK_ROW:
#line 1423 "BookmarkRow.c"
		{
			gchar* _tmp0_;
#line 447 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp0_ = gtk_selection_data_get_text (sel_data);
#line 447 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->drop_text);
#line 447 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->drop_text = _tmp0_;
#line 448 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1434 "BookmarkRow.c"
		}
#line 445 "../src/View/Sidebar/BookmarkRow.vala"
		case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 1438 "BookmarkRow.c"
		{
			gchar* _tmp1_ = NULL;
			gboolean _tmp2_;
#line 451 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp2_ = files_dnd_handler_selection_data_is_uri_list (sel_data, info, &_tmp1_);
#line 451 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->drop_text);
#line 451 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->drop_text = _tmp1_;
#line 451 "../src/View/Sidebar/BookmarkRow.vala"
			if (!_tmp2_) {
#line 452 "../src/View/Sidebar/BookmarkRow.vala"
				g_warning ("BookmarkRow.vala:452: sel data not uri list");
#line 453 "../src/View/Sidebar/BookmarkRow.vala"
				_g_free0 (self->priv->drop_text);
#line 453 "../src/View/Sidebar/BookmarkRow.vala"
				self->priv->drop_text = NULL;
#line 1456 "BookmarkRow.c"
			} else {
				const gchar* _tmp3_;
				GList* _tmp4_;
#line 455 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp3_ = self->priv->drop_text;
#line 455 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp4_ = files_file_utils_files_from_uris (_tmp3_);
#line 455 "../src/View/Sidebar/BookmarkRow.vala"
				(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 455 "../src/View/Sidebar/BookmarkRow.vala"
				self->priv->drop_file_list = _tmp4_;
#line 1468 "BookmarkRow.c"
			}
#line 458 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1472 "BookmarkRow.c"
		}
		default:
		{
#line 461 "../src/View/Sidebar/BookmarkRow.vala"
			return;
#line 1478 "BookmarkRow.c"
		}
	}
#line 464 "../src/View/Sidebar/BookmarkRow.vala"
	if (self->priv->drop_occurred) {
#line 1483 "BookmarkRow.c"
		gboolean success = FALSE;
#line 465 "../src/View/Sidebar/BookmarkRow.vala"
		success = FALSE;
#line 466 "../src/View/Sidebar/BookmarkRow.vala"
		switch (info) {
#line 466 "../src/View/Sidebar/BookmarkRow.vala"
			case FILES_TARGET_TYPE_BOOKMARK_ROW:
#line 1491 "BookmarkRow.c"
			{
				const gchar* _tmp5_;
				GtkRevealer* _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp5_ = self->priv->drop_text;
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp6_ = self->drop_revealer;
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp7_ = gtk_revealer_get_child_revealed (_tmp6_);
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp8_ = _tmp7_;
#line 468 "../src/View/Sidebar/BookmarkRow.vala"
				success = sidebar_bookmark_row_process_dropped_row (self, _tmp5_, _tmp8_);
#line 472 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1509 "BookmarkRow.c"
			}
#line 466 "../src/View/Sidebar/BookmarkRow.vala"
			case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 1513 "BookmarkRow.c"
			{
				GList* _tmp9_;
				GtkRevealer* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp9_ = self->priv->drop_file_list;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp10_ = self->drop_revealer;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp11_ = gtk_revealer_get_child_revealed (_tmp10_);
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp12_ = _tmp11_;
#line 475 "../src/View/Sidebar/BookmarkRow.vala"
				success = sidebar_bookmark_row_process_dropped_uris (self, gdk_drag_context_get_selected_action (ctx), gdk_drag_context_get_actions (ctx), _tmp9_, _tmp12_);
#line 481 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1531 "BookmarkRow.c"
			}
			default:
#line 466 "../src/View/Sidebar/BookmarkRow.vala"
			break;
#line 1536 "BookmarkRow.c"
		}
#line 485 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_drag_finish (ctx, success, FALSE, (guint32) time);
#line 486 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_bookmark_row_reset_drag_drop (self);
#line 1542 "BookmarkRow.c"
	}
}

static void
___lambda153__gtk_widget_drag_data_received (GtkWidget* _sender,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             GtkSelectionData* selection_data,
                                             guint info,
                                             guint time_,
                                             gpointer self)
{
#line 442 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda153_ ((SidebarBookmarkRow*) self, context, x, y, selection_data, info, time_);
#line 1558 "BookmarkRow.c"
}

static gboolean
_gdk_drag_action_equal (const GdkDragAction * s1,
                        const GdkDragAction * s2)
{
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
	if (s1 == s2) {
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
		return TRUE;
#line 1569 "BookmarkRow.c"
	}
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
	if (s1 == NULL) {
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
		return FALSE;
#line 1575 "BookmarkRow.c"
	}
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
	if (s2 == NULL) {
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
		return FALSE;
#line 1581 "BookmarkRow.c"
	}
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
	return (*s1) == (*s2);
#line 1585 "BookmarkRow.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 1606 "BookmarkRow.c"
}

static gboolean
__lambda154_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              guint time)
{
	GdkAtom target = (GdkAtom) 0U;
	const gchar* _tmp0_;
	gint pos = 0;
	SidebarBookmarkRow* previous_item = NULL;
	SidebarSidebarListInterface* _tmp1_;
	SidebarSidebarListInterface* _tmp2_;
	SidebarSidebarItemInterface* _tmp3_;
	SidebarBookmarkRow* next_item = NULL;
	SidebarSidebarListInterface* _tmp4_;
	SidebarSidebarListInterface* _tmp5_;
	SidebarSidebarItemInterface* _tmp6_;
	SidebarBookmarkRow* _tmp7_;
	gint row_height = 0;
	GtkGrid* _tmp9_;
	gboolean reveal = FALSE;
	GdkDragAction _tmp10_;
	GdkDragAction* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GQuark _tmp15_ = 0U;
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	static GQuark _tmp14_label0 = 0;
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	static GQuark _tmp14_label1 = 0;
#line 1640 "BookmarkRow.c"
	GdkDragAction* _tmp58_;
	gboolean result;
#line 491 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 492 "../src/View/Sidebar/BookmarkRow.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, ctx, NULL);
#line 493 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->drop_text;
#line 493 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_ == NULL) {
#line 494 "../src/View/Sidebar/BookmarkRow.vala"
		if (target != GDK_NONE) {
#line 495 "../src/View/Sidebar/BookmarkRow.vala"
			gtk_drag_get_data ((GtkWidget*) self, ctx, target, (guint32) time);
#line 1655 "BookmarkRow.c"
		}
#line 498 "../src/View/Sidebar/BookmarkRow.vala"
		result = TRUE;
#line 498 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 1661 "BookmarkRow.c"
	}
#line 501 "../src/View/Sidebar/BookmarkRow.vala"
	pos = sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self);
#line 502 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 502 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 502 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = sidebar_sidebar_list_interface_get_item_at_index (_tmp2_, pos - 1);
#line 502 "../src/View/Sidebar/BookmarkRow.vala"
	previous_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 503 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 503 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 503 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = sidebar_sidebar_list_interface_get_item_at_index (_tmp5_, pos + 1);
#line 503 "../src/View/Sidebar/BookmarkRow.vala"
	next_item = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 505 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = previous_item;
#line 505 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp7_ != NULL) {
#line 1685 "BookmarkRow.c"
		SidebarBookmarkRow* _tmp8_;
#line 506 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = previous_item;
#line 506 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_bookmark_row_reveal_drop_target (_tmp8_, FALSE);
#line 1691 "BookmarkRow.c"
	}
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = self->icon_label_grid;
#line 509 "../src/View/Sidebar/BookmarkRow.vala"
	row_height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp9_);
#line 510 "../src/View/Sidebar/BookmarkRow.vala"
	reveal = FALSE;
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = GDK_ACTION_DEFAULT;
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = __gdk_drag_action_dup0 (&_tmp10_);
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 512 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp11_;
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = gdk_atom_name (target);
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = _tmp12_;
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	g_free (_tmp13_);
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("text/plain")))) {
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1719 "BookmarkRow.c"
			default:
			{
				gboolean _tmp16_ = FALSE;
				gboolean _tmp17_ = FALSE;
				gboolean _tmp18_;
				gboolean _tmp19_;
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp18_ = sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self);
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp19_ = _tmp18_;
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp19_) {
#line 1732 "BookmarkRow.c"
					gboolean _tmp20_ = FALSE;
					SidebarBookmarkRow* _tmp21_;
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp21_ = next_item;
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
					if (_tmp21_ == NULL) {
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp20_ = TRUE;
#line 1741 "BookmarkRow.c"
					} else {
						SidebarBookmarkRow* _tmp22_;
						gboolean _tmp23_;
						gboolean _tmp24_;
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp22_ = next_item;
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp23_ = sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) _tmp22_);
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp24_ = _tmp23_;
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp20_ = _tmp24_;
#line 1754 "BookmarkRow.c"
					}
#line 516 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp17_ = _tmp20_;
#line 1758 "BookmarkRow.c"
				} else {
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp17_ = FALSE;
#line 1762 "BookmarkRow.c"
				}
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp17_) {
#line 517 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp16_ = y > (row_height / 2);
#line 1768 "BookmarkRow.c"
				} else {
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp16_ = FALSE;
#line 1772 "BookmarkRow.c"
				}
#line 515 "../src/View/Sidebar/BookmarkRow.vala"
				reveal = _tmp16_;
#line 519 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1778 "BookmarkRow.c"
			}
		}
	} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("text/uri-list")))) {
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1784 "BookmarkRow.c"
			default:
			{
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_;
				gboolean _tmp28_;
				gboolean _tmp34_ = FALSE;
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp27_ = sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self);
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
				_tmp28_ = _tmp27_;
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp28_) {
#line 1798 "BookmarkRow.c"
					gboolean _tmp29_ = FALSE;
					SidebarBookmarkRow* _tmp30_;
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp30_ = next_item;
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
					if (_tmp30_ == NULL) {
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp29_ = TRUE;
#line 1807 "BookmarkRow.c"
					} else {
						SidebarBookmarkRow* _tmp31_;
						gboolean _tmp32_;
						gboolean _tmp33_;
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp31_ = next_item;
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp32_ = sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) _tmp31_);
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp33_ = _tmp32_;
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
						_tmp29_ = _tmp33_;
#line 1820 "BookmarkRow.c"
					}
#line 523 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp26_ = _tmp29_;
#line 1824 "BookmarkRow.c"
				} else {
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp26_ = FALSE;
#line 1828 "BookmarkRow.c"
				}
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp26_) {
#line 524 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp25_ = y > (row_height - 1);
#line 1834 "BookmarkRow.c"
				} else {
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp25_ = FALSE;
#line 1838 "BookmarkRow.c"
				}
#line 522 "../src/View/Sidebar/BookmarkRow.vala"
				reveal = _tmp25_;
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
				if (!reveal) {
#line 1844 "BookmarkRow.c"
					GList* _tmp35_;
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp35_ = self->priv->drop_file_list;
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp34_ = _tmp35_ != NULL;
#line 1850 "BookmarkRow.c"
				} else {
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp34_ = FALSE;
#line 1854 "BookmarkRow.c"
				}
#line 527 "../src/View/Sidebar/BookmarkRow.vala"
				if (_tmp34_) {
#line 1858 "BookmarkRow.c"
					FilesFile* _tmp36_;
					GList* _tmp37_;
					GdkDragAction _tmp38_ = 0U;
					GdkDragAction _tmp39_;
					GdkDragAction* _tmp40_;
					GdkDragAction* _tmp41_;
					GdkDragAction _tmp42_;
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp36_ = self->priv->target_file;
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp37_ = self->priv->drop_file_list;
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					files_dnd_handler_file_accepts_drop (_tmp36_, _tmp37_, gdk_drag_context_get_selected_action (ctx), gdk_drag_context_get_actions (ctx), &_tmp38_);
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					_g_free0 (self->priv->current_suggested_action);
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp39_ = _tmp38_;
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp40_ = __gdk_drag_action_dup0 (&_tmp39_);
#line 528 "../src/View/Sidebar/BookmarkRow.vala"
					self->priv->current_suggested_action = _tmp40_;
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp41_ = self->priv->current_suggested_action;
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
					_tmp42_ = GDK_ACTION_DEFAULT;
#line 536 "../src/View/Sidebar/BookmarkRow.vala"
					if (_gdk_drag_action_equal (_tmp41_, &_tmp42_) != TRUE) {
#line 537 "../src/View/Sidebar/BookmarkRow.vala"
						sidebar_bookmark_row_highlight (self, TRUE);
#line 1888 "BookmarkRow.c"
					}
				} else {
#line 540 "../src/View/Sidebar/BookmarkRow.vala"
					sidebar_bookmark_row_highlight (self, FALSE);
#line 1893 "BookmarkRow.c"
				}
#line 543 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1897 "BookmarkRow.c"
			}
		}
	} else {
#line 513 "../src/View/Sidebar/BookmarkRow.vala"
		switch (0) {
#line 1903 "BookmarkRow.c"
			default:
			{
#line 545 "../src/View/Sidebar/BookmarkRow.vala"
				break;
#line 1908 "BookmarkRow.c"
			}
		}
	}
#line 548 "../src/View/Sidebar/BookmarkRow.vala"
	if (sidebar_bookmark_row_reveal_drop_target (self, reveal)) {
#line 1914 "BookmarkRow.c"
		GdkDragAction _tmp43_;
		GdkDragAction* _tmp44_;
		gboolean _tmp45_ = FALSE;
		gboolean _tmp46_ = FALSE;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gboolean _tmp49_;
#line 549 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp43_ = GDK_ACTION_LINK;
#line 549 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp44_ = __gdk_drag_action_dup0 (&_tmp43_);
#line 549 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->current_suggested_action);
#line 549 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->current_suggested_action = _tmp44_;
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp47_ = gdk_atom_name (target);
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp48_ = _tmp47_;
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp49_ = g_strcmp0 (_tmp48_, "text/uri-list") == 0;
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (_tmp48_);
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp49_) {
#line 1940 "BookmarkRow.c"
			const gchar* _tmp50_;
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp50_ = self->priv->drop_text;
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp46_ = _tmp50_ != NULL;
#line 1946 "BookmarkRow.c"
		} else {
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp46_ = FALSE;
#line 1950 "BookmarkRow.c"
		}
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp46_) {
#line 1954 "BookmarkRow.c"
			SidebarSidebarListInterface* _tmp51_;
			SidebarSidebarListInterface* _tmp52_;
			const gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp51_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp52_ = _tmp51_;
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp53_ = self->priv->drop_text;
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp54_ = string_strip (_tmp53_);
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp55_ = _tmp54_;
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp45_ = sidebar_sidebar_list_interface_has_uri (_tmp52_, _tmp55_, NULL);
#line 551 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (_tmp55_);
#line 1974 "BookmarkRow.c"
		} else {
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp45_ = FALSE;
#line 1978 "BookmarkRow.c"
		}
#line 550 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp45_) {
#line 1982 "BookmarkRow.c"
			GdkDragAction _tmp56_;
			GdkDragAction* _tmp57_;
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp56_ = GDK_ACTION_DEFAULT;
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp57_ = __gdk_drag_action_dup0 (&_tmp56_);
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (self->priv->current_suggested_action);
#line 553 "../src/View/Sidebar/BookmarkRow.vala"
			self->priv->current_suggested_action = _tmp57_;
#line 554 "../src/View/Sidebar/BookmarkRow.vala"
			reveal = FALSE;
#line 1995 "BookmarkRow.c"
		}
	}
#line 558 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp58_ = self->priv->current_suggested_action;
#line 558 "../src/View/Sidebar/BookmarkRow.vala"
	gdk_drag_status (ctx, *_tmp58_, (guint32) time);
#line 559 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 559 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (next_item);
#line 559 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (previous_item);
#line 559 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2010 "BookmarkRow.c"
}

static gboolean
___lambda154__gtk_widget_drag_motion (GtkWidget* _sender,
                                      GdkDragContext* context,
                                      gint x,
                                      gint y,
                                      guint time_,
                                      gpointer self)
{
	gboolean result;
	result = __lambda154_ ((SidebarBookmarkRow*) self, context, x, y, time_);
#line 491 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2025 "BookmarkRow.c"
}

static void
__lambda155_ (SidebarBookmarkRow* self)
{
#line 563 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reset_drag_drop (self);
#line 2033 "BookmarkRow.c"
}

static void
___lambda155__gtk_widget_drag_leave (GtkWidget* _sender,
                                     GdkDragContext* context,
                                     guint time_,
                                     gpointer self)
{
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	__lambda155_ ((SidebarBookmarkRow*) self);
#line 2044 "BookmarkRow.c"
}

static gboolean
__lambda156_ (SidebarBookmarkRow* self,
              GdkDragContext* ctx,
              gint x,
              gint y,
              guint time)
{
	GdkAtom target = (GdkAtom) 0U;
	gboolean result;
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 567 "../src/View/Sidebar/BookmarkRow.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, ctx, NULL);
#line 568 "../src/View/Sidebar/BookmarkRow.vala"
	if (target != GDK_NONE) {
#line 572 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->drop_occurred = TRUE;
#line 573 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_drag_get_data ((GtkWidget*) self, ctx, target, (guint32) time);
#line 2066 "BookmarkRow.c"
	} else {
#line 575 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 575 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2072 "BookmarkRow.c"
	}
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 578 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2078 "BookmarkRow.c"
}

static gboolean
___lambda156__gtk_widget_drag_drop (GtkWidget* _sender,
                                    GdkDragContext* context,
                                    gint x,
                                    gint y,
                                    guint time_,
                                    gpointer self)
{
	gboolean result;
	result = __lambda156_ ((SidebarBookmarkRow*) self, context, x, y, time_);
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2093 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_set_up_drop (SidebarBookmarkRow* self)
{
	GtkSeparator* drop_revealer_child = NULL;
	GtkSeparator* _tmp0_ = NULL;
	GtkWidget* _tmp1_;
	GtkRevealer* _tmp2_ = NULL;
	GtkRevealer* _tmp3_;
	GtkGrid* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkTargetEntry* _tmp6_;
	gint _tmp6__length1;
#line 421 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 422 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, 12);
#line 422 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp0_, 0);
#line 422 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp0_);
#line 422 "../src/View/Sidebar/BookmarkRow.vala"
	drop_revealer_child = _tmp0_;
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) drop_revealer_child);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = (GtkRevealer*) gtk_revealer_new ();
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_set ((GtkContainer*) _tmp2_, "child", _tmp1_, NULL);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (_tmp1_);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_revealer_set_transition_type (_tmp2_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp2_);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->drop_revealer);
#line 427 "../src/View/Sidebar/BookmarkRow.vala"
	self->drop_revealer = _tmp2_;
#line 431 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = self->drop_revealer;
#line 431 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
#line 433 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = self->content_grid;
#line 433 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = self->drop_revealer;
#line 433 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp4_, (GtkWidget*) _tmp5_, 0, 1, 1, 1);
#line 435 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = sidebar_bookmark_row_dest_targets;
#line 435 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6__length1 = sidebar_bookmark_row_dest_targets_length1;
#line 435 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT, _tmp6_, (gint) _tmp6__length1, ((GDK_ACTION_MOVE | GDK_ACTION_COPY) | GDK_ACTION_LINK) | GDK_ACTION_ASK);
#line 442 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-data-received", (GCallback) ___lambda153__gtk_widget_drag_data_received, self, 0);
#line 491 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-motion", (GCallback) ___lambda154__gtk_widget_drag_motion, self, 0);
#line 562 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-leave", (GCallback) ___lambda155__gtk_widget_drag_leave, self, 0);
#line 566 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "drag-drop", (GCallback) ___lambda156__gtk_widget_drag_drop, self, 0);
#line 421 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (drop_revealer_child);
#line 2162 "BookmarkRow.c"
}

void
sidebar_bookmark_row_highlight (SidebarBookmarkRow* self,
                                gboolean show)
{
	gboolean _tmp0_ = FALSE;
#line 582 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
	if (show) {
#line 2174 "BookmarkRow.c"
		GtkStyleContext* _tmp1_;
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = !gtk_style_context_has_class (_tmp1_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2180 "BookmarkRow.c"
	} else {
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = FALSE;
#line 2184 "BookmarkRow.c"
	}
#line 583 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_) {
#line 2188 "BookmarkRow.c"
		GtkStyleContext* _tmp2_;
#line 584 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 584 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2194 "BookmarkRow.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 585 "../src/View/Sidebar/BookmarkRow.vala"
		if (!show) {
#line 2199 "BookmarkRow.c"
			GtkStyleContext* _tmp4_;
#line 585 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 585 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp3_ = gtk_style_context_has_class (_tmp4_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2205 "BookmarkRow.c"
		} else {
#line 585 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp3_ = FALSE;
#line 2209 "BookmarkRow.c"
		}
#line 585 "../src/View/Sidebar/BookmarkRow.vala"
		if (_tmp3_) {
#line 2213 "BookmarkRow.c"
			GtkStyleContext* _tmp5_;
#line 586 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 586 "../src/View/Sidebar/BookmarkRow.vala"
			gtk_style_context_remove_class (_tmp5_, GTK_STYLE_CLASS_HIGHLIGHT);
#line 2219 "BookmarkRow.c"
		}
	}
}

static void
sidebar_bookmark_row_reset_drag_drop (SidebarBookmarkRow* self)
{
	GdkDragAction _tmp0_;
	GdkDragAction* _tmp1_;
#line 590 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/View/Sidebar/BookmarkRow.vala"
	(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 591 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_file_list = NULL;
#line 592 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 592 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 593 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_occurred = FALSE;
#line 594 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = GDK_ACTION_DEFAULT;
#line 594 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = __gdk_drag_action_dup0 (&_tmp0_);
#line 594 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 594 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp1_;
#line 595 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_reveal_drop_target (self, FALSE);
#line 596 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_highlight (self, FALSE);
#line 2253 "BookmarkRow.c"
}

static guint
uint_parse (const gchar* str,
            guint _base)
{
	guint result;
#line 213 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0U);
#line 214 "glib-2.0.vapi"
	result = (guint) strtoul (str, NULL, (gint) _base);
#line 214 "glib-2.0.vapi"
	return result;
#line 2267 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_process_dropped_row (SidebarBookmarkRow* self,
                                          const gchar* drop_text,
                                          gboolean dropped_between)
{
	guint32 id = 0U;
	SidebarSidebarItemInterface* item = NULL;
	SidebarSidebarItemInterface* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	SidebarSidebarItemInterface* _tmp3_;
	SidebarSidebarListInterface* _tmp9_;
	SidebarSidebarListInterface* _tmp10_;
	SidebarSidebarItemInterface* _tmp11_;
	gboolean result;
#line 599 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 599 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (drop_text != NULL, FALSE);
#line 600 "../src/View/Sidebar/BookmarkRow.vala"
	id = (guint32) uint_parse (drop_text, (guint) 0);
#line 601 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_item (id);
#line 601 "../src/View/Sidebar/BookmarkRow.vala"
	item = _tmp0_;
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = item;
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp3_ == NULL) {
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = TRUE;
#line 2301 "BookmarkRow.c"
	} else {
#line 604 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = !dropped_between;
#line 2305 "BookmarkRow.c"
	}
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp2_) {
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = TRUE;
#line 2311 "BookmarkRow.c"
	} else {
		SidebarSidebarItemInterface* _tmp4_;
		SidebarSidebarListInterface* _tmp5_;
		SidebarSidebarListInterface* _tmp6_;
		SidebarSidebarListInterface* _tmp7_;
		SidebarSidebarListInterface* _tmp8_;
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = item;
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = sidebar_sidebar_item_interface_get_list (_tmp4_);
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = _tmp5_;
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = _tmp7_;
#line 605 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = _tmp6_ != _tmp8_;
#line 2330 "BookmarkRow.c"
	}
#line 603 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp1_) {
#line 607 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 607 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (item);
#line 607 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2340 "BookmarkRow.c"
	}
#line 610 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 610 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = _tmp9_;
#line 610 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = item;
#line 610 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_list_interface_move_item_after (_tmp10_, _tmp11_, sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self));
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
	result = TRUE;
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (item);
#line 611 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2356 "BookmarkRow.c"
}

static gboolean
sidebar_bookmark_row_process_dropped_uris (SidebarBookmarkRow* self,
                                           GdkDragAction selected_action,
                                           GdkDragAction possible_actions,
                                           GList* drop_file_list,
                                           gboolean dropped_between)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 614 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 619 "../src/View/Sidebar/BookmarkRow.vala"
	if (dropped_between) {
#line 2372 "BookmarkRow.c"
		GList* _tmp1_;
#line 619 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp1_ = drop_file_list->next;
#line 619 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 2378 "BookmarkRow.c"
	} else {
#line 619 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = FALSE;
#line 2382 "BookmarkRow.c"
	}
#line 619 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp0_) {
#line 2386 "BookmarkRow.c"
		gint pos = 0;
		gint _tmp2_;
		SidebarSidebarListInterface* _tmp3_;
		SidebarSidebarListInterface* _tmp4_;
		gconstpointer _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
#line 620 "../src/View/Sidebar/BookmarkRow.vala"
		pos = sidebar_sidebar_item_interface_get_index ((SidebarSidebarItemInterface*) self);
#line 621 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = pos;
#line 621 "../src/View/Sidebar/BookmarkRow.vala"
		pos = _tmp2_ + 1;
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp3_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp4_ = _tmp3_;
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = drop_file_list->data;
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = g_file_get_uri ((GFile*) _tmp5_);
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = _tmp6_;
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = sidebar_sidebar_list_interface_add_favorite (_tmp4_, _tmp7_, "", pos);
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (_tmp7_);
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp8_;
#line 622 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2419 "BookmarkRow.c"
	} else {
		FilesDndHandler* dnd_handler = NULL;
		FilesDndHandler* _tmp9_;
		GdkDragAction real_action = 0U;
		FilesDndHandler* _tmp17_;
		FilesFile* _tmp18_;
#line 624 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp9_ = files_dnd_handler_new ();
#line 624 "../src/View/Sidebar/BookmarkRow.vala"
		dnd_handler = _tmp9_;
#line 625 "../src/View/Sidebar/BookmarkRow.vala"
		real_action = selected_action;
#line 627 "../src/View/Sidebar/BookmarkRow.vala"
		if (real_action == GDK_ACTION_ASK) {
#line 2434 "BookmarkRow.c"
			GdkDragAction actions = 0U;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			FilesDndHandler* _tmp12_;
			GtkWindow* _tmp13_;
			GtkApplicationWindow* _tmp14_;
			GdkDragAction* _tmp15_;
			GdkDragAction* _tmp16_;
#line 628 "../src/View/Sidebar/BookmarkRow.vala"
			actions = possible_actions;
#line 630 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp10_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 630 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp11_ = _tmp10_;
#line 630 "../src/View/Sidebar/BookmarkRow.vala"
			if (g_str_has_prefix (_tmp11_, "trash://")) {
#line 631 "../src/View/Sidebar/BookmarkRow.vala"
				actions &= GDK_ACTION_MOVE;
#line 2453 "BookmarkRow.c"
			}
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp12_ = dnd_handler;
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp13_ = files_get_active_window ();
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp15_ = files_dnd_handler_drag_drop_action_ask (_tmp12_, (GtkWidget*) self, _tmp14_, actions);
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_tmp16_ = _tmp15_;
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			real_action = *_tmp16_;
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_g_free0 (_tmp16_);
#line 634 "../src/View/Sidebar/BookmarkRow.vala"
			_g_object_unref0 (_tmp14_);
#line 2471 "BookmarkRow.c"
		}
#line 641 "../src/View/Sidebar/BookmarkRow.vala"
		if (real_action == 0) {
#line 642 "../src/View/Sidebar/BookmarkRow.vala"
			result = FALSE;
#line 642 "../src/View/Sidebar/BookmarkRow.vala"
			_g_object_unref0 (dnd_handler);
#line 642 "../src/View/Sidebar/BookmarkRow.vala"
			return result;
#line 2481 "BookmarkRow.c"
		}
#line 645 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp17_ = dnd_handler;
#line 645 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp18_ = self->priv->target_file;
#line 645 "../src/View/Sidebar/BookmarkRow.vala"
		files_dnd_handler_dnd_perform (_tmp17_, (GtkWidget*) self, _tmp18_, drop_file_list, real_action);
#line 652 "../src/View/Sidebar/BookmarkRow.vala"
		result = TRUE;
#line 652 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (dnd_handler);
#line 652 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2495 "BookmarkRow.c"
	}
}

gboolean
sidebar_bookmark_row_reveal_drop_target (SidebarBookmarkRow* self,
                                         gboolean reveal)
{
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
	gboolean result;
#line 656 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 657 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 657 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 657 "../src/View/Sidebar/BookmarkRow.vala"
	if (sidebar_sidebar_list_interface_is_drop_target (_tmp1_)) {
#line 2514 "BookmarkRow.c"
		GtkRevealer* _tmp2_;
#line 658 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp2_ = self->drop_revealer;
#line 658 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_revealer_set_reveal_child (_tmp2_, reveal);
#line 659 "../src/View/Sidebar/BookmarkRow.vala"
		result = reveal;
#line 659 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2524 "BookmarkRow.c"
	} else {
#line 661 "../src/View/Sidebar/BookmarkRow.vala"
		result = FALSE;
#line 661 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2530 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_custom_name (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_custom_name;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2548 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_custom_name (SidebarSidebarItemInterface* base,
                                           const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_custom_name (base);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2563 "BookmarkRow.c"
		gchar* _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_custom_name);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_custom_name = _tmp0_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY]);
#line 2573 "BookmarkRow.c"
	}
}

const gchar*
sidebar_bookmark_row_get_display_name (SidebarBookmarkRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 71 "../src/View/Sidebar/BookmarkRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "") != 0;
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp3_);
#line 72 "../src/View/Sidebar/BookmarkRow.vala"
	if (_tmp4_) {
#line 2602 "BookmarkRow.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = _tmp5_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp6_;
#line 73 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2613 "BookmarkRow.c"
	} else {
		FilesFile* _tmp7_;
		const gchar* _tmp8_;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = self->priv->target_file;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = files_file_get_display_name (_tmp7_);
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		result = _tmp8_;
#line 75 "../src/View/Sidebar/BookmarkRow.vala"
		return result;
#line 2625 "BookmarkRow.c"
	}
}

static SidebarSidebarListInterface*
sidebar_bookmark_row_real_get_list (SidebarSidebarItemInterface* base)
{
	SidebarSidebarListInterface* result;
	SidebarBookmarkRow* self;
	SidebarSidebarListInterface* _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_list;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2643 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_list (SidebarSidebarItemInterface* base,
                                    SidebarSidebarListInterface* value)
{
	SidebarBookmarkRow* self;
	SidebarSidebarListInterface* old_value;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_list (base);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2658 "BookmarkRow.c"
		SidebarSidebarListInterface* _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_list);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_list = _tmp0_;
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY]);
#line 2668 "BookmarkRow.c"
	}
}

static guint32
sidebar_bookmark_row_real_get_id (SidebarSidebarItemInterface* base)
{
	guint32 result;
	SidebarBookmarkRow* self;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_id;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2683 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_id (SidebarSidebarItemInterface* base,
                                  guint32 value)
{
	SidebarBookmarkRow* self;
	guint32 old_value;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_id (base);
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_id = value;
#line 81 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ID_PROPERTY]);
#line 2702 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_uri (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_uri;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2720 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_uri (SidebarSidebarItemInterface* base,
                                   const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_uri (base);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2735 "BookmarkRow.c"
		gchar* _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_uri);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_uri = _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_URI_PROPERTY]);
#line 2745 "BookmarkRow.c"
	}
}

static GIcon*
sidebar_bookmark_row_real_get_gicon (SidebarSidebarItemInterface* base)
{
	GIcon* result;
	SidebarBookmarkRow* self;
	GIcon* _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_gicon;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2763 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_gicon (SidebarSidebarItemInterface* base,
                                     GIcon* value)
{
	SidebarBookmarkRow* self;
	GIcon* old_value;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_gicon (base);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2778 "BookmarkRow.c"
		GIcon* _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_gicon);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_gicon = _tmp0_;
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY]);
#line 2788 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_pinned (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_pinned;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2803 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_pinned (SidebarSidebarItemInterface* base,
                                      gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_pinned (base);
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_pinned = value;
#line 84 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY]);
#line 2822 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_permanent (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_permanent;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2837 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_permanent (SidebarSidebarItemInterface* base,
                                         gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_permanent (base);
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_permanent = value;
#line 85 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY]);
#line 2856 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_can_insert_before (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_can_insert_before;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2871 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_can_insert_before (SidebarSidebarItemInterface* base,
                                                 gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_can_insert_before (base);
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_can_insert_before = value;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY]);
#line 2890 "BookmarkRow.c"
	}
}

static gboolean
sidebar_bookmark_row_real_get_can_insert_after (SidebarSidebarItemInterface* base)
{
	gboolean result;
	SidebarBookmarkRow* self;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	result = self->priv->_can_insert_after;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2905 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_can_insert_after (SidebarSidebarItemInterface* base,
                                                gboolean value)
{
	SidebarBookmarkRow* self;
	gboolean old_value;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_can_insert_after (base);
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_can_insert_after = value;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY]);
#line 2924 "BookmarkRow.c"
	}
}

static GMenuModel*
sidebar_bookmark_row_real_get_menu_model (SidebarSidebarItemInterface* base)
{
	GMenuModel* result;
	SidebarBookmarkRow* self;
	GMenuModel* _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_menu_model;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2942 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_menu_model (SidebarSidebarItemInterface* base,
                                          GMenuModel* value)
{
	SidebarBookmarkRow* self;
	GMenuModel* old_value;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_menu_model (base);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 2957 "BookmarkRow.c"
		GMenuModel* _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_menu_model);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_menu_model = _tmp0_;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY]);
#line 2967 "BookmarkRow.c"
	}
}

static GActionGroup*
sidebar_bookmark_row_real_get_action_group (SidebarSidebarItemInterface* base)
{
	GActionGroup* result;
	SidebarBookmarkRow* self;
	GActionGroup* _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_action_group;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 2985 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_action_group (SidebarSidebarItemInterface* base,
                                            GActionGroup* value)
{
	SidebarBookmarkRow* self;
	GActionGroup* old_value;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_action_group (base);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	if (old_value != value) {
#line 3000 "BookmarkRow.c"
		GActionGroup* _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->priv->_action_group);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_action_group = _tmp0_;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY]);
#line 3010 "BookmarkRow.c"
	}
}

static const gchar*
sidebar_bookmark_row_real_get_action_group_namespace (SidebarSidebarItemInterface* base)
{
	const gchar* result;
	SidebarBookmarkRow* self;
	const gchar* _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->_action_group_namespace;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	result = _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3028 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_real_set_action_group_namespace (SidebarSidebarItemInterface* base,
                                                      const gchar* value)
{
	SidebarBookmarkRow* self;
	gchar* old_value;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self = (SidebarBookmarkRow*) base;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	old_value = sidebar_bookmark_row_real_get_action_group_namespace (base);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3043 "BookmarkRow.c"
		gchar* _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp0_ = g_strdup (value);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		_g_free0 (self->priv->_action_group_namespace);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		self->priv->_action_group_namespace = _tmp0_;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY]);
#line 3053 "BookmarkRow.c"
	}
}

static void
_sidebar_bookmark_row____lambda157_ (SidebarBookmarkRow* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkStack* _tmp14_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = self->editable;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = _tmp3_;
#line 143 "../src/View/Sidebar/BookmarkRow.vala"
	if (g_strcmp0 (_tmp1_, _tmp4_) != 0) {
#line 3078 "BookmarkRow.c"
		GtkEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		SidebarSidebarListInterface* _tmp8_;
		SidebarSidebarListInterface* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 144 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp5_ = self->editable;
#line 144 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 144 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp7_ = _tmp6_;
#line 144 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, _tmp7_);
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp8_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp9_ = _tmp8_;
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp10_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp11_ = _tmp10_;
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp12_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self);
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp13_ = _tmp12_;
#line 145 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_list_interface_rename_bookmark_by_uri (_tmp9_, _tmp11_, _tmp13_);
#line 3110 "BookmarkRow.c"
	}
#line 147 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp14_ = self->label_stack;
#line 147 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp14_, "label");
#line 3116 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row____lambda157__gtk_entry_activate (GtkEntry* _sender,
                                                         gpointer self)
{
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row____lambda157_ ((SidebarBookmarkRow*) self);
#line 3125 "BookmarkRow.c"
}

static gboolean
_sidebar_bookmark_row____lambda158_ (SidebarBookmarkRow* self)
{
	GtkStack* _tmp0_;
#line 151 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label_stack;
#line 151 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp0_, "label");
#line 3136 "BookmarkRow.c"
}

static gboolean
__sidebar_bookmark_row____lambda158__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _sidebar_bookmark_row____lambda158_ ((SidebarBookmarkRow*) self);
#line 150 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3148 "BookmarkRow.c"
}

static gboolean
_sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                               guint keyval,
                                                                               guint keycode,
                                                                               GdkModifierType state,
                                                                               gpointer self)
{
	gboolean result;
	result = sidebar_bookmark_row_on_key_press_event ((SidebarBookmarkRow*) self, keyval, keycode, state);
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	return result;
#line 3162 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row_on_button_release_event_gtk_gesture_multi_press_released (GtkGestureMultiPress* _sender,
                                                                                gint n_press,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self)
{
#line 184 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_on_button_release_event ((SidebarBookmarkRow*) self, n_press, x, y);
#line 3174 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda159_ (SidebarBookmarkRow* self)
{
	GtkImage* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
#line 187 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->priv->icon;
#line 187 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self);
#line 187 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_image_set_from_gicon (_tmp0_, _tmp2_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 3191 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda159__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 186 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda159_ ((SidebarBookmarkRow*) self);
#line 3201 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda160_ (SidebarBookmarkRow* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 191 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = self->label;
#line 191 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = sidebar_bookmark_row_get_display_name (self);
#line 191 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 191 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 3218 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda160__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 190 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda160_ ((SidebarBookmarkRow*) self);
#line 3228 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda161_ (SidebarBookmarkRow* self)
{
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_DEFAULT);
#line 3236 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda161__g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda161_ ((SidebarBookmarkRow*) self);
#line 3246 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda162_ (SidebarBookmarkRow* self)
{
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_TAB);
#line 3254 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda162__g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda162_ ((SidebarBookmarkRow*) self);
#line 3264 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda163_ (SidebarBookmarkRow* self)
{
#line 204 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) self, FILES_OPEN_FLAG_NEW_WINDOW);
#line 3272 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda163__g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 204 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda163_ ((SidebarBookmarkRow*) self);
#line 3282 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row_rename_g_simple_action_activate (GSimpleAction* _sender,
                                                       GVariant* parameter,
                                                       gpointer self)
{
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_rename ((SidebarBookmarkRow*) self);
#line 3292 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda164_ (SidebarBookmarkRow* self)
{
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self);
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = _tmp2_;
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_list_interface_remove_item_by_id (_tmp1_, _tmp3_);
#line 3312 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda164__g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda164_ ((SidebarBookmarkRow*) self);
#line 3322 "BookmarkRow.c"
}

static void
_sidebar_bookmark_row___lambda165_ (SidebarBookmarkRow* self)
{
	GtkWidget* _tmp0_;
	FilesFileOperationsEmptyTrashJob* _tmp1_;
	FilesFileOperationsEmptyTrashJob* _tmp2_;
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = marlin_file_operations_empty_trash_job_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow), NULL);
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = _tmp1_;
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	marlin_file_operations_empty_trash_job_empty_trash (_tmp2_, NULL, NULL);
#line 214 "../src/View/Sidebar/BookmarkRow.vala"
	_marlin_file_operations_common_job_unref0 (_tmp2_);
#line 3341 "BookmarkRow.c"
}

static void
__sidebar_bookmark_row___lambda165__g_simple_action_activate (GSimpleAction* _sender,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 213 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row___lambda165_ ((SidebarBookmarkRow*) self);
#line 3351 "BookmarkRow.c"
}

static GObject *
sidebar_bookmark_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SidebarBookmarkRow * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeHashMap* _tmp8_;
	guint32 _tmp9_;
	guint32 _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GtkLabel* _tmp13_ = NULL;
	GtkStack* _tmp14_ = NULL;
	GtkStack* _tmp15_;
	GtkLabel* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GtkStack* _tmp24_;
	GIcon* _tmp25_;
	GIcon* _tmp26_;
	GtkImage* _tmp27_;
	GtkGrid* _tmp28_ = NULL;
	GtkGrid* _tmp29_;
	GtkImage* _tmp30_;
	GtkGrid* _tmp31_;
	GtkStack* _tmp32_;
	GtkEventBox* event_box = NULL;
	GtkEventBox* _tmp33_ = NULL;
	GtkEventBox* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkEventBox* _tmp38_;
	GtkGrid* _tmp39_;
	GtkEventControllerKey* _tmp40_ = NULL;
	GtkEventControllerKey* _tmp41_;
	GtkGestureMultiPress* _tmp42_ = NULL;
	GtkGestureMultiPress* _tmp43_;
	GSimpleAction* open_action = NULL;
	GSimpleAction* _tmp44_;
	GSimpleAction* _tmp45_;
	GSimpleAction* open_tab_action = NULL;
	GSimpleAction* _tmp46_;
	GSimpleAction* _tmp47_;
	GSimpleAction* open_window_action = NULL;
	GSimpleAction* _tmp48_;
	GSimpleAction* _tmp49_;
	GSimpleAction* rename_action = NULL;
	GSimpleAction* _tmp50_;
	GSimpleAction* _tmp51_;
	GSimpleAction* remove_action = NULL;
	GSimpleAction* _tmp52_;
	GSimpleAction* _tmp53_;
	GSimpleAction* _tmp54_;
	GSimpleAction* _tmp55_;
	GSimpleActionGroup* action_group = NULL;
	GSimpleActionGroup* _tmp56_;
	GSimpleActionGroup* _tmp57_;
	GSimpleAction* _tmp58_;
	GSimpleActionGroup* _tmp59_;
	GSimpleAction* _tmp60_;
	GSimpleActionGroup* _tmp61_;
	GSimpleAction* _tmp62_;
	GSimpleActionGroup* _tmp63_;
	GSimpleAction* _tmp64_;
	GSimpleActionGroup* _tmp65_;
	GSimpleAction* _tmp66_;
	GSimpleActionGroup* _tmp67_;
	GSimpleAction* _tmp68_;
	GSimpleActionGroup* _tmp69_;
	GApplication* _tmp70_;
	gchar* _tmp71_;
	gchar** _tmp72_;
	gchar** _tmp73_;
	gint _tmp73__length1;
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	parent_class = G_OBJECT_CLASS (sidebar_bookmark_row_parent_class);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 113 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 113 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = _tmp0_;
#line 113 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = files_file_get_by_uri (_tmp1_);
#line 113 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->target_file);
#line 113 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->target_file = _tmp2_;
#line 114 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_ = self->priv->target_file;
#line 114 "../src/View/Sidebar/BookmarkRow.vala"
	files_file_ensure_query_info (_tmp3_);
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self);
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = _tmp4_;
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = files_file_utils_sanitize_path (_tmp5_, NULL, FALSE);
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = _tmp6_;
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp7_);
#line 119 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp7_);
#line 121 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_list_box_row_set_selectable ((GtkListBoxRow*) self, TRUE);
#line 122 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_set_id ((SidebarSidebarItemInterface*) self, sidebar_sidebar_item_interface_get_next_item_id ());
#line 123 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_lock (&sidebar_sidebar_item_interface_item_map_lock);
#line 124 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = sidebar_sidebar_item_interface_item_id_map;
#line 124 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self);
#line 124 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp10_ = _tmp9_;
#line 124 "../src/View/Sidebar/BookmarkRow.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, (gpointer) ((guintptr) _tmp10_), (SidebarSidebarItemInterface*) self);
#line 125 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_unlock (&sidebar_sidebar_item_interface_item_map_lock);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp11_ = sidebar_bookmark_row_get_display_name (self);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp12_ = _tmp11_;
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_xalign (_tmp13_, 0.0f);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_START);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_label_set_ellipsize (_tmp13_, PANGO_ELLIPSIZE_END);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp13_);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label);
#line 127 "../src/View/Sidebar/BookmarkRow.vala"
	self->label = _tmp13_;
#line 134 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp14_ = (GtkStack*) gtk_stack_new ();
#line 134 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_homogeneous (_tmp14_, FALSE);
#line 134 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp14_);
#line 134 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label_stack);
#line 134 "../src/View/Sidebar/BookmarkRow.vala"
	self->label_stack = _tmp14_;
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp15_ = self->label_stack;
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp16_ = self->label;
#line 137 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_add_named (_tmp15_, (GtkWidget*) _tmp16_, "label");
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp17_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self);
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp18_ = _tmp17_;
#line 139 "../src/View/Sidebar/BookmarkRow.vala"
	if (!_tmp18_) {
#line 3529 "BookmarkRow.c"
		GtkEntry* _tmp19_;
		GtkStack* _tmp20_;
		GtkEntry* _tmp21_;
		GtkEntry* _tmp22_;
		GtkEntry* _tmp23_;
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp19_ = (GtkEntry*) gtk_entry_new ();
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		g_object_ref_sink (_tmp19_);
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		_g_object_unref0 (self->editable);
#line 140 "../src/View/Sidebar/BookmarkRow.vala"
		self->editable = _tmp19_;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp20_ = self->label_stack;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp21_ = self->editable;
#line 141 "../src/View/Sidebar/BookmarkRow.vala"
		gtk_stack_add_named (_tmp20_, (GtkWidget*) _tmp21_, "editable");
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp22_ = self->editable;
#line 142 "../src/View/Sidebar/BookmarkRow.vala"
		g_signal_connect_object (_tmp22_, "activate", (GCallback) __sidebar_bookmark_row____lambda157__gtk_entry_activate, self, 0);
#line 150 "../src/View/Sidebar/BookmarkRow.vala"
		_tmp23_ = self->editable;
#line 150 "../src/View/Sidebar/BookmarkRow.vala"
		g_signal_connect_object ((GtkWidget*) _tmp23_, "focus-out-event", (GCallback) __sidebar_bookmark_row____lambda158__gtk_widget_focus_out_event, self, 0);
#line 3557 "BookmarkRow.c"
	}
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp24_ = self->label_stack;
#line 154 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_stack_set_visible_child_name (_tmp24_, "label");
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp25_ = sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp26_ = _tmp25_;
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp27_ = (GtkImage*) gtk_image_new_from_gicon (_tmp26_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp27_);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->icon);
#line 156 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->icon = _tmp27_;
#line 158 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp28_ = (GtkGrid*) gtk_grid_new ();
#line 158 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_set_column_spacing (_tmp28_, 6);
#line 158 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp28_);
#line 158 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->icon_label_grid);
#line 158 "../src/View/Sidebar/BookmarkRow.vala"
	self->icon_label_grid = _tmp28_;
#line 161 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp29_ = self->icon_label_grid;
#line 161 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp30_ = self->priv->icon;
#line 161 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 0, 0, 1, 2);
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp31_ = self->icon_label_grid;
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp32_ = self->label_stack;
#line 162 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
#line 164 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp33_ = (GtkEventBox*) gtk_event_box_new ();
#line 164 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_box_set_above_child (_tmp33_, FALSE);
#line 164 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp33_);
#line 164 "../src/View/Sidebar/BookmarkRow.vala"
	event_box = _tmp33_;
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp34_ = event_box;
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp35_ = self->icon_label_grid;
#line 167 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 169 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp36_ = (GtkGrid*) gtk_grid_new ();
#line 169 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_ref_sink (_tmp36_);
#line 169 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->content_grid);
#line 169 "../src/View/Sidebar/BookmarkRow.vala"
	self->content_grid = _tmp36_;
#line 170 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp37_ = self->content_grid;
#line 170 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp38_ = event_box;
#line 170 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_grid_attach (_tmp37_, (GtkWidget*) _tmp38_, 0, 0, 1, 1);
#line 172 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp39_ = self->content_grid;
#line 172 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp39_);
#line 173 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 175 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp40_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
#line 175 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp40_, GTK_PHASE_BUBBLE);
#line 175 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 175 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->key_controller = _tmp40_;
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp41_ = self->priv->key_controller;
#line 178 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp41_, "key-pressed", (GCallback) _sidebar_bookmark_row_on_key_press_event_gtk_event_controller_key_key_pressed, self, 0);
#line 180 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp42_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 180 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp42_, GTK_PHASE_BUBBLE);
#line 180 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp42_, (guint) 0);
#line 180 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 180 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->button_controller = _tmp42_;
#line 184 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp43_ = self->priv->button_controller;
#line 184 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp43_, "released", (GCallback) _sidebar_bookmark_row_on_button_release_event_gtk_gesture_multi_press_released, self, 0);
#line 186 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GObject*) self, "notify::gicon", (GCallback) __sidebar_bookmark_row___lambda159__g_object_notify, self, 0);
#line 190 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object ((GObject*) self, "notify::custom-name", (GCallback) __sidebar_bookmark_row___lambda160__g_object_notify, self, 0);
#line 194 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_set_up_drag (self);
#line 195 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_set_up_drop (self);
#line 197 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp44_ = g_simple_action_new ("open", NULL);
#line 197 "../src/View/Sidebar/BookmarkRow.vala"
	open_action = _tmp44_;
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp45_ = open_action;
#line 198 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp45_, "activate", (GCallback) __sidebar_bookmark_row___lambda161__g_simple_action_activate, self, 0);
#line 200 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp46_ = g_simple_action_new ("open-tab", NULL);
#line 200 "../src/View/Sidebar/BookmarkRow.vala"
	open_tab_action = _tmp46_;
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp47_ = open_tab_action;
#line 201 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp47_, "activate", (GCallback) __sidebar_bookmark_row___lambda162__g_simple_action_activate, self, 0);
#line 203 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp48_ = g_simple_action_new ("open-window", NULL);
#line 203 "../src/View/Sidebar/BookmarkRow.vala"
	open_window_action = _tmp48_;
#line 204 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp49_ = open_window_action;
#line 204 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp49_, "activate", (GCallback) __sidebar_bookmark_row___lambda163__g_simple_action_activate, self, 0);
#line 206 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp50_ = g_simple_action_new ("rename", NULL);
#line 206 "../src/View/Sidebar/BookmarkRow.vala"
	rename_action = _tmp50_;
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp51_ = rename_action;
#line 207 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp51_, "activate", (GCallback) _sidebar_bookmark_row_rename_g_simple_action_activate, self, 0);
#line 209 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp52_ = g_simple_action_new ("remove", NULL);
#line 209 "../src/View/Sidebar/BookmarkRow.vala"
	remove_action = _tmp52_;
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp53_ = remove_action;
#line 210 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) __sidebar_bookmark_row___lambda164__g_simple_action_activate, self, 0);
#line 212 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp54_ = g_simple_action_new ("empty-all-trash", NULL);
#line 212 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->empty_all_trash_action);
#line 212 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->empty_all_trash_action = _tmp54_;
#line 213 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp55_ = self->priv->empty_all_trash_action;
#line 213 "../src/View/Sidebar/BookmarkRow.vala"
	g_signal_connect_object (_tmp55_, "activate", (GCallback) __sidebar_bookmark_row___lambda165__g_simple_action_activate, self, 0);
#line 217 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp56_ = g_simple_action_group_new ();
#line 217 "../src/View/Sidebar/BookmarkRow.vala"
	action_group = _tmp56_;
#line 218 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp57_ = action_group;
#line 218 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp58_ = open_action;
#line 218 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp57_, (GAction*) _tmp58_);
#line 219 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp59_ = action_group;
#line 219 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp60_ = open_tab_action;
#line 219 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp59_, (GAction*) _tmp60_);
#line 220 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp61_ = action_group;
#line 220 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp62_ = open_window_action;
#line 220 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp61_, (GAction*) _tmp62_);
#line 221 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp63_ = action_group;
#line 221 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp64_ = rename_action;
#line 221 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp63_, (GAction*) _tmp64_);
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp65_ = action_group;
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp66_ = remove_action;
#line 222 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp65_, (GAction*) _tmp66_);
#line 223 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp67_ = action_group;
#line 223 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp68_ = self->priv->empty_all_trash_action;
#line 223 "../src/View/Sidebar/BookmarkRow.vala"
	g_action_map_add_action ((GActionMap*) _tmp67_, (GAction*) _tmp68_);
#line 225 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp69_ = action_group;
#line 225 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "bookmark", (GActionGroup*) _tmp69_);
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp70_ = g_application_get_default ();
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp71_ = g_strdup ("F2");
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp72_ = g_new0 (gchar*, 1 + 1);
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp72_[0] = _tmp71_;
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp73_ = _tmp72_;
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp73__length1 = 1;
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	gtk_application_set_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, gtk_application_get_type (), GtkApplication), "bookmark.rename", _tmp73_);
#line 227 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp73_ = (_vala_array_free (_tmp73_, _tmp73__length1, (GDestroyNotify) g_free), NULL);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (action_group);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (remove_action);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (rename_action);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (open_window_action);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (open_tab_action);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (open_action);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (event_box);
#line 112 "../src/View/Sidebar/BookmarkRow.vala"
	return obj;
#line 3791 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_class_init (SidebarBookmarkRowClass * klass,
                                 gpointer klass_data)
{
	GtkTargetEntry _tmp0_ = {0};
	GtkTargetEntry* _tmp1_;
	GtkTargetEntry _tmp2_ = {0};
	GtkTargetEntry _tmp3_ = {0};
	GtkTargetEntry* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GRand* _tmp7_;
	GRand* _tmp8_;
	GeeHashMap* _tmp9_;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_type_class_adjust_private_offset (klass, &SidebarBookmarkRow_private_offset);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->on_key_press_event = (gboolean (*) (SidebarBookmarkRow*, guint, guint, GdkModifierType)) sidebar_bookmark_row_real_on_key_press_event;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->on_button_release_event = (void (*) (SidebarBookmarkRow*, gint, gdouble, gdouble)) sidebar_bookmark_row_real_on_button_release_event;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	((SidebarBookmarkRowClass *) klass)->popup_context_menu = (void (*) (SidebarBookmarkRow*)) sidebar_bookmark_row_real_popup_context_menu;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sidebar_bookmark_row_get_property;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sidebar_bookmark_row_set_property;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sidebar_bookmark_row_constructor;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sidebar_bookmark_row_finalize;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY] = g_param_spec_string ("custom-name", "custom-name", "custom-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY] = g_param_spec_object ("list", "list", "list", SIDEBAR_TYPE_SIDEBAR_LIST_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ID_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_URI_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY] = g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY] = g_param_spec_boolean ("permanent", "permanent", "permanent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY] = g_param_spec_boolean ("can-insert-before", "can-insert-before", "can-insert-before", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY] = g_param_spec_boolean ("can-insert-after", "can-insert-after", "can-insert-after", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY] = g_param_spec_object ("action-group", "action-group", "action-group", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY, sidebar_bookmark_row_properties[SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY] = g_param_spec_string ("action-group-namespace", "action-group-namespace", "action-group-namespace", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp0_, 0, sizeof (GtkTargetEntry));
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.target = "text/plain";
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.flags = (guint) GTK_TARGET_SAME_APP;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_.info = (guint) FILES_TARGET_TYPE_BOOKMARK_ROW;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = g_new0 (GtkTargetEntry, 1);
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_[0] = _tmp0_;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_source_targets = _tmp1_;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_source_targets_length1 = 1;
#line 27 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row_source_targets_size_ = sidebar_bookmark_row_source_targets_length1;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp2_, 0, sizeof (GtkTargetEntry));
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.target = "text/uri-list";
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.flags = (guint) GTK_TARGET_SAME_APP;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_.info = (guint) FILES_TARGET_TYPE_TEXT_URI_LIST;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	memset (&_tmp3_, 0, sizeof (GtkTargetEntry));
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.target = "text/plain";
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.flags = (guint) GTK_TARGET_SAME_APP;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp3_.info = (guint) FILES_TARGET_TYPE_BOOKMARK_ROW;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_ = g_new0 (GtkTargetEntry, 2);
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_[0] = _tmp2_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp4_[1] = _tmp3_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_dest_targets = _tmp4_;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_dest_targets_length1 = 2;
#line 35 "../src/View/Sidebar/BookmarkRow.vala"
	_sidebar_bookmark_row_dest_targets_size_ = sidebar_bookmark_row_dest_targets_length1;
#line 40 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_text_data_atom = gdk_atom_intern_static_string ("text/plain");
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp5_ = g_strdup_printf ("%" G_GINT64_FORMAT, g_get_real_time ());
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp6_ = _tmp5_;
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp7_ = g_rand_new_with_seed ((guint32) atoi (_tmp6_));
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp8_ = _tmp7_;
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_row_id = g_rand_int (_tmp8_);
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_g_rand_free0 (_tmp8_);
#line 44 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (_tmp6_);
#line 48 "../src/View/Sidebar/BookmarkRow.vala"
	_vala_clear_GMutex (&sidebar_sidebar_item_interface_item_map_lock);
#line 48 "../src/View/Sidebar/BookmarkRow.vala"
	g_mutex_init (&sidebar_sidebar_item_interface_item_map_lock);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp9_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (sidebar_sidebar_item_interface_item_id_map);
#line 49 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_sidebar_item_interface_item_id_map = _tmp9_;
#line 3924 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_sidebar_sidebar_item_interface_interface_init (SidebarSidebarItemInterfaceIface * iface,
                                                                    gpointer iface_data)
{
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	sidebar_bookmark_row_sidebar_sidebar_item_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->update_plugin_data = (void (*) (SidebarSidebarItemInterface*, FilesSidebarPluginItem*)) sidebar_bookmark_row_real_update_plugin_data;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->destroy_bookmark = (void (*) (SidebarSidebarItemInterface*)) sidebar_bookmark_row_real_destroy_bookmark;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->add_extra_menu_items = (void (*) (SidebarSidebarItemInterface*, GMenu*)) sidebar_bookmark_row_real_add_extra_menu_items;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_index = (gint (*) (SidebarSidebarItemInterface*)) gtk_list_box_row_get_index;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_custom_name = sidebar_bookmark_row_real_get_custom_name;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_custom_name = sidebar_bookmark_row_real_set_custom_name;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_list = sidebar_bookmark_row_real_get_list;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_list = sidebar_bookmark_row_real_set_list;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_id = sidebar_bookmark_row_real_get_id;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_id = sidebar_bookmark_row_real_set_id;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_uri = sidebar_bookmark_row_real_get_uri;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_uri = sidebar_bookmark_row_real_set_uri;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_gicon = sidebar_bookmark_row_real_get_gicon;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_gicon = sidebar_bookmark_row_real_set_gicon;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_pinned = sidebar_bookmark_row_real_get_pinned;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_pinned = sidebar_bookmark_row_real_set_pinned;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_permanent = sidebar_bookmark_row_real_get_permanent;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_permanent = sidebar_bookmark_row_real_set_permanent;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_can_insert_before = sidebar_bookmark_row_real_get_can_insert_before;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_can_insert_before = sidebar_bookmark_row_real_set_can_insert_before;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_can_insert_after = sidebar_bookmark_row_real_get_can_insert_after;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_can_insert_after = sidebar_bookmark_row_real_set_can_insert_after;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_menu_model = sidebar_bookmark_row_real_get_menu_model;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_menu_model = sidebar_bookmark_row_real_set_menu_model;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_action_group = sidebar_bookmark_row_real_get_action_group;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_action_group = sidebar_bookmark_row_real_set_action_group;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->get_action_group_namespace = sidebar_bookmark_row_real_get_action_group_namespace;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	iface->set_action_group_namespace = sidebar_bookmark_row_real_set_action_group_namespace;
#line 3989 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_instance_init (SidebarBookmarkRow * self,
                                    gpointer klass)
{
	GdkDragAction _tmp0_;
	GdkDragAction* _tmp1_;
	gchar* _tmp2_;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv = sidebar_bookmark_row_get_instance_private (self);
#line 52 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->valid = TRUE;
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_file_list = NULL;
#line 56 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_text = NULL;
#line 57 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->drop_occurred = FALSE;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp0_ = GDK_ACTION_DEFAULT;
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp1_ = __gdk_drag_action_dup0 (&_tmp0_);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->current_suggested_action = _tmp1_;
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_tmp2_ = g_strdup ("");
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_custom_name = _tmp2_;
#line 86 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_can_insert_before = TRUE;
#line 87 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_can_insert_after = TRUE;
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_menu_model = NULL;
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_action_group = NULL;
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	self->priv->_action_group_namespace = NULL;
#line 4029 "BookmarkRow.c"
}

static void
sidebar_bookmark_row_finalize (GObject * obj)
{
	SidebarBookmarkRow * self;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 53 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->icon);
#line 54 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->target_file);
#line 55 "../src/View/Sidebar/BookmarkRow.vala"
	(self->priv->drop_file_list == NULL) ? NULL : (self->priv->drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->drop_file_list), NULL));
#line 56 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->drop_text);
#line 58 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->current_suggested_action);
#line 59 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 60 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 62 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->content_grid);
#line 63 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->icon_label_grid);
#line 64 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label_stack);
#line 65 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->editable);
#line 66 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->label);
#line 67 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->drop_revealer);
#line 69 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_custom_name);
#line 80 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_list);
#line 82 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_uri);
#line 83 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_gicon);
#line 89 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_menu_model);
#line 90 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->_action_group);
#line 91 "../src/View/Sidebar/BookmarkRow.vala"
	_g_free0 (self->priv->_action_group_namespace);
#line 93 "../src/View/Sidebar/BookmarkRow.vala"
	_g_object_unref0 (self->priv->empty_all_trash_action);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	G_OBJECT_CLASS (sidebar_bookmark_row_parent_class)->finalize (obj);
#line 4082 "BookmarkRow.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_bookmark_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarBookmarkRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_bookmark_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SidebarBookmarkRow), 0, (GInstanceInitFunc) sidebar_bookmark_row_instance_init, NULL };
	static const GInterfaceInfo sidebar_sidebar_item_interface_info = { (GInterfaceInitFunc) sidebar_bookmark_row_sidebar_sidebar_item_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType sidebar_bookmark_row_type_id;
	sidebar_bookmark_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "SidebarBookmarkRow", &g_define_type_info, 0);
	g_type_add_interface_static (sidebar_bookmark_row_type_id, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, &sidebar_sidebar_item_interface_info);
	SidebarBookmarkRow_private_offset = g_type_add_instance_private (sidebar_bookmark_row_type_id, sizeof (SidebarBookmarkRowPrivate));
	return sidebar_bookmark_row_type_id;
}

GType
sidebar_bookmark_row_get_type (void)
{
	static volatile gsize sidebar_bookmark_row_type_id__once = 0;
	if (g_once_init_enter (&sidebar_bookmark_row_type_id__once)) {
		GType sidebar_bookmark_row_type_id;
		sidebar_bookmark_row_type_id = sidebar_bookmark_row_get_type_once ();
		g_once_init_leave (&sidebar_bookmark_row_type_id__once, sidebar_bookmark_row_type_id);
	}
	return sidebar_bookmark_row_type_id__once;
}

static void
_vala_sidebar_bookmark_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	SidebarBookmarkRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_DISPLAY_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_bookmark_row_get_display_name (self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_list ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ID_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_uint (value, sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_URI_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_gicon ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_can_insert_before ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_boolean (value, sidebar_sidebar_item_interface_get_can_insert_after ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_menu_model ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_object (value, sidebar_sidebar_item_interface_get_action_group ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		g_value_set_string (value, sidebar_sidebar_item_interface_get_action_group_namespace ((SidebarSidebarItemInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4197 "BookmarkRow.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4203 "BookmarkRow.c"
	}
}

static void
_vala_sidebar_bookmark_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	SidebarBookmarkRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CUSTOM_NAME_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_custom_name ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_LIST_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_list ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ID_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_id ((SidebarSidebarItemInterface*) self, g_value_get_uint (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_URI_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_uri ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_GICON_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_gicon ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PINNED_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_pinned ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_PERMANENT_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_permanent ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_BEFORE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_can_insert_before ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_CAN_INSERT_AFTER_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_can_insert_after ((SidebarSidebarItemInterface*) self, g_value_get_boolean (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_MENU_MODEL_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_menu_model ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_action_group ((SidebarSidebarItemInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		case SIDEBAR_BOOKMARK_ROW_ACTION_GROUP_NAMESPACE_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		sidebar_sidebar_item_interface_set_action_group_namespace ((SidebarSidebarItemInterface*) self, g_value_get_string (value));
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4289 "BookmarkRow.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkRow.vala"
		break;
#line 4295 "BookmarkRow.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

